using System;
using System.Collections.Generic;
using System.Data.Common;
using System.Linq;
using System.Text.RegularExpressions;
namespace Flabbergast {
class DbParser {
public static DbConnection Parse(string provider, string uri_fragment, Dictionary<string, string> in_properties, ResourcePathFinder finder, out string err) {
err = null;
if (provider == "mssql") {
var f000000001E_factory = DbProviderFactories.GetFactory("System.Data.SqlClient");	var f000000001E_builder = f000000001E_factory.CreateConnectionStringBuilder();
	if (!DbUriHandler.ParseUri(uri_fragment, f000000001E_builder, "Server", "Port", "User Id", "Password", "Database", out err)) return null;
	string[] f000000001E_defined = {};
	if (!in_properties.Keys.All(k => f000000001E_defined.Contains(k))) { err = "Unknown parameters specified."; return null; }
	var f000000001E_connection = f000000001E_factory.CreateConnection();
	f000000001E_connection.ConnectionString = f000000001E_builder.ConnectionString;
	return f000000001E_connection;
}
if (provider == "mysql") {
var f000000001V_factory = DbProviderFactories.GetFactory("MySql.Data.MySqlClient");	var f000000001V_builder = f000000001V_factory.CreateConnectionStringBuilder();
	if (!DbUriHandler.ParseUri(uri_fragment, f000000001V_builder, "Server", "Port", "Uid", "Pwd", "Database", out err)) return null;
	string[] f000000001V_defined = {};
	if (!in_properties.Keys.All(k => f000000001V_defined.Contains(k))) { err = "Unknown parameters specified."; return null; }
	f000000001V_builder["charset"] = "utf8";
	var f000000001V_connection = f000000001V_factory.CreateConnection();
	f000000001V_connection.ConnectionString = f000000001V_builder.ConnectionString;
	return f000000001V_connection;
}
if (provider == "oracle+host") {
var f000000001p_factory = DbProviderFactories.GetFactory("Oracle.DataAccess.Client");	var f000000001p_builder = f000000001p_factory.CreateConnectionStringBuilder();
	if (!DbUriHandler.ParseUri(uri_fragment, f000000001p_builder, "User Id", "Password", (f000000001p_host, f000000001p_port, f000000001p_db) => f000000001p_builder["Data Source"] = String.Format("(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST={0})(PORT={1})))(CONNECT_DATA=(SERVER=DEDICATED)(SERVICE_NAME={2})))", f000000001p_host, f000000001p_port ?? "1521", f000000001p_db), out err)) return null;
	string[] f000000001p_defined = {};
	if (!in_properties.Keys.All(k => f000000001p_defined.Contains(k))) { err = "Unknown parameters specified."; return null; }
	var f000000001p_connection = f000000001p_factory.CreateConnection();
	f000000001p_connection.ConnectionString = f000000001p_builder.ConnectionString;
	return f000000001p_connection;
}
if (provider == "oracle+tns") {
var f0000000026_factory = DbProviderFactories.GetFactory("Oracle.DataAccess.Client");	var f0000000026_builder = f0000000026_factory.CreateConnectionStringBuilder();
	if (!Regex.IsMatch(uri_fragment, "^[A-Za-z0-9_]+$")) { err = "Invalid file specified."; return null; }
	f0000000026_builder["Data Source"] = uri_fragment;
	string[] f0000000026_defined = {};
	if (!in_properties.Keys.All(k => f0000000026_defined.Contains(k))) { err = "Unknown parameters specified."; return null; }
	var f0000000026_connection = f0000000026_factory.CreateConnection();
	f0000000026_connection.ConnectionString = f0000000026_builder.ConnectionString;
	return f0000000026_connection;
}
if (provider == "postgresql") {
var f000000002N_factory = DbProviderFactories.GetFactory("Npgsql");	var f000000002N_builder = f000000002N_factory.CreateConnectionStringBuilder();
	if (!DbUriHandler.ParseUri(uri_fragment, f000000002N_builder, "Server", "Port", "User Id", "Password", "Database", out err)) return null;
	string[] f000000002N_defined = {"ssl"};
	if (!in_properties.Keys.All(k => f000000002N_defined.Contains(k))) { err = "Unknown parameters specified."; return null; }
	if (in_properties.ContainsKey("ssl")) {
	if (!Regex.IsMatch(in_properties["ssl"], "^(true|false)$")) { err = "The value for “ssl” is not allowed."; return null; }
		f000000002N_builder["SSL"] = in_properties["ssl"];
	}
	var f000000002N_connection = f000000002N_factory.CreateConnection();
	f000000002N_connection.ConnectionString = f000000002N_builder.ConnectionString;
	return f000000002N_connection;
}
if (provider == "sqlite") {
var f000000002j_factory = DbProviderFactories.GetFactory("System.Data.SQLite");	var f000000002j_builder = f000000002j_factory.CreateConnectionStringBuilder();
	if (!Regex.IsMatch(uri_fragment, ".*")) { err = "Invalid file specified."; return null; }
	f000000002j_builder["Data Source"] = uri_fragment;
	string[] f000000002j_defined = {};
	if (!in_properties.Keys.All(k => f000000002j_defined.Contains(k))) { err = "Unknown parameters specified."; return null; }
	var f000000002j_connection = f000000002j_factory.CreateConnection();
	f000000002j_connection.ConnectionString = f000000002j_builder.ConnectionString;
	return f000000002j_connection;
}
if (provider == "sqlite+res") {
var f0000000030_factory = DbProviderFactories.GetFactory("System.Data.SQLite");	var f0000000030_builder = f0000000030_factory.CreateConnectionStringBuilder();
	if (!Regex.IsMatch(uri_fragment, "^[A-Za-z0-9/]*$")) { err = "Invalid resource file specified."; return null; }
	var f0000000030_files = finder.FindAll(uri_fragment, ".sqlite", ".sqlite3", ".db", ".db3", ".s3db"); if (f0000000030_files.Count == 0) { err = "Cannot find resource “" + uri_fragment + "”."; return null; } else { f0000000030_builder["Data Source"] = f0000000030_files[0]; }
	string[] f0000000030_defined = {};
	if (!in_properties.Keys.All(k => f0000000030_defined.Contains(k))) { err = "Unknown parameters specified."; return null; }
	var f0000000030_connection = f0000000030_factory.CreateConnection();
	f0000000030_connection.ConnectionString = f0000000030_builder.ConnectionString;
	return f0000000030_connection;
}

err = string.Format("Unknown database provider “{0}”.", provider);
return null;
}
}
}
