using System.Linq;
namespace Flabbergast {
internal abstract class arithmetic_conjunction_term : AstTypeableNode, ITypeableElement {
	public abstract Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool needs_unbox);
	internal RevCons<char> comment = null;
	internal static bool ParseRule_Base(ref ParserPosition position, out arithmetic_conjunction_term result) {
		position.TraceEnter("arithmetic_conjunction_term");
		if(position.CheckCache<arithmetic_conjunction_term>("arithmetic_conjunction_term", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("any arithmetic_conjunction_term", "arithmetic_conjunction_term");		slave_position = position.Clone();
		if (ParseRule_division_term(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("arithmetic_conjunction_term", true);
			position.Cache<arithmetic_conjunction_term>("arithmetic_conjunction_term", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_modulus_term(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("arithmetic_conjunction_term", true);
			position.Cache<arithmetic_conjunction_term>("arithmetic_conjunction_term", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_multiplication_term(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("arithmetic_conjunction_term", true);
			position.Cache<arithmetic_conjunction_term>("arithmetic_conjunction_term", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("arithmetic_conjunction_term", false);
		position.Cache<arithmetic_conjunction_term>("arithmetic_conjunction_term", start_index, null);
		return false;
	}
	internal static bool ParseRule_division_term(ref ParserPosition _position, out arithmetic_conjunction_term _result) {
		if(_position.CheckCache<arithmetic_conjunction_term_division_term, arithmetic_conjunction_term>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new arithmetic_conjunction_term_division_term();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("arithmetic_conjunction_term:division_term");

		bool _sequence_fail_f00000000Iv = false;
		while(true) {
			ParserPosition _many_position_f00000000Tl = _position.Clone();
			var _many_obj_f00000000Tl = _obj.Clone();
			bool _alternate_success_f00000000b8 = false;
			ParserPosition _alt_position_f00000000b8 = _position;
			var _alt_obj_f00000000b8 = _obj;
			if (!_alternate_success_f00000000b8) {
				_position = _alt_position_f00000000b8.Clone();
				_obj = _alt_obj_f00000000b8.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000b8 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "division term");
					_position = _alt_position_f00000000b8;
					_obj = _alt_obj_f00000000b8;
				}
			}
			if (!_alternate_success_f00000000b8) {
				_position = _alt_position_f00000000b8.Clone();
				_obj = _alt_obj_f00000000b8.Clone();
				bool _sequence_fail_f00000000j1 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "division term");
					_sequence_fail_f00000000j1 = true;
					goto _sequence_end_f00000000j1;
				}
				while(true) {
					ParserPosition _many_position_f00000000te = _position.Clone();
					var _many_obj_f00000000te = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "division term");
						_position = _many_position_f00000000te;
						_obj = _many_obj_f00000000te;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "division term");
					_sequence_fail_f00000000j1 = true;
					goto _sequence_end_f00000000j1;
				}
				_sequence_end_f00000000j1:
				if (_sequence_fail_f00000000j1) {
					_position = _alt_position_f00000000b8;
					_obj = _alt_obj_f00000000b8;
				} else {
					_alternate_success_f00000000b8 = true;
				}
			}
			if (_alternate_success_f00000000b8) {
			} else {
				_position = _many_position_f00000000Tl;
				_obj = _many_obj_f00000000Tl;
				break;
			}
		}
		if (_position.Match("/")) {
		} else {
			_position.Update("“/”", "division term");
			_sequence_fail_f00000000Iv = true;
			goto _sequence_end_f00000000Iv;
		}
		while(true) {
			ParserPosition _many_position_f00000000Tm = _position.Clone();
			var _many_obj_f00000000Tm = _obj.Clone();
			bool _alternate_success_f00000000b9 = false;
			ParserPosition _alt_position_f00000000b9 = _position;
			var _alt_obj_f00000000b9 = _obj;
			if (!_alternate_success_f00000000b9) {
				_position = _alt_position_f00000000b9.Clone();
				_obj = _alt_obj_f00000000b9.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000b9 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "division term");
					_position = _alt_position_f00000000b9;
					_obj = _alt_obj_f00000000b9;
				}
			}
			if (!_alternate_success_f00000000b9) {
				_position = _alt_position_f00000000b9.Clone();
				_obj = _alt_obj_f00000000b9.Clone();
				bool _sequence_fail_f00000000j5 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "division term");
					_sequence_fail_f00000000j5 = true;
					goto _sequence_end_f00000000j5;
				}
				while(true) {
					ParserPosition _many_position_f00000000tk = _position.Clone();
					var _many_obj_f00000000tk = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "division term");
						_position = _many_position_f00000000tk;
						_obj = _many_obj_f00000000tk;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "division term");
					_sequence_fail_f00000000j5 = true;
					goto _sequence_end_f00000000j5;
				}
				_sequence_end_f00000000j5:
				if (_sequence_fail_f00000000j5) {
					_position = _alt_position_f00000000b9;
					_obj = _alt_obj_f00000000b9;
				} else {
					_alternate_success_f00000000b9 = true;
				}
			}
			if (_alternate_success_f00000000b9) {
			} else {
				_position = _many_position_f00000000Tm;
				_obj = _many_obj_f00000000Tm;
				break;
			}
		}
		if (expression.ParseRule_expression13(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000000Iv = true;
		goto _sequence_end_f00000000Iv;
		}
		_sequence_end_f00000000Iv:
		if (_sequence_fail_f00000000Iv) {
			_position.Cache<arithmetic_conjunction_term_division_term>(_start_index, null);
			_position.TraceExit("arithmetic_conjunction_term:division_term", false);
			_result = null;
			return false;
		} else {
			_position.Cache<arithmetic_conjunction_term_division_term>(_start_index, _obj);
			_position.TraceExit("arithmetic_conjunction_term:division_term", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (arithmetic_conjunction_term)_obj;
			return true;
		}
	}
	internal static bool ParseRule_modulus_term(ref ParserPosition _position, out arithmetic_conjunction_term _result) {
		if(_position.CheckCache<arithmetic_conjunction_term_modulus_term, arithmetic_conjunction_term>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new arithmetic_conjunction_term_modulus_term();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("arithmetic_conjunction_term:modulus_term");

		bool _sequence_fail_f00000000J2 = false;
		while(true) {
			ParserPosition _many_position_f00000000U0 = _position.Clone();
			var _many_obj_f00000000U0 = _obj.Clone();
			bool _alternate_success_f00000000bE = false;
			ParserPosition _alt_position_f00000000bE = _position;
			var _alt_obj_f00000000bE = _obj;
			if (!_alternate_success_f00000000bE) {
				_position = _alt_position_f00000000bE.Clone();
				_obj = _alt_obj_f00000000bE.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000bE = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "remainder term");
					_position = _alt_position_f00000000bE;
					_obj = _alt_obj_f00000000bE;
				}
			}
			if (!_alternate_success_f00000000bE) {
				_position = _alt_position_f00000000bE.Clone();
				_obj = _alt_obj_f00000000bE.Clone();
				bool _sequence_fail_f00000000jJ = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "remainder term");
					_sequence_fail_f00000000jJ = true;
					goto _sequence_end_f00000000jJ;
				}
				while(true) {
					ParserPosition _many_position_f00000000tx = _position.Clone();
					var _many_obj_f00000000tx = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "remainder term");
						_position = _many_position_f00000000tx;
						_obj = _many_obj_f00000000tx;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "remainder term");
					_sequence_fail_f00000000jJ = true;
					goto _sequence_end_f00000000jJ;
				}
				_sequence_end_f00000000jJ:
				if (_sequence_fail_f00000000jJ) {
					_position = _alt_position_f00000000bE;
					_obj = _alt_obj_f00000000bE;
				} else {
					_alternate_success_f00000000bE = true;
				}
			}
			if (_alternate_success_f00000000bE) {
			} else {
				_position = _many_position_f00000000U0;
				_obj = _many_obj_f00000000U0;
				break;
			}
		}
		if (_position.Match("%")) {
		} else {
			_position.Update("“%”", "remainder term");
			_sequence_fail_f00000000J2 = true;
			goto _sequence_end_f00000000J2;
		}
		while(true) {
			ParserPosition _many_position_f00000000U1 = _position.Clone();
			var _many_obj_f00000000U1 = _obj.Clone();
			bool _alternate_success_f00000000bF = false;
			ParserPosition _alt_position_f00000000bF = _position;
			var _alt_obj_f00000000bF = _obj;
			if (!_alternate_success_f00000000bF) {
				_position = _alt_position_f00000000bF.Clone();
				_obj = _alt_obj_f00000000bF.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000bF = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "remainder term");
					_position = _alt_position_f00000000bF;
					_obj = _alt_obj_f00000000bF;
				}
			}
			if (!_alternate_success_f00000000bF) {
				_position = _alt_position_f00000000bF.Clone();
				_obj = _alt_obj_f00000000bF.Clone();
				bool _sequence_fail_f00000000jN = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "remainder term");
					_sequence_fail_f00000000jN = true;
					goto _sequence_end_f00000000jN;
				}
				while(true) {
					ParserPosition _many_position_f00000000u3 = _position.Clone();
					var _many_obj_f00000000u3 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "remainder term");
						_position = _many_position_f00000000u3;
						_obj = _many_obj_f00000000u3;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "remainder term");
					_sequence_fail_f00000000jN = true;
					goto _sequence_end_f00000000jN;
				}
				_sequence_end_f00000000jN:
				if (_sequence_fail_f00000000jN) {
					_position = _alt_position_f00000000bF;
					_obj = _alt_obj_f00000000bF;
				} else {
					_alternate_success_f00000000bF = true;
				}
			}
			if (_alternate_success_f00000000bF) {
			} else {
				_position = _many_position_f00000000U1;
				_obj = _many_obj_f00000000U1;
				break;
			}
		}
		if (expression.ParseRule_expression13(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000000J2 = true;
		goto _sequence_end_f00000000J2;
		}
		_sequence_end_f00000000J2:
		if (_sequence_fail_f00000000J2) {
			_position.Cache<arithmetic_conjunction_term_modulus_term>(_start_index, null);
			_position.TraceExit("arithmetic_conjunction_term:modulus_term", false);
			_result = null;
			return false;
		} else {
			_position.Cache<arithmetic_conjunction_term_modulus_term>(_start_index, _obj);
			_position.TraceExit("arithmetic_conjunction_term:modulus_term", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (arithmetic_conjunction_term)_obj;
			return true;
		}
	}
	internal static bool ParseRule_multiplication_term(ref ParserPosition _position, out arithmetic_conjunction_term _result) {
		if(_position.CheckCache<arithmetic_conjunction_term_multiplication_term, arithmetic_conjunction_term>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new arithmetic_conjunction_term_multiplication_term();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("arithmetic_conjunction_term:multiplication_term");

		bool _sequence_fail_f00000000J9 = false;
		while(true) {
			ParserPosition _many_position_f00000000UF = _position.Clone();
			var _many_obj_f00000000UF = _obj.Clone();
			bool _alternate_success_f00000000bK = false;
			ParserPosition _alt_position_f00000000bK = _position;
			var _alt_obj_f00000000bK = _obj;
			if (!_alternate_success_f00000000bK) {
				_position = _alt_position_f00000000bK.Clone();
				_obj = _alt_obj_f00000000bK.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000bK = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "multiplication term");
					_position = _alt_position_f00000000bK;
					_obj = _alt_obj_f00000000bK;
				}
			}
			if (!_alternate_success_f00000000bK) {
				_position = _alt_position_f00000000bK.Clone();
				_obj = _alt_obj_f00000000bK.Clone();
				bool _sequence_fail_f00000000jb = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "multiplication term");
					_sequence_fail_f00000000jb = true;
					goto _sequence_end_f00000000jb;
				}
				while(true) {
					ParserPosition _many_position_f00000000uG = _position.Clone();
					var _many_obj_f00000000uG = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "multiplication term");
						_position = _many_position_f00000000uG;
						_obj = _many_obj_f00000000uG;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "multiplication term");
					_sequence_fail_f00000000jb = true;
					goto _sequence_end_f00000000jb;
				}
				_sequence_end_f00000000jb:
				if (_sequence_fail_f00000000jb) {
					_position = _alt_position_f00000000bK;
					_obj = _alt_obj_f00000000bK;
				} else {
					_alternate_success_f00000000bK = true;
				}
			}
			if (_alternate_success_f00000000bK) {
			} else {
				_position = _many_position_f00000000UF;
				_obj = _many_obj_f00000000UF;
				break;
			}
		}
		if (_position.Match("*")) {
		} else {
			_position.Update("“*”", "multiplication term");
			_sequence_fail_f00000000J9 = true;
			goto _sequence_end_f00000000J9;
		}
		while(true) {
			ParserPosition _many_position_f00000000UG = _position.Clone();
			var _many_obj_f00000000UG = _obj.Clone();
			bool _alternate_success_f00000000bL = false;
			ParserPosition _alt_position_f00000000bL = _position;
			var _alt_obj_f00000000bL = _obj;
			if (!_alternate_success_f00000000bL) {
				_position = _alt_position_f00000000bL.Clone();
				_obj = _alt_obj_f00000000bL.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000bL = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "multiplication term");
					_position = _alt_position_f00000000bL;
					_obj = _alt_obj_f00000000bL;
				}
			}
			if (!_alternate_success_f00000000bL) {
				_position = _alt_position_f00000000bL.Clone();
				_obj = _alt_obj_f00000000bL.Clone();
				bool _sequence_fail_f00000000jf = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "multiplication term");
					_sequence_fail_f00000000jf = true;
					goto _sequence_end_f00000000jf;
				}
				while(true) {
					ParserPosition _many_position_f00000000uM = _position.Clone();
					var _many_obj_f00000000uM = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "multiplication term");
						_position = _many_position_f00000000uM;
						_obj = _many_obj_f00000000uM;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "multiplication term");
					_sequence_fail_f00000000jf = true;
					goto _sequence_end_f00000000jf;
				}
				_sequence_end_f00000000jf:
				if (_sequence_fail_f00000000jf) {
					_position = _alt_position_f00000000bL;
					_obj = _alt_obj_f00000000bL;
				} else {
					_alternate_success_f00000000bL = true;
				}
			}
			if (_alternate_success_f00000000bL) {
			} else {
				_position = _many_position_f00000000UG;
				_obj = _many_obj_f00000000UG;
				break;
			}
		}
		if (expression.ParseRule_expression13(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000000J9 = true;
		goto _sequence_end_f00000000J9;
		}
		_sequence_end_f00000000J9:
		if (_sequence_fail_f00000000J9) {
			_position.Cache<arithmetic_conjunction_term_multiplication_term>(_start_index, null);
			_position.TraceExit("arithmetic_conjunction_term:multiplication_term", false);
			_result = null;
			return false;
		} else {
			_position.Cache<arithmetic_conjunction_term_multiplication_term>(_start_index, _obj);
			_position.TraceExit("arithmetic_conjunction_term:multiplication_term", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (arithmetic_conjunction_term)_obj;
			return true;
		}
	}
	public abstract void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _block);
}
internal class arithmetic_conjunction_term_division_term : arithmetic_conjunction_term {
	public override string PrettyName { get { return "division term"; } }
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000000Iu = _type & (0 | Flabbergast.Type.Float | Flabbergast.Type.Int);
		if (f00000000Iu == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float | Flabbergast.Type.Int, _type);
		}
		var f00000000No =  f00000000Iu;
		if (expression != null) f00000000No &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, f00000000Iu | Flabbergast.Type.Int, ref _success, true), f00000000Iu);
		InferredType = f00000000No;		return f00000000No;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		Generator.ParameterisedBlock<LoadableValue> f00000000It_code = (f00000000It) => {
			_final_block(f00000000It);
		};
		if (_accumulator.BackingType == typeof(double)) {
			expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000000iw) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f00000000b7_code = (f00000000b7) => {
					f00000000It_code(f00000000b7);
				};
				if (f00000000iw.BackingType == typeof(double)) {
					var f000000012Y = new GeneratedValue(typeof(double), (f00000005FP_builder) => {
					if (!typeof(double).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Div.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(double));
					if (!typeof(double).IsAssignableFrom(f00000000iw.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Div.", Stringish.NameForType(f00000000iw.BackingType)));
					_generator.LoadReboxed(f00000000iw, typeof(double));
					f00000005FP_builder.Emit(System.Reflection.Emit.OpCodes.Div);
					});
					f00000000b7_code(f000000012Y);
				} else if (f00000000iw.BackingType == typeof(long)) {
					var f0000000198 = new GeneratedValue(typeof(double), (f00000005CH_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000000iw.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_R8.", Stringish.NameForType(f00000000iw.BackingType)));
					_generator.LoadReboxed(f00000000iw, typeof(long));
					f00000005CH_builder.Emit(System.Reflection.Emit.OpCodes.Conv_R8);
					});
					var f000000012X = new GeneratedValue(typeof(double), (f000000058q_builder) => {
					if (!typeof(double).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Div.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(double));
					if (!typeof(double).IsAssignableFrom(f0000000198.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Div.", Stringish.NameForType(f0000000198.BackingType)));
					_generator.LoadReboxed(f0000000198, typeof(double));
					f000000058q_builder.Emit(System.Reflection.Emit.OpCodes.Div);
					});
					f00000000b7_code(f000000012X);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: division term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			});
		} else if (_accumulator.BackingType == typeof(long)) {
			expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000000it) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f00000000b6_code = (f00000000b6) => {
					f00000000It_code(f00000000b6);
				};
				if (f00000000it.BackingType == typeof(double)) {
					var f0000000193 = new GeneratedValue(typeof(double), (f000000051A_builder) => {
					if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_R8.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(long));
					f000000051A_builder.Emit(System.Reflection.Emit.OpCodes.Conv_R8);
					});
					var f000000012V = new GeneratedValue(typeof(double), (f00000004n6_builder) => {
					if (!typeof(double).IsAssignableFrom(f0000000193.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Div.", Stringish.NameForType(f0000000193.BackingType)));
					_generator.LoadReboxed(f0000000193, typeof(double));
					if (!typeof(double).IsAssignableFrom(f00000000it.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Div.", Stringish.NameForType(f00000000it.BackingType)));
					_generator.LoadReboxed(f00000000it, typeof(double));
					f00000004n6_builder.Emit(System.Reflection.Emit.OpCodes.Div);
					});
					f00000000b6_code(f000000012V);
				} else if (f00000000it.BackingType == typeof(long)) {
					var f000000012U = _generator.MakeField("division_term_Dup", typeof(long));
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
					if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Dup.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(long));
					if (!typeof(long).IsAssignableFrom(f00000000it.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Dup.", Stringish.NameForType(f00000000it.BackingType)));
					_generator.LoadReboxed(f00000000it, typeof(long));
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					var f00000001om_ok = _generator.Builder.DefineLabel();
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Brtrue, f00000001om_ok);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Pop);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Pop);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Pop);
					_generator.LoadTaskMaster();
					_source_reference.Load(_generator);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "Division by zero is an undignified operation.");
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(TaskMaster).GetMethod("ReportOtherError", new System.Type[] { typeof(SourceReference), typeof(string) }));
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
					_generator.Builder.MarkLabel(f00000001om_ok);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Div);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000012U.Field);
					f00000000b6_code(f000000012U);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: division term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			});
		} else {
			throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: division term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
		}
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expression.GenerateApi(_api_gen, false);
	}
	internal arithmetic_conjunction_term_division_term Clone() {
		var _obj = new arithmetic_conjunction_term_division_term();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expression = expression;
		return _obj;
	}
}
internal class arithmetic_conjunction_term_modulus_term : arithmetic_conjunction_term {
	public override string PrettyName { get { return "remainder term"; } }
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000000J1 = _type & (0 | Flabbergast.Type.Float | Flabbergast.Type.Int);
		if (f00000000J1 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float | Flabbergast.Type.Int, _type);
		}
		var f00000000O1 =  f00000000J1;
		if (expression != null) f00000000O1 &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, f00000000J1 | Flabbergast.Type.Int, ref _success, true), f00000000J1);
		InferredType = f00000000O1;		return f00000000O1;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		Generator.ParameterisedBlock<LoadableValue> f00000000J0_code = (f00000000J0) => {
			_final_block(f00000000J0);
		};
		if (_accumulator.BackingType == typeof(double)) {
			expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000000jE) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f00000000bD_code = (f00000000bD) => {
					f00000000J0_code(f00000000bD);
				};
				if (f00000000jE.BackingType == typeof(double)) {
					var f000000012p = new GeneratedValue(typeof(double), (f00000005FQ_builder) => {
					if (!typeof(double).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Rem.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(double));
					if (!typeof(double).IsAssignableFrom(f00000000jE.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Rem.", Stringish.NameForType(f00000000jE.BackingType)));
					_generator.LoadReboxed(f00000000jE, typeof(double));
					f00000005FQ_builder.Emit(System.Reflection.Emit.OpCodes.Rem);
					});
					f00000000bD_code(f000000012p);
				} else if (f00000000jE.BackingType == typeof(long)) {
					var f000000019U = new GeneratedValue(typeof(double), (f00000005CI_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000000jE.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_R8.", Stringish.NameForType(f00000000jE.BackingType)));
					_generator.LoadReboxed(f00000000jE, typeof(long));
					f00000005CI_builder.Emit(System.Reflection.Emit.OpCodes.Conv_R8);
					});
					var f000000012o = new GeneratedValue(typeof(double), (f000000058r_builder) => {
					if (!typeof(double).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Rem.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(double));
					if (!typeof(double).IsAssignableFrom(f000000019U.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Rem.", Stringish.NameForType(f000000019U.BackingType)));
					_generator.LoadReboxed(f000000019U, typeof(double));
					f000000058r_builder.Emit(System.Reflection.Emit.OpCodes.Rem);
					});
					f00000000bD_code(f000000012o);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: remainder term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			});
		} else if (_accumulator.BackingType == typeof(long)) {
			expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000000jB) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f00000000bC_code = (f00000000bC) => {
					f00000000J0_code(f00000000bC);
				};
				if (f00000000jB.BackingType == typeof(double)) {
					var f000000019P = new GeneratedValue(typeof(double), (f000000051B_builder) => {
					if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_R8.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(long));
					f000000051B_builder.Emit(System.Reflection.Emit.OpCodes.Conv_R8);
					});
					var f000000012m = new GeneratedValue(typeof(double), (f00000004n7_builder) => {
					if (!typeof(double).IsAssignableFrom(f000000019P.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Rem.", Stringish.NameForType(f000000019P.BackingType)));
					_generator.LoadReboxed(f000000019P, typeof(double));
					if (!typeof(double).IsAssignableFrom(f00000000jB.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Rem.", Stringish.NameForType(f00000000jB.BackingType)));
					_generator.LoadReboxed(f00000000jB, typeof(double));
					f00000004n7_builder.Emit(System.Reflection.Emit.OpCodes.Rem);
					});
					f00000000bC_code(f000000012m);
				} else if (f00000000jB.BackingType == typeof(long)) {
					var f000000012l = _generator.MakeField("modulus_term_Dup", typeof(long));
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
					if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Dup.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(long));
					if (!typeof(long).IsAssignableFrom(f00000000jB.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Dup.", Stringish.NameForType(f00000000jB.BackingType)));
					_generator.LoadReboxed(f00000000jB, typeof(long));
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					var f00000001on_ok = _generator.Builder.DefineLabel();
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Brtrue, f00000001on_ok);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Pop);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Pop);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Pop);
					_generator.LoadTaskMaster();
					_source_reference.Load(_generator);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "The modulus by zero is a mathematical koan.");
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(TaskMaster).GetMethod("ReportOtherError", new System.Type[] { typeof(SourceReference), typeof(string) }));
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
					_generator.Builder.MarkLabel(f00000001on_ok);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Rem);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000012l.Field);
					f00000000bC_code(f000000012l);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: remainder term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			});
		} else {
			throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: remainder term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
		}
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expression.GenerateApi(_api_gen, false);
	}
	internal arithmetic_conjunction_term_modulus_term Clone() {
		var _obj = new arithmetic_conjunction_term_modulus_term();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expression = expression;
		return _obj;
	}
}
internal class arithmetic_conjunction_term_multiplication_term : arithmetic_conjunction_term {
	public override string PrettyName { get { return "multiplication term"; } }
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000000J8 = _type & (0 | Flabbergast.Type.Float | Flabbergast.Type.Int);
		if (f00000000J8 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float | Flabbergast.Type.Int, _type);
		}
		var f00000000OE =  f00000000J8;
		if (expression != null) f00000000OE &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, f00000000J8 | Flabbergast.Type.Int, ref _success, true), f00000000J8);
		InferredType = f00000000OE;		return f00000000OE;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		Generator.ParameterisedBlock<LoadableValue> f00000000J7_code = (f00000000J7) => {
			_final_block(f00000000J7);
		};
		if (_accumulator.BackingType == typeof(double)) {
			expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000000jW) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f00000000bJ_code = (f00000000bJ) => {
					f00000000J7_code(f00000000bJ);
				};
				if (f00000000jW.BackingType == typeof(double)) {
					var f0000000136 = new GeneratedValue(typeof(double), (f00000005FJ_builder) => {
					if (!typeof(double).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Mul.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(double));
					if (!typeof(double).IsAssignableFrom(f00000000jW.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Mul.", Stringish.NameForType(f00000000jW.BackingType)));
					_generator.LoadReboxed(f00000000jW, typeof(double));
					f00000005FJ_builder.Emit(System.Reflection.Emit.OpCodes.Mul);
					});
					f00000000bJ_code(f0000000136);
				} else if (f00000000jW.BackingType == typeof(long)) {
					var f000000019q = new GeneratedValue(typeof(double), (f00000005CB_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000000jW.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_R8.", Stringish.NameForType(f00000000jW.BackingType)));
					_generator.LoadReboxed(f00000000jW, typeof(long));
					f00000005CB_builder.Emit(System.Reflection.Emit.OpCodes.Conv_R8);
					});
					var f0000000135 = new GeneratedValue(typeof(double), (f000000058j_builder) => {
					if (!typeof(double).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Mul.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(double));
					if (!typeof(double).IsAssignableFrom(f000000019q.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Mul.", Stringish.NameForType(f000000019q.BackingType)));
					_generator.LoadReboxed(f000000019q, typeof(double));
					f000000058j_builder.Emit(System.Reflection.Emit.OpCodes.Mul);
					});
					f00000000bJ_code(f0000000135);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: multiplication term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			});
		} else if (_accumulator.BackingType == typeof(long)) {
			expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000000jT) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f00000000bI_code = (f00000000bI) => {
					f00000000J7_code(f00000000bI);
				};
				if (f00000000jT.BackingType == typeof(double)) {
					var f000000019l = new GeneratedValue(typeof(double), (f000000050r_builder) => {
					if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_R8.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(long));
					f000000050r_builder.Emit(System.Reflection.Emit.OpCodes.Conv_R8);
					});
					var f0000000133 = new GeneratedValue(typeof(double), (f00000004mA_builder) => {
					if (!typeof(double).IsAssignableFrom(f000000019l.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Mul.", Stringish.NameForType(f000000019l.BackingType)));
					_generator.LoadReboxed(f000000019l, typeof(double));
					if (!typeof(double).IsAssignableFrom(f00000000jT.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Mul.", Stringish.NameForType(f00000000jT.BackingType)));
					_generator.LoadReboxed(f00000000jT, typeof(double));
					f00000004mA_builder.Emit(System.Reflection.Emit.OpCodes.Mul);
					});
					f00000000bI_code(f0000000133);
				} else if (f00000000jT.BackingType == typeof(long)) {
					var f0000000132 = new GeneratedValue(typeof(long), (f00000001oo_builder) => {
					if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Mul.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(long));
					if (!typeof(long).IsAssignableFrom(f00000000jT.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Mul.", Stringish.NameForType(f00000000jT.BackingType)));
					_generator.LoadReboxed(f00000000jT, typeof(long));
					f00000001oo_builder.Emit(System.Reflection.Emit.OpCodes.Mul);
					});
					f00000000bI_code(f0000000132);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: multiplication term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			});
		} else {
			throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: multiplication term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
		}
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expression.GenerateApi(_api_gen, false);
	}
	internal arithmetic_conjunction_term_multiplication_term Clone() {
		var _obj = new arithmetic_conjunction_term_multiplication_term();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expression = expression;
		return _obj;
	}
}
internal abstract class arithmetic_disjunction_term : AstTypeableNode, ITypeableElement {
	public abstract Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool needs_unbox);
	internal RevCons<char> comment = null;
	internal static bool ParseRule_Base(ref ParserPosition position, out arithmetic_disjunction_term result) {
		position.TraceEnter("arithmetic_disjunction_term");
		if(position.CheckCache<arithmetic_disjunction_term>("arithmetic_disjunction_term", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("any arithmetic_disjunction_term", "arithmetic_disjunction_term");		slave_position = position.Clone();
		if (ParseRule_addition_term(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("arithmetic_disjunction_term", true);
			position.Cache<arithmetic_disjunction_term>("arithmetic_disjunction_term", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_subtraction_term(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("arithmetic_disjunction_term", true);
			position.Cache<arithmetic_disjunction_term>("arithmetic_disjunction_term", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("arithmetic_disjunction_term", false);
		position.Cache<arithmetic_disjunction_term>("arithmetic_disjunction_term", start_index, null);
		return false;
	}
	internal static bool ParseRule_addition_term(ref ParserPosition _position, out arithmetic_disjunction_term _result) {
		if(_position.CheckCache<arithmetic_disjunction_term_addition_term, arithmetic_disjunction_term>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new arithmetic_disjunction_term_addition_term();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("arithmetic_disjunction_term:addition_term");

		bool _sequence_fail_f00000000Al = false;
		while(true) {
			ParserPosition _many_position_f00000000Ga = _position.Clone();
			var _many_obj_f00000000Ga = _obj.Clone();
			bool _alternate_success_f00000000LC = false;
			ParserPosition _alt_position_f00000000LC = _position;
			var _alt_obj_f00000000LC = _obj;
			if (!_alternate_success_f00000000LC) {
				_position = _alt_position_f00000000LC.Clone();
				_obj = _alt_obj_f00000000LC.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000LC = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "addition term");
					_position = _alt_position_f00000000LC;
					_obj = _alt_obj_f00000000LC;
				}
			}
			if (!_alternate_success_f00000000LC) {
				_position = _alt_position_f00000000LC.Clone();
				_obj = _alt_obj_f00000000LC.Clone();
				bool _sequence_fail_f00000000QS = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "addition term");
					_sequence_fail_f00000000QS = true;
					goto _sequence_end_f00000000QS;
				}
				while(true) {
					ParserPosition _many_position_f00000000W2 = _position.Clone();
					var _many_obj_f00000000W2 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "addition term");
						_position = _many_position_f00000000W2;
						_obj = _many_obj_f00000000W2;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "addition term");
					_sequence_fail_f00000000QS = true;
					goto _sequence_end_f00000000QS;
				}
				_sequence_end_f00000000QS:
				if (_sequence_fail_f00000000QS) {
					_position = _alt_position_f00000000LC;
					_obj = _alt_obj_f00000000LC;
				} else {
					_alternate_success_f00000000LC = true;
				}
			}
			if (_alternate_success_f00000000LC) {
			} else {
				_position = _many_position_f00000000Ga;
				_obj = _many_obj_f00000000Ga;
				break;
			}
		}
		if (_position.Match("+")) {
		} else {
			_position.Update("“+”", "addition term");
			_sequence_fail_f00000000Al = true;
			goto _sequence_end_f00000000Al;
		}
		while(true) {
			ParserPosition _many_position_f00000000Gb = _position.Clone();
			var _many_obj_f00000000Gb = _obj.Clone();
			bool _alternate_success_f00000000LD = false;
			ParserPosition _alt_position_f00000000LD = _position;
			var _alt_obj_f00000000LD = _obj;
			if (!_alternate_success_f00000000LD) {
				_position = _alt_position_f00000000LD.Clone();
				_obj = _alt_obj_f00000000LD.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000LD = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "addition term");
					_position = _alt_position_f00000000LD;
					_obj = _alt_obj_f00000000LD;
				}
			}
			if (!_alternate_success_f00000000LD) {
				_position = _alt_position_f00000000LD.Clone();
				_obj = _alt_obj_f00000000LD.Clone();
				bool _sequence_fail_f00000000QW = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "addition term");
					_sequence_fail_f00000000QW = true;
					goto _sequence_end_f00000000QW;
				}
				while(true) {
					ParserPosition _many_position_f00000000W8 = _position.Clone();
					var _many_obj_f00000000W8 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "addition term");
						_position = _many_position_f00000000W8;
						_obj = _many_obj_f00000000W8;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "addition term");
					_sequence_fail_f00000000QW = true;
					goto _sequence_end_f00000000QW;
				}
				_sequence_end_f00000000QW:
				if (_sequence_fail_f00000000QW) {
					_position = _alt_position_f00000000LD;
					_obj = _alt_obj_f00000000LD;
				} else {
					_alternate_success_f00000000LD = true;
				}
			}
			if (_alternate_success_f00000000LD) {
			} else {
				_position = _many_position_f00000000Gb;
				_obj = _many_obj_f00000000Gb;
				break;
			}
		}
		if (expression.ParseRule_expression12(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000000Al = true;
		goto _sequence_end_f00000000Al;
		}
		_sequence_end_f00000000Al:
		if (_sequence_fail_f00000000Al) {
			_position.Cache<arithmetic_disjunction_term_addition_term>(_start_index, null);
			_position.TraceExit("arithmetic_disjunction_term:addition_term", false);
			_result = null;
			return false;
		} else {
			_position.Cache<arithmetic_disjunction_term_addition_term>(_start_index, _obj);
			_position.TraceExit("arithmetic_disjunction_term:addition_term", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (arithmetic_disjunction_term)_obj;
			return true;
		}
	}
	internal static bool ParseRule_subtraction_term(ref ParserPosition _position, out arithmetic_disjunction_term _result) {
		if(_position.CheckCache<arithmetic_disjunction_term_subtraction_term, arithmetic_disjunction_term>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new arithmetic_disjunction_term_subtraction_term();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("arithmetic_disjunction_term:subtraction_term");

		bool _sequence_fail_f00000000As = false;
		while(true) {
			ParserPosition _many_position_f00000000Gp = _position.Clone();
			var _many_obj_f00000000Gp = _obj.Clone();
			bool _alternate_success_f00000000LI = false;
			ParserPosition _alt_position_f00000000LI = _position;
			var _alt_obj_f00000000LI = _obj;
			if (!_alternate_success_f00000000LI) {
				_position = _alt_position_f00000000LI.Clone();
				_obj = _alt_obj_f00000000LI.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000LI = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "subtraction term");
					_position = _alt_position_f00000000LI;
					_obj = _alt_obj_f00000000LI;
				}
			}
			if (!_alternate_success_f00000000LI) {
				_position = _alt_position_f00000000LI.Clone();
				_obj = _alt_obj_f00000000LI.Clone();
				bool _sequence_fail_f00000000Qk = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "subtraction term");
					_sequence_fail_f00000000Qk = true;
					goto _sequence_end_f00000000Qk;
				}
				while(true) {
					ParserPosition _many_position_f00000000WL = _position.Clone();
					var _many_obj_f00000000WL = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "subtraction term");
						_position = _many_position_f00000000WL;
						_obj = _many_obj_f00000000WL;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "subtraction term");
					_sequence_fail_f00000000Qk = true;
					goto _sequence_end_f00000000Qk;
				}
				_sequence_end_f00000000Qk:
				if (_sequence_fail_f00000000Qk) {
					_position = _alt_position_f00000000LI;
					_obj = _alt_obj_f00000000LI;
				} else {
					_alternate_success_f00000000LI = true;
				}
			}
			if (_alternate_success_f00000000LI) {
			} else {
				_position = _many_position_f00000000Gp;
				_obj = _many_obj_f00000000Gp;
				break;
			}
		}
		if (_position.Match("-")) {
		} else {
			_position.Update("“-”", "subtraction term");
			_sequence_fail_f00000000As = true;
			goto _sequence_end_f00000000As;
		}
		while(true) {
			ParserPosition _many_position_f00000000Gq = _position.Clone();
			var _many_obj_f00000000Gq = _obj.Clone();
			bool _alternate_success_f00000000LJ = false;
			ParserPosition _alt_position_f00000000LJ = _position;
			var _alt_obj_f00000000LJ = _obj;
			if (!_alternate_success_f00000000LJ) {
				_position = _alt_position_f00000000LJ.Clone();
				_obj = _alt_obj_f00000000LJ.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000LJ = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "subtraction term");
					_position = _alt_position_f00000000LJ;
					_obj = _alt_obj_f00000000LJ;
				}
			}
			if (!_alternate_success_f00000000LJ) {
				_position = _alt_position_f00000000LJ.Clone();
				_obj = _alt_obj_f00000000LJ.Clone();
				bool _sequence_fail_f00000000Qo = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "subtraction term");
					_sequence_fail_f00000000Qo = true;
					goto _sequence_end_f00000000Qo;
				}
				while(true) {
					ParserPosition _many_position_f00000000WR = _position.Clone();
					var _many_obj_f00000000WR = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "subtraction term");
						_position = _many_position_f00000000WR;
						_obj = _many_obj_f00000000WR;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "subtraction term");
					_sequence_fail_f00000000Qo = true;
					goto _sequence_end_f00000000Qo;
				}
				_sequence_end_f00000000Qo:
				if (_sequence_fail_f00000000Qo) {
					_position = _alt_position_f00000000LJ;
					_obj = _alt_obj_f00000000LJ;
				} else {
					_alternate_success_f00000000LJ = true;
				}
			}
			if (_alternate_success_f00000000LJ) {
			} else {
				_position = _many_position_f00000000Gq;
				_obj = _many_obj_f00000000Gq;
				break;
			}
		}
		if (expression.ParseRule_expression12(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000000As = true;
		goto _sequence_end_f00000000As;
		}
		_sequence_end_f00000000As:
		if (_sequence_fail_f00000000As) {
			_position.Cache<arithmetic_disjunction_term_subtraction_term>(_start_index, null);
			_position.TraceExit("arithmetic_disjunction_term:subtraction_term", false);
			_result = null;
			return false;
		} else {
			_position.Cache<arithmetic_disjunction_term_subtraction_term>(_start_index, _obj);
			_position.TraceExit("arithmetic_disjunction_term:subtraction_term", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (arithmetic_disjunction_term)_obj;
			return true;
		}
	}
	public abstract void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _block);
}
internal class arithmetic_disjunction_term_addition_term : arithmetic_disjunction_term {
	public override string PrettyName { get { return "addition term"; } }
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000000Ak = _type & (0 | Flabbergast.Type.Float | Flabbergast.Type.Int);
		if (f00000000Ak == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float | Flabbergast.Type.Int, _type);
		}
		var f00000000D1 =  f00000000Ak;
		if (expression != null) f00000000D1 &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, f00000000Ak | Flabbergast.Type.Int, ref _success, true), f00000000Ak);
		InferredType = f00000000D1;		return f00000000D1;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		Generator.ParameterisedBlock<LoadableValue> f00000000Aj_code = (f00000000Aj) => {
			_final_block(f00000000Aj);
		};
		if (_accumulator.BackingType == typeof(double)) {
			expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000000QN) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f00000000LB_code = (f00000000LB) => {
					f00000000Aj_code(f00000000LB);
				};
				if (f00000000QN.BackingType == typeof(double)) {
					var f00000000cw = new GeneratedValue(typeof(double), (f00000005En_builder) => {
					if (!typeof(double).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Add.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(double));
					if (!typeof(double).IsAssignableFrom(f00000000QN.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Add.", Stringish.NameForType(f00000000QN.BackingType)));
					_generator.LoadReboxed(f00000000QN, typeof(double));
					f00000005En_builder.Emit(System.Reflection.Emit.OpCodes.Add);
					});
					f00000000LB_code(f00000000cw);
				} else if (f00000000QN.BackingType == typeof(long)) {
					var f00000000mr = new GeneratedValue(typeof(double), (f00000005Bi_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000000QN.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_R8.", Stringish.NameForType(f00000000QN.BackingType)));
					_generator.LoadReboxed(f00000000QN, typeof(long));
					f00000005Bi_builder.Emit(System.Reflection.Emit.OpCodes.Conv_R8);
					});
					var f00000000cv = new GeneratedValue(typeof(double), (f0000000584_builder) => {
					if (!typeof(double).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Add.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(double));
					if (!typeof(double).IsAssignableFrom(f00000000mr.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Add.", Stringish.NameForType(f00000000mr.BackingType)));
					_generator.LoadReboxed(f00000000mr, typeof(double));
					f0000000584_builder.Emit(System.Reflection.Emit.OpCodes.Add);
					});
					f00000000LB_code(f00000000cv);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: addition term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			});
		} else if (_accumulator.BackingType == typeof(long)) {
			expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000000QK) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f00000000LA_code = (f00000000LA) => {
					f00000000Aj_code(f00000000LA);
				};
				if (f00000000QK.BackingType == typeof(double)) {
					var f00000000mm = new GeneratedValue(typeof(double), (f00000004zm_builder) => {
					if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_R8.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(long));
					f00000004zm_builder.Emit(System.Reflection.Emit.OpCodes.Conv_R8);
					});
					var f00000000ct = new GeneratedValue(typeof(double), (f00000004g6_builder) => {
					if (!typeof(double).IsAssignableFrom(f00000000mm.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Add.", Stringish.NameForType(f00000000mm.BackingType)));
					_generator.LoadReboxed(f00000000mm, typeof(double));
					if (!typeof(double).IsAssignableFrom(f00000000QK.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Add.", Stringish.NameForType(f00000000QK.BackingType)));
					_generator.LoadReboxed(f00000000QK, typeof(double));
					f00000004g6_builder.Emit(System.Reflection.Emit.OpCodes.Add);
					});
					f00000000LA_code(f00000000ct);
				} else if (f00000000QK.BackingType == typeof(long)) {
					var f00000000cs = new GeneratedValue(typeof(long), (f00000001ca_builder) => {
					if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Add.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(long));
					if (!typeof(long).IsAssignableFrom(f00000000QK.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Add.", Stringish.NameForType(f00000000QK.BackingType)));
					_generator.LoadReboxed(f00000000QK, typeof(long));
					f00000001ca_builder.Emit(System.Reflection.Emit.OpCodes.Add);
					});
					f00000000LA_code(f00000000cs);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: addition term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			});
		} else {
			throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: addition term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
		}
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expression.GenerateApi(_api_gen, false);
	}
	internal arithmetic_disjunction_term_addition_term Clone() {
		var _obj = new arithmetic_disjunction_term_addition_term();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expression = expression;
		return _obj;
	}
}
internal class arithmetic_disjunction_term_subtraction_term : arithmetic_disjunction_term {
	public override string PrettyName { get { return "subtraction term"; } }
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000000Ar = _type & (0 | Flabbergast.Type.Float | Flabbergast.Type.Int);
		if (f00000000Ar == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float | Flabbergast.Type.Int, _type);
		}
		var f00000000DE =  f00000000Ar;
		if (expression != null) f00000000DE &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, f00000000Ar | Flabbergast.Type.Int, ref _success, true), f00000000Ar);
		InferredType = f00000000DE;		return f00000000DE;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		Generator.ParameterisedBlock<LoadableValue> f00000000Aq_code = (f00000000Aq) => {
			_final_block(f00000000Aq);
		};
		if (_accumulator.BackingType == typeof(double)) {
			expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000000Qf) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f00000000LH_code = (f00000000LH) => {
					f00000000Aq_code(f00000000LH);
				};
				if (f00000000Qf.BackingType == typeof(double)) {
					var f00000000dD = new GeneratedValue(typeof(double), (f00000005Eo_builder) => {
					if (!typeof(double).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Sub.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(double));
					if (!typeof(double).IsAssignableFrom(f00000000Qf.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Sub.", Stringish.NameForType(f00000000Qf.BackingType)));
					_generator.LoadReboxed(f00000000Qf, typeof(double));
					f00000005Eo_builder.Emit(System.Reflection.Emit.OpCodes.Sub);
					});
					f00000000LH_code(f00000000dD);
				} else if (f00000000Qf.BackingType == typeof(long)) {
					var f00000000nD = new GeneratedValue(typeof(double), (f00000005Bj_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000000Qf.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_R8.", Stringish.NameForType(f00000000Qf.BackingType)));
					_generator.LoadReboxed(f00000000Qf, typeof(long));
					f00000005Bj_builder.Emit(System.Reflection.Emit.OpCodes.Conv_R8);
					});
					var f00000000dC = new GeneratedValue(typeof(double), (f0000000585_builder) => {
					if (!typeof(double).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Sub.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(double));
					if (!typeof(double).IsAssignableFrom(f00000000nD.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Sub.", Stringish.NameForType(f00000000nD.BackingType)));
					_generator.LoadReboxed(f00000000nD, typeof(double));
					f0000000585_builder.Emit(System.Reflection.Emit.OpCodes.Sub);
					});
					f00000000LH_code(f00000000dC);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: subtraction term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			});
		} else if (_accumulator.BackingType == typeof(long)) {
			expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000000Qc) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f00000000LG_code = (f00000000LG) => {
					f00000000Aq_code(f00000000LG);
				};
				if (f00000000Qc.BackingType == typeof(double)) {
					var f00000000n8 = new GeneratedValue(typeof(double), (f00000004zn_builder) => {
					if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_R8.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(long));
					f00000004zn_builder.Emit(System.Reflection.Emit.OpCodes.Conv_R8);
					});
					var f00000000dA = new GeneratedValue(typeof(double), (f00000004g7_builder) => {
					if (!typeof(double).IsAssignableFrom(f00000000n8.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Sub.", Stringish.NameForType(f00000000n8.BackingType)));
					_generator.LoadReboxed(f00000000n8, typeof(double));
					if (!typeof(double).IsAssignableFrom(f00000000Qc.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Sub.", Stringish.NameForType(f00000000Qc.BackingType)));
					_generator.LoadReboxed(f00000000Qc, typeof(double));
					f00000004g7_builder.Emit(System.Reflection.Emit.OpCodes.Sub);
					});
					f00000000LG_code(f00000000dA);
				} else if (f00000000Qc.BackingType == typeof(long)) {
					var f00000000d9 = new GeneratedValue(typeof(long), (f00000001cb_builder) => {
					if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Sub.", Stringish.NameForType(_accumulator.BackingType)));
					_generator.LoadReboxed(_accumulator, typeof(long));
					if (!typeof(long).IsAssignableFrom(f00000000Qc.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Sub.", Stringish.NameForType(f00000000Qc.BackingType)));
					_generator.LoadReboxed(f00000000Qc, typeof(long));
					f00000001cb_builder.Emit(System.Reflection.Emit.OpCodes.Sub);
					});
					f00000000LG_code(f00000000d9);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: subtraction term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			});
		} else {
			throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: subtraction term not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
		}
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expression.GenerateApi(_api_gen, false);
	}
	internal arithmetic_disjunction_term_subtraction_term Clone() {
		var _obj = new arithmetic_disjunction_term_subtraction_term();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expression = expression;
		return _obj;
	}
}
internal abstract class attribute : AstTypeableNode, ITypeableElement {
	public abstract Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool needs_unbox);
	internal RevCons<char> comment = null;
	internal RevCons<char> name = null;
	internal void AddMask(ErrorCollector collector, Environment environment) { environment.AddMask(Generator.ToString(name), this); }
	internal static bool ParseRule_extend_tmpl_attributes(ref ParserPosition position, out attribute result) {
		position.TraceEnter("extend_tmpl_attributes");
		if(position.CheckCache<attribute>("attribute.extend_tmpl_attributes", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("extend_tmpl_attributes", "attribute");
		slave_position = position.Clone();
		if (ParseRule_eager_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:extend_tmpl_attributes", true);
			position.Cache<attribute>("attribute.extend_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_informative_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:extend_tmpl_attributes", true);
			position.Cache<attribute>("attribute.extend_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_missing_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:extend_tmpl_attributes", true);
			position.Cache<attribute>("attribute.extend_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_named_override(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:extend_tmpl_attributes", true);
			position.Cache<attribute>("attribute.extend_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_plain_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:extend_tmpl_attributes", true);
			position.Cache<attribute>("attribute.extend_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_remove_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:extend_tmpl_attributes", true);
			position.Cache<attribute>("attribute.extend_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_template_override(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:extend_tmpl_attributes", true);
			position.Cache<attribute>("attribute.extend_tmpl_attributes", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("attribute:extend_tmpl_attributes", false);
		position.Cache<attribute>("attribute.extend_tmpl_attributes", start_index, null);
		return false;
	}
	internal static bool ParseRule_function_tmpl_attributes(ref ParserPosition position, out attribute result) {
		position.TraceEnter("function_tmpl_attributes");
		if(position.CheckCache<attribute>("attribute.function_tmpl_attributes", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("function_tmpl_attributes", "attribute");
		slave_position = position.Clone();
		if (ParseRule_eager_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:function_tmpl_attributes", true);
			position.Cache<attribute>("attribute.function_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_plain_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:function_tmpl_attributes", true);
			position.Cache<attribute>("attribute.function_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_zz_missing_name(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:function_tmpl_attributes", true);
			position.Cache<attribute>("attribute.function_tmpl_attributes", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("attribute:function_tmpl_attributes", false);
		position.Cache<attribute>("attribute.function_tmpl_attributes", start_index, null);
		return false;
	}
	internal static bool ParseRule_instantiate_tmpl_attributes(ref ParserPosition position, out attribute result) {
		position.TraceEnter("instantiate_tmpl_attributes");
		if(position.CheckCache<attribute>("attribute.instantiate_tmpl_attributes", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("instantiate_tmpl_attributes", "attribute");
		slave_position = position.Clone();
		if (ParseRule_eager_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:instantiate_tmpl_attributes", true);
			position.Cache<attribute>("attribute.instantiate_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_informative_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:instantiate_tmpl_attributes", true);
			position.Cache<attribute>("attribute.instantiate_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_named_override(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:instantiate_tmpl_attributes", true);
			position.Cache<attribute>("attribute.instantiate_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_plain_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:instantiate_tmpl_attributes", true);
			position.Cache<attribute>("attribute.instantiate_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_remove_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:instantiate_tmpl_attributes", true);
			position.Cache<attribute>("attribute.instantiate_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_template_override(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:instantiate_tmpl_attributes", true);
			position.Cache<attribute>("attribute.instantiate_tmpl_attributes", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("attribute:instantiate_tmpl_attributes", false);
		position.Cache<attribute>("attribute.instantiate_tmpl_attributes", start_index, null);
		return false;
	}
	internal static bool ParseRule_new_tmpl_attributes(ref ParserPosition position, out attribute result) {
		position.TraceEnter("new_tmpl_attributes");
		if(position.CheckCache<attribute>("attribute.new_tmpl_attributes", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("new_tmpl_attributes", "attribute");
		slave_position = position.Clone();
		if (ParseRule_eager_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:new_tmpl_attributes", true);
			position.Cache<attribute>("attribute.new_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_informative_attribute_new(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:new_tmpl_attributes", true);
			position.Cache<attribute>("attribute.new_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_missing_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:new_tmpl_attributes", true);
			position.Cache<attribute>("attribute.new_tmpl_attributes", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_plain_attribute(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("attribute:new_tmpl_attributes", true);
			position.Cache<attribute>("attribute.new_tmpl_attributes", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("attribute:new_tmpl_attributes", false);
		position.Cache<attribute>("attribute.new_tmpl_attributes", start_index, null);
		return false;
	}
	internal static bool ParseRule_eager_attribute(ref ParserPosition _position, out attribute _result) {
		if(_position.CheckCache<attribute_eager_attribute, attribute>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new attribute_eager_attribute();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("attribute:eager_attribute");

		bool _sequence_fail_f00000001rf = false;
		var _optional_obj_f00000001yB = _obj.Clone();
		ParserPosition _optional_position_f00000001yB = _position.Clone();
		bool _sequence_fail_f000000027w = false;
		while(true) {
			ParserPosition _many_position_f00000002Sl = _position.Clone();
			var _many_obj_f00000002Sl = _obj.Clone();
			bool _alternate_success_f00000002i2 = false;
			ParserPosition _alt_position_f00000002i2 = _position;
			var _alt_obj_f00000002i2 = _obj;
			if (!_alternate_success_f00000002i2) {
				_position = _alt_position_f00000002i2.Clone();
				_obj = _alt_obj_f00000002i2.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002i2 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "eagerly evaluated attribute");
					_position = _alt_position_f00000002i2;
					_obj = _alt_obj_f00000002i2;
				}
			}
			if (!_alternate_success_f00000002i2) {
				_position = _alt_position_f00000002i2.Clone();
				_obj = _alt_obj_f00000002i2.Clone();
				bool _sequence_fail_f00000002vO = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "eagerly evaluated attribute");
					_sequence_fail_f00000002vO = true;
					goto _sequence_end_f00000002vO;
				}
				while(true) {
					ParserPosition _many_position_f000000038T = _position.Clone();
					var _many_obj_f000000038T = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "eagerly evaluated attribute");
						_position = _many_position_f000000038T;
						_obj = _many_obj_f000000038T;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "eagerly evaluated attribute");
					_sequence_fail_f00000002vO = true;
					goto _sequence_end_f00000002vO;
				}
				_sequence_end_f00000002vO:
				if (_sequence_fail_f00000002vO) {
					_position = _alt_position_f00000002i2;
					_obj = _alt_obj_f00000002i2;
				} else {
					_alternate_success_f00000002i2 = true;
				}
			}
			if (_alternate_success_f00000002i2) {
			} else {
				_position = _many_position_f00000002Sl;
				_obj = _many_obj_f00000002Sl;
				break;
			}
		}
		if (_position.Match("{{{")) {
		} else {
			_position.Update("“{{{”", "eagerly evaluated attribute");
			_sequence_fail_f000000027w = true;
			goto _sequence_end_f000000027w;
		}
		while(true) {
			ParserPosition _many_position_f00000002Sn = _position.Clone();
			var _many_obj_f00000002Sn = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.intro, documentation.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000002Sn;
			_obj = _many_obj_f00000002Sn;
			break;
			}
		}
		if (_position.Match("}}}")) {
		} else {
			_position.Update("“}}}”", "eagerly evaluated attribute");
			_sequence_fail_f000000027w = true;
			goto _sequence_end_f000000027w;
		}
		_sequence_end_f000000027w:
		if (_sequence_fail_f000000027w) {
			_obj = _optional_obj_f00000001yB;
			_position = _optional_position_f00000001yB;
			goto optional_exit_f00000001yB;
		} else {
			goto optional_exit_f00000001yB;
		}
		optional_exit_f00000001yB:
		while(true) {
			ParserPosition _many_position_f000000027x = _position.Clone();
			var _many_obj_f000000027x = _obj.Clone();
			bool _alternate_success_f00000002Iw = false;
			ParserPosition _alt_position_f00000002Iw = _position;
			var _alt_obj_f00000002Iw = _obj;
			if (!_alternate_success_f00000002Iw) {
				_position = _alt_position_f00000002Iw.Clone();
				_obj = _alt_obj_f00000002Iw.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Iw = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "eagerly evaluated attribute");
					_position = _alt_position_f00000002Iw;
					_obj = _alt_obj_f00000002Iw;
				}
			}
			if (!_alternate_success_f00000002Iw) {
				_position = _alt_position_f00000002Iw.Clone();
				_obj = _alt_obj_f00000002Iw.Clone();
				bool _sequence_fail_f00000002Su = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "eagerly evaluated attribute");
					_sequence_fail_f00000002Su = true;
					goto _sequence_end_f00000002Su;
				}
				while(true) {
					ParserPosition _many_position_f00000002i6 = _position.Clone();
					var _many_obj_f00000002i6 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "eagerly evaluated attribute");
						_position = _many_position_f00000002i6;
						_obj = _many_obj_f00000002i6;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "eagerly evaluated attribute");
					_sequence_fail_f00000002Su = true;
					goto _sequence_end_f00000002Su;
				}
				_sequence_end_f00000002Su:
				if (_sequence_fail_f00000002Su) {
					_position = _alt_position_f00000002Iw;
					_obj = _alt_obj_f00000002Iw;
				} else {
					_alternate_success_f00000002Iw = true;
				}
			}
			if (_alternate_success_f00000002Iw) {
			} else {
				_position = _many_position_f000000027x;
				_obj = _many_obj_f000000027x;
				break;
			}
		}
		bool _sequence_fail_f000000027y = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "eagerly evaluated attribute");
			_sequence_fail_f000000027y = true;
			goto _sequence_end_f000000027y;
		}
		while(true) {
			ParserPosition _many_position_f00000002Iz = _position.Clone();
			var _many_obj_f00000002Iz = _obj.Clone();
			bool _alternate_success_f00000002Sy = false;
			ParserPosition _alt_position_f00000002Sy = _position;
			var _alt_obj_f00000002Sy = _obj;
			if (!_alternate_success_f00000002Sy) {
				_position = _alt_position_f00000002Sy.Clone();
				_obj = _alt_obj_f00000002Sy.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Sy = true;
				} else {
					_position.Update("character between “a” and “z”", "eagerly evaluated attribute");
					_position = _alt_position_f00000002Sy;
					_obj = _alt_obj_f00000002Sy;
				}
			}
			if (!_alternate_success_f00000002Sy) {
				_position = _alt_position_f00000002Sy.Clone();
				_obj = _alt_obj_f00000002Sy.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Sy = true;
				} else {
					_position.Update("character between “A” and “Z”", "eagerly evaluated attribute");
					_position = _alt_position_f00000002Sy;
					_obj = _alt_obj_f00000002Sy;
				}
			}
			if (!_alternate_success_f00000002Sy) {
				_position = _alt_position_f00000002Sy.Clone();
				_obj = _alt_obj_f00000002Sy.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Sy = true;
				} else {
					_position.Update("character between “0” and “9”", "eagerly evaluated attribute");
					_position = _alt_position_f00000002Sy;
					_obj = _alt_obj_f00000002Sy;
				}
			}
			if (!_alternate_success_f00000002Sy) {
				_position = _alt_position_f00000002Sy.Clone();
				_obj = _alt_obj_f00000002Sy.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Sy = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "eagerly evaluated attribute");
					_position = _alt_position_f00000002Sy;
					_obj = _alt_obj_f00000002Sy;
				}
			}
			if (_alternate_success_f00000002Sy) {
			} else {
				_position = _many_position_f00000002Iz;
				_obj = _many_obj_f00000002Iz;
				break;
			}
		}
		_sequence_end_f000000027y:
		if (_sequence_fail_f000000027y) {
			_sequence_fail_f00000001rf = true;
			goto _sequence_end_f00000001rf;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f000000027z = _position.Clone();
			var _many_obj_f000000027z = _obj.Clone();
			bool _alternate_success_f00000002J0 = false;
			ParserPosition _alt_position_f00000002J0 = _position;
			var _alt_obj_f00000002J0 = _obj;
			if (!_alternate_success_f00000002J0) {
				_position = _alt_position_f00000002J0.Clone();
				_obj = _alt_obj_f00000002J0.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002J0 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "eagerly evaluated attribute");
					_position = _alt_position_f00000002J0;
					_obj = _alt_obj_f00000002J0;
				}
			}
			if (!_alternate_success_f00000002J0) {
				_position = _alt_position_f00000002J0.Clone();
				_obj = _alt_obj_f00000002J0.Clone();
				bool _sequence_fail_f00000002T5 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "eagerly evaluated attribute");
					_sequence_fail_f00000002T5 = true;
					goto _sequence_end_f00000002T5;
				}
				while(true) {
					ParserPosition _many_position_f00000002iH = _position.Clone();
					var _many_obj_f00000002iH = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "eagerly evaluated attribute");
						_position = _many_position_f00000002iH;
						_obj = _many_obj_f00000002iH;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "eagerly evaluated attribute");
					_sequence_fail_f00000002T5 = true;
					goto _sequence_end_f00000002T5;
				}
				_sequence_end_f00000002T5:
				if (_sequence_fail_f00000002T5) {
					_position = _alt_position_f00000002J0;
					_obj = _alt_obj_f00000002J0;
				} else {
					_alternate_success_f00000002J0 = true;
				}
			}
			if (_alternate_success_f00000002J0) {
			} else {
				_position = _many_position_f000000027z;
				_obj = _many_obj_f000000027z;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "eagerly evaluated attribute");
			_sequence_fail_f00000001rf = true;
			goto _sequence_end_f00000001rf;
		}
		while(true) {
			ParserPosition _many_position_f0000000281 = _position.Clone();
			var _many_obj_f0000000281 = _obj.Clone();
			bool _alternate_success_f00000002J1 = false;
			ParserPosition _alt_position_f00000002J1 = _position;
			var _alt_obj_f00000002J1 = _obj;
			if (!_alternate_success_f00000002J1) {
				_position = _alt_position_f00000002J1.Clone();
				_obj = _alt_obj_f00000002J1.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002J1 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "eagerly evaluated attribute");
					_position = _alt_position_f00000002J1;
					_obj = _alt_obj_f00000002J1;
				}
			}
			if (!_alternate_success_f00000002J1) {
				_position = _alt_position_f00000002J1.Clone();
				_obj = _alt_obj_f00000002J1.Clone();
				bool _sequence_fail_f00000002T9 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "eagerly evaluated attribute");
					_sequence_fail_f00000002T9 = true;
					goto _sequence_end_f00000002T9;
				}
				while(true) {
					ParserPosition _many_position_f00000002iN = _position.Clone();
					var _many_obj_f00000002iN = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "eagerly evaluated attribute");
						_position = _many_position_f00000002iN;
						_obj = _many_obj_f00000002iN;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "eagerly evaluated attribute");
					_sequence_fail_f00000002T9 = true;
					goto _sequence_end_f00000002T9;
				}
				_sequence_end_f00000002T9:
				if (_sequence_fail_f00000002T9) {
					_position = _alt_position_f00000002J1;
					_obj = _alt_obj_f00000002J1;
				} else {
					_alternate_success_f00000002J1 = true;
				}
			}
			if (_alternate_success_f00000002J1) {
			} else {
				_position = _many_position_f0000000281;
				_obj = _many_obj_f0000000281;
				break;
			}
		}
		if (_position.Match("Now")) {
		} else {
			_position.Update("“Now”", "eagerly evaluated attribute");
			_sequence_fail_f00000001rf = true;
			goto _sequence_end_f00000001rf;
		}
		bool _first_f0000000283 = true;
		while(true) {
			ParserPosition _many_position_f0000000283 = _position.Clone();
			var _many_obj_f0000000283 = _obj.Clone();
			bool _alternate_success_f00000002J2 = false;
			ParserPosition _alt_position_f00000002J2 = _position;
			var _alt_obj_f00000002J2 = _obj;
			if (!_alternate_success_f00000002J2) {
				_position = _alt_position_f00000002J2.Clone();
				_obj = _alt_obj_f00000002J2.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002J2 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "eagerly evaluated attribute");
					_position = _alt_position_f00000002J2;
					_obj = _alt_obj_f00000002J2;
				}
			}
			if (!_alternate_success_f00000002J2) {
				_position = _alt_position_f00000002J2.Clone();
				_obj = _alt_obj_f00000002J2.Clone();
				bool _sequence_fail_f00000002TD = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "eagerly evaluated attribute");
					_sequence_fail_f00000002TD = true;
					goto _sequence_end_f00000002TD;
				}
				while(true) {
					ParserPosition _many_position_f00000002iT = _position.Clone();
					var _many_obj_f00000002iT = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "eagerly evaluated attribute");
						_position = _many_position_f00000002iT;
						_obj = _many_obj_f00000002iT;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "eagerly evaluated attribute");
					_sequence_fail_f00000002TD = true;
					goto _sequence_end_f00000002TD;
				}
				_sequence_end_f00000002TD:
				if (_sequence_fail_f00000002TD) {
					_position = _alt_position_f00000002J2;
					_obj = _alt_obj_f00000002J2;
				} else {
					_alternate_success_f00000002J2 = true;
				}
			}
			if (_alternate_success_f00000002J2) {
			} else {
				_position = _many_position_f0000000283;
				_obj = _many_obj_f0000000283;
				break;
			}
			_first_f0000000283 = false;
		}
		if (_first_f0000000283) {
			_sequence_fail_f00000001rf = true;
			goto _sequence_end_f00000001rf;
		} else {
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000001rf = true;
		goto _sequence_end_f00000001rf;
		}
		_sequence_end_f00000001rf:
		if (_sequence_fail_f00000001rf) {
			_position.Cache<attribute_eager_attribute>(_start_index, null);
			_position.TraceExit("attribute:eager_attribute", false);
			_result = null;
			return false;
		} else {
			_position.Cache<attribute_eager_attribute>(_start_index, _obj);
			_position.TraceExit("attribute:eager_attribute", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (attribute)_obj;
			return true;
		}
	}
	internal static bool ParseRule_informative_attribute(ref ParserPosition _position, out attribute _result) {
		if(_position.CheckCache<attribute_informative_attribute, attribute>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new attribute_informative_attribute();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("attribute:informative_attribute");

		bool _sequence_fail_f00000001rk = false;
		var _optional_obj_f00000001yQ = _obj.Clone();
		ParserPosition _optional_position_f00000001yQ = _position.Clone();
		bool _sequence_fail_f000000028F = false;
		while(true) {
			ParserPosition _many_position_f00000002TN = _position.Clone();
			var _many_obj_f00000002TN = _obj.Clone();
			bool _alternate_success_f00000002iX = false;
			ParserPosition _alt_position_f00000002iX = _position;
			var _alt_obj_f00000002iX = _obj;
			if (!_alternate_success_f00000002iX) {
				_position = _alt_position_f00000002iX.Clone();
				_obj = _alt_obj_f00000002iX.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002iX = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "informative attribute");
					_position = _alt_position_f00000002iX;
					_obj = _alt_obj_f00000002iX;
				}
			}
			if (!_alternate_success_f00000002iX) {
				_position = _alt_position_f00000002iX.Clone();
				_obj = _alt_obj_f00000002iX.Clone();
				bool _sequence_fail_f00000002w6 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "informative attribute");
					_sequence_fail_f00000002w6 = true;
					goto _sequence_end_f00000002w6;
				}
				while(true) {
					ParserPosition _many_position_f000000038h = _position.Clone();
					var _many_obj_f000000038h = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "informative attribute");
						_position = _many_position_f000000038h;
						_obj = _many_obj_f000000038h;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "informative attribute");
					_sequence_fail_f00000002w6 = true;
					goto _sequence_end_f00000002w6;
				}
				_sequence_end_f00000002w6:
				if (_sequence_fail_f00000002w6) {
					_position = _alt_position_f00000002iX;
					_obj = _alt_obj_f00000002iX;
				} else {
					_alternate_success_f00000002iX = true;
				}
			}
			if (_alternate_success_f00000002iX) {
			} else {
				_position = _many_position_f00000002TN;
				_obj = _many_obj_f00000002TN;
				break;
			}
		}
		if (_position.Match("{{{")) {
		} else {
			_position.Update("“{{{”", "informative attribute");
			_sequence_fail_f000000028F = true;
			goto _sequence_end_f000000028F;
		}
		while(true) {
			ParserPosition _many_position_f00000002TP = _position.Clone();
			var _many_obj_f00000002TP = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.intro, documentation.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000002TP;
			_obj = _many_obj_f00000002TP;
			break;
			}
		}
		if (_position.Match("}}}")) {
		} else {
			_position.Update("“}}}”", "informative attribute");
			_sequence_fail_f000000028F = true;
			goto _sequence_end_f000000028F;
		}
		_sequence_end_f000000028F:
		if (_sequence_fail_f000000028F) {
			_obj = _optional_obj_f00000001yQ;
			_position = _optional_position_f00000001yQ;
			goto optional_exit_f00000001yQ;
		} else {
			goto optional_exit_f00000001yQ;
		}
		optional_exit_f00000001yQ:
		while(true) {
			ParserPosition _many_position_f000000028G = _position.Clone();
			var _many_obj_f000000028G = _obj.Clone();
			bool _alternate_success_f00000002J8 = false;
			ParserPosition _alt_position_f00000002J8 = _position;
			var _alt_obj_f00000002J8 = _obj;
			if (!_alternate_success_f00000002J8) {
				_position = _alt_position_f00000002J8.Clone();
				_obj = _alt_obj_f00000002J8.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002J8 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "informative attribute");
					_position = _alt_position_f00000002J8;
					_obj = _alt_obj_f00000002J8;
				}
			}
			if (!_alternate_success_f00000002J8) {
				_position = _alt_position_f00000002J8.Clone();
				_obj = _alt_obj_f00000002J8.Clone();
				bool _sequence_fail_f00000002TW = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "informative attribute");
					_sequence_fail_f00000002TW = true;
					goto _sequence_end_f00000002TW;
				}
				while(true) {
					ParserPosition _many_position_f00000002ib = _position.Clone();
					var _many_obj_f00000002ib = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "informative attribute");
						_position = _many_position_f00000002ib;
						_obj = _many_obj_f00000002ib;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "informative attribute");
					_sequence_fail_f00000002TW = true;
					goto _sequence_end_f00000002TW;
				}
				_sequence_end_f00000002TW:
				if (_sequence_fail_f00000002TW) {
					_position = _alt_position_f00000002J8;
					_obj = _alt_obj_f00000002J8;
				} else {
					_alternate_success_f00000002J8 = true;
				}
			}
			if (_alternate_success_f00000002J8) {
			} else {
				_position = _many_position_f000000028G;
				_obj = _many_obj_f000000028G;
				break;
			}
		}
		bool _sequence_fail_f000000028H = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "informative attribute");
			_sequence_fail_f000000028H = true;
			goto _sequence_end_f000000028H;
		}
		while(true) {
			ParserPosition _many_position_f00000002JB = _position.Clone();
			var _many_obj_f00000002JB = _obj.Clone();
			bool _alternate_success_f00000002Ta = false;
			ParserPosition _alt_position_f00000002Ta = _position;
			var _alt_obj_f00000002Ta = _obj;
			if (!_alternate_success_f00000002Ta) {
				_position = _alt_position_f00000002Ta.Clone();
				_obj = _alt_obj_f00000002Ta.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Ta = true;
				} else {
					_position.Update("character between “a” and “z”", "informative attribute");
					_position = _alt_position_f00000002Ta;
					_obj = _alt_obj_f00000002Ta;
				}
			}
			if (!_alternate_success_f00000002Ta) {
				_position = _alt_position_f00000002Ta.Clone();
				_obj = _alt_obj_f00000002Ta.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Ta = true;
				} else {
					_position.Update("character between “A” and “Z”", "informative attribute");
					_position = _alt_position_f00000002Ta;
					_obj = _alt_obj_f00000002Ta;
				}
			}
			if (!_alternate_success_f00000002Ta) {
				_position = _alt_position_f00000002Ta.Clone();
				_obj = _alt_obj_f00000002Ta.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Ta = true;
				} else {
					_position.Update("character between “0” and “9”", "informative attribute");
					_position = _alt_position_f00000002Ta;
					_obj = _alt_obj_f00000002Ta;
				}
			}
			if (!_alternate_success_f00000002Ta) {
				_position = _alt_position_f00000002Ta.Clone();
				_obj = _alt_obj_f00000002Ta.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Ta = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "informative attribute");
					_position = _alt_position_f00000002Ta;
					_obj = _alt_obj_f00000002Ta;
				}
			}
			if (_alternate_success_f00000002Ta) {
			} else {
				_position = _many_position_f00000002JB;
				_obj = _many_obj_f00000002JB;
				break;
			}
		}
		_sequence_end_f000000028H:
		if (_sequence_fail_f000000028H) {
			_sequence_fail_f00000001rk = true;
			goto _sequence_end_f00000001rk;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f000000028I = _position.Clone();
			var _many_obj_f000000028I = _obj.Clone();
			bool _alternate_success_f00000002JC = false;
			ParserPosition _alt_position_f00000002JC = _position;
			var _alt_obj_f00000002JC = _obj;
			if (!_alternate_success_f00000002JC) {
				_position = _alt_position_f00000002JC.Clone();
				_obj = _alt_obj_f00000002JC.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002JC = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "informative attribute");
					_position = _alt_position_f00000002JC;
					_obj = _alt_obj_f00000002JC;
				}
			}
			if (!_alternate_success_f00000002JC) {
				_position = _alt_position_f00000002JC.Clone();
				_obj = _alt_obj_f00000002JC.Clone();
				bool _sequence_fail_f00000002Th = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "informative attribute");
					_sequence_fail_f00000002Th = true;
					goto _sequence_end_f00000002Th;
				}
				while(true) {
					ParserPosition _many_position_f00000002im = _position.Clone();
					var _many_obj_f00000002im = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "informative attribute");
						_position = _many_position_f00000002im;
						_obj = _many_obj_f00000002im;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "informative attribute");
					_sequence_fail_f00000002Th = true;
					goto _sequence_end_f00000002Th;
				}
				_sequence_end_f00000002Th:
				if (_sequence_fail_f00000002Th) {
					_position = _alt_position_f00000002JC;
					_obj = _alt_obj_f00000002JC;
				} else {
					_alternate_success_f00000002JC = true;
				}
			}
			if (_alternate_success_f00000002JC) {
			} else {
				_position = _many_position_f000000028I;
				_obj = _many_obj_f000000028I;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "informative attribute");
			_sequence_fail_f00000001rk = true;
			goto _sequence_end_f00000001rk;
		}
		while(true) {
			ParserPosition _many_position_f000000028K = _position.Clone();
			var _many_obj_f000000028K = _obj.Clone();
			bool _alternate_success_f00000002JD = false;
			ParserPosition _alt_position_f00000002JD = _position;
			var _alt_obj_f00000002JD = _obj;
			if (!_alternate_success_f00000002JD) {
				_position = _alt_position_f00000002JD.Clone();
				_obj = _alt_obj_f00000002JD.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002JD = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "informative attribute");
					_position = _alt_position_f00000002JD;
					_obj = _alt_obj_f00000002JD;
				}
			}
			if (!_alternate_success_f00000002JD) {
				_position = _alt_position_f00000002JD.Clone();
				_obj = _alt_obj_f00000002JD.Clone();
				bool _sequence_fail_f00000002Tl = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "informative attribute");
					_sequence_fail_f00000002Tl = true;
					goto _sequence_end_f00000002Tl;
				}
				while(true) {
					ParserPosition _many_position_f00000002is = _position.Clone();
					var _many_obj_f00000002is = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "informative attribute");
						_position = _many_position_f00000002is;
						_obj = _many_obj_f00000002is;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "informative attribute");
					_sequence_fail_f00000002Tl = true;
					goto _sequence_end_f00000002Tl;
				}
				_sequence_end_f00000002Tl:
				if (_sequence_fail_f00000002Tl) {
					_position = _alt_position_f00000002JD;
					_obj = _alt_obj_f00000002JD;
				} else {
					_alternate_success_f00000002JD = true;
				}
			}
			if (_alternate_success_f00000002JD) {
			} else {
				_position = _many_position_f000000028K;
				_obj = _many_obj_f000000028K;
				break;
			}
		}
		if (_position.Match("Used")) {
		} else {
			_position.Update("“Used”", "informative attribute");
			_sequence_fail_f00000001rk = true;
			goto _sequence_end_f00000001rk;
		}
		_sequence_end_f00000001rk:
		if (_sequence_fail_f00000001rk) {
			_position.Cache<attribute_informative_attribute>(_start_index, null);
			_position.TraceExit("attribute:informative_attribute", false);
			_result = null;
			return false;
		} else {
			_position.Cache<attribute_informative_attribute>(_start_index, _obj);
			_position.TraceExit("attribute:informative_attribute", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (attribute)_obj;
			return true;
		}
	}
	internal static bool ParseRule_informative_attribute_new(ref ParserPosition _position, out attribute _result) {
		if(_position.CheckCache<attribute_informative_attribute_new, attribute>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new attribute_informative_attribute_new();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("attribute:informative_attribute_new");

		bool _sequence_fail_f00000001ro = false;
		var _optional_obj_f00000001yZ = _obj.Clone();
		ParserPosition _optional_position_f00000001yZ = _position.Clone();
		bool _sequence_fail_f000000028Q = false;
		while(true) {
			ParserPosition _many_position_f00000002Tr = _position.Clone();
			var _many_obj_f00000002Tr = _obj.Clone();
			bool _alternate_success_f00000002iw = false;
			ParserPosition _alt_position_f00000002iw = _position;
			var _alt_obj_f00000002iw = _obj;
			if (!_alternate_success_f00000002iw) {
				_position = _alt_position_f00000002iw.Clone();
				_obj = _alt_obj_f00000002iw.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002iw = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "informative attribute");
					_position = _alt_position_f00000002iw;
					_obj = _alt_obj_f00000002iw;
				}
			}
			if (!_alternate_success_f00000002iw) {
				_position = _alt_position_f00000002iw.Clone();
				_obj = _alt_obj_f00000002iw.Clone();
				bool _sequence_fail_f00000002wj = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "informative attribute");
					_sequence_fail_f00000002wj = true;
					goto _sequence_end_f00000002wj;
				}
				while(true) {
					ParserPosition _many_position_f000000038t = _position.Clone();
					var _many_obj_f000000038t = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "informative attribute");
						_position = _many_position_f000000038t;
						_obj = _many_obj_f000000038t;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "informative attribute");
					_sequence_fail_f00000002wj = true;
					goto _sequence_end_f00000002wj;
				}
				_sequence_end_f00000002wj:
				if (_sequence_fail_f00000002wj) {
					_position = _alt_position_f00000002iw;
					_obj = _alt_obj_f00000002iw;
				} else {
					_alternate_success_f00000002iw = true;
				}
			}
			if (_alternate_success_f00000002iw) {
			} else {
				_position = _many_position_f00000002Tr;
				_obj = _many_obj_f00000002Tr;
				break;
			}
		}
		if (_position.Match("{{{")) {
		} else {
			_position.Update("“{{{”", "informative attribute");
			_sequence_fail_f000000028Q = true;
			goto _sequence_end_f000000028Q;
		}
		while(true) {
			ParserPosition _many_position_f00000002Tt = _position.Clone();
			var _many_obj_f00000002Tt = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.intro, documentation.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000002Tt;
			_obj = _many_obj_f00000002Tt;
			break;
			}
		}
		if (_position.Match("}}}")) {
		} else {
			_position.Update("“}}}”", "informative attribute");
			_sequence_fail_f000000028Q = true;
			goto _sequence_end_f000000028Q;
		}
		_sequence_end_f000000028Q:
		if (_sequence_fail_f000000028Q) {
			_obj = _optional_obj_f00000001yZ;
			_position = _optional_position_f00000001yZ;
			goto optional_exit_f00000001yZ;
		} else {
			goto optional_exit_f00000001yZ;
		}
		optional_exit_f00000001yZ:
		while(true) {
			ParserPosition _many_position_f000000028R = _position.Clone();
			var _many_obj_f000000028R = _obj.Clone();
			bool _alternate_success_f00000002JJ = false;
			ParserPosition _alt_position_f00000002JJ = _position;
			var _alt_obj_f00000002JJ = _obj;
			if (!_alternate_success_f00000002JJ) {
				_position = _alt_position_f00000002JJ.Clone();
				_obj = _alt_obj_f00000002JJ.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002JJ = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "informative attribute");
					_position = _alt_position_f00000002JJ;
					_obj = _alt_obj_f00000002JJ;
				}
			}
			if (!_alternate_success_f00000002JJ) {
				_position = _alt_position_f00000002JJ.Clone();
				_obj = _alt_obj_f00000002JJ.Clone();
				bool _sequence_fail_f00000002U0 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "informative attribute");
					_sequence_fail_f00000002U0 = true;
					goto _sequence_end_f00000002U0;
				}
				while(true) {
					ParserPosition _many_position_f00000002j0 = _position.Clone();
					var _many_obj_f00000002j0 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "informative attribute");
						_position = _many_position_f00000002j0;
						_obj = _many_obj_f00000002j0;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "informative attribute");
					_sequence_fail_f00000002U0 = true;
					goto _sequence_end_f00000002U0;
				}
				_sequence_end_f00000002U0:
				if (_sequence_fail_f00000002U0) {
					_position = _alt_position_f00000002JJ;
					_obj = _alt_obj_f00000002JJ;
				} else {
					_alternate_success_f00000002JJ = true;
				}
			}
			if (_alternate_success_f00000002JJ) {
			} else {
				_position = _many_position_f000000028R;
				_obj = _many_obj_f000000028R;
				break;
			}
		}
		bool _sequence_fail_f000000028S = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "informative attribute");
			_sequence_fail_f000000028S = true;
			goto _sequence_end_f000000028S;
		}
		while(true) {
			ParserPosition _many_position_f00000002JM = _position.Clone();
			var _many_obj_f00000002JM = _obj.Clone();
			bool _alternate_success_f00000002U4 = false;
			ParserPosition _alt_position_f00000002U4 = _position;
			var _alt_obj_f00000002U4 = _obj;
			if (!_alternate_success_f00000002U4) {
				_position = _alt_position_f00000002U4.Clone();
				_obj = _alt_obj_f00000002U4.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002U4 = true;
				} else {
					_position.Update("character between “a” and “z”", "informative attribute");
					_position = _alt_position_f00000002U4;
					_obj = _alt_obj_f00000002U4;
				}
			}
			if (!_alternate_success_f00000002U4) {
				_position = _alt_position_f00000002U4.Clone();
				_obj = _alt_obj_f00000002U4.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002U4 = true;
				} else {
					_position.Update("character between “A” and “Z”", "informative attribute");
					_position = _alt_position_f00000002U4;
					_obj = _alt_obj_f00000002U4;
				}
			}
			if (!_alternate_success_f00000002U4) {
				_position = _alt_position_f00000002U4.Clone();
				_obj = _alt_obj_f00000002U4.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002U4 = true;
				} else {
					_position.Update("character between “0” and “9”", "informative attribute");
					_position = _alt_position_f00000002U4;
					_obj = _alt_obj_f00000002U4;
				}
			}
			if (!_alternate_success_f00000002U4) {
				_position = _alt_position_f00000002U4.Clone();
				_obj = _alt_obj_f00000002U4.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002U4 = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "informative attribute");
					_position = _alt_position_f00000002U4;
					_obj = _alt_obj_f00000002U4;
				}
			}
			if (_alternate_success_f00000002U4) {
			} else {
				_position = _many_position_f00000002JM;
				_obj = _many_obj_f00000002JM;
				break;
			}
		}
		_sequence_end_f000000028S:
		if (_sequence_fail_f000000028S) {
			_sequence_fail_f00000001ro = true;
			goto _sequence_end_f00000001ro;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f000000028T = _position.Clone();
			var _many_obj_f000000028T = _obj.Clone();
			bool _alternate_success_f00000002JN = false;
			ParserPosition _alt_position_f00000002JN = _position;
			var _alt_obj_f00000002JN = _obj;
			if (!_alternate_success_f00000002JN) {
				_position = _alt_position_f00000002JN.Clone();
				_obj = _alt_obj_f00000002JN.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002JN = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "informative attribute");
					_position = _alt_position_f00000002JN;
					_obj = _alt_obj_f00000002JN;
				}
			}
			if (!_alternate_success_f00000002JN) {
				_position = _alt_position_f00000002JN.Clone();
				_obj = _alt_obj_f00000002JN.Clone();
				bool _sequence_fail_f00000002UB = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "informative attribute");
					_sequence_fail_f00000002UB = true;
					goto _sequence_end_f00000002UB;
				}
				while(true) {
					ParserPosition _many_position_f00000002jB = _position.Clone();
					var _many_obj_f00000002jB = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "informative attribute");
						_position = _many_position_f00000002jB;
						_obj = _many_obj_f00000002jB;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "informative attribute");
					_sequence_fail_f00000002UB = true;
					goto _sequence_end_f00000002UB;
				}
				_sequence_end_f00000002UB:
				if (_sequence_fail_f00000002UB) {
					_position = _alt_position_f00000002JN;
					_obj = _alt_obj_f00000002JN;
				} else {
					_alternate_success_f00000002JN = true;
				}
			}
			if (_alternate_success_f00000002JN) {
			} else {
				_position = _many_position_f000000028T;
				_obj = _many_obj_f000000028T;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "informative attribute");
			_sequence_fail_f00000001ro = true;
			goto _sequence_end_f00000001ro;
		}
		while(true) {
			ParserPosition _many_position_f000000028V = _position.Clone();
			var _many_obj_f000000028V = _obj.Clone();
			bool _alternate_success_f00000002JO = false;
			ParserPosition _alt_position_f00000002JO = _position;
			var _alt_obj_f00000002JO = _obj;
			if (!_alternate_success_f00000002JO) {
				_position = _alt_position_f00000002JO.Clone();
				_obj = _alt_obj_f00000002JO.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002JO = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "informative attribute");
					_position = _alt_position_f00000002JO;
					_obj = _alt_obj_f00000002JO;
				}
			}
			if (!_alternate_success_f00000002JO) {
				_position = _alt_position_f00000002JO.Clone();
				_obj = _alt_obj_f00000002JO.Clone();
				bool _sequence_fail_f00000002UF = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "informative attribute");
					_sequence_fail_f00000002UF = true;
					goto _sequence_end_f00000002UF;
				}
				while(true) {
					ParserPosition _many_position_f00000002jH = _position.Clone();
					var _many_obj_f00000002jH = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "informative attribute");
						_position = _many_position_f00000002jH;
						_obj = _many_obj_f00000002jH;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "informative attribute");
					_sequence_fail_f00000002UF = true;
					goto _sequence_end_f00000002UF;
				}
				_sequence_end_f00000002UF:
				if (_sequence_fail_f00000002UF) {
					_position = _alt_position_f00000002JO;
					_obj = _alt_obj_f00000002JO;
				} else {
					_alternate_success_f00000002JO = true;
				}
			}
			if (_alternate_success_f00000002JO) {
			} else {
				_position = _many_position_f000000028V;
				_obj = _many_obj_f000000028V;
				break;
			}
		}
		if (_position.Match("Used")) {
		} else {
			_position.Update("“Used”", "informative attribute");
			_sequence_fail_f00000001ro = true;
			goto _sequence_end_f00000001ro;
		}
		_sequence_end_f00000001ro:
		if (_sequence_fail_f00000001ro) {
			_position.Cache<attribute_informative_attribute_new>(_start_index, null);
			_position.TraceExit("attribute:informative_attribute_new", false);
			_result = null;
			return false;
		} else {
			_position.Cache<attribute_informative_attribute_new>(_start_index, _obj);
			_position.TraceExit("attribute:informative_attribute_new", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (attribute)_obj;
			return true;
		}
	}
	internal static bool ParseRule_missing_attribute(ref ParserPosition _position, out attribute _result) {
		if(_position.CheckCache<attribute_missing_attribute, attribute>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new attribute_missing_attribute();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("attribute:missing_attribute");

		bool _sequence_fail_f00000001rt = false;
		var _optional_obj_f00000001yj = _obj.Clone();
		ParserPosition _optional_position_f00000001yj = _position.Clone();
		bool _sequence_fail_f000000028f = false;
		while(true) {
			ParserPosition _many_position_f00000002UP = _position.Clone();
			var _many_obj_f00000002UP = _obj.Clone();
			bool _alternate_success_f00000002jR = false;
			ParserPosition _alt_position_f00000002jR = _position;
			var _alt_obj_f00000002jR = _obj;
			if (!_alternate_success_f00000002jR) {
				_position = _alt_position_f00000002jR.Clone();
				_obj = _alt_obj_f00000002jR.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002jR = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute requiring override");
					_position = _alt_position_f00000002jR;
					_obj = _alt_obj_f00000002jR;
				}
			}
			if (!_alternate_success_f00000002jR) {
				_position = _alt_position_f00000002jR.Clone();
				_obj = _alt_obj_f00000002jR.Clone();
				bool _sequence_fail_f00000002xT = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute requiring override");
					_sequence_fail_f00000002xT = true;
					goto _sequence_end_f00000002xT;
				}
				while(true) {
					ParserPosition _many_position_f0000000395 = _position.Clone();
					var _many_obj_f0000000395 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute requiring override");
						_position = _many_position_f0000000395;
						_obj = _many_obj_f0000000395;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute requiring override");
					_sequence_fail_f00000002xT = true;
					goto _sequence_end_f00000002xT;
				}
				_sequence_end_f00000002xT:
				if (_sequence_fail_f00000002xT) {
					_position = _alt_position_f00000002jR;
					_obj = _alt_obj_f00000002jR;
				} else {
					_alternate_success_f00000002jR = true;
				}
			}
			if (_alternate_success_f00000002jR) {
			} else {
				_position = _many_position_f00000002UP;
				_obj = _many_obj_f00000002UP;
				break;
			}
		}
		if (_position.Match("{{{")) {
		} else {
			_position.Update("“{{{”", "attribute requiring override");
			_sequence_fail_f000000028f = true;
			goto _sequence_end_f000000028f;
		}
		while(true) {
			ParserPosition _many_position_f00000002UR = _position.Clone();
			var _many_obj_f00000002UR = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.intro, documentation.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000002UR;
			_obj = _many_obj_f00000002UR;
			break;
			}
		}
		if (_position.Match("}}}")) {
		} else {
			_position.Update("“}}}”", "attribute requiring override");
			_sequence_fail_f000000028f = true;
			goto _sequence_end_f000000028f;
		}
		_sequence_end_f000000028f:
		if (_sequence_fail_f000000028f) {
			_obj = _optional_obj_f00000001yj;
			_position = _optional_position_f00000001yj;
			goto optional_exit_f00000001yj;
		} else {
			goto optional_exit_f00000001yj;
		}
		optional_exit_f00000001yj:
		while(true) {
			ParserPosition _many_position_f000000028g = _position.Clone();
			var _many_obj_f000000028g = _obj.Clone();
			bool _alternate_success_f00000002JV = false;
			ParserPosition _alt_position_f00000002JV = _position;
			var _alt_obj_f00000002JV = _obj;
			if (!_alternate_success_f00000002JV) {
				_position = _alt_position_f00000002JV.Clone();
				_obj = _alt_obj_f00000002JV.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002JV = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute requiring override");
					_position = _alt_position_f00000002JV;
					_obj = _alt_obj_f00000002JV;
				}
			}
			if (!_alternate_success_f00000002JV) {
				_position = _alt_position_f00000002JV.Clone();
				_obj = _alt_obj_f00000002JV.Clone();
				bool _sequence_fail_f00000002UY = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute requiring override");
					_sequence_fail_f00000002UY = true;
					goto _sequence_end_f00000002UY;
				}
				while(true) {
					ParserPosition _many_position_f00000002jV = _position.Clone();
					var _many_obj_f00000002jV = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute requiring override");
						_position = _many_position_f00000002jV;
						_obj = _many_obj_f00000002jV;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute requiring override");
					_sequence_fail_f00000002UY = true;
					goto _sequence_end_f00000002UY;
				}
				_sequence_end_f00000002UY:
				if (_sequence_fail_f00000002UY) {
					_position = _alt_position_f00000002JV;
					_obj = _alt_obj_f00000002JV;
				} else {
					_alternate_success_f00000002JV = true;
				}
			}
			if (_alternate_success_f00000002JV) {
			} else {
				_position = _many_position_f000000028g;
				_obj = _many_obj_f000000028g;
				break;
			}
		}
		bool _sequence_fail_f000000028h = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "attribute requiring override");
			_sequence_fail_f000000028h = true;
			goto _sequence_end_f000000028h;
		}
		while(true) {
			ParserPosition _many_position_f00000002JY = _position.Clone();
			var _many_obj_f00000002JY = _obj.Clone();
			bool _alternate_success_f00000002Uc = false;
			ParserPosition _alt_position_f00000002Uc = _position;
			var _alt_obj_f00000002Uc = _obj;
			if (!_alternate_success_f00000002Uc) {
				_position = _alt_position_f00000002Uc.Clone();
				_obj = _alt_obj_f00000002Uc.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Uc = true;
				} else {
					_position.Update("character between “a” and “z”", "attribute requiring override");
					_position = _alt_position_f00000002Uc;
					_obj = _alt_obj_f00000002Uc;
				}
			}
			if (!_alternate_success_f00000002Uc) {
				_position = _alt_position_f00000002Uc.Clone();
				_obj = _alt_obj_f00000002Uc.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Uc = true;
				} else {
					_position.Update("character between “A” and “Z”", "attribute requiring override");
					_position = _alt_position_f00000002Uc;
					_obj = _alt_obj_f00000002Uc;
				}
			}
			if (!_alternate_success_f00000002Uc) {
				_position = _alt_position_f00000002Uc.Clone();
				_obj = _alt_obj_f00000002Uc.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Uc = true;
				} else {
					_position.Update("character between “0” and “9”", "attribute requiring override");
					_position = _alt_position_f00000002Uc;
					_obj = _alt_obj_f00000002Uc;
				}
			}
			if (!_alternate_success_f00000002Uc) {
				_position = _alt_position_f00000002Uc.Clone();
				_obj = _alt_obj_f00000002Uc.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Uc = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "attribute requiring override");
					_position = _alt_position_f00000002Uc;
					_obj = _alt_obj_f00000002Uc;
				}
			}
			if (_alternate_success_f00000002Uc) {
			} else {
				_position = _many_position_f00000002JY;
				_obj = _many_obj_f00000002JY;
				break;
			}
		}
		_sequence_end_f000000028h:
		if (_sequence_fail_f000000028h) {
			_sequence_fail_f00000001rt = true;
			goto _sequence_end_f00000001rt;
		} else {
		}
		bool _sequence_fail_f00000001ym = false;
		while(true) {
			ParserPosition _many_position_f00000002JZ = _position.Clone();
			var _many_obj_f00000002JZ = _obj.Clone();
			bool _alternate_success_f00000002Uh = false;
			ParserPosition _alt_position_f00000002Uh = _position;
			var _alt_obj_f00000002Uh = _obj;
			if (!_alternate_success_f00000002Uh) {
				_position = _alt_position_f00000002Uh.Clone();
				_obj = _alt_obj_f00000002Uh.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Uh = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute requiring override");
					_position = _alt_position_f00000002Uh;
					_obj = _alt_obj_f00000002Uh;
				}
			}
			if (!_alternate_success_f00000002Uh) {
				_position = _alt_position_f00000002Uh.Clone();
				_obj = _alt_obj_f00000002Uh.Clone();
				bool _sequence_fail_f00000002jg = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute requiring override");
					_sequence_fail_f00000002jg = true;
					goto _sequence_end_f00000002jg;
				}
				while(true) {
					ParserPosition _many_position_f00000002xs = _position.Clone();
					var _many_obj_f00000002xs = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute requiring override");
						_position = _many_position_f00000002xs;
						_obj = _many_obj_f00000002xs;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute requiring override");
					_sequence_fail_f00000002jg = true;
					goto _sequence_end_f00000002jg;
				}
				_sequence_end_f00000002jg:
				if (_sequence_fail_f00000002jg) {
					_position = _alt_position_f00000002Uh;
					_obj = _alt_obj_f00000002Uh;
				} else {
					_alternate_success_f00000002Uh = true;
				}
			}
			if (_alternate_success_f00000002Uh) {
			} else {
				_position = _many_position_f00000002JZ;
				_obj = _many_obj_f00000002JZ;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "attribute requiring override");
			_sequence_fail_f00000001ym = true;
			goto _sequence_end_f00000001ym;
		}
		while(true) {
			ParserPosition _many_position_f00000002Jb = _position.Clone();
			var _many_obj_f00000002Jb = _obj.Clone();
			bool _alternate_success_f00000002Ui = false;
			ParserPosition _alt_position_f00000002Ui = _position;
			var _alt_obj_f00000002Ui = _obj;
			if (!_alternate_success_f00000002Ui) {
				_position = _alt_position_f00000002Ui.Clone();
				_obj = _alt_obj_f00000002Ui.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Ui = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute requiring override");
					_position = _alt_position_f00000002Ui;
					_obj = _alt_obj_f00000002Ui;
				}
			}
			if (!_alternate_success_f00000002Ui) {
				_position = _alt_position_f00000002Ui.Clone();
				_obj = _alt_obj_f00000002Ui.Clone();
				bool _sequence_fail_f00000002jk = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute requiring override");
					_sequence_fail_f00000002jk = true;
					goto _sequence_end_f00000002jk;
				}
				while(true) {
					ParserPosition _many_position_f00000002xy = _position.Clone();
					var _many_obj_f00000002xy = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute requiring override");
						_position = _many_position_f00000002xy;
						_obj = _many_obj_f00000002xy;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute requiring override");
					_sequence_fail_f00000002jk = true;
					goto _sequence_end_f00000002jk;
				}
				_sequence_end_f00000002jk:
				if (_sequence_fail_f00000002jk) {
					_position = _alt_position_f00000002Ui;
					_obj = _alt_obj_f00000002Ui;
				} else {
					_alternate_success_f00000002Ui = true;
				}
			}
			if (_alternate_success_f00000002Ui) {
			} else {
				_position = _many_position_f00000002Jb;
				_obj = _many_obj_f00000002Jb;
				break;
			}
		}
		if (_position.Match("Required")) {
		} else {
			_position.Update("“Required”", "attribute requiring override");
			_sequence_fail_f00000001ym = true;
			goto _sequence_end_f00000001ym;
		}
		_sequence_end_f00000001ym:
		if (_sequence_fail_f00000001ym) {
			_sequence_fail_f00000001rt = true;
			goto _sequence_end_f00000001rt;
		} else {
		}
		_sequence_end_f00000001rt:
		if (_sequence_fail_f00000001rt) {
			_position.Cache<attribute_missing_attribute>(_start_index, null);
			_position.TraceExit("attribute:missing_attribute", false);
			_result = null;
			return false;
		} else {
			_position.Cache<attribute_missing_attribute>(_start_index, _obj);
			_position.TraceExit("attribute:missing_attribute", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (attribute)_obj;
			return true;
		}
	}
	internal static bool ParseRule_named_override(ref ParserPosition _position, out attribute _result) {
		if(_position.CheckCache<attribute_named_override, attribute>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new attribute_named_override();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("attribute:named_override");

		bool _sequence_fail_f00000001s0 = false;
		var _optional_obj_f00000001yw = _obj.Clone();
		ParserPosition _optional_position_f00000001yw = _position.Clone();
		bool _sequence_fail_f0000000290 = false;
		while(true) {
			ParserPosition _many_position_f00000002Uq = _position.Clone();
			var _many_obj_f00000002Uq = _obj.Clone();
			bool _alternate_success_f00000002jw = false;
			ParserPosition _alt_position_f00000002jw = _position;
			var _alt_obj_f00000002jw = _obj;
			if (!_alternate_success_f00000002jw) {
				_position = _alt_position_f00000002jw.Clone();
				_obj = _alt_obj_f00000002jw.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002jw = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute with named override");
					_position = _alt_position_f00000002jw;
					_obj = _alt_obj_f00000002jw;
				}
			}
			if (!_alternate_success_f00000002jw) {
				_position = _alt_position_f00000002jw.Clone();
				_obj = _alt_obj_f00000002jw.Clone();
				bool _sequence_fail_f00000002y7 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute with named override");
					_sequence_fail_f00000002y7 = true;
					goto _sequence_end_f00000002y7;
				}
				while(true) {
					ParserPosition _many_position_f000000039P = _position.Clone();
					var _many_obj_f000000039P = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute with named override");
						_position = _many_position_f000000039P;
						_obj = _many_obj_f000000039P;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute with named override");
					_sequence_fail_f00000002y7 = true;
					goto _sequence_end_f00000002y7;
				}
				_sequence_end_f00000002y7:
				if (_sequence_fail_f00000002y7) {
					_position = _alt_position_f00000002jw;
					_obj = _alt_obj_f00000002jw;
				} else {
					_alternate_success_f00000002jw = true;
				}
			}
			if (_alternate_success_f00000002jw) {
			} else {
				_position = _many_position_f00000002Uq;
				_obj = _many_obj_f00000002Uq;
				break;
			}
		}
		if (_position.Match("{{{")) {
		} else {
			_position.Update("“{{{”", "attribute with named override");
			_sequence_fail_f0000000290 = true;
			goto _sequence_end_f0000000290;
		}
		while(true) {
			ParserPosition _many_position_f00000002Us = _position.Clone();
			var _many_obj_f00000002Us = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.intro, documentation.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000002Us;
			_obj = _many_obj_f00000002Us;
			break;
			}
		}
		if (_position.Match("}}}")) {
		} else {
			_position.Update("“}}}”", "attribute with named override");
			_sequence_fail_f0000000290 = true;
			goto _sequence_end_f0000000290;
		}
		_sequence_end_f0000000290:
		if (_sequence_fail_f0000000290) {
			_obj = _optional_obj_f00000001yw;
			_position = _optional_position_f00000001yw;
			goto optional_exit_f00000001yw;
		} else {
			goto optional_exit_f00000001yw;
		}
		optional_exit_f00000001yw:
		while(true) {
			ParserPosition _many_position_f0000000291 = _position.Clone();
			var _many_obj_f0000000291 = _obj.Clone();
			bool _alternate_success_f00000002Jt = false;
			ParserPosition _alt_position_f00000002Jt = _position;
			var _alt_obj_f00000002Jt = _obj;
			if (!_alternate_success_f00000002Jt) {
				_position = _alt_position_f00000002Jt.Clone();
				_obj = _alt_obj_f00000002Jt.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Jt = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute with named override");
					_position = _alt_position_f00000002Jt;
					_obj = _alt_obj_f00000002Jt;
				}
			}
			if (!_alternate_success_f00000002Jt) {
				_position = _alt_position_f00000002Jt.Clone();
				_obj = _alt_obj_f00000002Jt.Clone();
				bool _sequence_fail_f00000002Uz = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute with named override");
					_sequence_fail_f00000002Uz = true;
					goto _sequence_end_f00000002Uz;
				}
				while(true) {
					ParserPosition _many_position_f00000002k0 = _position.Clone();
					var _many_obj_f00000002k0 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute with named override");
						_position = _many_position_f00000002k0;
						_obj = _many_obj_f00000002k0;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute with named override");
					_sequence_fail_f00000002Uz = true;
					goto _sequence_end_f00000002Uz;
				}
				_sequence_end_f00000002Uz:
				if (_sequence_fail_f00000002Uz) {
					_position = _alt_position_f00000002Jt;
					_obj = _alt_obj_f00000002Jt;
				} else {
					_alternate_success_f00000002Jt = true;
				}
			}
			if (_alternate_success_f00000002Jt) {
			} else {
				_position = _many_position_f0000000291;
				_obj = _many_obj_f0000000291;
				break;
			}
		}
		bool _sequence_fail_f0000000292 = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "attribute with named override");
			_sequence_fail_f0000000292 = true;
			goto _sequence_end_f0000000292;
		}
		while(true) {
			ParserPosition _many_position_f00000002Jw = _position.Clone();
			var _many_obj_f00000002Jw = _obj.Clone();
			bool _alternate_success_f00000002V3 = false;
			ParserPosition _alt_position_f00000002V3 = _position;
			var _alt_obj_f00000002V3 = _obj;
			if (!_alternate_success_f00000002V3) {
				_position = _alt_position_f00000002V3.Clone();
				_obj = _alt_obj_f00000002V3.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002V3 = true;
				} else {
					_position.Update("character between “a” and “z”", "attribute with named override");
					_position = _alt_position_f00000002V3;
					_obj = _alt_obj_f00000002V3;
				}
			}
			if (!_alternate_success_f00000002V3) {
				_position = _alt_position_f00000002V3.Clone();
				_obj = _alt_obj_f00000002V3.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002V3 = true;
				} else {
					_position.Update("character between “A” and “Z”", "attribute with named override");
					_position = _alt_position_f00000002V3;
					_obj = _alt_obj_f00000002V3;
				}
			}
			if (!_alternate_success_f00000002V3) {
				_position = _alt_position_f00000002V3.Clone();
				_obj = _alt_obj_f00000002V3.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002V3 = true;
				} else {
					_position.Update("character between “0” and “9”", "attribute with named override");
					_position = _alt_position_f00000002V3;
					_obj = _alt_obj_f00000002V3;
				}
			}
			if (!_alternate_success_f00000002V3) {
				_position = _alt_position_f00000002V3.Clone();
				_obj = _alt_obj_f00000002V3.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002V3 = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "attribute with named override");
					_position = _alt_position_f00000002V3;
					_obj = _alt_obj_f00000002V3;
				}
			}
			if (_alternate_success_f00000002V3) {
			} else {
				_position = _many_position_f00000002Jw;
				_obj = _many_obj_f00000002Jw;
				break;
			}
		}
		_sequence_end_f0000000292:
		if (_sequence_fail_f0000000292) {
			_sequence_fail_f00000001s0 = true;
			goto _sequence_end_f00000001s0;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f0000000293 = _position.Clone();
			var _many_obj_f0000000293 = _obj.Clone();
			bool _alternate_success_f00000002Jx = false;
			ParserPosition _alt_position_f00000002Jx = _position;
			var _alt_obj_f00000002Jx = _obj;
			if (!_alternate_success_f00000002Jx) {
				_position = _alt_position_f00000002Jx.Clone();
				_obj = _alt_obj_f00000002Jx.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Jx = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute with named override");
					_position = _alt_position_f00000002Jx;
					_obj = _alt_obj_f00000002Jx;
				}
			}
			if (!_alternate_success_f00000002Jx) {
				_position = _alt_position_f00000002Jx.Clone();
				_obj = _alt_obj_f00000002Jx.Clone();
				bool _sequence_fail_f00000002VA = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute with named override");
					_sequence_fail_f00000002VA = true;
					goto _sequence_end_f00000002VA;
				}
				while(true) {
					ParserPosition _many_position_f00000002kB = _position.Clone();
					var _many_obj_f00000002kB = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute with named override");
						_position = _many_position_f00000002kB;
						_obj = _many_obj_f00000002kB;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute with named override");
					_sequence_fail_f00000002VA = true;
					goto _sequence_end_f00000002VA;
				}
				_sequence_end_f00000002VA:
				if (_sequence_fail_f00000002VA) {
					_position = _alt_position_f00000002Jx;
					_obj = _alt_obj_f00000002Jx;
				} else {
					_alternate_success_f00000002Jx = true;
				}
			}
			if (_alternate_success_f00000002Jx) {
			} else {
				_position = _many_position_f0000000293;
				_obj = _many_obj_f0000000293;
				break;
			}
		}
		if (_position.Match("+")) {
		} else {
			_position.Update("“+”", "attribute with named override");
			_sequence_fail_f00000001s0 = true;
			goto _sequence_end_f00000001s0;
		}
		bool _sequence_fail_f0000000295 = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.temporary_name = new RevCons<char>(_position.PeekLast(), _obj.temporary_name);
		} else {
			_position.Update("character between “a” and “z”", "attribute with named override");
			_sequence_fail_f0000000295 = true;
			goto _sequence_end_f0000000295;
		}
		while(true) {
			ParserPosition _many_position_f00000002K0 = _position.Clone();
			var _many_obj_f00000002K0 = _obj.Clone();
			bool _alternate_success_f00000002VE = false;
			ParserPosition _alt_position_f00000002VE = _position;
			var _alt_obj_f00000002VE = _obj;
			if (!_alternate_success_f00000002VE) {
				_position = _alt_position_f00000002VE.Clone();
				_obj = _alt_obj_f00000002VE.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.temporary_name = new RevCons<char>(_position.PeekLast(), _obj.temporary_name);
					_alternate_success_f00000002VE = true;
				} else {
					_position.Update("character between “a” and “z”", "attribute with named override");
					_position = _alt_position_f00000002VE;
					_obj = _alt_obj_f00000002VE;
				}
			}
			if (!_alternate_success_f00000002VE) {
				_position = _alt_position_f00000002VE.Clone();
				_obj = _alt_obj_f00000002VE.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.temporary_name = new RevCons<char>(_position.PeekLast(), _obj.temporary_name);
					_alternate_success_f00000002VE = true;
				} else {
					_position.Update("character between “A” and “Z”", "attribute with named override");
					_position = _alt_position_f00000002VE;
					_obj = _alt_obj_f00000002VE;
				}
			}
			if (!_alternate_success_f00000002VE) {
				_position = _alt_position_f00000002VE.Clone();
				_obj = _alt_obj_f00000002VE.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.temporary_name = new RevCons<char>(_position.PeekLast(), _obj.temporary_name);
					_alternate_success_f00000002VE = true;
				} else {
					_position.Update("character between “0” and “9”", "attribute with named override");
					_position = _alt_position_f00000002VE;
					_obj = _alt_obj_f00000002VE;
				}
			}
			if (!_alternate_success_f00000002VE) {
				_position = _alt_position_f00000002VE.Clone();
				_obj = _alt_obj_f00000002VE.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.temporary_name = new RevCons<char>(_position.PeekLast(), _obj.temporary_name);
					_alternate_success_f00000002VE = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "attribute with named override");
					_position = _alt_position_f00000002VE;
					_obj = _alt_obj_f00000002VE;
				}
			}
			if (_alternate_success_f00000002VE) {
			} else {
				_position = _many_position_f00000002K0;
				_obj = _many_obj_f00000002K0;
				break;
			}
		}
		_sequence_end_f0000000295:
		if (_sequence_fail_f0000000295) {
			_sequence_fail_f00000001s0 = true;
			goto _sequence_end_f00000001s0;
		} else {
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "attribute with named override");
			_sequence_fail_f00000001s0 = true;
			goto _sequence_end_f00000001s0;
		}
		while(true) {
			ParserPosition _many_position_f0000000297 = _position.Clone();
			var _many_obj_f0000000297 = _obj.Clone();
			bool _alternate_success_f00000002K1 = false;
			ParserPosition _alt_position_f00000002K1 = _position;
			var _alt_obj_f00000002K1 = _obj;
			if (!_alternate_success_f00000002K1) {
				_position = _alt_position_f00000002K1.Clone();
				_obj = _alt_obj_f00000002K1.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002K1 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute with named override");
					_position = _alt_position_f00000002K1;
					_obj = _alt_obj_f00000002K1;
				}
			}
			if (!_alternate_success_f00000002K1) {
				_position = _alt_position_f00000002K1.Clone();
				_obj = _alt_obj_f00000002K1.Clone();
				bool _sequence_fail_f00000002VL = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute with named override");
					_sequence_fail_f00000002VL = true;
					goto _sequence_end_f00000002VL;
				}
				while(true) {
					ParserPosition _many_position_f00000002kM = _position.Clone();
					var _many_obj_f00000002kM = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute with named override");
						_position = _many_position_f00000002kM;
						_obj = _many_obj_f00000002kM;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute with named override");
					_sequence_fail_f00000002VL = true;
					goto _sequence_end_f00000002VL;
				}
				_sequence_end_f00000002VL:
				if (_sequence_fail_f00000002VL) {
					_position = _alt_position_f00000002K1;
					_obj = _alt_obj_f00000002K1;
				} else {
					_alternate_success_f00000002K1 = true;
				}
			}
			if (_alternate_success_f00000002K1) {
			} else {
				_position = _many_position_f0000000297;
				_obj = _many_obj_f0000000297;
				break;
			}
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000001s0 = true;
		goto _sequence_end_f00000001s0;
		}
		_sequence_end_f00000001s0:
		if (_sequence_fail_f00000001s0) {
			_position.Cache<attribute_named_override>(_start_index, null);
			_position.TraceExit("attribute:named_override", false);
			_result = null;
			return false;
		} else {
			_position.Cache<attribute_named_override>(_start_index, _obj);
			_position.TraceExit("attribute:named_override", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (attribute)_obj;
			return true;
		}
	}
	internal static bool ParseRule_plain_attribute(ref ParserPosition _position, out attribute _result) {
		if(_position.CheckCache<attribute_plain_attribute, attribute>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new attribute_plain_attribute();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("attribute:plain_attribute");

		bool _sequence_fail_f00000001s7 = false;
		var _optional_obj_f000000029M = _obj.Clone();
		ParserPosition _optional_position_f000000029M = _position.Clone();
		bool _sequence_fail_f00000002K3 = false;
		while(true) {
			ParserPosition _many_position_f00000002kV = _position.Clone();
			var _many_obj_f00000002kV = _obj.Clone();
			bool _alternate_success_f00000002yr = false;
			ParserPosition _alt_position_f00000002yr = _position;
			var _alt_obj_f00000002yr = _obj;
			if (!_alternate_success_f00000002yr) {
				_position = _alt_position_f00000002yr.Clone();
				_obj = _alt_obj_f00000002yr.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002yr = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute");
					_position = _alt_position_f00000002yr;
					_obj = _alt_obj_f00000002yr;
				}
			}
			if (!_alternate_success_f00000002yr) {
				_position = _alt_position_f00000002yr.Clone();
				_obj = _alt_obj_f00000002yr.Clone();
				bool _sequence_fail_f000000039c = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute");
					_sequence_fail_f000000039c = true;
					goto _sequence_end_f000000039c;
				}
				while(true) {
					ParserPosition _many_position_f00000003JE = _position.Clone();
					var _many_obj_f00000003JE = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute");
						_position = _many_position_f00000003JE;
						_obj = _many_obj_f00000003JE;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute");
					_sequence_fail_f000000039c = true;
					goto _sequence_end_f000000039c;
				}
				_sequence_end_f000000039c:
				if (_sequence_fail_f000000039c) {
					_position = _alt_position_f00000002yr;
					_obj = _alt_obj_f00000002yr;
				} else {
					_alternate_success_f00000002yr = true;
				}
			}
			if (_alternate_success_f00000002yr) {
			} else {
				_position = _many_position_f00000002kV;
				_obj = _many_obj_f00000002kV;
				break;
			}
		}
		if (_position.Match("{{{")) {
		} else {
			_position.Update("“{{{”", "attribute");
			_sequence_fail_f00000002K3 = true;
			goto _sequence_end_f00000002K3;
		}
		while(true) {
			ParserPosition _many_position_f00000002kX = _position.Clone();
			var _many_obj_f00000002kX = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.intro, documentation.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000002kX;
			_obj = _many_obj_f00000002kX;
			break;
			}
		}
		if (_position.Match("}}}")) {
		} else {
			_position.Update("“}}}”", "attribute");
			_sequence_fail_f00000002K3 = true;
			goto _sequence_end_f00000002K3;
		}
		_sequence_end_f00000002K3:
		if (_sequence_fail_f00000002K3) {
			_obj = _optional_obj_f000000029M;
			_position = _optional_position_f000000029M;
			goto optional_exit_f000000029M;
		} else {
			goto optional_exit_f000000029M;
		}
		optional_exit_f000000029M:
		while(true) {
			ParserPosition _many_position_f00000002K4 = _position.Clone();
			var _many_obj_f00000002K4 = _obj.Clone();
			bool _alternate_success_f00000002Vd = false;
			ParserPosition _alt_position_f00000002Vd = _position;
			var _alt_obj_f00000002Vd = _obj;
			if (!_alternate_success_f00000002Vd) {
				_position = _alt_position_f00000002Vd.Clone();
				_obj = _alt_obj_f00000002Vd.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Vd = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute");
					_position = _alt_position_f00000002Vd;
					_obj = _alt_obj_f00000002Vd;
				}
			}
			if (!_alternate_success_f00000002Vd) {
				_position = _alt_position_f00000002Vd.Clone();
				_obj = _alt_obj_f00000002Vd.Clone();
				bool _sequence_fail_f00000002ke = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute");
					_sequence_fail_f00000002ke = true;
					goto _sequence_end_f00000002ke;
				}
				while(true) {
					ParserPosition _many_position_f00000002yv = _position.Clone();
					var _many_obj_f00000002yv = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute");
						_position = _many_position_f00000002yv;
						_obj = _many_obj_f00000002yv;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute");
					_sequence_fail_f00000002ke = true;
					goto _sequence_end_f00000002ke;
				}
				_sequence_end_f00000002ke:
				if (_sequence_fail_f00000002ke) {
					_position = _alt_position_f00000002Vd;
					_obj = _alt_obj_f00000002Vd;
				} else {
					_alternate_success_f00000002Vd = true;
				}
			}
			if (_alternate_success_f00000002Vd) {
			} else {
				_position = _many_position_f00000002K4;
				_obj = _many_obj_f00000002K4;
				break;
			}
		}
		bool _sequence_fail_f00000002K5 = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "attribute");
			_sequence_fail_f00000002K5 = true;
			goto _sequence_end_f00000002K5;
		}
		while(true) {
			ParserPosition _many_position_f00000002Vg = _position.Clone();
			var _many_obj_f00000002Vg = _obj.Clone();
			bool _alternate_success_f00000002ki = false;
			ParserPosition _alt_position_f00000002ki = _position;
			var _alt_obj_f00000002ki = _obj;
			if (!_alternate_success_f00000002ki) {
				_position = _alt_position_f00000002ki.Clone();
				_obj = _alt_obj_f00000002ki.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002ki = true;
				} else {
					_position.Update("character between “a” and “z”", "attribute");
					_position = _alt_position_f00000002ki;
					_obj = _alt_obj_f00000002ki;
				}
			}
			if (!_alternate_success_f00000002ki) {
				_position = _alt_position_f00000002ki.Clone();
				_obj = _alt_obj_f00000002ki.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002ki = true;
				} else {
					_position.Update("character between “A” and “Z”", "attribute");
					_position = _alt_position_f00000002ki;
					_obj = _alt_obj_f00000002ki;
				}
			}
			if (!_alternate_success_f00000002ki) {
				_position = _alt_position_f00000002ki.Clone();
				_obj = _alt_obj_f00000002ki.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002ki = true;
				} else {
					_position.Update("character between “0” and “9”", "attribute");
					_position = _alt_position_f00000002ki;
					_obj = _alt_obj_f00000002ki;
				}
			}
			if (!_alternate_success_f00000002ki) {
				_position = _alt_position_f00000002ki.Clone();
				_obj = _alt_obj_f00000002ki.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002ki = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "attribute");
					_position = _alt_position_f00000002ki;
					_obj = _alt_obj_f00000002ki;
				}
			}
			if (_alternate_success_f00000002ki) {
			} else {
				_position = _many_position_f00000002Vg;
				_obj = _many_obj_f00000002Vg;
				break;
			}
		}
		_sequence_end_f00000002K5:
		if (_sequence_fail_f00000002K5) {
			_sequence_fail_f00000001s7 = true;
			goto _sequence_end_f00000001s7;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f00000002K6 = _position.Clone();
			var _many_obj_f00000002K6 = _obj.Clone();
			bool _alternate_success_f00000002Vh = false;
			ParserPosition _alt_position_f00000002Vh = _position;
			var _alt_obj_f00000002Vh = _obj;
			if (!_alternate_success_f00000002Vh) {
				_position = _alt_position_f00000002Vh.Clone();
				_obj = _alt_obj_f00000002Vh.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Vh = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute");
					_position = _alt_position_f00000002Vh;
					_obj = _alt_obj_f00000002Vh;
				}
			}
			if (!_alternate_success_f00000002Vh) {
				_position = _alt_position_f00000002Vh.Clone();
				_obj = _alt_obj_f00000002Vh.Clone();
				bool _sequence_fail_f00000002kp = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute");
					_sequence_fail_f00000002kp = true;
					goto _sequence_end_f00000002kp;
				}
				while(true) {
					ParserPosition _many_position_f00000002z6 = _position.Clone();
					var _many_obj_f00000002z6 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute");
						_position = _many_position_f00000002z6;
						_obj = _many_obj_f00000002z6;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute");
					_sequence_fail_f00000002kp = true;
					goto _sequence_end_f00000002kp;
				}
				_sequence_end_f00000002kp:
				if (_sequence_fail_f00000002kp) {
					_position = _alt_position_f00000002Vh;
					_obj = _alt_obj_f00000002Vh;
				} else {
					_alternate_success_f00000002Vh = true;
				}
			}
			if (_alternate_success_f00000002Vh) {
			} else {
				_position = _many_position_f00000002K6;
				_obj = _many_obj_f00000002K6;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "attribute");
			_sequence_fail_f00000001s7 = true;
			goto _sequence_end_f00000001s7;
		}
		while(true) {
			ParserPosition _many_position_f00000002K8 = _position.Clone();
			var _many_obj_f00000002K8 = _obj.Clone();
			bool _alternate_success_f00000002Vi = false;
			ParserPosition _alt_position_f00000002Vi = _position;
			var _alt_obj_f00000002Vi = _obj;
			if (!_alternate_success_f00000002Vi) {
				_position = _alt_position_f00000002Vi.Clone();
				_obj = _alt_obj_f00000002Vi.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Vi = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute");
					_position = _alt_position_f00000002Vi;
					_obj = _alt_obj_f00000002Vi;
				}
			}
			if (!_alternate_success_f00000002Vi) {
				_position = _alt_position_f00000002Vi.Clone();
				_obj = _alt_obj_f00000002Vi.Clone();
				bool _sequence_fail_f00000002kt = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute");
					_sequence_fail_f00000002kt = true;
					goto _sequence_end_f00000002kt;
				}
				while(true) {
					ParserPosition _many_position_f00000002zC = _position.Clone();
					var _many_obj_f00000002zC = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute");
						_position = _many_position_f00000002zC;
						_obj = _many_obj_f00000002zC;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute");
					_sequence_fail_f00000002kt = true;
					goto _sequence_end_f00000002kt;
				}
				_sequence_end_f00000002kt:
				if (_sequence_fail_f00000002kt) {
					_position = _alt_position_f00000002Vi;
					_obj = _alt_obj_f00000002Vi;
				} else {
					_alternate_success_f00000002Vi = true;
				}
			}
			if (_alternate_success_f00000002Vi) {
			} else {
				_position = _many_position_f00000002K8;
				_obj = _many_obj_f00000002K8;
				break;
			}
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000001s7 = true;
		goto _sequence_end_f00000001s7;
		}
		_sequence_end_f00000001s7:
		if (_sequence_fail_f00000001s7) {
			_position.Cache<attribute_plain_attribute>(_start_index, null);
			_position.TraceExit("attribute:plain_attribute", false);
			_result = null;
			return false;
		} else {
			_position.Cache<attribute_plain_attribute>(_start_index, _obj);
			_position.TraceExit("attribute:plain_attribute", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (attribute)_obj;
			return true;
		}
	}
	internal static bool ParseRule_remove_attribute(ref ParserPosition _position, out attribute _result) {
		if(_position.CheckCache<attribute_remove_attribute, attribute>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new attribute_remove_attribute();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("attribute:remove_attribute");

		bool _sequence_fail_f00000001sB = false;
		var _optional_obj_f00000001zL = _obj.Clone();
		ParserPosition _optional_position_f00000001zL = _position.Clone();
		bool _sequence_fail_f000000029U = false;
		while(true) {
			ParserPosition _many_position_f00000002Vk = _position.Clone();
			var _many_obj_f00000002Vk = _obj.Clone();
			bool _alternate_success_f00000002kz = false;
			ParserPosition _alt_position_f00000002kz = _position;
			var _alt_obj_f00000002kz = _obj;
			if (!_alternate_success_f00000002kz) {
				_position = _alt_position_f00000002kz.Clone();
				_obj = _alt_obj_f00000002kz.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002kz = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "removal attribute");
					_position = _alt_position_f00000002kz;
					_obj = _alt_obj_f00000002kz;
				}
			}
			if (!_alternate_success_f00000002kz) {
				_position = _alt_position_f00000002kz.Clone();
				_obj = _alt_obj_f00000002kz.Clone();
				bool _sequence_fail_f00000002zJ = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "removal attribute");
					_sequence_fail_f00000002zJ = true;
					goto _sequence_end_f00000002zJ;
				}
				while(true) {
					ParserPosition _many_position_f00000003AE = _position.Clone();
					var _many_obj_f00000003AE = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "removal attribute");
						_position = _many_position_f00000003AE;
						_obj = _many_obj_f00000003AE;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "removal attribute");
					_sequence_fail_f00000002zJ = true;
					goto _sequence_end_f00000002zJ;
				}
				_sequence_end_f00000002zJ:
				if (_sequence_fail_f00000002zJ) {
					_position = _alt_position_f00000002kz;
					_obj = _alt_obj_f00000002kz;
				} else {
					_alternate_success_f00000002kz = true;
				}
			}
			if (_alternate_success_f00000002kz) {
			} else {
				_position = _many_position_f00000002Vk;
				_obj = _many_obj_f00000002Vk;
				break;
			}
		}
		if (_position.Match("{{{")) {
		} else {
			_position.Update("“{{{”", "removal attribute");
			_sequence_fail_f000000029U = true;
			goto _sequence_end_f000000029U;
		}
		while(true) {
			ParserPosition _many_position_f00000002Vm = _position.Clone();
			var _many_obj_f00000002Vm = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.intro, documentation.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000002Vm;
			_obj = _many_obj_f00000002Vm;
			break;
			}
		}
		if (_position.Match("}}}")) {
		} else {
			_position.Update("“}}}”", "removal attribute");
			_sequence_fail_f000000029U = true;
			goto _sequence_end_f000000029U;
		}
		_sequence_end_f000000029U:
		if (_sequence_fail_f000000029U) {
			_obj = _optional_obj_f00000001zL;
			_position = _optional_position_f00000001zL;
			goto optional_exit_f00000001zL;
		} else {
			goto optional_exit_f00000001zL;
		}
		optional_exit_f00000001zL:
		while(true) {
			ParserPosition _many_position_f000000029V = _position.Clone();
			var _many_obj_f000000029V = _obj.Clone();
			bool _alternate_success_f00000002KK = false;
			ParserPosition _alt_position_f00000002KK = _position;
			var _alt_obj_f00000002KK = _obj;
			if (!_alternate_success_f00000002KK) {
				_position = _alt_position_f00000002KK.Clone();
				_obj = _alt_obj_f00000002KK.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002KK = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "removal attribute");
					_position = _alt_position_f00000002KK;
					_obj = _alt_obj_f00000002KK;
				}
			}
			if (!_alternate_success_f00000002KK) {
				_position = _alt_position_f00000002KK.Clone();
				_obj = _alt_obj_f00000002KK.Clone();
				bool _sequence_fail_f00000002Vt = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "removal attribute");
					_sequence_fail_f00000002Vt = true;
					goto _sequence_end_f00000002Vt;
				}
				while(true) {
					ParserPosition _many_position_f00000002l3 = _position.Clone();
					var _many_obj_f00000002l3 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "removal attribute");
						_position = _many_position_f00000002l3;
						_obj = _many_obj_f00000002l3;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "removal attribute");
					_sequence_fail_f00000002Vt = true;
					goto _sequence_end_f00000002Vt;
				}
				_sequence_end_f00000002Vt:
				if (_sequence_fail_f00000002Vt) {
					_position = _alt_position_f00000002KK;
					_obj = _alt_obj_f00000002KK;
				} else {
					_alternate_success_f00000002KK = true;
				}
			}
			if (_alternate_success_f00000002KK) {
			} else {
				_position = _many_position_f000000029V;
				_obj = _many_obj_f000000029V;
				break;
			}
		}
		bool _sequence_fail_f000000029W = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "removal attribute");
			_sequence_fail_f000000029W = true;
			goto _sequence_end_f000000029W;
		}
		while(true) {
			ParserPosition _many_position_f00000002KN = _position.Clone();
			var _many_obj_f00000002KN = _obj.Clone();
			bool _alternate_success_f00000002Vx = false;
			ParserPosition _alt_position_f00000002Vx = _position;
			var _alt_obj_f00000002Vx = _obj;
			if (!_alternate_success_f00000002Vx) {
				_position = _alt_position_f00000002Vx.Clone();
				_obj = _alt_obj_f00000002Vx.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Vx = true;
				} else {
					_position.Update("character between “a” and “z”", "removal attribute");
					_position = _alt_position_f00000002Vx;
					_obj = _alt_obj_f00000002Vx;
				}
			}
			if (!_alternate_success_f00000002Vx) {
				_position = _alt_position_f00000002Vx.Clone();
				_obj = _alt_obj_f00000002Vx.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Vx = true;
				} else {
					_position.Update("character between “A” and “Z”", "removal attribute");
					_position = _alt_position_f00000002Vx;
					_obj = _alt_obj_f00000002Vx;
				}
			}
			if (!_alternate_success_f00000002Vx) {
				_position = _alt_position_f00000002Vx.Clone();
				_obj = _alt_obj_f00000002Vx.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Vx = true;
				} else {
					_position.Update("character between “0” and “9”", "removal attribute");
					_position = _alt_position_f00000002Vx;
					_obj = _alt_obj_f00000002Vx;
				}
			}
			if (!_alternate_success_f00000002Vx) {
				_position = _alt_position_f00000002Vx.Clone();
				_obj = _alt_obj_f00000002Vx.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002Vx = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "removal attribute");
					_position = _alt_position_f00000002Vx;
					_obj = _alt_obj_f00000002Vx;
				}
			}
			if (_alternate_success_f00000002Vx) {
			} else {
				_position = _many_position_f00000002KN;
				_obj = _many_obj_f00000002KN;
				break;
			}
		}
		_sequence_end_f000000029W:
		if (_sequence_fail_f000000029W) {
			_sequence_fail_f00000001sB = true;
			goto _sequence_end_f00000001sB;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f000000029X = _position.Clone();
			var _many_obj_f000000029X = _obj.Clone();
			bool _alternate_success_f00000002KO = false;
			ParserPosition _alt_position_f00000002KO = _position;
			var _alt_obj_f00000002KO = _obj;
			if (!_alternate_success_f00000002KO) {
				_position = _alt_position_f00000002KO.Clone();
				_obj = _alt_obj_f00000002KO.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002KO = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "removal attribute");
					_position = _alt_position_f00000002KO;
					_obj = _alt_obj_f00000002KO;
				}
			}
			if (!_alternate_success_f00000002KO) {
				_position = _alt_position_f00000002KO.Clone();
				_obj = _alt_obj_f00000002KO.Clone();
				bool _sequence_fail_f00000002W4 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "removal attribute");
					_sequence_fail_f00000002W4 = true;
					goto _sequence_end_f00000002W4;
				}
				while(true) {
					ParserPosition _many_position_f00000002lE = _position.Clone();
					var _many_obj_f00000002lE = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "removal attribute");
						_position = _many_position_f00000002lE;
						_obj = _many_obj_f00000002lE;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "removal attribute");
					_sequence_fail_f00000002W4 = true;
					goto _sequence_end_f00000002W4;
				}
				_sequence_end_f00000002W4:
				if (_sequence_fail_f00000002W4) {
					_position = _alt_position_f00000002KO;
					_obj = _alt_obj_f00000002KO;
				} else {
					_alternate_success_f00000002KO = true;
				}
			}
			if (_alternate_success_f00000002KO) {
			} else {
				_position = _many_position_f000000029X;
				_obj = _many_obj_f000000029X;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "removal attribute");
			_sequence_fail_f00000001sB = true;
			goto _sequence_end_f00000001sB;
		}
		while(true) {
			ParserPosition _many_position_f000000029Z = _position.Clone();
			var _many_obj_f000000029Z = _obj.Clone();
			bool _alternate_success_f00000002KP = false;
			ParserPosition _alt_position_f00000002KP = _position;
			var _alt_obj_f00000002KP = _obj;
			if (!_alternate_success_f00000002KP) {
				_position = _alt_position_f00000002KP.Clone();
				_obj = _alt_obj_f00000002KP.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002KP = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "removal attribute");
					_position = _alt_position_f00000002KP;
					_obj = _alt_obj_f00000002KP;
				}
			}
			if (!_alternate_success_f00000002KP) {
				_position = _alt_position_f00000002KP.Clone();
				_obj = _alt_obj_f00000002KP.Clone();
				bool _sequence_fail_f00000002W8 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "removal attribute");
					_sequence_fail_f00000002W8 = true;
					goto _sequence_end_f00000002W8;
				}
				while(true) {
					ParserPosition _many_position_f00000002lK = _position.Clone();
					var _many_obj_f00000002lK = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "removal attribute");
						_position = _many_position_f00000002lK;
						_obj = _many_obj_f00000002lK;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "removal attribute");
					_sequence_fail_f00000002W8 = true;
					goto _sequence_end_f00000002W8;
				}
				_sequence_end_f00000002W8:
				if (_sequence_fail_f00000002W8) {
					_position = _alt_position_f00000002KP;
					_obj = _alt_obj_f00000002KP;
				} else {
					_alternate_success_f00000002KP = true;
				}
			}
			if (_alternate_success_f00000002KP) {
			} else {
				_position = _many_position_f000000029Z;
				_obj = _many_obj_f000000029Z;
				break;
			}
		}
		if (_position.Match("Drop")) {
		} else {
			_position.Update("“Drop”", "removal attribute");
			_sequence_fail_f00000001sB = true;
			goto _sequence_end_f00000001sB;
		}
		_sequence_end_f00000001sB:
		if (_sequence_fail_f00000001sB) {
			_position.Cache<attribute_remove_attribute>(_start_index, null);
			_position.TraceExit("attribute:remove_attribute", false);
			_result = null;
			return false;
		} else {
			_position.Cache<attribute_remove_attribute>(_start_index, _obj);
			_position.TraceExit("attribute:remove_attribute", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (attribute)_obj;
			return true;
		}
	}
	internal static bool ParseRule_template_override(ref ParserPosition _position, out attribute _result) {
		if(_position.CheckCache<attribute_template_override, attribute>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new attribute_template_override();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("attribute:template_override");

		bool _sequence_fail_f00000001sI = false;
		var _optional_obj_f00000001zY = _obj.Clone();
		ParserPosition _optional_position_f00000001zY = _position.Clone();
		bool _sequence_fail_f000000029k = false;
		while(true) {
			ParserPosition _many_position_f00000002WG = _position.Clone();
			var _many_obj_f00000002WG = _obj.Clone();
			bool _alternate_success_f00000002lV = false;
			ParserPosition _alt_position_f00000002lV = _position;
			var _alt_obj_f00000002lV = _obj;
			if (!_alternate_success_f00000002lV) {
				_position = _alt_position_f00000002lV.Clone();
				_obj = _alt_obj_f00000002lV.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002lV = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute overriding a template");
					_position = _alt_position_f00000002lV;
					_obj = _alt_obj_f00000002lV;
				}
			}
			if (!_alternate_success_f00000002lV) {
				_position = _alt_position_f00000002lV.Clone();
				_obj = _alt_obj_f00000002lV.Clone();
				bool _sequence_fail_f00000002zy = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute overriding a template");
					_sequence_fail_f00000002zy = true;
					goto _sequence_end_f00000002zy;
				}
				while(true) {
					ParserPosition _many_position_f00000003AR = _position.Clone();
					var _many_obj_f00000003AR = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute overriding a template");
						_position = _many_position_f00000003AR;
						_obj = _many_obj_f00000003AR;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute overriding a template");
					_sequence_fail_f00000002zy = true;
					goto _sequence_end_f00000002zy;
				}
				_sequence_end_f00000002zy:
				if (_sequence_fail_f00000002zy) {
					_position = _alt_position_f00000002lV;
					_obj = _alt_obj_f00000002lV;
				} else {
					_alternate_success_f00000002lV = true;
				}
			}
			if (_alternate_success_f00000002lV) {
			} else {
				_position = _many_position_f00000002WG;
				_obj = _many_obj_f00000002WG;
				break;
			}
		}
		if (_position.Match("{{{")) {
		} else {
			_position.Update("“{{{”", "attribute overriding a template");
			_sequence_fail_f000000029k = true;
			goto _sequence_end_f000000029k;
		}
		while(true) {
			ParserPosition _many_position_f00000002WI = _position.Clone();
			var _many_obj_f00000002WI = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.intro, documentation.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000002WI;
			_obj = _many_obj_f00000002WI;
			break;
			}
		}
		if (_position.Match("}}}")) {
		} else {
			_position.Update("“}}}”", "attribute overriding a template");
			_sequence_fail_f000000029k = true;
			goto _sequence_end_f000000029k;
		}
		_sequence_end_f000000029k:
		if (_sequence_fail_f000000029k) {
			_obj = _optional_obj_f00000001zY;
			_position = _optional_position_f00000001zY;
			goto optional_exit_f00000001zY;
		} else {
			goto optional_exit_f00000001zY;
		}
		optional_exit_f00000001zY:
		while(true) {
			ParserPosition _many_position_f000000029l = _position.Clone();
			var _many_obj_f000000029l = _obj.Clone();
			bool _alternate_success_f00000002Kc = false;
			ParserPosition _alt_position_f00000002Kc = _position;
			var _alt_obj_f00000002Kc = _obj;
			if (!_alternate_success_f00000002Kc) {
				_position = _alt_position_f00000002Kc.Clone();
				_obj = _alt_obj_f00000002Kc.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Kc = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute overriding a template");
					_position = _alt_position_f00000002Kc;
					_obj = _alt_obj_f00000002Kc;
				}
			}
			if (!_alternate_success_f00000002Kc) {
				_position = _alt_position_f00000002Kc.Clone();
				_obj = _alt_obj_f00000002Kc.Clone();
				bool _sequence_fail_f00000002WP = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute overriding a template");
					_sequence_fail_f00000002WP = true;
					goto _sequence_end_f00000002WP;
				}
				while(true) {
					ParserPosition _many_position_f00000002lZ = _position.Clone();
					var _many_obj_f00000002lZ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute overriding a template");
						_position = _many_position_f00000002lZ;
						_obj = _many_obj_f00000002lZ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute overriding a template");
					_sequence_fail_f00000002WP = true;
					goto _sequence_end_f00000002WP;
				}
				_sequence_end_f00000002WP:
				if (_sequence_fail_f00000002WP) {
					_position = _alt_position_f00000002Kc;
					_obj = _alt_obj_f00000002Kc;
				} else {
					_alternate_success_f00000002Kc = true;
				}
			}
			if (_alternate_success_f00000002Kc) {
			} else {
				_position = _many_position_f000000029l;
				_obj = _many_obj_f000000029l;
				break;
			}
		}
		bool _sequence_fail_f000000029m = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "attribute overriding a template");
			_sequence_fail_f000000029m = true;
			goto _sequence_end_f000000029m;
		}
		while(true) {
			ParserPosition _many_position_f00000002Kf = _position.Clone();
			var _many_obj_f00000002Kf = _obj.Clone();
			bool _alternate_success_f00000002WT = false;
			ParserPosition _alt_position_f00000002WT = _position;
			var _alt_obj_f00000002WT = _obj;
			if (!_alternate_success_f00000002WT) {
				_position = _alt_position_f00000002WT.Clone();
				_obj = _alt_obj_f00000002WT.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002WT = true;
				} else {
					_position.Update("character between “a” and “z”", "attribute overriding a template");
					_position = _alt_position_f00000002WT;
					_obj = _alt_obj_f00000002WT;
				}
			}
			if (!_alternate_success_f00000002WT) {
				_position = _alt_position_f00000002WT.Clone();
				_obj = _alt_obj_f00000002WT.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002WT = true;
				} else {
					_position.Update("character between “A” and “Z”", "attribute overriding a template");
					_position = _alt_position_f00000002WT;
					_obj = _alt_obj_f00000002WT;
				}
			}
			if (!_alternate_success_f00000002WT) {
				_position = _alt_position_f00000002WT.Clone();
				_obj = _alt_obj_f00000002WT.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002WT = true;
				} else {
					_position.Update("character between “0” and “9”", "attribute overriding a template");
					_position = _alt_position_f00000002WT;
					_obj = _alt_obj_f00000002WT;
				}
			}
			if (!_alternate_success_f00000002WT) {
				_position = _alt_position_f00000002WT.Clone();
				_obj = _alt_obj_f00000002WT.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002WT = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "attribute overriding a template");
					_position = _alt_position_f00000002WT;
					_obj = _alt_obj_f00000002WT;
				}
			}
			if (_alternate_success_f00000002WT) {
			} else {
				_position = _many_position_f00000002Kf;
				_obj = _many_obj_f00000002Kf;
				break;
			}
		}
		_sequence_end_f000000029m:
		if (_sequence_fail_f000000029m) {
			_sequence_fail_f00000001sI = true;
			goto _sequence_end_f00000001sI;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f000000029n = _position.Clone();
			var _many_obj_f000000029n = _obj.Clone();
			bool _alternate_success_f00000002Kg = false;
			ParserPosition _alt_position_f00000002Kg = _position;
			var _alt_obj_f00000002Kg = _obj;
			if (!_alternate_success_f00000002Kg) {
				_position = _alt_position_f00000002Kg.Clone();
				_obj = _alt_obj_f00000002Kg.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Kg = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute overriding a template");
					_position = _alt_position_f00000002Kg;
					_obj = _alt_obj_f00000002Kg;
				}
			}
			if (!_alternate_success_f00000002Kg) {
				_position = _alt_position_f00000002Kg.Clone();
				_obj = _alt_obj_f00000002Kg.Clone();
				bool _sequence_fail_f00000002Wa = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute overriding a template");
					_sequence_fail_f00000002Wa = true;
					goto _sequence_end_f00000002Wa;
				}
				while(true) {
					ParserPosition _many_position_f00000002lk = _position.Clone();
					var _many_obj_f00000002lk = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute overriding a template");
						_position = _many_position_f00000002lk;
						_obj = _many_obj_f00000002lk;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute overriding a template");
					_sequence_fail_f00000002Wa = true;
					goto _sequence_end_f00000002Wa;
				}
				_sequence_end_f00000002Wa:
				if (_sequence_fail_f00000002Wa) {
					_position = _alt_position_f00000002Kg;
					_obj = _alt_obj_f00000002Kg;
				} else {
					_alternate_success_f00000002Kg = true;
				}
			}
			if (_alternate_success_f00000002Kg) {
			} else {
				_position = _many_position_f000000029n;
				_obj = _many_obj_f000000029n;
				break;
			}
		}
		if (_position.Match("+:")) {
		} else {
			_position.Update("“+:”", "attribute overriding a template");
			_sequence_fail_f00000001sI = true;
			goto _sequence_end_f00000001sI;
		}
		while(true) {
			ParserPosition _many_position_f000000029p = _position.Clone();
			var _many_obj_f000000029p = _obj.Clone();
			bool _alternate_success_f00000002Kh = false;
			ParserPosition _alt_position_f00000002Kh = _position;
			var _alt_obj_f00000002Kh = _obj;
			if (!_alternate_success_f00000002Kh) {
				_position = _alt_position_f00000002Kh.Clone();
				_obj = _alt_obj_f00000002Kh.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Kh = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute overriding a template");
					_position = _alt_position_f00000002Kh;
					_obj = _alt_obj_f00000002Kh;
				}
			}
			if (!_alternate_success_f00000002Kh) {
				_position = _alt_position_f00000002Kh.Clone();
				_obj = _alt_obj_f00000002Kh.Clone();
				bool _sequence_fail_f00000002We = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute overriding a template");
					_sequence_fail_f00000002We = true;
					goto _sequence_end_f00000002We;
				}
				while(true) {
					ParserPosition _many_position_f00000002lq = _position.Clone();
					var _many_obj_f00000002lq = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute overriding a template");
						_position = _many_position_f00000002lq;
						_obj = _many_obj_f00000002lq;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute overriding a template");
					_sequence_fail_f00000002We = true;
					goto _sequence_end_f00000002We;
				}
				_sequence_end_f00000002We:
				if (_sequence_fail_f00000002We) {
					_position = _alt_position_f00000002Kh;
					_obj = _alt_obj_f00000002Kh;
				} else {
					_alternate_success_f00000002Kh = true;
				}
			}
			if (_alternate_success_f00000002Kh) {
			} else {
				_position = _many_position_f000000029p;
				_obj = _many_obj_f000000029p;
				break;
			}
		}
		if (_position.Match("{")) {
		} else {
			_position.Update("“{”", "attribute overriding a template");
			_sequence_fail_f00000001sI = true;
			goto _sequence_end_f00000001sI;
		}
		while(true) {
			ParserPosition _many_position_f000000029s = _position.Clone();
			var _many_obj_f000000029s = _obj.Clone();
			bool _sequence_fail_f00000002Ki = false;
			while(true) {
				ParserPosition _many_position_f00000002Wh = _position.Clone();
				var _many_obj_f00000002Wh = _obj.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute overriding a template");
					_position = _many_position_f00000002Wh;
					_obj = _many_obj_f00000002Wh;
					break;
				}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.overrides, attribute.ParseRule_extend_tmpl_attributes)) {
			} else {
			_sequence_fail_f00000002Ki = true;
			goto _sequence_end_f00000002Ki;
			}
			_sequence_end_f00000002Ki:
			if (_sequence_fail_f00000002Ki) {
				_position = _many_position_f000000029s;
				_obj = _many_obj_f000000029s;
				break;
			} else {
			}
		}
		while(true) {
			ParserPosition _many_position_f000000029t = _position.Clone();
			var _many_obj_f000000029t = _obj.Clone();
			bool _alternate_success_f00000002Kj = false;
			ParserPosition _alt_position_f00000002Kj = _position;
			var _alt_obj_f00000002Kj = _obj;
			if (!_alternate_success_f00000002Kj) {
				_position = _alt_position_f00000002Kj.Clone();
				_obj = _alt_obj_f00000002Kj.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Kj = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute overriding a template");
					_position = _alt_position_f00000002Kj;
					_obj = _alt_obj_f00000002Kj;
				}
			}
			if (!_alternate_success_f00000002Kj) {
				_position = _alt_position_f00000002Kj.Clone();
				_obj = _alt_obj_f00000002Kj.Clone();
				bool _sequence_fail_f00000002Wm = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute overriding a template");
					_sequence_fail_f00000002Wm = true;
					goto _sequence_end_f00000002Wm;
				}
				while(true) {
					ParserPosition _many_position_f00000002m3 = _position.Clone();
					var _many_obj_f00000002m3 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute overriding a template");
						_position = _many_position_f00000002m3;
						_obj = _many_obj_f00000002m3;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute overriding a template");
					_sequence_fail_f00000002Wm = true;
					goto _sequence_end_f00000002Wm;
				}
				_sequence_end_f00000002Wm:
				if (_sequence_fail_f00000002Wm) {
					_position = _alt_position_f00000002Kj;
					_obj = _alt_obj_f00000002Kj;
				} else {
					_alternate_success_f00000002Kj = true;
				}
			}
			if (_alternate_success_f00000002Kj) {
			} else {
				_position = _many_position_f000000029t;
				_obj = _many_obj_f000000029t;
				break;
			}
		}
		if (_position.Match("}")) {
		} else {
			_position.Update("“}”", "attribute overriding a template");
			_sequence_fail_f00000001sI = true;
			goto _sequence_end_f00000001sI;
		}
		while(true) {
			ParserPosition _many_position_f000000029v = _position.Clone();
			var _many_obj_f000000029v = _obj.Clone();
			bool _alternate_success_f00000002Kk = false;
			ParserPosition _alt_position_f00000002Kk = _position;
			var _alt_obj_f00000002Kk = _obj;
			if (!_alternate_success_f00000002Kk) {
				_position = _alt_position_f00000002Kk.Clone();
				_obj = _alt_obj_f00000002Kk.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Kk = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "attribute overriding a template");
					_position = _alt_position_f00000002Kk;
					_obj = _alt_obj_f00000002Kk;
				}
			}
			if (!_alternate_success_f00000002Kk) {
				_position = _alt_position_f00000002Kk.Clone();
				_obj = _alt_obj_f00000002Kk.Clone();
				bool _sequence_fail_f00000002Wq = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "attribute overriding a template");
					_sequence_fail_f00000002Wq = true;
					goto _sequence_end_f00000002Wq;
				}
				while(true) {
					ParserPosition _many_position_f00000002m9 = _position.Clone();
					var _many_obj_f00000002m9 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "attribute overriding a template");
						_position = _many_position_f00000002m9;
						_obj = _many_obj_f00000002m9;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "attribute overriding a template");
					_sequence_fail_f00000002Wq = true;
					goto _sequence_end_f00000002Wq;
				}
				_sequence_end_f00000002Wq:
				if (_sequence_fail_f00000002Wq) {
					_position = _alt_position_f00000002Kk;
					_obj = _alt_obj_f00000002Kk;
				} else {
					_alternate_success_f00000002Kk = true;
				}
			}
			if (_alternate_success_f00000002Kk) {
			} else {
				_position = _many_position_f000000029v;
				_obj = _many_obj_f000000029v;
				break;
			}
		}
		_sequence_end_f00000001sI:
		if (_sequence_fail_f00000001sI) {
			_position.Cache<attribute_template_override>(_start_index, null);
			_position.TraceExit("attribute:template_override", false);
			_result = null;
			return false;
		} else {
			_position.Cache<attribute_template_override>(_start_index, _obj);
			_position.TraceExit("attribute:template_override", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (attribute)_obj;
			return true;
		}
	}
	internal static bool ParseRule_zz_missing_name(ref ParserPosition _position, out attribute _result) {
		if(_position.CheckCache<attribute_zz_missing_name, attribute>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new attribute_zz_missing_name();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("attribute:zz_missing_name");

		bool _sequence_fail_f00000001sN = false;
		var _optional_obj_f00000001zm = _obj.Clone();
		ParserPosition _optional_position_f00000001zm = _position.Clone();
		bool _sequence_fail_f00000002A4 = false;
		while(true) {
			ParserPosition _many_position_f00000002X0 = _position.Clone();
			var _many_obj_f00000002X0 = _obj.Clone();
			bool _alternate_success_f00000002mJ = false;
			ParserPosition _alt_position_f00000002mJ = _position;
			var _alt_obj_f00000002mJ = _obj;
			if (!_alternate_success_f00000002mJ) {
				_position = _alt_position_f00000002mJ.Clone();
				_obj = _alt_obj_f00000002mJ.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002mJ = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template required argument");
					_position = _alt_position_f00000002mJ;
					_obj = _alt_obj_f00000002mJ;
				}
			}
			if (!_alternate_success_f00000002mJ) {
				_position = _alt_position_f00000002mJ.Clone();
				_obj = _alt_obj_f00000002mJ.Clone();
				bool _sequence_fail_f000000030s = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "function-like template required argument");
					_sequence_fail_f000000030s = true;
					goto _sequence_end_f000000030s;
				}
				while(true) {
					ParserPosition _many_position_f00000003Ah = _position.Clone();
					var _many_obj_f00000003Ah = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template required argument");
						_position = _many_position_f00000003Ah;
						_obj = _many_obj_f00000003Ah;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "function-like template required argument");
					_sequence_fail_f000000030s = true;
					goto _sequence_end_f000000030s;
				}
				_sequence_end_f000000030s:
				if (_sequence_fail_f000000030s) {
					_position = _alt_position_f00000002mJ;
					_obj = _alt_obj_f00000002mJ;
				} else {
					_alternate_success_f00000002mJ = true;
				}
			}
			if (_alternate_success_f00000002mJ) {
			} else {
				_position = _many_position_f00000002X0;
				_obj = _many_obj_f00000002X0;
				break;
			}
		}
		if (_position.Match("{{{")) {
		} else {
			_position.Update("“{{{”", "function-like template required argument");
			_sequence_fail_f00000002A4 = true;
			goto _sequence_end_f00000002A4;
		}
		while(true) {
			ParserPosition _many_position_f00000002X2 = _position.Clone();
			var _many_obj_f00000002X2 = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.intro, documentation.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000002X2;
			_obj = _many_obj_f00000002X2;
			break;
			}
		}
		if (_position.Match("}}}")) {
		} else {
			_position.Update("“}}}”", "function-like template required argument");
			_sequence_fail_f00000002A4 = true;
			goto _sequence_end_f00000002A4;
		}
		_sequence_end_f00000002A4:
		if (_sequence_fail_f00000002A4) {
			_obj = _optional_obj_f00000001zm;
			_position = _optional_position_f00000001zm;
			goto optional_exit_f00000001zm;
		} else {
			goto optional_exit_f00000001zm;
		}
		optional_exit_f00000001zm:
		while(true) {
			ParserPosition _many_position_f00000002A5 = _position.Clone();
			var _many_obj_f00000002A5 = _obj.Clone();
			bool _alternate_success_f00000002Kr = false;
			ParserPosition _alt_position_f00000002Kr = _position;
			var _alt_obj_f00000002Kr = _obj;
			if (!_alternate_success_f00000002Kr) {
				_position = _alt_position_f00000002Kr.Clone();
				_obj = _alt_obj_f00000002Kr.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000002Kr = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template required argument");
					_position = _alt_position_f00000002Kr;
					_obj = _alt_obj_f00000002Kr;
				}
			}
			if (!_alternate_success_f00000002Kr) {
				_position = _alt_position_f00000002Kr.Clone();
				_obj = _alt_obj_f00000002Kr.Clone();
				bool _sequence_fail_f00000002X9 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "function-like template required argument");
					_sequence_fail_f00000002X9 = true;
					goto _sequence_end_f00000002X9;
				}
				while(true) {
					ParserPosition _many_position_f00000002mN = _position.Clone();
					var _many_obj_f00000002mN = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template required argument");
						_position = _many_position_f00000002mN;
						_obj = _many_obj_f00000002mN;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "function-like template required argument");
					_sequence_fail_f00000002X9 = true;
					goto _sequence_end_f00000002X9;
				}
				_sequence_end_f00000002X9:
				if (_sequence_fail_f00000002X9) {
					_position = _alt_position_f00000002Kr;
					_obj = _alt_obj_f00000002Kr;
				} else {
					_alternate_success_f00000002Kr = true;
				}
			}
			if (_alternate_success_f00000002Kr) {
			} else {
				_position = _many_position_f00000002A5;
				_obj = _many_obj_f00000002A5;
				break;
			}
		}
		bool _sequence_fail_f00000002A6 = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "function-like template required argument");
			_sequence_fail_f00000002A6 = true;
			goto _sequence_end_f00000002A6;
		}
		while(true) {
			ParserPosition _many_position_f00000002Ku = _position.Clone();
			var _many_obj_f00000002Ku = _obj.Clone();
			bool _alternate_success_f00000002XD = false;
			ParserPosition _alt_position_f00000002XD = _position;
			var _alt_obj_f00000002XD = _obj;
			if (!_alternate_success_f00000002XD) {
				_position = _alt_position_f00000002XD.Clone();
				_obj = _alt_obj_f00000002XD.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002XD = true;
				} else {
					_position.Update("character between “a” and “z”", "function-like template required argument");
					_position = _alt_position_f00000002XD;
					_obj = _alt_obj_f00000002XD;
				}
			}
			if (!_alternate_success_f00000002XD) {
				_position = _alt_position_f00000002XD.Clone();
				_obj = _alt_obj_f00000002XD.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002XD = true;
				} else {
					_position.Update("character between “A” and “Z”", "function-like template required argument");
					_position = _alt_position_f00000002XD;
					_obj = _alt_obj_f00000002XD;
				}
			}
			if (!_alternate_success_f00000002XD) {
				_position = _alt_position_f00000002XD.Clone();
				_obj = _alt_obj_f00000002XD.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002XD = true;
				} else {
					_position.Update("character between “0” and “9”", "function-like template required argument");
					_position = _alt_position_f00000002XD;
					_obj = _alt_obj_f00000002XD;
				}
			}
			if (!_alternate_success_f00000002XD) {
				_position = _alt_position_f00000002XD.Clone();
				_obj = _alt_obj_f00000002XD.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000002XD = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "function-like template required argument");
					_position = _alt_position_f00000002XD;
					_obj = _alt_obj_f00000002XD;
				}
			}
			if (_alternate_success_f00000002XD) {
			} else {
				_position = _many_position_f00000002Ku;
				_obj = _many_obj_f00000002Ku;
				break;
			}
		}
		_sequence_end_f00000002A6:
		if (_sequence_fail_f00000002A6) {
			_sequence_fail_f00000001sN = true;
			goto _sequence_end_f00000001sN;
		} else {
		}
		_sequence_end_f00000001sN:
		if (_sequence_fail_f00000001sN) {
			_position.Cache<attribute_zz_missing_name>(_start_index, null);
			_position.TraceExit("attribute:zz_missing_name", false);
			_result = null;
			return false;
		} else {
			_position.Cache<attribute_zz_missing_name>(_start_index, _obj);
			_position.TraceExit("attribute:zz_missing_name", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (attribute)_obj;
			return true;
		}
	}
	public abstract void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _source_template, LoadableValue _target, Generator.ParameterisedBlock<LoadableValue> _block);
}
internal class attribute_eager_attribute : attribute {
	public override string PrettyName { get { return "eagerly evaluated attribute"; } }
	internal System.Collections.Generic.List<documentation> intro = new System.Collections.Generic.List<documentation>();
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		inner_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, _environment, true);
		inner_environment.AddForbiddenName(Generator.ToString(name));
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, inner_environment, ref _success); }
		return _return;
	}
	Environment inner_environment;
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000001re =  _type;
		if (expression != null) f00000001re &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
		InferredType = f00000001re;		return f00000001re;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000001rg =  _type;
		if (expression != null) f00000001rg &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
	}
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _source_template, LoadableValue _target, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f000000027v = _generator.PushSourceReference(this, _source_reference);
		inner_environment.GenerateLookupCache(_generator, null, null, f000000027v, _context, _self_frame, (f00000002Iq_context, f00000002Iq_cache) => {
			_generator.DebugPosition(this);
			expression.Generate(_generator, f00000002Iq_cache, f000000027v, f00000002Iq_context, _self_frame, _container_frame, (f00000002Sj) => {
				_generator.DebugPosition(this);
			var f00000001y6 = new GeneratedValue(typeof(Flabbergast.ComputeValue), (f00000003IB_builder) => {
			if (!typeof(object).IsAssignableFrom(f00000002Sj.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Any but got {0} in Call.", Stringish.NameForType(f00000002Sj.BackingType)));
			_generator.LoadReboxed(f00000002Sj, typeof(object));
			f00000003IB_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Precomputation).GetMethod("Capture", new System.Type[] { typeof(object) }));
			});
			if (!typeof(Template).IsAssignableFrom(_target.BackingType) && !typeof(MutableFrame).IsAssignableFrom(_target.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(_target.BackingType)));
			_target.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(name));
			var f00000002vK_is_frame = typeof(MutableFrame).IsAssignableFrom(_target.BackingType);
			var f00000002vK_boxed_type = f00000002vK_is_frame ? typeof(object) : typeof(ComputeValue);
			_generator.LoadReboxed(f00000001y6, f00000002vK_boxed_type);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, _target.BackingType.GetMethod(f00000002vK_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000002vK_boxed_type }));
			_final_block(_target);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		var f00000001ra_api = _collect_names ? _api_gen.CreateChild(Generator.ToString(name), this, this.InferredType, false) : _api_gen;
		foreach(var f00000001ra in intro) f00000001ra.GenerateApi(f00000001ra_api, true);
		expression.GenerateApi(f00000001ra_api, _collect_names);
	}
	internal attribute_eager_attribute Clone() {
		var _obj = new attribute_eager_attribute();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		_obj.intro.AddRange(intro);
		_obj.expression = expression;
		return _obj;
	}
}
internal class attribute_informative_attribute : attribute {
	public override string PrettyName { get { return "informative attribute"; } }
	internal System.Collections.Generic.List<documentation> intro = new System.Collections.Generic.List<documentation>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000001rj = _type & (0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Frame | Flabbergast.Type.Int | Flabbergast.Type.Unit | Flabbergast.Type.Str | Flabbergast.Type.Template);
		if (f00000001rj == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Frame | Flabbergast.Type.Int | Flabbergast.Type.Unit | Flabbergast.Type.Str | Flabbergast.Type.Template, _type);
		}
		InferredType = f00000001rj;		return f00000001rj;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _source_template, LoadableValue _target, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000001yN = new GeneratedValue(typeof(Flabbergast.ComputeValue), (f00000003Bm_builder) => {
		if (!typeof(Flabbergast.Template).IsAssignableFrom(_source_template.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Ldstr.", Stringish.NameForType(_source_template.BackingType)));
		_generator.LoadReboxed(_source_template, typeof(Flabbergast.Template));
		f00000003Bm_builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(name));
		f00000003Bm_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("get_Item", new System.Type[] { typeof(string) }));
		});
		if (!typeof(Template).IsAssignableFrom(_target.BackingType) && !typeof(MutableFrame).IsAssignableFrom(_target.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(_target.BackingType)));
		_target.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(name));
		var f00000002oF_is_frame = typeof(MutableFrame).IsAssignableFrom(_target.BackingType);
		var f00000002oF_boxed_type = f00000002oF_is_frame ? typeof(object) : typeof(ComputeValue);
		_generator.LoadReboxed(f00000001yN, f00000002oF_boxed_type);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, _target.BackingType.GetMethod(f00000002oF_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000002oF_boxed_type }));
		_final_block(_target);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		var f00000001rh_api = _collect_names ? _api_gen.CreateChild(Generator.ToString(name), this, this.InferredType, true) : _api_gen;
		foreach(var f00000001rh in intro) f00000001rh.GenerateApi(f00000001rh_api, true);
	}
	internal attribute_informative_attribute Clone() {
		var _obj = new attribute_informative_attribute();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		_obj.intro.AddRange(intro);
		return _obj;
	}
}
internal class attribute_informative_attribute_new : attribute {
	public override string PrettyName { get { return "informative attribute"; } }
	internal System.Collections.Generic.List<documentation> intro = new System.Collections.Generic.List<documentation>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000001rn = _type & (0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Frame | Flabbergast.Type.Int | Flabbergast.Type.Unit | Flabbergast.Type.Str | Flabbergast.Type.Template);
		if (f00000001rn == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Frame | Flabbergast.Type.Int | Flabbergast.Type.Unit | Flabbergast.Type.Str | Flabbergast.Type.Template, _type);
		}
		InferredType = f00000001rn;		return f00000001rn;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _source_template, LoadableValue _target, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		_final_block(_target);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		var f00000001rm_api = _collect_names ? _api_gen.CreateChild(Generator.ToString(name), this, this.InferredType, true) : _api_gen;
		foreach(var f00000001rm in intro) f00000001rm.GenerateApi(f00000001rm_api, true);
	}
	internal attribute_informative_attribute_new Clone() {
		var _obj = new attribute_informative_attribute_new();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		_obj.intro.AddRange(intro);
		return _obj;
	}
}
internal class attribute_missing_attribute : attribute {
	public override string PrettyName { get { return "attribute requiring override"; } }
	internal System.Collections.Generic.List<documentation> intro = new System.Collections.Generic.List<documentation>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000001rs = _type & (0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Frame | Flabbergast.Type.Int | Flabbergast.Type.Unit | Flabbergast.Type.Str | Flabbergast.Type.Template);
		if (f00000001rs == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Frame | Flabbergast.Type.Int | Flabbergast.Type.Unit | Flabbergast.Type.Str | Flabbergast.Type.Template, _type);
		}
		InferredType = f00000001rs;		return f00000001rs;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _source_template, LoadableValue _target, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000001yg = new DelegateValue(_generator.CreateFunction(this, "f00000002UO", (f00000001yg_generator, f00000003TK_container_frame, f00000003Ch_context, f00000003Mb_self_frame, f00000002xJ_source_reference) => {
			f00000001yg_generator.DebugPosition(this);
			var f000000028c = f00000001yg_generator.PushSourceReference(this, f00000002xJ_source_reference);
			var f00000002jP = new StringishValue("Attribute “");
			var f00000002xO = new StringishValue(Generator.ToString(name));
			var f00000002xP = new StringishValue("” must be overridden.");
			var f00000002jQ = new GeneratedValue(typeof(Flabbergast.Stringish), (f00000004ys_builder) => {
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000002xO.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000002xO.BackingType)));
			f00000001yg_generator.LoadReboxed(f00000002xO, typeof(Flabbergast.Stringish));
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000002xP.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000002xP.BackingType)));
			f00000001yg_generator.LoadReboxed(f00000002xP, typeof(Flabbergast.Stringish));
			f00000004ys_builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(ConcatStringish).GetConstructors()[0]);
			});
			var f00000002UL = new GeneratedValue(typeof(Flabbergast.Stringish), (f00000004kG_builder) => {
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000002jP.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000002jP.BackingType)));
			f00000001yg_generator.LoadReboxed(f00000002jP, typeof(Flabbergast.Stringish));
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000002jQ.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000002jQ.BackingType)));
			f00000001yg_generator.LoadReboxed(f00000002jQ, typeof(Flabbergast.Stringish));
			f00000004kG_builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(ConcatStringish).GetConstructors()[0]);
			});
			f00000001yg_generator.LoadTaskMaster();
			f000000028c.Load(f00000001yg_generator);
			f00000002UL.Load(f00000001yg_generator);
			f00000001yg_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			f00000001yg_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(TaskMaster).GetMethod("ReportOtherError", new System.Type[] { typeof(SourceReference), typeof(string) }));
			f00000001yg_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			f00000001yg_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
		}), typeof(ComputeValue));
		if (!typeof(Template).IsAssignableFrom(_target.BackingType) && !typeof(MutableFrame).IsAssignableFrom(_target.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(_target.BackingType)));
		_target.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(name));
		var f000000028e_is_frame = typeof(MutableFrame).IsAssignableFrom(_target.BackingType);
		var f000000028e_boxed_type = f000000028e_is_frame ? typeof(object) : typeof(ComputeValue);
		_generator.LoadReboxed(f00000001yg, f000000028e_boxed_type);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, _target.BackingType.GetMethod(f000000028e_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f000000028e_boxed_type }));
		_final_block(_target);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		var f00000001rq_api = _collect_names ? _api_gen.CreateChild(Generator.ToString(name), this, this.InferredType, false) : _api_gen;
		foreach(var f00000001rq in intro) f00000001rq.GenerateApi(f00000001rq_api, true);
	}
	internal attribute_missing_attribute Clone() {
		var _obj = new attribute_missing_attribute();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		_obj.intro.AddRange(intro);
		return _obj;
	}
}
internal class attribute_named_override : attribute {
	public override string PrettyName { get { return "attribute with named override"; } }
	internal System.Collections.Generic.List<documentation> intro = new System.Collections.Generic.List<documentation>();
	internal RevCons<char> temporary_name = null;
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		inner_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, _environment, false);
		override_bottleneck = inner_environment.AddOverrideName(Generator.ToString(temporary_name));
		inner_environment.AddForbiddenName(Generator.ToString(name));
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, inner_environment, ref _success); }
		return _return;
	}
	Environment inner_environment;
	RestrictableType override_bottleneck;
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000001rz =  _type;
		if (expression != null) f00000001rz &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
		InferredType = f00000001rz;		return f00000001rz;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000001s1 =  _type;
		if (expression != null) f00000001s1 &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
	}
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _source_template, LoadableValue _target, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f000000028z = new DelegateValue(_generator.CreateFunctionOverride(this, "f00000004zW", (f000000028z_generator, f00000003f9_container_frame, f00000003Oc_context, f00000003p5_original_value, f00000003X5_self_frame, f00000003H0_source_reference) => {
			f000000028z_generator.DebugPosition(this);
			var f00000002Jn = f000000028z_generator.PushSourceReference(this, f00000003H0_source_reference);
			Environment.GenerateLookupCache(f000000028z_generator, null, null, f00000002Jn, f00000003Oc_context, f00000003X5_self_frame, (f00000002Uo_context, f00000002Uo_cache) => {
				f000000028z_generator.DebugPosition(this);
				inner_environment.GenerateLookupCache(f000000028z_generator, new[] { new System.Tuple<RestrictableType, Generator.ParameterisedBlock<Generator.ParameterisedBlock<LoadableValue>>>(override_bottleneck, f0000000526_block => {
					f0000000526_block(f00000003p5_original_value);})}, f00000002Uo_cache, f00000002Jn, f00000002Uo_context, f00000003X5_self_frame, (f00000002jv_context, f00000002jv_cache) => {
					f000000028z_generator.DebugPosition(this);
					expression.Generate(f000000028z_generator, f00000002jv_cache, f00000002Jn, f00000002jv_context, f00000003X5_self_frame, f00000003f9_container_frame, (f00000002y3) => {
						f000000028z_generator.DebugPosition(this);
				f000000028z_generator.Return(f00000002y3);
					});
				});
			});
		}), typeof(ComputeOverride));
		var f000000028y = new GeneratedValue(typeof(Flabbergast.ComputeValue), (f00000004qj_builder) => {
		if (!typeof(Flabbergast.Template).IsAssignableFrom(_source_template.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Ldstr.", Stringish.NameForType(_source_template.BackingType)));
		_generator.LoadReboxed(_source_template, typeof(Flabbergast.Template));
		f00000004qj_builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(name));
		f00000004qj_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("get_Item", new System.Type[] { typeof(string) }));
		});
		var f00000001yr = new GeneratedValue(typeof(Flabbergast.ComputeValue), (f00000003TY_builder) => {
		f00000003TY_builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, FileName);
		f00000003TY_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, StartRow);
		f00000003TY_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, StartColumn);
		f00000003TY_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, EndRow);
		f00000003TY_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, EndColumn);
		if (!typeof(Flabbergast.ComputeOverride).IsAssignableFrom(f000000028z.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Override but got {0} in Call.", Stringish.NameForType(f000000028z.BackingType)));
		_generator.LoadReboxed(f000000028z, typeof(Flabbergast.ComputeOverride));
		if (!typeof(Flabbergast.ComputeValue).IsAssignableFrom(f000000028y.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Function but got {0} in Call.", Stringish.NameForType(f000000028y.BackingType)));
		_generator.LoadReboxed(f000000028y, typeof(Flabbergast.ComputeValue));
		f00000003TY_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Computation).GetMethod("PerformOverride", new System.Type[] { typeof(string), typeof(int), typeof(int), typeof(int), typeof(int), typeof(ComputeOverride), typeof(ComputeValue) }));
		});
		if (!typeof(Template).IsAssignableFrom(_target.BackingType) && !typeof(MutableFrame).IsAssignableFrom(_target.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(_target.BackingType)));
		_target.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(name));
		var f00000003Iz_is_frame = typeof(MutableFrame).IsAssignableFrom(_target.BackingType);
		var f00000003Iz_boxed_type = f00000003Iz_is_frame ? typeof(object) : typeof(ComputeValue);
		_generator.LoadReboxed(f00000001yr, f00000003Iz_boxed_type);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, _target.BackingType.GetMethod(f00000003Iz_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000003Iz_boxed_type }));
		_final_block(_target);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		var f00000001rv_api = _collect_names ? _api_gen.CreateChild(Generator.ToString(name), this, this.InferredType, false) : _api_gen;
		foreach(var f00000001rv in intro) f00000001rv.GenerateApi(f00000001rv_api, true);
		expression.GenerateApi(f00000001rv_api, _collect_names);
	}
	internal attribute_named_override Clone() {
		var _obj = new attribute_named_override();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		_obj.intro.AddRange(intro);
		_obj.temporary_name = temporary_name;
		_obj.expression = expression;
		return _obj;
	}
}
internal class attribute_plain_attribute : attribute {
	public override string PrettyName { get { return "attribute"; } }
	internal System.Collections.Generic.List<documentation> intro = new System.Collections.Generic.List<documentation>();
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		inner_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, _environment, true);
		inner_environment.AddForbiddenName(Generator.ToString(name));
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, inner_environment, ref _success); }
		return _return;
	}
	Environment inner_environment;
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000001s6 =  _type;
		if (expression != null) f00000001s6 &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
		InferredType = f00000001s6;		return f00000001s6;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000001s8 =  _type;
		if (expression != null) f00000001s8 &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
	}
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _source_template, LoadableValue _target, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000001zC = new DelegateValue(_generator.CreateFunction(this, "f00000002VX", (f00000001zC_generator, f00000003Ti_container_frame, f00000003DZ_context, f00000003N4_self_frame, f00000002yp_source_reference) => {
			f00000001zC_generator.DebugPosition(this);
			var f000000029K = f00000001zC_generator.PushSourceReference(this, f00000002yp_source_reference);
			Environment.GenerateLookupCache(f00000001zC_generator, null, null, f000000029K, f00000003DZ_context, f00000003N4_self_frame, (f00000002K2_context, f00000002K2_cache) => {
				f00000001zC_generator.DebugPosition(this);
				inner_environment.GenerateLookupCache(f00000001zC_generator, null, f00000002K2_cache, f000000029K, f00000002K2_context, f00000003N4_self_frame, (f00000002VU_context, f00000002VU_cache) => {
					f00000001zC_generator.DebugPosition(this);
					expression.Generate(f00000001zC_generator, f00000002VU_cache, f000000029K, f00000002VU_context, f00000003N4_self_frame, f00000003Ti_container_frame, (f00000002kT) => {
						f00000001zC_generator.DebugPosition(this);
				f00000001zC_generator.Return(f00000002kT);
					});
				});
			});
		}), typeof(ComputeValue));
		if (!typeof(Template).IsAssignableFrom(_target.BackingType) && !typeof(MutableFrame).IsAssignableFrom(_target.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(_target.BackingType)));
		_target.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(name));
		var f000000029L_is_frame = typeof(MutableFrame).IsAssignableFrom(_target.BackingType);
		var f000000029L_boxed_type = f000000029L_is_frame ? typeof(object) : typeof(ComputeValue);
		_generator.LoadReboxed(f00000001zC, f000000029L_boxed_type);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, _target.BackingType.GetMethod(f000000029L_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f000000029L_boxed_type }));
		_final_block(_target);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		var f00000001s2_api = _collect_names ? _api_gen.CreateChild(Generator.ToString(name), this, this.InferredType, false) : _api_gen;
		foreach(var f00000001s2 in intro) f00000001s2.GenerateApi(f00000001s2_api, true);
		expression.GenerateApi(f00000001s2_api, _collect_names);
	}
	internal attribute_plain_attribute Clone() {
		var _obj = new attribute_plain_attribute();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		_obj.intro.AddRange(intro);
		_obj.expression = expression;
		return _obj;
	}
}
internal class attribute_remove_attribute : attribute {
	public override string PrettyName { get { return "removal attribute"; } }
	internal System.Collections.Generic.List<documentation> intro = new System.Collections.Generic.List<documentation>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000001sA = _type & (0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Frame | Flabbergast.Type.Int | Flabbergast.Type.Unit | Flabbergast.Type.Str | Flabbergast.Type.Template);
		if (f00000001sA == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Frame | Flabbergast.Type.Int | Flabbergast.Type.Unit | Flabbergast.Type.Str | Flabbergast.Type.Template, _type);
		}
		InferredType = f00000001sA;		return f00000001sA;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _source_template, LoadableValue _target, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		_final_block(_target);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		var f00000001s9_api = _collect_names ? _api_gen.CreateChild(Generator.ToString(name), this, this.InferredType, true) : _api_gen;
		foreach(var f00000001s9 in intro) f00000001s9.GenerateApi(f00000001s9_api, true);
	}
	internal attribute_remove_attribute Clone() {
		var _obj = new attribute_remove_attribute();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		_obj.intro.AddRange(intro);
		return _obj;
	}
}
internal class attribute_template_override : attribute {
	public override string PrettyName { get { return "attribute overriding a template"; } }
	internal System.Collections.Generic.List<documentation> intro = new System.Collections.Generic.List<documentation>();
	internal System.Collections.Generic.List<attribute> overrides = new System.Collections.Generic.List<attribute>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (overrides != null) { foreach (var f00000001sF in overrides) f00000001sF.PropagateEnvironment(_collector, _queue, new Environment(f00000001sF.FileName, f00000001sF.StartRow, f00000001sF.StartColumn, f00000001sF.EndRow, f00000001sF.EndColumn, null, false, false), ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000001sH = _type & (0 | Flabbergast.Type.Template);
		if (f00000001sH == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Template, _type);
		}
		InferredType = f00000001sH;		return f00000001sH;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _source_template, LoadableValue _target, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f000000029j = new DelegateValue(_generator.CreateFunctionOverride(this, "f00000004zX", (f000000029j_generator, f00000003fK_container_frame, f00000003PA_context, f00000003pB_original_value, f00000003XK_self_frame, f00000003Hh_source_reference) => {
			f000000029j_generator.DebugPosition(this);
			var f00000002KW = f000000029j_generator.PushSourceReference(this, f00000003Hh_source_reference);
			f000000029j_generator.DynamicTypeDispatch(f00000003pB_original_value, f00000002KW, new System.Type[] { typeof(Flabbergast.Template)}, (f00000002WE) => {
				f000000029j_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f00000002WD_code = (f00000002WD) => {
					f000000029j_generator.Return(f00000002WD);
				};
				if (f00000002WE.BackingType == typeof(Flabbergast.Template)) {
					var f00000003PD = f000000029j_generator.MakeField("template_override_iterator_inputs", typeof(IAttributeNames[]));
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003PD.Field);
					int f00000005DV_next;
					f00000005DV_next = f000000029j_generator.DefineState();
					f00000003PD.Load(f000000029j_generator);
					if (!typeof(IAttributeNames).IsAssignableFrom(f00000002WE.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f00000002WE.BackingType)));
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
					f00000002WE.Load(f000000029j_generator);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
					f000000029j_generator.JumpToState(f00000005DV_next);
					f000000029j_generator.MarkState(f00000005DV_next);
					var f00000003AO = f000000029j_generator.MakeField("template_override_iterator_accumulator", typeof(Flabbergast.Template));
					var f00000003AO_start_block = f000000029j_generator.DefineState();
					var f00000003UE = new GeneratedValue(typeof(Flabbergast.Context), (f000000059e_builder) => {
					if (!typeof(Flabbergast.Template).IsAssignableFrom(f00000002WE.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f00000002WE.BackingType)));
					f000000029j_generator.LoadReboxed(f00000002WE, typeof(Flabbergast.Template));
					f000000059e_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("get_Context"));
					});
					var f00000003PC = f000000029j_generator.MakeField("template_override_Call", typeof(Flabbergast.Context));
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
					if (!typeof(Flabbergast.Context).IsAssignableFrom(f00000003PA_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(f00000003PA_context.BackingType)));
					f000000029j_generator.LoadReboxed(f00000003PA_context, typeof(Flabbergast.Context));
					if (!typeof(Flabbergast.Context).IsAssignableFrom(f00000003UE.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(f00000003UE.BackingType)));
					f000000029j_generator.LoadReboxed(f00000003UE, typeof(Flabbergast.Context));
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Append", new System.Type[] { typeof(Context), typeof(Context) }));
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003PC.Field);
					var f00000003Jf = f000000029j_generator.MakeField("new_template", typeof(Template));
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
					f000000029j_generator.AmendSourceReference(this, "amend template", f00000002KW, f00000002WE);
					f00000003PC.Load(f000000029j_generator);
					f00000003XK_self_frame.Load(f000000029j_generator);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Template).GetConstructors()[0]);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003Jf.Field);
					f000000029j_generator.CopyField(f00000003Jf, f00000003AO);
					f000000029j_generator.JumpToState(f00000003AO_start_block);
					f000000029j_generator.MarkState(f00000003AO_start_block);
					var f00000003AO_dispatchers = new int[ 2 + overrides.Count ];
					for(var f0000000533_it = 0; f0000000533_it < f00000003AO_dispatchers.Length; f0000000533_it++) { f00000003AO_dispatchers[f0000000533_it] = f000000029j_generator.DefineState(); }
					var f00000003AO_iterator = f000000029j_generator.MakeField("template_override_iterator", typeof(MergeIterator));
					#pragma warning disable 219
					var f00000003AO_key = new MethodValue(f00000003AO_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
					var f00000003AO_ordinal = new MethodValue(f00000003AO_iterator, typeof(MergeIterator).GetMethod("get_Position"));
					#pragma warning restore 219
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
					f00000003PD.Load(f000000029j_generator);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003AO_dispatchers[1]);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003AO_dispatchers[0]);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
					#pragma warning disable 219
					var f00000003AO_position = 2;
					#pragma warning restore 219
					foreach (var f00000003PF in overrides) {
						f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
						f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(f00000003PF.name));
						f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003AO_dispatchers[f00000003AO_position++]);
						f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("AddDispatcher", new System.Type[] { typeof(string), typeof(int) }));
					}
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003AO_iterator.Field);
					var f00000003AO_next = f000000029j_generator.DefineState();
					f000000029j_generator.JumpToState(f00000003AO_next);
					f000000029j_generator.MarkState(f00000003AO_next);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
					f00000003AO_iterator.Load(f000000029j_generator);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000029j_generator.StateField);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
					f000000029j_generator.MarkState(f00000003AO_dispatchers[1]);
					var f00000003PB = new GeneratedValue(typeof(Flabbergast.ComputeValue), (f000000054X_builder) => {
					if (!typeof(Flabbergast.Template).IsAssignableFrom(f00000002WE.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f00000002WE.BackingType)));
					f000000029j_generator.LoadReboxed(f00000002WE, typeof(Flabbergast.Template));
					if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000003AO_key.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Call.", Stringish.NameForType(f00000003AO_key.BackingType)));
					f000000029j_generator.LoadReboxed(f00000003AO_key, typeof(Flabbergast.Stringish));
					f000000054X_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("Get", new System.Type[] { typeof(Stringish) }));
					});
					if (!typeof(Template).IsAssignableFrom(f00000003AO.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000003AO.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000003AO.BackingType)));
					f00000003AO.Load(f000000029j_generator);
					f00000003AO_key.Load(f000000029j_generator);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
					var f000000053p_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000003AO.BackingType);
					var f000000053p_boxed_type = f000000053p_is_frame ? typeof(object) : typeof(ComputeValue);
					f000000029j_generator.LoadReboxed(f00000003PB, f000000053p_boxed_type);
					f000000029j_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000003AO.BackingType.GetMethod(f000000053p_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f000000053p_boxed_type }));
					f000000029j_generator.CopyField(f00000003AO, f00000003AO);
					f000000029j_generator.JumpToState(f00000003AO_next);
					f00000003AO_position = 2;
					foreach (var f00000003PF in overrides) {
						f000000029j_generator.MarkState(f00000003AO_dispatchers[f00000003AO_position++]);
						f00000003PF.Generate(f000000029j_generator, f00000002KW, f00000003PA_context, f00000003XK_self_frame, f00000003fK_container_frame, f00000002WE, f00000003AO, (f00000003UG) => {
							f000000029j_generator.DebugPosition(this);
							f000000029j_generator.CopyField(f00000003UG, f00000003AO);
							f000000029j_generator.JumpToState(f00000003AO_next);
						});
					}
					f000000029j_generator.MarkState(f00000003AO_dispatchers[0]);
					f00000002WD_code(f00000003AO);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: attribute overriding a template not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			});
		}), typeof(ComputeOverride));
		var f000000029i = new GeneratedValue(typeof(Flabbergast.ComputeValue), (f00000004qk_builder) => {
		if (!typeof(Flabbergast.Template).IsAssignableFrom(_source_template.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Ldstr.", Stringish.NameForType(_source_template.BackingType)));
		_generator.LoadReboxed(_source_template, typeof(Flabbergast.Template));
		f00000004qk_builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(name));
		f00000004qk_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("get_Item", new System.Type[] { typeof(string) }));
		});
		var f00000001zU = new GeneratedValue(typeof(Flabbergast.ComputeValue), (f00000003U5_builder) => {
		f00000003U5_builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, FileName);
		f00000003U5_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, StartRow);
		f00000003U5_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, StartColumn);
		f00000003U5_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, EndRow);
		f00000003U5_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, EndColumn);
		if (!typeof(Flabbergast.ComputeOverride).IsAssignableFrom(f000000029j.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Override but got {0} in Call.", Stringish.NameForType(f000000029j.BackingType)));
		_generator.LoadReboxed(f000000029j, typeof(Flabbergast.ComputeOverride));
		if (!typeof(Flabbergast.ComputeValue).IsAssignableFrom(f000000029i.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Function but got {0} in Call.", Stringish.NameForType(f000000029i.BackingType)));
		_generator.LoadReboxed(f000000029i, typeof(Flabbergast.ComputeValue));
		f00000003U5_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Computation).GetMethod("PerformOverride", new System.Type[] { typeof(string), typeof(int), typeof(int), typeof(int), typeof(int), typeof(ComputeOverride), typeof(ComputeValue) }));
		});
		if (!typeof(Template).IsAssignableFrom(_target.BackingType) && !typeof(MutableFrame).IsAssignableFrom(_target.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(_target.BackingType)));
		_target.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(name));
		var f00000003Ja_is_frame = typeof(MutableFrame).IsAssignableFrom(_target.BackingType);
		var f00000003Ja_boxed_type = f00000003Ja_is_frame ? typeof(object) : typeof(ComputeValue);
		_generator.LoadReboxed(f00000001zU, f00000003Ja_boxed_type);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, _target.BackingType.GetMethod(f00000003Ja_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000003Ja_boxed_type }));
		_final_block(_target);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		var f00000001sD_api = _collect_names ? _api_gen.CreateChild(Generator.ToString(name), this, this.InferredType, false) : _api_gen;
		foreach(var f00000001sD in intro) f00000001sD.GenerateApi(f00000001sD_api, true);
		foreach(var f00000001zT in overrides) 			f00000001zT.GenerateApi(f00000001sD_api, _collect_names);
	}
	internal attribute_template_override Clone() {
		var _obj = new attribute_template_override();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		_obj.intro.AddRange(intro);
		_obj.overrides.AddRange(overrides);
		return _obj;
	}
}
internal class attribute_zz_missing_name : attribute {
	public override string PrettyName { get { return "function-like template required argument"; } }
	internal System.Collections.Generic.List<documentation> intro = new System.Collections.Generic.List<documentation>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000001sM = _type & (0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Frame | Flabbergast.Type.Int | Flabbergast.Type.Unit | Flabbergast.Type.Str | Flabbergast.Type.Template);
		if (f00000001sM == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Frame | Flabbergast.Type.Int | Flabbergast.Type.Unit | Flabbergast.Type.Str | Flabbergast.Type.Template, _type);
		}
		InferredType = f00000001sM;		return f00000001sM;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _source_template, LoadableValue _target, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000001zj = new DelegateValue(_generator.CreateFunction(this, "f00000002Wz", (f00000001zj_generator, f00000003UT_container_frame, f00000003Es_context, f00000003NX_self_frame, f000000030i_source_reference) => {
			f00000001zj_generator.DebugPosition(this);
			var f00000002A1 = f00000001zj_generator.PushSourceReference(this, f000000030i_source_reference);
			var f00000002mH = new StringishValue("Attribute “");
			var f000000030n = new StringishValue(Generator.ToString(name));
			var f000000030o = new StringishValue("” must be overridden.");
			var f00000002mI = new GeneratedValue(typeof(Flabbergast.Stringish), (f00000004yt_builder) => {
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f000000030n.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f000000030n.BackingType)));
			f00000001zj_generator.LoadReboxed(f000000030n, typeof(Flabbergast.Stringish));
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f000000030o.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f000000030o.BackingType)));
			f00000001zj_generator.LoadReboxed(f000000030o, typeof(Flabbergast.Stringish));
			f00000004yt_builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(ConcatStringish).GetConstructors()[0]);
			});
			var f00000002Ww = new GeneratedValue(typeof(Flabbergast.Stringish), (f00000004kJ_builder) => {
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000002mH.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000002mH.BackingType)));
			f00000001zj_generator.LoadReboxed(f00000002mH, typeof(Flabbergast.Stringish));
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000002mI.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000002mI.BackingType)));
			f00000001zj_generator.LoadReboxed(f00000002mI, typeof(Flabbergast.Stringish));
			f00000004kJ_builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(ConcatStringish).GetConstructors()[0]);
			});
			f00000001zj_generator.LoadTaskMaster();
			f00000002A1.Load(f00000001zj_generator);
			f00000002Ww.Load(f00000001zj_generator);
			f00000001zj_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			f00000001zj_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(TaskMaster).GetMethod("ReportOtherError", new System.Type[] { typeof(SourceReference), typeof(string) }));
			f00000001zj_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			f00000001zj_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
		}), typeof(ComputeValue));
		if (!typeof(Template).IsAssignableFrom(_target.BackingType) && !typeof(MutableFrame).IsAssignableFrom(_target.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(_target.BackingType)));
		_target.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(name));
		var f00000002A3_is_frame = typeof(MutableFrame).IsAssignableFrom(_target.BackingType);
		var f00000002A3_boxed_type = f00000002A3_is_frame ? typeof(object) : typeof(ComputeValue);
		_generator.LoadReboxed(f00000001zj, f00000002A3_boxed_type);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, _target.BackingType.GetMethod(f00000002A3_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000002A3_boxed_type }));
		_final_block(_target);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		var f00000001sK_api = _collect_names ? _api_gen.CreateChild(Generator.ToString(name), this, this.InferredType, false) : _api_gen;
		foreach(var f00000001sK in intro) f00000001sK.GenerateApi(f00000001sK_api, true);
	}
	internal attribute_zz_missing_name Clone() {
		var _obj = new attribute_zz_missing_name();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		_obj.intro.AddRange(intro);
		return _obj;
	}
}
internal abstract class documentation : AstNode {
	internal static bool ParseRule_Base(ref ParserPosition position, out documentation result) {
		position.TraceEnter("documentation");
		if(position.CheckCache<documentation>("documentation", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("any documentation", "documentation");		slave_position = position.Clone();
		if (ParseRule_emph(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("documentation", true);
			position.Cache<documentation>("documentation", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_from(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("documentation", true);
			position.Cache<documentation>("documentation", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_link(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("documentation", true);
			position.Cache<documentation>("documentation", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_lookup(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("documentation", true);
			position.Cache<documentation>("documentation", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_mono(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("documentation", true);
			position.Cache<documentation>("documentation", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_text(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("documentation", true);
			position.Cache<documentation>("documentation", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("documentation", false);
		position.Cache<documentation>("documentation", start_index, null);
		return false;
	}
	internal static bool ParseRule_emph(ref ParserPosition _position, out documentation _result) {
		if(_position.CheckCache<documentation_emph, documentation>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new documentation_emph();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("documentation:emph");

		bool _sequence_fail_f00000001IR = false;
		if (_position.Match("\\Emph{")) {
		} else {
			_position.Update("“\\Emph{”", "attribute");
			_sequence_fail_f00000001IR = true;
			goto _sequence_end_f00000001IR;
		}
		bool _first_f00000001RO = true;
		while(true) {
			ParserPosition _many_position_f00000001RO = _position.Clone();
			var _many_obj_f00000001RO = _obj.Clone();
			bool _alternate_success_f00000001VW = false;
			ParserPosition _alt_position_f00000001VW = _position;
			var _alt_obj_f00000001VW = _obj;
			if (!_alternate_success_f00000001VW) {
				_position = _alt_position_f00000001VW.Clone();
				_obj = _alt_obj_f00000001VW.Clone();
				if ("\\}".IndexOf(_position.Next()) == -1) {
					_obj.str = new RevCons<char>(_position.PeekLast(), _obj.str);
					_alternate_success_f00000001VW = true;
				} else {
					_position.Update(Parser.ToLiteral("\\}"), "attribute");
					_position = _alt_position_f00000001VW;
					_obj = _alt_obj_f00000001VW;
				}
			}
			if (!_alternate_success_f00000001VW) {
				_position = _alt_position_f00000001VW.Clone();
				_obj = _alt_obj_f00000001VW.Clone();
				if (_position.Match("\\\\")) {
					foreach (var f00000001hj_c in System.Char.ConvertFromUtf32(64)) {
					_obj.str = new RevCons<char>(f00000001hj_c, _obj.str);
					}
					_alternate_success_f00000001VW = true;
				} else {
					_position.Update("“\\\\”", "attribute");
					_position = _alt_position_f00000001VW;
					_obj = _alt_obj_f00000001VW;
				}
			}
			if (!_alternate_success_f00000001VW) {
				_position = _alt_position_f00000001VW.Clone();
				_obj = _alt_obj_f00000001VW.Clone();
				if (_position.Match("\\}")) {
					foreach (var f00000001hk_c in System.Char.ConvertFromUtf32(62)) {
					_obj.str = new RevCons<char>(f00000001hk_c, _obj.str);
					}
					_alternate_success_f00000001VW = true;
				} else {
					_position.Update("“\\}”", "attribute");
					_position = _alt_position_f00000001VW;
					_obj = _alt_obj_f00000001VW;
				}
			}
			if (_alternate_success_f00000001VW) {
			} else {
				_position = _many_position_f00000001RO;
				_obj = _many_obj_f00000001RO;
				break;
			}
			_first_f00000001RO = false;
		}
		if (_first_f00000001RO) {
			_sequence_fail_f00000001IR = true;
			goto _sequence_end_f00000001IR;
		} else {
		}
		if (_position.Match("}")) {
		} else {
			_position.Update("“}”", "attribute");
			_sequence_fail_f00000001IR = true;
			goto _sequence_end_f00000001IR;
		}
		_sequence_end_f00000001IR:
		if (_sequence_fail_f00000001IR) {
			_position.Cache<documentation_emph>(_start_index, null);
			_position.TraceExit("documentation:emph", false);
			_result = null;
			return false;
		} else {
			_position.Cache<documentation_emph>(_start_index, _obj);
			_position.TraceExit("documentation:emph", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (documentation)_obj;
			return true;
		}
	}
	internal static bool ParseRule_from(ref ParserPosition _position, out documentation _result) {
		if(_position.CheckCache<documentation_from, documentation>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new documentation_from();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("documentation:from");

		bool _sequence_fail_f00000001IU = false;
		if (_position.Match("\\From{")) {
		} else {
			_position.Update("“\\From{”", "attribute");
			_sequence_fail_f00000001IU = true;
			goto _sequence_end_f00000001IU;
		}
		bool _sequence_fail_f00000001RV = false;
		while(true) {
			ParserPosition _many_position_f00000001VY = _position.Clone();
			var _many_obj_f00000001VY = _obj.Clone();
			bool _alternate_success_f00000001Zm = false;
			ParserPosition _alt_position_f00000001Zm = _position;
			var _alt_obj_f00000001Zm = _obj;
			if (!_alternate_success_f00000001Zm) {
				_position = _alt_position_f00000001Zm.Clone();
				_obj = _alt_obj_f00000001Zm.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zm = true;
				} else {
					_position.Update("character between “A” and “Z”", "attribute");
					_position = _alt_position_f00000001Zm;
					_obj = _alt_obj_f00000001Zm;
				}
			}
			if (!_alternate_success_f00000001Zm) {
				_position = _alt_position_f00000001Zm.Clone();
				_obj = _alt_obj_f00000001Zm.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zm = true;
				} else {
					_position.Update("character between “a” and “z”", "attribute");
					_position = _alt_position_f00000001Zm;
					_obj = _alt_obj_f00000001Zm;
				}
			}
			if (!_alternate_success_f00000001Zm) {
				_position = _alt_position_f00000001Zm.Clone();
				_obj = _alt_obj_f00000001Zm.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zm = true;
				} else {
					_position.Update("character between “0” and “9”", "attribute");
					_position = _alt_position_f00000001Zm;
					_obj = _alt_obj_f00000001Zm;
				}
			}
			if (!_alternate_success_f00000001Zm) {
				_position = _alt_position_f00000001Zm.Clone();
				_obj = _alt_obj_f00000001Zm.Clone();
				if ("-.+".IndexOf(_position.Next()) != -1) {
					_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zm = true;
				} else {
					_position.Update(Parser.ToLiteral("-.+"), "attribute");
					_position = _alt_position_f00000001Zm;
					_obj = _alt_obj_f00000001Zm;
				}
			}
			if (_alternate_success_f00000001Zm) {
			} else {
				_position = _many_position_f00000001VY;
				_obj = _many_obj_f00000001VY;
				break;
			}
		}
		if (":".IndexOf(_position.Next()) != -1) {
			_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
		} else {
			_position.Update(Parser.ToLiteral(":"), "attribute");
			_sequence_fail_f00000001RV = true;
			goto _sequence_end_f00000001RV;
		}
		while(true) {
			ParserPosition _many_position_f00000001Va = _position.Clone();
			var _many_obj_f00000001Va = _obj.Clone();
			bool _alternate_success_f00000001Zn = false;
			ParserPosition _alt_position_f00000001Zn = _position;
			var _alt_obj_f00000001Zn = _obj;
			if (!_alternate_success_f00000001Zn) {
				_position = _alt_position_f00000001Zn.Clone();
				_obj = _alt_obj_f00000001Zn.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zn = true;
				} else {
					_position.Update("character between “A” and “Z”", "attribute");
					_position = _alt_position_f00000001Zn;
					_obj = _alt_obj_f00000001Zn;
				}
			}
			if (!_alternate_success_f00000001Zn) {
				_position = _alt_position_f00000001Zn.Clone();
				_obj = _alt_obj_f00000001Zn.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zn = true;
				} else {
					_position.Update("character between “a” and “z”", "attribute");
					_position = _alt_position_f00000001Zn;
					_obj = _alt_obj_f00000001Zn;
				}
			}
			if (!_alternate_success_f00000001Zn) {
				_position = _alt_position_f00000001Zn.Clone();
				_obj = _alt_obj_f00000001Zn.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zn = true;
				} else {
					_position.Update("character between “0” and “9”", "attribute");
					_position = _alt_position_f00000001Zn;
					_obj = _alt_obj_f00000001Zn;
				}
			}
			if (!_alternate_success_f00000001Zn) {
				_position = _alt_position_f00000001Zn.Clone();
				_obj = _alt_obj_f00000001Zn.Clone();
				if ("~=-,;!?/.'_[]@$*&#%+:".IndexOf(_position.Next()) != -1) {
					_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zn = true;
				} else {
					_position.Update(Parser.ToLiteral("~=-,;!?/.'_[]@$*&#%+:"), "attribute");
					_position = _alt_position_f00000001Zn;
					_obj = _alt_obj_f00000001Zn;
				}
			}
			if (_alternate_success_f00000001Zn) {
			} else {
				_position = _many_position_f00000001Va;
				_obj = _many_obj_f00000001Va;
				break;
			}
		}
		_sequence_end_f00000001RV:
		if (_sequence_fail_f00000001RV) {
			_sequence_fail_f00000001IU = true;
			goto _sequence_end_f00000001IU;
		} else {
		}
		if (_position.Match("}")) {
		} else {
			_position.Update("“}”", "attribute");
			_sequence_fail_f00000001IU = true;
			goto _sequence_end_f00000001IU;
		}
		_sequence_end_f00000001IU:
		if (_sequence_fail_f00000001IU) {
			_position.Cache<documentation_from>(_start_index, null);
			_position.TraceExit("documentation:from", false);
			_result = null;
			return false;
		} else {
			_position.Cache<documentation_from>(_start_index, _obj);
			_position.TraceExit("documentation:from", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (documentation)_obj;
			return true;
		}
	}
	internal static bool ParseRule_link(ref ParserPosition _position, out documentation _result) {
		if(_position.CheckCache<documentation_link, documentation>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new documentation_link();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("documentation:link");

		bool _sequence_fail_f00000001IX = false;
		if (_position.Match("\\Link{")) {
		} else {
			_position.Update("“\\Link{”", "attribute");
			_sequence_fail_f00000001IX = true;
			goto _sequence_end_f00000001IX;
		}
		bool _sequence_fail_f00000001Rb = false;
		while(true) {
			ParserPosition _many_position_f00000001Vc = _position.Clone();
			var _many_obj_f00000001Vc = _obj.Clone();
			bool _alternate_success_f00000001Zr = false;
			ParserPosition _alt_position_f00000001Zr = _position;
			var _alt_obj_f00000001Zr = _obj;
			if (!_alternate_success_f00000001Zr) {
				_position = _alt_position_f00000001Zr.Clone();
				_obj = _alt_obj_f00000001Zr.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zr = true;
				} else {
					_position.Update("character between “A” and “Z”", "attribute");
					_position = _alt_position_f00000001Zr;
					_obj = _alt_obj_f00000001Zr;
				}
			}
			if (!_alternate_success_f00000001Zr) {
				_position = _alt_position_f00000001Zr.Clone();
				_obj = _alt_obj_f00000001Zr.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zr = true;
				} else {
					_position.Update("character between “a” and “z”", "attribute");
					_position = _alt_position_f00000001Zr;
					_obj = _alt_obj_f00000001Zr;
				}
			}
			if (!_alternate_success_f00000001Zr) {
				_position = _alt_position_f00000001Zr.Clone();
				_obj = _alt_obj_f00000001Zr.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zr = true;
				} else {
					_position.Update("character between “0” and “9”", "attribute");
					_position = _alt_position_f00000001Zr;
					_obj = _alt_obj_f00000001Zr;
				}
			}
			if (!_alternate_success_f00000001Zr) {
				_position = _alt_position_f00000001Zr.Clone();
				_obj = _alt_obj_f00000001Zr.Clone();
				if ("-.+".IndexOf(_position.Next()) != -1) {
					_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zr = true;
				} else {
					_position.Update(Parser.ToLiteral("-.+"), "attribute");
					_position = _alt_position_f00000001Zr;
					_obj = _alt_obj_f00000001Zr;
				}
			}
			if (_alternate_success_f00000001Zr) {
			} else {
				_position = _many_position_f00000001Vc;
				_obj = _many_obj_f00000001Vc;
				break;
			}
		}
		if (":".IndexOf(_position.Next()) != -1) {
			_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
		} else {
			_position.Update(Parser.ToLiteral(":"), "attribute");
			_sequence_fail_f00000001Rb = true;
			goto _sequence_end_f00000001Rb;
		}
		while(true) {
			ParserPosition _many_position_f00000001Ve = _position.Clone();
			var _many_obj_f00000001Ve = _obj.Clone();
			bool _alternate_success_f00000001Zs = false;
			ParserPosition _alt_position_f00000001Zs = _position;
			var _alt_obj_f00000001Zs = _obj;
			if (!_alternate_success_f00000001Zs) {
				_position = _alt_position_f00000001Zs.Clone();
				_obj = _alt_obj_f00000001Zs.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zs = true;
				} else {
					_position.Update("character between “A” and “Z”", "attribute");
					_position = _alt_position_f00000001Zs;
					_obj = _alt_obj_f00000001Zs;
				}
			}
			if (!_alternate_success_f00000001Zs) {
				_position = _alt_position_f00000001Zs.Clone();
				_obj = _alt_obj_f00000001Zs.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zs = true;
				} else {
					_position.Update("character between “a” and “z”", "attribute");
					_position = _alt_position_f00000001Zs;
					_obj = _alt_obj_f00000001Zs;
				}
			}
			if (!_alternate_success_f00000001Zs) {
				_position = _alt_position_f00000001Zs.Clone();
				_obj = _alt_obj_f00000001Zs.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zs = true;
				} else {
					_position.Update("character between “0” and “9”", "attribute");
					_position = _alt_position_f00000001Zs;
					_obj = _alt_obj_f00000001Zs;
				}
			}
			if (!_alternate_success_f00000001Zs) {
				_position = _alt_position_f00000001Zs.Clone();
				_obj = _alt_obj_f00000001Zs.Clone();
				if ("~=-,;!?/.'_[]@$*&#%+:".IndexOf(_position.Next()) != -1) {
					_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f00000001Zs = true;
				} else {
					_position.Update(Parser.ToLiteral("~=-,;!?/.'_[]@$*&#%+:"), "attribute");
					_position = _alt_position_f00000001Zs;
					_obj = _alt_obj_f00000001Zs;
				}
			}
			if (_alternate_success_f00000001Zs) {
			} else {
				_position = _many_position_f00000001Ve;
				_obj = _many_obj_f00000001Ve;
				break;
			}
		}
		_sequence_end_f00000001Rb:
		if (_sequence_fail_f00000001Rb) {
			_sequence_fail_f00000001IX = true;
			goto _sequence_end_f00000001IX;
		} else {
		}
		if (_position.Match("|")) {
		} else {
			_position.Update("“|”", "attribute");
			_sequence_fail_f00000001IX = true;
			goto _sequence_end_f00000001IX;
		}
		bool _first_f00000001Rd = true;
		while(true) {
			ParserPosition _many_position_f00000001Rd = _position.Clone();
			var _many_obj_f00000001Rd = _obj.Clone();
			bool _alternate_success_f00000001Vf = false;
			ParserPosition _alt_position_f00000001Vf = _position;
			var _alt_obj_f00000001Vf = _obj;
			if (!_alternate_success_f00000001Vf) {
				_position = _alt_position_f00000001Vf.Clone();
				_obj = _alt_obj_f00000001Vf.Clone();
				if ("\\}".IndexOf(_position.Next()) == -1) {
					_obj.str = new RevCons<char>(_position.PeekLast(), _obj.str);
					_alternate_success_f00000001Vf = true;
				} else {
					_position.Update(Parser.ToLiteral("\\}"), "attribute");
					_position = _alt_position_f00000001Vf;
					_obj = _alt_obj_f00000001Vf;
				}
			}
			if (!_alternate_success_f00000001Vf) {
				_position = _alt_position_f00000001Vf.Clone();
				_obj = _alt_obj_f00000001Vf.Clone();
				if (_position.Match("\\\\")) {
					foreach (var f00000001iI_c in System.Char.ConvertFromUtf32(64)) {
					_obj.str = new RevCons<char>(f00000001iI_c, _obj.str);
					}
					_alternate_success_f00000001Vf = true;
				} else {
					_position.Update("“\\\\”", "attribute");
					_position = _alt_position_f00000001Vf;
					_obj = _alt_obj_f00000001Vf;
				}
			}
			if (!_alternate_success_f00000001Vf) {
				_position = _alt_position_f00000001Vf.Clone();
				_obj = _alt_obj_f00000001Vf.Clone();
				if (_position.Match("\\}")) {
					foreach (var f00000001iJ_c in System.Char.ConvertFromUtf32(62)) {
					_obj.str = new RevCons<char>(f00000001iJ_c, _obj.str);
					}
					_alternate_success_f00000001Vf = true;
				} else {
					_position.Update("“\\}”", "attribute");
					_position = _alt_position_f00000001Vf;
					_obj = _alt_obj_f00000001Vf;
				}
			}
			if (_alternate_success_f00000001Vf) {
			} else {
				_position = _many_position_f00000001Rd;
				_obj = _many_obj_f00000001Rd;
				break;
			}
			_first_f00000001Rd = false;
		}
		if (_first_f00000001Rd) {
			_sequence_fail_f00000001IX = true;
			goto _sequence_end_f00000001IX;
		} else {
		}
		if (_position.Match("}")) {
		} else {
			_position.Update("“}”", "attribute");
			_sequence_fail_f00000001IX = true;
			goto _sequence_end_f00000001IX;
		}
		_sequence_end_f00000001IX:
		if (_sequence_fail_f00000001IX) {
			_position.Cache<documentation_link>(_start_index, null);
			_position.TraceExit("documentation:link", false);
			_result = null;
			return false;
		} else {
			_position.Cache<documentation_link>(_start_index, _obj);
			_position.TraceExit("documentation:link", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (documentation)_obj;
			return true;
		}
	}
	internal static bool ParseRule_lookup(ref ParserPosition _position, out documentation _result) {
		if(_position.CheckCache<documentation_lookup, documentation>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new documentation_lookup();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("documentation:lookup");

		bool _sequence_fail_f00000001Ia = false;
		if (_position.Match("\\{")) {
		} else {
			_position.Update("“\\{”", "attribute");
			_sequence_fail_f00000001Ia = true;
			goto _sequence_end_f00000001Ia;
		}
		bool _first_f00000001Rk = true;
		while(true) {
			ParserPosition _many_position_f00000001Rk = _position.Clone();
			var _many_obj_f00000001Rk = _obj.Clone();
			if (!_first_f00000001Rk) {
			if (_position.Match(".")) {
			} else {
				_position.Update("“.”", "attribute");
				_position = _many_position_f00000001Rk;
				_obj = _many_obj_f00000001Rk;
				break;
			}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.names, identifier.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000001Rk;
			_obj = _many_obj_f00000001Rk;
			break;
			}
			_first_f00000001Rk = false;
		}
		if (_position.Match("}")) {
		} else {
			_position.Update("“}”", "attribute");
			_sequence_fail_f00000001Ia = true;
			goto _sequence_end_f00000001Ia;
		}
		_sequence_end_f00000001Ia:
		if (_sequence_fail_f00000001Ia) {
			_position.Cache<documentation_lookup>(_start_index, null);
			_position.TraceExit("documentation:lookup", false);
			_result = null;
			return false;
		} else {
			_position.Cache<documentation_lookup>(_start_index, _obj);
			_position.TraceExit("documentation:lookup", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (documentation)_obj;
			return true;
		}
	}
	internal static bool ParseRule_mono(ref ParserPosition _position, out documentation _result) {
		if(_position.CheckCache<documentation_mono, documentation>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new documentation_mono();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("documentation:mono");

		bool _sequence_fail_f00000001Id = false;
		if (_position.Match("\\Mono{")) {
		} else {
			_position.Update("“\\Mono{”", "attribute");
			_sequence_fail_f00000001Id = true;
			goto _sequence_end_f00000001Id;
		}
		bool _first_f00000001Rq = true;
		while(true) {
			ParserPosition _many_position_f00000001Rq = _position.Clone();
			var _many_obj_f00000001Rq = _obj.Clone();
			bool _alternate_success_f00000001Vi = false;
			ParserPosition _alt_position_f00000001Vi = _position;
			var _alt_obj_f00000001Vi = _obj;
			if (!_alternate_success_f00000001Vi) {
				_position = _alt_position_f00000001Vi.Clone();
				_obj = _alt_obj_f00000001Vi.Clone();
				if ("\\}".IndexOf(_position.Next()) == -1) {
					_obj.str = new RevCons<char>(_position.PeekLast(), _obj.str);
					_alternate_success_f00000001Vi = true;
				} else {
					_position.Update(Parser.ToLiteral("\\}"), "attribute");
					_position = _alt_position_f00000001Vi;
					_obj = _alt_obj_f00000001Vi;
				}
			}
			if (!_alternate_success_f00000001Vi) {
				_position = _alt_position_f00000001Vi.Clone();
				_obj = _alt_obj_f00000001Vi.Clone();
				if (_position.Match("\\\\")) {
					foreach (var f00000001iL_c in System.Char.ConvertFromUtf32(64)) {
					_obj.str = new RevCons<char>(f00000001iL_c, _obj.str);
					}
					_alternate_success_f00000001Vi = true;
				} else {
					_position.Update("“\\\\”", "attribute");
					_position = _alt_position_f00000001Vi;
					_obj = _alt_obj_f00000001Vi;
				}
			}
			if (!_alternate_success_f00000001Vi) {
				_position = _alt_position_f00000001Vi.Clone();
				_obj = _alt_obj_f00000001Vi.Clone();
				if (_position.Match("\\}")) {
					foreach (var f00000001iM_c in System.Char.ConvertFromUtf32(62)) {
					_obj.str = new RevCons<char>(f00000001iM_c, _obj.str);
					}
					_alternate_success_f00000001Vi = true;
				} else {
					_position.Update("“\\}”", "attribute");
					_position = _alt_position_f00000001Vi;
					_obj = _alt_obj_f00000001Vi;
				}
			}
			if (_alternate_success_f00000001Vi) {
			} else {
				_position = _many_position_f00000001Rq;
				_obj = _many_obj_f00000001Rq;
				break;
			}
			_first_f00000001Rq = false;
		}
		if (_first_f00000001Rq) {
			_sequence_fail_f00000001Id = true;
			goto _sequence_end_f00000001Id;
		} else {
		}
		if (_position.Match("}")) {
		} else {
			_position.Update("“}”", "attribute");
			_sequence_fail_f00000001Id = true;
			goto _sequence_end_f00000001Id;
		}
		_sequence_end_f00000001Id:
		if (_sequence_fail_f00000001Id) {
			_position.Cache<documentation_mono>(_start_index, null);
			_position.TraceExit("documentation:mono", false);
			_result = null;
			return false;
		} else {
			_position.Cache<documentation_mono>(_start_index, _obj);
			_position.TraceExit("documentation:mono", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (documentation)_obj;
			return true;
		}
	}
	internal static bool ParseRule_text(ref ParserPosition _position, out documentation _result) {
		if(_position.CheckCache<documentation_text, documentation>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new documentation_text();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("documentation:text");

		bool _first_f00000001Mo = true;
		while(true) {
			ParserPosition _many_position_f00000001Mo = _position.Clone();
			var _many_obj_f00000001Mo = _obj.Clone();
			bool _alternate_success_f00000001Rv = false;
			ParserPosition _alt_position_f00000001Rv = _position;
			var _alt_obj_f00000001Rv = _obj;
			if (!_alternate_success_f00000001Rv) {
				_position = _alt_position_f00000001Rv.Clone();
				_obj = _alt_obj_f00000001Rv.Clone();
				if ("\\}".IndexOf(_position.Next()) == -1) {
					_obj.str = new RevCons<char>(_position.PeekLast(), _obj.str);
					_alternate_success_f00000001Rv = true;
				} else {
					_position.Update(Parser.ToLiteral("\\}"), "attribute");
					_position = _alt_position_f00000001Rv;
					_obj = _alt_obj_f00000001Rv;
				}
			}
			if (!_alternate_success_f00000001Rv) {
				_position = _alt_position_f00000001Rv.Clone();
				_obj = _alt_obj_f00000001Rv.Clone();
				if (_position.Match("\\\\")) {
					foreach (var f00000001eO_c in System.Char.ConvertFromUtf32(64)) {
					_obj.str = new RevCons<char>(f00000001eO_c, _obj.str);
					}
					_alternate_success_f00000001Rv = true;
				} else {
					_position.Update("“\\\\”", "attribute");
					_position = _alt_position_f00000001Rv;
					_obj = _alt_obj_f00000001Rv;
				}
			}
			if (!_alternate_success_f00000001Rv) {
				_position = _alt_position_f00000001Rv.Clone();
				_obj = _alt_obj_f00000001Rv.Clone();
				if (_position.Match("\\}")) {
					foreach (var f00000001eP_c in System.Char.ConvertFromUtf32(62)) {
					_obj.str = new RevCons<char>(f00000001eP_c, _obj.str);
					}
					_alternate_success_f00000001Rv = true;
				} else {
					_position.Update("“\\}”", "attribute");
					_position = _alt_position_f00000001Rv;
					_obj = _alt_obj_f00000001Rv;
				}
			}
			if (_alternate_success_f00000001Rv) {
			} else {
				_position = _many_position_f00000001Mo;
				_obj = _many_obj_f00000001Mo;
				break;
			}
			_first_f00000001Mo = false;
		}
		if (_first_f00000001Mo) {
			_position.Cache<documentation_text>(_start_index, null);
			_position.TraceExit("documentation:text", false);
			_result = null;
			return false;
		} else {
			_position.Cache<documentation_text>(_start_index, _obj);
			_position.TraceExit("documentation:text", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (documentation)_obj;
			return true;
		}
	}
}
internal class documentation_emph : documentation {
	public override string PrettyName { get { return "attribute"; } }
	internal RevCons<char> str = null;
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		#pragma warning disable 219
		var f00000001IQ_contents = Generator.ToString(str);
		var f00000001IQ = _api_gen.AppendDescriptionTag("http://www.w3.org/1999/xhtml", "em", f00000001IQ_contents);
		#pragma warning restore 219
	}
	internal documentation_emph Clone() {
		var _obj = new documentation_emph();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.str = str;
		return _obj;
	}
}
internal class documentation_from : documentation {
	public override string PrettyName { get { return "attribute"; } }
	internal RevCons<char> uri = null;
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.RegisterRef(Generator.ToString(uri));
		#pragma warning disable 219
		var f00000001MV_contents = Generator.ToString(uri);
		if (f00000001MV_contents.StartsWith("lib:")) {
		f00000001MV_contents = f00000001MV_contents.Substring(4);
		var f00000001MV = _api_gen.AppendDescriptionTag("http://flabbergast.org/api", "o_0:ref", f00000001MV_contents);
		#pragma warning restore 219
		}
	}
	internal documentation_from Clone() {
		var _obj = new documentation_from();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.uri = uri;
		return _obj;
	}
}
internal class documentation_link : documentation {
	public override string PrettyName { get { return "attribute"; } }
	internal RevCons<char> uri = null;
	internal RevCons<char> str = null;
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		#pragma warning disable 219
		var f00000001IW_contents = Generator.ToString(str);
		var f00000001IW = _api_gen.AppendDescriptionTag("http://www.w3.org/1999/xhtml", "a", f00000001IW_contents);
		#pragma warning restore 219
		f00000001IW.SetAttribute("href", Generator.ToString(uri));
	}
	internal documentation_link Clone() {
		var _obj = new documentation_link();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.uri = uri;
		_obj.str = str;
		return _obj;
	}
}
internal class documentation_lookup : documentation {
	public override string PrettyName { get { return "attribute"; } }
	internal System.Collections.Generic.List<identifier> names = new System.Collections.Generic.List<identifier>();
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		#pragma warning disable 219
		var f00000001IZ_contents = System.String.Join(".", names.Select(f00000001IZ_item => f00000001IZ_item.ToString()));
		var f00000001IZ = _api_gen.AppendDescriptionTag("http://flabbergast.org/api", "o_0:use", f00000001IZ_contents);
		#pragma warning restore 219
	}
	internal documentation_lookup Clone() {
		var _obj = new documentation_lookup();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.names.AddRange(names);
		return _obj;
	}
}
internal class documentation_mono : documentation {
	public override string PrettyName { get { return "attribute"; } }
	internal RevCons<char> str = null;
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		#pragma warning disable 219
		var f00000001Ic_contents = Generator.ToString(str);
		var f00000001Ic = _api_gen.AppendDescriptionTag("http://www.w3.org/1999/xhtml", "tt", f00000001Ic_contents);
		#pragma warning restore 219
	}
	internal documentation_mono Clone() {
		var _obj = new documentation_mono();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.str = str;
		return _obj;
	}
}
internal class documentation_text : documentation {
	public override string PrettyName { get { return "attribute"; } }
	internal RevCons<char> str = null;
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.AppendDescriptionText(Generator.ToString(str));
	}
	internal documentation_text Clone() {
		var _obj = new documentation_text();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.str = str;
		return _obj;
	}
}
internal abstract class expression : AstTypeableNode, ITypeableElement {
	public abstract Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool needs_unbox);
	internal RevCons<char> comment = null;
	internal static bool ParseRule_expression0(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression0");
		if(position.CheckCache<expression>("expression.expression0", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression0", "expression");
		slave_position = position.Clone();
		if (ParseRule_let(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression0", true);
			position.Cache<expression>("expression.expression0", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression1(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression0", true);
			position.Cache<expression>("expression.expression0", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression0", false);
		position.Cache<expression>("expression.expression0", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression1(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression1");
		if(position.CheckCache<expression>("expression.expression1", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression1", "expression");
		slave_position = position.Clone();
		if (ParseRule_for_reduce(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression1", true);
			position.Cache<expression>("expression.expression1", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_for_select_anonymous(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression1", true);
			position.Cache<expression>("expression.expression1", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_for_select_named(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression1", true);
			position.Cache<expression>("expression.expression1", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression2(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression1", true);
			position.Cache<expression>("expression.expression1", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression1", false);
		position.Cache<expression>("expression.expression1", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression10(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression10");
		if(position.CheckCache<expression>("expression.expression10", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression10", "expression");
		slave_position = position.Clone();
		if (ParseRule_bitwise_conjunction(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression10", true);
			position.Cache<expression>("expression.expression10", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression11(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression10", true);
			position.Cache<expression>("expression.expression10", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression10", false);
		position.Cache<expression>("expression.expression10", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression11(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression11");
		if(position.CheckCache<expression>("expression.expression11", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression11", "expression");
		slave_position = position.Clone();
		if (ParseRule_arithmetic_disjunction(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression11", true);
			position.Cache<expression>("expression.expression11", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression12(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression11", true);
			position.Cache<expression>("expression.expression11", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression11", false);
		position.Cache<expression>("expression.expression11", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression12(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression12");
		if(position.CheckCache<expression>("expression.expression12", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression12", "expression");
		slave_position = position.Clone();
		if (ParseRule_arithmetic_conjunction(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression12", true);
			position.Cache<expression>("expression.expression12", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression13(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression12", true);
			position.Cache<expression>("expression.expression12", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression12", false);
		position.Cache<expression>("expression.expression12", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression13(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression13");
		if(position.CheckCache<expression>("expression.expression13", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression13", "expression");
		slave_position = position.Clone();
		if (ParseRule_range(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression13", true);
			position.Cache<expression>("expression.expression13", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression14(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression13", true);
			position.Cache<expression>("expression.expression13", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression13", false);
		position.Cache<expression>("expression.expression13", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression14(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression14");
		if(position.CheckCache<expression>("expression.expression14", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression14", "expression");
		slave_position = position.Clone();
		if (ParseRule_check(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression14", true);
			position.Cache<expression>("expression.expression14", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_coerce(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression14", true);
			position.Cache<expression>("expression.expression14", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_enforce(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression14", true);
			position.Cache<expression>("expression.expression14", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_is_finite(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression14", true);
			position.Cache<expression>("expression.expression14", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_is_nan(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression14", true);
			position.Cache<expression>("expression.expression14", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_is_null(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression14", true);
			position.Cache<expression>("expression.expression14", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression15(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression14", true);
			position.Cache<expression>("expression.expression14", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression14", false);
		position.Cache<expression>("expression.expression14", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression15(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression15");
		if(position.CheckCache<expression>("expression.expression15", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression15", "expression");
		slave_position = position.Clone();
		if (ParseRule_error(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression15", true);
			position.Cache<expression>("expression.expression15", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_length(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression15", true);
			position.Cache<expression>("expression.expression15", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression16(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression15", true);
			position.Cache<expression>("expression.expression15", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression15", false);
		position.Cache<expression>("expression.expression15", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression16(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression16");
		if(position.CheckCache<expression>("expression.expression16", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression16", "expression");
		slave_position = position.Clone();
		if (ParseRule_remote_lookup(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression16", true);
			position.Cache<expression>("expression.expression16", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression17(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression16", true);
			position.Cache<expression>("expression.expression16", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression16", false);
		position.Cache<expression>("expression.expression16", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression17(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression17");
		if(position.CheckCache<expression>("expression.expression17", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression17", "expression");
		slave_position = position.Clone();
		if (ParseRule_instantiation(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression17", true);
			position.Cache<expression>("expression.expression17", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression18(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression17", true);
			position.Cache<expression>("expression.expression17", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression17", false);
		position.Cache<expression>("expression.expression17", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression18(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression18");
		if(position.CheckCache<expression>("expression.expression18", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression18", "expression");
		slave_position = position.Clone();
		if (ParseRule_coalesce(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression18", true);
			position.Cache<expression>("expression.expression18", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression19(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression18", true);
			position.Cache<expression>("expression.expression18", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression18", false);
		position.Cache<expression>("expression.expression18", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression19(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression19");
		if(position.CheckCache<expression>("expression.expression19", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression19", "expression");
		slave_position = position.Clone();
		if (ParseRule_bitwise_not(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_function_new(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_generate_id(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_literal_frame(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_negation(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_not(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_nullable_lookup(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_template_extend(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_template_new(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_type_of(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_xcomputation(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_xfield(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_xinvoke(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression20(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression19", true);
			position.Cache<expression>("expression.expression19", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression19", false);
		position.Cache<expression>("expression.expression19", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression2(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression2");
		if(position.CheckCache<expression>("expression.expression2", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression2", "expression");
		slave_position = position.Clone();
		if (ParseRule_if(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression2", true);
			position.Cache<expression>("expression.expression2", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression3(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression2", true);
			position.Cache<expression>("expression.expression2", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression2", false);
		position.Cache<expression>("expression.expression2", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression20(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression20");
		if(position.CheckCache<expression>("expression.expression20", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression20", "expression");
		slave_position = position.Clone();
		if (ParseRule_function_anonymous(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression20", true);
			position.Cache<expression>("expression.expression20", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_function_mixed(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression20", true);
			position.Cache<expression>("expression.expression20", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_function_named(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression20", true);
			position.Cache<expression>("expression.expression20", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression21(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression20", true);
			position.Cache<expression>("expression.expression20", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression20", false);
		position.Cache<expression>("expression.expression20", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression21(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression21");
		if(position.CheckCache<expression>("expression.expression21", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression21", "expression");
		slave_position = position.Clone();
		if (ParseRule_contextual_lookup(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression21", true);
			position.Cache<expression>("expression.expression21", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_direct_lookup(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression21", true);
			position.Cache<expression>("expression.expression21", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_from(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression21", true);
			position.Cache<expression>("expression.expression21", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression22(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression21", true);
			position.Cache<expression>("expression.expression21", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression21", false);
		position.Cache<expression>("expression.expression21", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression22(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression22");
		if(position.CheckCache<expression>("expression.expression22", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression22", "expression");
		slave_position = position.Clone();
		if (ParseRule_container(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_false(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_float_literal(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_float_max(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_float_min(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_hex_integer_literal(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_id(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_infinity(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_int_ig(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_int_ik(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_int_im(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_int_max(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_int_min(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_int_sg(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_int_sk(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_int_sm(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_integer_literal(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_literal_list(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_nan(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_null(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_string_identifier(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_string_literal(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_subexpression(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_this(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_time_literal(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_true(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression22", true);
			position.Cache<expression>("expression.expression22", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression22", false);
		position.Cache<expression>("expression.expression22", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression3(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression3");
		if(position.CheckCache<expression>("expression.expression3", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression3", "expression");
		slave_position = position.Clone();
		if (ParseRule_concatenate(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression3", true);
			position.Cache<expression>("expression.expression3", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_list_join(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression3", true);
			position.Cache<expression>("expression.expression3", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression4(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression3", true);
			position.Cache<expression>("expression.expression3", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression3", false);
		position.Cache<expression>("expression.expression3", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression4(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression4");
		if(position.CheckCache<expression>("expression.expression4", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression4", "expression");
		slave_position = position.Clone();
		if (ParseRule_disjunction(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression4", true);
			position.Cache<expression>("expression.expression4", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression5(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression4", true);
			position.Cache<expression>("expression.expression4", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression4", false);
		position.Cache<expression>("expression.expression4", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression5(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression5");
		if(position.CheckCache<expression>("expression.expression5", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression5", "expression");
		slave_position = position.Clone();
		if (ParseRule_conjunction(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression5", true);
			position.Cache<expression>("expression.expression5", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression6(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression5", true);
			position.Cache<expression>("expression.expression5", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression5", false);
		position.Cache<expression>("expression.expression5", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression6(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression6");
		if(position.CheckCache<expression>("expression.expression6", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression6", "expression");
		slave_position = position.Clone();
		if (ParseRule_equality(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression6", true);
			position.Cache<expression>("expression.expression6", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_greater(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression6", true);
			position.Cache<expression>("expression.expression6", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_greater_or_equality(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression6", true);
			position.Cache<expression>("expression.expression6", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_inequality(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression6", true);
			position.Cache<expression>("expression.expression6", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_lesser(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression6", true);
			position.Cache<expression>("expression.expression6", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_lesser_or_equality(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression6", true);
			position.Cache<expression>("expression.expression6", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression7(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression6", true);
			position.Cache<expression>("expression.expression6", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression6", false);
		position.Cache<expression>("expression.expression6", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression7(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression7");
		if(position.CheckCache<expression>("expression.expression7", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression7", "expression");
		slave_position = position.Clone();
		if (ParseRule_compare(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression7", true);
			position.Cache<expression>("expression.expression7", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression8(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression7", true);
			position.Cache<expression>("expression.expression7", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression7", false);
		position.Cache<expression>("expression.expression7", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression8(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression8");
		if(position.CheckCache<expression>("expression.expression8", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression8", "expression");
		slave_position = position.Clone();
		if (ParseRule_bitwise_disjunction(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression8", true);
			position.Cache<expression>("expression.expression8", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression9(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression8", true);
			position.Cache<expression>("expression.expression8", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression8", false);
		position.Cache<expression>("expression.expression8", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression9(ref ParserPosition position, out expression result) {
		position.TraceEnter("expression9");
		if(position.CheckCache<expression>("expression.expression9", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("expression9", "expression");
		slave_position = position.Clone();
		if (ParseRule_bitwise_symdiff(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression9", true);
			position.Cache<expression>("expression.expression9", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_expression10(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("expression:expression9", true);
			position.Cache<expression>("expression.expression9", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("expression:expression9", false);
		position.Cache<expression>("expression.expression9", start_index, null);
		return false;
	}
	internal static bool ParseRule_arithmetic_conjunction(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_arithmetic_conjunction, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_arithmetic_conjunction();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:arithmetic_conjunction");

		bool _sequence_fail_f00000005PA = false;
		if (expression.ParseRule_expression13(ref _position, out _obj.start_expr)) {
		} else {
		_sequence_fail_f00000005PA = true;
		goto _sequence_end_f00000005PA;
		}
		bool _first_f00000006Bq = true;
		while(true) {
			ParserPosition _many_position_f00000006Bq = _position.Clone();
			var _many_obj_f00000006Bq = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.terms, arithmetic_conjunction_term.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000006Bq;
			_obj = _many_obj_f00000006Bq;
			break;
			}
			_first_f00000006Bq = false;
		}
		if (_first_f00000006Bq) {
			_sequence_fail_f00000005PA = true;
			goto _sequence_end_f00000005PA;
		} else {
		}
		_sequence_end_f00000005PA:
		if (_sequence_fail_f00000005PA) {
			_position.Cache<expression_arithmetic_conjunction>(_start_index, null);
			_position.TraceExit("expression:arithmetic_conjunction", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_arithmetic_conjunction>(_start_index, _obj);
			_position.TraceExit("expression:arithmetic_conjunction", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_arithmetic_disjunction(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_arithmetic_disjunction, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_arithmetic_disjunction();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:arithmetic_disjunction");

		bool _sequence_fail_f00000005PL = false;
		if (expression.ParseRule_expression12(ref _position, out _obj.start_expr)) {
		} else {
		_sequence_fail_f00000005PL = true;
		goto _sequence_end_f00000005PL;
		}
		bool _first_f00000006C6 = true;
		while(true) {
			ParserPosition _many_position_f00000006C6 = _position.Clone();
			var _many_obj_f00000006C6 = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.terms, arithmetic_disjunction_term.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000006C6;
			_obj = _many_obj_f00000006C6;
			break;
			}
			_first_f00000006C6 = false;
		}
		if (_first_f00000006C6) {
			_sequence_fail_f00000005PL = true;
			goto _sequence_end_f00000005PL;
		} else {
		}
		_sequence_end_f00000005PL:
		if (_sequence_fail_f00000005PL) {
			_position.Cache<expression_arithmetic_disjunction>(_start_index, null);
			_position.TraceExit("expression:arithmetic_disjunction", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_arithmetic_disjunction>(_start_index, _obj);
			_position.TraceExit("expression:arithmetic_disjunction", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_bitwise_conjunction(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_bitwise_conjunction, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_bitwise_conjunction();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:bitwise_conjunction");

		bool _sequence_fail_f00000005PV = false;
		if (expression.ParseRule_expression11(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005PV = true;
		goto _sequence_end_f00000005PV;
		}
		while(true) {
			ParserPosition _many_position_f00000006CF = _position.Clone();
			var _many_obj_f00000006CF = _obj.Clone();
			bool _alternate_success_f00000006dz = false;
			ParserPosition _alt_position_f00000006dz = _position;
			var _alt_obj_f00000006dz = _obj;
			if (!_alternate_success_f00000006dz) {
				_position = _alt_position_f00000006dz.Clone();
				_obj = _alt_obj_f00000006dz.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006dz = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "bit-wise conjunction");
					_position = _alt_position_f00000006dz;
					_obj = _alt_obj_f00000006dz;
				}
			}
			if (!_alternate_success_f00000006dz) {
				_position = _alt_position_f00000006dz.Clone();
				_obj = _alt_obj_f00000006dz.Clone();
				bool _sequence_fail_f000000072t = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "bit-wise conjunction");
					_sequence_fail_f000000072t = true;
					goto _sequence_end_f000000072t;
				}
				while(true) {
					ParserPosition _many_position_f00000007bO = _position.Clone();
					var _many_obj_f00000007bO = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "bit-wise conjunction");
						_position = _many_position_f00000007bO;
						_obj = _many_obj_f00000007bO;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "bit-wise conjunction");
					_sequence_fail_f000000072t = true;
					goto _sequence_end_f000000072t;
				}
				_sequence_end_f000000072t:
				if (_sequence_fail_f000000072t) {
					_position = _alt_position_f00000006dz;
					_obj = _alt_obj_f00000006dz;
				} else {
					_alternate_success_f00000006dz = true;
				}
			}
			if (_alternate_success_f00000006dz) {
			} else {
				_position = _many_position_f00000006CF;
				_obj = _many_obj_f00000006CF;
				break;
			}
		}
		if (_position.Match("B&")) {
		} else {
			_position.Update("“B&”", "bit-wise conjunction");
			_sequence_fail_f00000005PV = true;
			goto _sequence_end_f00000005PV;
		}
		while(true) {
			ParserPosition _many_position_f00000006CG = _position.Clone();
			var _many_obj_f00000006CG = _obj.Clone();
			bool _alternate_success_f00000006e0 = false;
			ParserPosition _alt_position_f00000006e0 = _position;
			var _alt_obj_f00000006e0 = _obj;
			if (!_alternate_success_f00000006e0) {
				_position = _alt_position_f00000006e0.Clone();
				_obj = _alt_obj_f00000006e0.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006e0 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "bit-wise conjunction");
					_position = _alt_position_f00000006e0;
					_obj = _alt_obj_f00000006e0;
				}
			}
			if (!_alternate_success_f00000006e0) {
				_position = _alt_position_f00000006e0.Clone();
				_obj = _alt_obj_f00000006e0.Clone();
				bool _sequence_fail_f000000072x = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "bit-wise conjunction");
					_sequence_fail_f000000072x = true;
					goto _sequence_end_f000000072x;
				}
				while(true) {
					ParserPosition _many_position_f00000007bU = _position.Clone();
					var _many_obj_f00000007bU = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "bit-wise conjunction");
						_position = _many_position_f00000007bU;
						_obj = _many_obj_f00000007bU;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "bit-wise conjunction");
					_sequence_fail_f000000072x = true;
					goto _sequence_end_f000000072x;
				}
				_sequence_end_f000000072x:
				if (_sequence_fail_f000000072x) {
					_position = _alt_position_f00000006e0;
					_obj = _alt_obj_f00000006e0;
				} else {
					_alternate_success_f00000006e0 = true;
				}
			}
			if (_alternate_success_f00000006e0) {
			} else {
				_position = _many_position_f00000006CG;
				_obj = _many_obj_f00000006CG;
				break;
			}
		}
		if (expression.ParseRule_expression10(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005PV = true;
		goto _sequence_end_f00000005PV;
		}
		_sequence_end_f00000005PV:
		if (_sequence_fail_f00000005PV) {
			_position.Cache<expression_bitwise_conjunction>(_start_index, null);
			_position.TraceExit("expression:bitwise_conjunction", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_bitwise_conjunction>(_start_index, _obj);
			_position.TraceExit("expression:bitwise_conjunction", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_bitwise_disjunction(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_bitwise_disjunction, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_bitwise_disjunction();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:bitwise_disjunction");

		bool _sequence_fail_f00000005Pf = false;
		if (expression.ParseRule_expression9(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Pf = true;
		goto _sequence_end_f00000005Pf;
		}
		while(true) {
			ParserPosition _many_position_f00000006CR = _position.Clone();
			var _many_obj_f00000006CR = _obj.Clone();
			bool _alternate_success_f00000006e3 = false;
			ParserPosition _alt_position_f00000006e3 = _position;
			var _alt_obj_f00000006e3 = _obj;
			if (!_alternate_success_f00000006e3) {
				_position = _alt_position_f00000006e3.Clone();
				_obj = _alt_obj_f00000006e3.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006e3 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "bit-wise disjunction");
					_position = _alt_position_f00000006e3;
					_obj = _alt_obj_f00000006e3;
				}
			}
			if (!_alternate_success_f00000006e3) {
				_position = _alt_position_f00000006e3.Clone();
				_obj = _alt_obj_f00000006e3.Clone();
				bool _sequence_fail_f0000000734 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "bit-wise disjunction");
					_sequence_fail_f0000000734 = true;
					goto _sequence_end_f0000000734;
				}
				while(true) {
					ParserPosition _many_position_f00000007bb = _position.Clone();
					var _many_obj_f00000007bb = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "bit-wise disjunction");
						_position = _many_position_f00000007bb;
						_obj = _many_obj_f00000007bb;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "bit-wise disjunction");
					_sequence_fail_f0000000734 = true;
					goto _sequence_end_f0000000734;
				}
				_sequence_end_f0000000734:
				if (_sequence_fail_f0000000734) {
					_position = _alt_position_f00000006e3;
					_obj = _alt_obj_f00000006e3;
				} else {
					_alternate_success_f00000006e3 = true;
				}
			}
			if (_alternate_success_f00000006e3) {
			} else {
				_position = _many_position_f00000006CR;
				_obj = _many_obj_f00000006CR;
				break;
			}
		}
		if (_position.Match("B|")) {
		} else {
			_position.Update("“B|”", "bit-wise disjunction");
			_sequence_fail_f00000005Pf = true;
			goto _sequence_end_f00000005Pf;
		}
		while(true) {
			ParserPosition _many_position_f00000006CS = _position.Clone();
			var _many_obj_f00000006CS = _obj.Clone();
			bool _alternate_success_f00000006e4 = false;
			ParserPosition _alt_position_f00000006e4 = _position;
			var _alt_obj_f00000006e4 = _obj;
			if (!_alternate_success_f00000006e4) {
				_position = _alt_position_f00000006e4.Clone();
				_obj = _alt_obj_f00000006e4.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006e4 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "bit-wise disjunction");
					_position = _alt_position_f00000006e4;
					_obj = _alt_obj_f00000006e4;
				}
			}
			if (!_alternate_success_f00000006e4) {
				_position = _alt_position_f00000006e4.Clone();
				_obj = _alt_obj_f00000006e4.Clone();
				bool _sequence_fail_f0000000738 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "bit-wise disjunction");
					_sequence_fail_f0000000738 = true;
					goto _sequence_end_f0000000738;
				}
				while(true) {
					ParserPosition _many_position_f00000007bh = _position.Clone();
					var _many_obj_f00000007bh = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "bit-wise disjunction");
						_position = _many_position_f00000007bh;
						_obj = _many_obj_f00000007bh;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "bit-wise disjunction");
					_sequence_fail_f0000000738 = true;
					goto _sequence_end_f0000000738;
				}
				_sequence_end_f0000000738:
				if (_sequence_fail_f0000000738) {
					_position = _alt_position_f00000006e4;
					_obj = _alt_obj_f00000006e4;
				} else {
					_alternate_success_f00000006e4 = true;
				}
			}
			if (_alternate_success_f00000006e4) {
			} else {
				_position = _many_position_f00000006CS;
				_obj = _many_obj_f00000006CS;
				break;
			}
		}
		if (expression.ParseRule_expression8(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Pf = true;
		goto _sequence_end_f00000005Pf;
		}
		_sequence_end_f00000005Pf:
		if (_sequence_fail_f00000005Pf) {
			_position.Cache<expression_bitwise_disjunction>(_start_index, null);
			_position.TraceExit("expression:bitwise_disjunction", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_bitwise_disjunction>(_start_index, _obj);
			_position.TraceExit("expression:bitwise_disjunction", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_bitwise_not(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_bitwise_not, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_bitwise_not();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:bitwise_not");

		bool _sequence_fail_f00000005Pp = false;
		if (_position.Match("B!")) {
		} else {
			_position.Update("“B!”", "bit-wise complementation");
			_sequence_fail_f00000005Pp = true;
			goto _sequence_end_f00000005Pp;
		}
		while(true) {
			ParserPosition _many_position_f00000006Cb = _position.Clone();
			var _many_obj_f00000006Cb = _obj.Clone();
			bool _alternate_success_f00000006eB = false;
			ParserPosition _alt_position_f00000006eB = _position;
			var _alt_obj_f00000006eB = _obj;
			if (!_alternate_success_f00000006eB) {
				_position = _alt_position_f00000006eB.Clone();
				_obj = _alt_obj_f00000006eB.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006eB = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "bit-wise complementation");
					_position = _alt_position_f00000006eB;
					_obj = _alt_obj_f00000006eB;
				}
			}
			if (!_alternate_success_f00000006eB) {
				_position = _alt_position_f00000006eB.Clone();
				_obj = _alt_obj_f00000006eB.Clone();
				bool _sequence_fail_f000000073H = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "bit-wise complementation");
					_sequence_fail_f000000073H = true;
					goto _sequence_end_f000000073H;
				}
				while(true) {
					ParserPosition _many_position_f00000007bn = _position.Clone();
					var _many_obj_f00000007bn = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "bit-wise complementation");
						_position = _many_position_f00000007bn;
						_obj = _many_obj_f00000007bn;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "bit-wise complementation");
					_sequence_fail_f000000073H = true;
					goto _sequence_end_f000000073H;
				}
				_sequence_end_f000000073H:
				if (_sequence_fail_f000000073H) {
					_position = _alt_position_f00000006eB;
					_obj = _alt_obj_f00000006eB;
				} else {
					_alternate_success_f00000006eB = true;
				}
			}
			if (_alternate_success_f00000006eB) {
			} else {
				_position = _many_position_f00000006Cb;
				_obj = _many_obj_f00000006Cb;
				break;
			}
		}
		if (expression.ParseRule_expression20(ref _position, out _obj.expr)) {
		} else {
		_sequence_fail_f00000005Pp = true;
		goto _sequence_end_f00000005Pp;
		}
		_sequence_end_f00000005Pp:
		if (_sequence_fail_f00000005Pp) {
			_position.Cache<expression_bitwise_not>(_start_index, null);
			_position.TraceExit("expression:bitwise_not", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_bitwise_not>(_start_index, _obj);
			_position.TraceExit("expression:bitwise_not", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_bitwise_symdiff(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_bitwise_symdiff, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_bitwise_symdiff();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:bitwise_symdiff");

		bool _sequence_fail_f00000005Pz = false;
		if (expression.ParseRule_expression10(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Pz = true;
		goto _sequence_end_f00000005Pz;
		}
		while(true) {
			ParserPosition _many_position_f00000006Cm = _position.Clone();
			var _many_obj_f00000006Cm = _obj.Clone();
			bool _alternate_success_f00000006eE = false;
			ParserPosition _alt_position_f00000006eE = _position;
			var _alt_obj_f00000006eE = _obj;
			if (!_alternate_success_f00000006eE) {
				_position = _alt_position_f00000006eE.Clone();
				_obj = _alt_obj_f00000006eE.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006eE = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "bit-wise symmetric difference");
					_position = _alt_position_f00000006eE;
					_obj = _alt_obj_f00000006eE;
				}
			}
			if (!_alternate_success_f00000006eE) {
				_position = _alt_position_f00000006eE.Clone();
				_obj = _alt_obj_f00000006eE.Clone();
				bool _sequence_fail_f000000073L = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "bit-wise symmetric difference");
					_sequence_fail_f000000073L = true;
					goto _sequence_end_f000000073L;
				}
				while(true) {
					ParserPosition _many_position_f00000007bu = _position.Clone();
					var _many_obj_f00000007bu = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "bit-wise symmetric difference");
						_position = _many_position_f00000007bu;
						_obj = _many_obj_f00000007bu;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "bit-wise symmetric difference");
					_sequence_fail_f000000073L = true;
					goto _sequence_end_f000000073L;
				}
				_sequence_end_f000000073L:
				if (_sequence_fail_f000000073L) {
					_position = _alt_position_f00000006eE;
					_obj = _alt_obj_f00000006eE;
				} else {
					_alternate_success_f00000006eE = true;
				}
			}
			if (_alternate_success_f00000006eE) {
			} else {
				_position = _many_position_f00000006Cm;
				_obj = _many_obj_f00000006Cm;
				break;
			}
		}
		if (_position.Match("B^")) {
		} else {
			_position.Update("“B^”", "bit-wise symmetric difference");
			_sequence_fail_f00000005Pz = true;
			goto _sequence_end_f00000005Pz;
		}
		while(true) {
			ParserPosition _many_position_f00000006Cn = _position.Clone();
			var _many_obj_f00000006Cn = _obj.Clone();
			bool _alternate_success_f00000006eF = false;
			ParserPosition _alt_position_f00000006eF = _position;
			var _alt_obj_f00000006eF = _obj;
			if (!_alternate_success_f00000006eF) {
				_position = _alt_position_f00000006eF.Clone();
				_obj = _alt_obj_f00000006eF.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006eF = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "bit-wise symmetric difference");
					_position = _alt_position_f00000006eF;
					_obj = _alt_obj_f00000006eF;
				}
			}
			if (!_alternate_success_f00000006eF) {
				_position = _alt_position_f00000006eF.Clone();
				_obj = _alt_obj_f00000006eF.Clone();
				bool _sequence_fail_f000000073P = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "bit-wise symmetric difference");
					_sequence_fail_f000000073P = true;
					goto _sequence_end_f000000073P;
				}
				while(true) {
					ParserPosition _many_position_f00000007c0 = _position.Clone();
					var _many_obj_f00000007c0 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "bit-wise symmetric difference");
						_position = _many_position_f00000007c0;
						_obj = _many_obj_f00000007c0;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "bit-wise symmetric difference");
					_sequence_fail_f000000073P = true;
					goto _sequence_end_f000000073P;
				}
				_sequence_end_f000000073P:
				if (_sequence_fail_f000000073P) {
					_position = _alt_position_f00000006eF;
					_obj = _alt_obj_f00000006eF;
				} else {
					_alternate_success_f00000006eF = true;
				}
			}
			if (_alternate_success_f00000006eF) {
			} else {
				_position = _many_position_f00000006Cn;
				_obj = _many_obj_f00000006Cn;
				break;
			}
		}
		if (expression.ParseRule_expression9(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Pz = true;
		goto _sequence_end_f00000005Pz;
		}
		_sequence_end_f00000005Pz:
		if (_sequence_fail_f00000005Pz) {
			_position.Cache<expression_bitwise_symdiff>(_start_index, null);
			_position.TraceExit("expression:bitwise_symdiff", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_bitwise_symdiff>(_start_index, _obj);
			_position.TraceExit("expression:bitwise_symdiff", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_check(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_check, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_check();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:check");

		bool _sequence_fail_f00000005Q9 = false;
		if (expression.ParseRule_expression15(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Q9 = true;
		goto _sequence_end_f00000005Q9;
		}
		while(true) {
			ParserPosition _many_position_f00000006Cw = _position.Clone();
			var _many_obj_f00000006Cw = _obj.Clone();
			bool _alternate_success_f00000006eI = false;
			ParserPosition _alt_position_f00000006eI = _position;
			var _alt_obj_f00000006eI = _obj;
			if (!_alternate_success_f00000006eI) {
				_position = _alt_position_f00000006eI.Clone();
				_obj = _alt_obj_f00000006eI.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006eI = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "type check");
					_position = _alt_position_f00000006eI;
					_obj = _alt_obj_f00000006eI;
				}
			}
			if (!_alternate_success_f00000006eI) {
				_position = _alt_position_f00000006eI.Clone();
				_obj = _alt_obj_f00000006eI.Clone();
				bool _sequence_fail_f000000073W = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "type check");
					_sequence_fail_f000000073W = true;
					goto _sequence_end_f000000073W;
				}
				while(true) {
					ParserPosition _many_position_f00000007c7 = _position.Clone();
					var _many_obj_f00000007c7 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "type check");
						_position = _many_position_f00000007c7;
						_obj = _many_obj_f00000007c7;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "type check");
					_sequence_fail_f000000073W = true;
					goto _sequence_end_f000000073W;
				}
				_sequence_end_f000000073W:
				if (_sequence_fail_f000000073W) {
					_position = _alt_position_f00000006eI;
					_obj = _alt_obj_f00000006eI;
				} else {
					_alternate_success_f00000006eI = true;
				}
			}
			if (_alternate_success_f00000006eI) {
			} else {
				_position = _many_position_f00000006Cw;
				_obj = _many_obj_f00000006Cw;
				break;
			}
		}
		if (_position.Match("Is")) {
		} else {
			_position.Update("“Is”", "type check");
			_sequence_fail_f00000005Q9 = true;
			goto _sequence_end_f00000005Q9;
		}
		while(true) {
			ParserPosition _many_position_f00000006Cx = _position.Clone();
			var _many_obj_f00000006Cx = _obj.Clone();
			bool _alternate_success_f00000006eJ = false;
			ParserPosition _alt_position_f00000006eJ = _position;
			var _alt_obj_f00000006eJ = _obj;
			if (!_alternate_success_f00000006eJ) {
				_position = _alt_position_f00000006eJ.Clone();
				_obj = _alt_obj_f00000006eJ.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006eJ = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "type check");
					_position = _alt_position_f00000006eJ;
					_obj = _alt_obj_f00000006eJ;
				}
			}
			if (!_alternate_success_f00000006eJ) {
				_position = _alt_position_f00000006eJ.Clone();
				_obj = _alt_obj_f00000006eJ.Clone();
				bool _sequence_fail_f000000073a = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "type check");
					_sequence_fail_f000000073a = true;
					goto _sequence_end_f000000073a;
				}
				while(true) {
					ParserPosition _many_position_f00000007cD = _position.Clone();
					var _many_obj_f00000007cD = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "type check");
						_position = _many_position_f00000007cD;
						_obj = _many_obj_f00000007cD;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "type check");
					_sequence_fail_f000000073a = true;
					goto _sequence_end_f000000073a;
				}
				_sequence_end_f000000073a:
				if (_sequence_fail_f000000073a) {
					_position = _alt_position_f00000006eJ;
					_obj = _alt_obj_f00000006eJ;
				} else {
					_alternate_success_f00000006eJ = true;
				}
			}
			if (_alternate_success_f00000006eJ) {
			} else {
				_position = _many_position_f00000006Cx;
				_obj = _many_obj_f00000006Cx;
				break;
			}
		}
		if (type_name.ParseRule_Base(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Q9 = true;
		goto _sequence_end_f00000005Q9;
		}
		_sequence_end_f00000005Q9:
		if (_sequence_fail_f00000005Q9) {
			_position.Cache<expression_check>(_start_index, null);
			_position.TraceExit("expression:check", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_check>(_start_index, _obj);
			_position.TraceExit("expression:check", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_coalesce(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_coalesce, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_coalesce();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:coalesce");

		bool _sequence_fail_f00000005QK = false;
		if (expression.ParseRule_expression19(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005QK = true;
		goto _sequence_end_f00000005QK;
		}
		while(true) {
			ParserPosition _many_position_f00000006DN = _position.Clone();
			var _many_obj_f00000006DN = _obj.Clone();
			bool _alternate_success_f00000006eN = false;
			ParserPosition _alt_position_f00000006eN = _position;
			var _alt_obj_f00000006eN = _obj;
			if (!_alternate_success_f00000006eN) {
				_position = _alt_position_f00000006eN.Clone();
				_obj = _alt_obj_f00000006eN.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006eN = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "null coalescence");
					_position = _alt_position_f00000006eN;
					_obj = _alt_obj_f00000006eN;
				}
			}
			if (!_alternate_success_f00000006eN) {
				_position = _alt_position_f00000006eN.Clone();
				_obj = _alt_obj_f00000006eN.Clone();
				bool _sequence_fail_f000000073i = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "null coalescence");
					_sequence_fail_f000000073i = true;
					goto _sequence_end_f000000073i;
				}
				while(true) {
					ParserPosition _many_position_f00000007cK = _position.Clone();
					var _many_obj_f00000007cK = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "null coalescence");
						_position = _many_position_f00000007cK;
						_obj = _many_obj_f00000007cK;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "null coalescence");
					_sequence_fail_f000000073i = true;
					goto _sequence_end_f000000073i;
				}
				_sequence_end_f000000073i:
				if (_sequence_fail_f000000073i) {
					_position = _alt_position_f00000006eN;
					_obj = _alt_obj_f00000006eN;
				} else {
					_alternate_success_f00000006eN = true;
				}
			}
			if (_alternate_success_f00000006eN) {
			} else {
				_position = _many_position_f00000006DN;
				_obj = _many_obj_f00000006DN;
				break;
			}
		}
		if (_position.Match("??")) {
		} else {
			_position.Update("“??”", "null coalescence");
			_sequence_fail_f00000005QK = true;
			goto _sequence_end_f00000005QK;
		}
		while(true) {
			ParserPosition _many_position_f00000006DO = _position.Clone();
			var _many_obj_f00000006DO = _obj.Clone();
			bool _alternate_success_f00000006eO = false;
			ParserPosition _alt_position_f00000006eO = _position;
			var _alt_obj_f00000006eO = _obj;
			if (!_alternate_success_f00000006eO) {
				_position = _alt_position_f00000006eO.Clone();
				_obj = _alt_obj_f00000006eO.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006eO = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "null coalescence");
					_position = _alt_position_f00000006eO;
					_obj = _alt_obj_f00000006eO;
				}
			}
			if (!_alternate_success_f00000006eO) {
				_position = _alt_position_f00000006eO.Clone();
				_obj = _alt_obj_f00000006eO.Clone();
				bool _sequence_fail_f000000073m = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "null coalescence");
					_sequence_fail_f000000073m = true;
					goto _sequence_end_f000000073m;
				}
				while(true) {
					ParserPosition _many_position_f00000007cQ = _position.Clone();
					var _many_obj_f00000007cQ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "null coalescence");
						_position = _many_position_f00000007cQ;
						_obj = _many_obj_f00000007cQ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "null coalescence");
					_sequence_fail_f000000073m = true;
					goto _sequence_end_f000000073m;
				}
				_sequence_end_f000000073m:
				if (_sequence_fail_f000000073m) {
					_position = _alt_position_f00000006eO;
					_obj = _alt_obj_f00000006eO;
				} else {
					_alternate_success_f00000006eO = true;
				}
			}
			if (_alternate_success_f00000006eO) {
			} else {
				_position = _many_position_f00000006DO;
				_obj = _many_obj_f00000006DO;
				break;
			}
		}
		if (expression.ParseRule_expression19(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005QK = true;
		goto _sequence_end_f00000005QK;
		}
		_sequence_end_f00000005QK:
		if (_sequence_fail_f00000005QK) {
			_position.Cache<expression_coalesce>(_start_index, null);
			_position.TraceExit("expression:coalesce", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_coalesce>(_start_index, _obj);
			_position.TraceExit("expression:coalesce", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_coerce(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_coerce, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_coerce();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:coerce");

		bool _sequence_fail_f00000005QU = false;
		if (expression.ParseRule_expression15(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005QU = true;
		goto _sequence_end_f00000005QU;
		}
		while(true) {
			ParserPosition _many_position_f00000006Dg = _position.Clone();
			var _many_obj_f00000006Dg = _obj.Clone();
			bool _alternate_success_f00000006eZ = false;
			ParserPosition _alt_position_f00000006eZ = _position;
			var _alt_obj_f00000006eZ = _obj;
			if (!_alternate_success_f00000006eZ) {
				_position = _alt_position_f00000006eZ.Clone();
				_obj = _alt_obj_f00000006eZ.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006eZ = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "type coercion");
					_position = _alt_position_f00000006eZ;
					_obj = _alt_obj_f00000006eZ;
				}
			}
			if (!_alternate_success_f00000006eZ) {
				_position = _alt_position_f00000006eZ.Clone();
				_obj = _alt_obj_f00000006eZ.Clone();
				bool _sequence_fail_f0000000741 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "type coercion");
					_sequence_fail_f0000000741 = true;
					goto _sequence_end_f0000000741;
				}
				while(true) {
					ParserPosition _many_position_f00000007cs = _position.Clone();
					var _many_obj_f00000007cs = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "type coercion");
						_position = _many_position_f00000007cs;
						_obj = _many_obj_f00000007cs;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "type coercion");
					_sequence_fail_f0000000741 = true;
					goto _sequence_end_f0000000741;
				}
				_sequence_end_f0000000741:
				if (_sequence_fail_f0000000741) {
					_position = _alt_position_f00000006eZ;
					_obj = _alt_obj_f00000006eZ;
				} else {
					_alternate_success_f00000006eZ = true;
				}
			}
			if (_alternate_success_f00000006eZ) {
			} else {
				_position = _many_position_f00000006Dg;
				_obj = _many_obj_f00000006Dg;
				break;
			}
		}
		if (_position.Match("To")) {
		} else {
			_position.Update("“To”", "type coercion");
			_sequence_fail_f00000005QU = true;
			goto _sequence_end_f00000005QU;
		}
		while(true) {
			ParserPosition _many_position_f00000006Dh = _position.Clone();
			var _many_obj_f00000006Dh = _obj.Clone();
			bool _alternate_success_f00000006ea = false;
			ParserPosition _alt_position_f00000006ea = _position;
			var _alt_obj_f00000006ea = _obj;
			if (!_alternate_success_f00000006ea) {
				_position = _alt_position_f00000006ea.Clone();
				_obj = _alt_obj_f00000006ea.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ea = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "type coercion");
					_position = _alt_position_f00000006ea;
					_obj = _alt_obj_f00000006ea;
				}
			}
			if (!_alternate_success_f00000006ea) {
				_position = _alt_position_f00000006ea.Clone();
				_obj = _alt_obj_f00000006ea.Clone();
				bool _sequence_fail_f0000000745 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "type coercion");
					_sequence_fail_f0000000745 = true;
					goto _sequence_end_f0000000745;
				}
				while(true) {
					ParserPosition _many_position_f00000007cy = _position.Clone();
					var _many_obj_f00000007cy = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "type coercion");
						_position = _many_position_f00000007cy;
						_obj = _many_obj_f00000007cy;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "type coercion");
					_sequence_fail_f0000000745 = true;
					goto _sequence_end_f0000000745;
				}
				_sequence_end_f0000000745:
				if (_sequence_fail_f0000000745) {
					_position = _alt_position_f00000006ea;
					_obj = _alt_obj_f00000006ea;
				} else {
					_alternate_success_f00000006ea = true;
				}
			}
			if (_alternate_success_f00000006ea) {
			} else {
				_position = _many_position_f00000006Dh;
				_obj = _many_obj_f00000006Dh;
				break;
			}
		}
		if (type_name.ParseRule_Base(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005QU = true;
		goto _sequence_end_f00000005QU;
		}
		_sequence_end_f00000005QU:
		if (_sequence_fail_f00000005QU) {
			_position.Cache<expression_coerce>(_start_index, null);
			_position.TraceExit("expression:coerce", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_coerce>(_start_index, _obj);
			_position.TraceExit("expression:coerce", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_compare(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_compare, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_compare();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:compare");

		bool _sequence_fail_f00000005Qe = false;
		if (expression.ParseRule_expression8(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Qe = true;
		goto _sequence_end_f00000005Qe;
		}
		while(true) {
			ParserPosition _many_position_f00000006Du = _position.Clone();
			var _many_obj_f00000006Du = _obj.Clone();
			bool _alternate_success_f00000006ed = false;
			ParserPosition _alt_position_f00000006ed = _position;
			var _alt_obj_f00000006ed = _obj;
			if (!_alternate_success_f00000006ed) {
				_position = _alt_position_f00000006ed.Clone();
				_obj = _alt_obj_f00000006ed.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ed = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "comparison");
					_position = _alt_position_f00000006ed;
					_obj = _alt_obj_f00000006ed;
				}
			}
			if (!_alternate_success_f00000006ed) {
				_position = _alt_position_f00000006ed.Clone();
				_obj = _alt_obj_f00000006ed.Clone();
				bool _sequence_fail_f000000074E = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "comparison");
					_sequence_fail_f000000074E = true;
					goto _sequence_end_f000000074E;
				}
				while(true) {
					ParserPosition _many_position_f00000007d4 = _position.Clone();
					var _many_obj_f00000007d4 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "comparison");
						_position = _many_position_f00000007d4;
						_obj = _many_obj_f00000007d4;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "comparison");
					_sequence_fail_f000000074E = true;
					goto _sequence_end_f000000074E;
				}
				_sequence_end_f000000074E:
				if (_sequence_fail_f000000074E) {
					_position = _alt_position_f00000006ed;
					_obj = _alt_obj_f00000006ed;
				} else {
					_alternate_success_f00000006ed = true;
				}
			}
			if (_alternate_success_f00000006ed) {
			} else {
				_position = _many_position_f00000006Du;
				_obj = _many_obj_f00000006Du;
				break;
			}
		}
		if (_position.Match("<=>")) {
		} else {
			_position.Update("“<=>”", "comparison");
			_sequence_fail_f00000005Qe = true;
			goto _sequence_end_f00000005Qe;
		}
		while(true) {
			ParserPosition _many_position_f00000006Dv = _position.Clone();
			var _many_obj_f00000006Dv = _obj.Clone();
			bool _alternate_success_f00000006ee = false;
			ParserPosition _alt_position_f00000006ee = _position;
			var _alt_obj_f00000006ee = _obj;
			if (!_alternate_success_f00000006ee) {
				_position = _alt_position_f00000006ee.Clone();
				_obj = _alt_obj_f00000006ee.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ee = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "comparison");
					_position = _alt_position_f00000006ee;
					_obj = _alt_obj_f00000006ee;
				}
			}
			if (!_alternate_success_f00000006ee) {
				_position = _alt_position_f00000006ee.Clone();
				_obj = _alt_obj_f00000006ee.Clone();
				bool _sequence_fail_f000000074I = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "comparison");
					_sequence_fail_f000000074I = true;
					goto _sequence_end_f000000074I;
				}
				while(true) {
					ParserPosition _many_position_f00000007dA = _position.Clone();
					var _many_obj_f00000007dA = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "comparison");
						_position = _many_position_f00000007dA;
						_obj = _many_obj_f00000007dA;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "comparison");
					_sequence_fail_f000000074I = true;
					goto _sequence_end_f000000074I;
				}
				_sequence_end_f000000074I:
				if (_sequence_fail_f000000074I) {
					_position = _alt_position_f00000006ee;
					_obj = _alt_obj_f00000006ee;
				} else {
					_alternate_success_f00000006ee = true;
				}
			}
			if (_alternate_success_f00000006ee) {
			} else {
				_position = _many_position_f00000006Dv;
				_obj = _many_obj_f00000006Dv;
				break;
			}
		}
		if (expression.ParseRule_expression8(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Qe = true;
		goto _sequence_end_f00000005Qe;
		}
		_sequence_end_f00000005Qe:
		if (_sequence_fail_f00000005Qe) {
			_position.Cache<expression_compare>(_start_index, null);
			_position.TraceExit("expression:compare", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_compare>(_start_index, _obj);
			_position.TraceExit("expression:compare", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_concatenate(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_concatenate, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_concatenate();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:concatenate");

		bool _sequence_fail_f00000005Qo = false;
		if (expression.ParseRule_expression4(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Qo = true;
		goto _sequence_end_f00000005Qo;
		}
		while(true) {
			ParserPosition _many_position_f00000006E7 = _position.Clone();
			var _many_obj_f00000006E7 = _obj.Clone();
			bool _alternate_success_f00000006ei = false;
			ParserPosition _alt_position_f00000006ei = _position;
			var _alt_obj_f00000006ei = _obj;
			if (!_alternate_success_f00000006ei) {
				_position = _alt_position_f00000006ei.Clone();
				_obj = _alt_obj_f00000006ei.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ei = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "string concatenation");
					_position = _alt_position_f00000006ei;
					_obj = _alt_obj_f00000006ei;
				}
			}
			if (!_alternate_success_f00000006ei) {
				_position = _alt_position_f00000006ei.Clone();
				_obj = _alt_obj_f00000006ei.Clone();
				bool _sequence_fail_f000000074R = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "string concatenation");
					_sequence_fail_f000000074R = true;
					goto _sequence_end_f000000074R;
				}
				while(true) {
					ParserPosition _many_position_f00000007dH = _position.Clone();
					var _many_obj_f00000007dH = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "string concatenation");
						_position = _many_position_f00000007dH;
						_obj = _many_obj_f00000007dH;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "string concatenation");
					_sequence_fail_f000000074R = true;
					goto _sequence_end_f000000074R;
				}
				_sequence_end_f000000074R:
				if (_sequence_fail_f000000074R) {
					_position = _alt_position_f00000006ei;
					_obj = _alt_obj_f00000006ei;
				} else {
					_alternate_success_f00000006ei = true;
				}
			}
			if (_alternate_success_f00000006ei) {
			} else {
				_position = _many_position_f00000006E7;
				_obj = _many_obj_f00000006E7;
				break;
			}
		}
		if (_position.Match("&")) {
		} else {
			_position.Update("“&”", "string concatenation");
			_sequence_fail_f00000005Qo = true;
			goto _sequence_end_f00000005Qo;
		}
		while(true) {
			ParserPosition _many_position_f00000006E8 = _position.Clone();
			var _many_obj_f00000006E8 = _obj.Clone();
			bool _alternate_success_f00000006ej = false;
			ParserPosition _alt_position_f00000006ej = _position;
			var _alt_obj_f00000006ej = _obj;
			if (!_alternate_success_f00000006ej) {
				_position = _alt_position_f00000006ej.Clone();
				_obj = _alt_obj_f00000006ej.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ej = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "string concatenation");
					_position = _alt_position_f00000006ej;
					_obj = _alt_obj_f00000006ej;
				}
			}
			if (!_alternate_success_f00000006ej) {
				_position = _alt_position_f00000006ej.Clone();
				_obj = _alt_obj_f00000006ej.Clone();
				bool _sequence_fail_f000000074V = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "string concatenation");
					_sequence_fail_f000000074V = true;
					goto _sequence_end_f000000074V;
				}
				while(true) {
					ParserPosition _many_position_f00000007dN = _position.Clone();
					var _many_obj_f00000007dN = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "string concatenation");
						_position = _many_position_f00000007dN;
						_obj = _many_obj_f00000007dN;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "string concatenation");
					_sequence_fail_f000000074V = true;
					goto _sequence_end_f000000074V;
				}
				_sequence_end_f000000074V:
				if (_sequence_fail_f000000074V) {
					_position = _alt_position_f00000006ej;
					_obj = _alt_obj_f00000006ej;
				} else {
					_alternate_success_f00000006ej = true;
				}
			}
			if (_alternate_success_f00000006ej) {
			} else {
				_position = _many_position_f00000006E8;
				_obj = _many_obj_f00000006E8;
				break;
			}
		}
		if (expression.ParseRule_expression3(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Qo = true;
		goto _sequence_end_f00000005Qo;
		}
		_sequence_end_f00000005Qo:
		if (_sequence_fail_f00000005Qo) {
			_position.Cache<expression_concatenate>(_start_index, null);
			_position.TraceExit("expression:concatenate", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_concatenate>(_start_index, _obj);
			_position.TraceExit("expression:concatenate", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_conjunction(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_conjunction, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_conjunction();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:conjunction");

		bool _sequence_fail_f00000005Qz = false;
		if (expression.ParseRule_expression6(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Qz = true;
		goto _sequence_end_f00000005Qz;
		}
		while(true) {
			ParserPosition _many_position_f00000006ES = _position.Clone();
			var _many_obj_f00000006ES = _obj.Clone();
			bool _alternate_success_f00000006eo = false;
			ParserPosition _alt_position_f00000006eo = _position;
			var _alt_obj_f00000006eo = _obj;
			if (!_alternate_success_f00000006eo) {
				_position = _alt_position_f00000006eo.Clone();
				_obj = _alt_obj_f00000006eo.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006eo = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "logical conjunction");
					_position = _alt_position_f00000006eo;
					_obj = _alt_obj_f00000006eo;
				}
			}
			if (!_alternate_success_f00000006eo) {
				_position = _alt_position_f00000006eo.Clone();
				_obj = _alt_obj_f00000006eo.Clone();
				bool _sequence_fail_f000000074d = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "logical conjunction");
					_sequence_fail_f000000074d = true;
					goto _sequence_end_f000000074d;
				}
				while(true) {
					ParserPosition _many_position_f00000007dT = _position.Clone();
					var _many_obj_f00000007dT = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "logical conjunction");
						_position = _many_position_f00000007dT;
						_obj = _many_obj_f00000007dT;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "logical conjunction");
					_sequence_fail_f000000074d = true;
					goto _sequence_end_f000000074d;
				}
				_sequence_end_f000000074d:
				if (_sequence_fail_f000000074d) {
					_position = _alt_position_f00000006eo;
					_obj = _alt_obj_f00000006eo;
				} else {
					_alternate_success_f00000006eo = true;
				}
			}
			if (_alternate_success_f00000006eo) {
			} else {
				_position = _many_position_f00000006ES;
				_obj = _many_obj_f00000006ES;
				break;
			}
		}
		if (_position.Match("&&")) {
		} else {
			_position.Update("“&&”", "logical conjunction");
			_sequence_fail_f00000005Qz = true;
			goto _sequence_end_f00000005Qz;
		}
		while(true) {
			ParserPosition _many_position_f00000006ET = _position.Clone();
			var _many_obj_f00000006ET = _obj.Clone();
			bool _alternate_success_f00000006ep = false;
			ParserPosition _alt_position_f00000006ep = _position;
			var _alt_obj_f00000006ep = _obj;
			if (!_alternate_success_f00000006ep) {
				_position = _alt_position_f00000006ep.Clone();
				_obj = _alt_obj_f00000006ep.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ep = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "logical conjunction");
					_position = _alt_position_f00000006ep;
					_obj = _alt_obj_f00000006ep;
				}
			}
			if (!_alternate_success_f00000006ep) {
				_position = _alt_position_f00000006ep.Clone();
				_obj = _alt_obj_f00000006ep.Clone();
				bool _sequence_fail_f000000074h = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "logical conjunction");
					_sequence_fail_f000000074h = true;
					goto _sequence_end_f000000074h;
				}
				while(true) {
					ParserPosition _many_position_f00000007dZ = _position.Clone();
					var _many_obj_f00000007dZ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "logical conjunction");
						_position = _many_position_f00000007dZ;
						_obj = _many_obj_f00000007dZ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "logical conjunction");
					_sequence_fail_f000000074h = true;
					goto _sequence_end_f000000074h;
				}
				_sequence_end_f000000074h:
				if (_sequence_fail_f000000074h) {
					_position = _alt_position_f00000006ep;
					_obj = _alt_obj_f00000006ep;
				} else {
					_alternate_success_f00000006ep = true;
				}
			}
			if (_alternate_success_f00000006ep) {
			} else {
				_position = _many_position_f00000006ET;
				_obj = _many_obj_f00000006ET;
				break;
			}
		}
		if (expression.ParseRule_expression5(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Qz = true;
		goto _sequence_end_f00000005Qz;
		}
		_sequence_end_f00000005Qz:
		if (_sequence_fail_f00000005Qz) {
			_position.Cache<expression_conjunction>(_start_index, null);
			_position.TraceExit("expression:conjunction", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_conjunction>(_start_index, _obj);
			_position.TraceExit("expression:conjunction", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_container(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_container, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_container();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:container");

		if (_position.Match("Container")) {
			_position.Cache<expression_container>(_start_index, _obj);
			_position.TraceExit("expression:container", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		} else {
			_position.Update("“Container”", "access containing frame");
			_position.Cache<expression_container>(_start_index, null);
			_position.TraceExit("expression:container", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_contextual_lookup(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_contextual_lookup, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_contextual_lookup();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:contextual_lookup");

		bool _first_f00000005lG = true;
		while(true) {
			ParserPosition _many_position_f00000005lG = _position.Clone();
			var _many_obj_f00000005lG = _obj.Clone();
			if (!_first_f00000005lG) {
			if (_position.Match(".")) {
			} else {
				_position.Update("“.”", "contextual lookup");
				_position = _many_position_f00000005lG;
				_obj = _many_obj_f00000005lG;
				break;
			}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.parts, identifier.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000005lG;
			_obj = _many_obj_f00000005lG;
			break;
			}
			_first_f00000005lG = false;
		}
		if (_first_f00000005lG) {
			_position.Cache<expression_contextual_lookup>(_start_index, null);
			_position.TraceExit("expression:contextual_lookup", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_contextual_lookup>(_start_index, _obj);
			_position.TraceExit("expression:contextual_lookup", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_direct_lookup(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_direct_lookup, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_direct_lookup();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:direct_lookup");

		bool _sequence_fail_f00000005RN = false;
		if (expression.ParseRule_expression22(ref _position, out _obj.expr)) {
		} else {
		_sequence_fail_f00000005RN = true;
		goto _sequence_end_f00000005RN;
		}
		while(true) {
			ParserPosition _many_position_f00000006Eh = _position.Clone();
			var _many_obj_f00000006Eh = _obj.Clone();
			bool _alternate_success_f00000006f1 = false;
			ParserPosition _alt_position_f00000006f1 = _position;
			var _alt_obj_f00000006f1 = _obj;
			if (!_alternate_success_f00000006f1) {
				_position = _alt_position_f00000006f1.Clone();
				_obj = _alt_obj_f00000006f1.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006f1 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "direct lookup");
					_position = _alt_position_f00000006f1;
					_obj = _alt_obj_f00000006f1;
				}
			}
			if (!_alternate_success_f00000006f1) {
				_position = _alt_position_f00000006f1.Clone();
				_obj = _alt_obj_f00000006f1.Clone();
				bool _sequence_fail_f000000074p = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "direct lookup");
					_sequence_fail_f000000074p = true;
					goto _sequence_end_f000000074p;
				}
				while(true) {
					ParserPosition _many_position_f00000007dh = _position.Clone();
					var _many_obj_f00000007dh = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "direct lookup");
						_position = _many_position_f00000007dh;
						_obj = _many_obj_f00000007dh;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "direct lookup");
					_sequence_fail_f000000074p = true;
					goto _sequence_end_f000000074p;
				}
				_sequence_end_f000000074p:
				if (_sequence_fail_f000000074p) {
					_position = _alt_position_f00000006f1;
					_obj = _alt_obj_f00000006f1;
				} else {
					_alternate_success_f00000006f1 = true;
				}
			}
			if (_alternate_success_f00000006f1) {
			} else {
				_position = _many_position_f00000006Eh;
				_obj = _many_obj_f00000006Eh;
				break;
			}
		}
		if (_position.Match(".")) {
		} else {
			_position.Update("“.”", "direct lookup");
			_sequence_fail_f00000005RN = true;
			goto _sequence_end_f00000005RN;
		}
		bool _first_f00000006Ek = true;
		while(true) {
			ParserPosition _many_position_f00000006Ek = _position.Clone();
			var _many_obj_f00000006Ek = _obj.Clone();
			if (!_first_f00000006Ek) {
			if (_position.Match(".")) {
			} else {
				_position.Update("“.”", "direct lookup");
				_position = _many_position_f00000006Ek;
				_obj = _many_obj_f00000006Ek;
				break;
			}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.names, identifier.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000006Ek;
			_obj = _many_obj_f00000006Ek;
			break;
			}
			_first_f00000006Ek = false;
		}
		if (_first_f00000006Ek) {
			_sequence_fail_f00000005RN = true;
			goto _sequence_end_f00000005RN;
		} else {
		}
		_sequence_end_f00000005RN:
		if (_sequence_fail_f00000005RN) {
			_position.Cache<expression_direct_lookup>(_start_index, null);
			_position.TraceExit("expression:direct_lookup", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_direct_lookup>(_start_index, _obj);
			_position.TraceExit("expression:direct_lookup", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_disjunction(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_disjunction, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_disjunction();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:disjunction");

		bool _sequence_fail_f00000005RY = false;
		if (expression.ParseRule_expression5(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005RY = true;
		goto _sequence_end_f00000005RY;
		}
		while(true) {
			ParserPosition _many_position_f00000006F1 = _position.Clone();
			var _many_obj_f00000006F1 = _obj.Clone();
			bool _alternate_success_f00000006f8 = false;
			ParserPosition _alt_position_f00000006f8 = _position;
			var _alt_obj_f00000006f8 = _obj;
			if (!_alternate_success_f00000006f8) {
				_position = _alt_position_f00000006f8.Clone();
				_obj = _alt_obj_f00000006f8.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006f8 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "logical disjunction");
					_position = _alt_position_f00000006f8;
					_obj = _alt_obj_f00000006f8;
				}
			}
			if (!_alternate_success_f00000006f8) {
				_position = _alt_position_f00000006f8.Clone();
				_obj = _alt_obj_f00000006f8.Clone();
				bool _sequence_fail_f0000000750 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "logical disjunction");
					_sequence_fail_f0000000750 = true;
					goto _sequence_end_f0000000750;
				}
				while(true) {
					ParserPosition _many_position_f00000007dn = _position.Clone();
					var _many_obj_f00000007dn = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "logical disjunction");
						_position = _many_position_f00000007dn;
						_obj = _many_obj_f00000007dn;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "logical disjunction");
					_sequence_fail_f0000000750 = true;
					goto _sequence_end_f0000000750;
				}
				_sequence_end_f0000000750:
				if (_sequence_fail_f0000000750) {
					_position = _alt_position_f00000006f8;
					_obj = _alt_obj_f00000006f8;
				} else {
					_alternate_success_f00000006f8 = true;
				}
			}
			if (_alternate_success_f00000006f8) {
			} else {
				_position = _many_position_f00000006F1;
				_obj = _many_obj_f00000006F1;
				break;
			}
		}
		if (_position.Match("||")) {
		} else {
			_position.Update("“||”", "logical disjunction");
			_sequence_fail_f00000005RY = true;
			goto _sequence_end_f00000005RY;
		}
		while(true) {
			ParserPosition _many_position_f00000006F2 = _position.Clone();
			var _many_obj_f00000006F2 = _obj.Clone();
			bool _alternate_success_f00000006f9 = false;
			ParserPosition _alt_position_f00000006f9 = _position;
			var _alt_obj_f00000006f9 = _obj;
			if (!_alternate_success_f00000006f9) {
				_position = _alt_position_f00000006f9.Clone();
				_obj = _alt_obj_f00000006f9.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006f9 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "logical disjunction");
					_position = _alt_position_f00000006f9;
					_obj = _alt_obj_f00000006f9;
				}
			}
			if (!_alternate_success_f00000006f9) {
				_position = _alt_position_f00000006f9.Clone();
				_obj = _alt_obj_f00000006f9.Clone();
				bool _sequence_fail_f0000000754 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "logical disjunction");
					_sequence_fail_f0000000754 = true;
					goto _sequence_end_f0000000754;
				}
				while(true) {
					ParserPosition _many_position_f00000007dt = _position.Clone();
					var _many_obj_f00000007dt = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "logical disjunction");
						_position = _many_position_f00000007dt;
						_obj = _many_obj_f00000007dt;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "logical disjunction");
					_sequence_fail_f0000000754 = true;
					goto _sequence_end_f0000000754;
				}
				_sequence_end_f0000000754:
				if (_sequence_fail_f0000000754) {
					_position = _alt_position_f00000006f9;
					_obj = _alt_obj_f00000006f9;
				} else {
					_alternate_success_f00000006f9 = true;
				}
			}
			if (_alternate_success_f00000006f9) {
			} else {
				_position = _many_position_f00000006F2;
				_obj = _many_obj_f00000006F2;
				break;
			}
		}
		if (expression.ParseRule_expression4(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005RY = true;
		goto _sequence_end_f00000005RY;
		}
		_sequence_end_f00000005RY:
		if (_sequence_fail_f00000005RY) {
			_position.Cache<expression_disjunction>(_start_index, null);
			_position.TraceExit("expression:disjunction", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_disjunction>(_start_index, _obj);
			_position.TraceExit("expression:disjunction", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_enforce(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_enforce, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_enforce();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:enforce");

		bool _sequence_fail_f00000005Ri = false;
		if (expression.ParseRule_expression15(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Ri = true;
		goto _sequence_end_f00000005Ri;
		}
		while(true) {
			ParserPosition _many_position_f00000006FJ = _position.Clone();
			var _many_obj_f00000006FJ = _obj.Clone();
			bool _alternate_success_f00000006fD = false;
			ParserPosition _alt_position_f00000006fD = _position;
			var _alt_obj_f00000006fD = _obj;
			if (!_alternate_success_f00000006fD) {
				_position = _alt_position_f00000006fD.Clone();
				_obj = _alt_obj_f00000006fD.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fD = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "type enforcement");
					_position = _alt_position_f00000006fD;
					_obj = _alt_obj_f00000006fD;
				}
			}
			if (!_alternate_success_f00000006fD) {
				_position = _alt_position_f00000006fD.Clone();
				_obj = _alt_obj_f00000006fD.Clone();
				bool _sequence_fail_f000000075E = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "type enforcement");
					_sequence_fail_f000000075E = true;
					goto _sequence_end_f000000075E;
				}
				while(true) {
					ParserPosition _many_position_f00000007e1 = _position.Clone();
					var _many_obj_f00000007e1 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "type enforcement");
						_position = _many_position_f00000007e1;
						_obj = _many_obj_f00000007e1;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "type enforcement");
					_sequence_fail_f000000075E = true;
					goto _sequence_end_f000000075E;
				}
				_sequence_end_f000000075E:
				if (_sequence_fail_f000000075E) {
					_position = _alt_position_f00000006fD;
					_obj = _alt_obj_f00000006fD;
				} else {
					_alternate_success_f00000006fD = true;
				}
			}
			if (_alternate_success_f00000006fD) {
			} else {
				_position = _many_position_f00000006FJ;
				_obj = _many_obj_f00000006FJ;
				break;
			}
		}
		if (_position.Match("Enforce")) {
		} else {
			_position.Update("“Enforce”", "type enforcement");
			_sequence_fail_f00000005Ri = true;
			goto _sequence_end_f00000005Ri;
		}
		while(true) {
			ParserPosition _many_position_f00000006FK = _position.Clone();
			var _many_obj_f00000006FK = _obj.Clone();
			bool _alternate_success_f00000006fE = false;
			ParserPosition _alt_position_f00000006fE = _position;
			var _alt_obj_f00000006fE = _obj;
			if (!_alternate_success_f00000006fE) {
				_position = _alt_position_f00000006fE.Clone();
				_obj = _alt_obj_f00000006fE.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fE = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "type enforcement");
					_position = _alt_position_f00000006fE;
					_obj = _alt_obj_f00000006fE;
				}
			}
			if (!_alternate_success_f00000006fE) {
				_position = _alt_position_f00000006fE.Clone();
				_obj = _alt_obj_f00000006fE.Clone();
				bool _sequence_fail_f000000075I = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "type enforcement");
					_sequence_fail_f000000075I = true;
					goto _sequence_end_f000000075I;
				}
				while(true) {
					ParserPosition _many_position_f00000007e7 = _position.Clone();
					var _many_obj_f00000007e7 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "type enforcement");
						_position = _many_position_f00000007e7;
						_obj = _many_obj_f00000007e7;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "type enforcement");
					_sequence_fail_f000000075I = true;
					goto _sequence_end_f000000075I;
				}
				_sequence_end_f000000075I:
				if (_sequence_fail_f000000075I) {
					_position = _alt_position_f00000006fE;
					_obj = _alt_obj_f00000006fE;
				} else {
					_alternate_success_f00000006fE = true;
				}
			}
			if (_alternate_success_f00000006fE) {
			} else {
				_position = _many_position_f00000006FK;
				_obj = _many_obj_f00000006FK;
				break;
			}
		}
		if (type_name.ParseRule_Base(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Ri = true;
		goto _sequence_end_f00000005Ri;
		}
		_sequence_end_f00000005Ri:
		if (_sequence_fail_f00000005Ri) {
			_position.Cache<expression_enforce>(_start_index, null);
			_position.TraceExit("expression:enforce", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_enforce>(_start_index, _obj);
			_position.TraceExit("expression:enforce", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_equality(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_equality, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_equality();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:equality");

		bool _sequence_fail_f00000005Rs = false;
		if (expression.ParseRule_expression7(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Rs = true;
		goto _sequence_end_f00000005Rs;
		}
		while(true) {
			ParserPosition _many_position_f00000006FV = _position.Clone();
			var _many_obj_f00000006FV = _obj.Clone();
			bool _alternate_success_f00000006fI = false;
			ParserPosition _alt_position_f00000006fI = _position;
			var _alt_obj_f00000006fI = _obj;
			if (!_alternate_success_f00000006fI) {
				_position = _alt_position_f00000006fI.Clone();
				_obj = _alt_obj_f00000006fI.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fI = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "equality comparison");
					_position = _alt_position_f00000006fI;
					_obj = _alt_obj_f00000006fI;
				}
			}
			if (!_alternate_success_f00000006fI) {
				_position = _alt_position_f00000006fI.Clone();
				_obj = _alt_obj_f00000006fI.Clone();
				bool _sequence_fail_f000000075S = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "equality comparison");
					_sequence_fail_f000000075S = true;
					goto _sequence_end_f000000075S;
				}
				while(true) {
					ParserPosition _many_position_f00000007eD = _position.Clone();
					var _many_obj_f00000007eD = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "equality comparison");
						_position = _many_position_f00000007eD;
						_obj = _many_obj_f00000007eD;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "equality comparison");
					_sequence_fail_f000000075S = true;
					goto _sequence_end_f000000075S;
				}
				_sequence_end_f000000075S:
				if (_sequence_fail_f000000075S) {
					_position = _alt_position_f00000006fI;
					_obj = _alt_obj_f00000006fI;
				} else {
					_alternate_success_f00000006fI = true;
				}
			}
			if (_alternate_success_f00000006fI) {
			} else {
				_position = _many_position_f00000006FV;
				_obj = _many_obj_f00000006FV;
				break;
			}
		}
		if (_position.Match("==")) {
		} else {
			_position.Update("“==”", "equality comparison");
			_sequence_fail_f00000005Rs = true;
			goto _sequence_end_f00000005Rs;
		}
		while(true) {
			ParserPosition _many_position_f00000006FW = _position.Clone();
			var _many_obj_f00000006FW = _obj.Clone();
			bool _alternate_success_f00000006fJ = false;
			ParserPosition _alt_position_f00000006fJ = _position;
			var _alt_obj_f00000006fJ = _obj;
			if (!_alternate_success_f00000006fJ) {
				_position = _alt_position_f00000006fJ.Clone();
				_obj = _alt_obj_f00000006fJ.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fJ = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "equality comparison");
					_position = _alt_position_f00000006fJ;
					_obj = _alt_obj_f00000006fJ;
				}
			}
			if (!_alternate_success_f00000006fJ) {
				_position = _alt_position_f00000006fJ.Clone();
				_obj = _alt_obj_f00000006fJ.Clone();
				bool _sequence_fail_f000000075W = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "equality comparison");
					_sequence_fail_f000000075W = true;
					goto _sequence_end_f000000075W;
				}
				while(true) {
					ParserPosition _many_position_f00000007eJ = _position.Clone();
					var _many_obj_f00000007eJ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "equality comparison");
						_position = _many_position_f00000007eJ;
						_obj = _many_obj_f00000007eJ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "equality comparison");
					_sequence_fail_f000000075W = true;
					goto _sequence_end_f000000075W;
				}
				_sequence_end_f000000075W:
				if (_sequence_fail_f000000075W) {
					_position = _alt_position_f00000006fJ;
					_obj = _alt_obj_f00000006fJ;
				} else {
					_alternate_success_f00000006fJ = true;
				}
			}
			if (_alternate_success_f00000006fJ) {
			} else {
				_position = _many_position_f00000006FW;
				_obj = _many_obj_f00000006FW;
				break;
			}
		}
		if (expression.ParseRule_expression7(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Rs = true;
		goto _sequence_end_f00000005Rs;
		}
		_sequence_end_f00000005Rs:
		if (_sequence_fail_f00000005Rs) {
			_position.Cache<expression_equality>(_start_index, null);
			_position.TraceExit("expression:equality", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_equality>(_start_index, _obj);
			_position.TraceExit("expression:equality", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_error(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_error, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_error();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:error");

		bool _sequence_fail_f00000005S2 = false;
		if (_position.Match("Error")) {
		} else {
			_position.Update("“Error”", "raise error");
			_sequence_fail_f00000005S2 = true;
			goto _sequence_end_f00000005S2;
		}
		while(true) {
			ParserPosition _many_position_f00000006Ff = _position.Clone();
			var _many_obj_f00000006Ff = _obj.Clone();
			bool _alternate_success_f00000006fP = false;
			ParserPosition _alt_position_f00000006fP = _position;
			var _alt_obj_f00000006fP = _obj;
			if (!_alternate_success_f00000006fP) {
				_position = _alt_position_f00000006fP.Clone();
				_obj = _alt_obj_f00000006fP.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fP = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "raise error");
					_position = _alt_position_f00000006fP;
					_obj = _alt_obj_f00000006fP;
				}
			}
			if (!_alternate_success_f00000006fP) {
				_position = _alt_position_f00000006fP.Clone();
				_obj = _alt_obj_f00000006fP.Clone();
				bool _sequence_fail_f000000075f = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "raise error");
					_sequence_fail_f000000075f = true;
					goto _sequence_end_f000000075f;
				}
				while(true) {
					ParserPosition _many_position_f00000007eQ = _position.Clone();
					var _many_obj_f00000007eQ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "raise error");
						_position = _many_position_f00000007eQ;
						_obj = _many_obj_f00000007eQ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "raise error");
					_sequence_fail_f000000075f = true;
					goto _sequence_end_f000000075f;
				}
				_sequence_end_f000000075f:
				if (_sequence_fail_f000000075f) {
					_position = _alt_position_f00000006fP;
					_obj = _alt_obj_f00000006fP;
				} else {
					_alternate_success_f00000006fP = true;
				}
			}
			if (_alternate_success_f00000006fP) {
			} else {
				_position = _many_position_f00000006Ff;
				_obj = _many_obj_f00000006Ff;
				break;
			}
		}
		if (expression.ParseRule_expression16(ref _position, out _obj.expr)) {
		} else {
		_sequence_fail_f00000005S2 = true;
		goto _sequence_end_f00000005S2;
		}
		_sequence_end_f00000005S2:
		if (_sequence_fail_f00000005S2) {
			_position.Cache<expression_error>(_start_index, null);
			_position.TraceExit("expression:error", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_error>(_start_index, _obj);
			_position.TraceExit("expression:error", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_false(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_false, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_false();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:false");

		if (_position.Match("False")) {
			_position.Cache<expression_false>(_start_index, _obj);
			_position.TraceExit("expression:false", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		} else {
			_position.Update("“False”", "logical false");
			_position.Cache<expression_false>(_start_index, null);
			_position.TraceExit("expression:false", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_float_literal(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_float_literal, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_float_literal();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:float_literal");
RevCons<char> _float_acc_f00000005SC = null;
		bool _sequence_fail_f00000005mZ = false;
		bool _alternate_success_f00000006Fq = false;
		ParserPosition _alt_position_f00000006Fq = _position;
		var _alt_obj_f00000006Fq = _obj;
		if (!_alternate_success_f00000006Fq) {
			_position = _alt_position_f00000006Fq.Clone();
			_obj = _alt_obj_f00000006Fq.Clone();
			if (_position.Match("0")) {
				_alternate_success_f00000006Fq = true;
			} else {
				_position.Update("“0”", "floating-point value");
				_position = _alt_position_f00000006Fq;
				_obj = _alt_obj_f00000006Fq;
			}
		}
		if (!_alternate_success_f00000006Fq) {
			_position = _alt_position_f00000006Fq.Clone();
			_obj = _alt_obj_f00000006Fq.Clone();
			bool _sequence_fail_f00000006fT = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_float_acc_f00000005SC = new RevCons<char>(_position.PeekLast(), _float_acc_f00000005SC);
			} else {
				_position.Update("character between “1” and “9”", "floating-point value");
				_sequence_fail_f00000006fT = true;
				goto _sequence_end_f00000006fT;
			}
			while(true) {
				ParserPosition _many_position_f000000075j = _position.Clone();
				var _many_obj_f000000075j = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_float_acc_f00000005SC = new RevCons<char>(_position.PeekLast(), _float_acc_f00000005SC);
				} else {
					_position.Update("character between “0” and “9”", "floating-point value");
					_position = _many_position_f000000075j;
					_obj = _many_obj_f000000075j;
					break;
				}
			}
			_sequence_end_f00000006fT:
			if (_sequence_fail_f00000006fT) {
				_position = _alt_position_f00000006Fq;
				_obj = _alt_obj_f00000006Fq;
			} else {
				_alternate_success_f00000006Fq = true;
			}
		}
		if (_alternate_success_f00000006Fq) {
		} else {
			_sequence_fail_f00000005mZ = true;
			goto _sequence_end_f00000005mZ;
		}
		if (".".IndexOf(_position.Next()) != -1) {
			_float_acc_f00000005SC = new RevCons<char>(_position.PeekLast(), _float_acc_f00000005SC);
		} else {
			_position.Update(Parser.ToLiteral("."), "floating-point value");
			_sequence_fail_f00000005mZ = true;
			goto _sequence_end_f00000005mZ;
		}
		while(true) {
			ParserPosition _many_position_f00000006Fs = _position.Clone();
			var _many_obj_f00000006Fs = _obj.Clone();
			if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
			_float_acc_f00000005SC = new RevCons<char>(_position.PeekLast(), _float_acc_f00000005SC);
			} else {
				_position.Update("character between “0” and “9”", "floating-point value");
				_position = _many_position_f00000006Fs;
				_obj = _many_obj_f00000006Fs;
				break;
			}
		}
		var _optional_obj_f00000006Ft = _obj.Clone();
		ParserPosition _optional_position_f00000006Ft = _position.Clone();
		bool _sequence_fail_f00000006fV = false;
		if ("eE".IndexOf(_position.Next()) != -1) {
			_float_acc_f00000005SC = new RevCons<char>(_position.PeekLast(), _float_acc_f00000005SC);
		} else {
			_position.Update(Parser.ToLiteral("eE"), "floating-point value");
			_sequence_fail_f00000006fV = true;
			goto _sequence_end_f00000006fV;
		}
		var _optional_obj_f000000075q = _obj.Clone();
		ParserPosition _optional_position_f000000075q = _position.Clone();
		if ("-".IndexOf(_position.Next()) != -1) {
			_float_acc_f00000005SC = new RevCons<char>(_position.PeekLast(), _float_acc_f00000005SC);
			goto optional_exit_f000000075q;
		} else {
			_position.Update(Parser.ToLiteral("-"), "floating-point value");
			_obj = _optional_obj_f000000075q;
			_position = _optional_position_f000000075q;
			goto optional_exit_f000000075q;
		}
		optional_exit_f000000075q:
		bool _alternate_success_f000000075r = false;
		ParserPosition _alt_position_f000000075r = _position;
		var _alt_obj_f000000075r = _obj;
		if (!_alternate_success_f000000075r) {
			_position = _alt_position_f000000075r.Clone();
			_obj = _alt_obj_f000000075r.Clone();
			if (_position.Match("0")) {
				_alternate_success_f000000075r = true;
			} else {
				_position.Update("“0”", "floating-point value");
				_position = _alt_position_f000000075r;
				_obj = _alt_obj_f000000075r;
			}
		}
		if (!_alternate_success_f000000075r) {
			_position = _alt_position_f000000075r.Clone();
			_obj = _alt_obj_f000000075r.Clone();
			bool _sequence_fail_f00000007ed = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_float_acc_f00000005SC = new RevCons<char>(_position.PeekLast(), _float_acc_f00000005SC);
			} else {
				_position.Update("character between “1” and “9”", "floating-point value");
				_sequence_fail_f00000007ed = true;
				goto _sequence_end_f00000007ed;
			}
			while(true) {
				ParserPosition _many_position_f00000008Fp = _position.Clone();
				var _many_obj_f00000008Fp = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_float_acc_f00000005SC = new RevCons<char>(_position.PeekLast(), _float_acc_f00000005SC);
				} else {
					_position.Update("character between “0” and “9”", "floating-point value");
					_position = _many_position_f00000008Fp;
					_obj = _many_obj_f00000008Fp;
					break;
				}
			}
			_sequence_end_f00000007ed:
			if (_sequence_fail_f00000007ed) {
				_position = _alt_position_f000000075r;
				_obj = _alt_obj_f000000075r;
			} else {
				_alternate_success_f000000075r = true;
			}
		}
		if (_alternate_success_f000000075r) {
		} else {
			_sequence_fail_f00000006fV = true;
			goto _sequence_end_f00000006fV;
		}
		_sequence_end_f00000006fV:
		if (_sequence_fail_f00000006fV) {
			_obj = _optional_obj_f00000006Ft;
			_position = _optional_position_f00000006Ft;
			goto optional_exit_f00000006Ft;
		} else {
			goto optional_exit_f00000006Ft;
		}
		optional_exit_f00000006Ft:
		_sequence_end_f00000005mZ:
		if (_sequence_fail_f00000005mZ) {
				_position.Cache<expression_float_literal>(_start_index, null);
				_position.TraceExit("expression:float_literal", false);
				_result = null;
				return false;
		} else {
			if (System.Double.TryParse(Generator.ToString(_float_acc_f00000005SC), out _obj.value)) {
				_position.Cache<expression_float_literal>(_start_index, _obj);
				_position.TraceExit("expression:float_literal", true);
				_obj.EndRow = _position.Row;
				_obj.EndColumn = _position.Column;
				_result = (expression)_obj;
				return true;
			} else {
				_position.Cache<expression_float_literal>(_start_index, null);
				_position.TraceExit("expression:float_literal", false);
				_result = null;
				return false;
			}
		}
	}
	internal static bool ParseRule_float_max(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_float_max, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_float_max();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:float_max");

		if (_position.Match("FloatMax")) {
			_position.Cache<expression_float_max>(_start_index, _obj);
			_position.TraceExit("expression:float_max", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		} else {
			_position.Update("“FloatMax”", "largest floating-point value");
			_position.Cache<expression_float_max>(_start_index, null);
			_position.TraceExit("expression:float_max", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_float_min(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_float_min, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_float_min();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:float_min");

		if (_position.Match("FloatMin")) {
			_position.Cache<expression_float_min>(_start_index, _obj);
			_position.TraceExit("expression:float_min", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		} else {
			_position.Update("“FloatMin”", "smallest floating-point value");
			_position.Cache<expression_float_min>(_start_index, null);
			_position.TraceExit("expression:float_min", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_for_reduce(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_for_reduce, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_for_reduce();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:for_reduce");

		bool _sequence_fail_f00000005SX = false;
		if (_position.Match("For")) {
		} else {
			_position.Update("“For”", "fricassée Reduce");
			_sequence_fail_f00000005SX = true;
			goto _sequence_end_f00000005SX;
		}
		if (selector.ParseRule_selector0(ref _position, out _obj.selector)) {
		} else {
		_sequence_fail_f00000005SX = true;
		goto _sequence_end_f00000005SX;
		}
		if (_position.Match("Reduce")) {
		} else {
			_position.Update("“Reduce”", "fricassée Reduce");
			_sequence_fail_f00000005SX = true;
			goto _sequence_end_f00000005SX;
		}
		bool _first_f00000006GF = true;
		while(true) {
			ParserPosition _many_position_f00000006GF = _position.Clone();
			var _many_obj_f00000006GF = _obj.Clone();
			bool _alternate_success_f00000006fe = false;
			ParserPosition _alt_position_f00000006fe = _position;
			var _alt_obj_f00000006fe = _obj;
			if (!_alternate_success_f00000006fe) {
				_position = _alt_position_f00000006fe.Clone();
				_obj = _alt_obj_f00000006fe.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fe = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Reduce");
					_position = _alt_position_f00000006fe;
					_obj = _alt_obj_f00000006fe;
				}
			}
			if (!_alternate_success_f00000006fe) {
				_position = _alt_position_f00000006fe.Clone();
				_obj = _alt_obj_f00000006fe.Clone();
				bool _sequence_fail_f000000075y = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Reduce");
					_sequence_fail_f000000075y = true;
					goto _sequence_end_f000000075y;
				}
				while(true) {
					ParserPosition _many_position_f00000007er = _position.Clone();
					var _many_obj_f00000007er = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Reduce");
						_position = _many_position_f00000007er;
						_obj = _many_obj_f00000007er;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Reduce");
					_sequence_fail_f000000075y = true;
					goto _sequence_end_f000000075y;
				}
				_sequence_end_f000000075y:
				if (_sequence_fail_f000000075y) {
					_position = _alt_position_f00000006fe;
					_obj = _alt_obj_f00000006fe;
				} else {
					_alternate_success_f00000006fe = true;
				}
			}
			if (_alternate_success_f00000006fe) {
			} else {
				_position = _many_position_f00000006GF;
				_obj = _many_obj_f00000006GF;
				break;
			}
			_first_f00000006GF = false;
		}
		if (_first_f00000006GF) {
			_sequence_fail_f00000005SX = true;
			goto _sequence_end_f00000005SX;
		} else {
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.reduce_expr)) {
		} else {
		_sequence_fail_f00000005SX = true;
		goto _sequence_end_f00000005SX;
		}
		bool _first_f00000006GJ = true;
		while(true) {
			ParserPosition _many_position_f00000006GJ = _position.Clone();
			var _many_obj_f00000006GJ = _obj.Clone();
			bool _alternate_success_f00000006ff = false;
			ParserPosition _alt_position_f00000006ff = _position;
			var _alt_obj_f00000006ff = _obj;
			if (!_alternate_success_f00000006ff) {
				_position = _alt_position_f00000006ff.Clone();
				_obj = _alt_obj_f00000006ff.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ff = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Reduce");
					_position = _alt_position_f00000006ff;
					_obj = _alt_obj_f00000006ff;
				}
			}
			if (!_alternate_success_f00000006ff) {
				_position = _alt_position_f00000006ff.Clone();
				_obj = _alt_obj_f00000006ff.Clone();
				bool _sequence_fail_f0000000761 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Reduce");
					_sequence_fail_f0000000761 = true;
					goto _sequence_end_f0000000761;
				}
				while(true) {
					ParserPosition _many_position_f00000007ex = _position.Clone();
					var _many_obj_f00000007ex = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Reduce");
						_position = _many_position_f00000007ex;
						_obj = _many_obj_f00000007ex;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Reduce");
					_sequence_fail_f0000000761 = true;
					goto _sequence_end_f0000000761;
				}
				_sequence_end_f0000000761:
				if (_sequence_fail_f0000000761) {
					_position = _alt_position_f00000006ff;
					_obj = _alt_obj_f00000006ff;
				} else {
					_alternate_success_f00000006ff = true;
				}
			}
			if (_alternate_success_f00000006ff) {
			} else {
				_position = _many_position_f00000006GJ;
				_obj = _many_obj_f00000006GJ;
				break;
			}
			_first_f00000006GJ = false;
		}
		if (_first_f00000006GJ) {
			_sequence_fail_f00000005SX = true;
			goto _sequence_end_f00000005SX;
		} else {
		}
		if (_position.Match("With")) {
		} else {
			_position.Update("“With”", "fricassée Reduce");
			_sequence_fail_f00000005SX = true;
			goto _sequence_end_f00000005SX;
		}
		bool _first_f00000006GL = true;
		while(true) {
			ParserPosition _many_position_f00000006GL = _position.Clone();
			var _many_obj_f00000006GL = _obj.Clone();
			bool _alternate_success_f00000006fg = false;
			ParserPosition _alt_position_f00000006fg = _position;
			var _alt_obj_f00000006fg = _obj;
			if (!_alternate_success_f00000006fg) {
				_position = _alt_position_f00000006fg.Clone();
				_obj = _alt_obj_f00000006fg.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fg = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Reduce");
					_position = _alt_position_f00000006fg;
					_obj = _alt_obj_f00000006fg;
				}
			}
			if (!_alternate_success_f00000006fg) {
				_position = _alt_position_f00000006fg.Clone();
				_obj = _alt_obj_f00000006fg.Clone();
				bool _sequence_fail_f0000000764 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Reduce");
					_sequence_fail_f0000000764 = true;
					goto _sequence_end_f0000000764;
				}
				while(true) {
					ParserPosition _many_position_f00000007f3 = _position.Clone();
					var _many_obj_f00000007f3 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Reduce");
						_position = _many_position_f00000007f3;
						_obj = _many_obj_f00000007f3;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Reduce");
					_sequence_fail_f0000000764 = true;
					goto _sequence_end_f0000000764;
				}
				_sequence_end_f0000000764:
				if (_sequence_fail_f0000000764) {
					_position = _alt_position_f00000006fg;
					_obj = _alt_obj_f00000006fg;
				} else {
					_alternate_success_f00000006fg = true;
				}
			}
			if (_alternate_success_f00000006fg) {
			} else {
				_position = _many_position_f00000006GL;
				_obj = _many_obj_f00000006GL;
				break;
			}
			_first_f00000006GL = false;
		}
		if (_first_f00000006GL) {
			_sequence_fail_f00000005SX = true;
			goto _sequence_end_f00000005SX;
		} else {
		}
		bool _sequence_fail_f00000006GM = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.initial_name = new RevCons<char>(_position.PeekLast(), _obj.initial_name);
		} else {
			_position.Update("character between “a” and “z”", "fricassée Reduce");
			_sequence_fail_f00000006GM = true;
			goto _sequence_end_f00000006GM;
		}
		while(true) {
			ParserPosition _many_position_f00000006fj = _position.Clone();
			var _many_obj_f00000006fj = _obj.Clone();
			bool _alternate_success_f0000000767 = false;
			ParserPosition _alt_position_f0000000767 = _position;
			var _alt_obj_f0000000767 = _obj;
			if (!_alternate_success_f0000000767) {
				_position = _alt_position_f0000000767.Clone();
				_obj = _alt_obj_f0000000767.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.initial_name = new RevCons<char>(_position.PeekLast(), _obj.initial_name);
					_alternate_success_f0000000767 = true;
				} else {
					_position.Update("character between “a” and “z”", "fricassée Reduce");
					_position = _alt_position_f0000000767;
					_obj = _alt_obj_f0000000767;
				}
			}
			if (!_alternate_success_f0000000767) {
				_position = _alt_position_f0000000767.Clone();
				_obj = _alt_obj_f0000000767.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.initial_name = new RevCons<char>(_position.PeekLast(), _obj.initial_name);
					_alternate_success_f0000000767 = true;
				} else {
					_position.Update("character between “A” and “Z”", "fricassée Reduce");
					_position = _alt_position_f0000000767;
					_obj = _alt_obj_f0000000767;
				}
			}
			if (!_alternate_success_f0000000767) {
				_position = _alt_position_f0000000767.Clone();
				_obj = _alt_obj_f0000000767.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.initial_name = new RevCons<char>(_position.PeekLast(), _obj.initial_name);
					_alternate_success_f0000000767 = true;
				} else {
					_position.Update("character between “0” and “9”", "fricassée Reduce");
					_position = _alt_position_f0000000767;
					_obj = _alt_obj_f0000000767;
				}
			}
			if (!_alternate_success_f0000000767) {
				_position = _alt_position_f0000000767.Clone();
				_obj = _alt_obj_f0000000767.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.initial_name = new RevCons<char>(_position.PeekLast(), _obj.initial_name);
					_alternate_success_f0000000767 = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "fricassée Reduce");
					_position = _alt_position_f0000000767;
					_obj = _alt_obj_f0000000767;
				}
			}
			if (_alternate_success_f0000000767) {
			} else {
				_position = _many_position_f00000006fj;
				_obj = _many_obj_f00000006fj;
				break;
			}
		}
		_sequence_end_f00000006GM:
		if (_sequence_fail_f00000006GM) {
			_sequence_fail_f00000005SX = true;
			goto _sequence_end_f00000005SX;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f00000006GN = _position.Clone();
			var _many_obj_f00000006GN = _obj.Clone();
			bool _alternate_success_f00000006fk = false;
			ParserPosition _alt_position_f00000006fk = _position;
			var _alt_obj_f00000006fk = _obj;
			if (!_alternate_success_f00000006fk) {
				_position = _alt_position_f00000006fk.Clone();
				_obj = _alt_obj_f00000006fk.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fk = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Reduce");
					_position = _alt_position_f00000006fk;
					_obj = _alt_obj_f00000006fk;
				}
			}
			if (!_alternate_success_f00000006fk) {
				_position = _alt_position_f00000006fk.Clone();
				_obj = _alt_obj_f00000006fk.Clone();
				bool _sequence_fail_f000000076D = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Reduce");
					_sequence_fail_f000000076D = true;
					goto _sequence_end_f000000076D;
				}
				while(true) {
					ParserPosition _many_position_f00000007fE = _position.Clone();
					var _many_obj_f00000007fE = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Reduce");
						_position = _many_position_f00000007fE;
						_obj = _many_obj_f00000007fE;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Reduce");
					_sequence_fail_f000000076D = true;
					goto _sequence_end_f000000076D;
				}
				_sequence_end_f000000076D:
				if (_sequence_fail_f000000076D) {
					_position = _alt_position_f00000006fk;
					_obj = _alt_obj_f00000006fk;
				} else {
					_alternate_success_f00000006fk = true;
				}
			}
			if (_alternate_success_f00000006fk) {
			} else {
				_position = _many_position_f00000006GN;
				_obj = _many_obj_f00000006GN;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "fricassée Reduce");
			_sequence_fail_f00000005SX = true;
			goto _sequence_end_f00000005SX;
		}
		while(true) {
			ParserPosition _many_position_f00000006GP = _position.Clone();
			var _many_obj_f00000006GP = _obj.Clone();
			bool _alternate_success_f00000006fl = false;
			ParserPosition _alt_position_f00000006fl = _position;
			var _alt_obj_f00000006fl = _obj;
			if (!_alternate_success_f00000006fl) {
				_position = _alt_position_f00000006fl.Clone();
				_obj = _alt_obj_f00000006fl.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fl = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Reduce");
					_position = _alt_position_f00000006fl;
					_obj = _alt_obj_f00000006fl;
				}
			}
			if (!_alternate_success_f00000006fl) {
				_position = _alt_position_f00000006fl.Clone();
				_obj = _alt_obj_f00000006fl.Clone();
				bool _sequence_fail_f000000076G = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Reduce");
					_sequence_fail_f000000076G = true;
					goto _sequence_end_f000000076G;
				}
				while(true) {
					ParserPosition _many_position_f00000007fK = _position.Clone();
					var _many_obj_f00000007fK = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Reduce");
						_position = _many_position_f00000007fK;
						_obj = _many_obj_f00000007fK;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Reduce");
					_sequence_fail_f000000076G = true;
					goto _sequence_end_f000000076G;
				}
				_sequence_end_f000000076G:
				if (_sequence_fail_f000000076G) {
					_position = _alt_position_f00000006fl;
					_obj = _alt_obj_f00000006fl;
				} else {
					_alternate_success_f00000006fl = true;
				}
			}
			if (_alternate_success_f00000006fl) {
			} else {
				_position = _many_position_f00000006GP;
				_obj = _many_obj_f00000006GP;
				break;
			}
		}
		if (expression.ParseRule_expression2(ref _position, out _obj.initial_expr)) {
		} else {
		_sequence_fail_f00000005SX = true;
		goto _sequence_end_f00000005SX;
		}
		_sequence_end_f00000005SX:
		if (_sequence_fail_f00000005SX) {
			_position.Cache<expression_for_reduce>(_start_index, null);
			_position.TraceExit("expression:for_reduce", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_for_reduce>(_start_index, _obj);
			_position.TraceExit("expression:for_reduce", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_for_select_anonymous(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_for_select_anonymous, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_for_select_anonymous();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:for_select_anonymous");

		bool _sequence_fail_f00000005Sh = false;
		if (_position.Match("For")) {
		} else {
			_position.Update("“For”", "fricassée Select");
			_sequence_fail_f00000005Sh = true;
			goto _sequence_end_f00000005Sh;
		}
		if (selector.ParseRule_selector0(ref _position, out _obj.selector)) {
		} else {
		_sequence_fail_f00000005Sh = true;
		goto _sequence_end_f00000005Sh;
		}
		if (_position.Match("Select")) {
		} else {
			_position.Update("“Select”", "fricassée Select");
			_sequence_fail_f00000005Sh = true;
			goto _sequence_end_f00000005Sh;
		}
		while(true) {
			ParserPosition _many_position_f00000006Gg = _position.Clone();
			var _many_obj_f00000006Gg = _obj.Clone();
			bool _alternate_success_f00000006fq = false;
			ParserPosition _alt_position_f00000006fq = _position;
			var _alt_obj_f00000006fq = _obj;
			if (!_alternate_success_f00000006fq) {
				_position = _alt_position_f00000006fq.Clone();
				_obj = _alt_obj_f00000006fq.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fq = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Select");
					_position = _alt_position_f00000006fq;
					_obj = _alt_obj_f00000006fq;
				}
			}
			if (!_alternate_success_f00000006fq) {
				_position = _alt_position_f00000006fq.Clone();
				_obj = _alt_obj_f00000006fq.Clone();
				bool _sequence_fail_f000000076S = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Select");
					_sequence_fail_f000000076S = true;
					goto _sequence_end_f000000076S;
				}
				while(true) {
					ParserPosition _many_position_f00000007fX = _position.Clone();
					var _many_obj_f00000007fX = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Select");
						_position = _many_position_f00000007fX;
						_obj = _many_obj_f00000007fX;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Select");
					_sequence_fail_f000000076S = true;
					goto _sequence_end_f000000076S;
				}
				_sequence_end_f000000076S:
				if (_sequence_fail_f000000076S) {
					_position = _alt_position_f00000006fq;
					_obj = _alt_obj_f00000006fq;
				} else {
					_alternate_success_f00000006fq = true;
				}
			}
			if (_alternate_success_f00000006fq) {
			} else {
				_position = _many_position_f00000006Gg;
				_obj = _many_obj_f00000006Gg;
				break;
			}
		}
		if (expression.ParseRule_expression2(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000005Sh = true;
		goto _sequence_end_f00000005Sh;
		}
		while(true) {
			ParserPosition _many_position_f00000006Gk = _position.Clone();
			var _many_obj_f00000006Gk = _obj.Clone();
			bool _alternate_success_f00000006fr = false;
			ParserPosition _alt_position_f00000006fr = _position;
			var _alt_obj_f00000006fr = _obj;
			if (!_alternate_success_f00000006fr) {
				_position = _alt_position_f00000006fr.Clone();
				_obj = _alt_obj_f00000006fr.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fr = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Select");
					_position = _alt_position_f00000006fr;
					_obj = _alt_obj_f00000006fr;
				}
			}
			if (!_alternate_success_f00000006fr) {
				_position = _alt_position_f00000006fr.Clone();
				_obj = _alt_obj_f00000006fr.Clone();
				bool _sequence_fail_f000000076V = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Select");
					_sequence_fail_f000000076V = true;
					goto _sequence_end_f000000076V;
				}
				while(true) {
					ParserPosition _many_position_f00000007fd = _position.Clone();
					var _many_obj_f00000007fd = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Select");
						_position = _many_position_f00000007fd;
						_obj = _many_obj_f00000007fd;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Select");
					_sequence_fail_f000000076V = true;
					goto _sequence_end_f000000076V;
				}
				_sequence_end_f000000076V:
				if (_sequence_fail_f000000076V) {
					_position = _alt_position_f00000006fr;
					_obj = _alt_obj_f00000006fr;
				} else {
					_alternate_success_f00000006fr = true;
				}
			}
			if (_alternate_success_f00000006fr) {
			} else {
				_position = _many_position_f00000006Gk;
				_obj = _many_obj_f00000006Gk;
				break;
			}
		}
		if (_position.Index >= _position.Parser.Input.Length || ":".IndexOf(_position.Parser.Input[_position.Index]) == -1) {
		} else {
			_position.Update("anything except " + Parser.ToLiteral(":"), "fricassée Select");
			_sequence_fail_f00000005Sh = true;
			goto _sequence_end_f00000005Sh;
		}
		_sequence_end_f00000005Sh:
		if (_sequence_fail_f00000005Sh) {
			_position.Cache<expression_for_select_anonymous>(_start_index, null);
			_position.TraceExit("expression:for_select_anonymous", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_for_select_anonymous>(_start_index, _obj);
			_position.TraceExit("expression:for_select_anonymous", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_for_select_named(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_for_select_named, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_for_select_named();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:for_select_named");

		bool _sequence_fail_f00000005Sr = false;
		if (_position.Match("For")) {
		} else {
			_position.Update("“For”", "fricassée Select with attribute names");
			_sequence_fail_f00000005Sr = true;
			goto _sequence_end_f00000005Sr;
		}
		if (selector.ParseRule_selector1(ref _position, out _obj.selector)) {
		} else {
		_sequence_fail_f00000005Sr = true;
		goto _sequence_end_f00000005Sr;
		}
		if (_position.Match("Select")) {
		} else {
			_position.Update("“Select”", "fricassée Select with attribute names");
			_sequence_fail_f00000005Sr = true;
			goto _sequence_end_f00000005Sr;
		}
		while(true) {
			ParserPosition _many_position_f00000006Gz = _position.Clone();
			var _many_obj_f00000006Gz = _obj.Clone();
			bool _alternate_success_f00000006fw = false;
			ParserPosition _alt_position_f00000006fw = _position;
			var _alt_obj_f00000006fw = _obj;
			if (!_alternate_success_f00000006fw) {
				_position = _alt_position_f00000006fw.Clone();
				_obj = _alt_obj_f00000006fw.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fw = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Select with attribute names");
					_position = _alt_position_f00000006fw;
					_obj = _alt_obj_f00000006fw;
				}
			}
			if (!_alternate_success_f00000006fw) {
				_position = _alt_position_f00000006fw.Clone();
				_obj = _alt_obj_f00000006fw.Clone();
				bool _sequence_fail_f000000076g = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Select with attribute names");
					_sequence_fail_f000000076g = true;
					goto _sequence_end_f000000076g;
				}
				while(true) {
					ParserPosition _many_position_f00000007fq = _position.Clone();
					var _many_obj_f00000007fq = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Select with attribute names");
						_position = _many_position_f00000007fq;
						_obj = _many_obj_f00000007fq;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Select with attribute names");
					_sequence_fail_f000000076g = true;
					goto _sequence_end_f000000076g;
				}
				_sequence_end_f000000076g:
				if (_sequence_fail_f000000076g) {
					_position = _alt_position_f00000006fw;
					_obj = _alt_obj_f00000006fw;
				} else {
					_alternate_success_f00000006fw = true;
				}
			}
			if (_alternate_success_f00000006fw) {
			} else {
				_position = _many_position_f00000006Gz;
				_obj = _many_obj_f00000006Gz;
				break;
			}
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.name_expr)) {
		} else {
		_sequence_fail_f00000005Sr = true;
		goto _sequence_end_f00000005Sr;
		}
		while(true) {
			ParserPosition _many_position_f00000006H3 = _position.Clone();
			var _many_obj_f00000006H3 = _obj.Clone();
			bool _alternate_success_f00000006fx = false;
			ParserPosition _alt_position_f00000006fx = _position;
			var _alt_obj_f00000006fx = _obj;
			if (!_alternate_success_f00000006fx) {
				_position = _alt_position_f00000006fx.Clone();
				_obj = _alt_obj_f00000006fx.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fx = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Select with attribute names");
					_position = _alt_position_f00000006fx;
					_obj = _alt_obj_f00000006fx;
				}
			}
			if (!_alternate_success_f00000006fx) {
				_position = _alt_position_f00000006fx.Clone();
				_obj = _alt_obj_f00000006fx.Clone();
				bool _sequence_fail_f000000076j = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Select with attribute names");
					_sequence_fail_f000000076j = true;
					goto _sequence_end_f000000076j;
				}
				while(true) {
					ParserPosition _many_position_f00000007fw = _position.Clone();
					var _many_obj_f00000007fw = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Select with attribute names");
						_position = _many_position_f00000007fw;
						_obj = _many_obj_f00000007fw;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Select with attribute names");
					_sequence_fail_f000000076j = true;
					goto _sequence_end_f000000076j;
				}
				_sequence_end_f000000076j:
				if (_sequence_fail_f000000076j) {
					_position = _alt_position_f00000006fx;
					_obj = _alt_obj_f00000006fx;
				} else {
					_alternate_success_f00000006fx = true;
				}
			}
			if (_alternate_success_f00000006fx) {
			} else {
				_position = _many_position_f00000006H3;
				_obj = _many_obj_f00000006H3;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "fricassée Select with attribute names");
			_sequence_fail_f00000005Sr = true;
			goto _sequence_end_f00000005Sr;
		}
		while(true) {
			ParserPosition _many_position_f00000006H5 = _position.Clone();
			var _many_obj_f00000006H5 = _obj.Clone();
			bool _alternate_success_f00000006fy = false;
			ParserPosition _alt_position_f00000006fy = _position;
			var _alt_obj_f00000006fy = _obj;
			if (!_alternate_success_f00000006fy) {
				_position = _alt_position_f00000006fy.Clone();
				_obj = _alt_obj_f00000006fy.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006fy = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Select with attribute names");
					_position = _alt_position_f00000006fy;
					_obj = _alt_obj_f00000006fy;
				}
			}
			if (!_alternate_success_f00000006fy) {
				_position = _alt_position_f00000006fy.Clone();
				_obj = _alt_obj_f00000006fy.Clone();
				bool _sequence_fail_f000000076m = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Select with attribute names");
					_sequence_fail_f000000076m = true;
					goto _sequence_end_f000000076m;
				}
				while(true) {
					ParserPosition _many_position_f00000007g2 = _position.Clone();
					var _many_obj_f00000007g2 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Select with attribute names");
						_position = _many_position_f00000007g2;
						_obj = _many_obj_f00000007g2;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Select with attribute names");
					_sequence_fail_f000000076m = true;
					goto _sequence_end_f000000076m;
				}
				_sequence_end_f000000076m:
				if (_sequence_fail_f000000076m) {
					_position = _alt_position_f00000006fy;
					_obj = _alt_obj_f00000006fy;
				} else {
					_alternate_success_f00000006fy = true;
				}
			}
			if (_alternate_success_f00000006fy) {
			} else {
				_position = _many_position_f00000006H5;
				_obj = _many_obj_f00000006H5;
				break;
			}
		}
		if (expression.ParseRule_expression2(ref _position, out _obj.value_expr)) {
		} else {
		_sequence_fail_f00000005Sr = true;
		goto _sequence_end_f00000005Sr;
		}
		_sequence_end_f00000005Sr:
		if (_sequence_fail_f00000005Sr) {
			_position.Cache<expression_for_select_named>(_start_index, null);
			_position.TraceExit("expression:for_select_named", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_for_select_named>(_start_index, _obj);
			_position.TraceExit("expression:for_select_named", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_from(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_from, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_from();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:from");

		bool _sequence_fail_f00000005Sz = false;
		if (_position.Match("From")) {
		} else {
			_position.Update("“From”", "external import");
			_sequence_fail_f00000005Sz = true;
			goto _sequence_end_f00000005Sz;
		}
		bool _first_f00000006HK = true;
		while(true) {
			ParserPosition _many_position_f00000006HK = _position.Clone();
			var _many_obj_f00000006HK = _obj.Clone();
			bool _alternate_success_f00000006g3 = false;
			ParserPosition _alt_position_f00000006g3 = _position;
			var _alt_obj_f00000006g3 = _obj;
			if (!_alternate_success_f00000006g3) {
				_position = _alt_position_f00000006g3.Clone();
				_obj = _alt_obj_f00000006g3.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006g3 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "external import");
					_position = _alt_position_f00000006g3;
					_obj = _alt_obj_f00000006g3;
				}
			}
			if (!_alternate_success_f00000006g3) {
				_position = _alt_position_f00000006g3.Clone();
				_obj = _alt_obj_f00000006g3.Clone();
				bool _sequence_fail_f000000076s = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "external import");
					_sequence_fail_f000000076s = true;
					goto _sequence_end_f000000076s;
				}
				while(true) {
					ParserPosition _many_position_f00000007g9 = _position.Clone();
					var _many_obj_f00000007g9 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "external import");
						_position = _many_position_f00000007g9;
						_obj = _many_obj_f00000007g9;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "external import");
					_sequence_fail_f000000076s = true;
					goto _sequence_end_f000000076s;
				}
				_sequence_end_f000000076s:
				if (_sequence_fail_f000000076s) {
					_position = _alt_position_f00000006g3;
					_obj = _alt_obj_f00000006g3;
				} else {
					_alternate_success_f00000006g3 = true;
				}
			}
			if (_alternate_success_f00000006g3) {
			} else {
				_position = _many_position_f00000006HK;
				_obj = _many_obj_f00000006HK;
				break;
			}
			_first_f00000006HK = false;
		}
		if (_first_f00000006HK) {
			_sequence_fail_f00000005Sz = true;
			goto _sequence_end_f00000005Sz;
		} else {
		}
		bool _sequence_fail_f00000006HL = false;
		while(true) {
			ParserPosition _many_position_f00000006g5 = _position.Clone();
			var _many_obj_f00000006g5 = _obj.Clone();
			bool _alternate_success_f000000076t = false;
			ParserPosition _alt_position_f000000076t = _position;
			var _alt_obj_f000000076t = _obj;
			if (!_alternate_success_f000000076t) {
				_position = _alt_position_f000000076t.Clone();
				_obj = _alt_obj_f000000076t.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f000000076t = true;
				} else {
					_position.Update("character between “A” and “Z”", "external import");
					_position = _alt_position_f000000076t;
					_obj = _alt_obj_f000000076t;
				}
			}
			if (!_alternate_success_f000000076t) {
				_position = _alt_position_f000000076t.Clone();
				_obj = _alt_obj_f000000076t.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f000000076t = true;
				} else {
					_position.Update("character between “a” and “z”", "external import");
					_position = _alt_position_f000000076t;
					_obj = _alt_obj_f000000076t;
				}
			}
			if (!_alternate_success_f000000076t) {
				_position = _alt_position_f000000076t.Clone();
				_obj = _alt_obj_f000000076t.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f000000076t = true;
				} else {
					_position.Update("character between “0” and “9”", "external import");
					_position = _alt_position_f000000076t;
					_obj = _alt_obj_f000000076t;
				}
			}
			if (!_alternate_success_f000000076t) {
				_position = _alt_position_f000000076t.Clone();
				_obj = _alt_obj_f000000076t.Clone();
				if ("-.+".IndexOf(_position.Next()) != -1) {
					_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f000000076t = true;
				} else {
					_position.Update(Parser.ToLiteral("-.+"), "external import");
					_position = _alt_position_f000000076t;
					_obj = _alt_obj_f000000076t;
				}
			}
			if (_alternate_success_f000000076t) {
			} else {
				_position = _many_position_f00000006g5;
				_obj = _many_obj_f00000006g5;
				break;
			}
		}
		if (":".IndexOf(_position.Next()) != -1) {
			_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
		} else {
			_position.Update(Parser.ToLiteral(":"), "external import");
			_sequence_fail_f00000006HL = true;
			goto _sequence_end_f00000006HL;
		}
		while(true) {
			ParserPosition _many_position_f00000006g7 = _position.Clone();
			var _many_obj_f00000006g7 = _obj.Clone();
			bool _alternate_success_f000000076u = false;
			ParserPosition _alt_position_f000000076u = _position;
			var _alt_obj_f000000076u = _obj;
			if (!_alternate_success_f000000076u) {
				_position = _alt_position_f000000076u.Clone();
				_obj = _alt_obj_f000000076u.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f000000076u = true;
				} else {
					_position.Update("character between “A” and “Z”", "external import");
					_position = _alt_position_f000000076u;
					_obj = _alt_obj_f000000076u;
				}
			}
			if (!_alternate_success_f000000076u) {
				_position = _alt_position_f000000076u.Clone();
				_obj = _alt_obj_f000000076u.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f000000076u = true;
				} else {
					_position.Update("character between “a” and “z”", "external import");
					_position = _alt_position_f000000076u;
					_obj = _alt_obj_f000000076u;
				}
			}
			if (!_alternate_success_f000000076u) {
				_position = _alt_position_f000000076u.Clone();
				_obj = _alt_obj_f000000076u.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f000000076u = true;
				} else {
					_position.Update("character between “0” and “9”", "external import");
					_position = _alt_position_f000000076u;
					_obj = _alt_obj_f000000076u;
				}
			}
			if (!_alternate_success_f000000076u) {
				_position = _alt_position_f000000076u.Clone();
				_obj = _alt_obj_f000000076u.Clone();
				if ("~=-,;!?/.'_[]@$*&#%+:".IndexOf(_position.Next()) != -1) {
					_obj.uri = new RevCons<char>(_position.PeekLast(), _obj.uri);
					_alternate_success_f000000076u = true;
				} else {
					_position.Update(Parser.ToLiteral("~=-,;!?/.'_[]@$*&#%+:"), "external import");
					_position = _alt_position_f000000076u;
					_obj = _alt_obj_f000000076u;
				}
			}
			if (_alternate_success_f000000076u) {
			} else {
				_position = _many_position_f00000006g7;
				_obj = _many_obj_f00000006g7;
				break;
			}
		}
		_sequence_end_f00000006HL:
		if (_sequence_fail_f00000006HL) {
			_sequence_fail_f00000005Sz = true;
			goto _sequence_end_f00000005Sz;
		} else {
		}
		_sequence_end_f00000005Sz:
		if (_sequence_fail_f00000005Sz) {
			_position.Cache<expression_from>(_start_index, null);
			_position.TraceExit("expression:from", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_from>(_start_index, _obj);
			_position.TraceExit("expression:from", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_function_anonymous(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_function_anonymous, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_function_anonymous();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:function_anonymous");

		bool _sequence_fail_f00000005T9 = false;
		if (expression.ParseRule_expression21(ref _position, out _obj.func_expr)) {
		} else {
		_sequence_fail_f00000005T9 = true;
		goto _sequence_end_f00000005T9;
		}
		while(true) {
			ParserPosition _many_position_f0000000774 = _position.Clone();
			var _many_obj_f0000000774 = _obj.Clone();
			bool _alternate_success_f00000007gP = false;
			ParserPosition _alt_position_f00000007gP = _position;
			var _alt_obj_f00000007gP = _obj;
			if (!_alternate_success_f00000007gP) {
				_position = _alt_position_f00000007gP.Clone();
				_obj = _alt_obj_f00000007gP.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000007gP = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template instantiation (unnamed arguments)");
					_position = _alt_position_f00000007gP;
					_obj = _alt_obj_f00000007gP;
				}
			}
			if (!_alternate_success_f00000007gP) {
				_position = _alt_position_f00000007gP.Clone();
				_obj = _alt_obj_f00000007gP.Clone();
				bool _sequence_fail_f00000008Hm = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "function-like template instantiation (unnamed arguments)");
					_sequence_fail_f00000008Hm = true;
					goto _sequence_end_f00000008Hm;
				}
				while(true) {
					ParserPosition _many_position_f00000008j9 = _position.Clone();
					var _many_obj_f00000008j9 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (unnamed arguments)");
						_position = _many_position_f00000008j9;
						_obj = _many_obj_f00000008j9;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (unnamed arguments)");
					_sequence_fail_f00000008Hm = true;
					goto _sequence_end_f00000008Hm;
				}
				_sequence_end_f00000008Hm:
				if (_sequence_fail_f00000008Hm) {
					_position = _alt_position_f00000007gP;
					_obj = _alt_obj_f00000007gP;
				} else {
					_alternate_success_f00000007gP = true;
				}
			}
			if (_alternate_success_f00000007gP) {
			} else {
				_position = _many_position_f0000000774;
				_obj = _many_obj_f0000000774;
				break;
			}
		}
		if (_position.Match("(")) {
		} else {
			_position.Update("“(”", "function-like template instantiation (unnamed arguments)");
			_sequence_fail_f00000005T9 = true;
			goto _sequence_end_f00000005T9;
		}
		bool _first_f0000000777 = true;
		while(true) {
			ParserPosition _many_position_f0000000777 = _position.Clone();
			var _many_obj_f0000000777 = _obj.Clone();
			if (!_first_f0000000777) {
			if (_position.Match(",")) {
			} else {
				_position.Update("“,”", "function-like template instantiation (unnamed arguments)");
				_position = _many_position_f0000000777;
				_obj = _many_obj_f0000000777;
				break;
			}
			}
			bool _sequence_fail_f00000007gQ = false;
			while(true) {
				ParserPosition _many_position_f00000008jD = _position.Clone();
				var _many_obj_f00000008jD = _obj.Clone();
				bool _alternate_success_f000000097a = false;
				ParserPosition _alt_position_f000000097a = _position;
				var _alt_obj_f000000097a = _obj;
				if (!_alternate_success_f000000097a) {
					_position = _alt_position_f000000097a.Clone();
					_obj = _alt_obj_f000000097a.Clone();
					if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
						_alternate_success_f000000097a = true;
					} else {
						_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template instantiation (unnamed arguments)");
						_position = _alt_position_f000000097a;
						_obj = _alt_obj_f000000097a;
					}
				}
				if (!_alternate_success_f000000097a) {
					_position = _alt_position_f000000097a.Clone();
					_obj = _alt_obj_f000000097a.Clone();
					bool _sequence_fail_f00000009KI = false;
					if (_position.Match("#")) {
					} else {
						_position.Update("“#”", "function-like template instantiation (unnamed arguments)");
						_sequence_fail_f00000009KI = true;
						goto _sequence_end_f00000009KI;
					}
					while(true) {
						ParserPosition _many_position_f00000009Vw = _position.Clone();
						var _many_obj_f00000009Vw = _obj.Clone();
						if ("\n".IndexOf(_position.Next()) == -1) {
							_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
						} else {
							_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (unnamed arguments)");
							_position = _many_position_f00000009Vw;
							_obj = _many_obj_f00000009Vw;
							break;
						}
					}
					if ("\n".IndexOf(_position.Next()) != -1) {
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (unnamed arguments)");
						_sequence_fail_f00000009KI = true;
						goto _sequence_end_f00000009KI;
					}
					_sequence_end_f00000009KI:
					if (_sequence_fail_f00000009KI) {
						_position = _alt_position_f000000097a;
						_obj = _alt_obj_f000000097a;
					} else {
						_alternate_success_f000000097a = true;
					}
				}
				if (_alternate_success_f000000097a) {
				} else {
					_position = _many_position_f00000008jD;
					_obj = _many_obj_f00000008jD;
					break;
				}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.anon_args, expression.ParseRule_expression0)) {
			} else {
			_sequence_fail_f00000007gQ = true;
			goto _sequence_end_f00000007gQ;
			}
			while(true) {
				ParserPosition _many_position_f00000008jH = _position.Clone();
				var _many_obj_f00000008jH = _obj.Clone();
				bool _alternate_success_f000000097b = false;
				ParserPosition _alt_position_f000000097b = _position;
				var _alt_obj_f000000097b = _obj;
				if (!_alternate_success_f000000097b) {
					_position = _alt_position_f000000097b.Clone();
					_obj = _alt_obj_f000000097b.Clone();
					if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
						_alternate_success_f000000097b = true;
					} else {
						_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template instantiation (unnamed arguments)");
						_position = _alt_position_f000000097b;
						_obj = _alt_obj_f000000097b;
					}
				}
				if (!_alternate_success_f000000097b) {
					_position = _alt_position_f000000097b.Clone();
					_obj = _alt_obj_f000000097b.Clone();
					bool _sequence_fail_f00000009KL = false;
					if (_position.Match("#")) {
					} else {
						_position.Update("“#”", "function-like template instantiation (unnamed arguments)");
						_sequence_fail_f00000009KL = true;
						goto _sequence_end_f00000009KL;
					}
					while(true) {
						ParserPosition _many_position_f00000009W2 = _position.Clone();
						var _many_obj_f00000009W2 = _obj.Clone();
						if ("\n".IndexOf(_position.Next()) == -1) {
							_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
						} else {
							_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (unnamed arguments)");
							_position = _many_position_f00000009W2;
							_obj = _many_obj_f00000009W2;
							break;
						}
					}
					if ("\n".IndexOf(_position.Next()) != -1) {
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (unnamed arguments)");
						_sequence_fail_f00000009KL = true;
						goto _sequence_end_f00000009KL;
					}
					_sequence_end_f00000009KL:
					if (_sequence_fail_f00000009KL) {
						_position = _alt_position_f000000097b;
						_obj = _alt_obj_f000000097b;
					} else {
						_alternate_success_f000000097b = true;
					}
				}
				if (_alternate_success_f000000097b) {
				} else {
					_position = _many_position_f00000008jH;
					_obj = _many_obj_f00000008jH;
					break;
				}
			}
			if (_position.Index >= _position.Parser.Input.Length || ":".IndexOf(_position.Parser.Input[_position.Index]) == -1) {
			} else {
				_position.Update("anything except " + Parser.ToLiteral(":"), "function-like template instantiation (unnamed arguments)");
				_sequence_fail_f00000007gQ = true;
				goto _sequence_end_f00000007gQ;
			}
			_sequence_end_f00000007gQ:
			if (_sequence_fail_f00000007gQ) {
				_position = _many_position_f0000000777;
				_obj = _many_obj_f0000000777;
				break;
			} else {
			}
			_first_f0000000777 = false;
		}
		while(true) {
			ParserPosition _many_position_f000000077A = _position.Clone();
			var _many_obj_f000000077A = _obj.Clone();
			bool _alternate_success_f00000007gS = false;
			ParserPosition _alt_position_f00000007gS = _position;
			var _alt_obj_f00000007gS = _obj;
			if (!_alternate_success_f00000007gS) {
				_position = _alt_position_f00000007gS.Clone();
				_obj = _alt_obj_f00000007gS.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000007gS = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template instantiation (unnamed arguments)");
					_position = _alt_position_f00000007gS;
					_obj = _alt_obj_f00000007gS;
				}
			}
			if (!_alternate_success_f00000007gS) {
				_position = _alt_position_f00000007gS.Clone();
				_obj = _alt_obj_f00000007gS.Clone();
				bool _sequence_fail_f00000008Hu = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "function-like template instantiation (unnamed arguments)");
					_sequence_fail_f00000008Hu = true;
					goto _sequence_end_f00000008Hu;
				}
				while(true) {
					ParserPosition _many_position_f00000008jO = _position.Clone();
					var _many_obj_f00000008jO = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (unnamed arguments)");
						_position = _many_position_f00000008jO;
						_obj = _many_obj_f00000008jO;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (unnamed arguments)");
					_sequence_fail_f00000008Hu = true;
					goto _sequence_end_f00000008Hu;
				}
				_sequence_end_f00000008Hu:
				if (_sequence_fail_f00000008Hu) {
					_position = _alt_position_f00000007gS;
					_obj = _alt_obj_f00000007gS;
				} else {
					_alternate_success_f00000007gS = true;
				}
			}
			if (_alternate_success_f00000007gS) {
			} else {
				_position = _many_position_f000000077A;
				_obj = _many_obj_f000000077A;
				break;
			}
		}
		if (_position.Match(")")) {
		} else {
			_position.Update("“)”", "function-like template instantiation (unnamed arguments)");
			_sequence_fail_f00000005T9 = true;
			goto _sequence_end_f00000005T9;
		}
		_sequence_end_f00000005T9:
		if (_sequence_fail_f00000005T9) {
			_position.Cache<expression_function_anonymous>(_start_index, null);
			_position.TraceExit("expression:function_anonymous", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_function_anonymous>(_start_index, _obj);
			_position.TraceExit("expression:function_anonymous", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_function_mixed(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_function_mixed, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_function_mixed();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:function_mixed");

		bool _sequence_fail_f00000005TJ = false;
		if (expression.ParseRule_expression21(ref _position, out _obj.func_expr)) {
		} else {
		_sequence_fail_f00000005TJ = true;
		goto _sequence_end_f00000005TJ;
		}
		while(true) {
			ParserPosition _many_position_f00000006oe = _position.Clone();
			var _many_obj_f00000006oe = _obj.Clone();
			bool _alternate_success_f00000007JL = false;
			ParserPosition _alt_position_f00000007JL = _position;
			var _alt_obj_f00000007JL = _obj;
			if (!_alternate_success_f00000007JL) {
				_position = _alt_position_f00000007JL.Clone();
				_obj = _alt_obj_f00000007JL.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000007JL = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template instantiation (named and unnamed arguments)");
					_position = _alt_position_f00000007JL;
					_obj = _alt_obj_f00000007JL;
				}
			}
			if (!_alternate_success_f00000007JL) {
				_position = _alt_position_f00000007JL.Clone();
				_obj = _alt_obj_f00000007JL.Clone();
				bool _sequence_fail_f00000007w3 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "function-like template instantiation (named and unnamed arguments)");
					_sequence_fail_f00000007w3 = true;
					goto _sequence_end_f00000007w3;
				}
				while(true) {
					ParserPosition _many_position_f00000008RZ = _position.Clone();
					var _many_obj_f00000008RZ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named and unnamed arguments)");
						_position = _many_position_f00000008RZ;
						_obj = _many_obj_f00000008RZ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named and unnamed arguments)");
					_sequence_fail_f00000007w3 = true;
					goto _sequence_end_f00000007w3;
				}
				_sequence_end_f00000007w3:
				if (_sequence_fail_f00000007w3) {
					_position = _alt_position_f00000007JL;
					_obj = _alt_obj_f00000007JL;
				} else {
					_alternate_success_f00000007JL = true;
				}
			}
			if (_alternate_success_f00000007JL) {
			} else {
				_position = _many_position_f00000006oe;
				_obj = _many_obj_f00000006oe;
				break;
			}
		}
		if (_position.Match("(")) {
		} else {
			_position.Update("“(”", "function-like template instantiation (named and unnamed arguments)");
			_sequence_fail_f00000005TJ = true;
			goto _sequence_end_f00000005TJ;
		}
		bool _first_f00000006oh = true;
		while(true) {
			ParserPosition _many_position_f00000006oh = _position.Clone();
			var _many_obj_f00000006oh = _obj.Clone();
			if (!_first_f00000006oh) {
			if (_position.Match(",")) {
			} else {
				_position.Update("“,”", "function-like template instantiation (named and unnamed arguments)");
				_position = _many_position_f00000006oh;
				_obj = _many_obj_f00000006oh;
				break;
			}
			}
			bool _sequence_fail_f00000007JM = false;
			while(true) {
				ParserPosition _many_position_f00000008Rd = _position.Clone();
				var _many_obj_f00000008Rd = _obj.Clone();
				bool _alternate_success_f00000008s1 = false;
				ParserPosition _alt_position_f00000008s1 = _position;
				var _alt_obj_f00000008s1 = _obj;
				if (!_alternate_success_f00000008s1) {
					_position = _alt_position_f00000008s1.Clone();
					_obj = _alt_obj_f00000008s1.Clone();
					if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
						_alternate_success_f00000008s1 = true;
					} else {
						_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template instantiation (named and unnamed arguments)");
						_position = _alt_position_f00000008s1;
						_obj = _alt_obj_f00000008s1;
					}
				}
				if (!_alternate_success_f00000008s1) {
					_position = _alt_position_f00000008s1.Clone();
					_obj = _alt_obj_f00000008s1.Clone();
					bool _sequence_fail_f00000009DH = false;
					if (_position.Match("#")) {
					} else {
						_position.Update("“#”", "function-like template instantiation (named and unnamed arguments)");
						_sequence_fail_f00000009DH = true;
						goto _sequence_end_f00000009DH;
					}
					while(true) {
						ParserPosition _many_position_f00000009Ox = _position.Clone();
						var _many_obj_f00000009Ox = _obj.Clone();
						if ("\n".IndexOf(_position.Next()) == -1) {
							_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
						} else {
							_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named and unnamed arguments)");
							_position = _many_position_f00000009Ox;
							_obj = _many_obj_f00000009Ox;
							break;
						}
					}
					if ("\n".IndexOf(_position.Next()) != -1) {
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named and unnamed arguments)");
						_sequence_fail_f00000009DH = true;
						goto _sequence_end_f00000009DH;
					}
					_sequence_end_f00000009DH:
					if (_sequence_fail_f00000009DH) {
						_position = _alt_position_f00000008s1;
						_obj = _alt_obj_f00000008s1;
					} else {
						_alternate_success_f00000008s1 = true;
					}
				}
				if (_alternate_success_f00000008s1) {
				} else {
					_position = _many_position_f00000008Rd;
					_obj = _many_obj_f00000008Rd;
					break;
				}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.anon_args, expression.ParseRule_expression0)) {
			} else {
			_sequence_fail_f00000007JM = true;
			goto _sequence_end_f00000007JM;
			}
			while(true) {
				ParserPosition _many_position_f00000008Rh = _position.Clone();
				var _many_obj_f00000008Rh = _obj.Clone();
				bool _alternate_success_f00000008s2 = false;
				ParserPosition _alt_position_f00000008s2 = _position;
				var _alt_obj_f00000008s2 = _obj;
				if (!_alternate_success_f00000008s2) {
					_position = _alt_position_f00000008s2.Clone();
					_obj = _alt_obj_f00000008s2.Clone();
					if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
						_alternate_success_f00000008s2 = true;
					} else {
						_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template instantiation (named and unnamed arguments)");
						_position = _alt_position_f00000008s2;
						_obj = _alt_obj_f00000008s2;
					}
				}
				if (!_alternate_success_f00000008s2) {
					_position = _alt_position_f00000008s2.Clone();
					_obj = _alt_obj_f00000008s2.Clone();
					bool _sequence_fail_f00000009DK = false;
					if (_position.Match("#")) {
					} else {
						_position.Update("“#”", "function-like template instantiation (named and unnamed arguments)");
						_sequence_fail_f00000009DK = true;
						goto _sequence_end_f00000009DK;
					}
					while(true) {
						ParserPosition _many_position_f00000009P3 = _position.Clone();
						var _many_obj_f00000009P3 = _obj.Clone();
						if ("\n".IndexOf(_position.Next()) == -1) {
							_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
						} else {
							_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named and unnamed arguments)");
							_position = _many_position_f00000009P3;
							_obj = _many_obj_f00000009P3;
							break;
						}
					}
					if ("\n".IndexOf(_position.Next()) != -1) {
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named and unnamed arguments)");
						_sequence_fail_f00000009DK = true;
						goto _sequence_end_f00000009DK;
					}
					_sequence_end_f00000009DK:
					if (_sequence_fail_f00000009DK) {
						_position = _alt_position_f00000008s2;
						_obj = _alt_obj_f00000008s2;
					} else {
						_alternate_success_f00000008s2 = true;
					}
				}
				if (_alternate_success_f00000008s2) {
				} else {
					_position = _many_position_f00000008Rh;
					_obj = _many_obj_f00000008Rh;
					break;
				}
			}
			if (_position.Index >= _position.Parser.Input.Length || ":".IndexOf(_position.Parser.Input[_position.Index]) == -1) {
			} else {
				_position.Update("anything except " + Parser.ToLiteral(":"), "function-like template instantiation (named and unnamed arguments)");
				_sequence_fail_f00000007JM = true;
				goto _sequence_end_f00000007JM;
			}
			_sequence_end_f00000007JM:
			if (_sequence_fail_f00000007JM) {
				_position = _many_position_f00000006oh;
				_obj = _many_obj_f00000006oh;
				break;
			} else {
			}
			_first_f00000006oh = false;
		}
		if (_position.Match(",")) {
		} else {
			_position.Update("“,”", "function-like template instantiation (named and unnamed arguments)");
			_sequence_fail_f00000005TJ = true;
			goto _sequence_end_f00000005TJ;
		}
		bool _first_f00000006ok = true;
		while(true) {
			ParserPosition _many_position_f00000006ok = _position.Clone();
			var _many_obj_f00000006ok = _obj.Clone();
			if (!_first_f00000006ok) {
			if (_position.Match(",")) {
			} else {
				_position.Update("“,”", "function-like template instantiation (named and unnamed arguments)");
				_position = _many_position_f00000006ok;
				_obj = _many_obj_f00000006ok;
				break;
			}
			}
			bool _sequence_fail_f00000007JP = false;
			if (ParserPosition.ParseIntoList(ref _position, _obj.named_args, (ref ParserPosition _iposition, out named_definition _iresult) => { if (named_definition.ParseRule_Base(ref _iposition, out _iresult)) { var f00000007wA_key = Generator.ToString(_iresult.name); if (_obj.named_args_dedup.ContainsKey(f00000007wA_key)) { _iposition.NameConstraint(f00000007wA_key); return false; } else { _obj.named_args_dedup[f00000007wA_key] = true; return true; } } else { return false; } })) {
			} else {
			_sequence_fail_f00000007JP = true;
			goto _sequence_end_f00000007JP;
			}
			while(true) {
				ParserPosition _many_position_f00000008Rq = _position.Clone();
				var _many_obj_f00000008Rq = _obj.Clone();
				bool _alternate_success_f00000008s4 = false;
				ParserPosition _alt_position_f00000008s4 = _position;
				var _alt_obj_f00000008s4 = _obj;
				if (!_alternate_success_f00000008s4) {
					_position = _alt_position_f00000008s4.Clone();
					_obj = _alt_obj_f00000008s4.Clone();
					if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
						_alternate_success_f00000008s4 = true;
					} else {
						_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template instantiation (named and unnamed arguments)");
						_position = _alt_position_f00000008s4;
						_obj = _alt_obj_f00000008s4;
					}
				}
				if (!_alternate_success_f00000008s4) {
					_position = _alt_position_f00000008s4.Clone();
					_obj = _alt_obj_f00000008s4.Clone();
					bool _sequence_fail_f00000009DS = false;
					if (_position.Match("#")) {
					} else {
						_position.Update("“#”", "function-like template instantiation (named and unnamed arguments)");
						_sequence_fail_f00000009DS = true;
						goto _sequence_end_f00000009DS;
					}
					while(true) {
						ParserPosition _many_position_f00000009P9 = _position.Clone();
						var _many_obj_f00000009P9 = _obj.Clone();
						if ("\n".IndexOf(_position.Next()) == -1) {
							_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
						} else {
							_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named and unnamed arguments)");
							_position = _many_position_f00000009P9;
							_obj = _many_obj_f00000009P9;
							break;
						}
					}
					if ("\n".IndexOf(_position.Next()) != -1) {
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named and unnamed arguments)");
						_sequence_fail_f00000009DS = true;
						goto _sequence_end_f00000009DS;
					}
					_sequence_end_f00000009DS:
					if (_sequence_fail_f00000009DS) {
						_position = _alt_position_f00000008s4;
						_obj = _alt_obj_f00000008s4;
					} else {
						_alternate_success_f00000008s4 = true;
					}
				}
				if (_alternate_success_f00000008s4) {
				} else {
					_position = _many_position_f00000008Rq;
					_obj = _many_obj_f00000008Rq;
					break;
				}
			}
			_sequence_end_f00000007JP:
			if (_sequence_fail_f00000007JP) {
				_position = _many_position_f00000006ok;
				_obj = _many_obj_f00000006ok;
				break;
			} else {
			}
			_first_f00000006ok = false;
		}
		if (_first_f00000006ok) {
			_sequence_fail_f00000005TJ = true;
			goto _sequence_end_f00000005TJ;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f00000006ol = _position.Clone();
			var _many_obj_f00000006ol = _obj.Clone();
			bool _alternate_success_f00000007JR = false;
			ParserPosition _alt_position_f00000007JR = _position;
			var _alt_obj_f00000007JR = _obj;
			if (!_alternate_success_f00000007JR) {
				_position = _alt_position_f00000007JR.Clone();
				_obj = _alt_obj_f00000007JR.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000007JR = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template instantiation (named and unnamed arguments)");
					_position = _alt_position_f00000007JR;
					_obj = _alt_obj_f00000007JR;
				}
			}
			if (!_alternate_success_f00000007JR) {
				_position = _alt_position_f00000007JR.Clone();
				_obj = _alt_obj_f00000007JR.Clone();
				bool _sequence_fail_f00000007wE = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "function-like template instantiation (named and unnamed arguments)");
					_sequence_fail_f00000007wE = true;
					goto _sequence_end_f00000007wE;
				}
				while(true) {
					ParserPosition _many_position_f00000008Rw = _position.Clone();
					var _many_obj_f00000008Rw = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named and unnamed arguments)");
						_position = _many_position_f00000008Rw;
						_obj = _many_obj_f00000008Rw;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named and unnamed arguments)");
					_sequence_fail_f00000007wE = true;
					goto _sequence_end_f00000007wE;
				}
				_sequence_end_f00000007wE:
				if (_sequence_fail_f00000007wE) {
					_position = _alt_position_f00000007JR;
					_obj = _alt_obj_f00000007JR;
				} else {
					_alternate_success_f00000007JR = true;
				}
			}
			if (_alternate_success_f00000007JR) {
			} else {
				_position = _many_position_f00000006ol;
				_obj = _many_obj_f00000006ol;
				break;
			}
		}
		if (_position.Match(")")) {
		} else {
			_position.Update("“)”", "function-like template instantiation (named and unnamed arguments)");
			_sequence_fail_f00000005TJ = true;
			goto _sequence_end_f00000005TJ;
		}
		_sequence_end_f00000005TJ:
		if (_sequence_fail_f00000005TJ) {
			_position.Cache<expression_function_mixed>(_start_index, null);
			_position.TraceExit("expression:function_mixed", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_function_mixed>(_start_index, _obj);
			_position.TraceExit("expression:function_mixed", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_function_named(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_function_named, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_function_named();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:function_named");

		bool _sequence_fail_f00000005TT = false;
		if (expression.ParseRule_expression21(ref _position, out _obj.func_expr)) {
		} else {
		_sequence_fail_f00000005TT = true;
		goto _sequence_end_f00000005TT;
		}
		while(true) {
			ParserPosition _many_position_f000000077e = _position.Clone();
			var _many_obj_f000000077e = _obj.Clone();
			bool _alternate_success_f00000007gk = false;
			ParserPosition _alt_position_f00000007gk = _position;
			var _alt_obj_f00000007gk = _obj;
			if (!_alternate_success_f00000007gk) {
				_position = _alt_position_f00000007gk.Clone();
				_obj = _alt_obj_f00000007gk.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000007gk = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template instantiation (named arguments)");
					_position = _alt_position_f00000007gk;
					_obj = _alt_obj_f00000007gk;
				}
			}
			if (!_alternate_success_f00000007gk) {
				_position = _alt_position_f00000007gk.Clone();
				_obj = _alt_obj_f00000007gk.Clone();
				bool _sequence_fail_f00000008ID = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "function-like template instantiation (named arguments)");
					_sequence_fail_f00000008ID = true;
					goto _sequence_end_f00000008ID;
				}
				while(true) {
					ParserPosition _many_position_f00000008ju = _position.Clone();
					var _many_obj_f00000008ju = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named arguments)");
						_position = _many_position_f00000008ju;
						_obj = _many_obj_f00000008ju;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named arguments)");
					_sequence_fail_f00000008ID = true;
					goto _sequence_end_f00000008ID;
				}
				_sequence_end_f00000008ID:
				if (_sequence_fail_f00000008ID) {
					_position = _alt_position_f00000007gk;
					_obj = _alt_obj_f00000007gk;
				} else {
					_alternate_success_f00000007gk = true;
				}
			}
			if (_alternate_success_f00000007gk) {
			} else {
				_position = _many_position_f000000077e;
				_obj = _many_obj_f000000077e;
				break;
			}
		}
		if (_position.Match("(")) {
		} else {
			_position.Update("“(”", "function-like template instantiation (named arguments)");
			_sequence_fail_f00000005TT = true;
			goto _sequence_end_f00000005TT;
		}
		bool _first_f000000077j = true;
		while(true) {
			ParserPosition _many_position_f000000077j = _position.Clone();
			var _many_obj_f000000077j = _obj.Clone();
			if (!_first_f000000077j) {
			if (_position.Match(",")) {
			} else {
				_position.Update("“,”", "function-like template instantiation (named arguments)");
				_position = _many_position_f000000077j;
				_obj = _many_obj_f000000077j;
				break;
			}
			}
			bool _sequence_fail_f00000007gl = false;
			if (ParserPosition.ParseIntoList(ref _position, _obj.named_args, (ref ParserPosition _iposition, out named_definition _iresult) => { if (named_definition.ParseRule_Base(ref _iposition, out _iresult)) { var f00000008IF_key = Generator.ToString(_iresult.name); if (_obj.named_args_dedup.ContainsKey(f00000008IF_key)) { _iposition.NameConstraint(f00000008IF_key); return false; } else { _obj.named_args_dedup[f00000008IF_key] = true; return true; } } else { return false; } })) {
			} else {
			_sequence_fail_f00000007gl = true;
			goto _sequence_end_f00000007gl;
			}
			while(true) {
				ParserPosition _many_position_f00000008k1 = _position.Clone();
				var _many_obj_f00000008k1 = _obj.Clone();
				bool _alternate_success_f000000098K = false;
				ParserPosition _alt_position_f000000098K = _position;
				var _alt_obj_f000000098K = _obj;
				if (!_alternate_success_f000000098K) {
					_position = _alt_position_f000000098K.Clone();
					_obj = _alt_obj_f000000098K.Clone();
					if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
						_alternate_success_f000000098K = true;
					} else {
						_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template instantiation (named arguments)");
						_position = _alt_position_f000000098K;
						_obj = _alt_obj_f000000098K;
					}
				}
				if (!_alternate_success_f000000098K) {
					_position = _alt_position_f000000098K.Clone();
					_obj = _alt_obj_f000000098K.Clone();
					bool _sequence_fail_f00000009L0 = false;
					if (_position.Match("#")) {
					} else {
						_position.Update("“#”", "function-like template instantiation (named arguments)");
						_sequence_fail_f00000009L0 = true;
						goto _sequence_end_f00000009L0;
					}
					while(true) {
						ParserPosition _many_position_f00000009WX = _position.Clone();
						var _many_obj_f00000009WX = _obj.Clone();
						if ("\n".IndexOf(_position.Next()) == -1) {
							_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
						} else {
							_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named arguments)");
							_position = _many_position_f00000009WX;
							_obj = _many_obj_f00000009WX;
							break;
						}
					}
					if ("\n".IndexOf(_position.Next()) != -1) {
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named arguments)");
						_sequence_fail_f00000009L0 = true;
						goto _sequence_end_f00000009L0;
					}
					_sequence_end_f00000009L0:
					if (_sequence_fail_f00000009L0) {
						_position = _alt_position_f000000098K;
						_obj = _alt_obj_f000000098K;
					} else {
						_alternate_success_f000000098K = true;
					}
				}
				if (_alternate_success_f000000098K) {
				} else {
					_position = _many_position_f00000008k1;
					_obj = _many_obj_f00000008k1;
					break;
				}
			}
			_sequence_end_f00000007gl:
			if (_sequence_fail_f00000007gl) {
				_position = _many_position_f000000077j;
				_obj = _many_obj_f000000077j;
				break;
			} else {
			}
			_first_f000000077j = false;
		}
		if (_first_f000000077j) {
			_sequence_fail_f00000005TT = true;
			goto _sequence_end_f00000005TT;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f000000077k = _position.Clone();
			var _many_obj_f000000077k = _obj.Clone();
			bool _alternate_success_f00000007gn = false;
			ParserPosition _alt_position_f00000007gn = _position;
			var _alt_obj_f00000007gn = _obj;
			if (!_alternate_success_f00000007gn) {
				_position = _alt_position_f00000007gn.Clone();
				_obj = _alt_obj_f00000007gn.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000007gn = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "function-like template instantiation (named arguments)");
					_position = _alt_position_f00000007gn;
					_obj = _alt_obj_f00000007gn;
				}
			}
			if (!_alternate_success_f00000007gn) {
				_position = _alt_position_f00000007gn.Clone();
				_obj = _alt_obj_f00000007gn.Clone();
				bool _sequence_fail_f00000008IJ = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "function-like template instantiation (named arguments)");
					_sequence_fail_f00000008IJ = true;
					goto _sequence_end_f00000008IJ;
				}
				while(true) {
					ParserPosition _many_position_f00000008k7 = _position.Clone();
					var _many_obj_f00000008k7 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named arguments)");
						_position = _many_position_f00000008k7;
						_obj = _many_obj_f00000008k7;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "function-like template instantiation (named arguments)");
					_sequence_fail_f00000008IJ = true;
					goto _sequence_end_f00000008IJ;
				}
				_sequence_end_f00000008IJ:
				if (_sequence_fail_f00000008IJ) {
					_position = _alt_position_f00000007gn;
					_obj = _alt_obj_f00000007gn;
				} else {
					_alternate_success_f00000007gn = true;
				}
			}
			if (_alternate_success_f00000007gn) {
			} else {
				_position = _many_position_f000000077k;
				_obj = _many_obj_f000000077k;
				break;
			}
		}
		if (_position.Match(")")) {
		} else {
			_position.Update("“)”", "function-like template instantiation (named arguments)");
			_sequence_fail_f00000005TT = true;
			goto _sequence_end_f00000005TT;
		}
		_sequence_end_f00000005TT:
		if (_sequence_fail_f00000005TT) {
			_position.Cache<expression_function_named>(_start_index, null);
			_position.TraceExit("expression:function_named", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_function_named>(_start_index, _obj);
			_position.TraceExit("expression:function_named", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_function_new(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_function_new, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_function_new();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:function_new");

		bool _sequence_fail_f00000005Td = false;
		if (_position.Match("Function")) {
		} else {
			_position.Update("“Function”", "define function-like template");
			_sequence_fail_f00000005Td = true;
			goto _sequence_end_f00000005Td;
		}
		while(true) {
			ParserPosition _many_position_f00000006HZ = _position.Clone();
			var _many_obj_f00000006HZ = _obj.Clone();
			bool _alternate_success_f00000006ge = false;
			ParserPosition _alt_position_f00000006ge = _position;
			var _alt_obj_f00000006ge = _obj;
			if (!_alternate_success_f00000006ge) {
				_position = _alt_position_f00000006ge.Clone();
				_obj = _alt_obj_f00000006ge.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ge = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "define function-like template");
					_position = _alt_position_f00000006ge;
					_obj = _alt_obj_f00000006ge;
				}
			}
			if (!_alternate_success_f00000006ge) {
				_position = _alt_position_f00000006ge.Clone();
				_obj = _alt_obj_f00000006ge.Clone();
				bool _sequence_fail_f000000077y = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "define function-like template");
					_sequence_fail_f000000077y = true;
					goto _sequence_end_f000000077y;
				}
				while(true) {
					ParserPosition _many_position_f00000007gu = _position.Clone();
					var _many_obj_f00000007gu = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "define function-like template");
						_position = _many_position_f00000007gu;
						_obj = _many_obj_f00000007gu;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "define function-like template");
					_sequence_fail_f000000077y = true;
					goto _sequence_end_f000000077y;
				}
				_sequence_end_f000000077y:
				if (_sequence_fail_f000000077y) {
					_position = _alt_position_f00000006ge;
					_obj = _alt_obj_f00000006ge;
				} else {
					_alternate_success_f00000006ge = true;
				}
			}
			if (_alternate_success_f00000006ge) {
			} else {
				_position = _many_position_f00000006HZ;
				_obj = _many_obj_f00000006HZ;
				break;
			}
		}
		if (_position.Match("(")) {
		} else {
			_position.Update("“(”", "define function-like template");
			_sequence_fail_f00000005Td = true;
			goto _sequence_end_f00000005Td;
		}
		bool _first_f00000006Hd = true;
		while(true) {
			ParserPosition _many_position_f00000006Hd = _position.Clone();
			var _many_obj_f00000006Hd = _obj.Clone();
			if (!_first_f00000006Hd) {
			if (_position.Match(",")) {
			} else {
				_position.Update("“,”", "define function-like template");
				_position = _many_position_f00000006Hd;
				_obj = _many_obj_f00000006Hd;
				break;
			}
			}
			bool _sequence_fail_f00000006gf = false;
			while(true) {
				ParserPosition _many_position_f0000000781 = _position.Clone();
				var _many_obj_f0000000781 = _obj.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "define function-like template");
					_position = _many_position_f0000000781;
					_obj = _many_obj_f0000000781;
					break;
				}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.attributes, (ref ParserPosition _iposition, out attribute _iresult) => { if (attribute.ParseRule_function_tmpl_attributes(ref _iposition, out _iresult)) { var f0000000782_key = Generator.ToString(_iresult.name); if (_obj.attributes_dedup.ContainsKey(f0000000782_key)) { _iposition.NameConstraint(f0000000782_key); return false; } else { _obj.attributes_dedup[f0000000782_key] = true; return true; } } else { return false; } })) {
			} else {
			_sequence_fail_f00000006gf = true;
			goto _sequence_end_f00000006gf;
			}
			while(true) {
				ParserPosition _many_position_f0000000783 = _position.Clone();
				var _many_obj_f0000000783 = _obj.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "define function-like template");
					_position = _many_position_f0000000783;
					_obj = _many_obj_f0000000783;
					break;
				}
			}
			_sequence_end_f00000006gf:
			if (_sequence_fail_f00000006gf) {
				_position = _many_position_f00000006Hd;
				_obj = _many_obj_f00000006Hd;
				break;
			} else {
			}
			_first_f00000006Hd = false;
		}
		while(true) {
			ParserPosition _many_position_f00000006He = _position.Clone();
			var _many_obj_f00000006He = _obj.Clone();
			bool _alternate_success_f00000006gh = false;
			ParserPosition _alt_position_f00000006gh = _position;
			var _alt_obj_f00000006gh = _obj;
			if (!_alternate_success_f00000006gh) {
				_position = _alt_position_f00000006gh.Clone();
				_obj = _alt_obj_f00000006gh.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006gh = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "define function-like template");
					_position = _alt_position_f00000006gh;
					_obj = _alt_obj_f00000006gh;
				}
			}
			if (!_alternate_success_f00000006gh) {
				_position = _alt_position_f00000006gh.Clone();
				_obj = _alt_obj_f00000006gh.Clone();
				bool _sequence_fail_f0000000786 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "define function-like template");
					_sequence_fail_f0000000786 = true;
					goto _sequence_end_f0000000786;
				}
				while(true) {
					ParserPosition _many_position_f00000007h8 = _position.Clone();
					var _many_obj_f00000007h8 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "define function-like template");
						_position = _many_position_f00000007h8;
						_obj = _many_obj_f00000007h8;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "define function-like template");
					_sequence_fail_f0000000786 = true;
					goto _sequence_end_f0000000786;
				}
				_sequence_end_f0000000786:
				if (_sequence_fail_f0000000786) {
					_position = _alt_position_f00000006gh;
					_obj = _alt_obj_f00000006gh;
				} else {
					_alternate_success_f00000006gh = true;
				}
			}
			if (_alternate_success_f00000006gh) {
			} else {
				_position = _many_position_f00000006He;
				_obj = _many_obj_f00000006He;
				break;
			}
		}
		if (_position.Match(")")) {
		} else {
			_position.Update("“)”", "define function-like template");
			_sequence_fail_f00000005Td = true;
			goto _sequence_end_f00000005Td;
		}
		while(true) {
			ParserPosition _many_position_f00000006Hg = _position.Clone();
			var _many_obj_f00000006Hg = _obj.Clone();
			bool _alternate_success_f00000006gi = false;
			ParserPosition _alt_position_f00000006gi = _position;
			var _alt_obj_f00000006gi = _obj;
			if (!_alternate_success_f00000006gi) {
				_position = _alt_position_f00000006gi.Clone();
				_obj = _alt_obj_f00000006gi.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006gi = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "define function-like template");
					_position = _alt_position_f00000006gi;
					_obj = _alt_obj_f00000006gi;
				}
			}
			if (!_alternate_success_f00000006gi) {
				_position = _alt_position_f00000006gi.Clone();
				_obj = _alt_obj_f00000006gi.Clone();
				bool _sequence_fail_f0000000789 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "define function-like template");
					_sequence_fail_f0000000789 = true;
					goto _sequence_end_f0000000789;
				}
				while(true) {
					ParserPosition _many_position_f00000007hE = _position.Clone();
					var _many_obj_f00000007hE = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "define function-like template");
						_position = _many_position_f00000007hE;
						_obj = _many_obj_f00000007hE;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "define function-like template");
					_sequence_fail_f0000000789 = true;
					goto _sequence_end_f0000000789;
				}
				_sequence_end_f0000000789:
				if (_sequence_fail_f0000000789) {
					_position = _alt_position_f00000006gi;
					_obj = _alt_obj_f00000006gi;
				} else {
					_alternate_success_f00000006gi = true;
				}
			}
			if (_alternate_success_f00000006gi) {
			} else {
				_position = _many_position_f00000006Hg;
				_obj = _many_obj_f00000006Hg;
				break;
			}
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.body)) {
		} else {
		_sequence_fail_f00000005Td = true;
		goto _sequence_end_f00000005Td;
		}
		_sequence_end_f00000005Td:
		if (_sequence_fail_f00000005Td) {
			_position.Cache<expression_function_new>(_start_index, null);
			_position.TraceExit("expression:function_new", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_function_new>(_start_index, _obj);
			_position.TraceExit("expression:function_new", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_generate_id(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_generate_id, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_generate_id();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:generate_id");

		bool _sequence_fail_f00000005Tn = false;
		if (_position.Match("GenerateId")) {
		} else {
			_position.Update("“GenerateId”", "unique frame identifier");
			_sequence_fail_f00000005Tn = true;
			goto _sequence_end_f00000005Tn;
		}
		while(true) {
			ParserPosition _many_position_f00000006Hn = _position.Clone();
			var _many_obj_f00000006Hn = _obj.Clone();
			bool _alternate_success_f00000006gp = false;
			ParserPosition _alt_position_f00000006gp = _position;
			var _alt_obj_f00000006gp = _obj;
			if (!_alternate_success_f00000006gp) {
				_position = _alt_position_f00000006gp.Clone();
				_obj = _alt_obj_f00000006gp.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006gp = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "unique frame identifier");
					_position = _alt_position_f00000006gp;
					_obj = _alt_obj_f00000006gp;
				}
			}
			if (!_alternate_success_f00000006gp) {
				_position = _alt_position_f00000006gp.Clone();
				_obj = _alt_obj_f00000006gp.Clone();
				bool _sequence_fail_f000000078I = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "unique frame identifier");
					_sequence_fail_f000000078I = true;
					goto _sequence_end_f000000078I;
				}
				while(true) {
					ParserPosition _many_position_f00000007hK = _position.Clone();
					var _many_obj_f00000007hK = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "unique frame identifier");
						_position = _many_position_f00000007hK;
						_obj = _many_obj_f00000007hK;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "unique frame identifier");
					_sequence_fail_f000000078I = true;
					goto _sequence_end_f000000078I;
				}
				_sequence_end_f000000078I:
				if (_sequence_fail_f000000078I) {
					_position = _alt_position_f00000006gp;
					_obj = _alt_obj_f00000006gp;
				} else {
					_alternate_success_f00000006gp = true;
				}
			}
			if (_alternate_success_f00000006gp) {
			} else {
				_position = _many_position_f00000006Hn;
				_obj = _many_obj_f00000006Hn;
				break;
			}
		}
		if (expression.ParseRule_expression20(ref _position, out _obj.expr)) {
		} else {
		_sequence_fail_f00000005Tn = true;
		goto _sequence_end_f00000005Tn;
		}
		_sequence_end_f00000005Tn:
		if (_sequence_fail_f00000005Tn) {
			_position.Cache<expression_generate_id>(_start_index, null);
			_position.TraceExit("expression:generate_id", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_generate_id>(_start_index, _obj);
			_position.TraceExit("expression:generate_id", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_greater(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_greater, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_greater();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:greater");

		bool _sequence_fail_f00000005Tx = false;
		if (expression.ParseRule_expression7(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Tx = true;
		goto _sequence_end_f00000005Tx;
		}
		while(true) {
			ParserPosition _many_position_f00000006I0 = _position.Clone();
			var _many_obj_f00000006I0 = _obj.Clone();
			bool _alternate_success_f00000006gt = false;
			ParserPosition _alt_position_f00000006gt = _position;
			var _alt_obj_f00000006gt = _obj;
			if (!_alternate_success_f00000006gt) {
				_position = _alt_position_f00000006gt.Clone();
				_obj = _alt_obj_f00000006gt.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006gt = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "greater-than comparison");
					_position = _alt_position_f00000006gt;
					_obj = _alt_obj_f00000006gt;
				}
			}
			if (!_alternate_success_f00000006gt) {
				_position = _alt_position_f00000006gt.Clone();
				_obj = _alt_obj_f00000006gt.Clone();
				bool _sequence_fail_f000000078P = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "greater-than comparison");
					_sequence_fail_f000000078P = true;
					goto _sequence_end_f000000078P;
				}
				while(true) {
					ParserPosition _many_position_f00000007hQ = _position.Clone();
					var _many_obj_f00000007hQ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "greater-than comparison");
						_position = _many_position_f00000007hQ;
						_obj = _many_obj_f00000007hQ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "greater-than comparison");
					_sequence_fail_f000000078P = true;
					goto _sequence_end_f000000078P;
				}
				_sequence_end_f000000078P:
				if (_sequence_fail_f000000078P) {
					_position = _alt_position_f00000006gt;
					_obj = _alt_obj_f00000006gt;
				} else {
					_alternate_success_f00000006gt = true;
				}
			}
			if (_alternate_success_f00000006gt) {
			} else {
				_position = _many_position_f00000006I0;
				_obj = _many_obj_f00000006I0;
				break;
			}
		}
		if (_position.Match(">")) {
		} else {
			_position.Update("“>”", "greater-than comparison");
			_sequence_fail_f00000005Tx = true;
			goto _sequence_end_f00000005Tx;
		}
		while(true) {
			ParserPosition _many_position_f00000006I1 = _position.Clone();
			var _many_obj_f00000006I1 = _obj.Clone();
			bool _alternate_success_f00000006gu = false;
			ParserPosition _alt_position_f00000006gu = _position;
			var _alt_obj_f00000006gu = _obj;
			if (!_alternate_success_f00000006gu) {
				_position = _alt_position_f00000006gu.Clone();
				_obj = _alt_obj_f00000006gu.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006gu = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "greater-than comparison");
					_position = _alt_position_f00000006gu;
					_obj = _alt_obj_f00000006gu;
				}
			}
			if (!_alternate_success_f00000006gu) {
				_position = _alt_position_f00000006gu.Clone();
				_obj = _alt_obj_f00000006gu.Clone();
				bool _sequence_fail_f000000078T = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "greater-than comparison");
					_sequence_fail_f000000078T = true;
					goto _sequence_end_f000000078T;
				}
				while(true) {
					ParserPosition _many_position_f00000007hW = _position.Clone();
					var _many_obj_f00000007hW = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "greater-than comparison");
						_position = _many_position_f00000007hW;
						_obj = _many_obj_f00000007hW;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "greater-than comparison");
					_sequence_fail_f000000078T = true;
					goto _sequence_end_f000000078T;
				}
				_sequence_end_f000000078T:
				if (_sequence_fail_f000000078T) {
					_position = _alt_position_f00000006gu;
					_obj = _alt_obj_f00000006gu;
				} else {
					_alternate_success_f00000006gu = true;
				}
			}
			if (_alternate_success_f00000006gu) {
			} else {
				_position = _many_position_f00000006I1;
				_obj = _many_obj_f00000006I1;
				break;
			}
		}
		if (expression.ParseRule_expression7(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Tx = true;
		goto _sequence_end_f00000005Tx;
		}
		_sequence_end_f00000005Tx:
		if (_sequence_fail_f00000005Tx) {
			_position.Cache<expression_greater>(_start_index, null);
			_position.TraceExit("expression:greater", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_greater>(_start_index, _obj);
			_position.TraceExit("expression:greater", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_greater_or_equality(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_greater_or_equality, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_greater_or_equality();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:greater_or_equality");

		bool _sequence_fail_f00000005U7 = false;
		if (expression.ParseRule_expression7(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005U7 = true;
		goto _sequence_end_f00000005U7;
		}
		while(true) {
			ParserPosition _many_position_f00000006ID = _position.Clone();
			var _many_obj_f00000006ID = _obj.Clone();
			bool _alternate_success_f00000006h1 = false;
			ParserPosition _alt_position_f00000006h1 = _position;
			var _alt_obj_f00000006h1 = _obj;
			if (!_alternate_success_f00000006h1) {
				_position = _alt_position_f00000006h1.Clone();
				_obj = _alt_obj_f00000006h1.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006h1 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "greater-than or equality comparison");
					_position = _alt_position_f00000006h1;
					_obj = _alt_obj_f00000006h1;
				}
			}
			if (!_alternate_success_f00000006h1) {
				_position = _alt_position_f00000006h1.Clone();
				_obj = _alt_obj_f00000006h1.Clone();
				bool _sequence_fail_f000000078d = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "greater-than or equality comparison");
					_sequence_fail_f000000078d = true;
					goto _sequence_end_f000000078d;
				}
				while(true) {
					ParserPosition _many_position_f00000007hc = _position.Clone();
					var _many_obj_f00000007hc = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "greater-than or equality comparison");
						_position = _many_position_f00000007hc;
						_obj = _many_obj_f00000007hc;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "greater-than or equality comparison");
					_sequence_fail_f000000078d = true;
					goto _sequence_end_f000000078d;
				}
				_sequence_end_f000000078d:
				if (_sequence_fail_f000000078d) {
					_position = _alt_position_f00000006h1;
					_obj = _alt_obj_f00000006h1;
				} else {
					_alternate_success_f00000006h1 = true;
				}
			}
			if (_alternate_success_f00000006h1) {
			} else {
				_position = _many_position_f00000006ID;
				_obj = _many_obj_f00000006ID;
				break;
			}
		}
		if (_position.Match(">=")) {
		} else {
			_position.Update("“>=”", "greater-than or equality comparison");
			_sequence_fail_f00000005U7 = true;
			goto _sequence_end_f00000005U7;
		}
		while(true) {
			ParserPosition _many_position_f00000006IE = _position.Clone();
			var _many_obj_f00000006IE = _obj.Clone();
			bool _alternate_success_f00000006h2 = false;
			ParserPosition _alt_position_f00000006h2 = _position;
			var _alt_obj_f00000006h2 = _obj;
			if (!_alternate_success_f00000006h2) {
				_position = _alt_position_f00000006h2.Clone();
				_obj = _alt_obj_f00000006h2.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006h2 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "greater-than or equality comparison");
					_position = _alt_position_f00000006h2;
					_obj = _alt_obj_f00000006h2;
				}
			}
			if (!_alternate_success_f00000006h2) {
				_position = _alt_position_f00000006h2.Clone();
				_obj = _alt_obj_f00000006h2.Clone();
				bool _sequence_fail_f000000078h = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "greater-than or equality comparison");
					_sequence_fail_f000000078h = true;
					goto _sequence_end_f000000078h;
				}
				while(true) {
					ParserPosition _many_position_f00000007hi = _position.Clone();
					var _many_obj_f00000007hi = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "greater-than or equality comparison");
						_position = _many_position_f00000007hi;
						_obj = _many_obj_f00000007hi;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "greater-than or equality comparison");
					_sequence_fail_f000000078h = true;
					goto _sequence_end_f000000078h;
				}
				_sequence_end_f000000078h:
				if (_sequence_fail_f000000078h) {
					_position = _alt_position_f00000006h2;
					_obj = _alt_obj_f00000006h2;
				} else {
					_alternate_success_f00000006h2 = true;
				}
			}
			if (_alternate_success_f00000006h2) {
			} else {
				_position = _many_position_f00000006IE;
				_obj = _many_obj_f00000006IE;
				break;
			}
		}
		if (expression.ParseRule_expression7(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005U7 = true;
		goto _sequence_end_f00000005U7;
		}
		_sequence_end_f00000005U7:
		if (_sequence_fail_f00000005U7) {
			_position.Cache<expression_greater_or_equality>(_start_index, null);
			_position.TraceExit("expression:greater_or_equality", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_greater_or_equality>(_start_index, _obj);
			_position.TraceExit("expression:greater_or_equality", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_hex_integer_literal(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_hex_integer_literal, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_hex_integer_literal();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:hex_integer_literal");

		bool _sequence_fail_f00000005pl = false;
		if (_position.Match("0x")) {
		} else {
			_position.Update("“0x”", "hexidecimal integral value");
			_sequence_fail_f00000005pl = true;
			goto _sequence_end_f00000005pl;
		}
		bool _first_f00000006IO = true;
		while(true) {
			ParserPosition _many_position_f00000006IO = _position.Clone();
			var _many_obj_f00000006IO = _obj.Clone();
			bool _alternate_success_f00000006h7 = false;
			ParserPosition _alt_position_f00000006h7 = _position;
			var _alt_obj_f00000006h7 = _obj;
			if (!_alternate_success_f00000006h7) {
				_position = _alt_position_f00000006h7.Clone();
				_obj = _alt_obj_f00000006h7.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.amount = _obj.amount * 16 + (_position.PeekLast() - 48);
					_alternate_success_f00000006h7 = true;
				} else {
					_position.Update("character between “0” and “9”", "hexidecimal integral value");
					_position = _alt_position_f00000006h7;
					_obj = _alt_obj_f00000006h7;
				}
			}
			if (!_alternate_success_f00000006h7) {
				_position = _alt_position_f00000006h7.Clone();
				_obj = _alt_obj_f00000006h7.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
				_obj.amount = _obj.amount * 16 + (_position.PeekLast() - 87);
					_alternate_success_f00000006h7 = true;
				} else {
					_position.Update("character between “a” and “f”", "hexidecimal integral value");
					_position = _alt_position_f00000006h7;
					_obj = _alt_obj_f00000006h7;
				}
			}
			if (!_alternate_success_f00000006h7) {
				_position = _alt_position_f00000006h7.Clone();
				_obj = _alt_obj_f00000006h7.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
				_obj.amount = _obj.amount * 16 + (_position.PeekLast() - 55);
					_alternate_success_f00000006h7 = true;
				} else {
					_position.Update("character between “A” and “F”", "hexidecimal integral value");
					_position = _alt_position_f00000006h7;
					_obj = _alt_obj_f00000006h7;
				}
			}
			if (_alternate_success_f00000006h7) {
			} else {
				_position = _many_position_f00000006IO;
				_obj = _many_obj_f00000006IO;
				break;
			}
			_first_f00000006IO = false;
		}
		if (_first_f00000006IO) {
			_sequence_fail_f00000005pl = true;
			goto _sequence_end_f00000005pl;
		} else {
		}
		_sequence_end_f00000005pl:
		if (_sequence_fail_f00000005pl) {
			_position.Cache<expression_hex_integer_literal>(_start_index, null);
			_position.TraceExit("expression:hex_integer_literal", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_hex_integer_literal>(_start_index, _obj);
			_position.TraceExit("expression:hex_integer_literal", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_id(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_id, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_id();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:id");

		if (_position.Match("Id")) {
			_position.Cache<expression_id>(_start_index, _obj);
			_position.TraceExit("expression:id", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		} else {
			_position.Update("“Id”", "unique identifier for current frame");
			_position.Cache<expression_id>(_start_index, null);
			_position.TraceExit("expression:id", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_if(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_if, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_if();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:if");

		bool _sequence_fail_f00000005UT = false;
		if (_position.Match("If")) {
		} else {
			_position.Update("“If”", "conditional expression");
			_sequence_fail_f00000005UT = true;
			goto _sequence_end_f00000005UT;
		}
		bool _first_f00000006If = true;
		while(true) {
			ParserPosition _many_position_f00000006If = _position.Clone();
			var _many_obj_f00000006If = _obj.Clone();
			bool _alternate_success_f00000006hL = false;
			ParserPosition _alt_position_f00000006hL = _position;
			var _alt_obj_f00000006hL = _obj;
			if (!_alternate_success_f00000006hL) {
				_position = _alt_position_f00000006hL.Clone();
				_obj = _alt_obj_f00000006hL.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006hL = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "conditional expression");
					_position = _alt_position_f00000006hL;
					_obj = _alt_obj_f00000006hL;
				}
			}
			if (!_alternate_success_f00000006hL) {
				_position = _alt_position_f00000006hL.Clone();
				_obj = _alt_obj_f00000006hL.Clone();
				bool _sequence_fail_f000000078w = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "conditional expression");
					_sequence_fail_f000000078w = true;
					goto _sequence_end_f000000078w;
				}
				while(true) {
					ParserPosition _many_position_f00000007hw = _position.Clone();
					var _many_obj_f00000007hw = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "conditional expression");
						_position = _many_position_f00000007hw;
						_obj = _many_obj_f00000007hw;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "conditional expression");
					_sequence_fail_f000000078w = true;
					goto _sequence_end_f000000078w;
				}
				_sequence_end_f000000078w:
				if (_sequence_fail_f000000078w) {
					_position = _alt_position_f00000006hL;
					_obj = _alt_obj_f00000006hL;
				} else {
					_alternate_success_f00000006hL = true;
				}
			}
			if (_alternate_success_f00000006hL) {
			} else {
				_position = _many_position_f00000006If;
				_obj = _many_obj_f00000006If;
				break;
			}
			_first_f00000006If = false;
		}
		if (_first_f00000006If) {
			_sequence_fail_f00000005UT = true;
			goto _sequence_end_f00000005UT;
		} else {
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.cond_expr)) {
		} else {
		_sequence_fail_f00000005UT = true;
		goto _sequence_end_f00000005UT;
		}
		bool _first_f00000006Ij = true;
		while(true) {
			ParserPosition _many_position_f00000006Ij = _position.Clone();
			var _many_obj_f00000006Ij = _obj.Clone();
			bool _alternate_success_f00000006hM = false;
			ParserPosition _alt_position_f00000006hM = _position;
			var _alt_obj_f00000006hM = _obj;
			if (!_alternate_success_f00000006hM) {
				_position = _alt_position_f00000006hM.Clone();
				_obj = _alt_obj_f00000006hM.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006hM = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "conditional expression");
					_position = _alt_position_f00000006hM;
					_obj = _alt_obj_f00000006hM;
				}
			}
			if (!_alternate_success_f00000006hM) {
				_position = _alt_position_f00000006hM.Clone();
				_obj = _alt_obj_f00000006hM.Clone();
				bool _sequence_fail_f000000078z = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "conditional expression");
					_sequence_fail_f000000078z = true;
					goto _sequence_end_f000000078z;
				}
				while(true) {
					ParserPosition _many_position_f00000007i2 = _position.Clone();
					var _many_obj_f00000007i2 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "conditional expression");
						_position = _many_position_f00000007i2;
						_obj = _many_obj_f00000007i2;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "conditional expression");
					_sequence_fail_f000000078z = true;
					goto _sequence_end_f000000078z;
				}
				_sequence_end_f000000078z:
				if (_sequence_fail_f000000078z) {
					_position = _alt_position_f00000006hM;
					_obj = _alt_obj_f00000006hM;
				} else {
					_alternate_success_f00000006hM = true;
				}
			}
			if (_alternate_success_f00000006hM) {
			} else {
				_position = _many_position_f00000006Ij;
				_obj = _many_obj_f00000006Ij;
				break;
			}
			_first_f00000006Ij = false;
		}
		if (_first_f00000006Ij) {
			_sequence_fail_f00000005UT = true;
			goto _sequence_end_f00000005UT;
		} else {
		}
		if (_position.Match("Then")) {
		} else {
			_position.Update("“Then”", "conditional expression");
			_sequence_fail_f00000005UT = true;
			goto _sequence_end_f00000005UT;
		}
		bool _first_f00000006Il = true;
		while(true) {
			ParserPosition _many_position_f00000006Il = _position.Clone();
			var _many_obj_f00000006Il = _obj.Clone();
			bool _alternate_success_f00000006hN = false;
			ParserPosition _alt_position_f00000006hN = _position;
			var _alt_obj_f00000006hN = _obj;
			if (!_alternate_success_f00000006hN) {
				_position = _alt_position_f00000006hN.Clone();
				_obj = _alt_obj_f00000006hN.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006hN = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "conditional expression");
					_position = _alt_position_f00000006hN;
					_obj = _alt_obj_f00000006hN;
				}
			}
			if (!_alternate_success_f00000006hN) {
				_position = _alt_position_f00000006hN.Clone();
				_obj = _alt_obj_f00000006hN.Clone();
				bool _sequence_fail_f0000000792 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "conditional expression");
					_sequence_fail_f0000000792 = true;
					goto _sequence_end_f0000000792;
				}
				while(true) {
					ParserPosition _many_position_f00000007i8 = _position.Clone();
					var _many_obj_f00000007i8 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "conditional expression");
						_position = _many_position_f00000007i8;
						_obj = _many_obj_f00000007i8;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "conditional expression");
					_sequence_fail_f0000000792 = true;
					goto _sequence_end_f0000000792;
				}
				_sequence_end_f0000000792:
				if (_sequence_fail_f0000000792) {
					_position = _alt_position_f00000006hN;
					_obj = _alt_obj_f00000006hN;
				} else {
					_alternate_success_f00000006hN = true;
				}
			}
			if (_alternate_success_f00000006hN) {
			} else {
				_position = _many_position_f00000006Il;
				_obj = _many_obj_f00000006Il;
				break;
			}
			_first_f00000006Il = false;
		}
		if (_first_f00000006Il) {
			_sequence_fail_f00000005UT = true;
			goto _sequence_end_f00000005UT;
		} else {
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.then_expr)) {
		} else {
		_sequence_fail_f00000005UT = true;
		goto _sequence_end_f00000005UT;
		}
		bool _first_f00000006Ip = true;
		while(true) {
			ParserPosition _many_position_f00000006Ip = _position.Clone();
			var _many_obj_f00000006Ip = _obj.Clone();
			bool _alternate_success_f00000006hO = false;
			ParserPosition _alt_position_f00000006hO = _position;
			var _alt_obj_f00000006hO = _obj;
			if (!_alternate_success_f00000006hO) {
				_position = _alt_position_f00000006hO.Clone();
				_obj = _alt_obj_f00000006hO.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006hO = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "conditional expression");
					_position = _alt_position_f00000006hO;
					_obj = _alt_obj_f00000006hO;
				}
			}
			if (!_alternate_success_f00000006hO) {
				_position = _alt_position_f00000006hO.Clone();
				_obj = _alt_obj_f00000006hO.Clone();
				bool _sequence_fail_f0000000795 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "conditional expression");
					_sequence_fail_f0000000795 = true;
					goto _sequence_end_f0000000795;
				}
				while(true) {
					ParserPosition _many_position_f00000007iE = _position.Clone();
					var _many_obj_f00000007iE = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "conditional expression");
						_position = _many_position_f00000007iE;
						_obj = _many_obj_f00000007iE;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "conditional expression");
					_sequence_fail_f0000000795 = true;
					goto _sequence_end_f0000000795;
				}
				_sequence_end_f0000000795:
				if (_sequence_fail_f0000000795) {
					_position = _alt_position_f00000006hO;
					_obj = _alt_obj_f00000006hO;
				} else {
					_alternate_success_f00000006hO = true;
				}
			}
			if (_alternate_success_f00000006hO) {
			} else {
				_position = _many_position_f00000006Ip;
				_obj = _many_obj_f00000006Ip;
				break;
			}
			_first_f00000006Ip = false;
		}
		if (_first_f00000006Ip) {
			_sequence_fail_f00000005UT = true;
			goto _sequence_end_f00000005UT;
		} else {
		}
		if (_position.Match("Else")) {
		} else {
			_position.Update("“Else”", "conditional expression");
			_sequence_fail_f00000005UT = true;
			goto _sequence_end_f00000005UT;
		}
		bool _first_f00000006Ir = true;
		while(true) {
			ParserPosition _many_position_f00000006Ir = _position.Clone();
			var _many_obj_f00000006Ir = _obj.Clone();
			bool _alternate_success_f00000006hP = false;
			ParserPosition _alt_position_f00000006hP = _position;
			var _alt_obj_f00000006hP = _obj;
			if (!_alternate_success_f00000006hP) {
				_position = _alt_position_f00000006hP.Clone();
				_obj = _alt_obj_f00000006hP.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006hP = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "conditional expression");
					_position = _alt_position_f00000006hP;
					_obj = _alt_obj_f00000006hP;
				}
			}
			if (!_alternate_success_f00000006hP) {
				_position = _alt_position_f00000006hP.Clone();
				_obj = _alt_obj_f00000006hP.Clone();
				bool _sequence_fail_f0000000798 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "conditional expression");
					_sequence_fail_f0000000798 = true;
					goto _sequence_end_f0000000798;
				}
				while(true) {
					ParserPosition _many_position_f00000007iK = _position.Clone();
					var _many_obj_f00000007iK = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "conditional expression");
						_position = _many_position_f00000007iK;
						_obj = _many_obj_f00000007iK;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "conditional expression");
					_sequence_fail_f0000000798 = true;
					goto _sequence_end_f0000000798;
				}
				_sequence_end_f0000000798:
				if (_sequence_fail_f0000000798) {
					_position = _alt_position_f00000006hP;
					_obj = _alt_obj_f00000006hP;
				} else {
					_alternate_success_f00000006hP = true;
				}
			}
			if (_alternate_success_f00000006hP) {
			} else {
				_position = _many_position_f00000006Ir;
				_obj = _many_obj_f00000006Ir;
				break;
			}
			_first_f00000006Ir = false;
		}
		if (_first_f00000006Ir) {
			_sequence_fail_f00000005UT = true;
			goto _sequence_end_f00000005UT;
		} else {
		}
		if (expression.ParseRule_expression2(ref _position, out _obj.else_expr)) {
		} else {
		_sequence_fail_f00000005UT = true;
		goto _sequence_end_f00000005UT;
		}
		_sequence_end_f00000005UT:
		if (_sequence_fail_f00000005UT) {
			_position.Cache<expression_if>(_start_index, null);
			_position.TraceExit("expression:if", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_if>(_start_index, _obj);
			_position.TraceExit("expression:if", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_inequality(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_inequality, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_inequality();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:inequality");

		bool _sequence_fail_f00000005Ud = false;
		if (expression.ParseRule_expression7(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Ud = true;
		goto _sequence_end_f00000005Ud;
		}
		while(true) {
			ParserPosition _many_position_f00000006J4 = _position.Clone();
			var _many_obj_f00000006J4 = _obj.Clone();
			bool _alternate_success_f00000006hT = false;
			ParserPosition _alt_position_f00000006hT = _position;
			var _alt_obj_f00000006hT = _obj;
			if (!_alternate_success_f00000006hT) {
				_position = _alt_position_f00000006hT.Clone();
				_obj = _alt_obj_f00000006hT.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006hT = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "inequality comparison");
					_position = _alt_position_f00000006hT;
					_obj = _alt_obj_f00000006hT;
				}
			}
			if (!_alternate_success_f00000006hT) {
				_position = _alt_position_f00000006hT.Clone();
				_obj = _alt_obj_f00000006hT.Clone();
				bool _sequence_fail_f000000079I = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "inequality comparison");
					_sequence_fail_f000000079I = true;
					goto _sequence_end_f000000079I;
				}
				while(true) {
					ParserPosition _many_position_f00000007iQ = _position.Clone();
					var _many_obj_f00000007iQ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "inequality comparison");
						_position = _many_position_f00000007iQ;
						_obj = _many_obj_f00000007iQ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "inequality comparison");
					_sequence_fail_f000000079I = true;
					goto _sequence_end_f000000079I;
				}
				_sequence_end_f000000079I:
				if (_sequence_fail_f000000079I) {
					_position = _alt_position_f00000006hT;
					_obj = _alt_obj_f00000006hT;
				} else {
					_alternate_success_f00000006hT = true;
				}
			}
			if (_alternate_success_f00000006hT) {
			} else {
				_position = _many_position_f00000006J4;
				_obj = _many_obj_f00000006J4;
				break;
			}
		}
		if (_position.Match("!=")) {
		} else {
			_position.Update("“!=”", "inequality comparison");
			_sequence_fail_f00000005Ud = true;
			goto _sequence_end_f00000005Ud;
		}
		while(true) {
			ParserPosition _many_position_f00000006J5 = _position.Clone();
			var _many_obj_f00000006J5 = _obj.Clone();
			bool _alternate_success_f00000006hU = false;
			ParserPosition _alt_position_f00000006hU = _position;
			var _alt_obj_f00000006hU = _obj;
			if (!_alternate_success_f00000006hU) {
				_position = _alt_position_f00000006hU.Clone();
				_obj = _alt_obj_f00000006hU.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006hU = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "inequality comparison");
					_position = _alt_position_f00000006hU;
					_obj = _alt_obj_f00000006hU;
				}
			}
			if (!_alternate_success_f00000006hU) {
				_position = _alt_position_f00000006hU.Clone();
				_obj = _alt_obj_f00000006hU.Clone();
				bool _sequence_fail_f000000079M = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "inequality comparison");
					_sequence_fail_f000000079M = true;
					goto _sequence_end_f000000079M;
				}
				while(true) {
					ParserPosition _many_position_f00000007iW = _position.Clone();
					var _many_obj_f00000007iW = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "inequality comparison");
						_position = _many_position_f00000007iW;
						_obj = _many_obj_f00000007iW;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "inequality comparison");
					_sequence_fail_f000000079M = true;
					goto _sequence_end_f000000079M;
				}
				_sequence_end_f000000079M:
				if (_sequence_fail_f000000079M) {
					_position = _alt_position_f00000006hU;
					_obj = _alt_obj_f00000006hU;
				} else {
					_alternate_success_f00000006hU = true;
				}
			}
			if (_alternate_success_f00000006hU) {
			} else {
				_position = _many_position_f00000006J5;
				_obj = _many_obj_f00000006J5;
				break;
			}
		}
		if (expression.ParseRule_expression7(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Ud = true;
		goto _sequence_end_f00000005Ud;
		}
		_sequence_end_f00000005Ud:
		if (_sequence_fail_f00000005Ud) {
			_position.Cache<expression_inequality>(_start_index, null);
			_position.TraceExit("expression:inequality", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_inequality>(_start_index, _obj);
			_position.TraceExit("expression:inequality", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_infinity(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_infinity, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_infinity();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:infinity");

		if (_position.Match("Infinity")) {
			_position.Cache<expression_infinity>(_start_index, _obj);
			_position.TraceExit("expression:infinity", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		} else {
			_position.Update("“Infinity”", "floating-point infinite value");
			_position.Cache<expression_infinity>(_start_index, null);
			_position.TraceExit("expression:infinity", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_instantiation(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_instantiation, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_instantiation();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:instantiation");

		bool _sequence_fail_f00000005Ut = false;
		if (expression.ParseRule_expression18(ref _position, out _obj.source)) {
		} else {
		_sequence_fail_f00000005Ut = true;
		goto _sequence_end_f00000005Ut;
		}
		while(true) {
			ParserPosition _many_position_f00000006JL = _position.Clone();
			var _many_obj_f00000006JL = _obj.Clone();
			bool _alternate_success_f00000006he = false;
			ParserPosition _alt_position_f00000006he = _position;
			var _alt_obj_f00000006he = _obj;
			if (!_alternate_success_f00000006he) {
				_position = _alt_position_f00000006he.Clone();
				_obj = _alt_obj_f00000006he.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006he = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "template instantiation");
					_position = _alt_position_f00000006he;
					_obj = _alt_obj_f00000006he;
				}
			}
			if (!_alternate_success_f00000006he) {
				_position = _alt_position_f00000006he.Clone();
				_obj = _alt_obj_f00000006he.Clone();
				bool _sequence_fail_f000000079V = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "template instantiation");
					_sequence_fail_f000000079V = true;
					goto _sequence_end_f000000079V;
				}
				while(true) {
					ParserPosition _many_position_f00000007ih = _position.Clone();
					var _many_obj_f00000007ih = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "template instantiation");
						_position = _many_position_f00000007ih;
						_obj = _many_obj_f00000007ih;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "template instantiation");
					_sequence_fail_f000000079V = true;
					goto _sequence_end_f000000079V;
				}
				_sequence_end_f000000079V:
				if (_sequence_fail_f000000079V) {
					_position = _alt_position_f00000006he;
					_obj = _alt_obj_f00000006he;
				} else {
					_alternate_success_f00000006he = true;
				}
			}
			if (_alternate_success_f00000006he) {
			} else {
				_position = _many_position_f00000006JL;
				_obj = _many_obj_f00000006JL;
				break;
			}
		}
		if (_position.Match("{")) {
		} else {
			_position.Update("“{”", "template instantiation");
			_sequence_fail_f00000005Ut = true;
			goto _sequence_end_f00000005Ut;
		}
		while(true) {
			ParserPosition _many_position_f00000006JO = _position.Clone();
			var _many_obj_f00000006JO = _obj.Clone();
			bool _sequence_fail_f00000006hf = false;
			while(true) {
				ParserPosition _many_position_f000000079X = _position.Clone();
				var _many_obj_f000000079X = _obj.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "template instantiation");
					_position = _many_position_f000000079X;
					_obj = _many_obj_f000000079X;
					break;
				}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.overrides, (ref ParserPosition _iposition, out attribute _iresult) => { if (attribute.ParseRule_instantiate_tmpl_attributes(ref _iposition, out _iresult)) { var f000000079Y_key = Generator.ToString(_iresult.name); if (_obj.overrides_dedup.ContainsKey(f000000079Y_key)) { _iposition.NameConstraint(f000000079Y_key); return false; } else { _obj.overrides_dedup[f000000079Y_key] = true; return true; } } else { return false; } })) {
			} else {
			_sequence_fail_f00000006hf = true;
			goto _sequence_end_f00000006hf;
			}
			_sequence_end_f00000006hf:
			if (_sequence_fail_f00000006hf) {
				_position = _many_position_f00000006JO;
				_obj = _many_obj_f00000006JO;
				break;
			} else {
			}
		}
		while(true) {
			ParserPosition _many_position_f00000006JP = _position.Clone();
			var _many_obj_f00000006JP = _obj.Clone();
			bool _alternate_success_f00000006hg = false;
			ParserPosition _alt_position_f00000006hg = _position;
			var _alt_obj_f00000006hg = _obj;
			if (!_alternate_success_f00000006hg) {
				_position = _alt_position_f00000006hg.Clone();
				_obj = _alt_obj_f00000006hg.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006hg = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "template instantiation");
					_position = _alt_position_f00000006hg;
					_obj = _alt_obj_f00000006hg;
				}
			}
			if (!_alternate_success_f00000006hg) {
				_position = _alt_position_f00000006hg.Clone();
				_obj = _alt_obj_f00000006hg.Clone();
				bool _sequence_fail_f000000079b = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "template instantiation");
					_sequence_fail_f000000079b = true;
					goto _sequence_end_f000000079b;
				}
				while(true) {
					ParserPosition _many_position_f00000007iu = _position.Clone();
					var _many_obj_f00000007iu = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "template instantiation");
						_position = _many_position_f00000007iu;
						_obj = _many_obj_f00000007iu;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "template instantiation");
					_sequence_fail_f000000079b = true;
					goto _sequence_end_f000000079b;
				}
				_sequence_end_f000000079b:
				if (_sequence_fail_f000000079b) {
					_position = _alt_position_f00000006hg;
					_obj = _alt_obj_f00000006hg;
				} else {
					_alternate_success_f00000006hg = true;
				}
			}
			if (_alternate_success_f00000006hg) {
			} else {
				_position = _many_position_f00000006JP;
				_obj = _many_obj_f00000006JP;
				break;
			}
		}
		if (_position.Match("}")) {
		} else {
			_position.Update("“}”", "template instantiation");
			_sequence_fail_f00000005Ut = true;
			goto _sequence_end_f00000005Ut;
		}
		_sequence_end_f00000005Ut:
		if (_sequence_fail_f00000005Ut) {
			_position.Cache<expression_instantiation>(_start_index, null);
			_position.TraceExit("expression:instantiation", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_instantiation>(_start_index, _obj);
			_position.TraceExit("expression:instantiation", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_int_ig(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_int_ig, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_int_ig();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:int_ig");

		bool _sequence_fail_f00000005Uy = false;
		bool _alternate_success_f00000006JX = false;
		ParserPosition _alt_position_f00000006JX = _position;
		var _alt_obj_f00000006JX = _obj;
		if (!_alternate_success_f00000006JX) {
			_position = _alt_position_f00000006JX.Clone();
			_obj = _alt_obj_f00000006JX.Clone();
			if (_position.Match("0")) {
				_alternate_success_f00000006JX = true;
			} else {
				_position.Update("“0”", "integral value with unit Gi");
				_position = _alt_position_f00000006JX;
				_obj = _alt_obj_f00000006JX;
			}
		}
		if (!_alternate_success_f00000006JX) {
			_position = _alt_position_f00000006JX.Clone();
			_obj = _alt_obj_f00000006JX.Clone();
			bool _sequence_fail_f00000006hj = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
			} else {
				_position.Update("character between “1” and “9”", "integral value with unit Gi");
				_sequence_fail_f00000006hj = true;
				goto _sequence_end_f00000006hj;
			}
			while(true) {
				ParserPosition _many_position_f000000079i = _position.Clone();
				var _many_obj_f000000079i = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “9”", "integral value with unit Gi");
					_position = _many_position_f000000079i;
					_obj = _many_obj_f000000079i;
					break;
				}
			}
			_sequence_end_f00000006hj:
			if (_sequence_fail_f00000006hj) {
				_position = _alt_position_f00000006JX;
				_obj = _alt_obj_f00000006JX;
			} else {
				_alternate_success_f00000006JX = true;
			}
		}
		if (_alternate_success_f00000006JX) {
		} else {
			_sequence_fail_f00000005Uy = true;
			goto _sequence_end_f00000005Uy;
		}
		if (_position.Match("Gi")) {
		} else {
			_position.Update("“Gi”", "integral value with unit Gi");
			_sequence_fail_f00000005Uy = true;
			goto _sequence_end_f00000005Uy;
		}
		_sequence_end_f00000005Uy:
		if (_sequence_fail_f00000005Uy) {
			_position.Cache<expression_int_ig>(_start_index, null);
			_position.TraceExit("expression:int_ig", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_int_ig>(_start_index, _obj);
			_position.TraceExit("expression:int_ig", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_int_ik(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_int_ik, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_int_ik();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:int_ik");

		bool _sequence_fail_f00000005V3 = false;
		bool _alternate_success_f00000006Jd = false;
		ParserPosition _alt_position_f00000006Jd = _position;
		var _alt_obj_f00000006Jd = _obj;
		if (!_alternate_success_f00000006Jd) {
			_position = _alt_position_f00000006Jd.Clone();
			_obj = _alt_obj_f00000006Jd.Clone();
			if (_position.Match("0")) {
				_alternate_success_f00000006Jd = true;
			} else {
				_position.Update("“0”", "integral value with unit ki");
				_position = _alt_position_f00000006Jd;
				_obj = _alt_obj_f00000006Jd;
			}
		}
		if (!_alternate_success_f00000006Jd) {
			_position = _alt_position_f00000006Jd.Clone();
			_obj = _alt_obj_f00000006Jd.Clone();
			bool _sequence_fail_f00000006hm = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
			} else {
				_position.Update("character between “1” and “9”", "integral value with unit ki");
				_sequence_fail_f00000006hm = true;
				goto _sequence_end_f00000006hm;
			}
			while(true) {
				ParserPosition _many_position_f000000079p = _position.Clone();
				var _many_obj_f000000079p = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “9”", "integral value with unit ki");
					_position = _many_position_f000000079p;
					_obj = _many_obj_f000000079p;
					break;
				}
			}
			_sequence_end_f00000006hm:
			if (_sequence_fail_f00000006hm) {
				_position = _alt_position_f00000006Jd;
				_obj = _alt_obj_f00000006Jd;
			} else {
				_alternate_success_f00000006Jd = true;
			}
		}
		if (_alternate_success_f00000006Jd) {
		} else {
			_sequence_fail_f00000005V3 = true;
			goto _sequence_end_f00000005V3;
		}
		if (_position.Match("ki")) {
		} else {
			_position.Update("“ki”", "integral value with unit ki");
			_sequence_fail_f00000005V3 = true;
			goto _sequence_end_f00000005V3;
		}
		_sequence_end_f00000005V3:
		if (_sequence_fail_f00000005V3) {
			_position.Cache<expression_int_ik>(_start_index, null);
			_position.TraceExit("expression:int_ik", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_int_ik>(_start_index, _obj);
			_position.TraceExit("expression:int_ik", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_int_im(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_int_im, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_int_im();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:int_im");

		bool _sequence_fail_f00000005V8 = false;
		bool _alternate_success_f00000006Jj = false;
		ParserPosition _alt_position_f00000006Jj = _position;
		var _alt_obj_f00000006Jj = _obj;
		if (!_alternate_success_f00000006Jj) {
			_position = _alt_position_f00000006Jj.Clone();
			_obj = _alt_obj_f00000006Jj.Clone();
			if (_position.Match("0")) {
				_alternate_success_f00000006Jj = true;
			} else {
				_position.Update("“0”", "integral value with unit Mi");
				_position = _alt_position_f00000006Jj;
				_obj = _alt_obj_f00000006Jj;
			}
		}
		if (!_alternate_success_f00000006Jj) {
			_position = _alt_position_f00000006Jj.Clone();
			_obj = _alt_obj_f00000006Jj.Clone();
			bool _sequence_fail_f00000006hp = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
			} else {
				_position.Update("character between “1” and “9”", "integral value with unit Mi");
				_sequence_fail_f00000006hp = true;
				goto _sequence_end_f00000006hp;
			}
			while(true) {
				ParserPosition _many_position_f000000079w = _position.Clone();
				var _many_obj_f000000079w = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “9”", "integral value with unit Mi");
					_position = _many_position_f000000079w;
					_obj = _many_obj_f000000079w;
					break;
				}
			}
			_sequence_end_f00000006hp:
			if (_sequence_fail_f00000006hp) {
				_position = _alt_position_f00000006Jj;
				_obj = _alt_obj_f00000006Jj;
			} else {
				_alternate_success_f00000006Jj = true;
			}
		}
		if (_alternate_success_f00000006Jj) {
		} else {
			_sequence_fail_f00000005V8 = true;
			goto _sequence_end_f00000005V8;
		}
		if (_position.Match("Mi")) {
		} else {
			_position.Update("“Mi”", "integral value with unit Mi");
			_sequence_fail_f00000005V8 = true;
			goto _sequence_end_f00000005V8;
		}
		_sequence_end_f00000005V8:
		if (_sequence_fail_f00000005V8) {
			_position.Cache<expression_int_im>(_start_index, null);
			_position.TraceExit("expression:int_im", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_int_im>(_start_index, _obj);
			_position.TraceExit("expression:int_im", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_int_max(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_int_max, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_int_max();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:int_max");

		if (_position.Match("IntMax")) {
			_position.Cache<expression_int_max>(_start_index, _obj);
			_position.TraceExit("expression:int_max", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		} else {
			_position.Update("“IntMax”", "largest integral value");
			_position.Cache<expression_int_max>(_start_index, null);
			_position.TraceExit("expression:int_max", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_int_min(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_int_min, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_int_min();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:int_min");

		if (_position.Match("IntMin")) {
			_position.Cache<expression_int_min>(_start_index, _obj);
			_position.TraceExit("expression:int_min", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		} else {
			_position.Update("“IntMin”", "smallest integral value");
			_position.Cache<expression_int_min>(_start_index, null);
			_position.TraceExit("expression:int_min", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_int_sg(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_int_sg, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_int_sg();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:int_sg");

		bool _sequence_fail_f00000005VN = false;
		bool _alternate_success_f00000006Jp = false;
		ParserPosition _alt_position_f00000006Jp = _position;
		var _alt_obj_f00000006Jp = _obj;
		if (!_alternate_success_f00000006Jp) {
			_position = _alt_position_f00000006Jp.Clone();
			_obj = _alt_obj_f00000006Jp.Clone();
			if (_position.Match("0")) {
				_alternate_success_f00000006Jp = true;
			} else {
				_position.Update("“0”", "integral value with unit G");
				_position = _alt_position_f00000006Jp;
				_obj = _alt_obj_f00000006Jp;
			}
		}
		if (!_alternate_success_f00000006Jp) {
			_position = _alt_position_f00000006Jp.Clone();
			_obj = _alt_obj_f00000006Jp.Clone();
			bool _sequence_fail_f00000006hu = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
			} else {
				_position.Update("character between “1” and “9”", "integral value with unit G");
				_sequence_fail_f00000006hu = true;
				goto _sequence_end_f00000006hu;
			}
			while(true) {
				ParserPosition _many_position_f00000007A3 = _position.Clone();
				var _many_obj_f00000007A3 = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “9”", "integral value with unit G");
					_position = _many_position_f00000007A3;
					_obj = _many_obj_f00000007A3;
					break;
				}
			}
			_sequence_end_f00000006hu:
			if (_sequence_fail_f00000006hu) {
				_position = _alt_position_f00000006Jp;
				_obj = _alt_obj_f00000006Jp;
			} else {
				_alternate_success_f00000006Jp = true;
			}
		}
		if (_alternate_success_f00000006Jp) {
		} else {
			_sequence_fail_f00000005VN = true;
			goto _sequence_end_f00000005VN;
		}
		if (_position.Match("G")) {
		} else {
			_position.Update("“G”", "integral value with unit G");
			_sequence_fail_f00000005VN = true;
			goto _sequence_end_f00000005VN;
		}
		_sequence_end_f00000005VN:
		if (_sequence_fail_f00000005VN) {
			_position.Cache<expression_int_sg>(_start_index, null);
			_position.TraceExit("expression:int_sg", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_int_sg>(_start_index, _obj);
			_position.TraceExit("expression:int_sg", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_int_sk(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_int_sk, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_int_sk();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:int_sk");

		bool _sequence_fail_f00000005VS = false;
		bool _alternate_success_f00000006Jv = false;
		ParserPosition _alt_position_f00000006Jv = _position;
		var _alt_obj_f00000006Jv = _obj;
		if (!_alternate_success_f00000006Jv) {
			_position = _alt_position_f00000006Jv.Clone();
			_obj = _alt_obj_f00000006Jv.Clone();
			if (_position.Match("0")) {
				_alternate_success_f00000006Jv = true;
			} else {
				_position.Update("“0”", "integral value with unit k");
				_position = _alt_position_f00000006Jv;
				_obj = _alt_obj_f00000006Jv;
			}
		}
		if (!_alternate_success_f00000006Jv) {
			_position = _alt_position_f00000006Jv.Clone();
			_obj = _alt_obj_f00000006Jv.Clone();
			bool _sequence_fail_f00000006hx = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
			} else {
				_position.Update("character between “1” and “9”", "integral value with unit k");
				_sequence_fail_f00000006hx = true;
				goto _sequence_end_f00000006hx;
			}
			while(true) {
				ParserPosition _many_position_f00000007AA = _position.Clone();
				var _many_obj_f00000007AA = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “9”", "integral value with unit k");
					_position = _many_position_f00000007AA;
					_obj = _many_obj_f00000007AA;
					break;
				}
			}
			_sequence_end_f00000006hx:
			if (_sequence_fail_f00000006hx) {
				_position = _alt_position_f00000006Jv;
				_obj = _alt_obj_f00000006Jv;
			} else {
				_alternate_success_f00000006Jv = true;
			}
		}
		if (_alternate_success_f00000006Jv) {
		} else {
			_sequence_fail_f00000005VS = true;
			goto _sequence_end_f00000005VS;
		}
		if (_position.Match("k")) {
		} else {
			_position.Update("“k”", "integral value with unit k");
			_sequence_fail_f00000005VS = true;
			goto _sequence_end_f00000005VS;
		}
		_sequence_end_f00000005VS:
		if (_sequence_fail_f00000005VS) {
			_position.Cache<expression_int_sk>(_start_index, null);
			_position.TraceExit("expression:int_sk", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_int_sk>(_start_index, _obj);
			_position.TraceExit("expression:int_sk", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_int_sm(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_int_sm, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_int_sm();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:int_sm");

		bool _sequence_fail_f00000005VX = false;
		bool _alternate_success_f00000006K1 = false;
		ParserPosition _alt_position_f00000006K1 = _position;
		var _alt_obj_f00000006K1 = _obj;
		if (!_alternate_success_f00000006K1) {
			_position = _alt_position_f00000006K1.Clone();
			_obj = _alt_obj_f00000006K1.Clone();
			if (_position.Match("0")) {
				_alternate_success_f00000006K1 = true;
			} else {
				_position.Update("“0”", "integral value with unit M");
				_position = _alt_position_f00000006K1;
				_obj = _alt_obj_f00000006K1;
			}
		}
		if (!_alternate_success_f00000006K1) {
			_position = _alt_position_f00000006K1.Clone();
			_obj = _alt_obj_f00000006K1.Clone();
			bool _sequence_fail_f00000006i0 = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
			} else {
				_position.Update("character between “1” and “9”", "integral value with unit M");
				_sequence_fail_f00000006i0 = true;
				goto _sequence_end_f00000006i0;
			}
			while(true) {
				ParserPosition _many_position_f00000007AH = _position.Clone();
				var _many_obj_f00000007AH = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “9”", "integral value with unit M");
					_position = _many_position_f00000007AH;
					_obj = _many_obj_f00000007AH;
					break;
				}
			}
			_sequence_end_f00000006i0:
			if (_sequence_fail_f00000006i0) {
				_position = _alt_position_f00000006K1;
				_obj = _alt_obj_f00000006K1;
			} else {
				_alternate_success_f00000006K1 = true;
			}
		}
		if (_alternate_success_f00000006K1) {
		} else {
			_sequence_fail_f00000005VX = true;
			goto _sequence_end_f00000005VX;
		}
		if (_position.Match("M")) {
		} else {
			_position.Update("“M”", "integral value with unit M");
			_sequence_fail_f00000005VX = true;
			goto _sequence_end_f00000005VX;
		}
		_sequence_end_f00000005VX:
		if (_sequence_fail_f00000005VX) {
			_position.Cache<expression_int_sm>(_start_index, null);
			_position.TraceExit("expression:int_sm", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_int_sm>(_start_index, _obj);
			_position.TraceExit("expression:int_sm", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_integer_literal(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_integer_literal, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_integer_literal();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:integer_literal");

		bool _sequence_fail_f00000005rv = false;
		bool _alternate_success_f00000006K9 = false;
		ParserPosition _alt_position_f00000006K9 = _position;
		var _alt_obj_f00000006K9 = _obj;
		if (!_alternate_success_f00000006K9) {
			_position = _alt_position_f00000006K9.Clone();
			_obj = _alt_obj_f00000006K9.Clone();
			if (_position.Match("0")) {
				_alternate_success_f00000006K9 = true;
			} else {
				_position.Update("“0”", "integral value");
				_position = _alt_position_f00000006K9;
				_obj = _alt_obj_f00000006K9;
			}
		}
		if (!_alternate_success_f00000006K9) {
			_position = _alt_position_f00000006K9.Clone();
			_obj = _alt_obj_f00000006K9.Clone();
			bool _sequence_fail_f00000006i3 = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_obj.amount = _obj.amount * 10 + (_position.PeekLast() - 48);
			} else {
				_position.Update("character between “1” and “9”", "integral value");
				_sequence_fail_f00000006i3 = true;
				goto _sequence_end_f00000006i3;
			}
			while(true) {
				ParserPosition _many_position_f00000007AP = _position.Clone();
				var _many_obj_f00000007AP = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.amount = _obj.amount * 10 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “9”", "integral value");
					_position = _many_position_f00000007AP;
					_obj = _many_obj_f00000007AP;
					break;
				}
			}
			_sequence_end_f00000006i3:
			if (_sequence_fail_f00000006i3) {
				_position = _alt_position_f00000006K9;
				_obj = _alt_obj_f00000006K9;
			} else {
				_alternate_success_f00000006K9 = true;
			}
		}
		if (_alternate_success_f00000006K9) {
		} else {
			_sequence_fail_f00000005rv = true;
			goto _sequence_end_f00000005rv;
		}
		if (_position.Index >= _position.Parser.Input.Length || ".eGMkdhms".IndexOf(_position.Parser.Input[_position.Index]) == -1) {
		} else {
			_position.Update("anything except " + Parser.ToLiteral(".eGMkdhms"), "integral value");
			_sequence_fail_f00000005rv = true;
			goto _sequence_end_f00000005rv;
		}
		_sequence_end_f00000005rv:
		if (_sequence_fail_f00000005rv) {
			_position.Cache<expression_integer_literal>(_start_index, null);
			_position.TraceExit("expression:integer_literal", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_integer_literal>(_start_index, _obj);
			_position.TraceExit("expression:integer_literal", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_is_finite(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_is_finite, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_is_finite();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:is_finite");

		bool _sequence_fail_f00000005Vm = false;
		if (expression.ParseRule_expression15(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Vm = true;
		goto _sequence_end_f00000005Vm;
		}
		while(true) {
			ParserPosition _many_position_f00000006KH = _position.Clone();
			var _many_obj_f00000006KH = _obj.Clone();
			bool _alternate_success_f00000006iD = false;
			ParserPosition _alt_position_f00000006iD = _position;
			var _alt_obj_f00000006iD = _obj;
			if (!_alternate_success_f00000006iD) {
				_position = _alt_position_f00000006iD.Clone();
				_obj = _alt_obj_f00000006iD.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006iD = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "finite check");
					_position = _alt_position_f00000006iD;
					_obj = _alt_obj_f00000006iD;
				}
			}
			if (!_alternate_success_f00000006iD) {
				_position = _alt_position_f00000006iD.Clone();
				_obj = _alt_obj_f00000006iD.Clone();
				bool _sequence_fail_f00000007AZ = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "finite check");
					_sequence_fail_f00000007AZ = true;
					goto _sequence_end_f00000007AZ;
				}
				while(true) {
					ParserPosition _many_position_f00000007jh = _position.Clone();
					var _many_obj_f00000007jh = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "finite check");
						_position = _many_position_f00000007jh;
						_obj = _many_obj_f00000007jh;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "finite check");
					_sequence_fail_f00000007AZ = true;
					goto _sequence_end_f00000007AZ;
				}
				_sequence_end_f00000007AZ:
				if (_sequence_fail_f00000007AZ) {
					_position = _alt_position_f00000006iD;
					_obj = _alt_obj_f00000006iD;
				} else {
					_alternate_success_f00000006iD = true;
				}
			}
			if (_alternate_success_f00000006iD) {
			} else {
				_position = _many_position_f00000006KH;
				_obj = _many_obj_f00000006KH;
				break;
			}
		}
		if (_position.Match("Is")) {
		} else {
			_position.Update("“Is”", "finite check");
			_sequence_fail_f00000005Vm = true;
			goto _sequence_end_f00000005Vm;
		}
		while(true) {
			ParserPosition _many_position_f00000006KI = _position.Clone();
			var _many_obj_f00000006KI = _obj.Clone();
			bool _alternate_success_f00000006iE = false;
			ParserPosition _alt_position_f00000006iE = _position;
			var _alt_obj_f00000006iE = _obj;
			if (!_alternate_success_f00000006iE) {
				_position = _alt_position_f00000006iE.Clone();
				_obj = _alt_obj_f00000006iE.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006iE = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "finite check");
					_position = _alt_position_f00000006iE;
					_obj = _alt_obj_f00000006iE;
				}
			}
			if (!_alternate_success_f00000006iE) {
				_position = _alt_position_f00000006iE.Clone();
				_obj = _alt_obj_f00000006iE.Clone();
				bool _sequence_fail_f00000007Ad = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "finite check");
					_sequence_fail_f00000007Ad = true;
					goto _sequence_end_f00000007Ad;
				}
				while(true) {
					ParserPosition _many_position_f00000007jn = _position.Clone();
					var _many_obj_f00000007jn = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "finite check");
						_position = _many_position_f00000007jn;
						_obj = _many_obj_f00000007jn;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "finite check");
					_sequence_fail_f00000007Ad = true;
					goto _sequence_end_f00000007Ad;
				}
				_sequence_end_f00000007Ad:
				if (_sequence_fail_f00000007Ad) {
					_position = _alt_position_f00000006iE;
					_obj = _alt_obj_f00000006iE;
				} else {
					_alternate_success_f00000006iE = true;
				}
			}
			if (_alternate_success_f00000006iE) {
			} else {
				_position = _many_position_f00000006KI;
				_obj = _many_obj_f00000006KI;
				break;
			}
		}
		if (_position.Match("Finite")) {
		} else {
			_position.Update("“Finite”", "finite check");
			_sequence_fail_f00000005Vm = true;
			goto _sequence_end_f00000005Vm;
		}
		_sequence_end_f00000005Vm:
		if (_sequence_fail_f00000005Vm) {
			_position.Cache<expression_is_finite>(_start_index, null);
			_position.TraceExit("expression:is_finite", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_is_finite>(_start_index, _obj);
			_position.TraceExit("expression:is_finite", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_is_nan(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_is_nan, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_is_nan();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:is_nan");

		bool _sequence_fail_f00000005Vw = false;
		if (expression.ParseRule_expression15(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Vw = true;
		goto _sequence_end_f00000005Vw;
		}
		while(true) {
			ParserPosition _many_position_f00000006KW = _position.Clone();
			var _many_obj_f00000006KW = _obj.Clone();
			bool _alternate_success_f00000006iK = false;
			ParserPosition _alt_position_f00000006iK = _position;
			var _alt_obj_f00000006iK = _obj;
			if (!_alternate_success_f00000006iK) {
				_position = _alt_position_f00000006iK.Clone();
				_obj = _alt_obj_f00000006iK.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006iK = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "not-a-number check");
					_position = _alt_position_f00000006iK;
					_obj = _alt_obj_f00000006iK;
				}
			}
			if (!_alternate_success_f00000006iK) {
				_position = _alt_position_f00000006iK.Clone();
				_obj = _alt_obj_f00000006iK.Clone();
				bool _sequence_fail_f00000007Aq = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "not-a-number check");
					_sequence_fail_f00000007Aq = true;
					goto _sequence_end_f00000007Aq;
				}
				while(true) {
					ParserPosition _many_position_f00000007ju = _position.Clone();
					var _many_obj_f00000007ju = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "not-a-number check");
						_position = _many_position_f00000007ju;
						_obj = _many_obj_f00000007ju;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "not-a-number check");
					_sequence_fail_f00000007Aq = true;
					goto _sequence_end_f00000007Aq;
				}
				_sequence_end_f00000007Aq:
				if (_sequence_fail_f00000007Aq) {
					_position = _alt_position_f00000006iK;
					_obj = _alt_obj_f00000006iK;
				} else {
					_alternate_success_f00000006iK = true;
				}
			}
			if (_alternate_success_f00000006iK) {
			} else {
				_position = _many_position_f00000006KW;
				_obj = _many_obj_f00000006KW;
				break;
			}
		}
		if (_position.Match("Is")) {
		} else {
			_position.Update("“Is”", "not-a-number check");
			_sequence_fail_f00000005Vw = true;
			goto _sequence_end_f00000005Vw;
		}
		while(true) {
			ParserPosition _many_position_f00000006KX = _position.Clone();
			var _many_obj_f00000006KX = _obj.Clone();
			bool _alternate_success_f00000006iL = false;
			ParserPosition _alt_position_f00000006iL = _position;
			var _alt_obj_f00000006iL = _obj;
			if (!_alternate_success_f00000006iL) {
				_position = _alt_position_f00000006iL.Clone();
				_obj = _alt_obj_f00000006iL.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006iL = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "not-a-number check");
					_position = _alt_position_f00000006iL;
					_obj = _alt_obj_f00000006iL;
				}
			}
			if (!_alternate_success_f00000006iL) {
				_position = _alt_position_f00000006iL.Clone();
				_obj = _alt_obj_f00000006iL.Clone();
				bool _sequence_fail_f00000007Au = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "not-a-number check");
					_sequence_fail_f00000007Au = true;
					goto _sequence_end_f00000007Au;
				}
				while(true) {
					ParserPosition _many_position_f00000007k0 = _position.Clone();
					var _many_obj_f00000007k0 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "not-a-number check");
						_position = _many_position_f00000007k0;
						_obj = _many_obj_f00000007k0;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "not-a-number check");
					_sequence_fail_f00000007Au = true;
					goto _sequence_end_f00000007Au;
				}
				_sequence_end_f00000007Au:
				if (_sequence_fail_f00000007Au) {
					_position = _alt_position_f00000006iL;
					_obj = _alt_obj_f00000006iL;
				} else {
					_alternate_success_f00000006iL = true;
				}
			}
			if (_alternate_success_f00000006iL) {
			} else {
				_position = _many_position_f00000006KX;
				_obj = _many_obj_f00000006KX;
				break;
			}
		}
		if (_position.Match("NaN")) {
		} else {
			_position.Update("“NaN”", "not-a-number check");
			_sequence_fail_f00000005Vw = true;
			goto _sequence_end_f00000005Vw;
		}
		_sequence_end_f00000005Vw:
		if (_sequence_fail_f00000005Vw) {
			_position.Cache<expression_is_nan>(_start_index, null);
			_position.TraceExit("expression:is_nan", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_is_nan>(_start_index, _obj);
			_position.TraceExit("expression:is_nan", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_is_null(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_is_null, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_is_null();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:is_null");

		bool _sequence_fail_f00000005W6 = false;
		if (expression.ParseRule_expression15(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005W6 = true;
		goto _sequence_end_f00000005W6;
		}
		while(true) {
			ParserPosition _many_position_f00000006Kk = _position.Clone();
			var _many_obj_f00000006Kk = _obj.Clone();
			bool _alternate_success_f00000006iQ = false;
			ParserPosition _alt_position_f00000006iQ = _position;
			var _alt_obj_f00000006iQ = _obj;
			if (!_alternate_success_f00000006iQ) {
				_position = _alt_position_f00000006iQ.Clone();
				_obj = _alt_obj_f00000006iQ.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006iQ = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "null check");
					_position = _alt_position_f00000006iQ;
					_obj = _alt_obj_f00000006iQ;
				}
			}
			if (!_alternate_success_f00000006iQ) {
				_position = _alt_position_f00000006iQ.Clone();
				_obj = _alt_obj_f00000006iQ.Clone();
				bool _sequence_fail_f00000007B3 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "null check");
					_sequence_fail_f00000007B3 = true;
					goto _sequence_end_f00000007B3;
				}
				while(true) {
					ParserPosition _many_position_f00000007k6 = _position.Clone();
					var _many_obj_f00000007k6 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "null check");
						_position = _many_position_f00000007k6;
						_obj = _many_obj_f00000007k6;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "null check");
					_sequence_fail_f00000007B3 = true;
					goto _sequence_end_f00000007B3;
				}
				_sequence_end_f00000007B3:
				if (_sequence_fail_f00000007B3) {
					_position = _alt_position_f00000006iQ;
					_obj = _alt_obj_f00000006iQ;
				} else {
					_alternate_success_f00000006iQ = true;
				}
			}
			if (_alternate_success_f00000006iQ) {
			} else {
				_position = _many_position_f00000006Kk;
				_obj = _many_obj_f00000006Kk;
				break;
			}
		}
		if (_position.Match("Is")) {
		} else {
			_position.Update("“Is”", "null check");
			_sequence_fail_f00000005W6 = true;
			goto _sequence_end_f00000005W6;
		}
		while(true) {
			ParserPosition _many_position_f00000006Kl = _position.Clone();
			var _many_obj_f00000006Kl = _obj.Clone();
			bool _alternate_success_f00000006iR = false;
			ParserPosition _alt_position_f00000006iR = _position;
			var _alt_obj_f00000006iR = _obj;
			if (!_alternate_success_f00000006iR) {
				_position = _alt_position_f00000006iR.Clone();
				_obj = _alt_obj_f00000006iR.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006iR = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "null check");
					_position = _alt_position_f00000006iR;
					_obj = _alt_obj_f00000006iR;
				}
			}
			if (!_alternate_success_f00000006iR) {
				_position = _alt_position_f00000006iR.Clone();
				_obj = _alt_obj_f00000006iR.Clone();
				bool _sequence_fail_f00000007B7 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "null check");
					_sequence_fail_f00000007B7 = true;
					goto _sequence_end_f00000007B7;
				}
				while(true) {
					ParserPosition _many_position_f00000007kC = _position.Clone();
					var _many_obj_f00000007kC = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "null check");
						_position = _many_position_f00000007kC;
						_obj = _many_obj_f00000007kC;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "null check");
					_sequence_fail_f00000007B7 = true;
					goto _sequence_end_f00000007B7;
				}
				_sequence_end_f00000007B7:
				if (_sequence_fail_f00000007B7) {
					_position = _alt_position_f00000006iR;
					_obj = _alt_obj_f00000006iR;
				} else {
					_alternate_success_f00000006iR = true;
				}
			}
			if (_alternate_success_f00000006iR) {
			} else {
				_position = _many_position_f00000006Kl;
				_obj = _many_obj_f00000006Kl;
				break;
			}
		}
		if (_position.Match("Null")) {
		} else {
			_position.Update("“Null”", "null check");
			_sequence_fail_f00000005W6 = true;
			goto _sequence_end_f00000005W6;
		}
		_sequence_end_f00000005W6:
		if (_sequence_fail_f00000005W6) {
			_position.Cache<expression_is_null>(_start_index, null);
			_position.TraceExit("expression:is_null", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_is_null>(_start_index, _obj);
			_position.TraceExit("expression:is_null", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_length(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_length, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_length();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:length");

		bool _sequence_fail_f00000005WG = false;
		if (_position.Match("Length")) {
		} else {
			_position.Update("“Length”", "length");
			_sequence_fail_f00000005WG = true;
			goto _sequence_end_f00000005WG;
		}
		while(true) {
			ParserPosition _many_position_f00000006Kx = _position.Clone();
			var _many_obj_f00000006Kx = _obj.Clone();
			bool _alternate_success_f00000006iW = false;
			ParserPosition _alt_position_f00000006iW = _position;
			var _alt_obj_f00000006iW = _obj;
			if (!_alternate_success_f00000006iW) {
				_position = _alt_position_f00000006iW.Clone();
				_obj = _alt_obj_f00000006iW.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006iW = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "length");
					_position = _alt_position_f00000006iW;
					_obj = _alt_obj_f00000006iW;
				}
			}
			if (!_alternate_success_f00000006iW) {
				_position = _alt_position_f00000006iW.Clone();
				_obj = _alt_obj_f00000006iW.Clone();
				bool _sequence_fail_f00000007BN = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "length");
					_sequence_fail_f00000007BN = true;
					goto _sequence_end_f00000007BN;
				}
				while(true) {
					ParserPosition _many_position_f00000007kK = _position.Clone();
					var _many_obj_f00000007kK = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "length");
						_position = _many_position_f00000007kK;
						_obj = _many_obj_f00000007kK;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "length");
					_sequence_fail_f00000007BN = true;
					goto _sequence_end_f00000007BN;
				}
				_sequence_end_f00000007BN:
				if (_sequence_fail_f00000007BN) {
					_position = _alt_position_f00000006iW;
					_obj = _alt_obj_f00000006iW;
				} else {
					_alternate_success_f00000006iW = true;
				}
			}
			if (_alternate_success_f00000006iW) {
			} else {
				_position = _many_position_f00000006Kx;
				_obj = _many_obj_f00000006Kx;
				break;
			}
		}
		if (expression.ParseRule_expression16(ref _position, out _obj.expr)) {
		} else {
		_sequence_fail_f00000005WG = true;
		goto _sequence_end_f00000005WG;
		}
		_sequence_end_f00000005WG:
		if (_sequence_fail_f00000005WG) {
			_position.Cache<expression_length>(_start_index, null);
			_position.TraceExit("expression:length", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_length>(_start_index, _obj);
			_position.TraceExit("expression:length", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_lesser(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_lesser, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_lesser();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:lesser");

		bool _sequence_fail_f00000005WQ = false;
		if (expression.ParseRule_expression7(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005WQ = true;
		goto _sequence_end_f00000005WQ;
		}
		while(true) {
			ParserPosition _many_position_f00000006LB = _position.Clone();
			var _many_obj_f00000006LB = _obj.Clone();
			bool _alternate_success_f00000006ia = false;
			ParserPosition _alt_position_f00000006ia = _position;
			var _alt_obj_f00000006ia = _obj;
			if (!_alternate_success_f00000006ia) {
				_position = _alt_position_f00000006ia.Clone();
				_obj = _alt_obj_f00000006ia.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ia = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "lesser-than comparison");
					_position = _alt_position_f00000006ia;
					_obj = _alt_obj_f00000006ia;
				}
			}
			if (!_alternate_success_f00000006ia) {
				_position = _alt_position_f00000006ia.Clone();
				_obj = _alt_obj_f00000006ia.Clone();
				bool _sequence_fail_f00000007BV = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "lesser-than comparison");
					_sequence_fail_f00000007BV = true;
					goto _sequence_end_f00000007BV;
				}
				while(true) {
					ParserPosition _many_position_f00000007kQ = _position.Clone();
					var _many_obj_f00000007kQ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "lesser-than comparison");
						_position = _many_position_f00000007kQ;
						_obj = _many_obj_f00000007kQ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "lesser-than comparison");
					_sequence_fail_f00000007BV = true;
					goto _sequence_end_f00000007BV;
				}
				_sequence_end_f00000007BV:
				if (_sequence_fail_f00000007BV) {
					_position = _alt_position_f00000006ia;
					_obj = _alt_obj_f00000006ia;
				} else {
					_alternate_success_f00000006ia = true;
				}
			}
			if (_alternate_success_f00000006ia) {
			} else {
				_position = _many_position_f00000006LB;
				_obj = _many_obj_f00000006LB;
				break;
			}
		}
		if (_position.Match("<")) {
		} else {
			_position.Update("“<”", "lesser-than comparison");
			_sequence_fail_f00000005WQ = true;
			goto _sequence_end_f00000005WQ;
		}
		while(true) {
			ParserPosition _many_position_f00000006LC = _position.Clone();
			var _many_obj_f00000006LC = _obj.Clone();
			bool _alternate_success_f00000006ib = false;
			ParserPosition _alt_position_f00000006ib = _position;
			var _alt_obj_f00000006ib = _obj;
			if (!_alternate_success_f00000006ib) {
				_position = _alt_position_f00000006ib.Clone();
				_obj = _alt_obj_f00000006ib.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ib = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "lesser-than comparison");
					_position = _alt_position_f00000006ib;
					_obj = _alt_obj_f00000006ib;
				}
			}
			if (!_alternate_success_f00000006ib) {
				_position = _alt_position_f00000006ib.Clone();
				_obj = _alt_obj_f00000006ib.Clone();
				bool _sequence_fail_f00000007BZ = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "lesser-than comparison");
					_sequence_fail_f00000007BZ = true;
					goto _sequence_end_f00000007BZ;
				}
				while(true) {
					ParserPosition _many_position_f00000007kW = _position.Clone();
					var _many_obj_f00000007kW = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "lesser-than comparison");
						_position = _many_position_f00000007kW;
						_obj = _many_obj_f00000007kW;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "lesser-than comparison");
					_sequence_fail_f00000007BZ = true;
					goto _sequence_end_f00000007BZ;
				}
				_sequence_end_f00000007BZ:
				if (_sequence_fail_f00000007BZ) {
					_position = _alt_position_f00000006ib;
					_obj = _alt_obj_f00000006ib;
				} else {
					_alternate_success_f00000006ib = true;
				}
			}
			if (_alternate_success_f00000006ib) {
			} else {
				_position = _many_position_f00000006LC;
				_obj = _many_obj_f00000006LC;
				break;
			}
		}
		if (expression.ParseRule_expression7(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005WQ = true;
		goto _sequence_end_f00000005WQ;
		}
		_sequence_end_f00000005WQ:
		if (_sequence_fail_f00000005WQ) {
			_position.Cache<expression_lesser>(_start_index, null);
			_position.TraceExit("expression:lesser", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_lesser>(_start_index, _obj);
			_position.TraceExit("expression:lesser", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_lesser_or_equality(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_lesser_or_equality, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_lesser_or_equality();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:lesser_or_equality");

		bool _sequence_fail_f00000005Wa = false;
		if (expression.ParseRule_expression7(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Wa = true;
		goto _sequence_end_f00000005Wa;
		}
		while(true) {
			ParserPosition _many_position_f00000006LO = _position.Clone();
			var _many_obj_f00000006LO = _obj.Clone();
			bool _alternate_success_f00000006ii = false;
			ParserPosition _alt_position_f00000006ii = _position;
			var _alt_obj_f00000006ii = _obj;
			if (!_alternate_success_f00000006ii) {
				_position = _alt_position_f00000006ii.Clone();
				_obj = _alt_obj_f00000006ii.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ii = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "lesser-than or equality comparison");
					_position = _alt_position_f00000006ii;
					_obj = _alt_obj_f00000006ii;
				}
			}
			if (!_alternate_success_f00000006ii) {
				_position = _alt_position_f00000006ii.Clone();
				_obj = _alt_obj_f00000006ii.Clone();
				bool _sequence_fail_f00000007Bj = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "lesser-than or equality comparison");
					_sequence_fail_f00000007Bj = true;
					goto _sequence_end_f00000007Bj;
				}
				while(true) {
					ParserPosition _many_position_f00000007kc = _position.Clone();
					var _many_obj_f00000007kc = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "lesser-than or equality comparison");
						_position = _many_position_f00000007kc;
						_obj = _many_obj_f00000007kc;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "lesser-than or equality comparison");
					_sequence_fail_f00000007Bj = true;
					goto _sequence_end_f00000007Bj;
				}
				_sequence_end_f00000007Bj:
				if (_sequence_fail_f00000007Bj) {
					_position = _alt_position_f00000006ii;
					_obj = _alt_obj_f00000006ii;
				} else {
					_alternate_success_f00000006ii = true;
				}
			}
			if (_alternate_success_f00000006ii) {
			} else {
				_position = _many_position_f00000006LO;
				_obj = _many_obj_f00000006LO;
				break;
			}
		}
		if (_position.Match("<=")) {
		} else {
			_position.Update("“<=”", "lesser-than or equality comparison");
			_sequence_fail_f00000005Wa = true;
			goto _sequence_end_f00000005Wa;
		}
		while(true) {
			ParserPosition _many_position_f00000006LP = _position.Clone();
			var _many_obj_f00000006LP = _obj.Clone();
			bool _alternate_success_f00000006ij = false;
			ParserPosition _alt_position_f00000006ij = _position;
			var _alt_obj_f00000006ij = _obj;
			if (!_alternate_success_f00000006ij) {
				_position = _alt_position_f00000006ij.Clone();
				_obj = _alt_obj_f00000006ij.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ij = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "lesser-than or equality comparison");
					_position = _alt_position_f00000006ij;
					_obj = _alt_obj_f00000006ij;
				}
			}
			if (!_alternate_success_f00000006ij) {
				_position = _alt_position_f00000006ij.Clone();
				_obj = _alt_obj_f00000006ij.Clone();
				bool _sequence_fail_f00000007Bn = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "lesser-than or equality comparison");
					_sequence_fail_f00000007Bn = true;
					goto _sequence_end_f00000007Bn;
				}
				while(true) {
					ParserPosition _many_position_f00000007ki = _position.Clone();
					var _many_obj_f00000007ki = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "lesser-than or equality comparison");
						_position = _many_position_f00000007ki;
						_obj = _many_obj_f00000007ki;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "lesser-than or equality comparison");
					_sequence_fail_f00000007Bn = true;
					goto _sequence_end_f00000007Bn;
				}
				_sequence_end_f00000007Bn:
				if (_sequence_fail_f00000007Bn) {
					_position = _alt_position_f00000006ij;
					_obj = _alt_obj_f00000006ij;
				} else {
					_alternate_success_f00000006ij = true;
				}
			}
			if (_alternate_success_f00000006ij) {
			} else {
				_position = _many_position_f00000006LP;
				_obj = _many_obj_f00000006LP;
				break;
			}
		}
		if (expression.ParseRule_expression7(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Wa = true;
		goto _sequence_end_f00000005Wa;
		}
		_sequence_end_f00000005Wa:
		if (_sequence_fail_f00000005Wa) {
			_position.Cache<expression_lesser_or_equality>(_start_index, null);
			_position.TraceExit("expression:lesser_or_equality", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_lesser_or_equality>(_start_index, _obj);
			_position.TraceExit("expression:lesser_or_equality", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_let(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_let, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_let();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:let");

		bool _sequence_fail_f00000005Wl = false;
		if (_position.Match("Let")) {
		} else {
			_position.Update("“Let”", "name binding");
			_sequence_fail_f00000005Wl = true;
			goto _sequence_end_f00000005Wl;
		}
		bool _first_f00000006Lg = true;
		while(true) {
			ParserPosition _many_position_f00000006Lg = _position.Clone();
			var _many_obj_f00000006Lg = _obj.Clone();
			bool _alternate_success_f00000006io = false;
			ParserPosition _alt_position_f00000006io = _position;
			var _alt_obj_f00000006io = _obj;
			if (!_alternate_success_f00000006io) {
				_position = _alt_position_f00000006io.Clone();
				_obj = _alt_obj_f00000006io.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006io = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "name binding");
					_position = _alt_position_f00000006io;
					_obj = _alt_obj_f00000006io;
				}
			}
			if (!_alternate_success_f00000006io) {
				_position = _alt_position_f00000006io.Clone();
				_obj = _alt_obj_f00000006io.Clone();
				bool _sequence_fail_f00000007Bx = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "name binding");
					_sequence_fail_f00000007Bx = true;
					goto _sequence_end_f00000007Bx;
				}
				while(true) {
					ParserPosition _many_position_f00000007kr = _position.Clone();
					var _many_obj_f00000007kr = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "name binding");
						_position = _many_position_f00000007kr;
						_obj = _many_obj_f00000007kr;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "name binding");
					_sequence_fail_f00000007Bx = true;
					goto _sequence_end_f00000007Bx;
				}
				_sequence_end_f00000007Bx:
				if (_sequence_fail_f00000007Bx) {
					_position = _alt_position_f00000006io;
					_obj = _alt_obj_f00000006io;
				} else {
					_alternate_success_f00000006io = true;
				}
			}
			if (_alternate_success_f00000006io) {
			} else {
				_position = _many_position_f00000006Lg;
				_obj = _many_obj_f00000006Lg;
				break;
			}
			_first_f00000006Lg = false;
		}
		if (_first_f00000006Lg) {
			_sequence_fail_f00000005Wl = true;
			goto _sequence_end_f00000005Wl;
		} else {
		}
		bool _first_f00000006Li = true;
		while(true) {
			ParserPosition _many_position_f00000006Li = _position.Clone();
			var _many_obj_f00000006Li = _obj.Clone();
			if (!_first_f00000006Li) {
			if (_position.Match(",")) {
			} else {
				_position.Update("“,”", "name binding");
				_position = _many_position_f00000006Li;
				_obj = _many_obj_f00000006Li;
				break;
			}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.definitions, (ref ParserPosition _iposition, out named_definition _iresult) => { if (named_definition.ParseRule_Base(ref _iposition, out _iresult)) { var f00000006ip_key = Generator.ToString(_iresult.name); if (_obj.definitions_dedup.ContainsKey(f00000006ip_key)) { _iposition.NameConstraint(f00000006ip_key); return false; } else { _obj.definitions_dedup[f00000006ip_key] = true; return true; } } else { return false; } })) {
			} else {
			_position = _many_position_f00000006Li;
			_obj = _many_obj_f00000006Li;
			break;
			}
			_first_f00000006Li = false;
		}
		if (_first_f00000006Li) {
			_sequence_fail_f00000005Wl = true;
			goto _sequence_end_f00000005Wl;
		} else {
		}
		bool _first_f00000006Lj = true;
		while(true) {
			ParserPosition _many_position_f00000006Lj = _position.Clone();
			var _many_obj_f00000006Lj = _obj.Clone();
			bool _alternate_success_f00000006ir = false;
			ParserPosition _alt_position_f00000006ir = _position;
			var _alt_obj_f00000006ir = _obj;
			if (!_alternate_success_f00000006ir) {
				_position = _alt_position_f00000006ir.Clone();
				_obj = _alt_obj_f00000006ir.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ir = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "name binding");
					_position = _alt_position_f00000006ir;
					_obj = _alt_obj_f00000006ir;
				}
			}
			if (!_alternate_success_f00000006ir) {
				_position = _alt_position_f00000006ir.Clone();
				_obj = _alt_obj_f00000006ir.Clone();
				bool _sequence_fail_f00000007C3 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "name binding");
					_sequence_fail_f00000007C3 = true;
					goto _sequence_end_f00000007C3;
				}
				while(true) {
					ParserPosition _many_position_f00000007kx = _position.Clone();
					var _many_obj_f00000007kx = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "name binding");
						_position = _many_position_f00000007kx;
						_obj = _many_obj_f00000007kx;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "name binding");
					_sequence_fail_f00000007C3 = true;
					goto _sequence_end_f00000007C3;
				}
				_sequence_end_f00000007C3:
				if (_sequence_fail_f00000007C3) {
					_position = _alt_position_f00000006ir;
					_obj = _alt_obj_f00000006ir;
				} else {
					_alternate_success_f00000006ir = true;
				}
			}
			if (_alternate_success_f00000006ir) {
			} else {
				_position = _many_position_f00000006Lj;
				_obj = _many_obj_f00000006Lj;
				break;
			}
			_first_f00000006Lj = false;
		}
		if (_first_f00000006Lj) {
			_sequence_fail_f00000005Wl = true;
			goto _sequence_end_f00000005Wl;
		} else {
		}
		if (_position.Match("In")) {
		} else {
			_position.Update("“In”", "name binding");
			_sequence_fail_f00000005Wl = true;
			goto _sequence_end_f00000005Wl;
		}
		bool _first_f00000006Ll = true;
		while(true) {
			ParserPosition _many_position_f00000006Ll = _position.Clone();
			var _many_obj_f00000006Ll = _obj.Clone();
			bool _alternate_success_f00000006is = false;
			ParserPosition _alt_position_f00000006is = _position;
			var _alt_obj_f00000006is = _obj;
			if (!_alternate_success_f00000006is) {
				_position = _alt_position_f00000006is.Clone();
				_obj = _alt_obj_f00000006is.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006is = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "name binding");
					_position = _alt_position_f00000006is;
					_obj = _alt_obj_f00000006is;
				}
			}
			if (!_alternate_success_f00000006is) {
				_position = _alt_position_f00000006is.Clone();
				_obj = _alt_obj_f00000006is.Clone();
				bool _sequence_fail_f00000007C6 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "name binding");
					_sequence_fail_f00000007C6 = true;
					goto _sequence_end_f00000007C6;
				}
				while(true) {
					ParserPosition _many_position_f00000007l3 = _position.Clone();
					var _many_obj_f00000007l3 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "name binding");
						_position = _many_position_f00000007l3;
						_obj = _many_obj_f00000007l3;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "name binding");
					_sequence_fail_f00000007C6 = true;
					goto _sequence_end_f00000007C6;
				}
				_sequence_end_f00000007C6:
				if (_sequence_fail_f00000007C6) {
					_position = _alt_position_f00000006is;
					_obj = _alt_obj_f00000006is;
				} else {
					_alternate_success_f00000006is = true;
				}
			}
			if (_alternate_success_f00000006is) {
			} else {
				_position = _many_position_f00000006Ll;
				_obj = _many_obj_f00000006Ll;
				break;
			}
			_first_f00000006Ll = false;
		}
		if (_first_f00000006Ll) {
			_sequence_fail_f00000005Wl = true;
			goto _sequence_end_f00000005Wl;
		} else {
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000005Wl = true;
		goto _sequence_end_f00000005Wl;
		}
		_sequence_end_f00000005Wl:
		if (_sequence_fail_f00000005Wl) {
			_position.Cache<expression_let>(_start_index, null);
			_position.TraceExit("expression:let", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_let>(_start_index, _obj);
			_position.TraceExit("expression:let", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_list_join(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_list_join, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_list_join();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:list_join");

		bool _sequence_fail_f00000005Wv = false;
		if (expression.ParseRule_expression4(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Wv = true;
		goto _sequence_end_f00000005Wv;
		}
		while(true) {
			ParserPosition _many_position_f00000006Lw = _position.Clone();
			var _many_obj_f00000006Lw = _obj.Clone();
			bool _alternate_success_f00000006j1 = false;
			ParserPosition _alt_position_f00000006j1 = _position;
			var _alt_obj_f00000006j1 = _obj;
			if (!_alternate_success_f00000006j1) {
				_position = _alt_position_f00000006j1.Clone();
				_obj = _alt_obj_f00000006j1.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006j1 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "frame concatenation");
					_position = _alt_position_f00000006j1;
					_obj = _alt_obj_f00000006j1;
				}
			}
			if (!_alternate_success_f00000006j1) {
				_position = _alt_position_f00000006j1.Clone();
				_obj = _alt_obj_f00000006j1.Clone();
				bool _sequence_fail_f00000007CD = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "frame concatenation");
					_sequence_fail_f00000007CD = true;
					goto _sequence_end_f00000007CD;
				}
				while(true) {
					ParserPosition _many_position_f00000007lJ = _position.Clone();
					var _many_obj_f00000007lJ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "frame concatenation");
						_position = _many_position_f00000007lJ;
						_obj = _many_obj_f00000007lJ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "frame concatenation");
					_sequence_fail_f00000007CD = true;
					goto _sequence_end_f00000007CD;
				}
				_sequence_end_f00000007CD:
				if (_sequence_fail_f00000007CD) {
					_position = _alt_position_f00000006j1;
					_obj = _alt_obj_f00000006j1;
				} else {
					_alternate_success_f00000006j1 = true;
				}
			}
			if (_alternate_success_f00000006j1) {
			} else {
				_position = _many_position_f00000006Lw;
				_obj = _many_obj_f00000006Lw;
				break;
			}
		}
		if (_position.Match("Append")) {
		} else {
			_position.Update("“Append”", "frame concatenation");
			_sequence_fail_f00000005Wv = true;
			goto _sequence_end_f00000005Wv;
		}
		while(true) {
			ParserPosition _many_position_f00000006Lx = _position.Clone();
			var _many_obj_f00000006Lx = _obj.Clone();
			bool _alternate_success_f00000006j2 = false;
			ParserPosition _alt_position_f00000006j2 = _position;
			var _alt_obj_f00000006j2 = _obj;
			if (!_alternate_success_f00000006j2) {
				_position = _alt_position_f00000006j2.Clone();
				_obj = _alt_obj_f00000006j2.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006j2 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "frame concatenation");
					_position = _alt_position_f00000006j2;
					_obj = _alt_obj_f00000006j2;
				}
			}
			if (!_alternate_success_f00000006j2) {
				_position = _alt_position_f00000006j2.Clone();
				_obj = _alt_obj_f00000006j2.Clone();
				bool _sequence_fail_f00000007CH = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "frame concatenation");
					_sequence_fail_f00000007CH = true;
					goto _sequence_end_f00000007CH;
				}
				while(true) {
					ParserPosition _many_position_f00000007lP = _position.Clone();
					var _many_obj_f00000007lP = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "frame concatenation");
						_position = _many_position_f00000007lP;
						_obj = _many_obj_f00000007lP;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "frame concatenation");
					_sequence_fail_f00000007CH = true;
					goto _sequence_end_f00000007CH;
				}
				_sequence_end_f00000007CH:
				if (_sequence_fail_f00000007CH) {
					_position = _alt_position_f00000006j2;
					_obj = _alt_obj_f00000006j2;
				} else {
					_alternate_success_f00000006j2 = true;
				}
			}
			if (_alternate_success_f00000006j2) {
			} else {
				_position = _many_position_f00000006Lx;
				_obj = _many_obj_f00000006Lx;
				break;
			}
		}
		if (expression.ParseRule_expression3(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Wv = true;
		goto _sequence_end_f00000005Wv;
		}
		_sequence_end_f00000005Wv:
		if (_sequence_fail_f00000005Wv) {
			_position.Cache<expression_list_join>(_start_index, null);
			_position.TraceExit("expression:list_join", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_list_join>(_start_index, _obj);
			_position.TraceExit("expression:list_join", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_literal_frame(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_literal_frame, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_literal_frame();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:literal_frame");

		bool _sequence_fail_f00000005X5 = false;
		if (_position.Match("{")) {
		} else {
			_position.Update("“{”", "literal frame");
			_sequence_fail_f00000005X5 = true;
			goto _sequence_end_f00000005X5;
		}
		while(true) {
			ParserPosition _many_position_f00000006M6 = _position.Clone();
			var _many_obj_f00000006M6 = _obj.Clone();
			bool _alternate_success_f00000006j4 = false;
			ParserPosition _alt_position_f00000006j4 = _position;
			var _alt_obj_f00000006j4 = _obj;
			if (!_alternate_success_f00000006j4) {
				_position = _alt_position_f00000006j4.Clone();
				_obj = _alt_obj_f00000006j4.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006j4 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "literal frame");
					_position = _alt_position_f00000006j4;
					_obj = _alt_obj_f00000006j4;
				}
			}
			if (!_alternate_success_f00000006j4) {
				_position = _alt_position_f00000006j4.Clone();
				_obj = _alt_obj_f00000006j4.Clone();
				bool _sequence_fail_f00000007CO = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "literal frame");
					_sequence_fail_f00000007CO = true;
					goto _sequence_end_f00000007CO;
				}
				while(true) {
					ParserPosition _many_position_f00000007lV = _position.Clone();
					var _many_obj_f00000007lV = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "literal frame");
						_position = _many_position_f00000007lV;
						_obj = _many_obj_f00000007lV;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "literal frame");
					_sequence_fail_f00000007CO = true;
					goto _sequence_end_f00000007CO;
				}
				_sequence_end_f00000007CO:
				if (_sequence_fail_f00000007CO) {
					_position = _alt_position_f00000006j4;
					_obj = _alt_obj_f00000006j4;
				} else {
					_alternate_success_f00000006j4 = true;
				}
			}
			if (_alternate_success_f00000006j4) {
			} else {
				_position = _many_position_f00000006M6;
				_obj = _many_obj_f00000006M6;
				break;
			}
		}
		while(true) {
			ParserPosition _many_position_f00000006M8 = _position.Clone();
			var _many_obj_f00000006M8 = _obj.Clone();
			bool _sequence_fail_f00000006j5 = false;
			while(true) {
				ParserPosition _many_position_f00000007CQ = _position.Clone();
				var _many_obj_f00000007CQ = _obj.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "literal frame");
					_position = _many_position_f00000007CQ;
					_obj = _many_obj_f00000007CQ;
					break;
				}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.attributes, (ref ParserPosition _iposition, out attribute _iresult) => { if (attribute.ParseRule_plain_attribute(ref _iposition, out _iresult)) { var f00000007CR_key = Generator.ToString(_iresult.name); if (_obj.attributes_dedup.ContainsKey(f00000007CR_key)) { _iposition.NameConstraint(f00000007CR_key); return false; } else { _obj.attributes_dedup[f00000007CR_key] = true; return true; } } else { return false; } })) {
			} else {
			_sequence_fail_f00000006j5 = true;
			goto _sequence_end_f00000006j5;
			}
			_sequence_end_f00000006j5:
			if (_sequence_fail_f00000006j5) {
				_position = _many_position_f00000006M8;
				_obj = _many_obj_f00000006M8;
				break;
			} else {
			}
		}
		while(true) {
			ParserPosition _many_position_f00000006M9 = _position.Clone();
			var _many_obj_f00000006M9 = _obj.Clone();
			bool _alternate_success_f00000006j6 = false;
			ParserPosition _alt_position_f00000006j6 = _position;
			var _alt_obj_f00000006j6 = _obj;
			if (!_alternate_success_f00000006j6) {
				_position = _alt_position_f00000006j6.Clone();
				_obj = _alt_obj_f00000006j6.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006j6 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "literal frame");
					_position = _alt_position_f00000006j6;
					_obj = _alt_obj_f00000006j6;
				}
			}
			if (!_alternate_success_f00000006j6) {
				_position = _alt_position_f00000006j6.Clone();
				_obj = _alt_obj_f00000006j6.Clone();
				bool _sequence_fail_f00000007CU = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "literal frame");
					_sequence_fail_f00000007CU = true;
					goto _sequence_end_f00000007CU;
				}
				while(true) {
					ParserPosition _many_position_f00000007li = _position.Clone();
					var _many_obj_f00000007li = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "literal frame");
						_position = _many_position_f00000007li;
						_obj = _many_obj_f00000007li;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "literal frame");
					_sequence_fail_f00000007CU = true;
					goto _sequence_end_f00000007CU;
				}
				_sequence_end_f00000007CU:
				if (_sequence_fail_f00000007CU) {
					_position = _alt_position_f00000006j6;
					_obj = _alt_obj_f00000006j6;
				} else {
					_alternate_success_f00000006j6 = true;
				}
			}
			if (_alternate_success_f00000006j6) {
			} else {
				_position = _many_position_f00000006M9;
				_obj = _many_obj_f00000006M9;
				break;
			}
		}
		if (_position.Match("}")) {
		} else {
			_position.Update("“}”", "literal frame");
			_sequence_fail_f00000005X5 = true;
			goto _sequence_end_f00000005X5;
		}
		_sequence_end_f00000005X5:
		if (_sequence_fail_f00000005X5) {
			_position.Cache<expression_literal_frame>(_start_index, null);
			_position.TraceExit("expression:literal_frame", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_literal_frame>(_start_index, _obj);
			_position.TraceExit("expression:literal_frame", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_literal_list(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_literal_list, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_literal_list();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:literal_list");

		bool _sequence_fail_f00000005XC = false;
		if (_position.Match("[")) {
		} else {
			_position.Update("“[”", "literal list");
			_sequence_fail_f00000005XC = true;
			goto _sequence_end_f00000005XC;
		}
		bool _first_f00000006MH = true;
		while(true) {
			ParserPosition _many_position_f00000006MH = _position.Clone();
			var _many_obj_f00000006MH = _obj.Clone();
			if (!_first_f00000006MH) {
			if (_position.Match(",")) {
			} else {
				_position.Update("“,”", "literal list");
				_position = _many_position_f00000006MH;
				_obj = _many_obj_f00000006MH;
				break;
			}
			}
			bool _sequence_fail_f00000006j8 = false;
			while(true) {
				ParserPosition _many_position_f00000007ln = _position.Clone();
				var _many_obj_f00000007ln = _obj.Clone();
				bool _alternate_success_f00000008Mf = false;
				ParserPosition _alt_position_f00000008Mf = _position;
				var _alt_obj_f00000008Mf = _obj;
				if (!_alternate_success_f00000008Mf) {
					_position = _alt_position_f00000008Mf.Clone();
					_obj = _alt_obj_f00000008Mf.Clone();
					if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
						_alternate_success_f00000008Mf = true;
					} else {
						_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "literal list");
						_position = _alt_position_f00000008Mf;
						_obj = _alt_obj_f00000008Mf;
					}
				}
				if (!_alternate_success_f00000008Mf) {
					_position = _alt_position_f00000008Mf.Clone();
					_obj = _alt_obj_f00000008Mf.Clone();
					bool _sequence_fail_f00000008m1 = false;
					if (_position.Match("#")) {
					} else {
						_position.Update("“#”", "literal list");
						_sequence_fail_f00000008m1 = true;
						goto _sequence_end_f00000008m1;
					}
					while(true) {
						ParserPosition _many_position_f00000009AU = _position.Clone();
						var _many_obj_f00000009AU = _obj.Clone();
						if ("\n".IndexOf(_position.Next()) == -1) {
							_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
						} else {
							_position.Update(Parser.ToLiteral("\n"), "literal list");
							_position = _many_position_f00000009AU;
							_obj = _many_obj_f00000009AU;
							break;
						}
					}
					if ("\n".IndexOf(_position.Next()) != -1) {
					} else {
						_position.Update(Parser.ToLiteral("\n"), "literal list");
						_sequence_fail_f00000008m1 = true;
						goto _sequence_end_f00000008m1;
					}
					_sequence_end_f00000008m1:
					if (_sequence_fail_f00000008m1) {
						_position = _alt_position_f00000008Mf;
						_obj = _alt_obj_f00000008Mf;
					} else {
						_alternate_success_f00000008Mf = true;
					}
				}
				if (_alternate_success_f00000008Mf) {
				} else {
					_position = _many_position_f00000007ln;
					_obj = _many_obj_f00000007ln;
					break;
				}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.items, expression.ParseRule_expression0)) {
			} else {
			_sequence_fail_f00000006j8 = true;
			goto _sequence_end_f00000006j8;
			}
			while(true) {
				ParserPosition _many_position_f00000007lr = _position.Clone();
				var _many_obj_f00000007lr = _obj.Clone();
				bool _alternate_success_f00000008Mg = false;
				ParserPosition _alt_position_f00000008Mg = _position;
				var _alt_obj_f00000008Mg = _obj;
				if (!_alternate_success_f00000008Mg) {
					_position = _alt_position_f00000008Mg.Clone();
					_obj = _alt_obj_f00000008Mg.Clone();
					if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
						_alternate_success_f00000008Mg = true;
					} else {
						_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "literal list");
						_position = _alt_position_f00000008Mg;
						_obj = _alt_obj_f00000008Mg;
					}
				}
				if (!_alternate_success_f00000008Mg) {
					_position = _alt_position_f00000008Mg.Clone();
					_obj = _alt_obj_f00000008Mg.Clone();
					bool _sequence_fail_f00000008m4 = false;
					if (_position.Match("#")) {
					} else {
						_position.Update("“#”", "literal list");
						_sequence_fail_f00000008m4 = true;
						goto _sequence_end_f00000008m4;
					}
					while(true) {
						ParserPosition _many_position_f00000009Aa = _position.Clone();
						var _many_obj_f00000009Aa = _obj.Clone();
						if ("\n".IndexOf(_position.Next()) == -1) {
							_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
						} else {
							_position.Update(Parser.ToLiteral("\n"), "literal list");
							_position = _many_position_f00000009Aa;
							_obj = _many_obj_f00000009Aa;
							break;
						}
					}
					if ("\n".IndexOf(_position.Next()) != -1) {
					} else {
						_position.Update(Parser.ToLiteral("\n"), "literal list");
						_sequence_fail_f00000008m4 = true;
						goto _sequence_end_f00000008m4;
					}
					_sequence_end_f00000008m4:
					if (_sequence_fail_f00000008m4) {
						_position = _alt_position_f00000008Mg;
						_obj = _alt_obj_f00000008Mg;
					} else {
						_alternate_success_f00000008Mg = true;
					}
				}
				if (_alternate_success_f00000008Mg) {
				} else {
					_position = _many_position_f00000007lr;
					_obj = _many_obj_f00000007lr;
					break;
				}
			}
			_sequence_end_f00000006j8:
			if (_sequence_fail_f00000006j8) {
				_position = _many_position_f00000006MH;
				_obj = _many_obj_f00000006MH;
				break;
			} else {
			}
			_first_f00000006MH = false;
		}
		while(true) {
			ParserPosition _many_position_f00000006MI = _position.Clone();
			var _many_obj_f00000006MI = _obj.Clone();
			bool _alternate_success_f00000006jA = false;
			ParserPosition _alt_position_f00000006jA = _position;
			var _alt_obj_f00000006jA = _obj;
			if (!_alternate_success_f00000006jA) {
				_position = _alt_position_f00000006jA.Clone();
				_obj = _alt_obj_f00000006jA.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006jA = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "literal list");
					_position = _alt_position_f00000006jA;
					_obj = _alt_obj_f00000006jA;
				}
			}
			if (!_alternate_success_f00000006jA) {
				_position = _alt_position_f00000006jA.Clone();
				_obj = _alt_obj_f00000006jA.Clone();
				bool _sequence_fail_f00000007Cf = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "literal list");
					_sequence_fail_f00000007Cf = true;
					goto _sequence_end_f00000007Cf;
				}
				while(true) {
					ParserPosition _many_position_f00000007lx = _position.Clone();
					var _many_obj_f00000007lx = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "literal list");
						_position = _many_position_f00000007lx;
						_obj = _many_obj_f00000007lx;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "literal list");
					_sequence_fail_f00000007Cf = true;
					goto _sequence_end_f00000007Cf;
				}
				_sequence_end_f00000007Cf:
				if (_sequence_fail_f00000007Cf) {
					_position = _alt_position_f00000006jA;
					_obj = _alt_obj_f00000006jA;
				} else {
					_alternate_success_f00000006jA = true;
				}
			}
			if (_alternate_success_f00000006jA) {
			} else {
				_position = _many_position_f00000006MI;
				_obj = _many_obj_f00000006MI;
				break;
			}
		}
		var _optional_obj_f00000005uU = _obj.Clone();
		ParserPosition _optional_position_f00000005uU = _position.Clone();
		bool _sequence_fail_f00000006MJ = false;
		if (_position.Match(",")) {
		} else {
			_position.Update("“,”", "literal list");
			_sequence_fail_f00000006MJ = true;
			goto _sequence_end_f00000006MJ;
		}
		while(true) {
			ParserPosition _many_position_f00000007Ch = _position.Clone();
			var _many_obj_f00000007Ch = _obj.Clone();
			bool _alternate_success_f00000007m1 = false;
			ParserPosition _alt_position_f00000007m1 = _position;
			var _alt_obj_f00000007m1 = _obj;
			if (!_alternate_success_f00000007m1) {
				_position = _alt_position_f00000007m1.Clone();
				_obj = _alt_obj_f00000007m1.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000007m1 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "literal list");
					_position = _alt_position_f00000007m1;
					_obj = _alt_obj_f00000007m1;
				}
			}
			if (!_alternate_success_f00000007m1) {
				_position = _alt_position_f00000007m1.Clone();
				_obj = _alt_obj_f00000007m1.Clone();
				bool _sequence_fail_f00000008Mp = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "literal list");
					_sequence_fail_f00000008Mp = true;
					goto _sequence_end_f00000008Mp;
				}
				while(true) {
					ParserPosition _many_position_f00000008m9 = _position.Clone();
					var _many_obj_f00000008m9 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "literal list");
						_position = _many_position_f00000008m9;
						_obj = _many_obj_f00000008m9;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "literal list");
					_sequence_fail_f00000008Mp = true;
					goto _sequence_end_f00000008Mp;
				}
				_sequence_end_f00000008Mp:
				if (_sequence_fail_f00000008Mp) {
					_position = _alt_position_f00000007m1;
					_obj = _alt_obj_f00000007m1;
				} else {
					_alternate_success_f00000007m1 = true;
				}
			}
			if (_alternate_success_f00000007m1) {
			} else {
				_position = _many_position_f00000007Ch;
				_obj = _many_obj_f00000007Ch;
				break;
			}
		}
		_sequence_end_f00000006MJ:
		if (_sequence_fail_f00000006MJ) {
			_obj = _optional_obj_f00000005uU;
			_position = _optional_position_f00000005uU;
			goto optional_exit_f00000005uU;
		} else {
			goto optional_exit_f00000005uU;
		}
		optional_exit_f00000005uU:
		if (_position.Match("]")) {
		} else {
			_position.Update("“]”", "literal list");
			_sequence_fail_f00000005XC = true;
			goto _sequence_end_f00000005XC;
		}
		_sequence_end_f00000005XC:
		if (_sequence_fail_f00000005XC) {
			_position.Cache<expression_literal_list>(_start_index, null);
			_position.TraceExit("expression:literal_list", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_literal_list>(_start_index, _obj);
			_position.TraceExit("expression:literal_list", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_nan(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_nan, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_nan();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:nan");

		if (_position.Match("NaN")) {
			_position.Cache<expression_nan>(_start_index, _obj);
			_position.TraceExit("expression:nan", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		} else {
			_position.Update("“NaN”", "floating-point not-a-number");
			_position.Cache<expression_nan>(_start_index, null);
			_position.TraceExit("expression:nan", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_negation(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_negation, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_negation();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:negation");

		bool _sequence_fail_f00000005XR = false;
		if (_position.Match("-")) {
		} else {
			_position.Update("“-”", "numeric negation");
			_sequence_fail_f00000005XR = true;
			goto _sequence_end_f00000005XR;
		}
		while(true) {
			ParserPosition _many_position_f00000006MW = _position.Clone();
			var _many_obj_f00000006MW = _obj.Clone();
			bool _alternate_success_f00000006jK = false;
			ParserPosition _alt_position_f00000006jK = _position;
			var _alt_obj_f00000006jK = _obj;
			if (!_alternate_success_f00000006jK) {
				_position = _alt_position_f00000006jK.Clone();
				_obj = _alt_obj_f00000006jK.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006jK = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "numeric negation");
					_position = _alt_position_f00000006jK;
					_obj = _alt_obj_f00000006jK;
				}
			}
			if (!_alternate_success_f00000006jK) {
				_position = _alt_position_f00000006jK.Clone();
				_obj = _alt_obj_f00000006jK.Clone();
				bool _sequence_fail_f00000007D1 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "numeric negation");
					_sequence_fail_f00000007D1 = true;
					goto _sequence_end_f00000007D1;
				}
				while(true) {
					ParserPosition _many_position_f00000007m5 = _position.Clone();
					var _many_obj_f00000007m5 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "numeric negation");
						_position = _many_position_f00000007m5;
						_obj = _many_obj_f00000007m5;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "numeric negation");
					_sequence_fail_f00000007D1 = true;
					goto _sequence_end_f00000007D1;
				}
				_sequence_end_f00000007D1:
				if (_sequence_fail_f00000007D1) {
					_position = _alt_position_f00000006jK;
					_obj = _alt_obj_f00000006jK;
				} else {
					_alternate_success_f00000006jK = true;
				}
			}
			if (_alternate_success_f00000006jK) {
			} else {
				_position = _many_position_f00000006MW;
				_obj = _many_obj_f00000006MW;
				break;
			}
		}
		if (expression.ParseRule_expression20(ref _position, out _obj.expr)) {
		} else {
		_sequence_fail_f00000005XR = true;
		goto _sequence_end_f00000005XR;
		}
		_sequence_end_f00000005XR:
		if (_sequence_fail_f00000005XR) {
			_position.Cache<expression_negation>(_start_index, null);
			_position.TraceExit("expression:negation", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_negation>(_start_index, _obj);
			_position.TraceExit("expression:negation", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_not(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_not, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_not();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:not");

		bool _sequence_fail_f00000005Xb = false;
		if (_position.Match("!")) {
		} else {
			_position.Update("“!”", "logical negation");
			_sequence_fail_f00000005Xb = true;
			goto _sequence_end_f00000005Xb;
		}
		while(true) {
			ParserPosition _many_position_f00000006Mf = _position.Clone();
			var _many_obj_f00000006Mf = _obj.Clone();
			bool _alternate_success_f00000006jR = false;
			ParserPosition _alt_position_f00000006jR = _position;
			var _alt_obj_f00000006jR = _obj;
			if (!_alternate_success_f00000006jR) {
				_position = _alt_position_f00000006jR.Clone();
				_obj = _alt_obj_f00000006jR.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006jR = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "logical negation");
					_position = _alt_position_f00000006jR;
					_obj = _alt_obj_f00000006jR;
				}
			}
			if (!_alternate_success_f00000006jR) {
				_position = _alt_position_f00000006jR.Clone();
				_obj = _alt_obj_f00000006jR.Clone();
				bool _sequence_fail_f00000007D7 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "logical negation");
					_sequence_fail_f00000007D7 = true;
					goto _sequence_end_f00000007D7;
				}
				while(true) {
					ParserPosition _many_position_f00000007mB = _position.Clone();
					var _many_obj_f00000007mB = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "logical negation");
						_position = _many_position_f00000007mB;
						_obj = _many_obj_f00000007mB;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "logical negation");
					_sequence_fail_f00000007D7 = true;
					goto _sequence_end_f00000007D7;
				}
				_sequence_end_f00000007D7:
				if (_sequence_fail_f00000007D7) {
					_position = _alt_position_f00000006jR;
					_obj = _alt_obj_f00000006jR;
				} else {
					_alternate_success_f00000006jR = true;
				}
			}
			if (_alternate_success_f00000006jR) {
			} else {
				_position = _many_position_f00000006Mf;
				_obj = _many_obj_f00000006Mf;
				break;
			}
		}
		if (expression.ParseRule_expression20(ref _position, out _obj.expr)) {
		} else {
		_sequence_fail_f00000005Xb = true;
		goto _sequence_end_f00000005Xb;
		}
		_sequence_end_f00000005Xb:
		if (_sequence_fail_f00000005Xb) {
			_position.Cache<expression_not>(_start_index, null);
			_position.TraceExit("expression:not", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_not>(_start_index, _obj);
			_position.TraceExit("expression:not", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_null(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_null, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_null();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:null");

		if (_position.Match("Null")) {
			_position.Cache<expression_null>(_start_index, _obj);
			_position.TraceExit("expression:null", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		} else {
			_position.Update("“Null”", "null value");
			_position.Cache<expression_null>(_start_index, null);
			_position.TraceExit("expression:null", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_nullable_lookup(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_nullable_lookup, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_nullable_lookup();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:nullable_lookup");

		bool _sequence_fail_f00000005Xq = false;
		if (expression.ParseRule_expression20(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000005Xq = true;
		goto _sequence_end_f00000005Xq;
		}
		if (_position.Match("?.")) {
		} else {
			_position.Update("“?.”", "nullable contextual lookup");
			_sequence_fail_f00000005Xq = true;
			goto _sequence_end_f00000005Xq;
		}
		bool _first_f00000006Mt = true;
		while(true) {
			ParserPosition _many_position_f00000006Mt = _position.Clone();
			var _many_obj_f00000006Mt = _obj.Clone();
			if (!_first_f00000006Mt) {
			if (_position.Match(".")) {
			} else {
				_position.Update("“.”", "nullable contextual lookup");
				_position = _many_position_f00000006Mt;
				_obj = _many_obj_f00000006Mt;
				break;
			}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.names, identifier.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000006Mt;
			_obj = _many_obj_f00000006Mt;
			break;
			}
			_first_f00000006Mt = false;
		}
		_sequence_end_f00000005Xq:
		if (_sequence_fail_f00000005Xq) {
			_position.Cache<expression_nullable_lookup>(_start_index, null);
			_position.TraceExit("expression:nullable_lookup", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_nullable_lookup>(_start_index, _obj);
			_position.TraceExit("expression:nullable_lookup", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_range(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_range, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_range();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:range");

		bool _sequence_fail_f00000005Y0 = false;
		if (expression.ParseRule_expression14(ref _position, out _obj.left)) {
		} else {
		_sequence_fail_f00000005Y0 = true;
		goto _sequence_end_f00000005Y0;
		}
		while(true) {
			ParserPosition _many_position_f00000006N5 = _position.Clone();
			var _many_obj_f00000006N5 = _obj.Clone();
			bool _alternate_success_f00000006ja = false;
			ParserPosition _alt_position_f00000006ja = _position;
			var _alt_obj_f00000006ja = _obj;
			if (!_alternate_success_f00000006ja) {
				_position = _alt_position_f00000006ja.Clone();
				_obj = _alt_obj_f00000006ja.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ja = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "integral range");
					_position = _alt_position_f00000006ja;
					_obj = _alt_obj_f00000006ja;
				}
			}
			if (!_alternate_success_f00000006ja) {
				_position = _alt_position_f00000006ja.Clone();
				_obj = _alt_obj_f00000006ja.Clone();
				bool _sequence_fail_f00000007DJ = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "integral range");
					_sequence_fail_f00000007DJ = true;
					goto _sequence_end_f00000007DJ;
				}
				while(true) {
					ParserPosition _many_position_f00000007mJ = _position.Clone();
					var _many_obj_f00000007mJ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "integral range");
						_position = _many_position_f00000007mJ;
						_obj = _many_obj_f00000007mJ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "integral range");
					_sequence_fail_f00000007DJ = true;
					goto _sequence_end_f00000007DJ;
				}
				_sequence_end_f00000007DJ:
				if (_sequence_fail_f00000007DJ) {
					_position = _alt_position_f00000006ja;
					_obj = _alt_obj_f00000006ja;
				} else {
					_alternate_success_f00000006ja = true;
				}
			}
			if (_alternate_success_f00000006ja) {
			} else {
				_position = _many_position_f00000006N5;
				_obj = _many_obj_f00000006N5;
				break;
			}
		}
		if (_position.Match("Through")) {
		} else {
			_position.Update("“Through”", "integral range");
			_sequence_fail_f00000005Y0 = true;
			goto _sequence_end_f00000005Y0;
		}
		while(true) {
			ParserPosition _many_position_f00000006N6 = _position.Clone();
			var _many_obj_f00000006N6 = _obj.Clone();
			bool _alternate_success_f00000006jb = false;
			ParserPosition _alt_position_f00000006jb = _position;
			var _alt_obj_f00000006jb = _obj;
			if (!_alternate_success_f00000006jb) {
				_position = _alt_position_f00000006jb.Clone();
				_obj = _alt_obj_f00000006jb.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006jb = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "integral range");
					_position = _alt_position_f00000006jb;
					_obj = _alt_obj_f00000006jb;
				}
			}
			if (!_alternate_success_f00000006jb) {
				_position = _alt_position_f00000006jb.Clone();
				_obj = _alt_obj_f00000006jb.Clone();
				bool _sequence_fail_f00000007DN = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "integral range");
					_sequence_fail_f00000007DN = true;
					goto _sequence_end_f00000007DN;
				}
				while(true) {
					ParserPosition _many_position_f00000007mP = _position.Clone();
					var _many_obj_f00000007mP = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "integral range");
						_position = _many_position_f00000007mP;
						_obj = _many_obj_f00000007mP;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "integral range");
					_sequence_fail_f00000007DN = true;
					goto _sequence_end_f00000007DN;
				}
				_sequence_end_f00000007DN:
				if (_sequence_fail_f00000007DN) {
					_position = _alt_position_f00000006jb;
					_obj = _alt_obj_f00000006jb;
				} else {
					_alternate_success_f00000006jb = true;
				}
			}
			if (_alternate_success_f00000006jb) {
			} else {
				_position = _many_position_f00000006N6;
				_obj = _many_obj_f00000006N6;
				break;
			}
		}
		if (expression.ParseRule_expression14(ref _position, out _obj.right)) {
		} else {
		_sequence_fail_f00000005Y0 = true;
		goto _sequence_end_f00000005Y0;
		}
		_sequence_end_f00000005Y0:
		if (_sequence_fail_f00000005Y0) {
			_position.Cache<expression_range>(_start_index, null);
			_position.TraceExit("expression:range", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_range>(_start_index, _obj);
			_position.TraceExit("expression:range", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_remote_lookup(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_remote_lookup, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_remote_lookup();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:remote_lookup");

		bool _sequence_fail_f00000005YA = false;
		if (_position.Match("Lookup")) {
		} else {
			_position.Update("“Lookup”", "remote contextual lookup");
			_sequence_fail_f00000005YA = true;
			goto _sequence_end_f00000005YA;
		}
		bool _first_f00000006NH = true;
		while(true) {
			ParserPosition _many_position_f00000006NH = _position.Clone();
			var _many_obj_f00000006NH = _obj.Clone();
			bool _alternate_success_f00000006jj = false;
			ParserPosition _alt_position_f00000006jj = _position;
			var _alt_obj_f00000006jj = _obj;
			if (!_alternate_success_f00000006jj) {
				_position = _alt_position_f00000006jj.Clone();
				_obj = _alt_obj_f00000006jj.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006jj = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "remote contextual lookup");
					_position = _alt_position_f00000006jj;
					_obj = _alt_obj_f00000006jj;
				}
			}
			if (!_alternate_success_f00000006jj) {
				_position = _alt_position_f00000006jj.Clone();
				_obj = _alt_obj_f00000006jj.Clone();
				bool _sequence_fail_f00000007DU = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "remote contextual lookup");
					_sequence_fail_f00000007DU = true;
					goto _sequence_end_f00000007DU;
				}
				while(true) {
					ParserPosition _many_position_f00000007mZ = _position.Clone();
					var _many_obj_f00000007mZ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "remote contextual lookup");
						_position = _many_position_f00000007mZ;
						_obj = _many_obj_f00000007mZ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "remote contextual lookup");
					_sequence_fail_f00000007DU = true;
					goto _sequence_end_f00000007DU;
				}
				_sequence_end_f00000007DU:
				if (_sequence_fail_f00000007DU) {
					_position = _alt_position_f00000006jj;
					_obj = _alt_obj_f00000006jj;
				} else {
					_alternate_success_f00000006jj = true;
				}
			}
			if (_alternate_success_f00000006jj) {
			} else {
				_position = _many_position_f00000006NH;
				_obj = _many_obj_f00000006NH;
				break;
			}
			_first_f00000006NH = false;
		}
		if (_first_f00000006NH) {
			_sequence_fail_f00000005YA = true;
			goto _sequence_end_f00000005YA;
		} else {
		}
		bool _first_f00000006NJ = true;
		while(true) {
			ParserPosition _many_position_f00000006NJ = _position.Clone();
			var _many_obj_f00000006NJ = _obj.Clone();
			if (!_first_f00000006NJ) {
			if (_position.Match(".")) {
			} else {
				_position.Update("“.”", "remote contextual lookup");
				_position = _many_position_f00000006NJ;
				_obj = _many_obj_f00000006NJ;
				break;
			}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.names, identifier.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000006NJ;
			_obj = _many_obj_f00000006NJ;
			break;
			}
			_first_f00000006NJ = false;
		}
		bool _first_f00000006NK = true;
		while(true) {
			ParserPosition _many_position_f00000006NK = _position.Clone();
			var _many_obj_f00000006NK = _obj.Clone();
			bool _alternate_success_f00000006jm = false;
			ParserPosition _alt_position_f00000006jm = _position;
			var _alt_obj_f00000006jm = _obj;
			if (!_alternate_success_f00000006jm) {
				_position = _alt_position_f00000006jm.Clone();
				_obj = _alt_obj_f00000006jm.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006jm = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "remote contextual lookup");
					_position = _alt_position_f00000006jm;
					_obj = _alt_obj_f00000006jm;
				}
			}
			if (!_alternate_success_f00000006jm) {
				_position = _alt_position_f00000006jm.Clone();
				_obj = _alt_obj_f00000006jm.Clone();
				bool _sequence_fail_f00000007Da = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "remote contextual lookup");
					_sequence_fail_f00000007Da = true;
					goto _sequence_end_f00000007Da;
				}
				while(true) {
					ParserPosition _many_position_f00000007mf = _position.Clone();
					var _many_obj_f00000007mf = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "remote contextual lookup");
						_position = _many_position_f00000007mf;
						_obj = _many_obj_f00000007mf;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "remote contextual lookup");
					_sequence_fail_f00000007Da = true;
					goto _sequence_end_f00000007Da;
				}
				_sequence_end_f00000007Da:
				if (_sequence_fail_f00000007Da) {
					_position = _alt_position_f00000006jm;
					_obj = _alt_obj_f00000006jm;
				} else {
					_alternate_success_f00000006jm = true;
				}
			}
			if (_alternate_success_f00000006jm) {
			} else {
				_position = _many_position_f00000006NK;
				_obj = _many_obj_f00000006NK;
				break;
			}
			_first_f00000006NK = false;
		}
		if (_first_f00000006NK) {
			_sequence_fail_f00000005YA = true;
			goto _sequence_end_f00000005YA;
		} else {
		}
		if (_position.Match("In")) {
		} else {
			_position.Update("“In”", "remote contextual lookup");
			_sequence_fail_f00000005YA = true;
			goto _sequence_end_f00000005YA;
		}
		bool _first_f00000006NM = true;
		while(true) {
			ParserPosition _many_position_f00000006NM = _position.Clone();
			var _many_obj_f00000006NM = _obj.Clone();
			bool _alternate_success_f00000006jn = false;
			ParserPosition _alt_position_f00000006jn = _position;
			var _alt_obj_f00000006jn = _obj;
			if (!_alternate_success_f00000006jn) {
				_position = _alt_position_f00000006jn.Clone();
				_obj = _alt_obj_f00000006jn.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006jn = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "remote contextual lookup");
					_position = _alt_position_f00000006jn;
					_obj = _alt_obj_f00000006jn;
				}
			}
			if (!_alternate_success_f00000006jn) {
				_position = _alt_position_f00000006jn.Clone();
				_obj = _alt_obj_f00000006jn.Clone();
				bool _sequence_fail_f00000007Dd = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "remote contextual lookup");
					_sequence_fail_f00000007Dd = true;
					goto _sequence_end_f00000007Dd;
				}
				while(true) {
					ParserPosition _many_position_f00000007ml = _position.Clone();
					var _many_obj_f00000007ml = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "remote contextual lookup");
						_position = _many_position_f00000007ml;
						_obj = _many_obj_f00000007ml;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "remote contextual lookup");
					_sequence_fail_f00000007Dd = true;
					goto _sequence_end_f00000007Dd;
				}
				_sequence_end_f00000007Dd:
				if (_sequence_fail_f00000007Dd) {
					_position = _alt_position_f00000006jn;
					_obj = _alt_obj_f00000006jn;
				} else {
					_alternate_success_f00000006jn = true;
				}
			}
			if (_alternate_success_f00000006jn) {
			} else {
				_position = _many_position_f00000006NM;
				_obj = _many_obj_f00000006NM;
				break;
			}
			_first_f00000006NM = false;
		}
		if (_first_f00000006NM) {
			_sequence_fail_f00000005YA = true;
			goto _sequence_end_f00000005YA;
		} else {
		}
		if (expression.ParseRule_expression16(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000005YA = true;
		goto _sequence_end_f00000005YA;
		}
		_sequence_end_f00000005YA:
		if (_sequence_fail_f00000005YA) {
			_position.Cache<expression_remote_lookup>(_start_index, null);
			_position.TraceExit("expression:remote_lookup", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_remote_lookup>(_start_index, _obj);
			_position.TraceExit("expression:remote_lookup", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_string_identifier(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_string_identifier, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_string_identifier();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:string_identifier");

		bool _sequence_fail_f00000005YF = false;
		if (_position.Match("$")) {
		} else {
			_position.Update("“$”", "string from identifier");
			_sequence_fail_f00000005YF = true;
			goto _sequence_end_f00000005YF;
		}
		bool _sequence_fail_f00000006NW = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "string from identifier");
			_sequence_fail_f00000006NW = true;
			goto _sequence_end_f00000006NW;
		}
		while(true) {
			ParserPosition _many_position_f00000006jq = _position.Clone();
			var _many_obj_f00000006jq = _obj.Clone();
			bool _alternate_success_f00000007Dj = false;
			ParserPosition _alt_position_f00000007Dj = _position;
			var _alt_obj_f00000007Dj = _obj;
			if (!_alternate_success_f00000007Dj) {
				_position = _alt_position_f00000007Dj.Clone();
				_obj = _alt_obj_f00000007Dj.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000007Dj = true;
				} else {
					_position.Update("character between “a” and “z”", "string from identifier");
					_position = _alt_position_f00000007Dj;
					_obj = _alt_obj_f00000007Dj;
				}
			}
			if (!_alternate_success_f00000007Dj) {
				_position = _alt_position_f00000007Dj.Clone();
				_obj = _alt_obj_f00000007Dj.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000007Dj = true;
				} else {
					_position.Update("character between “A” and “Z”", "string from identifier");
					_position = _alt_position_f00000007Dj;
					_obj = _alt_obj_f00000007Dj;
				}
			}
			if (!_alternate_success_f00000007Dj) {
				_position = _alt_position_f00000007Dj.Clone();
				_obj = _alt_obj_f00000007Dj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000007Dj = true;
				} else {
					_position.Update("character between “0” and “9”", "string from identifier");
					_position = _alt_position_f00000007Dj;
					_obj = _alt_obj_f00000007Dj;
				}
			}
			if (!_alternate_success_f00000007Dj) {
				_position = _alt_position_f00000007Dj.Clone();
				_obj = _alt_obj_f00000007Dj.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000007Dj = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "string from identifier");
					_position = _alt_position_f00000007Dj;
					_obj = _alt_obj_f00000007Dj;
				}
			}
			if (_alternate_success_f00000007Dj) {
			} else {
				_position = _many_position_f00000006jq;
				_obj = _many_obj_f00000006jq;
				break;
			}
		}
		_sequence_end_f00000006NW:
		if (_sequence_fail_f00000006NW) {
			_sequence_fail_f00000005YF = true;
			goto _sequence_end_f00000005YF;
		} else {
		}
		_sequence_end_f00000005YF:
		if (_sequence_fail_f00000005YF) {
			_position.Cache<expression_string_identifier>(_start_index, null);
			_position.TraceExit("expression:string_identifier", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_string_identifier>(_start_index, _obj);
			_position.TraceExit("expression:string_identifier", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_string_literal(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_string_literal, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_string_literal();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:string_literal");

		bool _sequence_fail_f00000005YM = false;
		if (_position.Match("\"")) {
		} else {
			_position.Update("“\"”", "string literal");
			_sequence_fail_f00000005YM = true;
			goto _sequence_end_f00000005YM;
		}
		while(true) {
			ParserPosition _many_position_f00000006Nc = _position.Clone();
			var _many_obj_f00000006Nc = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.parts, string_piece.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000006Nc;
			_obj = _many_obj_f00000006Nc;
			break;
			}
		}
		if (_position.Match("\"")) {
		} else {
			_position.Update("“\"”", "string literal");
			_sequence_fail_f00000005YM = true;
			goto _sequence_end_f00000005YM;
		}
		_sequence_end_f00000005YM:
		if (_sequence_fail_f00000005YM) {
			_position.Cache<expression_string_literal>(_start_index, null);
			_position.TraceExit("expression:string_literal", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_string_literal>(_start_index, _obj);
			_position.TraceExit("expression:string_literal", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_subexpression(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_subexpression, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_subexpression();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:subexpression");

		bool _sequence_fail_f00000005YT = false;
		if (_position.Match("(")) {
		} else {
			_position.Update("“(”", "sub-expression");
			_sequence_fail_f00000005YT = true;
			goto _sequence_end_f00000005YT;
		}
		while(true) {
			ParserPosition _many_position_f00000006Nj = _position.Clone();
			var _many_obj_f00000006Nj = _obj.Clone();
			bool _alternate_success_f00000006ju = false;
			ParserPosition _alt_position_f00000006ju = _position;
			var _alt_obj_f00000006ju = _obj;
			if (!_alternate_success_f00000006ju) {
				_position = _alt_position_f00000006ju.Clone();
				_obj = _alt_obj_f00000006ju.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006ju = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "sub-expression");
					_position = _alt_position_f00000006ju;
					_obj = _alt_obj_f00000006ju;
				}
			}
			if (!_alternate_success_f00000006ju) {
				_position = _alt_position_f00000006ju.Clone();
				_obj = _alt_obj_f00000006ju.Clone();
				bool _sequence_fail_f00000007Dv = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "sub-expression");
					_sequence_fail_f00000007Dv = true;
					goto _sequence_end_f00000007Dv;
				}
				while(true) {
					ParserPosition _many_position_f00000007mx = _position.Clone();
					var _many_obj_f00000007mx = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "sub-expression");
						_position = _many_position_f00000007mx;
						_obj = _many_obj_f00000007mx;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "sub-expression");
					_sequence_fail_f00000007Dv = true;
					goto _sequence_end_f00000007Dv;
				}
				_sequence_end_f00000007Dv:
				if (_sequence_fail_f00000007Dv) {
					_position = _alt_position_f00000006ju;
					_obj = _alt_obj_f00000006ju;
				} else {
					_alternate_success_f00000006ju = true;
				}
			}
			if (_alternate_success_f00000006ju) {
			} else {
				_position = _many_position_f00000006Nj;
				_obj = _many_obj_f00000006Nj;
				break;
			}
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000005YT = true;
		goto _sequence_end_f00000005YT;
		}
		while(true) {
			ParserPosition _many_position_f00000006Nn = _position.Clone();
			var _many_obj_f00000006Nn = _obj.Clone();
			bool _alternate_success_f00000006jv = false;
			ParserPosition _alt_position_f00000006jv = _position;
			var _alt_obj_f00000006jv = _obj;
			if (!_alternate_success_f00000006jv) {
				_position = _alt_position_f00000006jv.Clone();
				_obj = _alt_obj_f00000006jv.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006jv = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "sub-expression");
					_position = _alt_position_f00000006jv;
					_obj = _alt_obj_f00000006jv;
				}
			}
			if (!_alternate_success_f00000006jv) {
				_position = _alt_position_f00000006jv.Clone();
				_obj = _alt_obj_f00000006jv.Clone();
				bool _sequence_fail_f00000007Dy = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "sub-expression");
					_sequence_fail_f00000007Dy = true;
					goto _sequence_end_f00000007Dy;
				}
				while(true) {
					ParserPosition _many_position_f00000007n3 = _position.Clone();
					var _many_obj_f00000007n3 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "sub-expression");
						_position = _many_position_f00000007n3;
						_obj = _many_obj_f00000007n3;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "sub-expression");
					_sequence_fail_f00000007Dy = true;
					goto _sequence_end_f00000007Dy;
				}
				_sequence_end_f00000007Dy:
				if (_sequence_fail_f00000007Dy) {
					_position = _alt_position_f00000006jv;
					_obj = _alt_obj_f00000006jv;
				} else {
					_alternate_success_f00000006jv = true;
				}
			}
			if (_alternate_success_f00000006jv) {
			} else {
				_position = _many_position_f00000006Nn;
				_obj = _many_obj_f00000006Nn;
				break;
			}
		}
		if (_position.Match(")")) {
		} else {
			_position.Update("“)”", "sub-expression");
			_sequence_fail_f00000005YT = true;
			goto _sequence_end_f00000005YT;
		}
		_sequence_end_f00000005YT:
		if (_sequence_fail_f00000005YT) {
			_position.Cache<expression_subexpression>(_start_index, null);
			_position.TraceExit("expression:subexpression", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_subexpression>(_start_index, _obj);
			_position.TraceExit("expression:subexpression", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_template_extend(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_template_extend, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_template_extend();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:template_extend");

		bool _sequence_fail_f00000005Ye = false;
		if (_position.Match("Template")) {
		} else {
			_position.Update("“Template”", "extend existing template");
			_sequence_fail_f00000005Ye = true;
			goto _sequence_end_f00000005Ye;
		}
		bool _first_f00000006O2 = true;
		while(true) {
			ParserPosition _many_position_f00000006O2 = _position.Clone();
			var _many_obj_f00000006O2 = _obj.Clone();
			bool _alternate_success_f00000006k1 = false;
			ParserPosition _alt_position_f00000006k1 = _position;
			var _alt_obj_f00000006k1 = _obj;
			if (!_alternate_success_f00000006k1) {
				_position = _alt_position_f00000006k1.Clone();
				_obj = _alt_obj_f00000006k1.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006k1 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "extend existing template");
					_position = _alt_position_f00000006k1;
					_obj = _alt_obj_f00000006k1;
				}
			}
			if (!_alternate_success_f00000006k1) {
				_position = _alt_position_f00000006k1.Clone();
				_obj = _alt_obj_f00000006k1.Clone();
				bool _sequence_fail_f00000007E7 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "extend existing template");
					_sequence_fail_f00000007E7 = true;
					goto _sequence_end_f00000007E7;
				}
				while(true) {
					ParserPosition _many_position_f00000007nE = _position.Clone();
					var _many_obj_f00000007nE = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "extend existing template");
						_position = _many_position_f00000007nE;
						_obj = _many_obj_f00000007nE;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "extend existing template");
					_sequence_fail_f00000007E7 = true;
					goto _sequence_end_f00000007E7;
				}
				_sequence_end_f00000007E7:
				if (_sequence_fail_f00000007E7) {
					_position = _alt_position_f00000006k1;
					_obj = _alt_obj_f00000006k1;
				} else {
					_alternate_success_f00000006k1 = true;
				}
			}
			if (_alternate_success_f00000006k1) {
			} else {
				_position = _many_position_f00000006O2;
				_obj = _many_obj_f00000006O2;
				break;
			}
			_first_f00000006O2 = false;
		}
		if (_first_f00000006O2) {
			_sequence_fail_f00000005Ye = true;
			goto _sequence_end_f00000005Ye;
		} else {
		}
		if (expression.ParseRule_expression20(ref _position, out _obj.source)) {
		} else {
		_sequence_fail_f00000005Ye = true;
		goto _sequence_end_f00000005Ye;
		}
		while(true) {
			ParserPosition _many_position_f00000006O5 = _position.Clone();
			var _many_obj_f00000006O5 = _obj.Clone();
			bool _alternate_success_f00000006k2 = false;
			ParserPosition _alt_position_f00000006k2 = _position;
			var _alt_obj_f00000006k2 = _obj;
			if (!_alternate_success_f00000006k2) {
				_position = _alt_position_f00000006k2.Clone();
				_obj = _alt_obj_f00000006k2.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006k2 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "extend existing template");
					_position = _alt_position_f00000006k2;
					_obj = _alt_obj_f00000006k2;
				}
			}
			if (!_alternate_success_f00000006k2) {
				_position = _alt_position_f00000006k2.Clone();
				_obj = _alt_obj_f00000006k2.Clone();
				bool _sequence_fail_f00000007EA = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "extend existing template");
					_sequence_fail_f00000007EA = true;
					goto _sequence_end_f00000007EA;
				}
				while(true) {
					ParserPosition _many_position_f00000007nK = _position.Clone();
					var _many_obj_f00000007nK = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "extend existing template");
						_position = _many_position_f00000007nK;
						_obj = _many_obj_f00000007nK;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "extend existing template");
					_sequence_fail_f00000007EA = true;
					goto _sequence_end_f00000007EA;
				}
				_sequence_end_f00000007EA:
				if (_sequence_fail_f00000007EA) {
					_position = _alt_position_f00000006k2;
					_obj = _alt_obj_f00000006k2;
				} else {
					_alternate_success_f00000006k2 = true;
				}
			}
			if (_alternate_success_f00000006k2) {
			} else {
				_position = _many_position_f00000006O5;
				_obj = _many_obj_f00000006O5;
				break;
			}
		}
		if (_position.Match("{")) {
		} else {
			_position.Update("“{”", "extend existing template");
			_sequence_fail_f00000005Ye = true;
			goto _sequence_end_f00000005Ye;
		}
		while(true) {
			ParserPosition _many_position_f00000006O8 = _position.Clone();
			var _many_obj_f00000006O8 = _obj.Clone();
			bool _sequence_fail_f00000006k3 = false;
			while(true) {
				ParserPosition _many_position_f00000007EC = _position.Clone();
				var _many_obj_f00000007EC = _obj.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "extend existing template");
					_position = _many_position_f00000007EC;
					_obj = _many_obj_f00000007EC;
					break;
				}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.overrides, (ref ParserPosition _iposition, out attribute _iresult) => { if (attribute.ParseRule_extend_tmpl_attributes(ref _iposition, out _iresult)) { var f00000007ED_key = Generator.ToString(_iresult.name); if (_obj.overrides_dedup.ContainsKey(f00000007ED_key)) { _iposition.NameConstraint(f00000007ED_key); return false; } else { _obj.overrides_dedup[f00000007ED_key] = true; return true; } } else { return false; } })) {
			} else {
			_sequence_fail_f00000006k3 = true;
			goto _sequence_end_f00000006k3;
			}
			_sequence_end_f00000006k3:
			if (_sequence_fail_f00000006k3) {
				_position = _many_position_f00000006O8;
				_obj = _many_obj_f00000006O8;
				break;
			} else {
			}
		}
		while(true) {
			ParserPosition _many_position_f00000006O9 = _position.Clone();
			var _many_obj_f00000006O9 = _obj.Clone();
			bool _alternate_success_f00000006k4 = false;
			ParserPosition _alt_position_f00000006k4 = _position;
			var _alt_obj_f00000006k4 = _obj;
			if (!_alternate_success_f00000006k4) {
				_position = _alt_position_f00000006k4.Clone();
				_obj = _alt_obj_f00000006k4.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006k4 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "extend existing template");
					_position = _alt_position_f00000006k4;
					_obj = _alt_obj_f00000006k4;
				}
			}
			if (!_alternate_success_f00000006k4) {
				_position = _alt_position_f00000006k4.Clone();
				_obj = _alt_obj_f00000006k4.Clone();
				bool _sequence_fail_f00000007EG = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "extend existing template");
					_sequence_fail_f00000007EG = true;
					goto _sequence_end_f00000007EG;
				}
				while(true) {
					ParserPosition _many_position_f00000007nX = _position.Clone();
					var _many_obj_f00000007nX = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "extend existing template");
						_position = _many_position_f00000007nX;
						_obj = _many_obj_f00000007nX;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "extend existing template");
					_sequence_fail_f00000007EG = true;
					goto _sequence_end_f00000007EG;
				}
				_sequence_end_f00000007EG:
				if (_sequence_fail_f00000007EG) {
					_position = _alt_position_f00000006k4;
					_obj = _alt_obj_f00000006k4;
				} else {
					_alternate_success_f00000006k4 = true;
				}
			}
			if (_alternate_success_f00000006k4) {
			} else {
				_position = _many_position_f00000006O9;
				_obj = _many_obj_f00000006O9;
				break;
			}
		}
		if (_position.Match("}")) {
		} else {
			_position.Update("“}”", "extend existing template");
			_sequence_fail_f00000005Ye = true;
			goto _sequence_end_f00000005Ye;
		}
		_sequence_end_f00000005Ye:
		if (_sequence_fail_f00000005Ye) {
			_position.Cache<expression_template_extend>(_start_index, null);
			_position.TraceExit("expression:template_extend", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_template_extend>(_start_index, _obj);
			_position.TraceExit("expression:template_extend", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_template_new(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_template_new, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_template_new();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:template_new");

		bool _sequence_fail_f00000005Yo = false;
		if (_position.Match("Template")) {
		} else {
			_position.Update("“Template”", "define new template");
			_sequence_fail_f00000005Yo = true;
			goto _sequence_end_f00000005Yo;
		}
		while(true) {
			ParserPosition _many_position_f00000006OG = _position.Clone();
			var _many_obj_f00000006OG = _obj.Clone();
			bool _alternate_success_f00000006k5 = false;
			ParserPosition _alt_position_f00000006k5 = _position;
			var _alt_obj_f00000006k5 = _obj;
			if (!_alternate_success_f00000006k5) {
				_position = _alt_position_f00000006k5.Clone();
				_obj = _alt_obj_f00000006k5.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006k5 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "define new template");
					_position = _alt_position_f00000006k5;
					_obj = _alt_obj_f00000006k5;
				}
			}
			if (!_alternate_success_f00000006k5) {
				_position = _alt_position_f00000006k5.Clone();
				_obj = _alt_obj_f00000006k5.Clone();
				bool _sequence_fail_f00000007EN = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "define new template");
					_sequence_fail_f00000007EN = true;
					goto _sequence_end_f00000007EN;
				}
				while(true) {
					ParserPosition _many_position_f00000007ne = _position.Clone();
					var _many_obj_f00000007ne = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "define new template");
						_position = _many_position_f00000007ne;
						_obj = _many_obj_f00000007ne;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "define new template");
					_sequence_fail_f00000007EN = true;
					goto _sequence_end_f00000007EN;
				}
				_sequence_end_f00000007EN:
				if (_sequence_fail_f00000007EN) {
					_position = _alt_position_f00000006k5;
					_obj = _alt_obj_f00000006k5;
				} else {
					_alternate_success_f00000006k5 = true;
				}
			}
			if (_alternate_success_f00000006k5) {
			} else {
				_position = _many_position_f00000006OG;
				_obj = _many_obj_f00000006OG;
				break;
			}
		}
		if (_position.Match("{")) {
		} else {
			_position.Update("“{”", "define new template");
			_sequence_fail_f00000005Yo = true;
			goto _sequence_end_f00000005Yo;
		}
		while(true) {
			ParserPosition _many_position_f00000006OJ = _position.Clone();
			var _many_obj_f00000006OJ = _obj.Clone();
			bool _sequence_fail_f00000006k6 = false;
			while(true) {
				ParserPosition _many_position_f00000007EP = _position.Clone();
				var _many_obj_f00000007EP = _obj.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "define new template");
					_position = _many_position_f00000007EP;
					_obj = _many_obj_f00000007EP;
					break;
				}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.attributes, (ref ParserPosition _iposition, out attribute _iresult) => { if (attribute.ParseRule_new_tmpl_attributes(ref _iposition, out _iresult)) { var f00000007EQ_key = Generator.ToString(_iresult.name); if (_obj.attributes_dedup.ContainsKey(f00000007EQ_key)) { _iposition.NameConstraint(f00000007EQ_key); return false; } else { _obj.attributes_dedup[f00000007EQ_key] = true; return true; } } else { return false; } })) {
			} else {
			_sequence_fail_f00000006k6 = true;
			goto _sequence_end_f00000006k6;
			}
			_sequence_end_f00000006k6:
			if (_sequence_fail_f00000006k6) {
				_position = _many_position_f00000006OJ;
				_obj = _many_obj_f00000006OJ;
				break;
			} else {
			}
		}
		while(true) {
			ParserPosition _many_position_f00000006OK = _position.Clone();
			var _many_obj_f00000006OK = _obj.Clone();
			bool _alternate_success_f00000006k7 = false;
			ParserPosition _alt_position_f00000006k7 = _position;
			var _alt_obj_f00000006k7 = _obj;
			if (!_alternate_success_f00000006k7) {
				_position = _alt_position_f00000006k7.Clone();
				_obj = _alt_obj_f00000006k7.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006k7 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "define new template");
					_position = _alt_position_f00000006k7;
					_obj = _alt_obj_f00000006k7;
				}
			}
			if (!_alternate_success_f00000006k7) {
				_position = _alt_position_f00000006k7.Clone();
				_obj = _alt_obj_f00000006k7.Clone();
				bool _sequence_fail_f00000007ET = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "define new template");
					_sequence_fail_f00000007ET = true;
					goto _sequence_end_f00000007ET;
				}
				while(true) {
					ParserPosition _many_position_f00000007nr = _position.Clone();
					var _many_obj_f00000007nr = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "define new template");
						_position = _many_position_f00000007nr;
						_obj = _many_obj_f00000007nr;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "define new template");
					_sequence_fail_f00000007ET = true;
					goto _sequence_end_f00000007ET;
				}
				_sequence_end_f00000007ET:
				if (_sequence_fail_f00000007ET) {
					_position = _alt_position_f00000006k7;
					_obj = _alt_obj_f00000006k7;
				} else {
					_alternate_success_f00000006k7 = true;
				}
			}
			if (_alternate_success_f00000006k7) {
			} else {
				_position = _many_position_f00000006OK;
				_obj = _many_obj_f00000006OK;
				break;
			}
		}
		if (_position.Match("}")) {
		} else {
			_position.Update("“}”", "define new template");
			_sequence_fail_f00000005Yo = true;
			goto _sequence_end_f00000005Yo;
		}
		_sequence_end_f00000005Yo:
		if (_sequence_fail_f00000005Yo) {
			_position.Cache<expression_template_new>(_start_index, null);
			_position.TraceExit("expression:template_new", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_template_new>(_start_index, _obj);
			_position.TraceExit("expression:template_new", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_this(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_this, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_this();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:this");

		if (_position.Match("This")) {
			_position.Cache<expression_this>(_start_index, _obj);
			_position.TraceExit("expression:this", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		} else {
			_position.Update("“This”", "current frame");
			_position.Cache<expression_this>(_start_index, null);
			_position.TraceExit("expression:this", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_time_literal(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_time_literal, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_time_literal();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:time_literal");

		bool _first_f00000005wu = true;
		while(true) {
			ParserPosition _many_position_f00000005wu = _position.Clone();
			var _many_obj_f00000005wu = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.parts, time.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000005wu;
			_obj = _many_obj_f00000005wu;
			break;
			}
			_first_f00000005wu = false;
		}
		if (_first_f00000005wu) {
			_position.Cache<expression_time_literal>(_start_index, null);
			_position.TraceExit("expression:time_literal", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_time_literal>(_start_index, _obj);
			_position.TraceExit("expression:time_literal", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_true(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_true, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_true();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:true");

		if (_position.Match("True")) {
			_position.Cache<expression_true>(_start_index, _obj);
			_position.TraceExit("expression:true", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		} else {
			_position.Update("“True”", "logical truth");
			_position.Cache<expression_true>(_start_index, null);
			_position.TraceExit("expression:true", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_type_of(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_type_of, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_type_of();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:type_of");

		bool _sequence_fail_f00000005ZC = false;
		if (_position.Match("TypeOf")) {
		} else {
			_position.Update("“TypeOf”", "type-directed lookup");
			_sequence_fail_f00000005ZC = true;
			goto _sequence_end_f00000005ZC;
		}
		bool _first_f00000006Oc = true;
		while(true) {
			ParserPosition _many_position_f00000006Oc = _position.Clone();
			var _many_obj_f00000006Oc = _obj.Clone();
			bool _alternate_success_f00000006kE = false;
			ParserPosition _alt_position_f00000006kE = _position;
			var _alt_obj_f00000006kE = _obj;
			if (!_alternate_success_f00000006kE) {
				_position = _alt_position_f00000006kE.Clone();
				_obj = _alt_obj_f00000006kE.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006kE = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "type-directed lookup");
					_position = _alt_position_f00000006kE;
					_obj = _alt_obj_f00000006kE;
				}
			}
			if (!_alternate_success_f00000006kE) {
				_position = _alt_position_f00000006kE.Clone();
				_obj = _alt_obj_f00000006kE.Clone();
				bool _sequence_fail_f00000007Ef = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "type-directed lookup");
					_sequence_fail_f00000007Ef = true;
					goto _sequence_end_f00000007Ef;
				}
				while(true) {
					ParserPosition _many_position_f00000007nx = _position.Clone();
					var _many_obj_f00000007nx = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "type-directed lookup");
						_position = _many_position_f00000007nx;
						_obj = _many_obj_f00000007nx;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "type-directed lookup");
					_sequence_fail_f00000007Ef = true;
					goto _sequence_end_f00000007Ef;
				}
				_sequence_end_f00000007Ef:
				if (_sequence_fail_f00000007Ef) {
					_position = _alt_position_f00000006kE;
					_obj = _alt_obj_f00000006kE;
				} else {
					_alternate_success_f00000006kE = true;
				}
			}
			if (_alternate_success_f00000006kE) {
			} else {
				_position = _many_position_f00000006Oc;
				_obj = _many_obj_f00000006Oc;
				break;
			}
			_first_f00000006Oc = false;
		}
		if (_first_f00000006Oc) {
			_sequence_fail_f00000005ZC = true;
			goto _sequence_end_f00000005ZC;
		} else {
		}
		if (expression.ParseRule_expression20(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000005ZC = true;
		goto _sequence_end_f00000005ZC;
		}
		var _optional_obj_f00000005x9 = _obj.Clone();
		ParserPosition _optional_position_f00000005x9 = _position.Clone();
		bool _sequence_fail_f00000006Of = false;
		bool _first_f00000007Eg = true;
		while(true) {
			ParserPosition _many_position_f00000007Eg = _position.Clone();
			var _many_obj_f00000007Eg = _obj.Clone();
			bool _alternate_success_f00000007o1 = false;
			ParserPosition _alt_position_f00000007o1 = _position;
			var _alt_obj_f00000007o1 = _obj;
			if (!_alternate_success_f00000007o1) {
				_position = _alt_position_f00000007o1.Clone();
				_obj = _alt_obj_f00000007o1.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000007o1 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "type-directed lookup");
					_position = _alt_position_f00000007o1;
					_obj = _alt_obj_f00000007o1;
				}
			}
			if (!_alternate_success_f00000007o1) {
				_position = _alt_position_f00000007o1.Clone();
				_obj = _alt_obj_f00000007o1.Clone();
				bool _sequence_fail_f00000008Om = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "type-directed lookup");
					_sequence_fail_f00000008Om = true;
					goto _sequence_end_f00000008Om;
				}
				while(true) {
					ParserPosition _many_position_f00000008n0 = _position.Clone();
					var _many_obj_f00000008n0 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "type-directed lookup");
						_position = _many_position_f00000008n0;
						_obj = _many_obj_f00000008n0;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "type-directed lookup");
					_sequence_fail_f00000008Om = true;
					goto _sequence_end_f00000008Om;
				}
				_sequence_end_f00000008Om:
				if (_sequence_fail_f00000008Om) {
					_position = _alt_position_f00000007o1;
					_obj = _alt_obj_f00000007o1;
				} else {
					_alternate_success_f00000007o1 = true;
				}
			}
			if (_alternate_success_f00000007o1) {
			} else {
				_position = _many_position_f00000007Eg;
				_obj = _many_obj_f00000007Eg;
				break;
			}
			_first_f00000007Eg = false;
		}
		if (_first_f00000007Eg) {
			_sequence_fail_f00000006Of = true;
			goto _sequence_end_f00000006Of;
		} else {
		}
		if (_position.Match("With")) {
		} else {
			_position.Update("“With”", "type-directed lookup");
			_sequence_fail_f00000006Of = true;
			goto _sequence_end_f00000006Of;
		}
		bool _first_f00000007Ej = true;
		while(true) {
			ParserPosition _many_position_f00000007Ej = _position.Clone();
			var _many_obj_f00000007Ej = _obj.Clone();
			if (!_first_f00000007Ej) {
			if (_position.Match(".")) {
			} else {
				_position.Update("“.”", "type-directed lookup");
				_position = _many_position_f00000007Ej;
				_obj = _many_obj_f00000007Ej;
				break;
			}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.names, identifier.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000007Ej;
			_obj = _many_obj_f00000007Ej;
			break;
			}
			_first_f00000007Ej = false;
		}
		_sequence_end_f00000006Of:
		if (_sequence_fail_f00000006Of) {
			_obj = _optional_obj_f00000005x9;
			_position = _optional_position_f00000005x9;
			goto optional_exit_f00000005x9;
		} else {
			goto optional_exit_f00000005x9;
		}
		optional_exit_f00000005x9:
		_sequence_end_f00000005ZC:
		if (_sequence_fail_f00000005ZC) {
			_position.Cache<expression_type_of>(_start_index, null);
			_position.TraceExit("expression:type_of", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_type_of>(_start_index, _obj);
			_position.TraceExit("expression:type_of", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_xcomputation(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_xcomputation, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_xcomputation();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:xcomputation");

		bool _sequence_fail_f00000005ZK = false;
		if (_position.Parser.DisableExtensions) {
			_sequence_fail_f00000005ZK = true;
			goto _sequence_end_f00000005ZK;
		}
		if (_position.Match("XComputation")) {
		} else {
			_position.Update("“XComputation”", "invoke CLI Flabbergast.Computation class");
			_sequence_fail_f00000005ZK = true;
			goto _sequence_end_f00000005ZK;
		}
		bool _first_f00000006On = true;
		while(true) {
			ParserPosition _many_position_f00000006On = _position.Clone();
			var _many_obj_f00000006On = _obj.Clone();
			bool _alternate_success_f00000006kJ = false;
			ParserPosition _alt_position_f00000006kJ = _position;
			var _alt_obj_f00000006kJ = _obj;
			if (!_alternate_success_f00000006kJ) {
				_position = _alt_position_f00000006kJ.Clone();
				_obj = _alt_obj_f00000006kJ.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006kJ = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "invoke CLI Flabbergast.Computation class");
					_position = _alt_position_f00000006kJ;
					_obj = _alt_obj_f00000006kJ;
				}
			}
			if (!_alternate_success_f00000006kJ) {
				_position = _alt_position_f00000006kJ.Clone();
				_obj = _alt_obj_f00000006kJ.Clone();
				bool _sequence_fail_f00000007Es = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "invoke CLI Flabbergast.Computation class");
					_sequence_fail_f00000007Es = true;
					goto _sequence_end_f00000007Es;
				}
				while(true) {
					ParserPosition _many_position_f00000007o6 = _position.Clone();
					var _many_obj_f00000007o6 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "invoke CLI Flabbergast.Computation class");
						_position = _many_position_f00000007o6;
						_obj = _many_obj_f00000007o6;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "invoke CLI Flabbergast.Computation class");
					_sequence_fail_f00000007Es = true;
					goto _sequence_end_f00000007Es;
				}
				_sequence_end_f00000007Es:
				if (_sequence_fail_f00000007Es) {
					_position = _alt_position_f00000006kJ;
					_obj = _alt_obj_f00000006kJ;
				} else {
					_alternate_success_f00000006kJ = true;
				}
			}
			if (_alternate_success_f00000006kJ) {
			} else {
				_position = _many_position_f00000006On;
				_obj = _many_obj_f00000006On;
				break;
			}
			_first_f00000006On = false;
		}
		if (_first_f00000006On) {
			_sequence_fail_f00000005ZK = true;
			goto _sequence_end_f00000005ZK;
		} else {
		}
		bool _first_f00000006Oo = true;
		while(true) {
			ParserPosition _many_position_f00000006Oo = _position.Clone();
			var _many_obj_f00000006Oo = _obj.Clone();
			if (!_first_f00000006Oo) {
			if (".,".IndexOf(_position.Next()) != -1) {
				_obj.type_name = new RevCons<char>(_position.PeekLast(), _obj.type_name);
			} else {
				_position.Update(Parser.ToLiteral(".,"), "invoke CLI Flabbergast.Computation class");
				_position = _many_position_f00000006Oo;
				_obj = _many_obj_f00000006Oo;
				break;
			}
			}
			bool _sequence_fail_f00000006kK = false;
			var char_class_f00000007Eu = System.Char.GetUnicodeCategory(_position.Next());
			if (false || char_class_f00000007Eu == System.Globalization.UnicodeCategory.LowercaseLetter || char_class_f00000007Eu == System.Globalization.UnicodeCategory.ModifierLetter || char_class_f00000007Eu == System.Globalization.UnicodeCategory.OtherLetter || char_class_f00000007Eu == System.Globalization.UnicodeCategory.TitlecaseLetter || char_class_f00000007Eu == System.Globalization.UnicodeCategory.UppercaseLetter || char_class_f00000007Eu == System.Globalization.UnicodeCategory.LetterNumber) {
				_obj.type_name = new RevCons<char>(_position.PeekLast(), _obj.type_name);
			} else {
				_position.Update("character of type lower-case letter or modifier letter or other letter or title-case letter or upper-case letter or letter-like numeral", "invoke CLI Flabbergast.Computation class");
				_sequence_fail_f00000006kK = true;
				goto _sequence_end_f00000006kK;
			}
			while(true) {
				ParserPosition _many_position_f00000007Ev = _position.Clone();
				var _many_obj_f00000007Ev = _obj.Clone();
				var char_class_f00000007oB = System.Char.GetUnicodeCategory(_position.Next());
				if (false || char_class_f00000007oB == System.Globalization.UnicodeCategory.LowercaseLetter || char_class_f00000007oB == System.Globalization.UnicodeCategory.ModifierLetter || char_class_f00000007oB == System.Globalization.UnicodeCategory.OtherLetter || char_class_f00000007oB == System.Globalization.UnicodeCategory.TitlecaseLetter || char_class_f00000007oB == System.Globalization.UnicodeCategory.UppercaseLetter || char_class_f00000007oB == System.Globalization.UnicodeCategory.SpacingCombiningMark || char_class_f00000007oB == System.Globalization.UnicodeCategory.NonSpacingMark || char_class_f00000007oB == System.Globalization.UnicodeCategory.DecimalDigitNumber || char_class_f00000007oB == System.Globalization.UnicodeCategory.LetterNumber || char_class_f00000007oB == System.Globalization.UnicodeCategory.Format || char_class_f00000007oB == System.Globalization.UnicodeCategory.ConnectorPunctuation) {
					_obj.type_name = new RevCons<char>(_position.PeekLast(), _obj.type_name);
				} else {
					_position.Update("character of type lower-case letter or modifier letter or other letter or title-case letter or upper-case letter or spacing combining mark or non-spaching modification mark or decimal numeral or letter-like numeral or format layout or connecting punctuation", "invoke CLI Flabbergast.Computation class");
					_position = _many_position_f00000007Ev;
					_obj = _many_obj_f00000007Ev;
					break;
				}
			}
			_sequence_end_f00000006kK:
			if (_sequence_fail_f00000006kK) {
				_position = _many_position_f00000006Oo;
				_obj = _many_obj_f00000006Oo;
				break;
			} else {
			}
			_first_f00000006Oo = false;
		}
		if (_first_f00000006Oo) {
			_sequence_fail_f00000005ZK = true;
			goto _sequence_end_f00000005ZK;
		} else {
		}
		_sequence_end_f00000005ZK:
		if (_sequence_fail_f00000005ZK) {
			_position.Cache<expression_xcomputation>(_start_index, null);
			_position.TraceExit("expression:xcomputation", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_xcomputation>(_start_index, _obj);
			_position.TraceExit("expression:xcomputation", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_xfield(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_xfield, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_xfield();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:xfield");

		bool _sequence_fail_f00000005ZU = false;
		if (_position.Parser.DisableExtensions) {
			_sequence_fail_f00000005ZU = true;
			goto _sequence_end_f00000005ZU;
		}
		if (_position.Match("XField")) {
		} else {
			_position.Update("“XField”", "access CLI field");
			_sequence_fail_f00000005ZU = true;
			goto _sequence_end_f00000005ZU;
		}
		bool _first_f00000006Ou = true;
		while(true) {
			ParserPosition _many_position_f00000006Ou = _position.Clone();
			var _many_obj_f00000006Ou = _obj.Clone();
			bool _alternate_success_f00000006kM = false;
			ParserPosition _alt_position_f00000006kM = _position;
			var _alt_obj_f00000006kM = _obj;
			if (!_alternate_success_f00000006kM) {
				_position = _alt_position_f00000006kM.Clone();
				_obj = _alt_obj_f00000006kM.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006kM = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "access CLI field");
					_position = _alt_position_f00000006kM;
					_obj = _alt_obj_f00000006kM;
				}
			}
			if (!_alternate_success_f00000006kM) {
				_position = _alt_position_f00000006kM.Clone();
				_obj = _alt_obj_f00000006kM.Clone();
				bool _sequence_fail_f00000007F2 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "access CLI field");
					_sequence_fail_f00000007F2 = true;
					goto _sequence_end_f00000007F2;
				}
				while(true) {
					ParserPosition _many_position_f00000007oH = _position.Clone();
					var _many_obj_f00000007oH = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "access CLI field");
						_position = _many_position_f00000007oH;
						_obj = _many_obj_f00000007oH;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "access CLI field");
					_sequence_fail_f00000007F2 = true;
					goto _sequence_end_f00000007F2;
				}
				_sequence_end_f00000007F2:
				if (_sequence_fail_f00000007F2) {
					_position = _alt_position_f00000006kM;
					_obj = _alt_obj_f00000006kM;
				} else {
					_alternate_success_f00000006kM = true;
				}
			}
			if (_alternate_success_f00000006kM) {
			} else {
				_position = _many_position_f00000006Ou;
				_obj = _many_obj_f00000006Ou;
				break;
			}
			_first_f00000006Ou = false;
		}
		if (_first_f00000006Ou) {
			_sequence_fail_f00000005ZU = true;
			goto _sequence_end_f00000005ZU;
		} else {
		}
		bool _first_f00000006Ov = true;
		while(true) {
			ParserPosition _many_position_f00000006Ov = _position.Clone();
			var _many_obj_f00000006Ov = _obj.Clone();
			if (!_first_f00000006Ov) {
			if (".,".IndexOf(_position.Next()) != -1) {
				_obj.type_name = new RevCons<char>(_position.PeekLast(), _obj.type_name);
			} else {
				_position.Update(Parser.ToLiteral(".,"), "access CLI field");
				_position = _many_position_f00000006Ov;
				_obj = _many_obj_f00000006Ov;
				break;
			}
			}
			bool _sequence_fail_f00000006kN = false;
			var char_class_f00000007F4 = System.Char.GetUnicodeCategory(_position.Next());
			if (false || char_class_f00000007F4 == System.Globalization.UnicodeCategory.LowercaseLetter || char_class_f00000007F4 == System.Globalization.UnicodeCategory.ModifierLetter || char_class_f00000007F4 == System.Globalization.UnicodeCategory.OtherLetter || char_class_f00000007F4 == System.Globalization.UnicodeCategory.TitlecaseLetter || char_class_f00000007F4 == System.Globalization.UnicodeCategory.UppercaseLetter || char_class_f00000007F4 == System.Globalization.UnicodeCategory.LetterNumber) {
				_obj.type_name = new RevCons<char>(_position.PeekLast(), _obj.type_name);
			} else {
				_position.Update("character of type lower-case letter or modifier letter or other letter or title-case letter or upper-case letter or letter-like numeral", "access CLI field");
				_sequence_fail_f00000006kN = true;
				goto _sequence_end_f00000006kN;
			}
			while(true) {
				ParserPosition _many_position_f00000007F5 = _position.Clone();
				var _many_obj_f00000007F5 = _obj.Clone();
				var char_class_f00000007oM = System.Char.GetUnicodeCategory(_position.Next());
				if (false || char_class_f00000007oM == System.Globalization.UnicodeCategory.LowercaseLetter || char_class_f00000007oM == System.Globalization.UnicodeCategory.ModifierLetter || char_class_f00000007oM == System.Globalization.UnicodeCategory.OtherLetter || char_class_f00000007oM == System.Globalization.UnicodeCategory.TitlecaseLetter || char_class_f00000007oM == System.Globalization.UnicodeCategory.UppercaseLetter || char_class_f00000007oM == System.Globalization.UnicodeCategory.SpacingCombiningMark || char_class_f00000007oM == System.Globalization.UnicodeCategory.NonSpacingMark || char_class_f00000007oM == System.Globalization.UnicodeCategory.DecimalDigitNumber || char_class_f00000007oM == System.Globalization.UnicodeCategory.LetterNumber || char_class_f00000007oM == System.Globalization.UnicodeCategory.Format || char_class_f00000007oM == System.Globalization.UnicodeCategory.ConnectorPunctuation) {
					_obj.type_name = new RevCons<char>(_position.PeekLast(), _obj.type_name);
				} else {
					_position.Update("character of type lower-case letter or modifier letter or other letter or title-case letter or upper-case letter or spacing combining mark or non-spaching modification mark or decimal numeral or letter-like numeral or format layout or connecting punctuation", "access CLI field");
					_position = _many_position_f00000007F5;
					_obj = _many_obj_f00000007F5;
					break;
				}
			}
			_sequence_end_f00000006kN:
			if (_sequence_fail_f00000006kN) {
				_position = _many_position_f00000006Ov;
				_obj = _many_obj_f00000006Ov;
				break;
			} else {
			}
			_first_f00000006Ov = false;
		}
		if (_first_f00000006Ov) {
			_sequence_fail_f00000005ZU = true;
			goto _sequence_end_f00000005ZU;
		} else {
		}
		bool _first_f00000006Ow = true;
		while(true) {
			ParserPosition _many_position_f00000006Ow = _position.Clone();
			var _many_obj_f00000006Ow = _obj.Clone();
			bool _alternate_success_f00000006kP = false;
			ParserPosition _alt_position_f00000006kP = _position;
			var _alt_obj_f00000006kP = _obj;
			if (!_alternate_success_f00000006kP) {
				_position = _alt_position_f00000006kP.Clone();
				_obj = _alt_obj_f00000006kP.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006kP = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "access CLI field");
					_position = _alt_position_f00000006kP;
					_obj = _alt_obj_f00000006kP;
				}
			}
			if (!_alternate_success_f00000006kP) {
				_position = _alt_position_f00000006kP.Clone();
				_obj = _alt_obj_f00000006kP.Clone();
				bool _sequence_fail_f00000007F8 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "access CLI field");
					_sequence_fail_f00000007F8 = true;
					goto _sequence_end_f00000007F8;
				}
				while(true) {
					ParserPosition _many_position_f00000007oS = _position.Clone();
					var _many_obj_f00000007oS = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "access CLI field");
						_position = _many_position_f00000007oS;
						_obj = _many_obj_f00000007oS;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "access CLI field");
					_sequence_fail_f00000007F8 = true;
					goto _sequence_end_f00000007F8;
				}
				_sequence_end_f00000007F8:
				if (_sequence_fail_f00000007F8) {
					_position = _alt_position_f00000006kP;
					_obj = _alt_obj_f00000006kP;
				} else {
					_alternate_success_f00000006kP = true;
				}
			}
			if (_alternate_success_f00000006kP) {
			} else {
				_position = _many_position_f00000006Ow;
				_obj = _many_obj_f00000006Ow;
				break;
			}
			_first_f00000006Ow = false;
		}
		if (_first_f00000006Ow) {
			_sequence_fail_f00000005ZU = true;
			goto _sequence_end_f00000005ZU;
		} else {
		}
		bool _sequence_fail_f00000006Ox = false;
		var char_class_f00000006kR = System.Char.GetUnicodeCategory(_position.Next());
		if (false || char_class_f00000006kR == System.Globalization.UnicodeCategory.LowercaseLetter || char_class_f00000006kR == System.Globalization.UnicodeCategory.ModifierLetter || char_class_f00000006kR == System.Globalization.UnicodeCategory.OtherLetter || char_class_f00000006kR == System.Globalization.UnicodeCategory.TitlecaseLetter || char_class_f00000006kR == System.Globalization.UnicodeCategory.UppercaseLetter || char_class_f00000006kR == System.Globalization.UnicodeCategory.LetterNumber) {
			_obj.field_name = new RevCons<char>(_position.PeekLast(), _obj.field_name);
		} else {
			_position.Update("character of type lower-case letter or modifier letter or other letter or title-case letter or upper-case letter or letter-like numeral", "access CLI field");
			_sequence_fail_f00000006Ox = true;
			goto _sequence_end_f00000006Ox;
		}
		while(true) {
			ParserPosition _many_position_f00000006kS = _position.Clone();
			var _many_obj_f00000006kS = _obj.Clone();
			var char_class_f00000007FA = System.Char.GetUnicodeCategory(_position.Next());
			if (false || char_class_f00000007FA == System.Globalization.UnicodeCategory.LowercaseLetter || char_class_f00000007FA == System.Globalization.UnicodeCategory.ModifierLetter || char_class_f00000007FA == System.Globalization.UnicodeCategory.OtherLetter || char_class_f00000007FA == System.Globalization.UnicodeCategory.TitlecaseLetter || char_class_f00000007FA == System.Globalization.UnicodeCategory.UppercaseLetter || char_class_f00000007FA == System.Globalization.UnicodeCategory.SpacingCombiningMark || char_class_f00000007FA == System.Globalization.UnicodeCategory.NonSpacingMark || char_class_f00000007FA == System.Globalization.UnicodeCategory.DecimalDigitNumber || char_class_f00000007FA == System.Globalization.UnicodeCategory.LetterNumber || char_class_f00000007FA == System.Globalization.UnicodeCategory.Format || char_class_f00000007FA == System.Globalization.UnicodeCategory.ConnectorPunctuation) {
				_obj.field_name = new RevCons<char>(_position.PeekLast(), _obj.field_name);
			} else {
				_position.Update("character of type lower-case letter or modifier letter or other letter or title-case letter or upper-case letter or spacing combining mark or non-spaching modification mark or decimal numeral or letter-like numeral or format layout or connecting punctuation", "access CLI field");
				_position = _many_position_f00000006kS;
				_obj = _many_obj_f00000006kS;
				break;
			}
		}
		_sequence_end_f00000006Ox:
		if (_sequence_fail_f00000006Ox) {
			_sequence_fail_f00000005ZU = true;
			goto _sequence_end_f00000005ZU;
		} else {
		}
		_sequence_end_f00000005ZU:
		if (_sequence_fail_f00000005ZU) {
			_position.Cache<expression_xfield>(_start_index, null);
			_position.TraceExit("expression:xfield", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_xfield>(_start_index, _obj);
			_position.TraceExit("expression:xfield", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	internal static bool ParseRule_xinvoke(ref ParserPosition _position, out expression _result) {
		if(_position.CheckCache<expression_xinvoke, expression>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new expression_xinvoke();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("expression:xinvoke");

		bool _sequence_fail_f00000005Ze = false;
		if (_position.Parser.DisableExtensions) {
			_sequence_fail_f00000005Ze = true;
			goto _sequence_end_f00000005Ze;
		}
		if (_position.Match("XInvoke")) {
		} else {
			_position.Update("“XInvoke”", "invoke CLI method");
			_sequence_fail_f00000005Ze = true;
			goto _sequence_end_f00000005Ze;
		}
		bool _first_f00000006P4 = true;
		while(true) {
			ParserPosition _many_position_f00000006P4 = _position.Clone();
			var _many_obj_f00000006P4 = _obj.Clone();
			bool _alternate_success_f00000006kU = false;
			ParserPosition _alt_position_f00000006kU = _position;
			var _alt_obj_f00000006kU = _obj;
			if (!_alternate_success_f00000006kU) {
				_position = _alt_position_f00000006kU.Clone();
				_obj = _alt_obj_f00000006kU.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006kU = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "invoke CLI method");
					_position = _alt_position_f00000006kU;
					_obj = _alt_obj_f00000006kU;
				}
			}
			if (!_alternate_success_f00000006kU) {
				_position = _alt_position_f00000006kU.Clone();
				_obj = _alt_obj_f00000006kU.Clone();
				bool _sequence_fail_f00000007FK = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "invoke CLI method");
					_sequence_fail_f00000007FK = true;
					goto _sequence_end_f00000007FK;
				}
				while(true) {
					ParserPosition _many_position_f00000007ob = _position.Clone();
					var _many_obj_f00000007ob = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "invoke CLI method");
						_position = _many_position_f00000007ob;
						_obj = _many_obj_f00000007ob;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "invoke CLI method");
					_sequence_fail_f00000007FK = true;
					goto _sequence_end_f00000007FK;
				}
				_sequence_end_f00000007FK:
				if (_sequence_fail_f00000007FK) {
					_position = _alt_position_f00000006kU;
					_obj = _alt_obj_f00000006kU;
				} else {
					_alternate_success_f00000006kU = true;
				}
			}
			if (_alternate_success_f00000006kU) {
			} else {
				_position = _many_position_f00000006P4;
				_obj = _many_obj_f00000006P4;
				break;
			}
			_first_f00000006P4 = false;
		}
		if (_first_f00000006P4) {
			_sequence_fail_f00000005Ze = true;
			goto _sequence_end_f00000005Ze;
		} else {
		}
		bool _first_f00000006P5 = true;
		while(true) {
			ParserPosition _many_position_f00000006P5 = _position.Clone();
			var _many_obj_f00000006P5 = _obj.Clone();
			if (!_first_f00000006P5) {
			if (".,".IndexOf(_position.Next()) != -1) {
				_obj.type_name = new RevCons<char>(_position.PeekLast(), _obj.type_name);
			} else {
				_position.Update(Parser.ToLiteral(".,"), "invoke CLI method");
				_position = _many_position_f00000006P5;
				_obj = _many_obj_f00000006P5;
				break;
			}
			}
			bool _sequence_fail_f00000006kV = false;
			var char_class_f00000007FM = System.Char.GetUnicodeCategory(_position.Next());
			if (false || char_class_f00000007FM == System.Globalization.UnicodeCategory.LowercaseLetter || char_class_f00000007FM == System.Globalization.UnicodeCategory.ModifierLetter || char_class_f00000007FM == System.Globalization.UnicodeCategory.OtherLetter || char_class_f00000007FM == System.Globalization.UnicodeCategory.TitlecaseLetter || char_class_f00000007FM == System.Globalization.UnicodeCategory.UppercaseLetter || char_class_f00000007FM == System.Globalization.UnicodeCategory.LetterNumber) {
				_obj.type_name = new RevCons<char>(_position.PeekLast(), _obj.type_name);
			} else {
				_position.Update("character of type lower-case letter or modifier letter or other letter or title-case letter or upper-case letter or letter-like numeral", "invoke CLI method");
				_sequence_fail_f00000006kV = true;
				goto _sequence_end_f00000006kV;
			}
			while(true) {
				ParserPosition _many_position_f00000007FN = _position.Clone();
				var _many_obj_f00000007FN = _obj.Clone();
				var char_class_f00000007og = System.Char.GetUnicodeCategory(_position.Next());
				if (false || char_class_f00000007og == System.Globalization.UnicodeCategory.LowercaseLetter || char_class_f00000007og == System.Globalization.UnicodeCategory.ModifierLetter || char_class_f00000007og == System.Globalization.UnicodeCategory.OtherLetter || char_class_f00000007og == System.Globalization.UnicodeCategory.TitlecaseLetter || char_class_f00000007og == System.Globalization.UnicodeCategory.UppercaseLetter || char_class_f00000007og == System.Globalization.UnicodeCategory.SpacingCombiningMark || char_class_f00000007og == System.Globalization.UnicodeCategory.NonSpacingMark || char_class_f00000007og == System.Globalization.UnicodeCategory.DecimalDigitNumber || char_class_f00000007og == System.Globalization.UnicodeCategory.LetterNumber || char_class_f00000007og == System.Globalization.UnicodeCategory.Format || char_class_f00000007og == System.Globalization.UnicodeCategory.ConnectorPunctuation) {
					_obj.type_name = new RevCons<char>(_position.PeekLast(), _obj.type_name);
				} else {
					_position.Update("character of type lower-case letter or modifier letter or other letter or title-case letter or upper-case letter or spacing combining mark or non-spaching modification mark or decimal numeral or letter-like numeral or format layout or connecting punctuation", "invoke CLI method");
					_position = _many_position_f00000007FN;
					_obj = _many_obj_f00000007FN;
					break;
				}
			}
			_sequence_end_f00000006kV:
			if (_sequence_fail_f00000006kV) {
				_position = _many_position_f00000006P5;
				_obj = _many_obj_f00000006P5;
				break;
			} else {
			}
			_first_f00000006P5 = false;
		}
		if (_first_f00000006P5) {
			_sequence_fail_f00000005Ze = true;
			goto _sequence_end_f00000005Ze;
		} else {
		}
		bool _first_f00000006P6 = true;
		while(true) {
			ParserPosition _many_position_f00000006P6 = _position.Clone();
			var _many_obj_f00000006P6 = _obj.Clone();
			bool _alternate_success_f00000006kX = false;
			ParserPosition _alt_position_f00000006kX = _position;
			var _alt_obj_f00000006kX = _obj;
			if (!_alternate_success_f00000006kX) {
				_position = _alt_position_f00000006kX.Clone();
				_obj = _alt_obj_f00000006kX.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006kX = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "invoke CLI method");
					_position = _alt_position_f00000006kX;
					_obj = _alt_obj_f00000006kX;
				}
			}
			if (!_alternate_success_f00000006kX) {
				_position = _alt_position_f00000006kX.Clone();
				_obj = _alt_obj_f00000006kX.Clone();
				bool _sequence_fail_f00000007FQ = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "invoke CLI method");
					_sequence_fail_f00000007FQ = true;
					goto _sequence_end_f00000007FQ;
				}
				while(true) {
					ParserPosition _many_position_f00000007om = _position.Clone();
					var _many_obj_f00000007om = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "invoke CLI method");
						_position = _many_position_f00000007om;
						_obj = _many_obj_f00000007om;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "invoke CLI method");
					_sequence_fail_f00000007FQ = true;
					goto _sequence_end_f00000007FQ;
				}
				_sequence_end_f00000007FQ:
				if (_sequence_fail_f00000007FQ) {
					_position = _alt_position_f00000006kX;
					_obj = _alt_obj_f00000006kX;
				} else {
					_alternate_success_f00000006kX = true;
				}
			}
			if (_alternate_success_f00000006kX) {
			} else {
				_position = _many_position_f00000006P6;
				_obj = _many_obj_f00000006P6;
				break;
			}
			_first_f00000006P6 = false;
		}
		if (_first_f00000006P6) {
			_sequence_fail_f00000005Ze = true;
			goto _sequence_end_f00000005Ze;
		} else {
		}
		bool _sequence_fail_f00000006P7 = false;
		var char_class_f00000006kZ = System.Char.GetUnicodeCategory(_position.Next());
		if (false || char_class_f00000006kZ == System.Globalization.UnicodeCategory.LowercaseLetter || char_class_f00000006kZ == System.Globalization.UnicodeCategory.ModifierLetter || char_class_f00000006kZ == System.Globalization.UnicodeCategory.OtherLetter || char_class_f00000006kZ == System.Globalization.UnicodeCategory.TitlecaseLetter || char_class_f00000006kZ == System.Globalization.UnicodeCategory.UppercaseLetter || char_class_f00000006kZ == System.Globalization.UnicodeCategory.LetterNumber) {
			_obj.method_name = new RevCons<char>(_position.PeekLast(), _obj.method_name);
		} else {
			_position.Update("character of type lower-case letter or modifier letter or other letter or title-case letter or upper-case letter or letter-like numeral", "invoke CLI method");
			_sequence_fail_f00000006P7 = true;
			goto _sequence_end_f00000006P7;
		}
		while(true) {
			ParserPosition _many_position_f00000006ka = _position.Clone();
			var _many_obj_f00000006ka = _obj.Clone();
			var char_class_f00000007FS = System.Char.GetUnicodeCategory(_position.Next());
			if (false || char_class_f00000007FS == System.Globalization.UnicodeCategory.LowercaseLetter || char_class_f00000007FS == System.Globalization.UnicodeCategory.ModifierLetter || char_class_f00000007FS == System.Globalization.UnicodeCategory.OtherLetter || char_class_f00000007FS == System.Globalization.UnicodeCategory.TitlecaseLetter || char_class_f00000007FS == System.Globalization.UnicodeCategory.UppercaseLetter || char_class_f00000007FS == System.Globalization.UnicodeCategory.SpacingCombiningMark || char_class_f00000007FS == System.Globalization.UnicodeCategory.NonSpacingMark || char_class_f00000007FS == System.Globalization.UnicodeCategory.DecimalDigitNumber || char_class_f00000007FS == System.Globalization.UnicodeCategory.LetterNumber || char_class_f00000007FS == System.Globalization.UnicodeCategory.Format || char_class_f00000007FS == System.Globalization.UnicodeCategory.ConnectorPunctuation) {
				_obj.method_name = new RevCons<char>(_position.PeekLast(), _obj.method_name);
			} else {
				_position.Update("character of type lower-case letter or modifier letter or other letter or title-case letter or upper-case letter or spacing combining mark or non-spaching modification mark or decimal numeral or letter-like numeral or format layout or connecting punctuation", "invoke CLI method");
				_position = _many_position_f00000006ka;
				_obj = _many_obj_f00000006ka;
				break;
			}
		}
		_sequence_end_f00000006P7:
		if (_sequence_fail_f00000006P7) {
			_sequence_fail_f00000005Ze = true;
			goto _sequence_end_f00000005Ze;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f00000006P8 = _position.Clone();
			var _many_obj_f00000006P8 = _obj.Clone();
			bool _alternate_success_f00000006kb = false;
			ParserPosition _alt_position_f00000006kb = _position;
			var _alt_obj_f00000006kb = _obj;
			if (!_alternate_success_f00000006kb) {
				_position = _alt_position_f00000006kb.Clone();
				_obj = _alt_obj_f00000006kb.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000006kb = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "invoke CLI method");
					_position = _alt_position_f00000006kb;
					_obj = _alt_obj_f00000006kb;
				}
			}
			if (!_alternate_success_f00000006kb) {
				_position = _alt_position_f00000006kb.Clone();
				_obj = _alt_obj_f00000006kb.Clone();
				bool _sequence_fail_f00000007FY = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "invoke CLI method");
					_sequence_fail_f00000007FY = true;
					goto _sequence_end_f00000007FY;
				}
				while(true) {
					ParserPosition _many_position_f00000007ov = _position.Clone();
					var _many_obj_f00000007ov = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "invoke CLI method");
						_position = _many_position_f00000007ov;
						_obj = _many_obj_f00000007ov;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "invoke CLI method");
					_sequence_fail_f00000007FY = true;
					goto _sequence_end_f00000007FY;
				}
				_sequence_end_f00000007FY:
				if (_sequence_fail_f00000007FY) {
					_position = _alt_position_f00000006kb;
					_obj = _alt_obj_f00000006kb;
				} else {
					_alternate_success_f00000006kb = true;
				}
			}
			if (_alternate_success_f00000006kb) {
			} else {
				_position = _many_position_f00000006P8;
				_obj = _many_obj_f00000006P8;
				break;
			}
		}
		if (_position.Match("(")) {
		} else {
			_position.Update("“(”", "invoke CLI method");
			_sequence_fail_f00000005Ze = true;
			goto _sequence_end_f00000005Ze;
		}
		bool _first_f00000006PB = true;
		while(true) {
			ParserPosition _many_position_f00000006PB = _position.Clone();
			var _many_obj_f00000006PB = _obj.Clone();
			if (!_first_f00000006PB) {
			if (_position.Match(",")) {
			} else {
				_position.Update("“,”", "invoke CLI method");
				_position = _many_position_f00000006PB;
				_obj = _many_obj_f00000006PB;
				break;
			}
			}
			bool _sequence_fail_f00000006kc = false;
			while(true) {
				ParserPosition _many_position_f00000007oz = _position.Clone();
				var _many_obj_f00000007oz = _obj.Clone();
				bool _alternate_success_f00000008PY = false;
				ParserPosition _alt_position_f00000008PY = _position;
				var _alt_obj_f00000008PY = _obj;
				if (!_alternate_success_f00000008PY) {
					_position = _alt_position_f00000008PY.Clone();
					_obj = _alt_obj_f00000008PY.Clone();
					if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
						_alternate_success_f00000008PY = true;
					} else {
						_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "invoke CLI method");
						_position = _alt_position_f00000008PY;
						_obj = _alt_obj_f00000008PY;
					}
				}
				if (!_alternate_success_f00000008PY) {
					_position = _alt_position_f00000008PY.Clone();
					_obj = _alt_obj_f00000008PY.Clone();
					bool _sequence_fail_f00000008nV = false;
					if (_position.Match("#")) {
					} else {
						_position.Update("“#”", "invoke CLI method");
						_sequence_fail_f00000008nV = true;
						goto _sequence_end_f00000008nV;
					}
					while(true) {
						ParserPosition _many_position_f00000009C7 = _position.Clone();
						var _many_obj_f00000009C7 = _obj.Clone();
						if ("\n".IndexOf(_position.Next()) == -1) {
							_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
						} else {
							_position.Update(Parser.ToLiteral("\n"), "invoke CLI method");
							_position = _many_position_f00000009C7;
							_obj = _many_obj_f00000009C7;
							break;
						}
					}
					if ("\n".IndexOf(_position.Next()) != -1) {
					} else {
						_position.Update(Parser.ToLiteral("\n"), "invoke CLI method");
						_sequence_fail_f00000008nV = true;
						goto _sequence_end_f00000008nV;
					}
					_sequence_end_f00000008nV:
					if (_sequence_fail_f00000008nV) {
						_position = _alt_position_f00000008PY;
						_obj = _alt_obj_f00000008PY;
					} else {
						_alternate_success_f00000008PY = true;
					}
				}
				if (_alternate_success_f00000008PY) {
				} else {
					_position = _many_position_f00000007oz;
					_obj = _many_obj_f00000007oz;
					break;
				}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.arguments, expression.ParseRule_expression0)) {
			} else {
			_sequence_fail_f00000006kc = true;
			goto _sequence_end_f00000006kc;
			}
			while(true) {
				ParserPosition _many_position_f00000007p3 = _position.Clone();
				var _many_obj_f00000007p3 = _obj.Clone();
				bool _alternate_success_f00000008PZ = false;
				ParserPosition _alt_position_f00000008PZ = _position;
				var _alt_obj_f00000008PZ = _obj;
				if (!_alternate_success_f00000008PZ) {
					_position = _alt_position_f00000008PZ.Clone();
					_obj = _alt_obj_f00000008PZ.Clone();
					if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
						_alternate_success_f00000008PZ = true;
					} else {
						_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "invoke CLI method");
						_position = _alt_position_f00000008PZ;
						_obj = _alt_obj_f00000008PZ;
					}
				}
				if (!_alternate_success_f00000008PZ) {
					_position = _alt_position_f00000008PZ.Clone();
					_obj = _alt_obj_f00000008PZ.Clone();
					bool _sequence_fail_f00000008nY = false;
					if (_position.Match("#")) {
					} else {
						_position.Update("“#”", "invoke CLI method");
						_sequence_fail_f00000008nY = true;
						goto _sequence_end_f00000008nY;
					}
					while(true) {
						ParserPosition _many_position_f00000009CD = _position.Clone();
						var _many_obj_f00000009CD = _obj.Clone();
						if ("\n".IndexOf(_position.Next()) == -1) {
							_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
						} else {
							_position.Update(Parser.ToLiteral("\n"), "invoke CLI method");
							_position = _many_position_f00000009CD;
							_obj = _many_obj_f00000009CD;
							break;
						}
					}
					if ("\n".IndexOf(_position.Next()) != -1) {
					} else {
						_position.Update(Parser.ToLiteral("\n"), "invoke CLI method");
						_sequence_fail_f00000008nY = true;
						goto _sequence_end_f00000008nY;
					}
					_sequence_end_f00000008nY:
					if (_sequence_fail_f00000008nY) {
						_position = _alt_position_f00000008PZ;
						_obj = _alt_obj_f00000008PZ;
					} else {
						_alternate_success_f00000008PZ = true;
					}
				}
				if (_alternate_success_f00000008PZ) {
				} else {
					_position = _many_position_f00000007p3;
					_obj = _many_obj_f00000007p3;
					break;
				}
			}
			_sequence_end_f00000006kc:
			if (_sequence_fail_f00000006kc) {
				_position = _many_position_f00000006PB;
				_obj = _many_obj_f00000006PB;
				break;
			} else {
			}
			_first_f00000006PB = false;
		}
		if (_position.Match(")")) {
		} else {
			_position.Update("“)”", "invoke CLI method");
			_sequence_fail_f00000005Ze = true;
			goto _sequence_end_f00000005Ze;
		}
		_sequence_end_f00000005Ze:
		if (_sequence_fail_f00000005Ze) {
			_position.Cache<expression_xinvoke>(_start_index, null);
			_position.TraceExit("expression:xinvoke", false);
			_result = null;
			return false;
		} else {
			_position.Cache<expression_xinvoke>(_start_index, _obj);
			_position.TraceExit("expression:xinvoke", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (expression)_obj;
			return true;
		}
	}
	public abstract void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _block);
}
internal class expression_arithmetic_conjunction : expression {
	public override string PrettyName { get { return "arithmetic conjunction"; } }
	internal expression start_expr;
	internal System.Collections.Generic.List<arithmetic_conjunction_term> terms = new System.Collections.Generic.List<arithmetic_conjunction_term>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (start_expr != null) { start_expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (terms != null) { foreach (var f00000005P7 in terms) f00000005P7.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005P9 = _type & (0 | Flabbergast.Type.Float | Flabbergast.Type.Int);
		if (f00000005P9 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float | Flabbergast.Type.Int, _type);
		}
		var f00000005i6 = NameInfo.AnyType;
		var f00000006Bj =  f00000005P9;
		if (start_expr != null) f00000006Bj &= AstTypeableNode.HorrendousTypeMerge(start_expr.EnsureType(_collector, f00000005P9 | Flabbergast.Type.Int, ref _success, true), f00000005P9);
		f00000005i6 &= f00000006Bj;
		var f00000006Bk = NameInfo.AnyType;
		if (terms != null) foreach (var f00000006Bk_item in terms) f00000006Bk &= f00000006Bk_item.EnsureType(_collector, f00000005P9 | Flabbergast.Type.Int, ref _success, true);
		f00000005i6 &= f00000006Bk;
		InferredType = f00000005i6;		return f00000005i6;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		start_expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005i5) => {
			_generator.DebugPosition(this);
			_generator.Fold((LoadableValue) f00000005i5, terms, (f00000006Bh_index, f00000006Bh_item, f00000005P8_left, f00000006Bh_block) => f00000006Bh_item.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, f00000005P8_left, f00000006Bh_block), (f00000005P8) => {
				_final_block(f00000005P8);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		start_expr.GenerateApi(_api_gen, false);
		foreach(var f00000005i2 in terms) 			f00000005i2.GenerateApi(_api_gen, false);
	}
	internal expression_arithmetic_conjunction Clone() {
		var _obj = new expression_arithmetic_conjunction();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.start_expr = start_expr;
		_obj.terms.AddRange(terms);
		return _obj;
	}
}
internal class expression_arithmetic_disjunction : expression {
	public override string PrettyName { get { return "arithmetic disjunction"; } }
	internal expression start_expr;
	internal System.Collections.Generic.List<arithmetic_disjunction_term> terms = new System.Collections.Generic.List<arithmetic_disjunction_term>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (start_expr != null) { start_expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (terms != null) { foreach (var f00000005PI in terms) f00000005PI.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005PK = _type & (0 | Flabbergast.Type.Float | Flabbergast.Type.Int);
		if (f00000005PK == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float | Flabbergast.Type.Int, _type);
		}
		var f00000005iH = NameInfo.AnyType;
		var f00000006Bz =  f00000005PK;
		if (start_expr != null) f00000006Bz &= AstTypeableNode.HorrendousTypeMerge(start_expr.EnsureType(_collector, f00000005PK | Flabbergast.Type.Int, ref _success, true), f00000005PK);
		f00000005iH &= f00000006Bz;
		var f00000006C0 = NameInfo.AnyType;
		if (terms != null) foreach (var f00000006C0_item in terms) f00000006C0 &= f00000006C0_item.EnsureType(_collector, f00000005PK | Flabbergast.Type.Int, ref _success, true);
		f00000005iH &= f00000006C0;
		InferredType = f00000005iH;		return f00000005iH;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		start_expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005iG) => {
			_generator.DebugPosition(this);
			_generator.Fold((LoadableValue) f00000005iG, terms, (f00000006Bx_index, f00000006Bx_item, f00000005PJ_left, f00000006Bx_block) => f00000006Bx_item.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, f00000005PJ_left, f00000006Bx_block), (f00000005PJ) => {
				_final_block(f00000005PJ);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		start_expr.GenerateApi(_api_gen, false);
		foreach(var f00000005iD in terms) 			f00000005iD.GenerateApi(_api_gen, false);
	}
	internal expression_arithmetic_disjunction Clone() {
		var _obj = new expression_arithmetic_disjunction();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.start_expr = start_expr;
		_obj.terms.AddRange(terms);
		return _obj;
	}
}
internal class expression_bitwise_conjunction : expression {
	public override string PrettyName { get { return "bit-wise conjunction"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005PU = _type & (0 | Flabbergast.Type.Int);
		if (f00000005PU == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		var f00000005iW =  f00000005PU;
		if (left != null) f00000005iW &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005PU, ref _success, true), f00000005PU);
		if (right != null) f00000005iW &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005PU, ref _success, true), f00000005PU);
		InferredType = f00000005iW;		return f00000005iW;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005iU) => {
			_generator.DebugPosition(this);
			right.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005iV) => {
				_generator.DebugPosition(this);
				var f00000005PT = new GeneratedValue(typeof(long), (f00000008VA_builder) => {
				if (!typeof(long).IsAssignableFrom(f00000005iU.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in And.", Stringish.NameForType(f00000005iU.BackingType)));
				_generator.LoadReboxed(f00000005iU, typeof(long));
				if (!typeof(long).IsAssignableFrom(f00000005iV.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in And.", Stringish.NameForType(f00000005iV.BackingType)));
				_generator.LoadReboxed(f00000005iV, typeof(long));
				f00000008VA_builder.Emit(System.Reflection.Emit.OpCodes.And);
				});
				_final_block(f00000005PT);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_bitwise_conjunction Clone() {
		var _obj = new expression_bitwise_conjunction();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_bitwise_disjunction : expression {
	public override string PrettyName { get { return "bit-wise disjunction"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Pe = _type & (0 | Flabbergast.Type.Int);
		if (f00000005Pe == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		var f00000005io =  f00000005Pe;
		if (left != null) f00000005io &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005Pe, ref _success, true), f00000005Pe);
		if (right != null) f00000005io &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005Pe, ref _success, true), f00000005Pe);
		InferredType = f00000005io;		return f00000005io;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005im) => {
			_generator.DebugPosition(this);
			right.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005in) => {
				_generator.DebugPosition(this);
				var f00000005Pd = new GeneratedValue(typeof(long), (f00000008VP_builder) => {
				if (!typeof(long).IsAssignableFrom(f00000005im.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Or.", Stringish.NameForType(f00000005im.BackingType)));
				_generator.LoadReboxed(f00000005im, typeof(long));
				if (!typeof(long).IsAssignableFrom(f00000005in.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Or.", Stringish.NameForType(f00000005in.BackingType)));
				_generator.LoadReboxed(f00000005in, typeof(long));
				f00000008VP_builder.Emit(System.Reflection.Emit.OpCodes.Or);
				});
				_final_block(f00000005Pd);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_bitwise_disjunction Clone() {
		var _obj = new expression_bitwise_disjunction();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_bitwise_not : expression {
	public override string PrettyName { get { return "bit-wise complementation"; } }
	internal expression expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expr != null) { expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Po = _type & (0 | Flabbergast.Type.Int);
		if (f00000005Po == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		var f00000005j5 =  f00000005Po;
		if (expr != null) f00000005j5 &= AstTypeableNode.HorrendousTypeMerge(expr.EnsureType(_collector, f00000005Po, ref _success, true), f00000005Po);
		InferredType = f00000005j5;		return f00000005j5;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005j4) => {
			_generator.DebugPosition(this);
			var f00000005Pn = new GeneratedValue(typeof(long), (f000000073C_builder) => {
			if (!typeof(long).IsAssignableFrom(f00000005j4.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Not.", Stringish.NameForType(f00000005j4.BackingType)));
			_generator.LoadReboxed(f00000005j4, typeof(long));
			f000000073C_builder.Emit(System.Reflection.Emit.OpCodes.Not);
			});
			_final_block(f00000005Pn);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expr.GenerateApi(_api_gen, false);
	}
	internal expression_bitwise_not Clone() {
		var _obj = new expression_bitwise_not();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expr = expr;
		return _obj;
	}
}
internal class expression_bitwise_symdiff : expression {
	public override string PrettyName { get { return "bit-wise symmetric difference"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Py = _type & (0 | Flabbergast.Type.Int);
		if (f00000005Py == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		var f00000005jL =  f00000005Py;
		if (left != null) f00000005jL &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005Py, ref _success, true), f00000005Py);
		if (right != null) f00000005jL &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005Py, ref _success, true), f00000005Py);
		InferredType = f00000005jL;		return f00000005jL;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005jJ) => {
			_generator.DebugPosition(this);
			right.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005jK) => {
				_generator.DebugPosition(this);
				var f00000005Px = new GeneratedValue(typeof(long), (f00000008Vk_builder) => {
				if (!typeof(long).IsAssignableFrom(f00000005jJ.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Xor.", Stringish.NameForType(f00000005jJ.BackingType)));
				_generator.LoadReboxed(f00000005jJ, typeof(long));
				if (!typeof(long).IsAssignableFrom(f00000005jK.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Xor.", Stringish.NameForType(f00000005jK.BackingType)));
				_generator.LoadReboxed(f00000005jK, typeof(long));
				f00000008Vk_builder.Emit(System.Reflection.Emit.OpCodes.Xor);
				});
				_final_block(f00000005Px);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_bitwise_symdiff Clone() {
		var _obj = new expression_bitwise_symdiff();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_check : expression {
	public override string PrettyName { get { return "type check"; } }
	internal expression left;
	internal type_name right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Q8 = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005Q8 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005Q8;		return f00000005Q8;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005QA =  _type;
		if (left != null) f00000005QA &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		Generator.ParameterisedBlock<LoadableValue> f00000005Q7_code = (f00000005Q7) => {
			_final_block(f00000005Q7);
		};
		if (right.TypeId == Flabbergast.Type.Template) {
			left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f0000000AQz) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f0000000ANw_code = (f0000000ANw) => {
					f00000005Q7_code(f0000000ANw);
				};
				if (f0000000AQz.BackingType == typeof(object)) {
					var f0000000AXf = new TypeCheckValue(typeof(Flabbergast.Template), f0000000AQz);
					f0000000ANw_code(f0000000AXf);
				} else if (f0000000AQz.BackingType == typeof(Flabbergast.Template)) {
					var f0000000AXe = new BoolConstant(true);
					f0000000ANw_code(f0000000AXe);
				} else {
					var f0000000AQy = new BoolConstant(false);
					f0000000ANw_code(f0000000AQy);
				}
			});
		} else if (right.TypeId == Flabbergast.Type.Str) {
			left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f0000000AQw) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f0000000ANv_code = (f0000000ANv) => {
					f00000005Q7_code(f0000000ANv);
				};
				if (f0000000AQw.BackingType == typeof(object)) {
					var f0000000AXc = new TypeCheckValue(typeof(Flabbergast.Stringish), f0000000AQw);
					f0000000ANv_code(f0000000AXc);
				} else if (f0000000AQw.BackingType == typeof(Flabbergast.Stringish)) {
					var f0000000AXb = new BoolConstant(true);
					f0000000ANv_code(f0000000AXb);
				} else {
					var f0000000AQv = new BoolConstant(false);
					f0000000ANv_code(f0000000AQv);
				}
			});
		} else if (right.TypeId == Flabbergast.Type.Unit) {
			left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f0000000AQt) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f0000000ANu_code = (f0000000ANu) => {
					f00000005Q7_code(f0000000ANu);
				};
				if (f0000000AQt.BackingType == typeof(object)) {
					var f0000000AXZ = new TypeCheckValue(typeof(Flabbergast.Unit), f0000000AQt);
					f0000000ANu_code(f0000000AXZ);
				} else if (f0000000AQt.BackingType == typeof(Flabbergast.Unit)) {
					var f0000000AXY = new BoolConstant(true);
					f0000000ANu_code(f0000000AXY);
				} else {
					var f0000000AQs = new BoolConstant(false);
					f0000000ANu_code(f0000000AQs);
				}
			});
		} else if (right.TypeId == Flabbergast.Type.Int) {
			left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f0000000AQq) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f0000000ANt_code = (f0000000ANt) => {
					f00000005Q7_code(f0000000ANt);
				};
				if (f0000000AQq.BackingType == typeof(object)) {
					var f0000000AXW = new TypeCheckValue(typeof(long), f0000000AQq);
					f0000000ANt_code(f0000000AXW);
				} else if (f0000000AQq.BackingType == typeof(long)) {
					var f0000000AXV = new BoolConstant(true);
					f0000000ANt_code(f0000000AXV);
				} else {
					var f0000000AQp = new BoolConstant(false);
					f0000000ANt_code(f0000000AQp);
				}
			});
		} else if (right.TypeId == Flabbergast.Type.Frame) {
			left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f0000000AQn) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f0000000ANs_code = (f0000000ANs) => {
					f00000005Q7_code(f0000000ANs);
				};
				if (f0000000AQn.BackingType == typeof(object)) {
					var f0000000AXT = new TypeCheckValue(typeof(Flabbergast.Frame), f0000000AQn);
					f0000000ANs_code(f0000000AXT);
				} else if (f0000000AQn.BackingType == typeof(Flabbergast.Frame)) {
					var f0000000AXS = new BoolConstant(true);
					f0000000ANs_code(f0000000AXS);
				} else {
					var f0000000AQm = new BoolConstant(false);
					f0000000ANs_code(f0000000AQm);
				}
			});
		} else if (right.TypeId == Flabbergast.Type.Float) {
			left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f0000000AQk) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f0000000ANr_code = (f0000000ANr) => {
					f00000005Q7_code(f0000000ANr);
				};
				if (f0000000AQk.BackingType == typeof(object)) {
					var f0000000AXQ = new TypeCheckValue(typeof(double), f0000000AQk);
					f0000000ANr_code(f0000000AXQ);
				} else if (f0000000AQk.BackingType == typeof(double)) {
					var f0000000AXP = new BoolConstant(true);
					f0000000ANr_code(f0000000AXP);
				} else {
					var f0000000AQj = new BoolConstant(false);
					f0000000ANr_code(f0000000AQj);
				}
			});
		} else if (right.TypeId == Flabbergast.Type.Bool) {
			left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f0000000AQh) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f0000000ANq_code = (f0000000ANq) => {
					f00000005Q7_code(f0000000ANq);
				};
				if (f0000000AQh.BackingType == typeof(object)) {
					var f0000000AXN = new TypeCheckValue(typeof(bool), f0000000AQh);
					f0000000ANq_code(f0000000AXN);
				} else if (f0000000AQh.BackingType == typeof(bool)) {
					var f0000000AXM = new BoolConstant(true);
					f0000000ANq_code(f0000000AXM);
				} else {
					var f0000000AQg = new BoolConstant(false);
					f0000000ANq_code(f0000000AQg);
				}
			});
		} else if (right.TypeId == Flabbergast.Type.Bin) {
			left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f0000000AQe) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f0000000ANp_code = (f0000000ANp) => {
					f00000005Q7_code(f0000000ANp);
				};
				if (f0000000AQe.BackingType == typeof(object)) {
					var f0000000AXK = new TypeCheckValue(typeof(byte[]), f0000000AQe);
					f0000000ANp_code(f0000000AXK);
				} else if (f0000000AQe.BackingType == typeof(byte[])) {
					var f0000000AXJ = new BoolConstant(true);
					f0000000ANp_code(f0000000AXJ);
				} else {
					var f0000000AQd = new BoolConstant(false);
					f0000000ANp_code(f0000000AQd);
				}
			});
		} else {
			throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: type check not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
		}
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_check Clone() {
		var _obj = new expression_check();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_coalesce : expression {
	public override string PrettyName { get { return "null coalescence"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		optional_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, _environment, false);
		if (right != null) { right.PropagateEnvironment(_collector, _queue, optional_environment, ref _success); }
		return _return;
	}
	Environment optional_environment;
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005QJ = NameInfo.AnyType;
		var f00000005ju =  _type;
		if (right != null) f00000005ju &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, _type, ref _success, true), _type);
		f00000005QJ &= f00000005ju;
		var f00000005jv =  _type;
		if (left != null) f00000005jv &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, _type | Flabbergast.Type.Unit, ref _success, true), _type);
		f00000005QJ &= f00000005jv;
		InferredType = f00000005QJ;		return f00000005QJ;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005js) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000005QI_code = (f00000005QI) => {
				_final_block(f00000005QI);
			};
			if (f00000005js.BackingType == typeof(Flabbergast.Unit)) {
				optional_environment.GenerateLookupCache(_generator, null, _cache, _source_reference, _context, _self_frame, (f00000006eL_context, f00000006eL_cache) => {
					_generator.DebugPosition(this);
					right.Generate(_generator, f00000006eL_cache, _source_reference, f00000006eL_context, _self_frame, _container_frame, (f000000073f) => {
						_generator.DebugPosition(this);
					f00000005QI_code(f000000073f);
					});
				});
			} else {
				f00000005QI_code(f00000005js);
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_coalesce Clone() {
		var _obj = new expression_coalesce();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_coerce : expression {
	public override string PrettyName { get { return "type coercion"; } }
	internal expression left;
	internal type_name right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005QT = _type & right.TypeId;
		if (f00000005QT == 0) {
			_success = false; 
			_collector.ReportExpressionTypeError(this, right.TypeId, _type);
		}
		InferredType = f00000005QT;		return f00000005QT;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005QV = _type & right.CastableFrom;
		if (f00000005QV == 0) {
			_success = false; 
			_collector.ReportExpressionTypeError(this, right.CastableFrom, _type);
		}
		var f00000005kG =  f00000005QV;
		if (left != null) f00000005kG &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005QV, ref _success, true), f00000005QV);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005k8) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000005QS_code = (f00000005QS) => {
				_final_block(f00000005QS);
			};
			if (f00000005k8.BackingType == typeof(object)) {
				Generator.ParameterisedBlock<LoadableValue> f00000006eX_code = (f00000006eX) => {
					f00000005QS_code(f00000006eX);
				};
				if (right.TypeId == Flabbergast.Type.Str) {
					var f00000008EC = _generator.ToStringish(f00000005k8, _source_reference);
					f00000006eX_code(f00000008EC);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: type coercion not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			} else if (f00000005k8.BackingType == typeof(Flabbergast.Stringish)) {
				Generator.ParameterisedBlock<LoadableValue> f00000006eW_code = (f00000006eW) => {
					f00000005QS_code(f00000006eW);
				};
				if (right.TypeId == Flabbergast.Type.Str) {
					f00000006eW_code(f00000005k8);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: type coercion not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			} else if (f00000005k8.BackingType == typeof(Flabbergast.Template)) {
				Generator.ParameterisedBlock<LoadableValue> f00000006eV_code = (f00000006eV) => {
					f00000005QS_code(f00000006eV);
				};
				if (right.TypeId == Flabbergast.Type.Template) {
					f00000006eV_code(f00000005k8);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: type coercion not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			} else if (f00000005k8.BackingType == typeof(Flabbergast.Unit)) {
				Generator.ParameterisedBlock<LoadableValue> f00000006eU_code = (f00000006eU) => {
					f00000005QS_code(f00000006eU);
				};
				if (right.TypeId == Flabbergast.Type.Unit) {
					f00000006eU_code(f00000005k8);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: type coercion not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			} else if (f00000005k8.BackingType == typeof(Flabbergast.Frame)) {
				Generator.ParameterisedBlock<LoadableValue> f00000006eT_code = (f00000006eT) => {
					f00000005QS_code(f00000006eT);
				};
				if (right.TypeId == Flabbergast.Type.Frame) {
					f00000006eT_code(f00000005k8);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: type coercion not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			} else if (f00000005k8.BackingType == typeof(bool)) {
				Generator.ParameterisedBlock<LoadableValue> f00000006eS_code = (f00000006eS) => {
					f00000005QS_code(f00000006eS);
				};
				if (right.TypeId == Flabbergast.Type.Str) {
					var f00000008EB = _generator.ToStringish(f00000005k8, _source_reference);
					f00000006eS_code(f00000008EB);
				} else if (right.TypeId == Flabbergast.Type.Bool) {
					f00000006eS_code(f00000005k8);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: type coercion not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			} else if (f00000005k8.BackingType == typeof(double)) {
				Generator.ParameterisedBlock<LoadableValue> f00000006eR_code = (f00000006eR) => {
					f00000005QS_code(f00000006eR);
				};
				if (right.TypeId == Flabbergast.Type.Str) {
					var f00000008EA = _generator.ToStringish(f00000005k8, _source_reference);
					f00000006eR_code(f00000008EA);
				} else if (right.TypeId == Flabbergast.Type.Int) {
					var f00000008E9 = new GeneratedValue(typeof(long), (f0000000AvK_builder) => {
					if (!typeof(double).IsAssignableFrom(f00000005k8.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Conv_I8.", Stringish.NameForType(f00000005k8.BackingType)));
					_generator.LoadReboxed(f00000005k8, typeof(double));
					f0000000AvK_builder.Emit(System.Reflection.Emit.OpCodes.Conv_I8);
					});
					f00000006eR_code(f00000008E9);
				} else if (right.TypeId == Flabbergast.Type.Float) {
					f00000006eR_code(f00000005k8);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: type coercion not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			} else if (f00000005k8.BackingType == typeof(long)) {
				Generator.ParameterisedBlock<LoadableValue> f00000006eQ_code = (f00000006eQ) => {
					f00000005QS_code(f00000006eQ);
				};
				if (right.TypeId == Flabbergast.Type.Str) {
					var f00000008E8 = _generator.ToStringish(f00000005k8, _source_reference);
					f00000006eQ_code(f00000008E8);
				} else if (right.TypeId == Flabbergast.Type.Float) {
					var f00000008E7 = new GeneratedValue(typeof(double), (f0000000AbC_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000005k8.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_R8.", Stringish.NameForType(f00000005k8.BackingType)));
					_generator.LoadReboxed(f00000005k8, typeof(long));
					f0000000AbC_builder.Emit(System.Reflection.Emit.OpCodes.Conv_R8);
					});
					f00000006eQ_code(f00000008E7);
				} else if (right.TypeId == Flabbergast.Type.Int) {
					f00000006eQ_code(f00000005k8);
				} else {
					throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: type coercion not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
				}
			} else {
				throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: type coercion not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_coerce Clone() {
		var _obj = new expression_coerce();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_compare : expression {
	public override string PrettyName { get { return "comparison"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Qd = _type & (0 | Flabbergast.Type.Int);
		if (f00000005Qd == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		InferredType = f00000005Qd;		return f00000005Qd;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Qf = _type & (0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str);
		if (f00000005Qf == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str, _type);
		}
		var f00000005kV = f00000005Qf;
		for(var f00000005kV_junk = 0; f00000005kV_junk < 2; f00000005kV_junk++) {
			var f00000006E1 =  f00000005kV;
			if (left != null) f00000006E1 &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005kV, ref _success, true), f00000005kV);
			if (right != null) f00000006E1 &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005kV, ref _success, true), f00000005kV);
			f00000005kV &= f00000006E1;
		}
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005kL) => {
			_generator.DebugPosition(this);
			right.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005kM) => {
				_generator.DebugPosition(this);
						var f00000005Qc = _generator.Compare(f00000005kL, f00000005kM, _source_reference);
					if (f00000005Qc != null) {
					_final_block(f00000005Qc);
					}
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_compare Clone() {
		var _obj = new expression_compare();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_concatenate : expression {
	public override string PrettyName { get { return "string concatenation"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Qn = _type & (0 | Flabbergast.Type.Str);
		if (f00000005Qn == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Str, _type);
		}
		InferredType = f00000005Qn;		return f00000005Qn;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Qp = _type & (0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str);
		if (f00000005Qp == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str, _type);
		}
		var f00000005kp =  f00000005Qp;
		if (left != null) f00000005kp &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005Qp, ref _success, _needs_unbox), f00000005Qp);
		if (right != null) f00000005kp &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005Qp, ref _success, _needs_unbox), f00000005Qp);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006E3) => {
			_generator.DebugPosition(this);
			var f00000005kf = _generator.ToStringish(f00000006E3, _source_reference);
			right.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006E4) => {
				_generator.DebugPosition(this);
				var f00000005kg = _generator.ToStringish(f00000006E4, _source_reference);
				var f00000005Qm = new GeneratedValue(typeof(Flabbergast.Stringish), (f00000008Wk_builder) => {
				if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000005kf.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000005kf.BackingType)));
				_generator.LoadReboxed(f00000005kf, typeof(Flabbergast.Stringish));
				if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000005kg.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000005kg.BackingType)));
				_generator.LoadReboxed(f00000005kg, typeof(Flabbergast.Stringish));
				f00000008Wk_builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(ConcatStringish).GetConstructors()[0]);
				});
				_final_block(f00000005Qm);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_concatenate Clone() {
		var _obj = new expression_concatenate();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_conjunction : expression {
	public override string PrettyName { get { return "logical conjunction"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		optional_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, _environment, false);
		if (right != null) { right.PropagateEnvironment(_collector, _queue, optional_environment, ref _success); }
		return _return;
	}
	Environment optional_environment;
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Qy = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005Qy == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005Qy;		return f00000005Qy;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005R0 = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005R0 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		var f00000005l8 =  f00000005R0;
		if (left != null) f00000005l8 &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005R0, ref _success, true), f00000005R0);
		if (right != null) f00000005l8 &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005R0, ref _success, true), f00000005R0);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		_generator.ConditionalFlow((f00000005zr_cond) => {
			left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005kx) => {
				_generator.DebugPosition(this);
			f00000005zr_cond(f00000005kx);
			});
		}, (f00000005zr_true) => {
			optional_environment.GenerateLookupCache(_generator, null, _cache, _source_reference, _context, _self_frame, (f00000005kz_context, f00000005kz_cache) => {
				_generator.DebugPosition(this);
				right.Generate(_generator, f00000005kz_cache, _source_reference, f00000005kz_context, _self_frame, _container_frame, (f00000006EO) => {
					_generator.DebugPosition(this);
			f00000005zr_true(f00000006EO);
				});
			});
		}, (f00000005zr_false) => {
			var f00000005ky = new BoolConstant(false);
		f00000005zr_false(f00000005ky);
		}, (f00000005Qx) => {
			_final_block(f00000005Qx);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_conjunction Clone() {
		var _obj = new expression_conjunction();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_container : expression {
	public override string PrettyName { get { return "access containing frame"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (_environment.TopLevel != false) { _success = false; _collector.ReportRawError(this, "At file-level scope, access containing frame is now allowed."); }		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005R4 = _type & (0 | Flabbergast.Type.Frame);
		if (f00000005R4 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		InferredType = f00000005R4;		return f00000005R4;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		_final_block(_container_frame);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_container Clone() {
		var _obj = new expression_container();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class expression_contextual_lookup : expression {
	public override string PrettyName { get { return "contextual lookup"; } }
	internal System.Collections.Generic.List<identifier> parts = new System.Collections.Generic.List<identifier>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005RC = Environment.Lookup(_collector, parts.Select((s) => s.ToString()), ref _success).EnsureType(_collector, _type, ref _success, _needs_unbox);
		InferredType = f00000005RC;		return f00000005RC;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		bool f000000060B_junk = true;
		var f00000005RB = _cache[Environment.Lookup(null, parts.Select((s) => s.ToString()), ref f000000060B_junk)];
		_final_block(f00000005RB);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_contextual_lookup Clone() {
		var _obj = new expression_contextual_lookup();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.parts.AddRange(parts);
		return _obj;
	}
}
internal class expression_direct_lookup : expression {
	public override string PrettyName { get { return "direct lookup"; } }
	internal expression expr;
	internal System.Collections.Generic.List<identifier> names = new System.Collections.Generic.List<identifier>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expr != null) { expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005RM = Environment.EnsureIntrinsic(_collector, this, _type, _needs_unbox, ref _success);
		InferredType = f00000005RM;		return f00000005RM;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005RO = _type & (0 | Flabbergast.Type.Frame);
		if (f00000005RO == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		var f00000005lQ =  f00000005RO;
		if (expr != null) f00000005lQ &= AstTypeableNode.HorrendousTypeMerge(expr.EnsureType(_collector, f00000005RO, ref _success, true), f00000005RO);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006ez) => {
			_generator.DebugPosition(this);
			var f00000006Ee = _generator.MakeField("direct_lookup_Call", typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000006ez.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000006ez.BackingType)));
			_generator.LoadReboxed(f00000006ez, typeof(Flabbergast.Frame));
			if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
			_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006Ee.Field);
			_generator.StartInterlock(1);
			_generator.LoadTaskMaster();
			_source_reference.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
			for (var f00000009bT_iter = 0; f00000009bT_iter < names.Count; f00000009bT_iter++) {
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000009bT_iter);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, names[f00000009bT_iter].ToString());
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
			}
			f00000006Ee.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
			var f00000005lK = _generator.MakeField("lookup", typeof(object));
			_generator.GenerateConsumeResult(f00000005lK, true);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
			_generator.StopInterlock();
			Environment.IntrinsicDispatch(_generator, this, f00000005lK, _source_reference, (f00000005RL) => {
				_final_block(f00000005RL);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_direct_lookup Clone() {
		var _obj = new expression_direct_lookup();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expr = expr;
		_obj.names.AddRange(names);
		return _obj;
	}
}
internal class expression_disjunction : expression {
	public override string PrettyName { get { return "logical disjunction"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		optional_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, _environment, false);
		if (right != null) { right.PropagateEnvironment(_collector, _queue, optional_environment, ref _success); }
		return _return;
	}
	Environment optional_environment;
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005RX = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005RX == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005RX;		return f00000005RX;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005RZ = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005RZ == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		var f00000005lj =  f00000005RZ;
		if (left != null) f00000005lj &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005RZ, ref _success, true), f00000005RZ);
		if (right != null) f00000005lj &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005RZ, ref _success, true), f00000005RZ);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		_generator.ConditionalFlow((f000000060S_cond) => {
			left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005lY) => {
				_generator.DebugPosition(this);
			f000000060S_cond(f00000005lY);
			});
		}, (f000000060S_true) => {
			var f00000005la = new BoolConstant(true);
		f000000060S_true(f00000005la);
		}, (f000000060S_false) => {
			optional_environment.GenerateLookupCache(_generator, null, _cache, _source_reference, _context, _self_frame, (f00000005lZ_context, f00000005lZ_cache) => {
				_generator.DebugPosition(this);
				right.Generate(_generator, f00000005lZ_cache, _source_reference, f00000005lZ_context, _self_frame, _container_frame, (f00000006Ex) => {
					_generator.DebugPosition(this);
			f000000060S_false(f00000006Ex);
				});
			});
		}, (f00000005RW) => {
			_final_block(f00000005RW);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_disjunction Clone() {
		var _obj = new expression_disjunction();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_enforce : expression {
	public override string PrettyName { get { return "type enforcement"; } }
	internal expression left;
	internal type_name right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Rh = _type & right.TypeId;
		if (f00000005Rh == 0) {
			_success = false; 
			_collector.ReportExpressionTypeError(this, right.TypeId, _type);
		}
		var f00000005lq =  f00000005Rh;
		if (left != null) f00000005lq &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005Rh, ref _success, true), f00000005Rh);
		InferredType = f00000005Rh;		return f00000005Rh;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		Generator.ParameterisedBlock<LoadableValue> f00000005Rg_code = (f00000005Rg) => {
			_final_block(f00000005Rg);
		};
		if (right.TypeId == Flabbergast.Type.Float) {
			left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f000000075A) => {
				_generator.DebugPosition(this);
				Generator.ParameterisedBlock<LoadableValue> f00000006fB_code = (f00000006fB) => {
					f00000005Rg_code(f00000006fB);
				};
				if (f000000075A.BackingType == typeof(long)) {
					var f00000008FE = new GeneratedValue(typeof(double), (f0000000Abw_builder) => {
					if (!typeof(long).IsAssignableFrom(f000000075A.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_R8.", Stringish.NameForType(f000000075A.BackingType)));
					_generator.LoadReboxed(f000000075A, typeof(long));
					f0000000Abw_builder.Emit(System.Reflection.Emit.OpCodes.Conv_R8);
					});
					f00000006fB_code(f00000008FE);
				} else {
					f00000006fB_code(f000000075A);
				}
			});
		} else {
			left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005lp) => {
				_generator.DebugPosition(this);
				f00000005Rg_code(f00000005lp);
			});
		}
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_enforce Clone() {
		var _obj = new expression_enforce();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_equality : expression {
	public override string PrettyName { get { return "equality comparison"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Rr = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005Rr == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005Rr;		return f00000005Rr;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Rt = _type & (0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str);
		if (f00000005Rt == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str, _type);
		}
		var f00000005mE = f00000005Rt;
		for(var f00000005mE_junk = 0; f00000005mE_junk < 2; f00000005mE_junk++) {
			var f00000006Fc =  f00000005mE;
			if (left != null) f00000006Fc &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005mE, ref _success, true), f00000005mE);
			if (right != null) f00000006Fc &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005mE, ref _success, true), f00000005mE);
			f00000005mE &= f00000006Fc;
		}
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006FR) => {
			_generator.DebugPosition(this);
			right.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006FS) => {
				_generator.DebugPosition(this);
						var f00000005m5 = _generator.Compare(f00000006FR, f00000006FS, _source_reference);
					if (f00000005m5 != null) {
					var f00000005Rq = new GeneratedValue(typeof(bool), (f000000075M_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000005m5.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_I4.", Stringish.NameForType(f00000005m5.BackingType)));
					_generator.LoadReboxed(f00000005m5, typeof(long));
					f000000075M_builder.Emit(System.Reflection.Emit.OpCodes.Conv_I4);
					f000000075M_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
					f000000075M_builder.Emit(System.Reflection.Emit.OpCodes.Ceq);
					});
					_final_block(f00000005Rq);
					}
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_equality Clone() {
		var _obj = new expression_equality();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_error : expression {
	public override string PrettyName { get { return "raise error"; } }
	internal expression expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expr != null) { expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		InferredType = _type;		return _type;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005S3 = _type & (0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str);
		if (f00000005S3 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str, _type);
		}
		var f00000005mP =  f00000005S3;
		if (expr != null) f00000005mP &= AstTypeableNode.HorrendousTypeMerge(expr.EnsureType(_collector, f00000005S3, ref _success, _needs_unbox), f00000005S3);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006Fe) => {
			_generator.DebugPosition(this);
			var f00000005mK = _generator.ToStringish(f00000006Fe, _source_reference);
			_generator.LoadTaskMaster();
			_source_reference.Load(_generator);
			f00000005mK.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(TaskMaster).GetMethod("ReportOtherError", new System.Type[] { typeof(SourceReference), typeof(string) }));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expr.GenerateApi(_api_gen, false);
	}
	internal expression_error Clone() {
		var _obj = new expression_error();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expr = expr;
		return _obj;
	}
}
internal class expression_false : expression {
	public override string PrettyName { get { return "logical false"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005S6 = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005S6 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005S6;		return f00000005S6;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005S5 = new BoolConstant(false);
		_final_block(f00000005S5);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_false Clone() {
		var _obj = new expression_false();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class expression_float_literal : expression {
	public override string PrettyName { get { return "floating-point value"; } }
	internal double value;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005SB = _type & (0 | Flabbergast.Type.Float);
		if (f00000005SB == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float, _type);
		}
		InferredType = f00000005SB;		return f00000005SB;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005SA = new FloatConstant(value);
		_final_block(f00000005SA);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_float_literal Clone() {
		var _obj = new expression_float_literal();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.value = value;
		return _obj;
	}
}
internal class expression_float_max : expression {
	public override string PrettyName { get { return "largest floating-point value"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005SG = _type & (0 | Flabbergast.Type.Float);
		if (f00000005SG == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float, _type);
		}
		InferredType = f00000005SG;		return f00000005SG;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005SF = new FloatConstant(System.Double.MaxValue);
		_final_block(f00000005SF);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_float_max Clone() {
		var _obj = new expression_float_max();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class expression_float_min : expression {
	public override string PrettyName { get { return "smallest floating-point value"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005SL = _type & (0 | Flabbergast.Type.Float);
		if (f00000005SL == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float, _type);
		}
		InferredType = f00000005SL;		return f00000005SL;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005SK = new FloatConstant(System.Double.MinValue);
		_final_block(f00000005SK);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_float_min Clone() {
		var _obj = new expression_float_min();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class expression_for_reduce : expression {
	public override string PrettyName { get { return "fricassée Reduce"; } }
	internal selector selector;
	internal expression reduce_expr;
	internal RevCons<char> initial_name = null;
	internal expression initial_expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (initial_expr != null) { initial_expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (_return != null) throw new System.InvalidOperationException("Refusing to overwrite return value.");
		if (selector == null) throw new System.InvalidOperationException("Field selector in for_reduce is empty.");
		select_env = selector.PropagateEnvironment(_collector, _queue, _environment, ref _success);
		if (select_env == null) throw new System.InvalidOperationException("Field selector in for_reduce did not collect and environment.");
		reduce_env = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, select_env, false);
		bottleneck_type = reduce_env.AddMask(Generator.ToString(initial_name), initial_expr);
		if (reduce_expr != null) { reduce_expr.PropagateEnvironment(_collector, _queue, reduce_env, ref _success); }
		return _return;
	}
	Environment select_env;
	Environment reduce_env;
	RestrictableType bottleneck_type;
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005SW = NameInfo.AnyType;
		var f00000005ms =  _type;
		if (reduce_expr != null) f00000005ms &= AstTypeableNode.HorrendousTypeMerge(reduce_expr.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
		if (initial_expr != null) f00000005ms &= AstTypeableNode.HorrendousTypeMerge(initial_expr.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
		f00000005SW &= f00000005ms;
		var f00000005mt = bottleneck_type.EnsureType(_collector, _type, ref _success,  _needs_unbox);
		f00000005SW &= f00000005mt;
		InferredType = f00000005SW;		return f00000005SW;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		selector.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006QW) => {
			_generator.DebugPosition(this);
			var f00000007IO = _generator.MakeField("for_reduce_iterator_inputs", typeof(IAttributeNames[]));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000007IO.Field);
			int f0000000B1c_next;
			f0000000B1c_next = _generator.DefineState();
			f00000007IO.Load(_generator);
			if (!typeof(IAttributeNames).IsAssignableFrom(f00000006QW.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f00000006QW.BackingType)));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
			f00000006QW.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
			_generator.JumpToState(f0000000B1c_next);
			_generator.MarkState(f0000000B1c_next);
			var f00000006QX = _generator.MakeField("for_reduce_iterator_accumulator", typeof(object));
			var f00000006QX_start_block = _generator.DefineState();
			LoadableValue f00000007IP = _source_reference;
			initial_expr.Generate(_generator, _cache, f00000007IP, _context, _self_frame, _container_frame, (f00000006nE) => {
				_generator.DebugPosition(this);
				_generator.CopyField(f00000006nE, f00000006QX);
				_generator.JumpToState(f00000006QX_start_block);
			});
			_generator.MarkState(f00000006QX_start_block);
			var f00000006QX_dispatchers = new int[ 2 ];
			for(var f00000009ff_it = 0; f00000009ff_it < f00000006QX_dispatchers.Length; f00000009ff_it++) { f00000006QX_dispatchers[f00000009ff_it] = _generator.DefineState(); }
			var f00000006QX_iterator = _generator.MakeField("for_reduce_iterator", typeof(MergeIterator));
			#pragma warning disable 219
			var f00000006QX_key = new MethodValue(f00000006QX_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
			var f00000006QX_ordinal = new MethodValue(f00000006QX_iterator, typeof(MergeIterator).GetMethod("get_Position"));
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000007IO.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000006QX_dispatchers[1]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000006QX_dispatchers[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
			#pragma warning disable 219
			var f00000006QX_position = 2;
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006QX_iterator.Field);
			var f00000006QX_next = _generator.DefineState();
			_generator.JumpToState(f00000006QX_next);
			_generator.MarkState(f00000006QX_next);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000006QX_iterator.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
			f00000007IP = _generator.PushIteratorSourceReference(this, f00000006QX_iterator, _source_reference);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
			_generator.MarkState(f00000006QX_dispatchers[1]);
			var f000000088W = _generator.MakeField("for_reduce_Call", typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000006QW.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000006QW.BackingType)));
			_generator.LoadReboxed(f00000006QW, typeof(Flabbergast.Frame));
			if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
			_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000088W.Field);
			_generator.StartInterlock(1);
			_generator.LoadTaskMaster();
			f00000007IP.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			f00000006QX_key.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
			f000000088W.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
			var f00000007Uk = _generator.MakeField("lookup", typeof(object));
			_generator.GenerateConsumeResult(f00000007Uk, true);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
			_generator.StopInterlock();
			_generator.DynamicTypeDispatch(f00000007Uk, f00000007IP, new System.Type[] { typeof(Flabbergast.Frame)}, (f00000008iJ) => {
				_generator.DebugPosition(this);
				var f00000008G0 = _generator.MakeField("for_reduce_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000008iJ.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000008iJ.BackingType)));
				_generator.LoadReboxed(f00000008iJ, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(_context.BackingType)));
				_generator.LoadReboxed(_context, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000008G0.Field);
				select_env.GenerateLookupCache(_generator, null, _cache, f00000007IP, f00000008G0, _self_frame, (f00000008G1_context, f00000008G1_cache) => {
					_generator.DebugPosition(this);
					reduce_env.GenerateLookupCache(_generator, new[] { new System.Tuple<RestrictableType, Generator.ParameterisedBlock<Generator.ParameterisedBlock<LoadableValue>>>(bottleneck_type, f0000000AdN_block => {
						f0000000AdN_block(f00000006QX);})}, f00000008G1_cache, f00000007IP, f00000008G1_context, _self_frame, (f00000008iK_context, f00000008iK_cache) => {
						_generator.DebugPosition(this);
						reduce_expr.Generate(_generator, f00000008iK_cache, f00000007IP, f00000008iK_context, _self_frame, _container_frame, (f000000096k) => {
							_generator.DebugPosition(this);
					_generator.CopyField(f000000096k, f00000006QX);
					_generator.JumpToState(f00000006QX_next);
						});
					});
				});
			});
			f00000006QX_position = 2;
			_generator.MarkState(f00000006QX_dispatchers[0]);
			_generator.DynamicTypeDispatch(f00000006QX, _source_reference, bottleneck_type.MustUnbox ? AstTypeableNode.ClrTypeFromType(bottleneck_type.RestrictedType) : null, (f00000005SV) => {
				_generator.DebugPosition(this);
				_final_block(f00000005SV);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		selector.GenerateApi(_api_gen, false);
		reduce_expr.GenerateApi(_api_gen, false);
		initial_expr.GenerateApi(_api_gen, false);
	}
	internal expression_for_reduce Clone() {
		var _obj = new expression_for_reduce();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.selector = selector;
		_obj.reduce_expr = reduce_expr;
		_obj.initial_name = initial_name;
		_obj.initial_expr = initial_expr;
		return _obj;
	}
}
internal class expression_for_select_anonymous : expression {
	public override string PrettyName { get { return "fricassée Select"; } }
	internal selector selector;
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (_return != null) throw new System.InvalidOperationException("Refusing to overwrite return value.");
		if (selector == null) throw new System.InvalidOperationException("Field selector in for_select_anonymous is empty.");
		select_env = selector.PropagateEnvironment(_collector, _queue, _environment, ref _success);
		if (select_env == null) throw new System.InvalidOperationException("Field selector in for_select_anonymous did not collect and environment.");
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, select_env, ref _success); }
		return _return;
	}
	Environment select_env;
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Sg = _type & (0 | Flabbergast.Type.Frame);
		if (f00000005Sg == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		InferredType = f00000005Sg;		return f00000005Sg;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Si =  _type;
		if (expression != null) f00000005Si &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		selector.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f000000061i) => {
			_generator.DebugPosition(this);
			var f00000006nf = _generator.MakeField("for_select_anonymous_iterator_inputs", typeof(IAttributeNames[]));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006nf.Field);
			int f0000000B2q_next;
			f0000000B2q_next = _generator.DefineState();
			f00000006nf.Load(_generator);
			if (!typeof(IAttributeNames).IsAssignableFrom(f000000061i.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f000000061i.BackingType)));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
			f000000061i.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
			_generator.JumpToState(f0000000B2q_next);
			_generator.MarkState(f0000000B2q_next);
			var f000000061j = _generator.MakeField("for_select_anonymous_iterator_accumulator", typeof(Flabbergast.MutableFrame));
			var f000000061j_start_block = _generator.DefineState();
			LoadableValue f00000006ng = _source_reference;
			var f00000006Qc = _generator.MakeField("for_select_anonymous_new_frame", typeof(MutableFrame));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.LoadTaskMaster();
			_generator.AmendSourceReference(this, "fricassée Select", f00000006ng, null);
			_context.Load(_generator);
			_self_frame.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006Qc.Field);
			_generator.CopyField(f00000006Qc, f000000061j);
			_generator.JumpToState(f000000061j_start_block);
			_generator.MarkState(f000000061j_start_block);
			var f000000061j_dispatchers = new int[ 2 ];
			for(var f00000009Ci_it = 0; f00000009Ci_it < f000000061j_dispatchers.Length; f00000009Ci_it++) { f000000061j_dispatchers[f00000009Ci_it] = _generator.DefineState(); }
			var f000000061j_iterator = _generator.MakeField("for_select_anonymous_iterator", typeof(MergeIterator));
			#pragma warning disable 219
			var f000000061j_key = new MethodValue(f000000061j_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
			var f000000061j_ordinal = new MethodValue(f000000061j_iterator, typeof(MergeIterator).GetMethod("get_Position"));
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000006nf.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f000000061j_dispatchers[1]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f000000061j_dispatchers[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
			#pragma warning disable 219
			var f000000061j_position = 2;
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000061j_iterator.Field);
			var f000000061j_next = _generator.DefineState();
			_generator.JumpToState(f000000061j_next);
			_generator.MarkState(f000000061j_next);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f000000061j_iterator.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
			f00000006ng = _generator.PushIteratorSourceReference(this, f000000061j_iterator, _source_reference);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
			_generator.MarkState(f000000061j_dispatchers[1]);
			var f00000007V7 = _generator.MakeField("for_select_anonymous_Call", typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(f000000061i.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f000000061i.BackingType)));
			_generator.LoadReboxed(f000000061i, typeof(Flabbergast.Frame));
			if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
			_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000007V7.Field);
			_generator.StartInterlock(1);
			_generator.LoadTaskMaster();
			f00000006ng.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			f000000061j_key.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
			f00000007V7.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
			var f00000006xl = _generator.MakeField("lookup", typeof(object));
			_generator.GenerateConsumeResult(f00000006xl, true);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
			_generator.StopInterlock();
			_generator.DynamicTypeDispatch(f00000006xl, f00000006ng, new System.Type[] { typeof(Flabbergast.Frame)}, (f00000008Gi) => {
				_generator.DebugPosition(this);
				var f00000007fT = _generator.MakeField("for_select_anonymous_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000008Gi.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000008Gi.BackingType)));
				_generator.LoadReboxed(f00000008Gi, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(_context.BackingType)));
				_generator.LoadReboxed(_context, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000007fT.Field);
				select_env.GenerateLookupCache(_generator, null, _cache, f00000006ng, f00000007fT, _self_frame, (f00000007fU_context, f00000007fU_cache) => {
					_generator.DebugPosition(this);
					var f00000008ib = new GeneratedValue(typeof(Flabbergast.Stringish), (f0000000AjD_builder) => {
					if (!typeof(long).IsAssignableFrom(f000000061j_ordinal.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Call.", Stringish.NameForType(f000000061j_ordinal.BackingType)));
					_generator.LoadReboxed(f000000061j_ordinal, typeof(long));
					f0000000AjD_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(TaskMaster).GetMethod("OrdinalName", new System.Type[] { typeof(long) }));
					});
					var f00000008ic = _generator.PushSourceReference(expression, f00000006ng);
					expression.Generate(_generator, f00000007fU_cache, f00000008ic, f00000007fU_context, _self_frame, _container_frame, (f0000000974) => {
						_generator.DebugPosition(this);
						if (!typeof(Template).IsAssignableFrom(f000000061j.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f000000061j.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f000000061j.BackingType)));
						f000000061j.Load(_generator);
						f00000008ib.Load(_generator);
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
						var f0000000Aae_is_frame = typeof(MutableFrame).IsAssignableFrom(f000000061j.BackingType);
						var f0000000Aae_boxed_type = f0000000Aae_is_frame ? typeof(object) : typeof(ComputeValue);
						_generator.LoadReboxed(f0000000974, f0000000Aae_boxed_type);
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f000000061j.BackingType.GetMethod(f0000000Aae_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f0000000Aae_boxed_type }));
					_generator.CopyField(f000000061j, f000000061j);
					_generator.JumpToState(f000000061j_next);
					});
				});
			});
			f000000061j_position = 2;
			_generator.MarkState(f000000061j_dispatchers[0]);
			_final_block(f000000061j);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		selector.GenerateApi(_api_gen, false);
		expression.GenerateApi(_api_gen, false);
	}
	internal expression_for_select_anonymous Clone() {
		var _obj = new expression_for_select_anonymous();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.selector = selector;
		_obj.expression = expression;
		return _obj;
	}
}
internal class expression_for_select_named : expression {
	public override string PrettyName { get { return "fricassée Select with attribute names"; } }
	internal selector selector;
	internal expression name_expr;
	internal expression value_expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (_return != null) throw new System.InvalidOperationException("Refusing to overwrite return value.");
		if (selector == null) throw new System.InvalidOperationException("Field selector in for_select_named is empty.");
		select_env = selector.PropagateEnvironment(_collector, _queue, _environment, ref _success);
		if (select_env == null) throw new System.InvalidOperationException("Field selector in for_select_named did not collect and environment.");
		if (name_expr != null) { name_expr.PropagateEnvironment(_collector, _queue, select_env, ref _success); }
		if (value_expr != null) { value_expr.PropagateEnvironment(_collector, _queue, select_env, ref _success); }
		return _return;
	}
	Environment select_env;
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Sq = _type & (0 | Flabbergast.Type.Frame);
		if (f00000005Sq == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		InferredType = f00000005Sq;		return f00000005Sq;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Ss = NameInfo.AnyType;
		var f00000005ns = _type & (0 | Flabbergast.Type.Int | Flabbergast.Type.Str);
		if (f00000005ns == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int | Flabbergast.Type.Str, _type);
		}
		var f00000006HC =  f00000005ns;
		if (name_expr != null) f00000006HC &= AstTypeableNode.HorrendousTypeMerge(name_expr.EnsureType(_collector, f00000005ns, ref _success, true), f00000005ns);
		f00000005Ss &= f00000006HC;
		var f00000005nt =  _type;
		if (value_expr != null) f00000005nt &= AstTypeableNode.HorrendousTypeMerge(value_expr.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
		f00000005Ss &= f00000005nt;
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		selector.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f000000061w) => {
			_generator.DebugPosition(this);
			var f00000006nw = _generator.MakeField("for_select_named_iterator_inputs", typeof(IAttributeNames[]));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006nw.Field);
			int f0000000B7O_next;
			f0000000B7O_next = _generator.DefineState();
			f00000006nw.Load(_generator);
			if (!typeof(IAttributeNames).IsAssignableFrom(f000000061w.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f000000061w.BackingType)));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
			f000000061w.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
			_generator.JumpToState(f0000000B7O_next);
			_generator.MarkState(f0000000B7O_next);
			var f000000061x = _generator.MakeField("for_select_named_iterator_accumulator", typeof(Flabbergast.MutableFrame));
			var f000000061x_start_block = _generator.DefineState();
			LoadableValue f00000006nx = _source_reference;
			var f00000006Qi = _generator.MakeField("for_select_named_new_frame", typeof(MutableFrame));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.LoadTaskMaster();
			_generator.AmendSourceReference(this, "fricassée Select with attribute names", f00000006nx, null);
			_context.Load(_generator);
			_self_frame.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006Qi.Field);
			_generator.CopyField(f00000006Qi, f000000061x);
			_generator.JumpToState(f000000061x_start_block);
			_generator.MarkState(f000000061x_start_block);
			var f000000061x_dispatchers = new int[ 2 ];
			for(var f00000009Cq_it = 0; f00000009Cq_it < f000000061x_dispatchers.Length; f00000009Cq_it++) { f000000061x_dispatchers[f00000009Cq_it] = _generator.DefineState(); }
			var f000000061x_iterator = _generator.MakeField("for_select_named_iterator", typeof(MergeIterator));
			#pragma warning disable 219
			var f000000061x_key = new MethodValue(f000000061x_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
			var f000000061x_ordinal = new MethodValue(f000000061x_iterator, typeof(MergeIterator).GetMethod("get_Position"));
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000006nw.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f000000061x_dispatchers[1]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f000000061x_dispatchers[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
			#pragma warning disable 219
			var f000000061x_position = 2;
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000061x_iterator.Field);
			var f000000061x_next = _generator.DefineState();
			_generator.JumpToState(f000000061x_next);
			_generator.MarkState(f000000061x_next);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f000000061x_iterator.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
			f00000006nx = _generator.PushIteratorSourceReference(this, f000000061x_iterator, _source_reference);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
			_generator.MarkState(f000000061x_dispatchers[1]);
			var f00000007VQ = _generator.MakeField("for_select_named_Call", typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(f000000061w.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f000000061w.BackingType)));
			_generator.LoadReboxed(f000000061w, typeof(Flabbergast.Frame));
			if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
			_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000007VQ.Field);
			_generator.StartInterlock(1);
			_generator.LoadTaskMaster();
			f00000006nx.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			f000000061x_key.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
			f00000007VQ.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
			var f00000006xv = _generator.MakeField("lookup", typeof(object));
			_generator.GenerateConsumeResult(f00000006xv, true);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
			_generator.StopInterlock();
			_generator.DynamicTypeDispatch(f00000006xv, f00000006nx, new System.Type[] { typeof(Flabbergast.Frame)}, (f00000008H2) => {
				_generator.DebugPosition(this);
				var f00000007fm = _generator.MakeField("for_select_named_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000008H2.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000008H2.BackingType)));
				_generator.LoadReboxed(f00000008H2, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(_context.BackingType)));
				_generator.LoadReboxed(_context, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000007fm.Field);
				select_env.GenerateLookupCache(_generator, null, _cache, f00000006nx, f00000007fm, _self_frame, (f00000007fn_context, f00000007fn_cache) => {
					_generator.DebugPosition(this);
					var f00000009OG = _generator.PushSourceReference(name_expr, f00000006nx);
					name_expr.Generate(_generator, f00000007fn_cache, f00000009OG, f00000007fn_context, _self_frame, _container_frame, (f00000009Zc) => {
						_generator.DebugPosition(this);
						Generator.ParameterisedBlock<LoadableValue> f00000009Cn_code = (f00000009Cn) => {
							_generator.ConditionalFlow((f0000000AnL_cond) => {
								var f00000009OH = new GeneratedValue(typeof(bool), (f0000000Ao6_builder) => {
								if (!typeof(Flabbergast.Frame).IsAssignableFrom(f000000061x.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f000000061x.BackingType)));
								_generator.LoadReboxed(f000000061x, typeof(Flabbergast.Frame));
								if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000009Cn.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Call.", Stringish.NameForType(f00000009Cn.BackingType)));
								_generator.LoadReboxed(f00000009Cn, typeof(Flabbergast.Stringish));
								f0000000Ao6_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("Has", new System.Type[] { typeof(Stringish) }));
								});
							f0000000AnL_cond(f00000009OH);
							}, (f0000000AnL_true) => {
								var f00000009fr = new StringishValue("Duplicate attribute name: ");
								var f00000009Zh = new GeneratedValue(typeof(Flabbergast.Stringish), (f0000000Aoc_builder) => {
								if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000009fr.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000009fr.BackingType)));
								_generator.LoadReboxed(f00000009fr, typeof(Flabbergast.Stringish));
								if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000009Cn.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000009Cn.BackingType)));
								_generator.LoadReboxed(f00000009Cn, typeof(Flabbergast.Stringish));
								f0000000Aoc_builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(ConcatStringish).GetConstructors()[0]);
								});
								_generator.LoadTaskMaster();
								f00000006nx.Load(_generator);
								f00000009Zh.Load(_generator);
								_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
								_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(TaskMaster).GetMethod("ReportOtherError", new System.Type[] { typeof(SourceReference), typeof(string) }));
								_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
								_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
							}, (f0000000AnL_false) => {
							f0000000AnL_false(f00000009Cn);
							}, (f00000009Co) => {
								var f00000008in = _generator.PushSourceReference(value_expr, f00000006nx);
								value_expr.Generate(_generator, f00000007fn_cache, f00000008in, f00000007fn_context, _self_frame, _container_frame, (f000000097H) => {
									_generator.DebugPosition(this);
									if (!typeof(Template).IsAssignableFrom(f000000061x.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f000000061x.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f000000061x.BackingType)));
									f000000061x.Load(_generator);
									f00000009Co.Load(_generator);
									_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
									var f0000000Abx_is_frame = typeof(MutableFrame).IsAssignableFrom(f000000061x.BackingType);
									var f0000000Abx_boxed_type = f0000000Abx_is_frame ? typeof(object) : typeof(ComputeValue);
									_generator.LoadReboxed(f000000097H, f0000000Abx_boxed_type);
									_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f000000061x.BackingType.GetMethod(f0000000Abx_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f0000000Abx_boxed_type }));
								_generator.CopyField(f000000061x, f000000061x);
								_generator.JumpToState(f000000061x_next);
								});
							});
						};
						if (f00000009Zc.BackingType == typeof(Flabbergast.Stringish)) {
							_generator.ConditionalFlow((f0000000B11_cond) => {
								var f00000009oH = new GeneratedValue(typeof(bool), (f0000000B1I_builder) => {
								_generator.LoadTaskMaster();
								f00000006nx.Load(f0000000B1I_builder);
								if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000009Zc.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Call.", Stringish.NameForType(f00000009Zc.BackingType)));
								_generator.LoadReboxed(f00000009Zc, typeof(Flabbergast.Stringish));
								f0000000B1I_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(TaskMaster).GetMethod("VerifySymbol", new System.Type[] { typeof(SourceReference), typeof(Stringish) }));
								});
							f0000000B11_cond(f00000009oH);
							}, (f0000000B11_true) => {
							f0000000B11_true(f00000009Zc);
							}, (f0000000B11_false) => {
								_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
								_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
							}, (f00000009fm) => {
								f00000009Cn_code(f00000009fm);
							});
						} else if (f00000009Zc.BackingType == typeof(long)) {
							var f00000009fl = new GeneratedValue(typeof(Flabbergast.Stringish), (f0000000Ayx_builder) => {
							if (!typeof(long).IsAssignableFrom(f00000009Zc.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Call.", Stringish.NameForType(f00000009Zc.BackingType)));
							_generator.LoadReboxed(f00000009Zc, typeof(long));
							f0000000Ayx_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(TaskMaster).GetMethod("OrdinalName", new System.Type[] { typeof(long) }));
							});
							f00000009Cn_code(f00000009fl);
						} else {
							throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: fricassée Select with attribute names not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
						}
					});
				});
			});
			f000000061x_position = 2;
			_generator.MarkState(f000000061x_dispatchers[0]);
			_final_block(f000000061x);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		selector.GenerateApi(_api_gen, false);
		name_expr.GenerateApi(_api_gen, false);
		value_expr.GenerateApi(_api_gen, false);
	}
	internal expression_for_select_named Clone() {
		var _obj = new expression_for_select_named();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.selector = selector;
		_obj.name_expr = name_expr;
		_obj.value_expr = value_expr;
		return _obj;
	}
}
internal class expression_from : expression {
	public override string PrettyName { get { return "external import"; } }
	internal RevCons<char> uri = null;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Sy = Environment.EnsureIntrinsic(_collector, this, _type, _needs_unbox, ref _success);
		InferredType = f00000005Sy;		return f00000005Sy;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005nu = _generator.ResolveUri(Generator.ToString(uri));
		Environment.IntrinsicDispatch(_generator, this, f00000005nu, _source_reference, (f00000005Sx) => {
			_final_block(f00000005Sx);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		_api_gen.RegisterRef(Generator.ToString(uri));
	}
	internal expression_from Clone() {
		var _obj = new expression_from();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.uri = uri;
		return _obj;
	}
}
internal class expression_function_anonymous : expression {
	public override string PrettyName { get { return "function-like template instantiation (unnamed arguments)"; } }
	internal expression func_expr;
	internal System.Collections.Generic.List<expression> anon_args = new System.Collections.Generic.List<expression>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (func_expr != null) { func_expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (anon_args != null) { foreach (var f00000005fG in anon_args) f00000005fG.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005T8 = Environment.EnsureIntrinsic(_collector, this, _type, _needs_unbox, ref _success);
		InferredType = f00000005T8;		return f00000005T8;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005TA = NameInfo.AnyType;
		var f00000005oA = _type & (0 | Flabbergast.Type.Template);
		if (f00000005oA == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Template, _type);
		}
		var f00000006oV =  f00000005oA;
		if (func_expr != null) f00000006oV &= AstTypeableNode.HorrendousTypeMerge(func_expr.EnsureType(_collector, f00000005oA, ref _success, true), f00000005oA);
		f00000005TA &= f00000006oV;
		var f00000006Al = NameInfo.AnyType;
		if (anon_args != null) foreach (var f00000006Al_item in anon_args) f00000006Al &= f00000006Al_item.EnsureType(_collector, _type, ref _success, _needs_unbox);
		f00000005TA &= f00000006Al;
		f00000005TA &= _type;
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		func_expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f0000000771) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000006gD_code = (f00000006gD) => {
				var f00000006HP = _generator.MakeField("function_anonymous_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000006gD.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000006gD.BackingType)));
				_generator.LoadReboxed(f00000006gD, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
				_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006HP.Field);
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "value");
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				f00000006HP.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f00000005o4 = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f00000005o4, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				Environment.IntrinsicDispatch(_generator, this, f00000005o4, _source_reference, (f00000005T7) => {
					_final_block(f00000005T7);
				});
			};
			if (f0000000771.BackingType == typeof(Flabbergast.Template)) {
				var f000000097T = _generator.MakeField("function_anonymous_iterator_inputs", typeof(IAttributeNames[]));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000097T.Field);
				int f0000000Azy_next;
				f0000000Azy_next = _generator.DefineState();
				f000000097T.Load(_generator);
				if (!typeof(IAttributeNames).IsAssignableFrom(f0000000771.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f0000000771.BackingType)));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
				f0000000771.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
				_generator.JumpToState(f0000000Azy_next);
				_generator.MarkState(f0000000Azy_next);
				var f00000008Hi = _generator.MakeField("function_anonymous_iterator_accumulator", typeof(Flabbergast.MutableFrame));
				var f00000008Hi_start_block = _generator.DefineState();
				var f00000008j6 = _generator.PushSourceReference(this, _source_reference);
				var f00000009KA = new GeneratedValue(typeof(Flabbergast.Context), (f0000000Atg_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f0000000771.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f0000000771.BackingType)));
				_generator.LoadReboxed(f0000000771, typeof(Flabbergast.Template));
				f0000000Atg_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("get_Context"));
				});
				var f00000009K9 = new GeneratedValue(typeof(Flabbergast.Frame), (f0000000Ath_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f0000000771.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f0000000771.BackingType)));
				_generator.LoadReboxed(f0000000771, typeof(Flabbergast.Template));
				f0000000Ath_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("get_Container"));
				});
				var f000000097S = _generator.MakeField("function_anonymous_new_frame", typeof(MutableFrame));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.LoadTaskMaster();
				_generator.AmendSourceReference(this, "function-like instantiation", f00000008j6, null);
				f00000009KA.Load(_generator);
				f00000009K9.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000097S.Field);
				_generator.CopyField(f000000097S, f00000008Hi);
				_generator.JumpToState(f00000008Hi_start_block);
				_generator.MarkState(f00000008Hi_start_block);
				var f00000008Hi_dispatchers = new int[ 2 + 1 ];
				for(var f0000000ArV_it = 0; f0000000ArV_it < f00000008Hi_dispatchers.Length; f0000000ArV_it++) { f00000008Hi_dispatchers[f0000000ArV_it] = _generator.DefineState(); }
				var f00000008Hi_iterator = _generator.MakeField("function_anonymous_iterator", typeof(MergeIterator));
				#pragma warning disable 219
				var f00000008Hi_key = new MethodValue(f00000008Hi_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
				var f00000008Hi_ordinal = new MethodValue(f00000008Hi_iterator, typeof(MergeIterator).GetMethod("get_Position"));
				#pragma warning restore 219
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f000000097T.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000008Hi_dispatchers[1]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000008Hi_dispatchers[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
				#pragma warning disable 219
				var f00000008Hi_position = 2;
				#pragma warning restore 219
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "args");
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000008Hi_dispatchers[f00000008Hi_position++]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("AddDispatcher", new System.Type[] { typeof(string), typeof(int) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000008Hi_iterator.Field);
				var f00000008Hi_next = _generator.DefineState();
				_generator.JumpToState(f00000008Hi_next);
				_generator.MarkState(f00000008Hi_next);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f00000008Hi_iterator.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
				_generator.MarkState(f00000008Hi_dispatchers[1]);
				var f000000097R = new GeneratedValue(typeof(Flabbergast.ComputeValue), (f0000000AtF_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f0000000771.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f0000000771.BackingType)));
				_generator.LoadReboxed(f0000000771, typeof(Flabbergast.Template));
				if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000008Hi_key.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Call.", Stringish.NameForType(f00000008Hi_key.BackingType)));
				_generator.LoadReboxed(f00000008Hi_key, typeof(Flabbergast.Stringish));
				f0000000AtF_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("Get", new System.Type[] { typeof(Stringish) }));
				});
				if (!typeof(Template).IsAssignableFrom(f00000008Hi.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000008Hi.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000008Hi.BackingType)));
				f00000008Hi.Load(_generator);
				f00000008Hi_key.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
				var f0000000AsA_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000008Hi.BackingType);
				var f0000000AsA_boxed_type = f0000000AsA_is_frame ? typeof(object) : typeof(ComputeValue);
				_generator.LoadReboxed(f000000097R, f0000000AsA_boxed_type);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000008Hi.BackingType.GetMethod(f0000000AsA_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f0000000AsA_boxed_type }));
				_generator.CopyField(f00000008Hi, f00000008Hi);
				_generator.JumpToState(f00000008Hi_next);
				f00000008Hi_position = 2;
				_generator.MarkState(f00000008Hi_dispatchers[f00000008Hi_position++]);
				var f0000000Avg_label = _generator.DefineState();
				var f00000009eB = _generator.MakeField("function_anonymous_new_frame", typeof(MutableFrame));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.LoadTaskMaster();
				_generator.AmendSourceReference(this, "list defined", _source_reference, null);
				_context.Load(_generator);
				_self_frame.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000009eB.Field);
				_generator.JumpToState(f0000000Avg_label);
				for (var f0000000Avg_index = 0; f0000000Avg_index < anon_args.Count; f0000000Avg_index++) {
					_generator.MarkState(f0000000Avg_label);
					f0000000Avg_label = _generator.DefineState();
					anon_args[f0000000Avg_index].Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f0000000Avg_result) => {
						f00000009eB.Load(_generator);
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I8, (long) f0000000Avg_index + 1);
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(TaskMaster).GetMethod("OrdinalNameStr", new System.Type[] { typeof(long) }));
						_generator.LoadReboxed(f0000000Avg_result, typeof(object));
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MutableFrame).GetMethod("Set", new System.Type[] { typeof(string), typeof(object) }));
						_generator.JumpToState(f0000000Avg_label);
					});
				}
				_generator.MarkState(f0000000Avg_label);
				if (!typeof(Template).IsAssignableFrom(f00000008Hi.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000008Hi.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000008Hi.BackingType)));
				f00000008Hi.Load(_generator);
				f00000008Hi_key.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
				var f0000000Av8_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000008Hi.BackingType);
				var f0000000Av8_boxed_type = f0000000Av8_is_frame ? typeof(object) : typeof(ComputeValue);
				_generator.LoadReboxed(f00000009eB, f0000000Av8_boxed_type);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000008Hi.BackingType.GetMethod(f0000000Av8_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f0000000Av8_boxed_type }));
				_generator.CopyField(f00000008Hi, f00000008Hi);
				_generator.JumpToState(f00000008Hi_next);
				_generator.MarkState(f00000008Hi_dispatchers[0]);
				f00000006gD_code(f00000008Hi);
			} else {
				throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: function-like template instantiation (unnamed arguments) not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		func_expr.GenerateApi(_api_gen, false);
		foreach(var f00000006Ag in anon_args) 			f00000006Ag.GenerateApi(_api_gen, false);
	}
	internal expression_function_anonymous Clone() {
		var _obj = new expression_function_anonymous();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.func_expr = func_expr;
		_obj.anon_args.AddRange(anon_args);
		return _obj;
	}
}
internal class expression_function_mixed : expression {
	public override string PrettyName { get { return "function-like template instantiation (named and unnamed arguments)"; } }
	internal expression func_expr;
	internal System.Collections.Generic.List<expression> anon_args = new System.Collections.Generic.List<expression>();
	internal System.Collections.Generic.List<named_definition> named_args = new System.Collections.Generic.List<named_definition>();
	internal System.Collections.Generic.Dictionary<string, bool> named_args_dedup = new System.Collections.Generic.Dictionary<string, bool>{{ "args", true},{ "value", true},};
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (func_expr != null) { func_expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (anon_args != null) { foreach (var f00000005fI in anon_args) f00000005fI.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (named_args != null) { foreach (var f000000062I in named_args) f000000062I.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005TI = Environment.EnsureIntrinsic(_collector, this, _type, _needs_unbox, ref _success);
		InferredType = f00000005TI;		return f00000005TI;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005TK = NameInfo.AnyType;
		var f00000005oJ = _type & (0 | Flabbergast.Type.Template);
		if (f00000005oJ == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Template, _type);
		}
		var f00000006oq =  f00000005oJ;
		if (func_expr != null) f00000006oq &= AstTypeableNode.HorrendousTypeMerge(func_expr.EnsureType(_collector, f00000005oJ, ref _success, true), f00000005oJ);
		f00000005TK &= f00000006oq;
		var f00000006As = NameInfo.AnyType;
		if (anon_args != null) foreach (var f00000006As_item in anon_args) f00000006As &= f00000006As_item.EnsureType(_collector, _type, ref _success, _needs_unbox);
		f00000005TK &= f00000006As;
		var f00000006R4 = NameInfo.AnyType;
		if (named_args != null) foreach (var f00000006R4_item in named_args) f00000006R4 &= f00000006R4_item.EnsureType(_collector, _type, ref _success, _needs_unbox);
		f00000005TK &= f00000006R4;
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		func_expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f000000077J) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000006gN_code = (f00000006gN) => {
				var f00000006HQ = _generator.MakeField("function_mixed_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000006gN.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000006gN.BackingType)));
				_generator.LoadReboxed(f00000006gN, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
				_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006HQ.Field);
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "value");
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				f00000006HQ.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f00000005oD = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f00000005oD, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				Environment.IntrinsicDispatch(_generator, this, f00000005oD, _source_reference, (f00000005TH) => {
					_final_block(f00000005TH);
				});
			};
			if (f000000077J.BackingType == typeof(Flabbergast.Template)) {
				var f000000097o = _generator.MakeField("function_mixed_iterator_inputs", typeof(IAttributeNames[]));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000097o.Field);
				int f0000000B0a_next;
				f0000000B0a_next = _generator.DefineState();
				f000000097o.Load(_generator);
				if (!typeof(IAttributeNames).IsAssignableFrom(f000000077J.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f000000077J.BackingType)));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
				f000000077J.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
				_generator.JumpToState(f0000000B0a_next);
				_generator.MarkState(f0000000B0a_next);
				var f00000008Hz = _generator.MakeField("function_mixed_iterator_accumulator", typeof(Flabbergast.MutableFrame));
				var f00000008Hz_start_block = _generator.DefineState();
				var f00000008jY = _generator.PushSourceReference(this, _source_reference);
				var f00000009KX = new GeneratedValue(typeof(Flabbergast.Context), (f0000000Atk_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f000000077J.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f000000077J.BackingType)));
				_generator.LoadReboxed(f000000077J, typeof(Flabbergast.Template));
				f0000000Atk_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("get_Context"));
				});
				var f00000009KW = new GeneratedValue(typeof(Flabbergast.Frame), (f0000000Atl_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f000000077J.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f000000077J.BackingType)));
				_generator.LoadReboxed(f000000077J, typeof(Flabbergast.Template));
				f0000000Atl_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("get_Container"));
				});
				var f000000097n = _generator.MakeField("function_mixed_new_frame", typeof(MutableFrame));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.LoadTaskMaster();
				_generator.AmendSourceReference(this, "function-like instantiation", f00000008jY, null);
				f00000009KX.Load(_generator);
				f00000009KW.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000097n.Field);
				_generator.CopyField(f000000097n, f00000008Hz);
				_generator.JumpToState(f00000008Hz_start_block);
				_generator.MarkState(f00000008Hz_start_block);
				var f00000008Hz_dispatchers = new int[ 2 + 1 + named_args.Count ];
				for(var f0000000ArW_it = 0; f0000000ArW_it < f00000008Hz_dispatchers.Length; f0000000ArW_it++) { f00000008Hz_dispatchers[f0000000ArW_it] = _generator.DefineState(); }
				var f00000008Hz_iterator = _generator.MakeField("function_mixed_iterator", typeof(MergeIterator));
				#pragma warning disable 219
				var f00000008Hz_key = new MethodValue(f00000008Hz_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
				var f00000008Hz_ordinal = new MethodValue(f00000008Hz_iterator, typeof(MergeIterator).GetMethod("get_Position"));
				#pragma warning restore 219
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f000000097o.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000008Hz_dispatchers[1]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000008Hz_dispatchers[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
				#pragma warning disable 219
				var f00000008Hz_position = 2;
				#pragma warning restore 219
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "args");
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000008Hz_dispatchers[f00000008Hz_position++]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("AddDispatcher", new System.Type[] { typeof(string), typeof(int) }));
				foreach (var f00000009G1 in named_args) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(f00000009G1.name));
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000008Hz_dispatchers[f00000008Hz_position++]);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("AddDispatcher", new System.Type[] { typeof(string), typeof(int) }));
				}
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000008Hz_iterator.Field);
				var f00000008Hz_next = _generator.DefineState();
				_generator.JumpToState(f00000008Hz_next);
				_generator.MarkState(f00000008Hz_next);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f00000008Hz_iterator.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
				_generator.MarkState(f00000008Hz_dispatchers[1]);
				var f000000097m = new GeneratedValue(typeof(Flabbergast.ComputeValue), (f0000000AtH_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f000000077J.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f000000077J.BackingType)));
				_generator.LoadReboxed(f000000077J, typeof(Flabbergast.Template));
				if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000008Hz_key.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Call.", Stringish.NameForType(f00000008Hz_key.BackingType)));
				_generator.LoadReboxed(f00000008Hz_key, typeof(Flabbergast.Stringish));
				f0000000AtH_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("Get", new System.Type[] { typeof(Stringish) }));
				});
				if (!typeof(Template).IsAssignableFrom(f00000008Hz.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000008Hz.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000008Hz.BackingType)));
				f00000008Hz.Load(_generator);
				f00000008Hz_key.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
				var f0000000AsG_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000008Hz.BackingType);
				var f0000000AsG_boxed_type = f0000000AsG_is_frame ? typeof(object) : typeof(ComputeValue);
				_generator.LoadReboxed(f000000097m, f0000000AsG_boxed_type);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000008Hz.BackingType.GetMethod(f0000000AsG_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f0000000AsG_boxed_type }));
				_generator.CopyField(f00000008Hz, f00000008Hz);
				_generator.JumpToState(f00000008Hz_next);
				f00000008Hz_position = 2;
				_generator.MarkState(f00000008Hz_dispatchers[f00000008Hz_position++]);
				var f0000000Avk_label = _generator.DefineState();
				var f00000009iA = _generator.MakeField("function_mixed_new_frame", typeof(MutableFrame));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.LoadTaskMaster();
				_generator.AmendSourceReference(this, "list defined", _source_reference, null);
				_context.Load(_generator);
				_self_frame.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000009iA.Field);
				_generator.JumpToState(f0000000Avk_label);
				for (var f0000000Avk_index = 0; f0000000Avk_index < anon_args.Count; f0000000Avk_index++) {
					_generator.MarkState(f0000000Avk_label);
					f0000000Avk_label = _generator.DefineState();
					anon_args[f0000000Avk_index].Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f0000000Avk_result) => {
						f00000009iA.Load(_generator);
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I8, (long) f0000000Avk_index + 1);
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(TaskMaster).GetMethod("OrdinalNameStr", new System.Type[] { typeof(long) }));
						_generator.LoadReboxed(f0000000Avk_result, typeof(object));
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MutableFrame).GetMethod("Set", new System.Type[] { typeof(string), typeof(object) }));
						_generator.JumpToState(f0000000Avk_label);
					});
				}
				_generator.MarkState(f0000000Avk_label);
				if (!typeof(Template).IsAssignableFrom(f00000008Hz.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000008Hz.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000008Hz.BackingType)));
				f00000008Hz.Load(_generator);
				f00000008Hz_key.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
				var f0000000AvA_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000008Hz.BackingType);
				var f0000000AvA_boxed_type = f0000000AvA_is_frame ? typeof(object) : typeof(ComputeValue);
				_generator.LoadReboxed(f00000009iA, f0000000AvA_boxed_type);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000008Hz.BackingType.GetMethod(f0000000AvA_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f0000000AvA_boxed_type }));
				_generator.CopyField(f00000008Hz, f00000008Hz);
				_generator.JumpToState(f00000008Hz_next);
				foreach (var f00000009G1 in named_args) {
					_generator.MarkState(f00000008Hz_dispatchers[f00000008Hz_position++]);
					f00000009G1.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000009c8) => {
						_generator.DebugPosition(this);
						if (!typeof(Template).IsAssignableFrom(f00000008Hz.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000008Hz.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000008Hz.BackingType)));
						f00000008Hz.Load(_generator);
						f00000008Hz_key.Load(_generator);
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
						var f0000000AzC_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000008Hz.BackingType);
						var f0000000AzC_boxed_type = f0000000AzC_is_frame ? typeof(object) : typeof(ComputeValue);
						_generator.LoadReboxed(f00000009c8, f0000000AzC_boxed_type);
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000008Hz.BackingType.GetMethod(f0000000AzC_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f0000000AzC_boxed_type }));
						_generator.CopyField(f00000008Hz, f00000008Hz);
						_generator.JumpToState(f00000008Hz_next);
					});
				}
				_generator.MarkState(f00000008Hz_dispatchers[0]);
				f00000006gN_code(f00000008Hz);
			} else {
				throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: function-like template instantiation (named and unnamed arguments) not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		func_expr.GenerateApi(_api_gen, false);
		foreach(var f00000006Am in anon_args) 			f00000006Am.GenerateApi(_api_gen, false);
		foreach(var f00000006Qu in named_args) 			f00000006Qu.GenerateApi(_api_gen, false);
	}
	internal expression_function_mixed Clone() {
		var _obj = new expression_function_mixed();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.func_expr = func_expr;
		_obj.anon_args.AddRange(anon_args);
		_obj.named_args.AddRange(named_args);
		foreach(var _element in named_args_dedup.Keys) _obj.named_args_dedup[_element] = true;
		return _obj;
	}
}
internal class expression_function_named : expression {
	public override string PrettyName { get { return "function-like template instantiation (named arguments)"; } }
	internal expression func_expr;
	internal System.Collections.Generic.List<named_definition> named_args = new System.Collections.Generic.List<named_definition>();
	internal System.Collections.Generic.Dictionary<string, bool> named_args_dedup = new System.Collections.Generic.Dictionary<string, bool>{{ "value", true},};
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (func_expr != null) { func_expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (named_args != null) { foreach (var f00000005fK in named_args) f00000005fK.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005TS = Environment.EnsureIntrinsic(_collector, this, _type, _needs_unbox, ref _success);
		InferredType = f00000005TS;		return f00000005TS;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005TU = NameInfo.AnyType;
		var f00000005oV = _type & (0 | Flabbergast.Type.Template);
		if (f00000005oV == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Template, _type);
		}
		var f00000006p5 =  f00000005oV;
		if (func_expr != null) f00000006p5 &= AstTypeableNode.HorrendousTypeMerge(func_expr.EnsureType(_collector, f00000005oV, ref _success, true), f00000005oV);
		f00000005TU &= f00000006p5;
		f00000005TU &= _type;
		var f00000006RB = NameInfo.AnyType;
		if (named_args != null) foreach (var f00000006RB_item in named_args) f00000006RB &= f00000006RB_item.EnsureType(_collector, _type, ref _success, _needs_unbox);
		f00000005TU &= f00000006RB;
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		func_expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f000000077b) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000006gU_code = (f00000006gU) => {
				var f00000006HR = _generator.MakeField("function_named_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000006gU.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000006gU.BackingType)));
				_generator.LoadReboxed(f00000006gU, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
				_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006HR.Field);
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "value");
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				f00000006HR.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f00000005oP = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f00000005oP, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				Environment.IntrinsicDispatch(_generator, this, f00000005oP, _source_reference, (f00000005TR) => {
					_final_block(f00000005TR);
				});
			};
			if (f000000077b.BackingType == typeof(Flabbergast.Template)) {
				var f000000098D = _generator.MakeField("function_named_iterator_inputs", typeof(IAttributeNames[]));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000098D.Field);
				int f0000000Azz_next;
				f0000000Azz_next = _generator.DefineState();
				f000000098D.Load(_generator);
				if (!typeof(IAttributeNames).IsAssignableFrom(f000000077b.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f000000077b.BackingType)));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
				f000000077b.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
				_generator.JumpToState(f0000000Azz_next);
				_generator.MarkState(f0000000Azz_next);
				var f00000008I9 = _generator.MakeField("function_named_iterator_accumulator", typeof(Flabbergast.MutableFrame));
				var f00000008I9_start_block = _generator.DefineState();
				var f00000008jr = _generator.PushSourceReference(this, _source_reference);
				var f00000009Kr = new GeneratedValue(typeof(Flabbergast.Context), (f0000000Ato_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f000000077b.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f000000077b.BackingType)));
				_generator.LoadReboxed(f000000077b, typeof(Flabbergast.Template));
				f0000000Ato_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("get_Context"));
				});
				var f00000009Kq = new GeneratedValue(typeof(Flabbergast.Frame), (f0000000Atp_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f000000077b.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f000000077b.BackingType)));
				_generator.LoadReboxed(f000000077b, typeof(Flabbergast.Template));
				f0000000Atp_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("get_Container"));
				});
				var f000000098C = _generator.MakeField("function_named_new_frame", typeof(MutableFrame));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.LoadTaskMaster();
				_generator.AmendSourceReference(this, "function-like instantiation", f00000008jr, null);
				f00000009Kr.Load(_generator);
				f00000009Kq.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000098C.Field);
				_generator.CopyField(f000000098C, f00000008I9);
				_generator.JumpToState(f00000008I9_start_block);
				_generator.MarkState(f00000008I9_start_block);
				var f00000008I9_dispatchers = new int[ 2 + named_args.Count ];
				for(var f0000000ArX_it = 0; f0000000ArX_it < f00000008I9_dispatchers.Length; f0000000ArX_it++) { f00000008I9_dispatchers[f0000000ArX_it] = _generator.DefineState(); }
				var f00000008I9_iterator = _generator.MakeField("function_named_iterator", typeof(MergeIterator));
				#pragma warning disable 219
				var f00000008I9_key = new MethodValue(f00000008I9_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
				var f00000008I9_ordinal = new MethodValue(f00000008I9_iterator, typeof(MergeIterator).GetMethod("get_Position"));
				#pragma warning restore 219
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f000000098D.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000008I9_dispatchers[1]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000008I9_dispatchers[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
				#pragma warning disable 219
				var f00000008I9_position = 2;
				#pragma warning restore 219
				foreach (var f000000098E in named_args) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(f000000098E.name));
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000008I9_dispatchers[f00000008I9_position++]);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("AddDispatcher", new System.Type[] { typeof(string), typeof(int) }));
				}
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000008I9_iterator.Field);
				var f00000008I9_next = _generator.DefineState();
				_generator.JumpToState(f00000008I9_next);
				_generator.MarkState(f00000008I9_next);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f00000008I9_iterator.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
				_generator.MarkState(f00000008I9_dispatchers[1]);
				var f000000098B = new GeneratedValue(typeof(Flabbergast.ComputeValue), (f0000000AtJ_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f000000077b.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f000000077b.BackingType)));
				_generator.LoadReboxed(f000000077b, typeof(Flabbergast.Template));
				if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000008I9_key.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Call.", Stringish.NameForType(f00000008I9_key.BackingType)));
				_generator.LoadReboxed(f00000008I9_key, typeof(Flabbergast.Stringish));
				f0000000AtJ_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("Get", new System.Type[] { typeof(Stringish) }));
				});
				if (!typeof(Template).IsAssignableFrom(f00000008I9.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000008I9.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000008I9.BackingType)));
				f00000008I9.Load(_generator);
				f00000008I9_key.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
				var f0000000AsN_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000008I9.BackingType);
				var f0000000AsN_boxed_type = f0000000AsN_is_frame ? typeof(object) : typeof(ComputeValue);
				_generator.LoadReboxed(f000000098B, f0000000AsN_boxed_type);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000008I9.BackingType.GetMethod(f0000000AsN_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f0000000AsN_boxed_type }));
				_generator.CopyField(f00000008I9, f00000008I9);
				_generator.JumpToState(f00000008I9_next);
				f00000008I9_position = 2;
				foreach (var f000000098E in named_args) {
					_generator.MarkState(f00000008I9_dispatchers[f00000008I9_position++]);
					f000000098E.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000009WS) => {
						_generator.DebugPosition(this);
						if (!typeof(Template).IsAssignableFrom(f00000008I9.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000008I9.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000008I9.BackingType)));
						f00000008I9.Load(_generator);
						f00000008I9_key.Load(_generator);
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
						var f0000000AvD_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000008I9.BackingType);
						var f0000000AvD_boxed_type = f0000000AvD_is_frame ? typeof(object) : typeof(ComputeValue);
						_generator.LoadReboxed(f00000009WS, f0000000AvD_boxed_type);
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000008I9.BackingType.GetMethod(f0000000AvD_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f0000000AvD_boxed_type }));
						_generator.CopyField(f00000008I9, f00000008I9);
						_generator.JumpToState(f00000008I9_next);
					});
				}
				_generator.MarkState(f00000008I9_dispatchers[0]);
				f00000006gU_code(f00000008I9);
			} else {
				throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: function-like template instantiation (named arguments) not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		func_expr.GenerateApi(_api_gen, false);
		foreach(var f00000006R5 in named_args) 			f00000006R5.GenerateApi(_api_gen, false);
	}
	internal expression_function_named Clone() {
		var _obj = new expression_function_named();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.func_expr = func_expr;
		_obj.named_args.AddRange(named_args);
		foreach(var _element in named_args_dedup.Keys) _obj.named_args_dedup[_element] = true;
		return _obj;
	}
}
internal class expression_function_new : expression {
	public override string PrettyName { get { return "define function-like template"; } }
	internal System.Collections.Generic.List<attribute> attributes = new System.Collections.Generic.List<attribute>();
	internal System.Collections.Generic.Dictionary<string, bool> attributes_dedup = new System.Collections.Generic.Dictionary<string, bool>{{ "value", true},};
	internal expression body;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		outer_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, null, false);
		inner_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, outer_environment, false);
		if (attributes != null) foreach (var f00000006RE in attributes) {
			f00000006RE.AddMask(_collector, inner_environment);
		}
		inner_environment.AddForbiddenName("value");
		if (attributes != null) { foreach (var f00000006HT in attributes) f00000006HT.PropagateEnvironment(_collector, _queue, new Environment(f00000006HT.FileName, f00000006HT.StartRow, f00000006HT.StartColumn, f00000006HT.EndRow, f00000006HT.EndColumn, inner_environment, false, false), ref _success); }
		if (body != null) { body.PropagateEnvironment(_collector, _queue, inner_environment, ref _success); }
		return _return;
	}
	Environment outer_environment;
	Environment inner_environment;
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Tc = _type & (0 | Flabbergast.Type.Template);
		if (f00000005Tc == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Template, _type);
		}
		InferredType = f00000005Tc;		return f00000005Tc;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Te =  _type;
		if (body != null) f00000005Te &= AstTypeableNode.HorrendousTypeMerge(body.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005oZ = _generator.MakeField("collapse_result", typeof(Flabbergast.Template));
		var f00000006Xl_label = _generator.DefineState();
		var f00000006gc = new StringishValue("value");
		var f00000006gb = _generator.MakeField("new_template", typeof(Template));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
		_generator.AmendSourceReference(this, "amend template", _source_reference, null);
		_context.Load(_generator);
		_self_frame.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Template).GetConstructors()[0]);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006gb.Field);
		var f00000006gd = new DelegateValue(_generator.CreateFunction(this, "f0000000AZW", (f00000006gd_generator, f00000009mX_container_frame, f00000009Pb_context, f00000009cH_self_frame, f000000098W_source_reference) => {
			f00000006gd_generator.DebugPosition(this);
			var f000000077u = f00000006gd_generator.PushSourceReference(this, f000000098W_source_reference);
			outer_environment.GenerateLookupCache(f00000006gd_generator, null, null, f000000077u, f00000009Pb_context, f00000009cH_self_frame, (f00000007gq_context, f00000007gq_cache) => {
				f00000006gd_generator.DebugPosition(this);
				inner_environment.GenerateLookupCache(f00000006gd_generator, null, f00000007gq_cache, f000000077u, f00000007gq_context, f00000009cH_self_frame, (f00000008IP_context, f00000008IP_cache) => {
					f00000006gd_generator.DebugPosition(this);
					body.Generate(f00000006gd_generator, f00000008IP_cache, f000000077u, f00000008IP_context, f00000009cH_self_frame, f00000009mX_container_frame, (f00000008kB) => {
						f00000006gd_generator.DebugPosition(this);
				f00000006gd_generator.Return(f00000008kB);
					});
				});
			});
		}), typeof(ComputeValue));
		if (!typeof(Template).IsAssignableFrom(f00000006gb.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000006gb.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000006gb.BackingType)));
		f00000006gb.Load(_generator);
		f00000006gc.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
		var f0000000AVT_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000006gb.BackingType);
		var f0000000AVT_boxed_type = f0000000AVT_is_frame ? typeof(object) : typeof(ComputeValue);
		_generator.LoadReboxed(f00000006gd, f0000000AVT_boxed_type);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000006gb.BackingType.GetMethod(f0000000AVT_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f0000000AVT_boxed_type }));
		_generator.CopyField(f00000006gb, f00000005oZ);
		_generator.JumpToState(f00000006Xl_label);
		foreach (var f00000006Xl_item in attributes) {
			_generator.MarkState(f00000006Xl_label);
			f00000006Xl_label = _generator.DefineState();
			f00000006Xl_item.Generate(_generator, _source_reference, _context, _self_frame, _container_frame, null, f00000005oZ, (f00000006Xl_result) => {
				_generator.CopyField(f00000006Xl_result, f00000005oZ);
				_generator.JumpToState(f00000006Xl_label);
			});
		}
		_generator.MarkState(f00000006Xl_label);
		_final_block(f00000005oZ);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		foreach(var f00000005TY in attributes) 			f00000005TY.GenerateApi(_api_gen, _collect_names);
	}
	internal expression_function_new Clone() {
		var _obj = new expression_function_new();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.attributes.AddRange(attributes);
		foreach(var _element in attributes_dedup.Keys) _obj.attributes_dedup[_element] = true;
		_obj.body = body;
		return _obj;
	}
}
internal class expression_generate_id : expression {
	public override string PrettyName { get { return "unique frame identifier"; } }
	internal expression expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expr != null) { expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Tm = _type & (0 | Flabbergast.Type.Str);
		if (f00000005Tm == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Str, _type);
		}
		InferredType = f00000005Tm;		return f00000005Tm;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005To = _type & (0 | Flabbergast.Type.Frame);
		if (f00000005To == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		var f00000005p3 =  f00000005To;
		if (expr != null) f00000005p3 &= AstTypeableNode.HorrendousTypeMerge(expr.EnsureType(_collector, f00000005To, ref _success, true), f00000005To);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005ow) => {
			_generator.DebugPosition(this);
			var f00000005Tl = new GeneratedValue(typeof(Flabbergast.Stringish), (f000000078D_builder) => {
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000005ow.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000005ow.BackingType)));
			_generator.LoadReboxed(f00000005ow, typeof(Flabbergast.Frame));
			f000000078D_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("get_Id"));
			});
			_final_block(f00000005Tl);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expr.GenerateApi(_api_gen, false);
	}
	internal expression_generate_id Clone() {
		var _obj = new expression_generate_id();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expr = expr;
		return _obj;
	}
}
internal class expression_greater : expression {
	public override string PrettyName { get { return "greater-than comparison"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Tw = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005Tw == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005Tw;		return f00000005Tw;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Ty = _type & (0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str);
		if (f00000005Ty == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str, _type);
		}
		var f00000005pM = f00000005Ty;
		for(var f00000005pM_junk = 0; f00000005pM_junk < 2; f00000005pM_junk++) {
			var f00000006I7 =  f00000005pM;
			if (left != null) f00000006I7 &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005pM, ref _success, true), f00000005pM);
			if (right != null) f00000006I7 &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005pM, ref _success, true), f00000005pM);
			f00000005pM &= f00000006I7;
		}
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006Hw) => {
			_generator.DebugPosition(this);
			right.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006Hx) => {
				_generator.DebugPosition(this);
						var f00000005pD = _generator.Compare(f00000006Hw, f00000006Hx, _source_reference);
					if (f00000005pD != null) {
					var f00000005Tv = new GeneratedValue(typeof(bool), (f000000078J_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000005pD.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_I4.", Stringish.NameForType(f00000005pD.BackingType)));
					_generator.LoadReboxed(f00000005pD, typeof(long));
					f000000078J_builder.Emit(System.Reflection.Emit.OpCodes.Conv_I4);
					f000000078J_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
					f000000078J_builder.Emit(System.Reflection.Emit.OpCodes.Ceq);
					});
					_final_block(f00000005Tv);
					}
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_greater Clone() {
		var _obj = new expression_greater();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_greater_or_equality : expression {
	public override string PrettyName { get { return "greater-than or equality comparison"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005U6 = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005U6 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005U6;		return f00000005U6;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005U8 = _type & (0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str);
		if (f00000005U8 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str, _type);
		}
		var f00000005pf = f00000005U8;
		for(var f00000005pf_junk = 0; f00000005pf_junk < 2; f00000005pf_junk++) {
			var f00000006IK =  f00000005pf;
			if (left != null) f00000006IK &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005pf, ref _success, true), f00000005pf);
			if (right != null) f00000006IK &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005pf, ref _success, true), f00000005pf);
			f00000005pf &= f00000006IK;
		}
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006I9) => {
			_generator.DebugPosition(this);
			right.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006IA) => {
				_generator.DebugPosition(this);
						var f00000005pW = _generator.Compare(f00000006I9, f00000006IA, _source_reference);
					if (f00000005pW != null) {
					var f00000005U5 = new GeneratedValue(typeof(bool), (f000000078X_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000005pW.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_I4.", Stringish.NameForType(f00000005pW.BackingType)));
					_generator.LoadReboxed(f00000005pW, typeof(long));
					f000000078X_builder.Emit(System.Reflection.Emit.OpCodes.Conv_I4);
					f000000078X_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, -1);
					f000000078X_builder.Emit(System.Reflection.Emit.OpCodes.Ceq);
					f000000078X_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
					f000000078X_builder.Emit(System.Reflection.Emit.OpCodes.Ceq);
					});
					_final_block(f00000005U5);
					}
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_greater_or_equality Clone() {
		var _obj = new expression_greater_or_equality();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_hex_integer_literal : expression {
	public override string PrettyName { get { return "hexidecimal integral value"; } }
	internal long amount;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005UB = _type & (0 | Flabbergast.Type.Int);
		if (f00000005UB == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		InferredType = f00000005UB;		return f00000005UB;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005UA = new IntConstant(amount);
		_final_block(f00000005UA);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_hex_integer_literal Clone() {
		var _obj = new expression_hex_integer_literal();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.amount = amount;
		return _obj;
	}
}
internal class expression_id : expression {
	public override string PrettyName { get { return "unique identifier for current frame"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005UG = _type & (0 | Flabbergast.Type.Str);
		if (f00000005UG == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Str, _type);
		}
		InferredType = f00000005UG;		return f00000005UG;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005UF = new GeneratedValue(typeof(Flabbergast.Stringish), (f000000078p_builder) => {
		if (!typeof(Flabbergast.Frame).IsAssignableFrom(_self_frame.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(_self_frame.BackingType)));
		_generator.LoadReboxed(_self_frame, typeof(Flabbergast.Frame));
		f000000078p_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("get_Id"));
		});
		_final_block(f00000005UF);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_id Clone() {
		var _obj = new expression_id();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class expression_if : expression {
	public override string PrettyName { get { return "conditional expression"; } }
	internal expression cond_expr;
	internal expression then_expr;
	internal expression else_expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (cond_expr != null) { cond_expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		then_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, _environment, false);
		if (then_expr != null) { then_expr.PropagateEnvironment(_collector, _queue, then_environment, ref _success); }
		else_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, _environment, false);
		if (else_expr != null) { else_expr.PropagateEnvironment(_collector, _queue, else_environment, ref _success); }
		return _return;
	}
	Environment then_environment;
	Environment else_environment;
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005US =  _type;
		if (then_expr != null) f00000005US &= AstTypeableNode.HorrendousTypeMerge(then_expr.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
		if (else_expr != null) f00000005US &= AstTypeableNode.HorrendousTypeMerge(else_expr.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
		InferredType = f00000005US;		return f00000005US;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005UU = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005UU == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		var f00000005qM =  f00000005UU;
		if (cond_expr != null) f00000005qM &= AstTypeableNode.HorrendousTypeMerge(cond_expr.EnsureType(_collector, f00000005UU, ref _success, true), f00000005UU);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		_generator.ConditionalFlow((f000000063M_cond) => {
			cond_expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005q4) => {
				_generator.DebugPosition(this);
			f000000063M_cond(f00000005q4);
			});
		}, (f000000063M_true) => {
			then_environment.GenerateLookupCache(_generator, null, _cache, _source_reference, _context, _self_frame, (f00000005q6_context, f00000005q6_cache) => {
				_generator.DebugPosition(this);
				then_expr.Generate(_generator, f00000005q6_cache, _source_reference, f00000005q6_context, _self_frame, _container_frame, (f00000006Ic) => {
					_generator.DebugPosition(this);
			f000000063M_true(f00000006Ic);
				});
			});
		}, (f000000063M_false) => {
			else_environment.GenerateLookupCache(_generator, null, _cache, _source_reference, _context, _self_frame, (f00000005q5_context, f00000005q5_cache) => {
				_generator.DebugPosition(this);
				else_expr.Generate(_generator, f00000005q5_cache, _source_reference, f00000005q5_context, _self_frame, _container_frame, (f00000006Ib) => {
					_generator.DebugPosition(this);
			f000000063M_false(f00000006Ib);
				});
			});
		}, (f00000005UR) => {
			_final_block(f00000005UR);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		cond_expr.GenerateApi(_api_gen, false);
		then_expr.GenerateApi(_api_gen, false);
		else_expr.GenerateApi(_api_gen, false);
	}
	internal expression_if Clone() {
		var _obj = new expression_if();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.cond_expr = cond_expr;
		_obj.then_expr = then_expr;
		_obj.else_expr = else_expr;
		return _obj;
	}
}
internal class expression_inequality : expression {
	public override string PrettyName { get { return "inequality comparison"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Uc = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005Uc == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005Uc;		return f00000005Uc;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Ue = _type & (0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str);
		if (f00000005Ue == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str, _type);
		}
		var f00000005qf = f00000005Ue;
		for(var f00000005qf_junk = 0; f00000005qf_junk < 2; f00000005qf_junk++) {
			var f00000006JB =  f00000005qf;
			if (left != null) f00000006JB &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005qf, ref _success, true), f00000005qf);
			if (right != null) f00000006JB &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005qf, ref _success, true), f00000005qf);
			f00000005qf &= f00000006JB;
		}
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006J0) => {
			_generator.DebugPosition(this);
			right.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006J1) => {
				_generator.DebugPosition(this);
						var f00000005qW = _generator.Compare(f00000006J0, f00000006J1, _source_reference);
					if (f00000005qW != null) {
					var f00000005Ub = new GeneratedValue(typeof(bool), (f000000079C_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000005qW.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_I4.", Stringish.NameForType(f00000005qW.BackingType)));
					_generator.LoadReboxed(f00000005qW, typeof(long));
					f000000079C_builder.Emit(System.Reflection.Emit.OpCodes.Conv_I4);
					f000000079C_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
					f000000079C_builder.Emit(System.Reflection.Emit.OpCodes.Ceq);
					f000000079C_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
					f000000079C_builder.Emit(System.Reflection.Emit.OpCodes.Ceq);
					});
					_final_block(f00000005Ub);
					}
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_inequality Clone() {
		var _obj = new expression_inequality();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_infinity : expression {
	public override string PrettyName { get { return "floating-point infinite value"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Uh = _type & (0 | Flabbergast.Type.Float);
		if (f00000005Uh == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float, _type);
		}
		InferredType = f00000005Uh;		return f00000005Uh;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005Ug = FloatConstant.INFINITY;
		_final_block(f00000005Ug);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_infinity Clone() {
		var _obj = new expression_infinity();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class expression_instantiation : expression {
	public override string PrettyName { get { return "template instantiation"; } }
	internal expression source;
	internal System.Collections.Generic.List<attribute> overrides = new System.Collections.Generic.List<attribute>();
	internal System.Collections.Generic.Dictionary<string, bool> overrides_dedup = new System.Collections.Generic.Dictionary<string, bool>{};
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (source != null) { source.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (overrides != null) { foreach (var f00000005Uq in overrides) f00000005Uq.PropagateEnvironment(_collector, _queue, new Environment(f00000005Uq.FileName, f00000005Uq.StartRow, f00000005Uq.StartColumn, f00000005Uq.EndRow, f00000005Uq.EndColumn, null, false, false), ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Us = _type & (0 | Flabbergast.Type.Frame);
		if (f00000005Us == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		InferredType = f00000005Us;		return f00000005Us;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Uu = _type & (0 | Flabbergast.Type.Template);
		if (f00000005Uu == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Template, _type);
		}
		var f00000005r1 =  f00000005Uu;
		if (source != null) f00000005r1 &= AstTypeableNode.HorrendousTypeMerge(source.EnsureType(_collector, f00000005Uu, ref _success, true), f00000005Uu);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005Ur = _generator.PushSourceReference(this, _source_reference);
		source.Generate(_generator, _cache, f00000005Ur, _context, _self_frame, _container_frame, (f00000005qr) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000005qq_code = (f00000005qq) => {
				_final_block(f00000005qq);
			};
			if (f00000005qr.BackingType == typeof(Flabbergast.Template)) {
				var f00000008Jt = _generator.MakeField("instantiation_iterator_inputs", typeof(IAttributeNames[]));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000008Jt.Field);
				int f0000000Aun_next;
				f0000000Aun_next = _generator.DefineState();
				f00000008Jt.Load(_generator);
				if (!typeof(IAttributeNames).IsAssignableFrom(f00000005qr.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f00000005qr.BackingType)));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
				f00000005qr.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
				_generator.JumpToState(f0000000Aun_next);
				_generator.MarkState(f0000000Aun_next);
				var f000000079S = _generator.MakeField("instantiation_iterator_accumulator", typeof(Flabbergast.MutableFrame));
				var f000000079S_start_block = _generator.DefineState();
				var f00000008kz = new GeneratedValue(typeof(Flabbergast.Context), (f0000000AnY_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f00000005qr.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f00000005qr.BackingType)));
				_generator.LoadReboxed(f00000005qr, typeof(Flabbergast.Template));
				f0000000AnY_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("get_Context"));
				});
				var f00000008Js = _generator.MakeField("instantiation_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Context).IsAssignableFrom(_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(_context.BackingType)));
				_generator.LoadReboxed(_context, typeof(Flabbergast.Context));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(f00000008kz.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(f00000008kz.BackingType)));
				_generator.LoadReboxed(f00000008kz, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Append", new System.Type[] { typeof(Context), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000008Js.Field);
				var f00000007ie = _generator.MakeField("instantiation_new_frame", typeof(MutableFrame));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.LoadTaskMaster();
				_generator.AmendSourceReference(this, "instantiated", f00000005Ur, f00000005qr);
				f00000008Js.Load(_generator);
				_self_frame.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000007ie.Field);
				_generator.CopyField(f00000007ie, f000000079S);
				_generator.JumpToState(f000000079S_start_block);
				_generator.MarkState(f000000079S_start_block);
				var f000000079S_dispatchers = new int[ 2 + overrides.Count ];
				for(var f00000009ab_it = 0; f00000009ab_it < f000000079S_dispatchers.Length; f00000009ab_it++) { f000000079S_dispatchers[f00000009ab_it] = _generator.DefineState(); }
				var f000000079S_iterator = _generator.MakeField("instantiation_iterator", typeof(MergeIterator));
				#pragma warning disable 219
				var f000000079S_key = new MethodValue(f000000079S_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
				var f000000079S_ordinal = new MethodValue(f000000079S_iterator, typeof(MergeIterator).GetMethod("get_Position"));
				#pragma warning restore 219
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f00000008Jt.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f000000079S_dispatchers[1]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f000000079S_dispatchers[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
				#pragma warning disable 219
				var f000000079S_position = 2;
				#pragma warning restore 219
				foreach (var f00000008Jv in overrides) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(f00000008Jv.name));
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f000000079S_dispatchers[f000000079S_position++]);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("AddDispatcher", new System.Type[] { typeof(string), typeof(int) }));
				}
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000079S_iterator.Field);
				var f000000079S_next = _generator.DefineState();
				_generator.JumpToState(f000000079S_next);
				_generator.MarkState(f000000079S_next);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f000000079S_iterator.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
				_generator.MarkState(f000000079S_dispatchers[1]);
				var f00000008Jr = new GeneratedValue(typeof(Flabbergast.ComputeValue), (f0000000AAC_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f00000005qr.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f00000005qr.BackingType)));
				_generator.LoadReboxed(f00000005qr, typeof(Flabbergast.Template));
				if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f000000079S_key.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Call.", Stringish.NameForType(f000000079S_key.BackingType)));
				_generator.LoadReboxed(f000000079S_key, typeof(Flabbergast.Stringish));
				f0000000AAC_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("Get", new System.Type[] { typeof(Stringish) }));
				});
				if (!typeof(Template).IsAssignableFrom(f000000079S.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f000000079S.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f000000079S.BackingType)));
				f000000079S.Load(_generator);
				f000000079S_key.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
				var f00000009xT_is_frame = typeof(MutableFrame).IsAssignableFrom(f000000079S.BackingType);
				var f00000009xT_boxed_type = f00000009xT_is_frame ? typeof(object) : typeof(ComputeValue);
				_generator.LoadReboxed(f00000008Jr, f00000009xT_boxed_type);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f000000079S.BackingType.GetMethod(f00000009xT_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000009xT_boxed_type }));
				_generator.CopyField(f000000079S, f000000079S);
				_generator.JumpToState(f000000079S_next);
				f000000079S_position = 2;
				foreach (var f00000008Jv in overrides) {
					_generator.MarkState(f000000079S_dispatchers[f000000079S_position++]);
					f00000008Jv.Generate(_generator, f00000005Ur, _context, _self_frame, _container_frame, f00000005qr, f000000079S, (f00000008l1) => {
						_generator.DebugPosition(this);
						_generator.CopyField(f00000008l1, f000000079S);
						_generator.JumpToState(f000000079S_next);
					});
				}
				_generator.MarkState(f000000079S_dispatchers[0]);
				f00000005qq_code(f000000079S);
			} else {
				throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: template instantiation not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		source.GenerateApi(_api_gen, false);
		foreach(var f00000005qn in overrides) 			f00000005qn.GenerateApi(_api_gen, _collect_names);
	}
	internal expression_instantiation Clone() {
		var _obj = new expression_instantiation();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.source = source;
		_obj.overrides.AddRange(overrides);
		foreach(var _element in overrides_dedup.Keys) _obj.overrides_dedup[_element] = true;
		return _obj;
	}
}
internal class expression_int_ig : expression {
	public override string PrettyName { get { return "integral value with unit Gi"; } }
	internal long count;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Ux = _type & (0 | Flabbergast.Type.Int);
		if (f00000005Ux == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		InferredType = f00000005Ux;		return f00000005Ux;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005Uw = new IntConstant(count * 1073741824);
		_final_block(f00000005Uw);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_int_ig Clone() {
		var _obj = new expression_int_ig();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.count = count;
		return _obj;
	}
}
internal class expression_int_ik : expression {
	public override string PrettyName { get { return "integral value with unit ki"; } }
	internal long count;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005V2 = _type & (0 | Flabbergast.Type.Int);
		if (f00000005V2 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		InferredType = f00000005V2;		return f00000005V2;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005V1 = new IntConstant(count * 1024);
		_final_block(f00000005V1);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_int_ik Clone() {
		var _obj = new expression_int_ik();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.count = count;
		return _obj;
	}
}
internal class expression_int_im : expression {
	public override string PrettyName { get { return "integral value with unit Mi"; } }
	internal long count;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005V7 = _type & (0 | Flabbergast.Type.Int);
		if (f00000005V7 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		InferredType = f00000005V7;		return f00000005V7;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005V6 = new IntConstant(count * 1048576);
		_final_block(f00000005V6);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_int_im Clone() {
		var _obj = new expression_int_im();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.count = count;
		return _obj;
	}
}
internal class expression_int_max : expression {
	public override string PrettyName { get { return "largest integral value"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005VC = _type & (0 | Flabbergast.Type.Int);
		if (f00000005VC == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		InferredType = f00000005VC;		return f00000005VC;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005VB = new IntConstant(System.Int64.MaxValue);
		_final_block(f00000005VB);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_int_max Clone() {
		var _obj = new expression_int_max();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class expression_int_min : expression {
	public override string PrettyName { get { return "smallest integral value"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005VH = _type & (0 | Flabbergast.Type.Int);
		if (f00000005VH == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		InferredType = f00000005VH;		return f00000005VH;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005VG = new IntConstant(System.Int64.MinValue);
		_final_block(f00000005VG);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_int_min Clone() {
		var _obj = new expression_int_min();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class expression_int_sg : expression {
	public override string PrettyName { get { return "integral value with unit G"; } }
	internal long count;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005VM = _type & (0 | Flabbergast.Type.Int);
		if (f00000005VM == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		InferredType = f00000005VM;		return f00000005VM;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005VL = new IntConstant(count * 1000000000);
		_final_block(f00000005VL);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_int_sg Clone() {
		var _obj = new expression_int_sg();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.count = count;
		return _obj;
	}
}
internal class expression_int_sk : expression {
	public override string PrettyName { get { return "integral value with unit k"; } }
	internal long count;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005VR = _type & (0 | Flabbergast.Type.Int);
		if (f00000005VR == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		InferredType = f00000005VR;		return f00000005VR;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005VQ = new IntConstant(count * 1000);
		_final_block(f00000005VQ);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_int_sk Clone() {
		var _obj = new expression_int_sk();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.count = count;
		return _obj;
	}
}
internal class expression_int_sm : expression {
	public override string PrettyName { get { return "integral value with unit M"; } }
	internal long count;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005VW = _type & (0 | Flabbergast.Type.Int);
		if (f00000005VW == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		InferredType = f00000005VW;		return f00000005VW;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005VV = new IntConstant(count * 1000000);
		_final_block(f00000005VV);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_int_sm Clone() {
		var _obj = new expression_int_sm();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.count = count;
		return _obj;
	}
}
internal class expression_integer_literal : expression {
	public override string PrettyName { get { return "integral value"; } }
	internal long amount;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Vb = _type & (0 | Flabbergast.Type.Int | Flabbergast.Type.Float);
		if (f00000005Vb == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int | Flabbergast.Type.Float, _type);
		}
		InferredType = f00000005Vb;		return f00000005Vb;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005Va = new IntConstant(amount);
		_final_block(f00000005Va);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_integer_literal Clone() {
		var _obj = new expression_integer_literal();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.amount = amount;
		return _obj;
	}
}
internal class expression_is_finite : expression {
	public override string PrettyName { get { return "finite check"; } }
	internal expression left;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Vl = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005Vl == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005Vl;		return f00000005Vl;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Vn = _type & (0 | Flabbergast.Type.Float | Flabbergast.Type.Int);
		if (f00000005Vn == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float | Flabbergast.Type.Int, _type);
		}
		var f00000005sD =  f00000005Vn;
		if (left != null) f00000005sD &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005Vn, ref _success, true), f00000005Vn);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005s4) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000005Vk_code = (f00000005Vk) => {
				_final_block(f00000005Vk);
			};
			if (f00000005s4.BackingType == typeof(double)) {
				var f00000006iB = new GeneratedValue(typeof(bool), (f00000009p2_builder) => {
				if (!typeof(double).IsAssignableFrom(f00000005s4.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Call.", Stringish.NameForType(f00000005s4.BackingType)));
				_generator.LoadReboxed(f00000005s4, typeof(double));
				f00000009p2_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(double).GetMethod("IsInfinity", new System.Type[] { typeof(double) }));
				f00000009p2_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
				f00000009p2_builder.Emit(System.Reflection.Emit.OpCodes.Ceq);
				});
				f00000005Vk_code(f00000006iB);
			} else if (f00000005s4.BackingType == typeof(long)) {
				var f00000006iA = new BoolConstant(true);
				f00000005Vk_code(f00000006iA);
			} else {
				throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: finite check not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
	}
	internal expression_is_finite Clone() {
		var _obj = new expression_is_finite();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		return _obj;
	}
}
internal class expression_is_nan : expression {
	public override string PrettyName { get { return "not-a-number check"; } }
	internal expression left;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Vv = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005Vv == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005Vv;		return f00000005Vv;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Vx = _type & (0 | Flabbergast.Type.Float | Flabbergast.Type.Int);
		if (f00000005Vx == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float | Flabbergast.Type.Int, _type);
		}
		var f00000005sU =  f00000005Vx;
		if (left != null) f00000005sU &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005Vx, ref _success, true), f00000005Vx);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005sL) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000005Vu_code = (f00000005Vu) => {
				_final_block(f00000005Vu);
			};
			if (f00000005sL.BackingType == typeof(double)) {
				var f00000006iI = new GeneratedValue(typeof(bool), (f00000009p3_builder) => {
				if (!typeof(double).IsAssignableFrom(f00000005sL.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Call.", Stringish.NameForType(f00000005sL.BackingType)));
				_generator.LoadReboxed(f00000005sL, typeof(double));
				f00000009p3_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(double).GetMethod("IsNaN", new System.Type[] { typeof(double) }));
				});
				f00000005Vu_code(f00000006iI);
			} else if (f00000005sL.BackingType == typeof(long)) {
				var f00000006iH = new BoolConstant(false);
				f00000005Vu_code(f00000006iH);
			} else {
				throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: not-a-number check not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
	}
	internal expression_is_nan Clone() {
		var _obj = new expression_is_nan();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		return _obj;
	}
}
internal class expression_is_null : expression {
	public override string PrettyName { get { return "null check"; } }
	internal expression left;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005W5 = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005W5 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005W5;		return f00000005W5;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005W7 =  _type;
		if (left != null) f00000005W7 &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, _type, ref _success, true), _type);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005sc) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000005W4_code = (f00000005W4) => {
				_final_block(f00000005W4);
			};
			if (f00000005sc.BackingType == typeof(Flabbergast.Unit)) {
				var f00000006iO = new BoolConstant(true);
				f00000005W4_code(f00000006iO);
			} else {
				var f00000005sb = new BoolConstant(false);
				f00000005W4_code(f00000005sb);
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
	}
	internal expression_is_null Clone() {
		var _obj = new expression_is_null();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		return _obj;
	}
}
internal class expression_length : expression {
	public override string PrettyName { get { return "length"; } }
	internal expression expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expr != null) { expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		InferredType = _type;		return _type;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005WH = _type & (0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str);
		if (f00000005WH == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str, _type);
		}
		var f00000005sz =  f00000005WH;
		if (expr != null) f00000005sz &= AstTypeableNode.HorrendousTypeMerge(expr.EnsureType(_collector, f00000005WH, ref _success, _needs_unbox), f00000005WH);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005su) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000005WE_code = (f00000005WE) => {
				_final_block(f00000005WE);
			};
			if (f00000005su.BackingType == typeof(byte[])) {
				var f00000006iU = new GeneratedValue(typeof(long), (f0000000Aai_builder) => {
				if (!typeof(byte[]).IsAssignableFrom(f00000005su.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Bin but got {0} in Ldlen.", Stringish.NameForType(f00000005su.BackingType)));
				_generator.LoadReboxed(f00000005su, typeof(byte[]));
				f0000000Aai_builder.Emit(System.Reflection.Emit.OpCodes.Ldlen);
				f0000000Aai_builder.Emit(System.Reflection.Emit.OpCodes.Conv_I8);
				});
				f00000005WE_code(f00000006iU);
			} else {
				var f00000006Kv = _generator.ToStringish(f00000005su, _source_reference);
				var f00000005st = new GeneratedValue(typeof(long), (f00000008BB_builder) => {
				if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000006Kv.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Callvirt.", Stringish.NameForType(f00000006Kv.BackingType)));
				_generator.LoadReboxed(f00000006Kv, typeof(Flabbergast.Stringish));
				f00000008BB_builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("get_Length"));
				});
				f00000005WE_code(f00000005st);
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expr.GenerateApi(_api_gen, false);
	}
	internal expression_length Clone() {
		var _obj = new expression_length();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expr = expr;
		return _obj;
	}
}
internal class expression_lesser : expression {
	public override string PrettyName { get { return "lesser-than comparison"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005WP = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005WP == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005WP;		return f00000005WP;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005WR = _type & (0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str);
		if (f00000005WR == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str, _type);
		}
		var f00000005tI = f00000005WR;
		for(var f00000005tI_junk = 0; f00000005tI_junk < 2; f00000005tI_junk++) {
			var f00000006LI =  f00000005tI;
			if (left != null) f00000006LI &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005tI, ref _success, true), f00000005tI);
			if (right != null) f00000006LI &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005tI, ref _success, true), f00000005tI);
			f00000005tI &= f00000006LI;
		}
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006L7) => {
			_generator.DebugPosition(this);
			right.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006L8) => {
				_generator.DebugPosition(this);
						var f00000005t9 = _generator.Compare(f00000006L7, f00000006L8, _source_reference);
					if (f00000005t9 != null) {
					var f00000005WO = new GeneratedValue(typeof(bool), (f00000007BP_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000005t9.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_I4.", Stringish.NameForType(f00000005t9.BackingType)));
					_generator.LoadReboxed(f00000005t9, typeof(long));
					f00000007BP_builder.Emit(System.Reflection.Emit.OpCodes.Conv_I4);
					f00000007BP_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, -1);
					f00000007BP_builder.Emit(System.Reflection.Emit.OpCodes.Ceq);
					});
					_final_block(f00000005WO);
					}
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_lesser Clone() {
		var _obj = new expression_lesser();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_lesser_or_equality : expression {
	public override string PrettyName { get { return "lesser-than or equality comparison"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005WZ = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005WZ == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005WZ;		return f00000005WZ;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Wb = _type & (0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str);
		if (f00000005Wb == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str, _type);
		}
		var f00000005tb = f00000005Wb;
		for(var f00000005tb_junk = 0; f00000005tb_junk < 2; f00000005tb_junk++) {
			var f00000006LV =  f00000005tb;
			if (left != null) f00000006LV &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005tb, ref _success, true), f00000005tb);
			if (right != null) f00000006LV &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005tb, ref _success, true), f00000005tb);
			f00000005tb &= f00000006LV;
		}
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006LK) => {
			_generator.DebugPosition(this);
			right.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006LL) => {
				_generator.DebugPosition(this);
						var f00000005tS = _generator.Compare(f00000006LK, f00000006LL, _source_reference);
					if (f00000005tS != null) {
					var f00000005WY = new GeneratedValue(typeof(bool), (f00000007Bd_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000005tS.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Conv_I4.", Stringish.NameForType(f00000005tS.BackingType)));
					_generator.LoadReboxed(f00000005tS, typeof(long));
					f00000007Bd_builder.Emit(System.Reflection.Emit.OpCodes.Conv_I4);
					f00000007Bd_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
					f00000007Bd_builder.Emit(System.Reflection.Emit.OpCodes.Ceq);
					f00000007Bd_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
					f00000007Bd_builder.Emit(System.Reflection.Emit.OpCodes.Ceq);
					});
					_final_block(f00000005WY);
					}
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_lesser_or_equality Clone() {
		var _obj = new expression_lesser_or_equality();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_let : expression {
	public override string PrettyName { get { return "name binding"; } }
	internal System.Collections.Generic.List<named_definition> definitions = new System.Collections.Generic.List<named_definition>();
	internal System.Collections.Generic.Dictionary<string, bool> definitions_dedup = new System.Collections.Generic.Dictionary<string, bool>{};
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (definitions != null) { foreach (var f00000005Wh in definitions) f00000005Wh.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		inner_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, _environment, true);
		if (definitions != null) foreach (var f000000066M in definitions) {
			f000000066M.AddMask(_collector, inner_environment);
		}
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, inner_environment, ref _success); }
		return _return;
	}
	Environment inner_environment;
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Wk =  _type;
		if (expression != null) f00000005Wk &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
		InferredType = f00000005Wk;		return f00000005Wk;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Wm = NameInfo.AnyType;
		if (definitions != null) foreach (var f00000005Wm_item in definitions) f00000005Wm &= f00000005Wm_item.EnsureType(_collector, _type, ref _success, true);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		inner_environment.GenerateLookupCache(_generator, definitions.Select(f00000006rk_item => new System.Tuple<RestrictableType, Generator.ParameterisedBlock<Generator.ParameterisedBlock<LoadableValue>>>(f00000006rk_item.BoundInfo, f00000006rk_block => f00000006rk_item.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006rk_block)))), _cache, _source_reference, _context, _self_frame, (f00000005Wj_context, f00000005Wj_cache) => {
			_generator.DebugPosition(this);
			expression.Generate(_generator, f00000005Wj_cache, _source_reference, f00000005Wj_context, _self_frame, _container_frame, (f00000005ti) => {
				_generator.DebugPosition(this);
			_final_block(f00000005ti);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expression.GenerateApi(_api_gen, false);
		foreach(var f00000005tf in definitions) 			f00000005tf.GenerateApi(_api_gen, false);
	}
	internal expression_let Clone() {
		var _obj = new expression_let();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.definitions.AddRange(definitions);
		foreach(var _element in definitions_dedup.Keys) _obj.definitions_dedup[_element] = true;
		_obj.expression = expression;
		return _obj;
	}
}
internal class expression_list_join : expression {
	public override string PrettyName { get { return "frame concatenation"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Wu = _type & (0 | Flabbergast.Type.Frame);
		if (f00000005Wu == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		var f00000005u5 =  f00000005Wu;
		if (left != null) f00000005u5 &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005Wu, ref _success, true), f00000005Wu);
		if (right != null) f00000005u5 &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005Wu, ref _success, true), f00000005Wu);
		InferredType = f00000005u5;		return f00000005u5;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		left.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f000000066X) => {
			_generator.DebugPosition(this);
			var f000000066W = _generator.MakeField("list_join_new_frame", typeof(MutableFrame));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.LoadTaskMaster();
			_generator.AmendSourceReference(this, "concatenated", _source_reference, null);
			_context.Load(_generator);
			_self_frame.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000066W.Field);
			right.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f000000066Y) => {
				_generator.DebugPosition(this);
				var f00000007Yg = _generator.MakeField("list_join_iterator_inputs", typeof(IAttributeNames[]));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000007Yg.Field);
				int f0000000B7Z_next;
				f0000000B7Z_next = _generator.DefineState();
				f00000007Yg.Load(_generator);
				if (!typeof(IAttributeNames).IsAssignableFrom(f000000066X.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f000000066X.BackingType)));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
				f000000066X.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
				_generator.JumpToState(f0000000B7Z_next);
				_generator.MarkState(f0000000B7Z_next);
				var f00000006at = _generator.MakeField("list_join_iterator_accumulator", typeof(long));
				var f00000006at_start_block = _generator.DefineState();
				var f000000070k = new IntConstant(0);
				_generator.CopyField(f000000070k, f00000006at);
				_generator.JumpToState(f00000006at_start_block);
				_generator.MarkState(f00000006at_start_block);
				var f00000006at_dispatchers = new int[ 2 ];
				for(var f0000000B4L_it = 0; f0000000B4L_it < f00000006at_dispatchers.Length; f0000000B4L_it++) { f00000006at_dispatchers[f0000000B4L_it] = _generator.DefineState(); }
				var f00000006at_iterator = _generator.MakeField("list_join_iterator", typeof(MergeIterator));
				#pragma warning disable 219
				var f00000006at_key = new MethodValue(f00000006at_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
				var f00000006at_ordinal = new MethodValue(f00000006at_iterator, typeof(MergeIterator).GetMethod("get_Position"));
				#pragma warning restore 219
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f00000007Yg.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000006at_dispatchers[1]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000006at_dispatchers[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
				#pragma warning disable 219
				var f00000006at_position = 2;
				#pragma warning restore 219
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006at_iterator.Field);
				var f00000006at_next = _generator.DefineState();
				_generator.JumpToState(f00000006at_next);
				_generator.MarkState(f00000006at_next);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f00000006at_iterator.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
				_generator.MarkState(f00000006at_dispatchers[1]);
				var f00000007Ye = new GeneratedValue(typeof(Flabbergast.Stringish), (f0000000B6p_builder) => {
				if (!typeof(long).IsAssignableFrom(f00000006at_ordinal.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Call.", Stringish.NameForType(f00000006at_ordinal.BackingType)));
				_generator.LoadReboxed(f00000006at_ordinal, typeof(long));
				f0000000B6p_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(TaskMaster).GetMethod("OrdinalName", new System.Type[] { typeof(long) }));
				});
				var f00000008Bc = _generator.MakeField("list_join_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f000000066X.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f000000066X.BackingType)));
				_generator.LoadReboxed(f000000066X, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
				_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000008Bc.Field);
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
				f00000006at_key.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				f00000008Bc.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f00000007Yf = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f00000007Yf, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				if (!typeof(Template).IsAssignableFrom(f000000066W.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f000000066W.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f000000066W.BackingType)));
				f000000066W.Load(_generator);
				f00000007Ye.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
				var f0000000B4X_is_frame = typeof(MutableFrame).IsAssignableFrom(f000000066W.BackingType);
				var f0000000B4X_boxed_type = f0000000B4X_is_frame ? typeof(object) : typeof(ComputeValue);
				_generator.LoadReboxed(f00000007Yf, f0000000B4X_boxed_type);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f000000066W.BackingType.GetMethod(f0000000B4X_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f0000000B4X_boxed_type }));
				_generator.CopyField(f00000006at_ordinal, f00000006at);
				_generator.JumpToState(f00000006at_next);
				f00000006at_position = 2;
				_generator.MarkState(f00000006at_dispatchers[0]);
				var f00000007Yj = _generator.MakeField("list_join_iterator_inputs", typeof(IAttributeNames[]));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000007Yj.Field);
				int f0000000B3g_next;
				f0000000B3g_next = _generator.DefineState();
				f00000007Yj.Load(_generator);
				if (!typeof(IAttributeNames).IsAssignableFrom(f000000066Y.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f000000066Y.BackingType)));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
				f000000066Y.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
				_generator.JumpToState(f0000000B3g_next);
				_generator.MarkState(f0000000B3g_next);
				var f00000006au = _generator.MakeField("list_join_iterator_accumulator", typeof(Flabbergast.MutableFrame));
				var f00000006au_start_block = _generator.DefineState();
				_generator.CopyField(f000000066W, f00000006au);
				_generator.JumpToState(f00000006au_start_block);
				_generator.MarkState(f00000006au_start_block);
				var f00000006au_dispatchers = new int[ 2 ];
				for(var f0000000AqO_it = 0; f0000000AqO_it < f00000006au_dispatchers.Length; f0000000AqO_it++) { f00000006au_dispatchers[f0000000AqO_it] = _generator.DefineState(); }
				var f00000006au_iterator = _generator.MakeField("list_join_iterator", typeof(MergeIterator));
				#pragma warning disable 219
				var f00000006au_key = new MethodValue(f00000006au_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
				var f00000006au_ordinal = new MethodValue(f00000006au_iterator, typeof(MergeIterator).GetMethod("get_Position"));
				#pragma warning restore 219
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f00000007Yj.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000006au_dispatchers[1]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000006au_dispatchers[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
				#pragma warning disable 219
				var f00000006au_position = 2;
				#pragma warning restore 219
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006au_iterator.Field);
				var f00000006au_next = _generator.DefineState();
				_generator.JumpToState(f00000006au_next);
				_generator.MarkState(f00000006au_next);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f00000006au_iterator.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
				_generator.MarkState(f00000006au_dispatchers[1]);
				var f00000008Bh = new GeneratedValue(typeof(long), (f0000000B1M_builder) => {
				if (!typeof(long).IsAssignableFrom(f00000006au_ordinal.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Add.", Stringish.NameForType(f00000006au_ordinal.BackingType)));
				_generator.LoadReboxed(f00000006au_ordinal, typeof(long));
				if (!typeof(long).IsAssignableFrom(f00000006at.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Add.", Stringish.NameForType(f00000006at.BackingType)));
				_generator.LoadReboxed(f00000006at, typeof(long));
				f0000000B1M_builder.Emit(System.Reflection.Emit.OpCodes.Add);
				});
				var f00000007Yh = new GeneratedValue(typeof(Flabbergast.Stringish), (f0000000Azl_builder) => {
				if (!typeof(long).IsAssignableFrom(f00000008Bh.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Call.", Stringish.NameForType(f00000008Bh.BackingType)));
				_generator.LoadReboxed(f00000008Bh, typeof(long));
				f0000000Azl_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(TaskMaster).GetMethod("OrdinalName", new System.Type[] { typeof(long) }));
				});
				var f00000008Bi = _generator.MakeField("list_join_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f000000066Y.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f000000066Y.BackingType)));
				_generator.LoadReboxed(f000000066Y, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
				_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000008Bi.Field);
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
				f00000006au_key.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				f00000008Bi.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f00000007Yi = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f00000007Yi, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				if (!typeof(Template).IsAssignableFrom(f000000066W.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f000000066W.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f000000066W.BackingType)));
				f000000066W.Load(_generator);
				f00000007Yh.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
				var f0000000Ar1_is_frame = typeof(MutableFrame).IsAssignableFrom(f000000066W.BackingType);
				var f0000000Ar1_boxed_type = f0000000Ar1_is_frame ? typeof(object) : typeof(ComputeValue);
				_generator.LoadReboxed(f00000007Yi, f0000000Ar1_boxed_type);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f000000066W.BackingType.GetMethod(f0000000Ar1_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f0000000Ar1_boxed_type }));
				_generator.CopyField(f000000066W, f00000006au);
				_generator.JumpToState(f00000006au_next);
				f00000006au_position = 2;
				_generator.MarkState(f00000006au_dispatchers[0]);
				_final_block(f00000006au);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_list_join Clone() {
		var _obj = new expression_list_join();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_literal_frame : expression {
	public override string PrettyName { get { return "literal frame"; } }
	internal System.Collections.Generic.List<attribute> attributes = new System.Collections.Generic.List<attribute>();
	internal System.Collections.Generic.Dictionary<string, bool> attributes_dedup = new System.Collections.Generic.Dictionary<string, bool>{};
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (attributes != null) { foreach (var f00000005X2 in attributes) f00000005X2.PropagateEnvironment(_collector, _queue, new Environment(f00000005X2.FileName, f00000005X2.StartRow, f00000005X2.StartColumn, f00000005X2.EndRow, f00000005X2.EndColumn, null, false, false), ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005X4 = _type & (0 | Flabbergast.Type.Frame);
		if (f00000005X4 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		InferredType = f00000005X4;		return f00000005X4;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005X3 = _generator.PushSourceReference(this, _source_reference);
		var f00000006M4 = _generator.MakeField("collapse_result", typeof(Flabbergast.MutableFrame));
		var f00000007Yr_label = _generator.DefineState();
		var f00000006j3 = _generator.MakeField("literal_frame_new_frame", typeof(MutableFrame));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
		_generator.LoadTaskMaster();
		_generator.AmendSourceReference(this, "defined", f00000005X3, null);
		_context.Load(_generator);
		_self_frame.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006j3.Field);
		_generator.CopyField(f00000006j3, f00000006M4);
		_generator.JumpToState(f00000007Yr_label);
		foreach (var f00000007Yr_item in attributes) {
			_generator.MarkState(f00000007Yr_label);
			f00000007Yr_label = _generator.DefineState();
			f00000007Yr_item.Generate(_generator, f00000005X3, _context, _self_frame, _container_frame, null, f00000006M4, (f00000007Yr_result) => {
				_generator.CopyField(f00000007Yr_result, f00000006M4);
				_generator.JumpToState(f00000007Yr_label);
			});
		}
		_generator.MarkState(f00000007Yr_label);
		_final_block(f00000006M4);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		foreach(var f00000005X0 in attributes) 			f00000005X0.GenerateApi(_api_gen, _collect_names);
	}
	internal expression_literal_frame Clone() {
		var _obj = new expression_literal_frame();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.attributes.AddRange(attributes);
		foreach(var _element in attributes_dedup.Keys) _obj.attributes_dedup[_element] = true;
		return _obj;
	}
}
internal class expression_literal_list : expression {
	public override string PrettyName { get { return "literal list"; } }
	internal System.Collections.Generic.List<expression> items = new System.Collections.Generic.List<expression>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (items != null) { foreach (var f00000005X9 in items) f00000005X9.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005XB = _type & (0 | Flabbergast.Type.Frame);
		if (f00000005XB == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		InferredType = f00000005XB;		return f00000005XB;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005XD = NameInfo.AnyType;
		if (items != null) foreach (var f00000005XD_item in items) f00000005XD &= f00000005XD_item.EnsureType(_collector, _type, ref _success, _needs_unbox);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005XA = _generator.PushSourceReference(this, _source_reference);
		var f00000007Z3_label = _generator.DefineState();
		var f00000006ME = _generator.MakeField("literal_list_new_frame", typeof(MutableFrame));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
		_generator.LoadTaskMaster();
		_generator.AmendSourceReference(this, "list defined", f00000005XA, null);
		_context.Load(_generator);
		_self_frame.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006ME.Field);
		_generator.JumpToState(f00000007Z3_label);
		for (var f00000007Z3_index = 0; f00000007Z3_index < items.Count; f00000007Z3_index++) {
			_generator.MarkState(f00000007Z3_label);
			f00000007Z3_label = _generator.DefineState();
			items[f00000007Z3_index].Generate(_generator, _cache, f00000005XA, _context, _self_frame, _container_frame, (f00000007Z3_result) => {
				f00000006ME.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I8, (long) f00000007Z3_index + 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(TaskMaster).GetMethod("OrdinalNameStr", new System.Type[] { typeof(long) }));
				_generator.LoadReboxed(f00000007Z3_result, typeof(object));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MutableFrame).GetMethod("Set", new System.Type[] { typeof(string), typeof(object) }));
				_generator.JumpToState(f00000007Z3_label);
			});
		}
		_generator.MarkState(f00000007Z3_label);
		_final_block(f00000006ME);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		foreach(var f00000005X7 in items) 			f00000005X7.GenerateApi(_api_gen, false);
	}
	internal expression_literal_list Clone() {
		var _obj = new expression_literal_list();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.items.AddRange(items);
		return _obj;
	}
}
internal class expression_nan : expression {
	public override string PrettyName { get { return "floating-point not-a-number"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005XG = _type & (0 | Flabbergast.Type.Float);
		if (f00000005XG == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float, _type);
		}
		InferredType = f00000005XG;		return f00000005XG;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005XF = FloatConstant.NAN;
		_final_block(f00000005XF);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_nan Clone() {
		var _obj = new expression_nan();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class expression_negation : expression {
	public override string PrettyName { get { return "numeric negation"; } }
	internal expression expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expr != null) { expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005XQ = _type & (0 | Flabbergast.Type.Float | Flabbergast.Type.Int);
		if (f00000005XQ == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Float | Flabbergast.Type.Int, _type);
		}
		var f00000005ui =  f00000005XQ;
		if (expr != null) f00000005ui &= AstTypeableNode.HorrendousTypeMerge(expr.EnsureType(_collector, f00000005XQ, ref _success, true), f00000005XQ);
		InferredType = f00000005ui;		return f00000005ui;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005uh) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000005XP_code = (f00000005XP) => {
				_final_block(f00000005XP);
			};
			if (f00000005uh.BackingType == typeof(double)) {
				var f00000006jI = new GeneratedValue(typeof(double), (f0000000Abo_builder) => {
				if (!typeof(double).IsAssignableFrom(f00000005uh.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Float but got {0} in Neg.", Stringish.NameForType(f00000005uh.BackingType)));
				_generator.LoadReboxed(f00000005uh, typeof(double));
				f0000000Abo_builder.Emit(System.Reflection.Emit.OpCodes.Neg);
				});
				f00000005XP_code(f00000006jI);
			} else if (f00000005uh.BackingType == typeof(long)) {
				var f00000006jH = new GeneratedValue(typeof(long), (f00000009HI_builder) => {
				if (!typeof(long).IsAssignableFrom(f00000005uh.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Neg.", Stringish.NameForType(f00000005uh.BackingType)));
				_generator.LoadReboxed(f00000005uh, typeof(long));
				f00000009HI_builder.Emit(System.Reflection.Emit.OpCodes.Neg);
				});
				f00000005XP_code(f00000006jH);
			} else {
				throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: numeric negation not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expr.GenerateApi(_api_gen, false);
	}
	internal expression_negation Clone() {
		var _obj = new expression_negation();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expr = expr;
		return _obj;
	}
}
internal class expression_not : expression {
	public override string PrettyName { get { return "logical negation"; } }
	internal expression expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expr != null) { expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Xa = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005Xa == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		var f00000005ux =  f00000005Xa;
		if (expr != null) f00000005ux &= AstTypeableNode.HorrendousTypeMerge(expr.EnsureType(_collector, f00000005Xa, ref _success, true), f00000005Xa);
		InferredType = f00000005ux;		return f00000005ux;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005uw) => {
			_generator.DebugPosition(this);
			var f00000005XZ = new GeneratedValue(typeof(bool), (f00000007D2_builder) => {
			if (!typeof(bool).IsAssignableFrom(f00000005uw.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Bool but got {0} in Ldc_I4_0.", Stringish.NameForType(f00000005uw.BackingType)));
			_generator.LoadReboxed(f00000005uw, typeof(bool));
			f00000007D2_builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			f00000007D2_builder.Emit(System.Reflection.Emit.OpCodes.Ceq);
			});
			_final_block(f00000005XZ);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expr.GenerateApi(_api_gen, false);
	}
	internal expression_not Clone() {
		var _obj = new expression_not();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expr = expr;
		return _obj;
	}
}
internal class expression_null : expression {
	public override string PrettyName { get { return "null value"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Xf = _type & (0 | Flabbergast.Type.Unit);
		if (f00000005Xf == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Unit, _type);
		}
		InferredType = f00000005Xf;		return f00000005Xf;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005Xe = UnitConstant.NULL;
		_final_block(f00000005Xe);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_null Clone() {
		var _obj = new expression_null();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class expression_nullable_lookup : expression {
	public override string PrettyName { get { return "nullable contextual lookup"; } }
	internal expression expression;
	internal System.Collections.Generic.List<identifier> names = new System.Collections.Generic.List<identifier>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Xp = Environment.EnsureIntrinsic(_collector, this, _type, _needs_unbox, ref _success);
		InferredType = f00000005Xp;		return f00000005Xp;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Xr = _type & (0 | Flabbergast.Type.Frame | Flabbergast.Type.Unit);
		if (f00000005Xr == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame | Flabbergast.Type.Unit, _type);
		}
		var f00000005vI =  f00000005Xr;
		if (expression != null) f00000005vI &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, f00000005Xr, ref _success, true), f00000005Xr);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005vD) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000005Xo_code = (f00000005Xo) => {
				_final_block(f00000005Xo);
			};
			if (f00000005vD.BackingType == typeof(Flabbergast.Frame)) {
				var f00000007mF = new GeneratedValue(typeof(Flabbergast.Context), (f0000000ACP_builder) => {
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000005vD.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000005vD.BackingType)));
				_generator.LoadReboxed(f00000005vD, typeof(Flabbergast.Frame));
				f0000000ACP_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("get_Context"));
				});
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				for (var f00000009zs_iter = 0; f00000009zs_iter < names.Count; f00000009zs_iter++) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000009zs_iter);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, names[f00000009zs_iter].ToString());
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				}
				f00000007mF.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f00000007D8 = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f00000007D8, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				Environment.IntrinsicDispatch(_generator, this, f00000007D8, _source_reference, (f00000006jW) => {
					f00000005Xo_code(f00000006jW);
				});
			} else if (f00000005vD.BackingType == typeof(Flabbergast.Unit)) {
				var f00000006jV = UnitConstant.NULL;
				f00000005Xo_code(f00000006jV);
			} else {
				throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: nullable contextual lookup not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expression.GenerateApi(_api_gen, false);
	}
	internal expression_nullable_lookup Clone() {
		var _obj = new expression_nullable_lookup();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expression = expression;
		_obj.names.AddRange(names);
		return _obj;
	}
}
internal class expression_range : expression {
	public override string PrettyName { get { return "integral range"; } }
	internal expression left;
	internal expression right;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (left != null) { left.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (right != null) { right.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Xz = _type & (0 | Flabbergast.Type.Frame);
		if (f00000005Xz == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		InferredType = f00000005Xz;		return f00000005Xz;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005Y1 = _type & (0 | Flabbergast.Type.Int);
		if (f00000005Y1 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		var f00000005vX =  f00000005Y1;
		if (left != null) f00000005vX &= AstTypeableNode.HorrendousTypeMerge(left.EnsureType(_collector, f00000005Y1, ref _success, true), f00000005Y1);
		if (right != null) f00000005vX &= AstTypeableNode.HorrendousTypeMerge(right.EnsureType(_collector, f00000005Y1, ref _success, true), f00000005Y1);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005Xy = _generator.PushSourceReference(this, _source_reference);
		left.Generate(_generator, _cache, f00000005Xy, _context, _self_frame, _container_frame, (f00000006N2) => {
			_generator.DebugPosition(this);
			right.Generate(_generator, _cache, f00000005Xy, _context, _self_frame, _container_frame, (f00000006N1) => {
				_generator.DebugPosition(this);
				var f00000005vO = _generator.MakeField("range_new_frame", typeof(Frame));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.LoadTaskMaster();
				f00000005Xy.Load(_generator);
				f00000006N2.Load(_generator);
				f00000006N1.Load(_generator);
				_context.Load(_generator);
				_self_frame.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("Through", new System.Type[] { typeof(TaskMaster), typeof(SourceReference), typeof(long), typeof(long), typeof(Context), typeof(Frame) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000005vO.Field);
				_final_block(f00000005vO);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		left.GenerateApi(_api_gen, false);
		right.GenerateApi(_api_gen, false);
	}
	internal expression_range Clone() {
		var _obj = new expression_range();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.left = left;
		_obj.right = right;
		return _obj;
	}
}
internal class expression_remote_lookup : expression {
	public override string PrettyName { get { return "remote contextual lookup"; } }
	internal System.Collections.Generic.List<identifier> names = new System.Collections.Generic.List<identifier>();
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Y9 = Environment.EnsureIntrinsic(_collector, this, _type, _needs_unbox, ref _success);
		InferredType = f00000005Y9;		return f00000005Y9;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005YB = _type & (0 | Flabbergast.Type.Frame);
		if (f00000005YB == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		var f00000005vm =  f00000005YB;
		if (expression != null) f00000005vm &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, f00000005YB, ref _success, true), f00000005YB);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006ji) => {
			_generator.DebugPosition(this);
			var f00000006NF = new GeneratedValue(typeof(Flabbergast.Context), (f00000009YT_builder) => {
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000006ji.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000006ji.BackingType)));
			_generator.LoadReboxed(f00000006ji, typeof(Flabbergast.Frame));
			f00000009YT_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("get_Context"));
			});
			_generator.StartInterlock(1);
			_generator.LoadTaskMaster();
			_source_reference.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
			for (var f00000009B1_iter = 0; f00000009B1_iter < names.Count; f00000009B1_iter++) {
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000009B1_iter);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, names[f00000009B1_iter].ToString());
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
			}
			f00000006NF.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
			var f00000005vd = _generator.MakeField("lookup", typeof(object));
			_generator.GenerateConsumeResult(f00000005vd, true);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
			_generator.StopInterlock();
			Environment.IntrinsicDispatch(_generator, this, f00000005vd, _source_reference, (f00000005Y8) => {
				_final_block(f00000005Y8);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expression.GenerateApi(_api_gen, false);
	}
	internal expression_remote_lookup Clone() {
		var _obj = new expression_remote_lookup();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.names.AddRange(names);
		_obj.expression = expression;
		return _obj;
	}
}
internal class expression_string_identifier : expression {
	public override string PrettyName { get { return "string from identifier"; } }
	internal RevCons<char> name = null;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005YE = _type & (0 | Flabbergast.Type.Str);
		if (f00000005YE == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Str, _type);
		}
		InferredType = f00000005YE;		return f00000005YE;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005YD = new StringishValue(Generator.ToString(name));
		_final_block(f00000005YD);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_string_identifier Clone() {
		var _obj = new expression_string_identifier();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		return _obj;
	}
}
internal class expression_string_literal : expression {
	public override string PrettyName { get { return "string literal"; } }
	internal System.Collections.Generic.List<string_piece> parts = new System.Collections.Generic.List<string_piece>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (parts != null) { foreach (var f00000005YJ in parts) f00000005YJ.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005YL = _type & (0 | Flabbergast.Type.Str);
		if (f00000005YL == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Str, _type);
		}
		InferredType = f00000005YL;		return f00000005YL;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005YK = _generator.MakeField("collapse_result", typeof(Flabbergast.Stringish));
		var f000000068N_label = _generator.DefineState();
		var f00000005vv = new StringishValue("");
		_generator.CopyField(f00000005vv, f00000005YK);
		_generator.JumpToState(f000000068N_label);
		foreach (var f000000068N_item in parts) {
			_generator.MarkState(f000000068N_label);
			f000000068N_label = _generator.DefineState();
			f000000068N_item.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, f00000005YK, (f000000068N_result) => {
				_generator.CopyField(f000000068N_result, f00000005YK);
				_generator.JumpToState(f000000068N_label);
			});
		}
		_generator.MarkState(f000000068N_label);
		_final_block(f00000005YK);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		foreach(var f00000005YH in parts) 			f00000005YH.GenerateApi(_api_gen, false);
	}
	internal expression_string_literal Clone() {
		var _obj = new expression_string_literal();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.parts.AddRange(parts);
		return _obj;
	}
}
internal class expression_subexpression : expression {
	public override string PrettyName { get { return "sub-expression"; } }
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005YS =  _type;
		if (expression != null) f00000005YS &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
		InferredType = f00000005YS;		return f00000005YS;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000005YR) => {
			_generator.DebugPosition(this);
			_final_block(f00000005YR);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expression.GenerateApi(_api_gen, false);
	}
	internal expression_subexpression Clone() {
		var _obj = new expression_subexpression();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expression = expression;
		return _obj;
	}
}
internal class expression_template_extend : expression {
	public override string PrettyName { get { return "extend existing template"; } }
	internal expression source;
	internal System.Collections.Generic.List<attribute> overrides = new System.Collections.Generic.List<attribute>();
	internal System.Collections.Generic.Dictionary<string, bool> overrides_dedup = new System.Collections.Generic.Dictionary<string, bool>{};
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (source != null) { source.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (overrides != null) { foreach (var f00000005Yb in overrides) f00000005Yb.PropagateEnvironment(_collector, _queue, new Environment(f00000005Yb.FileName, f00000005Yb.StartRow, f00000005Yb.StartColumn, f00000005Yb.EndRow, f00000005Yb.EndColumn, null, false, false), ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Yd = _type & (0 | Flabbergast.Type.Template);
		if (f00000005Yd == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Template, _type);
		}
		var f00000005wO =  f00000005Yd;
		if (source != null) f00000005wO &= AstTypeableNode.HorrendousTypeMerge(source.EnsureType(_collector, f00000005Yd, ref _success, true), f00000005Yd);
		InferredType = f00000005wO;		return f00000005wO;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005Yc = _generator.PushSourceReference(this, _source_reference);
		source.Generate(_generator, _cache, f00000005Yc, _context, _self_frame, _container_frame, (f00000005wN) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000005wM_code = (f00000005wM) => {
				_final_block(f00000005wM);
			};
			if (f00000005wN.BackingType == typeof(Flabbergast.Template)) {
				var f00000008O4 = _generator.MakeField("template_extend_iterator_inputs", typeof(IAttributeNames[]));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000008O4.Field);
				int f0000000AvH_next;
				f0000000AvH_next = _generator.DefineState();
				f00000008O4.Load(_generator);
				if (!typeof(IAttributeNames).IsAssignableFrom(f00000005wN.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f00000005wN.BackingType)));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
				f00000005wN.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
				_generator.JumpToState(f0000000AvH_next);
				_generator.MarkState(f0000000AvH_next);
				var f00000007E4 = _generator.MakeField("template_extend_iterator_accumulator", typeof(Flabbergast.Template));
				var f00000007E4_start_block = _generator.DefineState();
				var f00000008mf = new GeneratedValue(typeof(Flabbergast.Context), (f0000000Amd_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f00000005wN.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f00000005wN.BackingType)));
				_generator.LoadReboxed(f00000005wN, typeof(Flabbergast.Template));
				f0000000Amd_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("get_Context"));
				});
				var f00000008O3 = _generator.MakeField("template_extend_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Context).IsAssignableFrom(_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(_context.BackingType)));
				_generator.LoadReboxed(_context, typeof(Flabbergast.Context));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(f00000008mf.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(f00000008mf.BackingType)));
				_generator.LoadReboxed(f00000008mf, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Append", new System.Type[] { typeof(Context), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000008O3.Field);
				var f00000007nB = _generator.MakeField("new_template", typeof(Template));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.AmendSourceReference(this, "amend template", f00000005Yc, f00000005wN);
				f00000008O3.Load(_generator);
				_self_frame.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Template).GetConstructors()[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000007nB.Field);
				_generator.CopyField(f00000007nB, f00000007E4);
				_generator.JumpToState(f00000007E4_start_block);
				_generator.MarkState(f00000007E4_start_block);
				var f00000007E4_dispatchers = new int[ 2 + overrides.Count ];
				for(var f00000009as_it = 0; f00000009as_it < f00000007E4_dispatchers.Length; f00000009as_it++) { f00000007E4_dispatchers[f00000009as_it] = _generator.DefineState(); }
				var f00000007E4_iterator = _generator.MakeField("template_extend_iterator", typeof(MergeIterator));
				#pragma warning disable 219
				var f00000007E4_key = new MethodValue(f00000007E4_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
				var f00000007E4_ordinal = new MethodValue(f00000007E4_iterator, typeof(MergeIterator).GetMethod("get_Position"));
				#pragma warning restore 219
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f00000008O4.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000007E4_dispatchers[1]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000007E4_dispatchers[0]);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
				#pragma warning disable 219
				var f00000007E4_position = 2;
				#pragma warning restore 219
				foreach (var f00000008O6 in overrides) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(f00000008O6.name));
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000007E4_dispatchers[f00000007E4_position++]);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("AddDispatcher", new System.Type[] { typeof(string), typeof(int) }));
				}
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000007E4_iterator.Field);
				var f00000007E4_next = _generator.DefineState();
				_generator.JumpToState(f00000007E4_next);
				_generator.MarkState(f00000007E4_next);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				f00000007E4_iterator.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
				_generator.MarkState(f00000007E4_dispatchers[1]);
				var f00000008O2 = new GeneratedValue(typeof(Flabbergast.ComputeValue), (f0000000AAP_builder) => {
				if (!typeof(Flabbergast.Template).IsAssignableFrom(f00000005wN.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Template but got {0} in Call.", Stringish.NameForType(f00000005wN.BackingType)));
				_generator.LoadReboxed(f00000005wN, typeof(Flabbergast.Template));
				if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000007E4_key.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Call.", Stringish.NameForType(f00000007E4_key.BackingType)));
				_generator.LoadReboxed(f00000007E4_key, typeof(Flabbergast.Stringish));
				f0000000AAP_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Template).GetMethod("Get", new System.Type[] { typeof(Stringish) }));
				});
				if (!typeof(Template).IsAssignableFrom(f00000007E4.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000007E4.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000007E4.BackingType)));
				f00000007E4.Load(_generator);
				f00000007E4_key.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
				var f00000009xe_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000007E4.BackingType);
				var f00000009xe_boxed_type = f00000009xe_is_frame ? typeof(object) : typeof(ComputeValue);
				_generator.LoadReboxed(f00000008O2, f00000009xe_boxed_type);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000007E4.BackingType.GetMethod(f00000009xe_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000009xe_boxed_type }));
				_generator.CopyField(f00000007E4, f00000007E4);
				_generator.JumpToState(f00000007E4_next);
				f00000007E4_position = 2;
				foreach (var f00000008O6 in overrides) {
					_generator.MarkState(f00000007E4_dispatchers[f00000007E4_position++]);
					f00000008O6.Generate(_generator, f00000005Yc, _context, _self_frame, _container_frame, f00000005wN, f00000007E4, (f00000008mh) => {
						_generator.DebugPosition(this);
						_generator.CopyField(f00000008mh, f00000007E4);
						_generator.JumpToState(f00000007E4_next);
					});
				}
				_generator.MarkState(f00000007E4_dispatchers[0]);
				f00000005wM_code(f00000007E4);
			} else {
				throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: extend existing template not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		source.GenerateApi(_api_gen, false);
		foreach(var f00000005wJ in overrides) 			f00000005wJ.GenerateApi(_api_gen, _collect_names);
	}
	internal expression_template_extend Clone() {
		var _obj = new expression_template_extend();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.source = source;
		_obj.overrides.AddRange(overrides);
		foreach(var _element in overrides_dedup.Keys) _obj.overrides_dedup[_element] = true;
		return _obj;
	}
}
internal class expression_template_new : expression {
	public override string PrettyName { get { return "define new template"; } }
	internal System.Collections.Generic.List<attribute> attributes = new System.Collections.Generic.List<attribute>();
	internal System.Collections.Generic.Dictionary<string, bool> attributes_dedup = new System.Collections.Generic.Dictionary<string, bool>{};
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (attributes != null) { foreach (var f00000005Yl in attributes) f00000005Yl.PropagateEnvironment(_collector, _queue, new Environment(f00000005Yl.FileName, f00000005Yl.StartRow, f00000005Yl.StartColumn, f00000005Yl.EndRow, f00000005Yl.EndColumn, null, false, false), ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Yn = _type & (0 | Flabbergast.Type.Template);
		if (f00000005Yn == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Template, _type);
		}
		InferredType = f00000005Yn;		return f00000005Yn;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005wa = _generator.MakeField("collapse_result", typeof(Flabbergast.Template));
		var f00000006ck_label = _generator.DefineState();
		var f00000006OE = _generator.MakeField("new_template", typeof(Template));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
		_generator.AmendSourceReference(this, "amend template", _source_reference, null);
		_context.Load(_generator);
		_self_frame.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Template).GetConstructors()[0]);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000006OE.Field);
		_generator.CopyField(f00000006OE, f00000005wa);
		_generator.JumpToState(f00000006ck_label);
		foreach (var f00000006ck_item in attributes) {
			_generator.MarkState(f00000006ck_label);
			f00000006ck_label = _generator.DefineState();
			f00000006ck_item.Generate(_generator, _source_reference, _context, _self_frame, _container_frame, null, f00000005wa, (f00000006ck_result) => {
				_generator.CopyField(f00000006ck_result, f00000005wa);
				_generator.JumpToState(f00000006ck_label);
			});
		}
		_generator.MarkState(f00000006ck_label);
		_final_block(f00000005wa);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		foreach(var f00000005Yj in attributes) 			f00000005Yj.GenerateApi(_api_gen, _collect_names);
	}
	internal expression_template_new Clone() {
		var _obj = new expression_template_new();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.attributes.AddRange(attributes);
		foreach(var _element in attributes_dedup.Keys) _obj.attributes_dedup[_element] = true;
		return _obj;
	}
}
internal class expression_this : expression {
	public override string PrettyName { get { return "current frame"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Yr = _type & (0 | Flabbergast.Type.Frame);
		if (f00000005Yr == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		InferredType = f00000005Yr;		return f00000005Yr;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		_final_block(_self_frame);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_this Clone() {
		var _obj = new expression_this();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class expression_time_literal : expression {
	public override string PrettyName { get { return "time value"; } }
	internal System.Collections.Generic.List<time> parts = new System.Collections.Generic.List<time>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Yw = _type & (0 | Flabbergast.Type.Int);
		if (f00000005Yw == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		InferredType = f00000005Yw;		return f00000005Yw;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005wp = new IntConstant(0);
		_generator.Fold((LoadableValue) f00000005wp, parts, (f00000006OP_index, f00000006OP_item, f00000005Yv_left, f00000006OP_block) => f00000006OP_item.Generate(_generator, _source_reference, f00000005Yv_left, f00000006OP_block), (f00000005Yv) => {
			_final_block(f00000005Yv);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_time_literal Clone() {
		var _obj = new expression_time_literal();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.parts.AddRange(parts);
		return _obj;
	}
}
internal class expression_true : expression {
	public override string PrettyName { get { return "logical truth"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Z1 = _type & (0 | Flabbergast.Type.Bool);
		if (f00000005Z1 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		InferredType = f00000005Z1;		return f00000005Z1;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005Z0 = new BoolConstant(true);
		_final_block(f00000005Z0);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal expression_true Clone() {
		var _obj = new expression_true();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class expression_type_of : expression {
	public override string PrettyName { get { return "type-directed lookup"; } }
	internal expression expression;
	internal System.Collections.Generic.List<identifier> names = new System.Collections.Generic.List<identifier>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005ZB = Environment.EnsureIntrinsic(_collector, this, _type, _needs_unbox, ref _success);
		InferredType = f00000005ZB;		return f00000005ZB;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000005ZD =  _type;
		if (expression != null) f00000005ZD &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, _type, ref _success, true), _type);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000006Oa) => {
			_generator.DebugPosition(this);
			Generator.ParameterisedBlock<LoadableValue> f00000005x4_code = (f00000005x4) => {
				Environment.IntrinsicDispatch(_generator, this, f00000005x4, _source_reference, (f00000005ZA) => {
					_final_block(f00000005ZA);
				});
			};
			if (f00000006Oa.BackingType == typeof(Flabbergast.Template)) {
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count + 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				for (var f0000000Ayu_iter = 0; f0000000Ayu_iter < names.Count; f0000000Ayu_iter++) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f0000000Ayu_iter);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, names[f0000000Ayu_iter].ToString());
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				}
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "template");
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				_context.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f0000000ARX = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f0000000ARX, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				f00000005x4_code(f0000000ARX);
			} else if (f00000006Oa.BackingType == typeof(Flabbergast.Stringish)) {
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count + 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				for (var f0000000Axd_iter = 0; f0000000Axd_iter < names.Count; f0000000Axd_iter++) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f0000000Axd_iter);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, names[f0000000Axd_iter].ToString());
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				}
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "str");
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				_context.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f0000000ARW = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f0000000ARW, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				f00000005x4_code(f0000000ARW);
			} else if (f00000006Oa.BackingType == typeof(Flabbergast.Unit)) {
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count + 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				for (var f0000000Aw7_iter = 0; f0000000Aw7_iter < names.Count; f0000000Aw7_iter++) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f0000000Aw7_iter);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, names[f0000000Aw7_iter].ToString());
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				}
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "null");
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				_context.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f0000000ARV = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f0000000ARV, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				f00000005x4_code(f0000000ARV);
			} else if (f00000006Oa.BackingType == typeof(long)) {
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count + 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				for (var f0000000AuM_iter = 0; f0000000AuM_iter < names.Count; f0000000AuM_iter++) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f0000000AuM_iter);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, names[f0000000AuM_iter].ToString());
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				}
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "int");
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				_context.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f0000000ARU = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f0000000ARU, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				f00000005x4_code(f0000000ARU);
			} else if (f00000006Oa.BackingType == typeof(Flabbergast.Frame)) {
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count + 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				for (var f0000000ArY_iter = 0; f0000000ArY_iter < names.Count; f0000000ArY_iter++) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f0000000ArY_iter);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, names[f0000000ArY_iter].ToString());
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				}
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "frame");
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				_context.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f0000000ART = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f0000000ART, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				f00000005x4_code(f0000000ART);
			} else if (f00000006Oa.BackingType == typeof(double)) {
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count + 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				for (var f0000000ApB_iter = 0; f0000000ApB_iter < names.Count; f0000000ApB_iter++) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f0000000ApB_iter);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, names[f0000000ApB_iter].ToString());
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				}
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "float");
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				_context.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f0000000ARS = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f0000000ARS, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				f00000005x4_code(f0000000ARS);
			} else if (f00000006Oa.BackingType == typeof(bool)) {
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count + 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				for (var f0000000AmI_iter = 0; f0000000AmI_iter < names.Count; f0000000AmI_iter++) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f0000000AmI_iter);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, names[f0000000AmI_iter].ToString());
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				}
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "bool");
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				_context.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f0000000ARR = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f0000000ARR, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				f00000005x4_code(f0000000ARR);
			} else if (f00000006Oa.BackingType == typeof(byte[])) {
				_generator.StartInterlock(1);
				_generator.LoadTaskMaster();
				_source_reference.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count + 1);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
				for (var f0000000Ag6_iter = 0; f0000000Ag6_iter < names.Count; f0000000Ag6_iter++) {
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f0000000Ag6_iter);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, names[f0000000Ag6_iter].ToString());
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				}
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, names.Count);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, "bin");
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
				_context.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
				var f0000000ARQ = _generator.MakeField("lookup", typeof(object));
				_generator.GenerateConsumeResult(f0000000ARQ, true);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
				_generator.StopInterlock();
				f00000005x4_code(f0000000ARQ);
			} else {
				throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: type-directed lookup not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		_api_gen.RegisterUse(names.Select(f00000005x0 => f00000005x0.ToString()), "bin", "bool", "float", "frame", "int", "null", "str", "template");
		expression.GenerateApi(_api_gen, false);
	}
	internal expression_type_of Clone() {
		var _obj = new expression_type_of();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expression = expression;
		_obj.names.AddRange(names);
		return _obj;
	}
}
internal class expression_xcomputation : expression {
	public override string PrettyName { get { return "invoke CLI Flabbergast.Computation class"; } }
	internal RevCons<char> type_name = null;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005ZJ = NameInfo.AnyType;
		var f00000005xG = Environment.EnsureIntrinsic(_collector, this, _type, true, ref _success);
		f00000005ZJ &= f00000005xG;
		System.Type type = System.Type.GetType(Generator.ToString(type_name), false);
		if (type == null) {
			_success = false;
			_collector.ReportRawError(this, "No such type " + type_name + ".");
		} else {
			constructor = type.GetConstructor(new[] { typeof(TaskMaster), typeof(SourceReference), typeof(Context), typeof(Frame), typeof(Frame) });
			if (!typeof(Computation).IsAssignableFrom(type)) {
				_success = false;
				_collector.ReportRawError(this, "Type " + type_name + " does not extend Flabbergast.Computation.");
			}
			if (constructor == null) {
				_success = false;
				_collector.ReportRawError(this, "No valid constructor in type " + type_name + " found.");
			}
		}
		f00000005ZJ &= _type;
		InferredType = f00000005ZJ;		return f00000005ZJ;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		_generator.StartInterlock(1);
		_generator.LoadTaskMaster();
		_source_reference.Load(_generator);
		_context.Load(_generator);
		_self_frame.Load(_generator);
		_container_frame.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, constructor);
		var f00000005xE = _generator.MakeField("xcomputation", typeof(object));
		_generator.GenerateConsumeResult(f00000005xE, true);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Computation).GetMethod("Notify", new[] { typeof(ConsumeResult) }));
		_generator.StopInterlock();
		Environment.IntrinsicDispatch(_generator, this, f00000005xE, _source_reference, (f00000005ZI) => {
			_final_block(f00000005ZI);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
		System.Reflection.ConstructorInfo constructor;	internal expression_xcomputation Clone() {
		var _obj = new expression_xcomputation();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.type_name = type_name;
		return _obj;
	}
}
internal class expression_xfield : expression {
	public override string PrettyName { get { return "access CLI field"; } }
	internal RevCons<char> type_name = null;
	internal RevCons<char> field_name = null;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		Field = ReflectField(_collector, this, Generator.ToString(type_name), Generator.ToString(field_name), ref _success);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005ZT = _type & ((Field == null ? 0 : AstTypeableNode.TypeFromClrType(Field.FieldType)));
		if (f00000005ZT == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, (Field == null ? 0 : AstTypeableNode.TypeFromClrType(Field.FieldType)), _type);
		}
		InferredType = f00000005ZT;		return f00000005ZT;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000005ZS = new StaticFieldValue(Field);
				_final_block(f00000005ZS);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	private System.Reflection.FieldInfo Field;
	internal expression_xfield Clone() {
		var _obj = new expression_xfield();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.type_name = type_name;
		_obj.field_name = field_name;
		return _obj;
	}
}
internal class expression_xinvoke : expression {
	public override string PrettyName { get { return "invoke CLI method"; } }
	internal RevCons<char> type_name = null;
	internal RevCons<char> method_name = null;
	internal System.Collections.Generic.List<expression> arguments = new System.Collections.Generic.List<expression>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (arguments != null) { foreach (var f00000005Zb in arguments) f00000005Zb.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		ReflectMethod(_collector, this, Generator.ToString(type_name), Generator.ToString(method_name), arguments.Count, Methods, ref _success);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000005Ou = CheckReflectedMethod(_collector, this, Methods, arguments, _type, ref _success);
		InferredType = f00000005Ou;		return f00000005Ou;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		_generator.Fold((RevCons<LoadableValue>) null, arguments, (f000000069l_index, f000000069l_item, f000000069l_tail, f000000069l_block) => f000000069l_item.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f000000069l_result) => f000000069l_block(new RevCons<LoadableValue>(f000000069l_result, f000000069l_tail))), (f000000069l_args) => {
			_generator.DebugPosition(this);
			var f00000005Zd = _generator.InvokeNative(_source_reference, Methods, f000000069l_args == null ? new LoadableValue[0] : f000000069l_args.ToArray());
			if (f00000005Zd != null) {
				_final_block(f00000005Zd);
			}
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		foreach(var f00000005ZZ in arguments) 			f00000005ZZ.GenerateApi(_api_gen, false);
	}
	private System.Collections.Generic.List<System.Reflection.MethodInfo> Methods = new System.Collections.Generic.List<System.Reflection.MethodInfo>();
	internal expression_xinvoke Clone() {
		var _obj = new expression_xinvoke();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.type_name = type_name;
		_obj.method_name = method_name;
		_obj.arguments.AddRange(arguments);
		return _obj;
	}
}
internal abstract class file : AstTypeableNode {
	internal RevCons<char> comment = null;
	internal static bool ParseRule_Base(ref ParserPosition position, out file result) {
		position.TraceEnter("file");
		if(position.CheckCache<file>("file", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("any file", "file");		slave_position = position.Clone();
		if (ParseRule_file(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("file", true);
			position.Cache<file>("file", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("file", false);
		position.Cache<file>("file", start_index, null);
		return false;
	}
	internal static bool ParseRule_file(ref ParserPosition _position, out file _result) {
		if(_position.CheckCache<file_file, file>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new file_file();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("file:file");

		bool _sequence_fail_f000000007R = false;
		var _optional_obj_f000000008Q = _obj.Clone();
		ParserPosition _optional_position_f000000008Q = _position.Clone();
		bool _sequence_fail_f000000009t = false;
		while(true) {
			ParserPosition _many_position_f00000000Ec = _position.Clone();
			var _many_obj_f00000000Ec = _obj.Clone();
			bool _alternate_success_f00000000I9 = false;
			ParserPosition _alt_position_f00000000I9 = _position;
			var _alt_obj_f00000000I9 = _obj;
			if (!_alternate_success_f00000000I9) {
				_position = _alt_position_f00000000I9.Clone();
				_obj = _alt_obj_f00000000I9.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000I9 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "file contents");
					_position = _alt_position_f00000000I9;
					_obj = _alt_obj_f00000000I9;
				}
			}
			if (!_alternate_success_f00000000I9) {
				_position = _alt_position_f00000000I9.Clone();
				_obj = _alt_obj_f00000000I9.Clone();
				bool _sequence_fail_f00000000Mw = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "file contents");
					_sequence_fail_f00000000Mw = true;
					goto _sequence_end_f00000000Mw;
				}
				while(true) {
					ParserPosition _many_position_f00000000Se = _position.Clone();
					var _many_obj_f00000000Se = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "file contents");
						_position = _many_position_f00000000Se;
						_obj = _many_obj_f00000000Se;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "file contents");
					_sequence_fail_f00000000Mw = true;
					goto _sequence_end_f00000000Mw;
				}
				_sequence_end_f00000000Mw:
				if (_sequence_fail_f00000000Mw) {
					_position = _alt_position_f00000000I9;
					_obj = _alt_obj_f00000000I9;
				} else {
					_alternate_success_f00000000I9 = true;
				}
			}
			if (_alternate_success_f00000000I9) {
			} else {
				_position = _many_position_f00000000Ec;
				_obj = _many_obj_f00000000Ec;
				break;
			}
		}
		if (_position.Match("Introduction{{{")) {
		} else {
			_position.Update("“Introduction{{{”", "file contents");
			_sequence_fail_f000000009t = true;
			goto _sequence_end_f000000009t;
		}
		while(true) {
			ParserPosition _many_position_f00000000Ee = _position.Clone();
			var _many_obj_f00000000Ee = _obj.Clone();
			if (ParserPosition.ParseIntoList(ref _position, _obj.intro, documentation.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000000Ee;
			_obj = _many_obj_f00000000Ee;
			break;
			}
		}
		if (_position.Match("}}}")) {
		} else {
			_position.Update("“}}}”", "file contents");
			_sequence_fail_f000000009t = true;
			goto _sequence_end_f000000009t;
		}
		_sequence_end_f000000009t:
		if (_sequence_fail_f000000009t) {
			_obj = _optional_obj_f000000008Q;
			_position = _optional_position_f000000008Q;
			goto optional_exit_f000000008Q;
		} else {
			goto optional_exit_f000000008Q;
		}
		optional_exit_f000000008Q:
		bool _first_f000000009v = true;
		while(true) {
			ParserPosition _many_position_f000000009v = _position.Clone();
			var _many_obj_f000000009v = _obj.Clone();
			bool _sequence_fail_f00000000Bg = false;
			while(true) {
				ParserPosition _many_position_f00000000Ek = _position.Clone();
				var _many_obj_f00000000Ek = _obj.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "file contents");
					_position = _many_position_f00000000Ek;
					_obj = _many_obj_f00000000Ek;
					break;
				}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.attributes, (ref ParserPosition _iposition, out attribute _iresult) => { if (attribute.ParseRule_plain_attribute(ref _iposition, out _iresult)) { var f00000000El_key = Generator.ToString(_iresult.name); if (_obj.attributes_dedup.ContainsKey(f00000000El_key)) { _iposition.NameConstraint(f00000000El_key); return false; } else { _obj.attributes_dedup[f00000000El_key] = true; return true; } } else { return false; } })) {
			} else {
			_sequence_fail_f00000000Bg = true;
			goto _sequence_end_f00000000Bg;
			}
			_sequence_end_f00000000Bg:
			if (_sequence_fail_f00000000Bg) {
				_position = _many_position_f000000009v;
				_obj = _many_obj_f000000009v;
				break;
			} else {
			}
			_first_f000000009v = false;
		}
		if (_first_f000000009v) {
			_sequence_fail_f000000007R = true;
			goto _sequence_end_f000000007R;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f000000009w = _position.Clone();
			var _many_obj_f000000009w = _obj.Clone();
			bool _alternate_success_f00000000Bh = false;
			ParserPosition _alt_position_f00000000Bh = _position;
			var _alt_obj_f00000000Bh = _obj;
			if (!_alternate_success_f00000000Bh) {
				_position = _alt_position_f00000000Bh.Clone();
				_obj = _alt_obj_f00000000Bh.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000Bh = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "file contents");
					_position = _alt_position_f00000000Bh;
					_obj = _alt_obj_f00000000Bh;
				}
			}
			if (!_alternate_success_f00000000Bh) {
				_position = _alt_position_f00000000Bh.Clone();
				_obj = _alt_obj_f00000000Bh.Clone();
				bool _sequence_fail_f00000000Eo = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "file contents");
					_sequence_fail_f00000000Eo = true;
					goto _sequence_end_f00000000Eo;
				}
				while(true) {
					ParserPosition _many_position_f00000000IK = _position.Clone();
					var _many_obj_f00000000IK = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "file contents");
						_position = _many_position_f00000000IK;
						_obj = _many_obj_f00000000IK;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "file contents");
					_sequence_fail_f00000000Eo = true;
					goto _sequence_end_f00000000Eo;
				}
				_sequence_end_f00000000Eo:
				if (_sequence_fail_f00000000Eo) {
					_position = _alt_position_f00000000Bh;
					_obj = _alt_obj_f00000000Bh;
				} else {
					_alternate_success_f00000000Bh = true;
				}
			}
			if (_alternate_success_f00000000Bh) {
			} else {
				_position = _many_position_f000000009w;
				_obj = _many_obj_f000000009w;
				break;
			}
		}
		_sequence_end_f000000007R:
		if (_sequence_fail_f000000007R) {
			_position.Cache<file_file>(_start_index, null);
			_position.TraceExit("file:file", false);
			_result = null;
			return false;
		} else {
			_position.Cache<file_file>(_start_index, _obj);
			_position.TraceExit("file:file", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (file)_obj;
			return true;
		}
	}
	public abstract void Generate(Generator _generator, Generator.ParameterisedBlock<LoadableValue> _block);
}
internal class file_file : file {
	public override string PrettyName { get { return "file contents"; } }
	internal System.Collections.Generic.List<documentation> intro = new System.Collections.Generic.List<documentation>();
	internal System.Collections.Generic.List<attribute> attributes = new System.Collections.Generic.List<attribute>();
	internal System.Collections.Generic.Dictionary<string, bool> attributes_dedup = new System.Collections.Generic.Dictionary<string, bool>{};
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (attributes != null) { foreach (var f000000007P in attributes) f000000007P.PropagateEnvironment(_collector, _queue, new Environment(f000000007P.FileName, f000000007P.StartRow, f000000007P.StartColumn, f000000007P.EndRow, f000000007P.EndColumn, null, false, true), ref _success); }
		return _return;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f000000007Q = _generator.PushSourceReference(this, null);
		var f000000009s = _generator.MakeField("collapse_result", typeof(Flabbergast.MutableFrame));
		var f00000000Gy_label = _generator.DefineState();
		var f00000000Ba = _generator.MakeField("file_new_frame", typeof(MutableFrame));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
		_generator.LoadTaskMaster();
		_generator.AmendSourceReference(this, "file-level definition", f000000007Q, null);
		LoadableValue.NULL_LIST.Load(_generator);
		LoadableValue.NULL_FRAME.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000000Ba.Field);
		_generator.CopyField(f00000000Ba, f000000009s);
		_generator.JumpToState(f00000000Gy_label);
		foreach (var f00000000Gy_item in attributes) {
			_generator.MarkState(f00000000Gy_label);
			f00000000Gy_label = _generator.DefineState();
			f00000000Gy_item.Generate(_generator, f000000007Q, null, null, null, null, f000000009s, (f00000000Gy_result) => {
				_generator.CopyField(f00000000Gy_result, f000000009s);
				_generator.JumpToState(f00000000Gy_label);
			});
		}
		_generator.MarkState(f00000000Gy_label);
		_final_block(f000000009s);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		foreach(var f000000008M in intro) 			f000000008M.GenerateApi(_api_gen, _collect_names);
		foreach(var f000000008N in attributes) 			f000000008N.GenerateApi(_api_gen, _collect_names);
	}
	internal file_file Clone() {
		var _obj = new file_file();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.intro.AddRange(intro);
		_obj.attributes.AddRange(attributes);
		foreach(var _element in attributes_dedup.Keys) _obj.attributes_dedup[_element] = true;
		return _obj;
	}
}
internal abstract class fricassee_merge_input : AstTypeableNode, ITypeableElement {
	public abstract Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool needs_unbox);
	internal RevCons<char> comment = null;
	internal RevCons<char> name = null;
	internal void AddMask(ErrorCollector collector, Environment environment) { environment.AddMask(Generator.ToString(name), this); }
	internal abstract void PrepareValue(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _matched_frame, LoadableValue _ordinal, LoadableValue _name, LoadableValue _target_frame);
	internal abstract bool NeedsGeneration { get; }
	internal static bool ParseRule_Base(ref ParserPosition position, out fricassee_merge_input result) {
		position.TraceEnter("fricassee_merge_input");
		if(position.CheckCache<fricassee_merge_input>("fricassee_merge_input", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("any fricassee_merge_input", "fricassee_merge_input");		slave_position = position.Clone();
		if (ParseRule_expr_input(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("fricassee_merge_input", true);
			position.Cache<fricassee_merge_input>("fricassee_merge_input", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_name_input(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("fricassee_merge_input", true);
			position.Cache<fricassee_merge_input>("fricassee_merge_input", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_ordinal_input(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("fricassee_merge_input", true);
			position.Cache<fricassee_merge_input>("fricassee_merge_input", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("fricassee_merge_input", false);
		position.Cache<fricassee_merge_input>("fricassee_merge_input", start_index, null);
		return false;
	}
	internal static bool ParseRule_expr_input(ref ParserPosition _position, out fricassee_merge_input _result) {
		if(_position.CheckCache<fricassee_merge_input_expr_input, fricassee_merge_input>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new fricassee_merge_input_expr_input();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("fricassee_merge_input:expr_input");

		bool _sequence_fail_f00000000Jv = false;
		while(true) {
			ParserPosition _many_position_f00000000WZ = _position.Clone();
			var _many_obj_f00000000WZ = _obj.Clone();
			bool _alternate_success_f00000000da = false;
			ParserPosition _alt_position_f00000000da = _position;
			var _alt_obj_f00000000da = _obj;
			if (!_alternate_success_f00000000da) {
				_position = _alt_position_f00000000da.Clone();
				_obj = _alt_obj_f00000000da.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000da = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée frame input");
					_position = _alt_position_f00000000da;
					_obj = _alt_obj_f00000000da;
				}
			}
			if (!_alternate_success_f00000000da) {
				_position = _alt_position_f00000000da.Clone();
				_obj = _alt_obj_f00000000da.Clone();
				bool _sequence_fail_f00000000nV = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée frame input");
					_sequence_fail_f00000000nV = true;
					goto _sequence_end_f00000000nV;
				}
				while(true) {
					ParserPosition _many_position_f00000000yo = _position.Clone();
					var _many_obj_f00000000yo = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée frame input");
						_position = _many_position_f00000000yo;
						_obj = _many_obj_f00000000yo;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée frame input");
					_sequence_fail_f00000000nV = true;
					goto _sequence_end_f00000000nV;
				}
				_sequence_end_f00000000nV:
				if (_sequence_fail_f00000000nV) {
					_position = _alt_position_f00000000da;
					_obj = _alt_obj_f00000000da;
				} else {
					_alternate_success_f00000000da = true;
				}
			}
			if (_alternate_success_f00000000da) {
			} else {
				_position = _many_position_f00000000WZ;
				_obj = _many_obj_f00000000WZ;
				break;
			}
		}
		bool _sequence_fail_f00000000Wa = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "fricassée frame input");
			_sequence_fail_f00000000Wa = true;
			goto _sequence_end_f00000000Wa;
		}
		while(true) {
			ParserPosition _many_position_f00000000dd = _position.Clone();
			var _many_obj_f00000000dd = _obj.Clone();
			bool _alternate_success_f00000000nZ = false;
			ParserPosition _alt_position_f00000000nZ = _position;
			var _alt_obj_f00000000nZ = _obj;
			if (!_alternate_success_f00000000nZ) {
				_position = _alt_position_f00000000nZ.Clone();
				_obj = _alt_obj_f00000000nZ.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000nZ = true;
				} else {
					_position.Update("character between “a” and “z”", "fricassée frame input");
					_position = _alt_position_f00000000nZ;
					_obj = _alt_obj_f00000000nZ;
				}
			}
			if (!_alternate_success_f00000000nZ) {
				_position = _alt_position_f00000000nZ.Clone();
				_obj = _alt_obj_f00000000nZ.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000nZ = true;
				} else {
					_position.Update("character between “A” and “Z”", "fricassée frame input");
					_position = _alt_position_f00000000nZ;
					_obj = _alt_obj_f00000000nZ;
				}
			}
			if (!_alternate_success_f00000000nZ) {
				_position = _alt_position_f00000000nZ.Clone();
				_obj = _alt_obj_f00000000nZ.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000nZ = true;
				} else {
					_position.Update("character between “0” and “9”", "fricassée frame input");
					_position = _alt_position_f00000000nZ;
					_obj = _alt_obj_f00000000nZ;
				}
			}
			if (!_alternate_success_f00000000nZ) {
				_position = _alt_position_f00000000nZ.Clone();
				_obj = _alt_obj_f00000000nZ.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000nZ = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "fricassée frame input");
					_position = _alt_position_f00000000nZ;
					_obj = _alt_obj_f00000000nZ;
				}
			}
			if (_alternate_success_f00000000nZ) {
			} else {
				_position = _many_position_f00000000dd;
				_obj = _many_obj_f00000000dd;
				break;
			}
		}
		_sequence_end_f00000000Wa:
		if (_sequence_fail_f00000000Wa) {
			_sequence_fail_f00000000Jv = true;
			goto _sequence_end_f00000000Jv;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f00000000Wb = _position.Clone();
			var _many_obj_f00000000Wb = _obj.Clone();
			bool _alternate_success_f00000000de = false;
			ParserPosition _alt_position_f00000000de = _position;
			var _alt_obj_f00000000de = _obj;
			if (!_alternate_success_f00000000de) {
				_position = _alt_position_f00000000de.Clone();
				_obj = _alt_obj_f00000000de.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000de = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée frame input");
					_position = _alt_position_f00000000de;
					_obj = _alt_obj_f00000000de;
				}
			}
			if (!_alternate_success_f00000000de) {
				_position = _alt_position_f00000000de.Clone();
				_obj = _alt_obj_f00000000de.Clone();
				bool _sequence_fail_f00000000ng = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée frame input");
					_sequence_fail_f00000000ng = true;
					goto _sequence_end_f00000000ng;
				}
				while(true) {
					ParserPosition _many_position_f00000000yz = _position.Clone();
					var _many_obj_f00000000yz = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée frame input");
						_position = _many_position_f00000000yz;
						_obj = _many_obj_f00000000yz;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée frame input");
					_sequence_fail_f00000000ng = true;
					goto _sequence_end_f00000000ng;
				}
				_sequence_end_f00000000ng:
				if (_sequence_fail_f00000000ng) {
					_position = _alt_position_f00000000de;
					_obj = _alt_obj_f00000000de;
				} else {
					_alternate_success_f00000000de = true;
				}
			}
			if (_alternate_success_f00000000de) {
			} else {
				_position = _many_position_f00000000Wb;
				_obj = _many_obj_f00000000Wb;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "fricassée frame input");
			_sequence_fail_f00000000Jv = true;
			goto _sequence_end_f00000000Jv;
		}
		while(true) {
			ParserPosition _many_position_f00000000Wd = _position.Clone();
			var _many_obj_f00000000Wd = _obj.Clone();
			bool _alternate_success_f00000000df = false;
			ParserPosition _alt_position_f00000000df = _position;
			var _alt_obj_f00000000df = _obj;
			if (!_alternate_success_f00000000df) {
				_position = _alt_position_f00000000df.Clone();
				_obj = _alt_obj_f00000000df.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000df = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée frame input");
					_position = _alt_position_f00000000df;
					_obj = _alt_obj_f00000000df;
				}
			}
			if (!_alternate_success_f00000000df) {
				_position = _alt_position_f00000000df.Clone();
				_obj = _alt_obj_f00000000df.Clone();
				bool _sequence_fail_f00000000nk = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée frame input");
					_sequence_fail_f00000000nk = true;
					goto _sequence_end_f00000000nk;
				}
				while(true) {
					ParserPosition _many_position_f00000000z5 = _position.Clone();
					var _many_obj_f00000000z5 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée frame input");
						_position = _many_position_f00000000z5;
						_obj = _many_obj_f00000000z5;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée frame input");
					_sequence_fail_f00000000nk = true;
					goto _sequence_end_f00000000nk;
				}
				_sequence_end_f00000000nk:
				if (_sequence_fail_f00000000nk) {
					_position = _alt_position_f00000000df;
					_obj = _alt_obj_f00000000df;
				} else {
					_alternate_success_f00000000df = true;
				}
			}
			if (_alternate_success_f00000000df) {
			} else {
				_position = _many_position_f00000000Wd;
				_obj = _many_obj_f00000000Wd;
				break;
			}
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000000Jv = true;
		goto _sequence_end_f00000000Jv;
		}
		_sequence_end_f00000000Jv:
		if (_sequence_fail_f00000000Jv) {
			_position.Cache<fricassee_merge_input_expr_input>(_start_index, null);
			_position.TraceExit("fricassee_merge_input:expr_input", false);
			_result = null;
			return false;
		} else {
			_position.Cache<fricassee_merge_input_expr_input>(_start_index, _obj);
			_position.TraceExit("fricassee_merge_input:expr_input", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (fricassee_merge_input)_obj;
			return true;
		}
	}
	internal static bool ParseRule_name_input(ref ParserPosition _position, out fricassee_merge_input _result) {
		if(_position.CheckCache<fricassee_merge_input_name_input, fricassee_merge_input>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new fricassee_merge_input_name_input();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("fricassee_merge_input:name_input");

		bool _sequence_fail_f00000000K1 = false;
		while(true) {
			ParserPosition _many_position_f00000000Wo = _position.Clone();
			var _many_obj_f00000000Wo = _obj.Clone();
			bool _alternate_success_f00000000dl = false;
			ParserPosition _alt_position_f00000000dl = _position;
			var _alt_obj_f00000000dl = _obj;
			if (!_alternate_success_f00000000dl) {
				_position = _alt_position_f00000000dl.Clone();
				_obj = _alt_obj_f00000000dl.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000dl = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Name input");
					_position = _alt_position_f00000000dl;
					_obj = _alt_obj_f00000000dl;
				}
			}
			if (!_alternate_success_f00000000dl) {
				_position = _alt_position_f00000000dl.Clone();
				_obj = _alt_obj_f00000000dl.Clone();
				bool _sequence_fail_f00000000nv = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Name input");
					_sequence_fail_f00000000nv = true;
					goto _sequence_end_f00000000nv;
				}
				while(true) {
					ParserPosition _many_position_f00000000zD = _position.Clone();
					var _many_obj_f00000000zD = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Name input");
						_position = _many_position_f00000000zD;
						_obj = _many_obj_f00000000zD;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Name input");
					_sequence_fail_f00000000nv = true;
					goto _sequence_end_f00000000nv;
				}
				_sequence_end_f00000000nv:
				if (_sequence_fail_f00000000nv) {
					_position = _alt_position_f00000000dl;
					_obj = _alt_obj_f00000000dl;
				} else {
					_alternate_success_f00000000dl = true;
				}
			}
			if (_alternate_success_f00000000dl) {
			} else {
				_position = _many_position_f00000000Wo;
				_obj = _many_obj_f00000000Wo;
				break;
			}
		}
		bool _sequence_fail_f00000000Wp = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "fricassée Name input");
			_sequence_fail_f00000000Wp = true;
			goto _sequence_end_f00000000Wp;
		}
		while(true) {
			ParserPosition _many_position_f00000000do = _position.Clone();
			var _many_obj_f00000000do = _obj.Clone();
			bool _alternate_success_f00000000nz = false;
			ParserPosition _alt_position_f00000000nz = _position;
			var _alt_obj_f00000000nz = _obj;
			if (!_alternate_success_f00000000nz) {
				_position = _alt_position_f00000000nz.Clone();
				_obj = _alt_obj_f00000000nz.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000nz = true;
				} else {
					_position.Update("character between “a” and “z”", "fricassée Name input");
					_position = _alt_position_f00000000nz;
					_obj = _alt_obj_f00000000nz;
				}
			}
			if (!_alternate_success_f00000000nz) {
				_position = _alt_position_f00000000nz.Clone();
				_obj = _alt_obj_f00000000nz.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000nz = true;
				} else {
					_position.Update("character between “A” and “Z”", "fricassée Name input");
					_position = _alt_position_f00000000nz;
					_obj = _alt_obj_f00000000nz;
				}
			}
			if (!_alternate_success_f00000000nz) {
				_position = _alt_position_f00000000nz.Clone();
				_obj = _alt_obj_f00000000nz.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000nz = true;
				} else {
					_position.Update("character between “0” and “9”", "fricassée Name input");
					_position = _alt_position_f00000000nz;
					_obj = _alt_obj_f00000000nz;
				}
			}
			if (!_alternate_success_f00000000nz) {
				_position = _alt_position_f00000000nz.Clone();
				_obj = _alt_obj_f00000000nz.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000nz = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "fricassée Name input");
					_position = _alt_position_f00000000nz;
					_obj = _alt_obj_f00000000nz;
				}
			}
			if (_alternate_success_f00000000nz) {
			} else {
				_position = _many_position_f00000000do;
				_obj = _many_obj_f00000000do;
				break;
			}
		}
		_sequence_end_f00000000Wp:
		if (_sequence_fail_f00000000Wp) {
			_sequence_fail_f00000000K1 = true;
			goto _sequence_end_f00000000K1;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f00000000Wq = _position.Clone();
			var _many_obj_f00000000Wq = _obj.Clone();
			bool _alternate_success_f00000000dp = false;
			ParserPosition _alt_position_f00000000dp = _position;
			var _alt_obj_f00000000dp = _obj;
			if (!_alternate_success_f00000000dp) {
				_position = _alt_position_f00000000dp.Clone();
				_obj = _alt_obj_f00000000dp.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000dp = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Name input");
					_position = _alt_position_f00000000dp;
					_obj = _alt_obj_f00000000dp;
				}
			}
			if (!_alternate_success_f00000000dp) {
				_position = _alt_position_f00000000dp.Clone();
				_obj = _alt_obj_f00000000dp.Clone();
				bool _sequence_fail_f00000000o6 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Name input");
					_sequence_fail_f00000000o6 = true;
					goto _sequence_end_f00000000o6;
				}
				while(true) {
					ParserPosition _many_position_f00000000zO = _position.Clone();
					var _many_obj_f00000000zO = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Name input");
						_position = _many_position_f00000000zO;
						_obj = _many_obj_f00000000zO;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Name input");
					_sequence_fail_f00000000o6 = true;
					goto _sequence_end_f00000000o6;
				}
				_sequence_end_f00000000o6:
				if (_sequence_fail_f00000000o6) {
					_position = _alt_position_f00000000dp;
					_obj = _alt_obj_f00000000dp;
				} else {
					_alternate_success_f00000000dp = true;
				}
			}
			if (_alternate_success_f00000000dp) {
			} else {
				_position = _many_position_f00000000Wq;
				_obj = _many_obj_f00000000Wq;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "fricassée Name input");
			_sequence_fail_f00000000K1 = true;
			goto _sequence_end_f00000000K1;
		}
		while(true) {
			ParserPosition _many_position_f00000000Ws = _position.Clone();
			var _many_obj_f00000000Ws = _obj.Clone();
			bool _alternate_success_f00000000dq = false;
			ParserPosition _alt_position_f00000000dq = _position;
			var _alt_obj_f00000000dq = _obj;
			if (!_alternate_success_f00000000dq) {
				_position = _alt_position_f00000000dq.Clone();
				_obj = _alt_obj_f00000000dq.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000dq = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Name input");
					_position = _alt_position_f00000000dq;
					_obj = _alt_obj_f00000000dq;
				}
			}
			if (!_alternate_success_f00000000dq) {
				_position = _alt_position_f00000000dq.Clone();
				_obj = _alt_obj_f00000000dq.Clone();
				bool _sequence_fail_f00000000oA = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Name input");
					_sequence_fail_f00000000oA = true;
					goto _sequence_end_f00000000oA;
				}
				while(true) {
					ParserPosition _many_position_f00000000zU = _position.Clone();
					var _many_obj_f00000000zU = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Name input");
						_position = _many_position_f00000000zU;
						_obj = _many_obj_f00000000zU;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Name input");
					_sequence_fail_f00000000oA = true;
					goto _sequence_end_f00000000oA;
				}
				_sequence_end_f00000000oA:
				if (_sequence_fail_f00000000oA) {
					_position = _alt_position_f00000000dq;
					_obj = _alt_obj_f00000000dq;
				} else {
					_alternate_success_f00000000dq = true;
				}
			}
			if (_alternate_success_f00000000dq) {
			} else {
				_position = _many_position_f00000000Ws;
				_obj = _many_obj_f00000000Ws;
				break;
			}
		}
		if (_position.Match("Name")) {
		} else {
			_position.Update("“Name”", "fricassée Name input");
			_sequence_fail_f00000000K1 = true;
			goto _sequence_end_f00000000K1;
		}
		_sequence_end_f00000000K1:
		if (_sequence_fail_f00000000K1) {
			_position.Cache<fricassee_merge_input_name_input>(_start_index, null);
			_position.TraceExit("fricassee_merge_input:name_input", false);
			_result = null;
			return false;
		} else {
			_position.Cache<fricassee_merge_input_name_input>(_start_index, _obj);
			_position.TraceExit("fricassee_merge_input:name_input", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (fricassee_merge_input)_obj;
			return true;
		}
	}
	internal static bool ParseRule_ordinal_input(ref ParserPosition _position, out fricassee_merge_input _result) {
		if(_position.CheckCache<fricassee_merge_input_ordinal_input, fricassee_merge_input>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new fricassee_merge_input_ordinal_input();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("fricassee_merge_input:ordinal_input");

		bool _sequence_fail_f00000000K7 = false;
		while(true) {
			ParserPosition _many_position_f00000000Wy = _position.Clone();
			var _many_obj_f00000000Wy = _obj.Clone();
			bool _alternate_success_f00000000ds = false;
			ParserPosition _alt_position_f00000000ds = _position;
			var _alt_obj_f00000000ds = _obj;
			if (!_alternate_success_f00000000ds) {
				_position = _alt_position_f00000000ds.Clone();
				_obj = _alt_obj_f00000000ds.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000ds = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Ordinal input");
					_position = _alt_position_f00000000ds;
					_obj = _alt_obj_f00000000ds;
				}
			}
			if (!_alternate_success_f00000000ds) {
				_position = _alt_position_f00000000ds.Clone();
				_obj = _alt_obj_f00000000ds.Clone();
				bool _sequence_fail_f00000000oJ = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Ordinal input");
					_sequence_fail_f00000000oJ = true;
					goto _sequence_end_f00000000oJ;
				}
				while(true) {
					ParserPosition _many_position_f00000000za = _position.Clone();
					var _many_obj_f00000000za = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Ordinal input");
						_position = _many_position_f00000000za;
						_obj = _many_obj_f00000000za;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Ordinal input");
					_sequence_fail_f00000000oJ = true;
					goto _sequence_end_f00000000oJ;
				}
				_sequence_end_f00000000oJ:
				if (_sequence_fail_f00000000oJ) {
					_position = _alt_position_f00000000ds;
					_obj = _alt_obj_f00000000ds;
				} else {
					_alternate_success_f00000000ds = true;
				}
			}
			if (_alternate_success_f00000000ds) {
			} else {
				_position = _many_position_f00000000Wy;
				_obj = _many_obj_f00000000Wy;
				break;
			}
		}
		bool _sequence_fail_f00000000Wz = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "fricassée Ordinal input");
			_sequence_fail_f00000000Wz = true;
			goto _sequence_end_f00000000Wz;
		}
		while(true) {
			ParserPosition _many_position_f00000000dv = _position.Clone();
			var _many_obj_f00000000dv = _obj.Clone();
			bool _alternate_success_f00000000oN = false;
			ParserPosition _alt_position_f00000000oN = _position;
			var _alt_obj_f00000000oN = _obj;
			if (!_alternate_success_f00000000oN) {
				_position = _alt_position_f00000000oN.Clone();
				_obj = _alt_obj_f00000000oN.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000oN = true;
				} else {
					_position.Update("character between “a” and “z”", "fricassée Ordinal input");
					_position = _alt_position_f00000000oN;
					_obj = _alt_obj_f00000000oN;
				}
			}
			if (!_alternate_success_f00000000oN) {
				_position = _alt_position_f00000000oN.Clone();
				_obj = _alt_obj_f00000000oN.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000oN = true;
				} else {
					_position.Update("character between “A” and “Z”", "fricassée Ordinal input");
					_position = _alt_position_f00000000oN;
					_obj = _alt_obj_f00000000oN;
				}
			}
			if (!_alternate_success_f00000000oN) {
				_position = _alt_position_f00000000oN.Clone();
				_obj = _alt_obj_f00000000oN.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000oN = true;
				} else {
					_position.Update("character between “0” and “9”", "fricassée Ordinal input");
					_position = _alt_position_f00000000oN;
					_obj = _alt_obj_f00000000oN;
				}
			}
			if (!_alternate_success_f00000000oN) {
				_position = _alt_position_f00000000oN.Clone();
				_obj = _alt_obj_f00000000oN.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000oN = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "fricassée Ordinal input");
					_position = _alt_position_f00000000oN;
					_obj = _alt_obj_f00000000oN;
				}
			}
			if (_alternate_success_f00000000oN) {
			} else {
				_position = _many_position_f00000000dv;
				_obj = _many_obj_f00000000dv;
				break;
			}
		}
		_sequence_end_f00000000Wz:
		if (_sequence_fail_f00000000Wz) {
			_sequence_fail_f00000000K7 = true;
			goto _sequence_end_f00000000K7;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f00000000X0 = _position.Clone();
			var _many_obj_f00000000X0 = _obj.Clone();
			bool _alternate_success_f00000000dw = false;
			ParserPosition _alt_position_f00000000dw = _position;
			var _alt_obj_f00000000dw = _obj;
			if (!_alternate_success_f00000000dw) {
				_position = _alt_position_f00000000dw.Clone();
				_obj = _alt_obj_f00000000dw.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000dw = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Ordinal input");
					_position = _alt_position_f00000000dw;
					_obj = _alt_obj_f00000000dw;
				}
			}
			if (!_alternate_success_f00000000dw) {
				_position = _alt_position_f00000000dw.Clone();
				_obj = _alt_obj_f00000000dw.Clone();
				bool _sequence_fail_f00000000oU = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Ordinal input");
					_sequence_fail_f00000000oU = true;
					goto _sequence_end_f00000000oU;
				}
				while(true) {
					ParserPosition _many_position_f00000000zl = _position.Clone();
					var _many_obj_f00000000zl = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Ordinal input");
						_position = _many_position_f00000000zl;
						_obj = _many_obj_f00000000zl;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Ordinal input");
					_sequence_fail_f00000000oU = true;
					goto _sequence_end_f00000000oU;
				}
				_sequence_end_f00000000oU:
				if (_sequence_fail_f00000000oU) {
					_position = _alt_position_f00000000dw;
					_obj = _alt_obj_f00000000dw;
				} else {
					_alternate_success_f00000000dw = true;
				}
			}
			if (_alternate_success_f00000000dw) {
			} else {
				_position = _many_position_f00000000X0;
				_obj = _many_obj_f00000000X0;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "fricassée Ordinal input");
			_sequence_fail_f00000000K7 = true;
			goto _sequence_end_f00000000K7;
		}
		while(true) {
			ParserPosition _many_position_f00000000X2 = _position.Clone();
			var _many_obj_f00000000X2 = _obj.Clone();
			bool _alternate_success_f00000000dx = false;
			ParserPosition _alt_position_f00000000dx = _position;
			var _alt_obj_f00000000dx = _obj;
			if (!_alternate_success_f00000000dx) {
				_position = _alt_position_f00000000dx.Clone();
				_obj = _alt_obj_f00000000dx.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000dx = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Ordinal input");
					_position = _alt_position_f00000000dx;
					_obj = _alt_obj_f00000000dx;
				}
			}
			if (!_alternate_success_f00000000dx) {
				_position = _alt_position_f00000000dx.Clone();
				_obj = _alt_obj_f00000000dx.Clone();
				bool _sequence_fail_f00000000oY = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Ordinal input");
					_sequence_fail_f00000000oY = true;
					goto _sequence_end_f00000000oY;
				}
				while(true) {
					ParserPosition _many_position_f00000000zr = _position.Clone();
					var _many_obj_f00000000zr = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Ordinal input");
						_position = _many_position_f00000000zr;
						_obj = _many_obj_f00000000zr;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Ordinal input");
					_sequence_fail_f00000000oY = true;
					goto _sequence_end_f00000000oY;
				}
				_sequence_end_f00000000oY:
				if (_sequence_fail_f00000000oY) {
					_position = _alt_position_f00000000dx;
					_obj = _alt_obj_f00000000dx;
				} else {
					_alternate_success_f00000000dx = true;
				}
			}
			if (_alternate_success_f00000000dx) {
			} else {
				_position = _many_position_f00000000X2;
				_obj = _many_obj_f00000000X2;
				break;
			}
		}
		if (_position.Match("Ordinal")) {
		} else {
			_position.Update("“Ordinal”", "fricassée Ordinal input");
			_sequence_fail_f00000000K7 = true;
			goto _sequence_end_f00000000K7;
		}
		_sequence_end_f00000000K7:
		if (_sequence_fail_f00000000K7) {
			_position.Cache<fricassee_merge_input_ordinal_input>(_start_index, null);
			_position.TraceExit("fricassee_merge_input:ordinal_input", false);
			_result = null;
			return false;
		} else {
			_position.Cache<fricassee_merge_input_ordinal_input>(_start_index, _obj);
			_position.TraceExit("fricassee_merge_input:ordinal_input", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (fricassee_merge_input)_obj;
			return true;
		}
	}
	public abstract void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _block);
}
internal class fricassee_merge_input_expr_input : fricassee_merge_input {
	public override string PrettyName { get { return "fricassée frame input"; } }
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000000Ju = Environment.EnsureIntrinsic(_collector, this, _type, true, ref _success);
		InferredType = f00000000Ju;		return f00000000Ju;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000000Jx = _type & (0 | Flabbergast.Type.Frame);
		if (f00000000Jx == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		var f00000000Ol =  f00000000Jx;
		if (expression != null) f00000000Ol &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, f00000000Jx, ref _success, true), f00000000Jx);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000000Jt) => {
			_generator.DebugPosition(this);
			_final_block(f00000000Jt);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expression.GenerateApi(_api_gen, false);
	}
	internal override void PrepareValue(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _matched_frame, LoadableValue _ordinal, LoadableValue _name, LoadableValue _target_frame) {
		_generator.DebugPosition(this);		var _state = _generator.DefineState();
		var f00000000Oj = new StringishValue(Generator.ToString(name));
		_generator.ConditionalFlow((f00000000nr_cond) => {
			var f00000000Us = new GeneratedValue(typeof(bool), (f00000001LH_builder) => {
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(_matched_frame.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(_matched_frame.BackingType)));
			_generator.LoadReboxed(_matched_frame, typeof(Flabbergast.Frame));
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(_name.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Call.", Stringish.NameForType(_name.BackingType)));
			_generator.LoadReboxed(_name, typeof(Flabbergast.Stringish));
			f00000001LH_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("Has", new System.Type[] { typeof(Stringish) }));
			});
		f00000000nr_cond(f00000000Us);
		}, (f00000000nr_true) => {
			var f00000000bi = _generator.MakeField("expr_input_Call", typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(_matched_frame.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(_matched_frame.BackingType)));
			_generator.LoadReboxed(_matched_frame, typeof(Flabbergast.Frame));
			if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
			_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000000bi.Field);
			_generator.StartInterlock(1);
			_generator.LoadTaskMaster();
			_source_reference.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			_name.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
			f00000000bi.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
			var f00000000Uu = _generator.MakeField("lookup", typeof(object));
			_generator.GenerateConsumeResult(f00000000Uu, true);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
			_generator.StopInterlock();
		f00000000nr_true(f00000000Uu);
		}, (f00000000nr_false) => {
			var f00000000Ut = UnitConstant.NULL;
		f00000000nr_false(f00000000Ut);
		}, (f00000000Ok) => {
			if (!typeof(Template).IsAssignableFrom(_target_frame.BackingType) && !typeof(MutableFrame).IsAssignableFrom(_target_frame.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(_target_frame.BackingType)));
			_target_frame.Load(_generator);
			f00000000Oj.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			var f00000000Wk_is_frame = typeof(MutableFrame).IsAssignableFrom(_target_frame.BackingType);
			var f00000000Wk_boxed_type = f00000000Wk_is_frame ? typeof(object) : typeof(ComputeValue);
			_generator.LoadReboxed(f00000000Ok, f00000000Wk_boxed_type);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, _target_frame.BackingType.GetMethod(f00000000Wk_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000000Wk_boxed_type }));
			_generator.JumpToState(_state);
		});
		_generator.MarkState(_state);
	}
	internal override bool NeedsGeneration { get { return true; } }
	internal fricassee_merge_input_expr_input Clone() {
		var _obj = new fricassee_merge_input_expr_input();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		_obj.expression = expression;
		return _obj;
	}
}
internal class fricassee_merge_input_name_input : fricassee_merge_input {
	public override string PrettyName { get { return "fricassée Name input"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000000K0 = _type & (0 | Flabbergast.Type.Str);
		if (f00000000K0 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Str, _type);
		}
		InferredType = f00000000K0;		return f00000000K0;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: fricassée Name input not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal override void PrepareValue(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _matched_frame, LoadableValue _ordinal, LoadableValue _name, LoadableValue _target_frame) {
		_generator.DebugPosition(this);		var _state = _generator.DefineState();
		var f00000000Oq = new StringishValue(Generator.ToString(name));
		if (!typeof(Template).IsAssignableFrom(_target_frame.BackingType) && !typeof(MutableFrame).IsAssignableFrom(_target_frame.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(_target_frame.BackingType)));
		_target_frame.Load(_generator);
		f00000000Oq.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
		var f00000000Wx_is_frame = typeof(MutableFrame).IsAssignableFrom(_target_frame.BackingType);
		var f00000000Wx_boxed_type = f00000000Wx_is_frame ? typeof(object) : typeof(ComputeValue);
		_generator.LoadReboxed(_name, f00000000Wx_boxed_type);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, _target_frame.BackingType.GetMethod(f00000000Wx_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000000Wx_boxed_type }));
		_generator.JumpToState(_state);
		_generator.MarkState(_state);
	}
	internal override bool NeedsGeneration { get { return false; } }
	internal fricassee_merge_input_name_input Clone() {
		var _obj = new fricassee_merge_input_name_input();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		return _obj;
	}
}
internal class fricassee_merge_input_ordinal_input : fricassee_merge_input {
	public override string PrettyName { get { return "fricassée Ordinal input"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f00000000K6 = _type & (0 | Flabbergast.Type.Int);
		if (f00000000K6 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int, _type);
		}
		InferredType = f00000000K6;		return f00000000K6;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		throw new System.NotImplementedException(System.String.Format("{0}:{1}:{2}-{3}:{4}: fricassée Ordinal input not implemented", FileName, StartRow, StartColumn, EndRow, EndColumn));
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
	}
	internal override void PrepareValue(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _matched_frame, LoadableValue _ordinal, LoadableValue _name, LoadableValue _target_frame) {
		_generator.DebugPosition(this);		var _state = _generator.DefineState();
		var f00000000Ou = new StringishValue(Generator.ToString(name));
		if (!typeof(Template).IsAssignableFrom(_target_frame.BackingType) && !typeof(MutableFrame).IsAssignableFrom(_target_frame.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(_target_frame.BackingType)));
		_target_frame.Load(_generator);
		f00000000Ou.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
		var f00000000X7_is_frame = typeof(MutableFrame).IsAssignableFrom(_target_frame.BackingType);
		var f00000000X7_boxed_type = f00000000X7_is_frame ? typeof(object) : typeof(ComputeValue);
		_generator.LoadReboxed(_ordinal, f00000000X7_boxed_type);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, _target_frame.BackingType.GetMethod(f00000000X7_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000000X7_boxed_type }));
		_generator.JumpToState(_state);
		_generator.MarkState(_state);
	}
	internal override bool NeedsGeneration { get { return false; } }
	internal fricassee_merge_input_ordinal_input Clone() {
		var _obj = new fricassee_merge_input_ordinal_input();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		return _obj;
	}
}
internal abstract class identifier : AstNode {
	internal RevCons<char> comment = null;
	internal static bool ParseRule_Base(ref ParserPosition position, out identifier result) {
		position.TraceEnter("identifier");
		if(position.CheckCache<identifier>("identifier", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("any identifier", "identifier");		slave_position = position.Clone();
		if (ParseRule_literal_identifier(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("identifier", true);
			position.Cache<identifier>("identifier", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("identifier", false);
		position.Cache<identifier>("identifier", start_index, null);
		return false;
	}
	internal static bool ParseRule_literal_identifier(ref ParserPosition _position, out identifier _result) {
		if(_position.CheckCache<identifier_literal_identifier, identifier>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new identifier_literal_identifier();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("identifier:literal_identifier");

		bool _sequence_fail_f0000000096 = false;
		while(true) {
			ParserPosition _many_position_f00000000CV = _position.Clone();
			var _many_obj_f00000000CV = _obj.Clone();
			bool _alternate_success_f00000000FY = false;
			ParserPosition _alt_position_f00000000FY = _position;
			var _alt_obj_f00000000FY = _obj;
			if (!_alternate_success_f00000000FY) {
				_position = _alt_position_f00000000FY.Clone();
				_obj = _alt_obj_f00000000FY.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000FY = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "identifier");
					_position = _alt_position_f00000000FY;
					_obj = _alt_obj_f00000000FY;
				}
			}
			if (!_alternate_success_f00000000FY) {
				_position = _alt_position_f00000000FY.Clone();
				_obj = _alt_obj_f00000000FY.Clone();
				bool _sequence_fail_f00000000KF = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "identifier");
					_sequence_fail_f00000000KF = true;
					goto _sequence_end_f00000000KF;
				}
				while(true) {
					ParserPosition _many_position_f00000000Ox = _position.Clone();
					var _many_obj_f00000000Ox = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "identifier");
						_position = _many_position_f00000000Ox;
						_obj = _many_obj_f00000000Ox;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "identifier");
					_sequence_fail_f00000000KF = true;
					goto _sequence_end_f00000000KF;
				}
				_sequence_end_f00000000KF:
				if (_sequence_fail_f00000000KF) {
					_position = _alt_position_f00000000FY;
					_obj = _alt_obj_f00000000FY;
				} else {
					_alternate_success_f00000000FY = true;
				}
			}
			if (_alternate_success_f00000000FY) {
			} else {
				_position = _many_position_f00000000CV;
				_obj = _many_obj_f00000000CV;
				break;
			}
		}
		bool _sequence_fail_f00000000CW = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "identifier");
			_sequence_fail_f00000000CW = true;
			goto _sequence_end_f00000000CW;
		}
		while(true) {
			ParserPosition _many_position_f00000000Fb = _position.Clone();
			var _many_obj_f00000000Fb = _obj.Clone();
			bool _alternate_success_f00000000KI = false;
			ParserPosition _alt_position_f00000000KI = _position;
			var _alt_obj_f00000000KI = _obj;
			if (!_alternate_success_f00000000KI) {
				_position = _alt_position_f00000000KI.Clone();
				_obj = _alt_obj_f00000000KI.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000KI = true;
				} else {
					_position.Update("character between “a” and “z”", "identifier");
					_position = _alt_position_f00000000KI;
					_obj = _alt_obj_f00000000KI;
				}
			}
			if (!_alternate_success_f00000000KI) {
				_position = _alt_position_f00000000KI.Clone();
				_obj = _alt_obj_f00000000KI.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000KI = true;
				} else {
					_position.Update("character between “A” and “Z”", "identifier");
					_position = _alt_position_f00000000KI;
					_obj = _alt_obj_f00000000KI;
				}
			}
			if (!_alternate_success_f00000000KI) {
				_position = _alt_position_f00000000KI.Clone();
				_obj = _alt_obj_f00000000KI.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000KI = true;
				} else {
					_position.Update("character between “0” and “9”", "identifier");
					_position = _alt_position_f00000000KI;
					_obj = _alt_obj_f00000000KI;
				}
			}
			if (!_alternate_success_f00000000KI) {
				_position = _alt_position_f00000000KI.Clone();
				_obj = _alt_obj_f00000000KI.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000KI = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "identifier");
					_position = _alt_position_f00000000KI;
					_obj = _alt_obj_f00000000KI;
				}
			}
			if (_alternate_success_f00000000KI) {
			} else {
				_position = _many_position_f00000000Fb;
				_obj = _many_obj_f00000000Fb;
				break;
			}
		}
		_sequence_end_f00000000CW:
		if (_sequence_fail_f00000000CW) {
			_sequence_fail_f0000000096 = true;
			goto _sequence_end_f0000000096;
		} else {
		}
		_sequence_end_f0000000096:
		if (_sequence_fail_f0000000096) {
			_position.Cache<identifier_literal_identifier>(_start_index, null);
			_position.TraceExit("identifier:literal_identifier", false);
			_result = null;
			return false;
		} else {
			_position.Cache<identifier_literal_identifier>(_start_index, _obj);
			_position.TraceExit("identifier:literal_identifier", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (identifier)_obj;
			return true;
		}
	}
}
internal class identifier_literal_identifier : identifier {
	public override string PrettyName { get { return "identifier"; } }
	internal RevCons<char> name = null;
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	public override string ToString() { return Generator.ToString(name); }
	internal identifier_literal_identifier Clone() {
		var _obj = new identifier_literal_identifier();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		return _obj;
	}
}
internal abstract class named_definition : AstTypeableNode, ITypeableElement {
	public abstract Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool needs_unbox);
	internal RevCons<char> comment = null;
	internal RevCons<char> name = null;
	internal void AddMask(ErrorCollector collector, Environment environment) { BoundInfo = environment.AddMask(Generator.ToString(name), this); }
	internal RestrictableType BoundInfo;
	internal static bool ParseRule_Base(ref ParserPosition position, out named_definition result) {
		position.TraceEnter("named_definition");
		if(position.CheckCache<named_definition>("named_definition", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("any named_definition", "named_definition");		slave_position = position.Clone();
		if (ParseRule_definition(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("named_definition", true);
			position.Cache<named_definition>("named_definition", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("named_definition", false);
		position.Cache<named_definition>("named_definition", start_index, null);
		return false;
	}
	internal static bool ParseRule_definition(ref ParserPosition _position, out named_definition _result) {
		if(_position.CheckCache<named_definition_definition, named_definition>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new named_definition_definition();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("named_definition:definition");

		bool _sequence_fail_f000000007b = false;
		while(true) {
			ParserPosition _many_position_f00000000AU = _position.Clone();
			var _many_obj_f00000000AU = _obj.Clone();
			bool _alternate_success_f00000000Ce = false;
			ParserPosition _alt_position_f00000000Ce = _position;
			var _alt_obj_f00000000Ce = _obj;
			if (!_alternate_success_f00000000Ce) {
				_position = _alt_position_f00000000Ce.Clone();
				_obj = _alt_obj_f00000000Ce.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000Ce = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "named definition");
					_position = _alt_position_f00000000Ce;
					_obj = _alt_obj_f00000000Ce;
				}
			}
			if (!_alternate_success_f00000000Ce) {
				_position = _alt_position_f00000000Ce.Clone();
				_obj = _alt_obj_f00000000Ce.Clone();
				bool _sequence_fail_f00000000Ff = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "named definition");
					_sequence_fail_f00000000Ff = true;
					goto _sequence_end_f00000000Ff;
				}
				while(true) {
					ParserPosition _many_position_f00000000KR = _position.Clone();
					var _many_obj_f00000000KR = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "named definition");
						_position = _many_position_f00000000KR;
						_obj = _many_obj_f00000000KR;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "named definition");
					_sequence_fail_f00000000Ff = true;
					goto _sequence_end_f00000000Ff;
				}
				_sequence_end_f00000000Ff:
				if (_sequence_fail_f00000000Ff) {
					_position = _alt_position_f00000000Ce;
					_obj = _alt_obj_f00000000Ce;
				} else {
					_alternate_success_f00000000Ce = true;
				}
			}
			if (_alternate_success_f00000000Ce) {
			} else {
				_position = _many_position_f00000000AU;
				_obj = _many_obj_f00000000AU;
				break;
			}
		}
		bool _sequence_fail_f00000000AV = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
		} else {
			_position.Update("character between “a” and “z”", "named definition");
			_sequence_fail_f00000000AV = true;
			goto _sequence_end_f00000000AV;
		}
		while(true) {
			ParserPosition _many_position_f00000000Ch = _position.Clone();
			var _many_obj_f00000000Ch = _obj.Clone();
			bool _alternate_success_f00000000Fj = false;
			ParserPosition _alt_position_f00000000Fj = _position;
			var _alt_obj_f00000000Fj = _obj;
			if (!_alternate_success_f00000000Fj) {
				_position = _alt_position_f00000000Fj.Clone();
				_obj = _alt_obj_f00000000Fj.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000Fj = true;
				} else {
					_position.Update("character between “a” and “z”", "named definition");
					_position = _alt_position_f00000000Fj;
					_obj = _alt_obj_f00000000Fj;
				}
			}
			if (!_alternate_success_f00000000Fj) {
				_position = _alt_position_f00000000Fj.Clone();
				_obj = _alt_obj_f00000000Fj.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000Fj = true;
				} else {
					_position.Update("character between “A” and “Z”", "named definition");
					_position = _alt_position_f00000000Fj;
					_obj = _alt_obj_f00000000Fj;
				}
			}
			if (!_alternate_success_f00000000Fj) {
				_position = _alt_position_f00000000Fj.Clone();
				_obj = _alt_obj_f00000000Fj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000Fj = true;
				} else {
					_position.Update("character between “0” and “9”", "named definition");
					_position = _alt_position_f00000000Fj;
					_obj = _alt_obj_f00000000Fj;
				}
			}
			if (!_alternate_success_f00000000Fj) {
				_position = _alt_position_f00000000Fj.Clone();
				_obj = _alt_obj_f00000000Fj.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.name = new RevCons<char>(_position.PeekLast(), _obj.name);
					_alternate_success_f00000000Fj = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "named definition");
					_position = _alt_position_f00000000Fj;
					_obj = _alt_obj_f00000000Fj;
				}
			}
			if (_alternate_success_f00000000Fj) {
			} else {
				_position = _many_position_f00000000Ch;
				_obj = _many_obj_f00000000Ch;
				break;
			}
		}
		_sequence_end_f00000000AV:
		if (_sequence_fail_f00000000AV) {
			_sequence_fail_f000000007b = true;
			goto _sequence_end_f000000007b;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f00000000AW = _position.Clone();
			var _many_obj_f00000000AW = _obj.Clone();
			bool _alternate_success_f00000000Ci = false;
			ParserPosition _alt_position_f00000000Ci = _position;
			var _alt_obj_f00000000Ci = _obj;
			if (!_alternate_success_f00000000Ci) {
				_position = _alt_position_f00000000Ci.Clone();
				_obj = _alt_obj_f00000000Ci.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000Ci = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "named definition");
					_position = _alt_position_f00000000Ci;
					_obj = _alt_obj_f00000000Ci;
				}
			}
			if (!_alternate_success_f00000000Ci) {
				_position = _alt_position_f00000000Ci.Clone();
				_obj = _alt_obj_f00000000Ci.Clone();
				bool _sequence_fail_f00000000Fq = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "named definition");
					_sequence_fail_f00000000Fq = true;
					goto _sequence_end_f00000000Fq;
				}
				while(true) {
					ParserPosition _many_position_f00000000Kc = _position.Clone();
					var _many_obj_f00000000Kc = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "named definition");
						_position = _many_position_f00000000Kc;
						_obj = _many_obj_f00000000Kc;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "named definition");
					_sequence_fail_f00000000Fq = true;
					goto _sequence_end_f00000000Fq;
				}
				_sequence_end_f00000000Fq:
				if (_sequence_fail_f00000000Fq) {
					_position = _alt_position_f00000000Ci;
					_obj = _alt_obj_f00000000Ci;
				} else {
					_alternate_success_f00000000Ci = true;
				}
			}
			if (_alternate_success_f00000000Ci) {
			} else {
				_position = _many_position_f00000000AW;
				_obj = _many_obj_f00000000AW;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "named definition");
			_sequence_fail_f000000007b = true;
			goto _sequence_end_f000000007b;
		}
		while(true) {
			ParserPosition _many_position_f00000000AY = _position.Clone();
			var _many_obj_f00000000AY = _obj.Clone();
			bool _alternate_success_f00000000Cj = false;
			ParserPosition _alt_position_f00000000Cj = _position;
			var _alt_obj_f00000000Cj = _obj;
			if (!_alternate_success_f00000000Cj) {
				_position = _alt_position_f00000000Cj.Clone();
				_obj = _alt_obj_f00000000Cj.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000Cj = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "named definition");
					_position = _alt_position_f00000000Cj;
					_obj = _alt_obj_f00000000Cj;
				}
			}
			if (!_alternate_success_f00000000Cj) {
				_position = _alt_position_f00000000Cj.Clone();
				_obj = _alt_obj_f00000000Cj.Clone();
				bool _sequence_fail_f00000000Fu = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "named definition");
					_sequence_fail_f00000000Fu = true;
					goto _sequence_end_f00000000Fu;
				}
				while(true) {
					ParserPosition _many_position_f00000000Ki = _position.Clone();
					var _many_obj_f00000000Ki = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "named definition");
						_position = _many_position_f00000000Ki;
						_obj = _many_obj_f00000000Ki;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "named definition");
					_sequence_fail_f00000000Fu = true;
					goto _sequence_end_f00000000Fu;
				}
				_sequence_end_f00000000Fu:
				if (_sequence_fail_f00000000Fu) {
					_position = _alt_position_f00000000Cj;
					_obj = _alt_obj_f00000000Cj;
				} else {
					_alternate_success_f00000000Cj = true;
				}
			}
			if (_alternate_success_f00000000Cj) {
			} else {
				_position = _many_position_f00000000AY;
				_obj = _many_obj_f00000000AY;
				break;
			}
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f000000007b = true;
		goto _sequence_end_f000000007b;
		}
		_sequence_end_f000000007b:
		if (_sequence_fail_f000000007b) {
			_position.Cache<named_definition_definition>(_start_index, null);
			_position.TraceExit("named_definition:definition", false);
			_result = null;
			return false;
		} else {
			_position.Cache<named_definition_definition>(_start_index, _obj);
			_position.TraceExit("named_definition:definition", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (named_definition)_obj;
			return true;
		}
	}
	public abstract void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _block);
}
internal class named_definition_definition : named_definition {
	public override string PrettyName { get { return "named definition"; } }
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	public override Type EnsureType(ErrorCollector _collector, Type _type, ref bool _success, bool _needs_unbox) {

		var f000000007a = _type & (0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Frame | Flabbergast.Type.Int | Flabbergast.Type.Unit | Flabbergast.Type.Str | Flabbergast.Type.Template);
		if (f000000007a == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bin | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Frame | Flabbergast.Type.Int | Flabbergast.Type.Unit | Flabbergast.Type.Str | Flabbergast.Type.Template, _type);
		}
		var f000000008h =  f000000007a;
		if (expression != null) f000000008h &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, f000000007a, ref _success, true), f000000007a);
		InferredType = f000000008h;		return f000000008h;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f000000007Z) => {
			_generator.DebugPosition(this);
			_final_block(f000000007Z);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		_api_gen.CollectEnvironment(Environment);
		expression.GenerateApi(_api_gen, false);
	}
	internal named_definition_definition Clone() {
		var _obj = new named_definition_definition();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.name = name;
		_obj.expression = expression;
		return _obj;
	}
}
internal abstract class repl : AstTypeableNode {
	internal RevCons<char> comment = null;
	internal static bool ParseRule_Base(ref ParserPosition position, out repl result) {
		position.TraceEnter("repl");
		if(position.CheckCache<repl>("repl", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("any repl", "repl");		slave_position = position.Clone();
		if (ParseRule_expr(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("repl", true);
			position.Cache<repl>("repl", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_goto(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("repl", true);
			position.Cache<repl>("repl", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_help(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("repl", true);
			position.Cache<repl>("repl", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_home(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("repl", true);
			position.Cache<repl>("repl", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_ls(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("repl", true);
			position.Cache<repl>("repl", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_quit(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("repl", true);
			position.Cache<repl>("repl", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_trace(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("repl", true);
			position.Cache<repl>("repl", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_up(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("repl", true);
			position.Cache<repl>("repl", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("repl", false);
		position.Cache<repl>("repl", start_index, null);
		return false;
	}
	internal static bool ParseRule_expr(ref ParserPosition _position, out repl _result) {
		if(_position.CheckCache<repl_expr, repl>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new repl_expr();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("repl:expr");

		bool _sequence_fail_f00000001fb = false;
		while(true) {
			ParserPosition _many_position_f00000001pX = _position.Clone();
			var _many_obj_f00000001pX = _obj.Clone();
			bool _alternate_success_f00000001un = false;
			ParserPosition _alt_position_f00000001un = _position;
			var _alt_obj_f00000001un = _obj;
			if (!_alternate_success_f00000001un) {
				_position = _alt_position_f00000001un.Clone();
				_obj = _alt_obj_f00000001un.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001un = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Expression in REPL");
					_position = _alt_position_f00000001un;
					_obj = _alt_obj_f00000001un;
				}
			}
			if (!_alternate_success_f00000001un) {
				_position = _alt_position_f00000001un.Clone();
				_obj = _alt_obj_f00000001un.Clone();
				bool _sequence_fail_f000000023u = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Expression in REPL");
					_sequence_fail_f000000023u = true;
					goto _sequence_end_f000000023u;
				}
				while(true) {
					ParserPosition _many_position_f00000002CE = _position.Clone();
					var _many_obj_f00000002CE = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Expression in REPL");
						_position = _many_position_f00000002CE;
						_obj = _many_obj_f00000002CE;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Expression in REPL");
					_sequence_fail_f000000023u = true;
					goto _sequence_end_f000000023u;
				}
				_sequence_end_f000000023u:
				if (_sequence_fail_f000000023u) {
					_position = _alt_position_f00000001un;
					_obj = _alt_obj_f00000001un;
				} else {
					_alternate_success_f00000001un = true;
				}
			}
			if (_alternate_success_f00000001un) {
			} else {
				_position = _many_position_f00000001pX;
				_obj = _many_obj_f00000001pX;
				break;
			}
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.expr)) {
		} else {
		_sequence_fail_f00000001fb = true;
		goto _sequence_end_f00000001fb;
		}
		while(true) {
			ParserPosition _many_position_f00000001pb = _position.Clone();
			var _many_obj_f00000001pb = _obj.Clone();
			bool _alternate_success_f00000001uo = false;
			ParserPosition _alt_position_f00000001uo = _position;
			var _alt_obj_f00000001uo = _obj;
			if (!_alternate_success_f00000001uo) {
				_position = _alt_position_f00000001uo.Clone();
				_obj = _alt_obj_f00000001uo.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001uo = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Expression in REPL");
					_position = _alt_position_f00000001uo;
					_obj = _alt_obj_f00000001uo;
				}
			}
			if (!_alternate_success_f00000001uo) {
				_position = _alt_position_f00000001uo.Clone();
				_obj = _alt_obj_f00000001uo.Clone();
				bool _sequence_fail_f000000023x = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Expression in REPL");
					_sequence_fail_f000000023x = true;
					goto _sequence_end_f000000023x;
				}
				while(true) {
					ParserPosition _many_position_f00000002CK = _position.Clone();
					var _many_obj_f00000002CK = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Expression in REPL");
						_position = _many_position_f00000002CK;
						_obj = _many_obj_f00000002CK;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Expression in REPL");
					_sequence_fail_f000000023x = true;
					goto _sequence_end_f000000023x;
				}
				_sequence_end_f000000023x:
				if (_sequence_fail_f000000023x) {
					_position = _alt_position_f00000001uo;
					_obj = _alt_obj_f00000001uo;
				} else {
					_alternate_success_f00000001uo = true;
				}
			}
			if (_alternate_success_f00000001uo) {
			} else {
				_position = _many_position_f00000001pb;
				_obj = _many_obj_f00000001pb;
				break;
			}
		}
		_sequence_end_f00000001fb:
		if (_sequence_fail_f00000001fb) {
			_position.Cache<repl_expr>(_start_index, null);
			_position.TraceExit("repl:expr", false);
			_result = null;
			return false;
		} else {
			_position.Cache<repl_expr>(_start_index, _obj);
			_position.TraceExit("repl:expr", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (repl)_obj;
			return true;
		}
	}
	internal static bool ParseRule_goto(ref ParserPosition _position, out repl _result) {
		if(_position.CheckCache<repl_goto, repl>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new repl_goto();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("repl:goto");

		bool _sequence_fail_f00000001fh = false;
		while(true) {
			ParserPosition _many_position_f00000001pk = _position.Clone();
			var _many_obj_f00000001pk = _obj.Clone();
			bool _alternate_success_f00000001uz = false;
			ParserPosition _alt_position_f00000001uz = _position;
			var _alt_obj_f00000001uz = _obj;
			if (!_alternate_success_f00000001uz) {
				_position = _alt_position_f00000001uz.Clone();
				_obj = _alt_obj_f00000001uz.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001uz = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Go in REPL");
					_position = _alt_position_f00000001uz;
					_obj = _alt_obj_f00000001uz;
				}
			}
			if (!_alternate_success_f00000001uz) {
				_position = _alt_position_f00000001uz.Clone();
				_obj = _alt_obj_f00000001uz.Clone();
				bool _sequence_fail_f0000000242 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Go in REPL");
					_sequence_fail_f0000000242 = true;
					goto _sequence_end_f0000000242;
				}
				while(true) {
					ParserPosition _many_position_f00000002CU = _position.Clone();
					var _many_obj_f00000002CU = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Go in REPL");
						_position = _many_position_f00000002CU;
						_obj = _many_obj_f00000002CU;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Go in REPL");
					_sequence_fail_f0000000242 = true;
					goto _sequence_end_f0000000242;
				}
				_sequence_end_f0000000242:
				if (_sequence_fail_f0000000242) {
					_position = _alt_position_f00000001uz;
					_obj = _alt_obj_f00000001uz;
				} else {
					_alternate_success_f00000001uz = true;
				}
			}
			if (_alternate_success_f00000001uz) {
			} else {
				_position = _many_position_f00000001pk;
				_obj = _many_obj_f00000001pk;
				break;
			}
		}
		if (_position.Match("Go")) {
		} else {
			_position.Update("“Go”", "Go in REPL");
			_sequence_fail_f00000001fh = true;
			goto _sequence_end_f00000001fh;
		}
		while(true) {
			ParserPosition _many_position_f00000001pl = _position.Clone();
			var _many_obj_f00000001pl = _obj.Clone();
			bool _alternate_success_f00000001v0 = false;
			ParserPosition _alt_position_f00000001v0 = _position;
			var _alt_obj_f00000001v0 = _obj;
			if (!_alternate_success_f00000001v0) {
				_position = _alt_position_f00000001v0.Clone();
				_obj = _alt_obj_f00000001v0.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001v0 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Go in REPL");
					_position = _alt_position_f00000001v0;
					_obj = _alt_obj_f00000001v0;
				}
			}
			if (!_alternate_success_f00000001v0) {
				_position = _alt_position_f00000001v0.Clone();
				_obj = _alt_obj_f00000001v0.Clone();
				bool _sequence_fail_f0000000246 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Go in REPL");
					_sequence_fail_f0000000246 = true;
					goto _sequence_end_f0000000246;
				}
				while(true) {
					ParserPosition _many_position_f00000002Ca = _position.Clone();
					var _many_obj_f00000002Ca = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Go in REPL");
						_position = _many_position_f00000002Ca;
						_obj = _many_obj_f00000002Ca;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Go in REPL");
					_sequence_fail_f0000000246 = true;
					goto _sequence_end_f0000000246;
				}
				_sequence_end_f0000000246:
				if (_sequence_fail_f0000000246) {
					_position = _alt_position_f00000001v0;
					_obj = _alt_obj_f00000001v0;
				} else {
					_alternate_success_f00000001v0 = true;
				}
			}
			if (_alternate_success_f00000001v0) {
			} else {
				_position = _many_position_f00000001pl;
				_obj = _many_obj_f00000001pl;
				break;
			}
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.expr)) {
		} else {
		_sequence_fail_f00000001fh = true;
		goto _sequence_end_f00000001fh;
		}
		while(true) {
			ParserPosition _many_position_f00000001pp = _position.Clone();
			var _many_obj_f00000001pp = _obj.Clone();
			bool _alternate_success_f00000001v1 = false;
			ParserPosition _alt_position_f00000001v1 = _position;
			var _alt_obj_f00000001v1 = _obj;
			if (!_alternate_success_f00000001v1) {
				_position = _alt_position_f00000001v1.Clone();
				_obj = _alt_obj_f00000001v1.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001v1 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Go in REPL");
					_position = _alt_position_f00000001v1;
					_obj = _alt_obj_f00000001v1;
				}
			}
			if (!_alternate_success_f00000001v1) {
				_position = _alt_position_f00000001v1.Clone();
				_obj = _alt_obj_f00000001v1.Clone();
				bool _sequence_fail_f0000000249 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Go in REPL");
					_sequence_fail_f0000000249 = true;
					goto _sequence_end_f0000000249;
				}
				while(true) {
					ParserPosition _many_position_f00000002Cg = _position.Clone();
					var _many_obj_f00000002Cg = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Go in REPL");
						_position = _many_position_f00000002Cg;
						_obj = _many_obj_f00000002Cg;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Go in REPL");
					_sequence_fail_f0000000249 = true;
					goto _sequence_end_f0000000249;
				}
				_sequence_end_f0000000249:
				if (_sequence_fail_f0000000249) {
					_position = _alt_position_f00000001v1;
					_obj = _alt_obj_f00000001v1;
				} else {
					_alternate_success_f00000001v1 = true;
				}
			}
			if (_alternate_success_f00000001v1) {
			} else {
				_position = _many_position_f00000001pp;
				_obj = _many_obj_f00000001pp;
				break;
			}
		}
		_sequence_end_f00000001fh:
		if (_sequence_fail_f00000001fh) {
			_position.Cache<repl_goto>(_start_index, null);
			_position.TraceExit("repl:goto", false);
			_result = null;
			return false;
		} else {
			_position.Cache<repl_goto>(_start_index, _obj);
			_position.TraceExit("repl:goto", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (repl)_obj;
			return true;
		}
	}
	internal static bool ParseRule_help(ref ParserPosition _position, out repl _result) {
		if(_position.CheckCache<repl_help, repl>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new repl_help();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("repl:help");

		bool _sequence_fail_f00000001fl = false;
		while(true) {
			ParserPosition _many_position_f00000001pz = _position.Clone();
			var _many_obj_f00000001pz = _obj.Clone();
			bool _alternate_success_f00000001v2 = false;
			ParserPosition _alt_position_f00000001v2 = _position;
			var _alt_obj_f00000001v2 = _obj;
			if (!_alternate_success_f00000001v2) {
				_position = _alt_position_f00000001v2.Clone();
				_obj = _alt_obj_f00000001v2.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001v2 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Help in REPL");
					_position = _alt_position_f00000001v2;
					_obj = _alt_obj_f00000001v2;
				}
			}
			if (!_alternate_success_f00000001v2) {
				_position = _alt_position_f00000001v2.Clone();
				_obj = _alt_obj_f00000001v2.Clone();
				bool _sequence_fail_f000000024G = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Help in REPL");
					_sequence_fail_f000000024G = true;
					goto _sequence_end_f000000024G;
				}
				while(true) {
					ParserPosition _many_position_f00000002Cm = _position.Clone();
					var _many_obj_f00000002Cm = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Help in REPL");
						_position = _many_position_f00000002Cm;
						_obj = _many_obj_f00000002Cm;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Help in REPL");
					_sequence_fail_f000000024G = true;
					goto _sequence_end_f000000024G;
				}
				_sequence_end_f000000024G:
				if (_sequence_fail_f000000024G) {
					_position = _alt_position_f00000001v2;
					_obj = _alt_obj_f00000001v2;
				} else {
					_alternate_success_f00000001v2 = true;
				}
			}
			if (_alternate_success_f00000001v2) {
			} else {
				_position = _many_position_f00000001pz;
				_obj = _many_obj_f00000001pz;
				break;
			}
		}
		if (_position.Match("Help")) {
		} else {
			_position.Update("“Help”", "Help in REPL");
			_sequence_fail_f00000001fl = true;
			goto _sequence_end_f00000001fl;
		}
		while(true) {
			ParserPosition _many_position_f00000001q0 = _position.Clone();
			var _many_obj_f00000001q0 = _obj.Clone();
			bool _alternate_success_f00000001v3 = false;
			ParserPosition _alt_position_f00000001v3 = _position;
			var _alt_obj_f00000001v3 = _obj;
			if (!_alternate_success_f00000001v3) {
				_position = _alt_position_f00000001v3.Clone();
				_obj = _alt_obj_f00000001v3.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001v3 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Help in REPL");
					_position = _alt_position_f00000001v3;
					_obj = _alt_obj_f00000001v3;
				}
			}
			if (!_alternate_success_f00000001v3) {
				_position = _alt_position_f00000001v3.Clone();
				_obj = _alt_obj_f00000001v3.Clone();
				bool _sequence_fail_f000000024K = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Help in REPL");
					_sequence_fail_f000000024K = true;
					goto _sequence_end_f000000024K;
				}
				while(true) {
					ParserPosition _many_position_f00000002Cs = _position.Clone();
					var _many_obj_f00000002Cs = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Help in REPL");
						_position = _many_position_f00000002Cs;
						_obj = _many_obj_f00000002Cs;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Help in REPL");
					_sequence_fail_f000000024K = true;
					goto _sequence_end_f000000024K;
				}
				_sequence_end_f000000024K:
				if (_sequence_fail_f000000024K) {
					_position = _alt_position_f00000001v3;
					_obj = _alt_obj_f00000001v3;
				} else {
					_alternate_success_f00000001v3 = true;
				}
			}
			if (_alternate_success_f00000001v3) {
			} else {
				_position = _many_position_f00000001q0;
				_obj = _many_obj_f00000001q0;
				break;
			}
		}
		_sequence_end_f00000001fl:
		if (_sequence_fail_f00000001fl) {
			_position.Cache<repl_help>(_start_index, null);
			_position.TraceExit("repl:help", false);
			_result = null;
			return false;
		} else {
			_position.Cache<repl_help>(_start_index, _obj);
			_position.TraceExit("repl:help", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (repl)_obj;
			return true;
		}
	}
	internal static bool ParseRule_home(ref ParserPosition _position, out repl _result) {
		if(_position.CheckCache<repl_home, repl>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new repl_home();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("repl:home");

		bool _sequence_fail_f00000001fp = false;
		while(true) {
			ParserPosition _many_position_f00000001q5 = _position.Clone();
			var _many_obj_f00000001q5 = _obj.Clone();
			bool _alternate_success_f00000001vC = false;
			ParserPosition _alt_position_f00000001vC = _position;
			var _alt_obj_f00000001vC = _obj;
			if (!_alternate_success_f00000001vC) {
				_position = _alt_position_f00000001vC.Clone();
				_obj = _alt_obj_f00000001vC.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001vC = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Home in REPL");
					_position = _alt_position_f00000001vC;
					_obj = _alt_obj_f00000001vC;
				}
			}
			if (!_alternate_success_f00000001vC) {
				_position = _alt_position_f00000001vC.Clone();
				_obj = _alt_obj_f00000001vC.Clone();
				bool _sequence_fail_f000000024N = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Home in REPL");
					_sequence_fail_f000000024N = true;
					goto _sequence_end_f000000024N;
				}
				while(true) {
					ParserPosition _many_position_f00000002D1 = _position.Clone();
					var _many_obj_f00000002D1 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Home in REPL");
						_position = _many_position_f00000002D1;
						_obj = _many_obj_f00000002D1;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Home in REPL");
					_sequence_fail_f000000024N = true;
					goto _sequence_end_f000000024N;
				}
				_sequence_end_f000000024N:
				if (_sequence_fail_f000000024N) {
					_position = _alt_position_f00000001vC;
					_obj = _alt_obj_f00000001vC;
				} else {
					_alternate_success_f00000001vC = true;
				}
			}
			if (_alternate_success_f00000001vC) {
			} else {
				_position = _many_position_f00000001q5;
				_obj = _many_obj_f00000001q5;
				break;
			}
		}
		if (_position.Match("Home")) {
		} else {
			_position.Update("“Home”", "Home in REPL");
			_sequence_fail_f00000001fp = true;
			goto _sequence_end_f00000001fp;
		}
		while(true) {
			ParserPosition _many_position_f00000001q6 = _position.Clone();
			var _many_obj_f00000001q6 = _obj.Clone();
			bool _alternate_success_f00000001vD = false;
			ParserPosition _alt_position_f00000001vD = _position;
			var _alt_obj_f00000001vD = _obj;
			if (!_alternate_success_f00000001vD) {
				_position = _alt_position_f00000001vD.Clone();
				_obj = _alt_obj_f00000001vD.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001vD = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Home in REPL");
					_position = _alt_position_f00000001vD;
					_obj = _alt_obj_f00000001vD;
				}
			}
			if (!_alternate_success_f00000001vD) {
				_position = _alt_position_f00000001vD.Clone();
				_obj = _alt_obj_f00000001vD.Clone();
				bool _sequence_fail_f000000024R = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Home in REPL");
					_sequence_fail_f000000024R = true;
					goto _sequence_end_f000000024R;
				}
				while(true) {
					ParserPosition _many_position_f00000002D7 = _position.Clone();
					var _many_obj_f00000002D7 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Home in REPL");
						_position = _many_position_f00000002D7;
						_obj = _many_obj_f00000002D7;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Home in REPL");
					_sequence_fail_f000000024R = true;
					goto _sequence_end_f000000024R;
				}
				_sequence_end_f000000024R:
				if (_sequence_fail_f000000024R) {
					_position = _alt_position_f00000001vD;
					_obj = _alt_obj_f00000001vD;
				} else {
					_alternate_success_f00000001vD = true;
				}
			}
			if (_alternate_success_f00000001vD) {
			} else {
				_position = _many_position_f00000001q6;
				_obj = _many_obj_f00000001q6;
				break;
			}
		}
		_sequence_end_f00000001fp:
		if (_sequence_fail_f00000001fp) {
			_position.Cache<repl_home>(_start_index, null);
			_position.TraceExit("repl:home", false);
			_result = null;
			return false;
		} else {
			_position.Cache<repl_home>(_start_index, _obj);
			_position.TraceExit("repl:home", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (repl)_obj;
			return true;
		}
	}
	internal static bool ParseRule_ls(ref ParserPosition _position, out repl _result) {
		if(_position.CheckCache<repl_ls, repl>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new repl_ls();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("repl:ls");

		bool _sequence_fail_f00000001fv = false;
		while(true) {
			ParserPosition _many_position_f00000001qB = _position.Clone();
			var _many_obj_f00000001qB = _obj.Clone();
			bool _alternate_success_f00000001vK = false;
			ParserPosition _alt_position_f00000001vK = _position;
			var _alt_obj_f00000001vK = _obj;
			if (!_alternate_success_f00000001vK) {
				_position = _alt_position_f00000001vK.Clone();
				_obj = _alt_obj_f00000001vK.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001vK = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Ls in REPL");
					_position = _alt_position_f00000001vK;
					_obj = _alt_obj_f00000001vK;
				}
			}
			if (!_alternate_success_f00000001vK) {
				_position = _alt_position_f00000001vK.Clone();
				_obj = _alt_obj_f00000001vK.Clone();
				bool _sequence_fail_f000000024V = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Ls in REPL");
					_sequence_fail_f000000024V = true;
					goto _sequence_end_f000000024V;
				}
				while(true) {
					ParserPosition _many_position_f00000002DH = _position.Clone();
					var _many_obj_f00000002DH = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Ls in REPL");
						_position = _many_position_f00000002DH;
						_obj = _many_obj_f00000002DH;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Ls in REPL");
					_sequence_fail_f000000024V = true;
					goto _sequence_end_f000000024V;
				}
				_sequence_end_f000000024V:
				if (_sequence_fail_f000000024V) {
					_position = _alt_position_f00000001vK;
					_obj = _alt_obj_f00000001vK;
				} else {
					_alternate_success_f00000001vK = true;
				}
			}
			if (_alternate_success_f00000001vK) {
			} else {
				_position = _many_position_f00000001qB;
				_obj = _many_obj_f00000001qB;
				break;
			}
		}
		if (_position.Match("Ls")) {
		} else {
			_position.Update("“Ls”", "Ls in REPL");
			_sequence_fail_f00000001fv = true;
			goto _sequence_end_f00000001fv;
		}
		while(true) {
			ParserPosition _many_position_f00000001qC = _position.Clone();
			var _many_obj_f00000001qC = _obj.Clone();
			bool _alternate_success_f00000001vL = false;
			ParserPosition _alt_position_f00000001vL = _position;
			var _alt_obj_f00000001vL = _obj;
			if (!_alternate_success_f00000001vL) {
				_position = _alt_position_f00000001vL.Clone();
				_obj = _alt_obj_f00000001vL.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001vL = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Ls in REPL");
					_position = _alt_position_f00000001vL;
					_obj = _alt_obj_f00000001vL;
				}
			}
			if (!_alternate_success_f00000001vL) {
				_position = _alt_position_f00000001vL.Clone();
				_obj = _alt_obj_f00000001vL.Clone();
				bool _sequence_fail_f000000024Z = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Ls in REPL");
					_sequence_fail_f000000024Z = true;
					goto _sequence_end_f000000024Z;
				}
				while(true) {
					ParserPosition _many_position_f00000002DN = _position.Clone();
					var _many_obj_f00000002DN = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Ls in REPL");
						_position = _many_position_f00000002DN;
						_obj = _many_obj_f00000002DN;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Ls in REPL");
					_sequence_fail_f000000024Z = true;
					goto _sequence_end_f000000024Z;
				}
				_sequence_end_f000000024Z:
				if (_sequence_fail_f000000024Z) {
					_position = _alt_position_f00000001vL;
					_obj = _alt_obj_f00000001vL;
				} else {
					_alternate_success_f00000001vL = true;
				}
			}
			if (_alternate_success_f00000001vL) {
			} else {
				_position = _many_position_f00000001qC;
				_obj = _many_obj_f00000001qC;
				break;
			}
		}
		_sequence_end_f00000001fv:
		if (_sequence_fail_f00000001fv) {
			_position.Cache<repl_ls>(_start_index, null);
			_position.TraceExit("repl:ls", false);
			_result = null;
			return false;
		} else {
			_position.Cache<repl_ls>(_start_index, _obj);
			_position.TraceExit("repl:ls", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (repl)_obj;
			return true;
		}
	}
	internal static bool ParseRule_quit(ref ParserPosition _position, out repl _result) {
		if(_position.CheckCache<repl_quit, repl>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new repl_quit();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("repl:quit");

		bool _sequence_fail_f00000001fz = false;
		while(true) {
			ParserPosition _many_position_f00000001qG = _position.Clone();
			var _many_obj_f00000001qG = _obj.Clone();
			bool _alternate_success_f00000001vM = false;
			ParserPosition _alt_position_f00000001vM = _position;
			var _alt_obj_f00000001vM = _obj;
			if (!_alternate_success_f00000001vM) {
				_position = _alt_position_f00000001vM.Clone();
				_obj = _alt_obj_f00000001vM.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001vM = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Quit in REPL");
					_position = _alt_position_f00000001vM;
					_obj = _alt_obj_f00000001vM;
				}
			}
			if (!_alternate_success_f00000001vM) {
				_position = _alt_position_f00000001vM.Clone();
				_obj = _alt_obj_f00000001vM.Clone();
				bool _sequence_fail_f000000024c = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Quit in REPL");
					_sequence_fail_f000000024c = true;
					goto _sequence_end_f000000024c;
				}
				while(true) {
					ParserPosition _many_position_f00000002DT = _position.Clone();
					var _many_obj_f00000002DT = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Quit in REPL");
						_position = _many_position_f00000002DT;
						_obj = _many_obj_f00000002DT;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Quit in REPL");
					_sequence_fail_f000000024c = true;
					goto _sequence_end_f000000024c;
				}
				_sequence_end_f000000024c:
				if (_sequence_fail_f000000024c) {
					_position = _alt_position_f00000001vM;
					_obj = _alt_obj_f00000001vM;
				} else {
					_alternate_success_f00000001vM = true;
				}
			}
			if (_alternate_success_f00000001vM) {
			} else {
				_position = _many_position_f00000001qG;
				_obj = _many_obj_f00000001qG;
				break;
			}
		}
		if (_position.Match("Quit")) {
		} else {
			_position.Update("“Quit”", "Quit in REPL");
			_sequence_fail_f00000001fz = true;
			goto _sequence_end_f00000001fz;
		}
		while(true) {
			ParserPosition _many_position_f00000001qH = _position.Clone();
			var _many_obj_f00000001qH = _obj.Clone();
			bool _alternate_success_f00000001vN = false;
			ParserPosition _alt_position_f00000001vN = _position;
			var _alt_obj_f00000001vN = _obj;
			if (!_alternate_success_f00000001vN) {
				_position = _alt_position_f00000001vN.Clone();
				_obj = _alt_obj_f00000001vN.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001vN = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Quit in REPL");
					_position = _alt_position_f00000001vN;
					_obj = _alt_obj_f00000001vN;
				}
			}
			if (!_alternate_success_f00000001vN) {
				_position = _alt_position_f00000001vN.Clone();
				_obj = _alt_obj_f00000001vN.Clone();
				bool _sequence_fail_f000000024g = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Quit in REPL");
					_sequence_fail_f000000024g = true;
					goto _sequence_end_f000000024g;
				}
				while(true) {
					ParserPosition _many_position_f00000002DZ = _position.Clone();
					var _many_obj_f00000002DZ = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Quit in REPL");
						_position = _many_position_f00000002DZ;
						_obj = _many_obj_f00000002DZ;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Quit in REPL");
					_sequence_fail_f000000024g = true;
					goto _sequence_end_f000000024g;
				}
				_sequence_end_f000000024g:
				if (_sequence_fail_f000000024g) {
					_position = _alt_position_f00000001vN;
					_obj = _alt_obj_f00000001vN;
				} else {
					_alternate_success_f00000001vN = true;
				}
			}
			if (_alternate_success_f00000001vN) {
			} else {
				_position = _many_position_f00000001qH;
				_obj = _many_obj_f00000001qH;
				break;
			}
		}
		_sequence_end_f00000001fz:
		if (_sequence_fail_f00000001fz) {
			_position.Cache<repl_quit>(_start_index, null);
			_position.TraceExit("repl:quit", false);
			_result = null;
			return false;
		} else {
			_position.Cache<repl_quit>(_start_index, _obj);
			_position.TraceExit("repl:quit", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (repl)_obj;
			return true;
		}
	}
	internal static bool ParseRule_trace(ref ParserPosition _position, out repl _result) {
		if(_position.CheckCache<repl_trace, repl>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new repl_trace();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("repl:trace");

		bool _sequence_fail_f00000001g3 = false;
		while(true) {
			ParserPosition _many_position_f00000001qQ = _position.Clone();
			var _many_obj_f00000001qQ = _obj.Clone();
			bool _alternate_success_f00000001vO = false;
			ParserPosition _alt_position_f00000001vO = _position;
			var _alt_obj_f00000001vO = _obj;
			if (!_alternate_success_f00000001vO) {
				_position = _alt_position_f00000001vO.Clone();
				_obj = _alt_obj_f00000001vO.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001vO = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Trace in REPL");
					_position = _alt_position_f00000001vO;
					_obj = _alt_obj_f00000001vO;
				}
			}
			if (!_alternate_success_f00000001vO) {
				_position = _alt_position_f00000001vO.Clone();
				_obj = _alt_obj_f00000001vO.Clone();
				bool _sequence_fail_f000000024j = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Trace in REPL");
					_sequence_fail_f000000024j = true;
					goto _sequence_end_f000000024j;
				}
				while(true) {
					ParserPosition _many_position_f00000002Df = _position.Clone();
					var _many_obj_f00000002Df = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Trace in REPL");
						_position = _many_position_f00000002Df;
						_obj = _many_obj_f00000002Df;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Trace in REPL");
					_sequence_fail_f000000024j = true;
					goto _sequence_end_f000000024j;
				}
				_sequence_end_f000000024j:
				if (_sequence_fail_f000000024j) {
					_position = _alt_position_f00000001vO;
					_obj = _alt_obj_f00000001vO;
				} else {
					_alternate_success_f00000001vO = true;
				}
			}
			if (_alternate_success_f00000001vO) {
			} else {
				_position = _many_position_f00000001qQ;
				_obj = _many_obj_f00000001qQ;
				break;
			}
		}
		if (_position.Match("Trace")) {
		} else {
			_position.Update("“Trace”", "Trace in REPL");
			_sequence_fail_f00000001g3 = true;
			goto _sequence_end_f00000001g3;
		}
		while(true) {
			ParserPosition _many_position_f00000001qR = _position.Clone();
			var _many_obj_f00000001qR = _obj.Clone();
			bool _alternate_success_f00000001vP = false;
			ParserPosition _alt_position_f00000001vP = _position;
			var _alt_obj_f00000001vP = _obj;
			if (!_alternate_success_f00000001vP) {
				_position = _alt_position_f00000001vP.Clone();
				_obj = _alt_obj_f00000001vP.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001vP = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Trace in REPL");
					_position = _alt_position_f00000001vP;
					_obj = _alt_obj_f00000001vP;
				}
			}
			if (!_alternate_success_f00000001vP) {
				_position = _alt_position_f00000001vP.Clone();
				_obj = _alt_obj_f00000001vP.Clone();
				bool _sequence_fail_f000000024n = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Trace in REPL");
					_sequence_fail_f000000024n = true;
					goto _sequence_end_f000000024n;
				}
				while(true) {
					ParserPosition _many_position_f00000002Dl = _position.Clone();
					var _many_obj_f00000002Dl = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Trace in REPL");
						_position = _many_position_f00000002Dl;
						_obj = _many_obj_f00000002Dl;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Trace in REPL");
					_sequence_fail_f000000024n = true;
					goto _sequence_end_f000000024n;
				}
				_sequence_end_f000000024n:
				if (_sequence_fail_f000000024n) {
					_position = _alt_position_f00000001vP;
					_obj = _alt_obj_f00000001vP;
				} else {
					_alternate_success_f00000001vP = true;
				}
			}
			if (_alternate_success_f00000001vP) {
			} else {
				_position = _many_position_f00000001qR;
				_obj = _many_obj_f00000001qR;
				break;
			}
		}
		_sequence_end_f00000001g3:
		if (_sequence_fail_f00000001g3) {
			_position.Cache<repl_trace>(_start_index, null);
			_position.TraceExit("repl:trace", false);
			_result = null;
			return false;
		} else {
			_position.Cache<repl_trace>(_start_index, _obj);
			_position.TraceExit("repl:trace", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (repl)_obj;
			return true;
		}
	}
	internal static bool ParseRule_up(ref ParserPosition _position, out repl _result) {
		if(_position.CheckCache<repl_up, repl>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new repl_up();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("repl:up");

		bool _sequence_fail_f00000001g7 = false;
		while(true) {
			ParserPosition _many_position_f00000001qW = _position.Clone();
			var _many_obj_f00000001qW = _obj.Clone();
			bool _alternate_success_f00000001vY = false;
			ParserPosition _alt_position_f00000001vY = _position;
			var _alt_obj_f00000001vY = _obj;
			if (!_alternate_success_f00000001vY) {
				_position = _alt_position_f00000001vY.Clone();
				_obj = _alt_obj_f00000001vY.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001vY = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Up in REPL");
					_position = _alt_position_f00000001vY;
					_obj = _alt_obj_f00000001vY;
				}
			}
			if (!_alternate_success_f00000001vY) {
				_position = _alt_position_f00000001vY.Clone();
				_obj = _alt_obj_f00000001vY.Clone();
				bool _sequence_fail_f000000024q = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Up in REPL");
					_sequence_fail_f000000024q = true;
					goto _sequence_end_f000000024q;
				}
				while(true) {
					ParserPosition _many_position_f00000002Du = _position.Clone();
					var _many_obj_f00000002Du = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Up in REPL");
						_position = _many_position_f00000002Du;
						_obj = _many_obj_f00000002Du;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Up in REPL");
					_sequence_fail_f000000024q = true;
					goto _sequence_end_f000000024q;
				}
				_sequence_end_f000000024q:
				if (_sequence_fail_f000000024q) {
					_position = _alt_position_f00000001vY;
					_obj = _alt_obj_f00000001vY;
				} else {
					_alternate_success_f00000001vY = true;
				}
			}
			if (_alternate_success_f00000001vY) {
			} else {
				_position = _many_position_f00000001qW;
				_obj = _many_obj_f00000001qW;
				break;
			}
		}
		if (_position.Match("Up")) {
		} else {
			_position.Update("“Up”", "Up in REPL");
			_sequence_fail_f00000001g7 = true;
			goto _sequence_end_f00000001g7;
		}
		while(true) {
			ParserPosition _many_position_f00000001qX = _position.Clone();
			var _many_obj_f00000001qX = _obj.Clone();
			bool _alternate_success_f00000001vZ = false;
			ParserPosition _alt_position_f00000001vZ = _position;
			var _alt_obj_f00000001vZ = _obj;
			if (!_alternate_success_f00000001vZ) {
				_position = _alt_position_f00000001vZ.Clone();
				_obj = _alt_obj_f00000001vZ.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000001vZ = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "Up in REPL");
					_position = _alt_position_f00000001vZ;
					_obj = _alt_obj_f00000001vZ;
				}
			}
			if (!_alternate_success_f00000001vZ) {
				_position = _alt_position_f00000001vZ.Clone();
				_obj = _alt_obj_f00000001vZ.Clone();
				bool _sequence_fail_f000000024u = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "Up in REPL");
					_sequence_fail_f000000024u = true;
					goto _sequence_end_f000000024u;
				}
				while(true) {
					ParserPosition _many_position_f00000002E0 = _position.Clone();
					var _many_obj_f00000002E0 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "Up in REPL");
						_position = _many_position_f00000002E0;
						_obj = _many_obj_f00000002E0;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "Up in REPL");
					_sequence_fail_f000000024u = true;
					goto _sequence_end_f000000024u;
				}
				_sequence_end_f000000024u:
				if (_sequence_fail_f000000024u) {
					_position = _alt_position_f00000001vZ;
					_obj = _alt_obj_f00000001vZ;
				} else {
					_alternate_success_f00000001vZ = true;
				}
			}
			if (_alternate_success_f00000001vZ) {
			} else {
				_position = _many_position_f00000001qX;
				_obj = _many_obj_f00000001qX;
				break;
			}
		}
		_sequence_end_f00000001g7:
		if (_sequence_fail_f00000001g7) {
			_position.Cache<repl_up>(_start_index, null);
			_position.TraceExit("repl:up", false);
			_result = null;
			return false;
		} else {
			_position.Cache<repl_up>(_start_index, _obj);
			_position.TraceExit("repl:up", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (repl)_obj;
			return true;
		}
	}
	public abstract void Generate(Generator _generator, LoadableValue _root, LoadableValue _current, LoadableValue _update_current, LoadableValue _escape_value, LoadableValue _print_value, Generator.ParameterisedBlock<LoadableValue> _block);
}
internal class repl_expr : repl {
	public override string PrettyName { get { return "Expression in REPL"; } }
	internal expression expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		blank = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, null, false);
		if (expr != null) { expr.PropagateEnvironment(_collector, _queue, blank, ref _success); }
		return _return;
	}
	Environment blank;
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000001fc =  _type;
		if (expr != null) f00000001fc &= AstTypeableNode.HorrendousTypeMerge(expr.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
	}
	public override void Generate(Generator _generator, LoadableValue _root, LoadableValue _current, LoadableValue _update_current, LoadableValue _escape_value, LoadableValue _print_value, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000001jY = _generator.PushSourceReference(this, null);
		var f00000001x1 = new GeneratedValue(typeof(Flabbergast.Context), (f000000056r_builder) => {
		if (!typeof(Flabbergast.Frame).IsAssignableFrom(_current.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(_current.BackingType)));
		_generator.LoadReboxed(_current, typeof(Flabbergast.Frame));
		f000000056r_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("get_Container"));
		});
		var f00000001x0 = new GeneratedValue(typeof(Flabbergast.Context), (f000000051d_builder) => {
		if (!typeof(Flabbergast.Frame).IsAssignableFrom(_current.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(_current.BackingType)));
		_generator.LoadReboxed(_current, typeof(Flabbergast.Frame));
		f000000051d_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("get_Context"));
		});
		blank.GenerateLookupCache(_generator, null, null, f00000001jY, f00000001x0, _current, (f00000001x2_context, f00000001x2_cache) => {
			_generator.DebugPosition(this);
			expr.Generate(_generator, f00000001x2_cache, f00000001jY, f00000001x2_context, _current, f00000001x1, (f000000026B) => {
				_generator.DebugPosition(this);
			_escape_value.Load(_generator);
			_generator.SlotIfFrame(f000000026B);
			_generator.LoadReboxed(f000000026B, typeof(object));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(ConsumeResult).GetMethod("Invoke", new [] { typeof(object) }));
			_final_block((new BoolConstant(true)));
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		expr.GenerateApi(_api_gen, false);
	}
	internal repl_expr Clone() {
		var _obj = new repl_expr();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expr = expr;
		return _obj;
	}
}
internal class repl_goto : repl {
	public override string PrettyName { get { return "Go in REPL"; } }
	internal expression expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		blank = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, null, false);
		if (expr != null) { expr.PropagateEnvironment(_collector, _queue, blank, ref _success); }
		return _return;
	}
	Environment blank;
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000001fi = _type & (0 | Flabbergast.Type.Frame);
		if (f00000001fi == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		var f00000001jw =  f00000001fi;
		if (expr != null) f00000001jw &= AstTypeableNode.HorrendousTypeMerge(expr.EnsureType(_collector, f00000001fi, ref _success, true), f00000001fi);
	}
	public override void Generate(Generator _generator, LoadableValue _root, LoadableValue _current, LoadableValue _update_current, LoadableValue _escape_value, LoadableValue _print_value, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000001jj = _generator.PushSourceReference(this, null);
		var f00000001xA = new GeneratedValue(typeof(Flabbergast.Context), (f000000057I_builder) => {
		if (!typeof(Flabbergast.Frame).IsAssignableFrom(_current.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(_current.BackingType)));
		_generator.LoadReboxed(_current, typeof(Flabbergast.Frame));
		f000000057I_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("get_Container"));
		});
		var f00000001x9 = new GeneratedValue(typeof(Flabbergast.Context), (f000000052H_builder) => {
		if (!typeof(Flabbergast.Frame).IsAssignableFrom(_current.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(_current.BackingType)));
		_generator.LoadReboxed(_current, typeof(Flabbergast.Frame));
		f000000052H_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("get_Context"));
		});
		blank.GenerateLookupCache(_generator, null, null, f00000001jj, f00000001x9, _current, (f00000001xB_context, f00000001xB_cache) => {
			_generator.DebugPosition(this);
			expr.Generate(_generator, f00000001xB_cache, f00000001jj, f00000001xB_context, _current, f00000001xA, (f00000002Gf) => {
				_generator.DebugPosition(this);
				_update_current.Load(_generator);
				_generator.LoadReboxed(f00000002Gf, typeof(object));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(ConsumeResult).GetMethod("Invoke", new [] { typeof(object) }));
			var f00000001mR = new BoolConstant(true);
			_final_block(f00000001mR);
			});
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal repl_goto Clone() {
		var _obj = new repl_goto();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expr = expr;
		return _obj;
	}
}
internal class repl_help : repl {
	public override string PrettyName { get { return "Help in REPL"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LoadableValue _root, LoadableValue _current, LoadableValue _update_current, LoadableValue _escape_value, LoadableValue _print_value, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000001jz = new StringishValue("Interactive Shell Help\n\nGo <expr>	Change the current frame (This) to some other frame.\nHelp	This dreck.\nHome	Change the current frame (This) to the file-level frame.\nLs	List the names of the attributes in the current frame (This).\nQuit	Stop with the Flabbergast.\nTrace	Print the stack trace for the current frame.\nUp	Change the current frame (This) to the containing frame (Container).");
		_print_value.Load(_generator);
		_generator.SlotIfFrame(f00000001jz);
		_generator.LoadReboxed(f00000001jz, typeof(object));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(ConsumeResult).GetMethod("Invoke", new [] { typeof(object) }));
		_final_block((new BoolConstant(true)));
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal repl_help Clone() {
		var _obj = new repl_help();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class repl_home : repl {
	public override string PrettyName { get { return "Home in REPL"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LoadableValue _root, LoadableValue _current, LoadableValue _update_current, LoadableValue _escape_value, LoadableValue _print_value, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000001q4 = new GeneratedValue(typeof(Flabbergast.Context), (f00000003th_builder) => {
		if (!typeof(Flabbergast.Frame).IsAssignableFrom(_root.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(_root.BackingType)));
		_generator.LoadReboxed(_root, typeof(Flabbergast.Frame));
		f00000003th_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("get_Container"));
		});
		_update_current.Load(_generator);
		_generator.LoadReboxed(f00000001q4, typeof(object));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(ConsumeResult).GetMethod("Invoke", new [] { typeof(object) }));
		var f00000001ml = new BoolConstant(true);
		_final_block(f00000001ml);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal repl_home Clone() {
		var _obj = new repl_home();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class repl_ls : repl {
	public override string PrettyName { get { return "Ls in REPL"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		blank = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, null, false);
		return _return;
	}
	Environment blank;
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LoadableValue _root, LoadableValue _current, LoadableValue _update_current, LoadableValue _escape_value, LoadableValue _print_value, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000001kL = _generator.PushSourceReference(this, null);
		var f00000001xW = new GeneratedValue(typeof(Flabbergast.Context), (f00000005GX_builder) => {
		if (!typeof(Flabbergast.Frame).IsAssignableFrom(_current.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(_current.BackingType)));
		_generator.LoadReboxed(_current, typeof(Flabbergast.Frame));
		f00000005GX_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("get_Container"));
		});
		var f00000001xV = new GeneratedValue(typeof(Flabbergast.Context), (f00000005EI_builder) => {
		if (!typeof(Flabbergast.Frame).IsAssignableFrom(_current.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(_current.BackingType)));
		_generator.LoadReboxed(_current, typeof(Flabbergast.Frame));
		f00000005EI_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("get_Context"));
		});
		blank.GenerateLookupCache(_generator, null, null, f00000001kL, f00000001xV, _current, (f00000001xX_context, f00000001xX_cache) => {
			_generator.DebugPosition(this);
			var f00000002SS = _generator.MakeField("ls_iterator_inputs", typeof(IAttributeNames[]));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000002SS.Field);
			int f00000005C8_next;
			f00000005C8_next = _generator.DefineState();
			f00000002SS.Load(_generator);
			if (!typeof(IAttributeNames).IsAssignableFrom(_current.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(_current.BackingType)));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
			_current.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
			_generator.JumpToState(f00000005C8_next);
			_generator.MarkState(f00000005C8_next);
			var f000000027A = _generator.MakeField("ls_iterator_accumulator", typeof(Flabbergast.Stringish));
			var f000000027A_start_block = _generator.DefineState();
			var f00000002Hh = new StringishValue("Attributes:");
			_generator.CopyField(f00000002Hh, f000000027A);
			_generator.JumpToState(f000000027A_start_block);
			_generator.MarkState(f000000027A_start_block);
			var f000000027A_dispatchers = new int[ 2 ];
			for(var f00000004yW_it = 0; f00000004yW_it < f000000027A_dispatchers.Length; f00000004yW_it++) { f000000027A_dispatchers[f00000004yW_it] = _generator.DefineState(); }
			var f000000027A_iterator = _generator.MakeField("ls_iterator", typeof(MergeIterator));
			#pragma warning disable 219
			var f000000027A_key = new MethodValue(f000000027A_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
			var f000000027A_ordinal = new MethodValue(f000000027A_iterator, typeof(MergeIterator).GetMethod("get_Position"));
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000002SS.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f000000027A_dispatchers[1]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f000000027A_dispatchers[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
			#pragma warning disable 219
			var f000000027A_position = 2;
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000027A_iterator.Field);
			var f000000027A_next = _generator.DefineState();
			_generator.JumpToState(f000000027A_next);
			_generator.MarkState(f000000027A_next);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f000000027A_iterator.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
			_generator.MarkState(f000000027A_dispatchers[1]);
			var f00000002hH = new StringishValue("	");
			var f00000002SR = new GeneratedValue(typeof(Flabbergast.Stringish), (f000000055x_builder) => {
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000002hH.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000002hH.BackingType)));
			_generator.LoadReboxed(f00000002hH, typeof(Flabbergast.Stringish));
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f000000027A_key.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f000000027A_key.BackingType)));
			_generator.LoadReboxed(f000000027A_key, typeof(Flabbergast.Stringish));
			f000000055x_builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(ConcatStringish).GetConstructors()[0]);
			});
			var f00000002Hg = new GeneratedValue(typeof(Flabbergast.Stringish), (f00000004z9_builder) => {
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f000000027A.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f000000027A.BackingType)));
			_generator.LoadReboxed(f000000027A, typeof(Flabbergast.Stringish));
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000002SR.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000002SR.BackingType)));
			_generator.LoadReboxed(f00000002SR, typeof(Flabbergast.Stringish));
			f00000004z9_builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(ConcatStringish).GetConstructors()[0]);
			});
			_generator.CopyField(f00000002Hg, f000000027A);
			_generator.JumpToState(f000000027A_next);
			f000000027A_position = 2;
			_generator.MarkState(f000000027A_dispatchers[0]);
		_print_value.Load(_generator);
		_generator.SlotIfFrame(f000000027A);
		_generator.LoadReboxed(f000000027A, typeof(object));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(ConsumeResult).GetMethod("Invoke", new [] { typeof(object) }));
		_final_block((new BoolConstant(true)));
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal repl_ls Clone() {
		var _obj = new repl_ls();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class repl_quit : repl {
	public override string PrettyName { get { return "Quit in REPL"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LoadableValue _root, LoadableValue _current, LoadableValue _update_current, LoadableValue _escape_value, LoadableValue _print_value, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000001fy = new BoolConstant(false);
		_final_block(f00000001fy);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal repl_quit Clone() {
		var _obj = new repl_quit();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class repl_trace : repl {
	public override string PrettyName { get { return "Trace in REPL"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LoadableValue _root, LoadableValue _current, LoadableValue _update_current, LoadableValue _escape_value, LoadableValue _print_value, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000001qP = new StringishValue("");
		var f00000001kW = new GeneratedValue(typeof(Flabbergast.Stringish), (f00000003B2_builder) => {
		if (!typeof(Flabbergast.Frame).IsAssignableFrom(_current.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(_current.BackingType)));
		_generator.LoadReboxed(_current, typeof(Flabbergast.Frame));
		if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000001qP.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Call.", Stringish.NameForType(f00000001qP.BackingType)));
		_generator.LoadReboxed(f00000001qP, typeof(Flabbergast.Stringish));
		f00000003B2_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("RenderTrace", new System.Type[] { typeof(Stringish) }));
		});
		_print_value.Load(_generator);
		_generator.SlotIfFrame(f00000001kW);
		_generator.LoadReboxed(f00000001kW, typeof(object));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(ConsumeResult).GetMethod("Invoke", new [] { typeof(object) }));
		_final_block((new BoolConstant(true)));
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal repl_trace Clone() {
		var _obj = new repl_trace();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal class repl_up : repl {
	public override string PrettyName { get { return "Up in REPL"; } }
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LoadableValue _root, LoadableValue _current, LoadableValue _update_current, LoadableValue _escape_value, LoadableValue _print_value, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000001qV = new GeneratedValue(typeof(Flabbergast.Context), (f00000003tj_builder) => {
		if (!typeof(Flabbergast.Frame).IsAssignableFrom(_current.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(_current.BackingType)));
		_generator.LoadReboxed(_current, typeof(Flabbergast.Frame));
		f00000003tj_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Frame).GetMethod("get_Container"));
		});
		_update_current.Load(_generator);
		_generator.LoadReboxed(f00000001qV, typeof(object));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(ConsumeResult).GetMethod("Invoke", new [] { typeof(object) }));
		var f00000001nI = new BoolConstant(true);
		_final_block(f00000001nI);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal repl_up Clone() {
		var _obj = new repl_up();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		return _obj;
	}
}
internal abstract class selector : AstTypeableNode {
	internal RevCons<char> comment = null;
	internal static bool ParseRule_Base(ref ParserPosition position, out selector result) {
		position.TraceEnter("selector");
		if(position.CheckCache<selector>("selector", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("any selector", "selector");		slave_position = position.Clone();
		if (ParseRule_accumulate(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector", true);
			position.Cache<selector>("selector", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_each(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector", true);
			position.Cache<selector>("selector", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_let(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector", true);
			position.Cache<selector>("selector", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_merge(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector", true);
			position.Cache<selector>("selector", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_order_by(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector", true);
			position.Cache<selector>("selector", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_reverse(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector", true);
			position.Cache<selector>("selector", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_where(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector", true);
			position.Cache<selector>("selector", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("selector", false);
		position.Cache<selector>("selector", start_index, null);
		return false;
	}
	internal static bool ParseRule_selector0(ref ParserPosition position, out selector result) {
		position.TraceEnter("selector0");
		if(position.CheckCache<selector>("selector.selector0", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("selector0", "selector");
		slave_position = position.Clone();
		if (ParseRule_order_by(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector:selector0", true);
			position.Cache<selector>("selector.selector0", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_reverse(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector:selector0", true);
			position.Cache<selector>("selector.selector0", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_selector1(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector:selector0", true);
			position.Cache<selector>("selector.selector0", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("selector:selector0", false);
		position.Cache<selector>("selector.selector0", start_index, null);
		return false;
	}
	internal static bool ParseRule_selector1(ref ParserPosition position, out selector result) {
		position.TraceEnter("selector1");
		if(position.CheckCache<selector>("selector.selector1", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("selector1", "selector");
		slave_position = position.Clone();
		if (ParseRule_where(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector:selector1", true);
			position.Cache<selector>("selector.selector1", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_selector2(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector:selector1", true);
			position.Cache<selector>("selector.selector1", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("selector:selector1", false);
		position.Cache<selector>("selector.selector1", start_index, null);
		return false;
	}
	internal static bool ParseRule_selector2(ref ParserPosition position, out selector result) {
		position.TraceEnter("selector2");
		if(position.CheckCache<selector>("selector.selector2", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("selector2", "selector");
		slave_position = position.Clone();
		if (ParseRule_accumulate(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector:selector2", true);
			position.Cache<selector>("selector.selector2", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_selector3(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector:selector2", true);
			position.Cache<selector>("selector.selector2", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("selector:selector2", false);
		position.Cache<selector>("selector.selector2", start_index, null);
		return false;
	}
	internal static bool ParseRule_selector3(ref ParserPosition position, out selector result) {
		position.TraceEnter("selector3");
		if(position.CheckCache<selector>("selector.selector3", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("selector3", "selector");
		slave_position = position.Clone();
		if (ParseRule_let(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector:selector3", true);
			position.Cache<selector>("selector.selector3", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_selector4(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector:selector3", true);
			position.Cache<selector>("selector.selector3", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("selector:selector3", false);
		position.Cache<selector>("selector.selector3", start_index, null);
		return false;
	}
	internal static bool ParseRule_selector4(ref ParserPosition position, out selector result) {
		position.TraceEnter("selector4");
		if(position.CheckCache<selector>("selector.selector4", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("selector4", "selector");
		slave_position = position.Clone();
		if (ParseRule_each(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector:selector4", true);
			position.Cache<selector>("selector.selector4", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_merge(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("selector:selector4", true);
			position.Cache<selector>("selector.selector4", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("selector:selector4", false);
		position.Cache<selector>("selector.selector4", start_index, null);
		return false;
	}
	internal static bool ParseRule_accumulate(ref ParserPosition _position, out selector _result) {
		if(_position.CheckCache<selector_accumulate, selector>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new selector_accumulate();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("selector:accumulate");

		bool _sequence_fail_f00000003W1 = false;
		if (selector.ParseRule_selector3(ref _position, out _obj.selector)) {
		} else {
		_sequence_fail_f00000003W1 = true;
		goto _sequence_end_f00000003W1;
		}
		if (_position.Match("Accumulate")) {
		} else {
			_position.Update("“Accumulate”", "fricassée Accumulate");
			_sequence_fail_f00000003W1 = true;
			goto _sequence_end_f00000003W1;
		}
		bool _first_f00000003i8 = true;
		while(true) {
			ParserPosition _many_position_f00000003i8 = _position.Clone();
			var _many_obj_f00000003i8 = _obj.Clone();
			bool _alternate_success_f00000003pc = false;
			ParserPosition _alt_position_f00000003pc = _position;
			var _alt_obj_f00000003pc = _obj;
			if (!_alternate_success_f00000003pc) {
				_position = _alt_position_f00000003pc.Clone();
				_obj = _alt_obj_f00000003pc.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003pc = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Accumulate");
					_position = _alt_position_f00000003pc;
					_obj = _alt_obj_f00000003pc;
				}
			}
			if (!_alternate_success_f00000003pc) {
				_position = _alt_position_f00000003pc.Clone();
				_obj = _alt_obj_f00000003pc.Clone();
				bool _sequence_fail_f00000003wZ = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Accumulate");
					_sequence_fail_f00000003wZ = true;
					goto _sequence_end_f00000003wZ;
				}
				while(true) {
					ParserPosition _many_position_f0000000451 = _position.Clone();
					var _many_obj_f0000000451 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Accumulate");
						_position = _many_position_f0000000451;
						_obj = _many_obj_f0000000451;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Accumulate");
					_sequence_fail_f00000003wZ = true;
					goto _sequence_end_f00000003wZ;
				}
				_sequence_end_f00000003wZ:
				if (_sequence_fail_f00000003wZ) {
					_position = _alt_position_f00000003pc;
					_obj = _alt_obj_f00000003pc;
				} else {
					_alternate_success_f00000003pc = true;
				}
			}
			if (_alternate_success_f00000003pc) {
			} else {
				_position = _many_position_f00000003i8;
				_obj = _many_obj_f00000003i8;
				break;
			}
			_first_f00000003i8 = false;
		}
		if (_first_f00000003i8) {
			_sequence_fail_f00000003W1 = true;
			goto _sequence_end_f00000003W1;
		} else {
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.reduce_expr)) {
		} else {
		_sequence_fail_f00000003W1 = true;
		goto _sequence_end_f00000003W1;
		}
		bool _first_f00000003iC = true;
		while(true) {
			ParserPosition _many_position_f00000003iC = _position.Clone();
			var _many_obj_f00000003iC = _obj.Clone();
			bool _alternate_success_f00000003pd = false;
			ParserPosition _alt_position_f00000003pd = _position;
			var _alt_obj_f00000003pd = _obj;
			if (!_alternate_success_f00000003pd) {
				_position = _alt_position_f00000003pd.Clone();
				_obj = _alt_obj_f00000003pd.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003pd = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Accumulate");
					_position = _alt_position_f00000003pd;
					_obj = _alt_obj_f00000003pd;
				}
			}
			if (!_alternate_success_f00000003pd) {
				_position = _alt_position_f00000003pd.Clone();
				_obj = _alt_obj_f00000003pd.Clone();
				bool _sequence_fail_f00000003wc = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Accumulate");
					_sequence_fail_f00000003wc = true;
					goto _sequence_end_f00000003wc;
				}
				while(true) {
					ParserPosition _many_position_f0000000457 = _position.Clone();
					var _many_obj_f0000000457 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Accumulate");
						_position = _many_position_f0000000457;
						_obj = _many_obj_f0000000457;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Accumulate");
					_sequence_fail_f00000003wc = true;
					goto _sequence_end_f00000003wc;
				}
				_sequence_end_f00000003wc:
				if (_sequence_fail_f00000003wc) {
					_position = _alt_position_f00000003pd;
					_obj = _alt_obj_f00000003pd;
				} else {
					_alternate_success_f00000003pd = true;
				}
			}
			if (_alternate_success_f00000003pd) {
			} else {
				_position = _many_position_f00000003iC;
				_obj = _many_obj_f00000003iC;
				break;
			}
			_first_f00000003iC = false;
		}
		if (_first_f00000003iC) {
			_sequence_fail_f00000003W1 = true;
			goto _sequence_end_f00000003W1;
		} else {
		}
		if (_position.Match("With")) {
		} else {
			_position.Update("“With”", "fricassée Accumulate");
			_sequence_fail_f00000003W1 = true;
			goto _sequence_end_f00000003W1;
		}
		bool _first_f00000003iE = true;
		while(true) {
			ParserPosition _many_position_f00000003iE = _position.Clone();
			var _many_obj_f00000003iE = _obj.Clone();
			bool _alternate_success_f00000003pe = false;
			ParserPosition _alt_position_f00000003pe = _position;
			var _alt_obj_f00000003pe = _obj;
			if (!_alternate_success_f00000003pe) {
				_position = _alt_position_f00000003pe.Clone();
				_obj = _alt_obj_f00000003pe.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003pe = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Accumulate");
					_position = _alt_position_f00000003pe;
					_obj = _alt_obj_f00000003pe;
				}
			}
			if (!_alternate_success_f00000003pe) {
				_position = _alt_position_f00000003pe.Clone();
				_obj = _alt_obj_f00000003pe.Clone();
				bool _sequence_fail_f00000003wf = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Accumulate");
					_sequence_fail_f00000003wf = true;
					goto _sequence_end_f00000003wf;
				}
				while(true) {
					ParserPosition _many_position_f000000045D = _position.Clone();
					var _many_obj_f000000045D = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Accumulate");
						_position = _many_position_f000000045D;
						_obj = _many_obj_f000000045D;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Accumulate");
					_sequence_fail_f00000003wf = true;
					goto _sequence_end_f00000003wf;
				}
				_sequence_end_f00000003wf:
				if (_sequence_fail_f00000003wf) {
					_position = _alt_position_f00000003pe;
					_obj = _alt_obj_f00000003pe;
				} else {
					_alternate_success_f00000003pe = true;
				}
			}
			if (_alternate_success_f00000003pe) {
			} else {
				_position = _many_position_f00000003iE;
				_obj = _many_obj_f00000003iE;
				break;
			}
			_first_f00000003iE = false;
		}
		if (_first_f00000003iE) {
			_sequence_fail_f00000003W1 = true;
			goto _sequence_end_f00000003W1;
		} else {
		}
		bool _sequence_fail_f00000003iF = false;
		if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
		_obj.initial_name = new RevCons<char>(_position.PeekLast(), _obj.initial_name);
		} else {
			_position.Update("character between “a” and “z”", "fricassée Accumulate");
			_sequence_fail_f00000003iF = true;
			goto _sequence_end_f00000003iF;
		}
		while(true) {
			ParserPosition _many_position_f00000003ph = _position.Clone();
			var _many_obj_f00000003ph = _obj.Clone();
			bool _alternate_success_f00000003wi = false;
			ParserPosition _alt_position_f00000003wi = _position;
			var _alt_obj_f00000003wi = _obj;
			if (!_alternate_success_f00000003wi) {
				_position = _alt_position_f00000003wi.Clone();
				_obj = _alt_obj_f00000003wi.Clone();
				if (_position.Next() >= 'a' && _position.PeekLast() <= 'z') {
				_obj.initial_name = new RevCons<char>(_position.PeekLast(), _obj.initial_name);
					_alternate_success_f00000003wi = true;
				} else {
					_position.Update("character between “a” and “z”", "fricassée Accumulate");
					_position = _alt_position_f00000003wi;
					_obj = _alt_obj_f00000003wi;
				}
			}
			if (!_alternate_success_f00000003wi) {
				_position = _alt_position_f00000003wi.Clone();
				_obj = _alt_obj_f00000003wi.Clone();
				if (_position.Next() >= 'A' && _position.PeekLast() <= 'Z') {
				_obj.initial_name = new RevCons<char>(_position.PeekLast(), _obj.initial_name);
					_alternate_success_f00000003wi = true;
				} else {
					_position.Update("character between “A” and “Z”", "fricassée Accumulate");
					_position = _alt_position_f00000003wi;
					_obj = _alt_obj_f00000003wi;
				}
			}
			if (!_alternate_success_f00000003wi) {
				_position = _alt_position_f00000003wi.Clone();
				_obj = _alt_obj_f00000003wi.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.initial_name = new RevCons<char>(_position.PeekLast(), _obj.initial_name);
					_alternate_success_f00000003wi = true;
				} else {
					_position.Update("character between “0” and “9”", "fricassée Accumulate");
					_position = _alt_position_f00000003wi;
					_obj = _alt_obj_f00000003wi;
				}
			}
			if (!_alternate_success_f00000003wi) {
				_position = _alt_position_f00000003wi.Clone();
				_obj = _alt_obj_f00000003wi.Clone();
				if ("_".IndexOf(_position.Next()) != -1) {
					_obj.initial_name = new RevCons<char>(_position.PeekLast(), _obj.initial_name);
					_alternate_success_f00000003wi = true;
				} else {
					_position.Update(Parser.ToLiteral("_"), "fricassée Accumulate");
					_position = _alt_position_f00000003wi;
					_obj = _alt_obj_f00000003wi;
				}
			}
			if (_alternate_success_f00000003wi) {
			} else {
				_position = _many_position_f00000003ph;
				_obj = _many_obj_f00000003ph;
				break;
			}
		}
		_sequence_end_f00000003iF:
		if (_sequence_fail_f00000003iF) {
			_sequence_fail_f00000003W1 = true;
			goto _sequence_end_f00000003W1;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f00000003iG = _position.Clone();
			var _many_obj_f00000003iG = _obj.Clone();
			bool _alternate_success_f00000003pi = false;
			ParserPosition _alt_position_f00000003pi = _position;
			var _alt_obj_f00000003pi = _obj;
			if (!_alternate_success_f00000003pi) {
				_position = _alt_position_f00000003pi.Clone();
				_obj = _alt_obj_f00000003pi.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003pi = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Accumulate");
					_position = _alt_position_f00000003pi;
					_obj = _alt_obj_f00000003pi;
				}
			}
			if (!_alternate_success_f00000003pi) {
				_position = _alt_position_f00000003pi.Clone();
				_obj = _alt_obj_f00000003pi.Clone();
				bool _sequence_fail_f00000003wo = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Accumulate");
					_sequence_fail_f00000003wo = true;
					goto _sequence_end_f00000003wo;
				}
				while(true) {
					ParserPosition _many_position_f000000045O = _position.Clone();
					var _many_obj_f000000045O = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Accumulate");
						_position = _many_position_f000000045O;
						_obj = _many_obj_f000000045O;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Accumulate");
					_sequence_fail_f00000003wo = true;
					goto _sequence_end_f00000003wo;
				}
				_sequence_end_f00000003wo:
				if (_sequence_fail_f00000003wo) {
					_position = _alt_position_f00000003pi;
					_obj = _alt_obj_f00000003pi;
				} else {
					_alternate_success_f00000003pi = true;
				}
			}
			if (_alternate_success_f00000003pi) {
			} else {
				_position = _many_position_f00000003iG;
				_obj = _many_obj_f00000003iG;
				break;
			}
		}
		if (_position.Match(":")) {
		} else {
			_position.Update("“:”", "fricassée Accumulate");
			_sequence_fail_f00000003W1 = true;
			goto _sequence_end_f00000003W1;
		}
		while(true) {
			ParserPosition _many_position_f00000003iI = _position.Clone();
			var _many_obj_f00000003iI = _obj.Clone();
			bool _alternate_success_f00000003pj = false;
			ParserPosition _alt_position_f00000003pj = _position;
			var _alt_obj_f00000003pj = _obj;
			if (!_alternate_success_f00000003pj) {
				_position = _alt_position_f00000003pj.Clone();
				_obj = _alt_obj_f00000003pj.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003pj = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Accumulate");
					_position = _alt_position_f00000003pj;
					_obj = _alt_obj_f00000003pj;
				}
			}
			if (!_alternate_success_f00000003pj) {
				_position = _alt_position_f00000003pj.Clone();
				_obj = _alt_obj_f00000003pj.Clone();
				bool _sequence_fail_f00000003wr = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Accumulate");
					_sequence_fail_f00000003wr = true;
					goto _sequence_end_f00000003wr;
				}
				while(true) {
					ParserPosition _many_position_f000000045U = _position.Clone();
					var _many_obj_f000000045U = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Accumulate");
						_position = _many_position_f000000045U;
						_obj = _many_obj_f000000045U;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Accumulate");
					_sequence_fail_f00000003wr = true;
					goto _sequence_end_f00000003wr;
				}
				_sequence_end_f00000003wr:
				if (_sequence_fail_f00000003wr) {
					_position = _alt_position_f00000003pj;
					_obj = _alt_obj_f00000003pj;
				} else {
					_alternate_success_f00000003pj = true;
				}
			}
			if (_alternate_success_f00000003pj) {
			} else {
				_position = _many_position_f00000003iI;
				_obj = _many_obj_f00000003iI;
				break;
			}
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.initial_expr)) {
		} else {
		_sequence_fail_f00000003W1 = true;
		goto _sequence_end_f00000003W1;
		}
		while(true) {
			ParserPosition _many_position_f00000003iM = _position.Clone();
			var _many_obj_f00000003iM = _obj.Clone();
			bool _alternate_success_f00000003pk = false;
			ParserPosition _alt_position_f00000003pk = _position;
			var _alt_obj_f00000003pk = _obj;
			if (!_alternate_success_f00000003pk) {
				_position = _alt_position_f00000003pk.Clone();
				_obj = _alt_obj_f00000003pk.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003pk = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Accumulate");
					_position = _alt_position_f00000003pk;
					_obj = _alt_obj_f00000003pk;
				}
			}
			if (!_alternate_success_f00000003pk) {
				_position = _alt_position_f00000003pk.Clone();
				_obj = _alt_obj_f00000003pk.Clone();
				bool _sequence_fail_f00000003wu = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Accumulate");
					_sequence_fail_f00000003wu = true;
					goto _sequence_end_f00000003wu;
				}
				while(true) {
					ParserPosition _many_position_f000000045a = _position.Clone();
					var _many_obj_f000000045a = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Accumulate");
						_position = _many_position_f000000045a;
						_obj = _many_obj_f000000045a;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Accumulate");
					_sequence_fail_f00000003wu = true;
					goto _sequence_end_f00000003wu;
				}
				_sequence_end_f00000003wu:
				if (_sequence_fail_f00000003wu) {
					_position = _alt_position_f00000003pk;
					_obj = _alt_obj_f00000003pk;
				} else {
					_alternate_success_f00000003pk = true;
				}
			}
			if (_alternate_success_f00000003pk) {
			} else {
				_position = _many_position_f00000003iM;
				_obj = _many_obj_f00000003iM;
				break;
			}
		}
		_sequence_end_f00000003W1:
		if (_sequence_fail_f00000003W1) {
			_position.Cache<selector_accumulate>(_start_index, null);
			_position.TraceExit("selector:accumulate", false);
			_result = null;
			return false;
		} else {
			_position.Cache<selector_accumulate>(_start_index, _obj);
			_position.TraceExit("selector:accumulate", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (selector)_obj;
			return true;
		}
	}
	internal static bool ParseRule_each(ref ParserPosition _position, out selector _result) {
		if(_position.CheckCache<selector_each, selector>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new selector_each();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("selector:each");

		bool _sequence_fail_f00000003W8 = false;
		bool _first_f00000003iU = true;
		while(true) {
			ParserPosition _many_position_f00000003iU = _position.Clone();
			var _many_obj_f00000003iU = _obj.Clone();
			bool _alternate_success_f00000003pn = false;
			ParserPosition _alt_position_f00000003pn = _position;
			var _alt_obj_f00000003pn = _obj;
			if (!_alternate_success_f00000003pn) {
				_position = _alt_position_f00000003pn.Clone();
				_obj = _alt_obj_f00000003pn.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003pn = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Each input");
					_position = _alt_position_f00000003pn;
					_obj = _alt_obj_f00000003pn;
				}
			}
			if (!_alternate_success_f00000003pn) {
				_position = _alt_position_f00000003pn.Clone();
				_obj = _alt_obj_f00000003pn.Clone();
				bool _sequence_fail_f00000003x0 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Each input");
					_sequence_fail_f00000003x0 = true;
					goto _sequence_end_f00000003x0;
				}
				while(true) {
					ParserPosition _many_position_f000000045h = _position.Clone();
					var _many_obj_f000000045h = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Each input");
						_position = _many_position_f000000045h;
						_obj = _many_obj_f000000045h;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Each input");
					_sequence_fail_f00000003x0 = true;
					goto _sequence_end_f00000003x0;
				}
				_sequence_end_f00000003x0:
				if (_sequence_fail_f00000003x0) {
					_position = _alt_position_f00000003pn;
					_obj = _alt_obj_f00000003pn;
				} else {
					_alternate_success_f00000003pn = true;
				}
			}
			if (_alternate_success_f00000003pn) {
			} else {
				_position = _many_position_f00000003iU;
				_obj = _many_obj_f00000003iU;
				break;
			}
			_first_f00000003iU = false;
		}
		if (_first_f00000003iU) {
			_sequence_fail_f00000003W8 = true;
			goto _sequence_end_f00000003W8;
		} else {
		}
		if (_position.Match("Each")) {
		} else {
			_position.Update("“Each”", "fricassée Each input");
			_sequence_fail_f00000003W8 = true;
			goto _sequence_end_f00000003W8;
		}
		while(true) {
			ParserPosition _many_position_f00000003iW = _position.Clone();
			var _many_obj_f00000003iW = _obj.Clone();
			bool _alternate_success_f00000003po = false;
			ParserPosition _alt_position_f00000003po = _position;
			var _alt_obj_f00000003po = _obj;
			if (!_alternate_success_f00000003po) {
				_position = _alt_position_f00000003po.Clone();
				_obj = _alt_obj_f00000003po.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003po = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Each input");
					_position = _alt_position_f00000003po;
					_obj = _alt_obj_f00000003po;
				}
			}
			if (!_alternate_success_f00000003po) {
				_position = _alt_position_f00000003po.Clone();
				_obj = _alt_obj_f00000003po.Clone();
				bool _sequence_fail_f00000003x3 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Each input");
					_sequence_fail_f00000003x3 = true;
					goto _sequence_end_f00000003x3;
				}
				while(true) {
					ParserPosition _many_position_f000000045n = _position.Clone();
					var _many_obj_f000000045n = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Each input");
						_position = _many_position_f000000045n;
						_obj = _many_obj_f000000045n;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Each input");
					_sequence_fail_f00000003x3 = true;
					goto _sequence_end_f00000003x3;
				}
				_sequence_end_f00000003x3:
				if (_sequence_fail_f00000003x3) {
					_position = _alt_position_f00000003po;
					_obj = _alt_obj_f00000003po;
				} else {
					_alternate_success_f00000003po = true;
				}
			}
			if (_alternate_success_f00000003po) {
			} else {
				_position = _many_position_f00000003iW;
				_obj = _many_obj_f00000003iW;
				break;
			}
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.each_expr)) {
		} else {
		_sequence_fail_f00000003W8 = true;
		goto _sequence_end_f00000003W8;
		}
		while(true) {
			ParserPosition _many_position_f00000003ia = _position.Clone();
			var _many_obj_f00000003ia = _obj.Clone();
			bool _alternate_success_f00000003pp = false;
			ParserPosition _alt_position_f00000003pp = _position;
			var _alt_obj_f00000003pp = _obj;
			if (!_alternate_success_f00000003pp) {
				_position = _alt_position_f00000003pp.Clone();
				_obj = _alt_obj_f00000003pp.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003pp = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Each input");
					_position = _alt_position_f00000003pp;
					_obj = _alt_obj_f00000003pp;
				}
			}
			if (!_alternate_success_f00000003pp) {
				_position = _alt_position_f00000003pp.Clone();
				_obj = _alt_obj_f00000003pp.Clone();
				bool _sequence_fail_f00000003x6 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Each input");
					_sequence_fail_f00000003x6 = true;
					goto _sequence_end_f00000003x6;
				}
				while(true) {
					ParserPosition _many_position_f000000045t = _position.Clone();
					var _many_obj_f000000045t = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Each input");
						_position = _many_position_f000000045t;
						_obj = _many_obj_f000000045t;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Each input");
					_sequence_fail_f00000003x6 = true;
					goto _sequence_end_f00000003x6;
				}
				_sequence_end_f00000003x6:
				if (_sequence_fail_f00000003x6) {
					_position = _alt_position_f00000003pp;
					_obj = _alt_obj_f00000003pp;
				} else {
					_alternate_success_f00000003pp = true;
				}
			}
			if (_alternate_success_f00000003pp) {
			} else {
				_position = _many_position_f00000003ia;
				_obj = _many_obj_f00000003ia;
				break;
			}
		}
		_sequence_end_f00000003W8:
		if (_sequence_fail_f00000003W8) {
			_position.Cache<selector_each>(_start_index, null);
			_position.TraceExit("selector:each", false);
			_result = null;
			return false;
		} else {
			_position.Cache<selector_each>(_start_index, _obj);
			_position.TraceExit("selector:each", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (selector)_obj;
			return true;
		}
	}
	internal static bool ParseRule_let(ref ParserPosition _position, out selector _result) {
		if(_position.CheckCache<selector_let, selector>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new selector_let();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("selector:let");

		bool _sequence_fail_f00000003WH = false;
		if (selector.ParseRule_selector4(ref _position, out _obj.selector)) {
		} else {
		_sequence_fail_f00000003WH = true;
		goto _sequence_end_f00000003WH;
		}
		if (_position.Match("Let")) {
		} else {
			_position.Update("“Let”", "fricassée Let");
			_sequence_fail_f00000003WH = true;
			goto _sequence_end_f00000003WH;
		}
		bool _first_f00000003is = true;
		while(true) {
			ParserPosition _many_position_f00000003is = _position.Clone();
			var _many_obj_f00000003is = _obj.Clone();
			bool _alternate_success_f00000003pu = false;
			ParserPosition _alt_position_f00000003pu = _position;
			var _alt_obj_f00000003pu = _obj;
			if (!_alternate_success_f00000003pu) {
				_position = _alt_position_f00000003pu.Clone();
				_obj = _alt_obj_f00000003pu.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003pu = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Let");
					_position = _alt_position_f00000003pu;
					_obj = _alt_obj_f00000003pu;
				}
			}
			if (!_alternate_success_f00000003pu) {
				_position = _alt_position_f00000003pu.Clone();
				_obj = _alt_obj_f00000003pu.Clone();
				bool _sequence_fail_f00000003xJ = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Let");
					_sequence_fail_f00000003xJ = true;
					goto _sequence_end_f00000003xJ;
				}
				while(true) {
					ParserPosition _many_position_f0000000466 = _position.Clone();
					var _many_obj_f0000000466 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Let");
						_position = _many_position_f0000000466;
						_obj = _many_obj_f0000000466;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Let");
					_sequence_fail_f00000003xJ = true;
					goto _sequence_end_f00000003xJ;
				}
				_sequence_end_f00000003xJ:
				if (_sequence_fail_f00000003xJ) {
					_position = _alt_position_f00000003pu;
					_obj = _alt_obj_f00000003pu;
				} else {
					_alternate_success_f00000003pu = true;
				}
			}
			if (_alternate_success_f00000003pu) {
			} else {
				_position = _many_position_f00000003is;
				_obj = _many_obj_f00000003is;
				break;
			}
			_first_f00000003is = false;
		}
		if (_first_f00000003is) {
			_sequence_fail_f00000003WH = true;
			goto _sequence_end_f00000003WH;
		} else {
		}
		bool _first_f00000003iu = true;
		while(true) {
			ParserPosition _many_position_f00000003iu = _position.Clone();
			var _many_obj_f00000003iu = _obj.Clone();
			if (!_first_f00000003iu) {
			if (_position.Match(",")) {
			} else {
				_position.Update("“,”", "fricassée Let");
				_position = _many_position_f00000003iu;
				_obj = _many_obj_f00000003iu;
				break;
			}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.definitions, (ref ParserPosition _iposition, out named_definition _iresult) => { if (named_definition.ParseRule_Base(ref _iposition, out _iresult)) { var f00000003pv_key = Generator.ToString(_iresult.name); if (_obj.definitions_dedup.ContainsKey(f00000003pv_key)) { _iposition.NameConstraint(f00000003pv_key); return false; } else { _obj.definitions_dedup[f00000003pv_key] = true; return true; } } else { return false; } })) {
			} else {
			_position = _many_position_f00000003iu;
			_obj = _many_obj_f00000003iu;
			break;
			}
			_first_f00000003iu = false;
		}
		if (_first_f00000003iu) {
			_sequence_fail_f00000003WH = true;
			goto _sequence_end_f00000003WH;
		} else {
		}
		while(true) {
			ParserPosition _many_position_f00000003iv = _position.Clone();
			var _many_obj_f00000003iv = _obj.Clone();
			bool _alternate_success_f00000003px = false;
			ParserPosition _alt_position_f00000003px = _position;
			var _alt_obj_f00000003px = _obj;
			if (!_alternate_success_f00000003px) {
				_position = _alt_position_f00000003px.Clone();
				_obj = _alt_obj_f00000003px.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003px = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Let");
					_position = _alt_position_f00000003px;
					_obj = _alt_obj_f00000003px;
				}
			}
			if (!_alternate_success_f00000003px) {
				_position = _alt_position_f00000003px.Clone();
				_obj = _alt_obj_f00000003px.Clone();
				bool _sequence_fail_f00000003xP = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Let");
					_sequence_fail_f00000003xP = true;
					goto _sequence_end_f00000003xP;
				}
				while(true) {
					ParserPosition _many_position_f000000046C = _position.Clone();
					var _many_obj_f000000046C = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Let");
						_position = _many_position_f000000046C;
						_obj = _many_obj_f000000046C;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Let");
					_sequence_fail_f00000003xP = true;
					goto _sequence_end_f00000003xP;
				}
				_sequence_end_f00000003xP:
				if (_sequence_fail_f00000003xP) {
					_position = _alt_position_f00000003px;
					_obj = _alt_obj_f00000003px;
				} else {
					_alternate_success_f00000003px = true;
				}
			}
			if (_alternate_success_f00000003px) {
			} else {
				_position = _many_position_f00000003iv;
				_obj = _many_obj_f00000003iv;
				break;
			}
		}
		_sequence_end_f00000003WH:
		if (_sequence_fail_f00000003WH) {
			_position.Cache<selector_let>(_start_index, null);
			_position.TraceExit("selector:let", false);
			_result = null;
			return false;
		} else {
			_position.Cache<selector_let>(_start_index, _obj);
			_position.TraceExit("selector:let", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (selector)_obj;
			return true;
		}
	}
	internal static bool ParseRule_merge(ref ParserPosition _position, out selector _result) {
		if(_position.CheckCache<selector_merge, selector>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new selector_merge();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("selector:merge");

		bool _sequence_fail_f00000003WO = false;
		bool _first_f00000003j2 = true;
		while(true) {
			ParserPosition _many_position_f00000003j2 = _position.Clone();
			var _many_obj_f00000003j2 = _obj.Clone();
			bool _alternate_success_f00000003q0 = false;
			ParserPosition _alt_position_f00000003q0 = _position;
			var _alt_obj_f00000003q0 = _obj;
			if (!_alternate_success_f00000003q0) {
				_position = _alt_position_f00000003q0.Clone();
				_obj = _alt_obj_f00000003q0.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003q0 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée merge input");
					_position = _alt_position_f00000003q0;
					_obj = _alt_obj_f00000003q0;
				}
			}
			if (!_alternate_success_f00000003q0) {
				_position = _alt_position_f00000003q0.Clone();
				_obj = _alt_obj_f00000003q0.Clone();
				bool _sequence_fail_f00000003xX = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée merge input");
					_sequence_fail_f00000003xX = true;
					goto _sequence_end_f00000003xX;
				}
				while(true) {
					ParserPosition _many_position_f000000046M = _position.Clone();
					var _many_obj_f000000046M = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée merge input");
						_position = _many_position_f000000046M;
						_obj = _many_obj_f000000046M;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée merge input");
					_sequence_fail_f00000003xX = true;
					goto _sequence_end_f00000003xX;
				}
				_sequence_end_f00000003xX:
				if (_sequence_fail_f00000003xX) {
					_position = _alt_position_f00000003q0;
					_obj = _alt_obj_f00000003q0;
				} else {
					_alternate_success_f00000003q0 = true;
				}
			}
			if (_alternate_success_f00000003q0) {
			} else {
				_position = _many_position_f00000003j2;
				_obj = _many_obj_f00000003j2;
				break;
			}
			_first_f00000003j2 = false;
		}
		if (_first_f00000003j2) {
			_sequence_fail_f00000003WO = true;
			goto _sequence_end_f00000003WO;
		} else {
		}
		bool _first_f00000003j4 = true;
		while(true) {
			ParserPosition _many_position_f00000003j4 = _position.Clone();
			var _many_obj_f00000003j4 = _obj.Clone();
			if (!_first_f00000003j4) {
			if (_position.Match(",")) {
			} else {
				_position.Update("“,”", "fricassée merge input");
				_position = _many_position_f00000003j4;
				_obj = _many_obj_f00000003j4;
				break;
			}
			}
			if (ParserPosition.ParseIntoList(ref _position, _obj.inputs, fricassee_merge_input.ParseRule_Base)) {
			} else {
			_position = _many_position_f00000003j4;
			_obj = _many_obj_f00000003j4;
			break;
			}
			_first_f00000003j4 = false;
		}
		if (_first_f00000003j4) {
			_sequence_fail_f00000003WO = true;
			goto _sequence_end_f00000003WO;
		} else {
		}
		bool _first_f00000003j5 = true;
		while(true) {
			ParserPosition _many_position_f00000003j5 = _position.Clone();
			var _many_obj_f00000003j5 = _obj.Clone();
			bool _alternate_success_f00000003q3 = false;
			ParserPosition _alt_position_f00000003q3 = _position;
			var _alt_obj_f00000003q3 = _obj;
			if (!_alternate_success_f00000003q3) {
				_position = _alt_position_f00000003q3.Clone();
				_obj = _alt_obj_f00000003q3.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003q3 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée merge input");
					_position = _alt_position_f00000003q3;
					_obj = _alt_obj_f00000003q3;
				}
			}
			if (!_alternate_success_f00000003q3) {
				_position = _alt_position_f00000003q3.Clone();
				_obj = _alt_obj_f00000003q3.Clone();
				bool _sequence_fail_f00000003xd = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée merge input");
					_sequence_fail_f00000003xd = true;
					goto _sequence_end_f00000003xd;
				}
				while(true) {
					ParserPosition _many_position_f000000046S = _position.Clone();
					var _many_obj_f000000046S = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée merge input");
						_position = _many_position_f000000046S;
						_obj = _many_obj_f000000046S;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée merge input");
					_sequence_fail_f00000003xd = true;
					goto _sequence_end_f00000003xd;
				}
				_sequence_end_f00000003xd:
				if (_sequence_fail_f00000003xd) {
					_position = _alt_position_f00000003q3;
					_obj = _alt_obj_f00000003q3;
				} else {
					_alternate_success_f00000003q3 = true;
				}
			}
			if (_alternate_success_f00000003q3) {
			} else {
				_position = _many_position_f00000003j5;
				_obj = _many_obj_f00000003j5;
				break;
			}
			_first_f00000003j5 = false;
		}
		if (_first_f00000003j5) {
			_sequence_fail_f00000003WO = true;
			goto _sequence_end_f00000003WO;
		} else {
		}
		_sequence_end_f00000003WO:
		if (_sequence_fail_f00000003WO) {
			_position.Cache<selector_merge>(_start_index, null);
			_position.TraceExit("selector:merge", false);
			_result = null;
			return false;
		} else {
			_position.Cache<selector_merge>(_start_index, _obj);
			_position.TraceExit("selector:merge", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (selector)_obj;
			return true;
		}
	}
	internal static bool ParseRule_order_by(ref ParserPosition _position, out selector _result) {
		if(_position.CheckCache<selector_order_by, selector>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new selector_order_by();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("selector:order_by");

		bool _sequence_fail_f00000003WX = false;
		if (selector.ParseRule_selector1(ref _position, out _obj.selector)) {
		} else {
		_sequence_fail_f00000003WX = true;
		goto _sequence_end_f00000003WX;
		}
		if (_position.Match("Order")) {
		} else {
			_position.Update("“Order”", "fricassée Order By clause");
			_sequence_fail_f00000003WX = true;
			goto _sequence_end_f00000003WX;
		}
		bool _first_f00000003jH = true;
		while(true) {
			ParserPosition _many_position_f00000003jH = _position.Clone();
			var _many_obj_f00000003jH = _obj.Clone();
			bool _alternate_success_f00000003q8 = false;
			ParserPosition _alt_position_f00000003q8 = _position;
			var _alt_obj_f00000003q8 = _obj;
			if (!_alternate_success_f00000003q8) {
				_position = _alt_position_f00000003q8.Clone();
				_obj = _alt_obj_f00000003q8.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003q8 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Order By clause");
					_position = _alt_position_f00000003q8;
					_obj = _alt_obj_f00000003q8;
				}
			}
			if (!_alternate_success_f00000003q8) {
				_position = _alt_position_f00000003q8.Clone();
				_obj = _alt_obj_f00000003q8.Clone();
				bool _sequence_fail_f00000003xo = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Order By clause");
					_sequence_fail_f00000003xo = true;
					goto _sequence_end_f00000003xo;
				}
				while(true) {
					ParserPosition _many_position_f000000046c = _position.Clone();
					var _many_obj_f000000046c = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Order By clause");
						_position = _many_position_f000000046c;
						_obj = _many_obj_f000000046c;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Order By clause");
					_sequence_fail_f00000003xo = true;
					goto _sequence_end_f00000003xo;
				}
				_sequence_end_f00000003xo:
				if (_sequence_fail_f00000003xo) {
					_position = _alt_position_f00000003q8;
					_obj = _alt_obj_f00000003q8;
				} else {
					_alternate_success_f00000003q8 = true;
				}
			}
			if (_alternate_success_f00000003q8) {
			} else {
				_position = _many_position_f00000003jH;
				_obj = _many_obj_f00000003jH;
				break;
			}
			_first_f00000003jH = false;
		}
		if (_first_f00000003jH) {
			_sequence_fail_f00000003WX = true;
			goto _sequence_end_f00000003WX;
		} else {
		}
		if (_position.Match("By")) {
		} else {
			_position.Update("“By”", "fricassée Order By clause");
			_sequence_fail_f00000003WX = true;
			goto _sequence_end_f00000003WX;
		}
		bool _first_f00000003jJ = true;
		while(true) {
			ParserPosition _many_position_f00000003jJ = _position.Clone();
			var _many_obj_f00000003jJ = _obj.Clone();
			bool _alternate_success_f00000003q9 = false;
			ParserPosition _alt_position_f00000003q9 = _position;
			var _alt_obj_f00000003q9 = _obj;
			if (!_alternate_success_f00000003q9) {
				_position = _alt_position_f00000003q9.Clone();
				_obj = _alt_obj_f00000003q9.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003q9 = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Order By clause");
					_position = _alt_position_f00000003q9;
					_obj = _alt_obj_f00000003q9;
				}
			}
			if (!_alternate_success_f00000003q9) {
				_position = _alt_position_f00000003q9.Clone();
				_obj = _alt_obj_f00000003q9.Clone();
				bool _sequence_fail_f00000003xr = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Order By clause");
					_sequence_fail_f00000003xr = true;
					goto _sequence_end_f00000003xr;
				}
				while(true) {
					ParserPosition _many_position_f000000046i = _position.Clone();
					var _many_obj_f000000046i = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Order By clause");
						_position = _many_position_f000000046i;
						_obj = _many_obj_f000000046i;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Order By clause");
					_sequence_fail_f00000003xr = true;
					goto _sequence_end_f00000003xr;
				}
				_sequence_end_f00000003xr:
				if (_sequence_fail_f00000003xr) {
					_position = _alt_position_f00000003q9;
					_obj = _alt_obj_f00000003q9;
				} else {
					_alternate_success_f00000003q9 = true;
				}
			}
			if (_alternate_success_f00000003q9) {
			} else {
				_position = _many_position_f00000003jJ;
				_obj = _many_obj_f00000003jJ;
				break;
			}
			_first_f00000003jJ = false;
		}
		if (_first_f00000003jJ) {
			_sequence_fail_f00000003WX = true;
			goto _sequence_end_f00000003WX;
		} else {
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000003WX = true;
		goto _sequence_end_f00000003WX;
		}
		while(true) {
			ParserPosition _many_position_f00000003jN = _position.Clone();
			var _many_obj_f00000003jN = _obj.Clone();
			bool _alternate_success_f00000003qA = false;
			ParserPosition _alt_position_f00000003qA = _position;
			var _alt_obj_f00000003qA = _obj;
			if (!_alternate_success_f00000003qA) {
				_position = _alt_position_f00000003qA.Clone();
				_obj = _alt_obj_f00000003qA.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003qA = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Order By clause");
					_position = _alt_position_f00000003qA;
					_obj = _alt_obj_f00000003qA;
				}
			}
			if (!_alternate_success_f00000003qA) {
				_position = _alt_position_f00000003qA.Clone();
				_obj = _alt_obj_f00000003qA.Clone();
				bool _sequence_fail_f00000003xu = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Order By clause");
					_sequence_fail_f00000003xu = true;
					goto _sequence_end_f00000003xu;
				}
				while(true) {
					ParserPosition _many_position_f000000046o = _position.Clone();
					var _many_obj_f000000046o = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Order By clause");
						_position = _many_position_f000000046o;
						_obj = _many_obj_f000000046o;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Order By clause");
					_sequence_fail_f00000003xu = true;
					goto _sequence_end_f00000003xu;
				}
				_sequence_end_f00000003xu:
				if (_sequence_fail_f00000003xu) {
					_position = _alt_position_f00000003qA;
					_obj = _alt_obj_f00000003qA;
				} else {
					_alternate_success_f00000003qA = true;
				}
			}
			if (_alternate_success_f00000003qA) {
			} else {
				_position = _many_position_f00000003jN;
				_obj = _many_obj_f00000003jN;
				break;
			}
		}
		_sequence_end_f00000003WX:
		if (_sequence_fail_f00000003WX) {
			_position.Cache<selector_order_by>(_start_index, null);
			_position.TraceExit("selector:order_by", false);
			_result = null;
			return false;
		} else {
			_position.Cache<selector_order_by>(_start_index, _obj);
			_position.TraceExit("selector:order_by", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (selector)_obj;
			return true;
		}
	}
	internal static bool ParseRule_reverse(ref ParserPosition _position, out selector _result) {
		if(_position.CheckCache<selector_reverse, selector>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new selector_reverse();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("selector:reverse");

		bool _sequence_fail_f00000003Wg = false;
		if (selector.ParseRule_selector1(ref _position, out _obj.selector)) {
		} else {
		_sequence_fail_f00000003Wg = true;
		goto _sequence_end_f00000003Wg;
		}
		if (_position.Match("Reverse")) {
		} else {
			_position.Update("“Reverse”", "fricassée Reverse clause");
			_sequence_fail_f00000003Wg = true;
			goto _sequence_end_f00000003Wg;
		}
		bool _first_f00000003ja = true;
		while(true) {
			ParserPosition _many_position_f00000003ja = _position.Clone();
			var _many_obj_f00000003ja = _obj.Clone();
			bool _alternate_success_f00000003qI = false;
			ParserPosition _alt_position_f00000003qI = _position;
			var _alt_obj_f00000003qI = _obj;
			if (!_alternate_success_f00000003qI) {
				_position = _alt_position_f00000003qI.Clone();
				_obj = _alt_obj_f00000003qI.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003qI = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Reverse clause");
					_position = _alt_position_f00000003qI;
					_obj = _alt_obj_f00000003qI;
				}
			}
			if (!_alternate_success_f00000003qI) {
				_position = _alt_position_f00000003qI.Clone();
				_obj = _alt_obj_f00000003qI.Clone();
				bool _sequence_fail_f00000003y7 = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Reverse clause");
					_sequence_fail_f00000003y7 = true;
					goto _sequence_end_f00000003y7;
				}
				while(true) {
					ParserPosition _many_position_f0000000475 = _position.Clone();
					var _many_obj_f0000000475 = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Reverse clause");
						_position = _many_position_f0000000475;
						_obj = _many_obj_f0000000475;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Reverse clause");
					_sequence_fail_f00000003y7 = true;
					goto _sequence_end_f00000003y7;
				}
				_sequence_end_f00000003y7:
				if (_sequence_fail_f00000003y7) {
					_position = _alt_position_f00000003qI;
					_obj = _alt_obj_f00000003qI;
				} else {
					_alternate_success_f00000003qI = true;
				}
			}
			if (_alternate_success_f00000003qI) {
			} else {
				_position = _many_position_f00000003ja;
				_obj = _many_obj_f00000003ja;
				break;
			}
			_first_f00000003ja = false;
		}
		if (_first_f00000003ja) {
			_sequence_fail_f00000003Wg = true;
			goto _sequence_end_f00000003Wg;
		} else {
		}
		_sequence_end_f00000003Wg:
		if (_sequence_fail_f00000003Wg) {
			_position.Cache<selector_reverse>(_start_index, null);
			_position.TraceExit("selector:reverse", false);
			_result = null;
			return false;
		} else {
			_position.Cache<selector_reverse>(_start_index, _obj);
			_position.TraceExit("selector:reverse", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (selector)_obj;
			return true;
		}
	}
	internal static bool ParseRule_where(ref ParserPosition _position, out selector _result) {
		if(_position.CheckCache<selector_where, selector>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new selector_where();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("selector:where");

		bool _sequence_fail_f00000003Wp = false;
		if (selector.ParseRule_selector2(ref _position, out _obj.selector)) {
		} else {
		_sequence_fail_f00000003Wp = true;
		goto _sequence_end_f00000003Wp;
		}
		if (_position.Match("Where")) {
		} else {
			_position.Update("“Where”", "fricassée Where clause");
			_sequence_fail_f00000003Wp = true;
			goto _sequence_end_f00000003Wp;
		}
		bool _first_f00000003jo = true;
		while(true) {
			ParserPosition _many_position_f00000003jo = _position.Clone();
			var _many_obj_f00000003jo = _obj.Clone();
			bool _alternate_success_f00000003qR = false;
			ParserPosition _alt_position_f00000003qR = _position;
			var _alt_obj_f00000003qR = _obj;
			if (!_alternate_success_f00000003qR) {
				_position = _alt_position_f00000003qR.Clone();
				_obj = _alt_obj_f00000003qR.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003qR = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Where clause");
					_position = _alt_position_f00000003qR;
					_obj = _alt_obj_f00000003qR;
				}
			}
			if (!_alternate_success_f00000003qR) {
				_position = _alt_position_f00000003qR.Clone();
				_obj = _alt_obj_f00000003qR.Clone();
				bool _sequence_fail_f00000003yG = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Where clause");
					_sequence_fail_f00000003yG = true;
					goto _sequence_end_f00000003yG;
				}
				while(true) {
					ParserPosition _many_position_f000000047I = _position.Clone();
					var _many_obj_f000000047I = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Where clause");
						_position = _many_position_f000000047I;
						_obj = _many_obj_f000000047I;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Where clause");
					_sequence_fail_f00000003yG = true;
					goto _sequence_end_f00000003yG;
				}
				_sequence_end_f00000003yG:
				if (_sequence_fail_f00000003yG) {
					_position = _alt_position_f00000003qR;
					_obj = _alt_obj_f00000003qR;
				} else {
					_alternate_success_f00000003qR = true;
				}
			}
			if (_alternate_success_f00000003qR) {
			} else {
				_position = _many_position_f00000003jo;
				_obj = _many_obj_f00000003jo;
				break;
			}
			_first_f00000003jo = false;
		}
		if (_first_f00000003jo) {
			_sequence_fail_f00000003Wp = true;
			goto _sequence_end_f00000003Wp;
		} else {
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000003Wp = true;
		goto _sequence_end_f00000003Wp;
		}
		while(true) {
			ParserPosition _many_position_f00000003js = _position.Clone();
			var _many_obj_f00000003js = _obj.Clone();
			bool _alternate_success_f00000003qS = false;
			ParserPosition _alt_position_f00000003qS = _position;
			var _alt_obj_f00000003qS = _obj;
			if (!_alternate_success_f00000003qS) {
				_position = _alt_position_f00000003qS.Clone();
				_obj = _alt_obj_f00000003qS.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000003qS = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "fricassée Where clause");
					_position = _alt_position_f00000003qS;
					_obj = _alt_obj_f00000003qS;
				}
			}
			if (!_alternate_success_f00000003qS) {
				_position = _alt_position_f00000003qS.Clone();
				_obj = _alt_obj_f00000003qS.Clone();
				bool _sequence_fail_f00000003yJ = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "fricassée Where clause");
					_sequence_fail_f00000003yJ = true;
					goto _sequence_end_f00000003yJ;
				}
				while(true) {
					ParserPosition _many_position_f000000047O = _position.Clone();
					var _many_obj_f000000047O = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "fricassée Where clause");
						_position = _many_position_f000000047O;
						_obj = _many_obj_f000000047O;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "fricassée Where clause");
					_sequence_fail_f00000003yJ = true;
					goto _sequence_end_f00000003yJ;
				}
				_sequence_end_f00000003yJ:
				if (_sequence_fail_f00000003yJ) {
					_position = _alt_position_f00000003qS;
					_obj = _alt_obj_f00000003qS;
				} else {
					_alternate_success_f00000003qS = true;
				}
			}
			if (_alternate_success_f00000003qS) {
			} else {
				_position = _many_position_f00000003js;
				_obj = _many_obj_f00000003js;
				break;
			}
		}
		_sequence_end_f00000003Wp:
		if (_sequence_fail_f00000003Wp) {
			_position.Cache<selector_where>(_start_index, null);
			_position.TraceExit("selector:where", false);
			_result = null;
			return false;
		} else {
			_position.Cache<selector_where>(_start_index, _obj);
			_position.TraceExit("selector:where", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (selector)_obj;
			return true;
		}
	}
	public abstract void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _block);
}
internal class selector_accumulate : selector {
	public override string PrettyName { get { return "fricassée Accumulate"; } }
	internal selector selector;
	internal expression reduce_expr;
	internal RevCons<char> initial_name = null;
	internal expression initial_expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (initial_expr != null) { initial_expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		if (_return != null) throw new System.InvalidOperationException("Refusing to overwrite return value.");
		if (selector == null) throw new System.InvalidOperationException("Field selector in accumulate is empty.");
		select_env = selector.PropagateEnvironment(_collector, _queue, _environment, ref _success);
		if (select_env == null) throw new System.InvalidOperationException("Field selector in accumulate did not collect and environment.");
		reduce_env = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, select_env, false);
		bottleneck_type = reduce_env.AddMask(Generator.ToString(initial_name), initial_expr);
		if (reduce_expr != null) { reduce_expr.PropagateEnvironment(_collector, _queue, reduce_env, ref _success); }
		_return = reduce_env;
		return _return;
	}
	Environment select_env;
	Environment reduce_env;
	RestrictableType bottleneck_type;
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000003W2 =  _type;
		if (reduce_expr != null) f00000003W2 &= AstTypeableNode.HorrendousTypeMerge(reduce_expr.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
		if (initial_expr != null) f00000003W2 &= AstTypeableNode.HorrendousTypeMerge(initial_expr.EnsureType(_collector, _type, ref _success, _needs_unbox), _type);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000003dF = _generator.MakeField("accumulate_new_frame", typeof(MutableFrame));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
		_generator.LoadTaskMaster();
		_generator.AmendSourceReference(this, "fricassée Accumulate", _source_reference, null);
		_context.Load(_generator);
		_self_frame.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003dF.Field);
		selector.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000003nC) => {
			_generator.DebugPosition(this);
			var f0000000431 = _generator.MakeField("accumulate_iterator_inputs", typeof(IAttributeNames[]));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f0000000431.Field);
			int f00000005Nb_next;
			f00000005Nb_next = _generator.DefineState();
			f0000000431.Load(_generator);
			if (!typeof(IAttributeNames).IsAssignableFrom(f00000003nC.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f00000003nC.BackingType)));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
			f00000003nC.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
			_generator.JumpToState(f00000005Nb_next);
			_generator.MarkState(f00000005Nb_next);
			var f00000003nD = _generator.MakeField("accumulate_iterator_accumulator", typeof(object));
			var f00000003nD_start_block = _generator.DefineState();
			LoadableValue f0000000432 = _source_reference;
			initial_expr.Generate(_generator, _cache, f0000000432, _context, _self_frame, _container_frame, (f00000003tp) => {
				_generator.DebugPosition(this);
				_generator.CopyField(f00000003tp, f00000003nD);
				_generator.JumpToState(f00000003nD_start_block);
			});
			_generator.MarkState(f00000003nD_start_block);
			var f00000003nD_dispatchers = new int[ 2 ];
			for(var f00000004jr_it = 0; f00000004jr_it < f00000003nD_dispatchers.Length; f00000004jr_it++) { f00000003nD_dispatchers[f00000004jr_it] = _generator.DefineState(); }
			var f00000003nD_iterator = _generator.MakeField("accumulate_iterator", typeof(MergeIterator));
			#pragma warning disable 219
			var f00000003nD_key = new MethodValue(f00000003nD_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
			var f00000003nD_ordinal = new MethodValue(f00000003nD_iterator, typeof(MergeIterator).GetMethod("get_Position"));
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f0000000431.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003nD_dispatchers[1]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003nD_dispatchers[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
			#pragma warning disable 219
			var f00000003nD_position = 2;
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003nD_iterator.Field);
			var f00000003nD_next = _generator.DefineState();
			_generator.JumpToState(f00000003nD_next);
			_generator.MarkState(f00000003nD_next);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000003nD_iterator.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
			f0000000432 = _generator.PushIteratorSourceReference(this, f00000003nD_iterator, _source_reference);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
			_generator.MarkState(f00000003nD_dispatchers[1]);
			var f00000004DD = _generator.MakeField("accumulate_Call", typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000003nC.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000003nC.BackingType)));
			_generator.LoadReboxed(f00000003nC, typeof(Flabbergast.Frame));
			if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
			_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004DD.Field);
			_generator.StartInterlock(1);
			_generator.LoadTaskMaster();
			f0000000432.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			f00000003nD_key.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
			f00000004DD.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
			var f000000044x = _generator.MakeField("lookup", typeof(object));
			_generator.GenerateConsumeResult(f000000044x, true);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
			_generator.StopInterlock();
			_generator.DynamicTypeDispatch(f000000044x, f0000000432, new System.Type[] { typeof(Flabbergast.Frame)}, (f00000004Ne) => {
				_generator.DebugPosition(this);
				var f00000004GG = _generator.MakeField("accumulate_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000004Ne.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000004Ne.BackingType)));
				_generator.LoadReboxed(f00000004Ne, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(_context.BackingType)));
				_generator.LoadReboxed(_context, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004GG.Field);
				select_env.GenerateLookupCache(_generator, null, _cache, f0000000432, f00000004GG, _self_frame, (f00000004GH_context, f00000004GH_cache) => {
					_generator.DebugPosition(this);
					_generator.DynamicTypeDispatch(f000000044x, f0000000432, new System.Type[] { typeof(Flabbergast.Frame)}, (f00000004a0) => {
						_generator.DebugPosition(this);
						var f00000004VK = _generator.MakeField("accumulate_Call", typeof(Flabbergast.Context));
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
						if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000004a0.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000004a0.BackingType)));
						_generator.LoadReboxed(f00000004a0, typeof(Flabbergast.Frame));
						if (!typeof(Flabbergast.Context).IsAssignableFrom(f00000004GH_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(f00000004GH_context.BackingType)));
						_generator.LoadReboxed(f00000004GH_context, typeof(Flabbergast.Context));
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004VK.Field);
						_generator.DynamicTypeDispatch(f000000044x, f0000000432, new System.Type[] { typeof(Flabbergast.Frame)}, (f00000004VI) => {
							_generator.DebugPosition(this);
							var f00000004Zv = _generator.MakeField("accumulate_new_frame", typeof(MutableFrame));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
							_generator.LoadTaskMaster();
							_generator.AmendSourceReference(this, "fricassée Accumulate", f0000000432, null);
							f00000004GH_context.Load(_generator);
							_self_frame.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004Zv.Field);
							if (!typeof(Template).IsAssignableFrom(f00000003dF.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000003dF.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000003dF.BackingType)));
							f00000003dF.Load(_generator);
							f00000003nD_key.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
							var f00000005IF_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000003dF.BackingType);
							var f00000005IF_boxed_type = f00000005IF_is_frame ? typeof(object) : typeof(ComputeValue);
							_generator.LoadReboxed(f00000004Zv, f00000005IF_boxed_type);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000003dF.BackingType.GetMethod(f00000005IF_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000005IF_boxed_type }));
							var f00000004VL = _generator.PushSourceReference(this, f0000000432);
							var f00000004ez = _generator.MakeField("accumulate_iterator_inputs", typeof(IAttributeNames[]));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004ez.Field);
							int f00000005Gs_next;
							f00000005Gs_next = _generator.DefineState();
							f00000004ez.Load(_generator);
							if (!typeof(IAttributeNames).IsAssignableFrom(f00000004VI.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f00000004VI.BackingType)));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
							f00000004VI.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
							_generator.JumpToState(f00000005Gs_next);
							_generator.MarkState(f00000005Gs_next);
							var f00000004a2 = _generator.MakeField("accumulate_iterator_accumulator", typeof(object));
							var f00000004a2_start_block = _generator.DefineState();
							var f00000004dA = UnitConstant.NULL;
							_generator.CopyField(f00000004dA, f00000004a2);
							_generator.JumpToState(f00000004a2_start_block);
							_generator.MarkState(f00000004a2_start_block);
							var f00000004a2_dispatchers = new int[ 2 + 1 ];
							for(var f00000005B3_it = 0; f00000005B3_it < f00000004a2_dispatchers.Length; f00000005B3_it++) { f00000004a2_dispatchers[f00000005B3_it] = _generator.DefineState(); }
							var f00000004a2_iterator = _generator.MakeField("accumulate_iterator", typeof(MergeIterator));
							#pragma warning disable 219
							var f00000004a2_key = new MethodValue(f00000004a2_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
							var f00000004a2_ordinal = new MethodValue(f00000004a2_iterator, typeof(MergeIterator).GetMethod("get_Position"));
							#pragma warning restore 219
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
							f00000004ez.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000004a2_dispatchers[1]);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000004a2_dispatchers[0]);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
							#pragma warning disable 219
							var f00000004a2_position = 2;
							#pragma warning restore 219
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(initial_name));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000004a2_dispatchers[f00000004a2_position++]);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("AddDispatcher", new System.Type[] { typeof(string), typeof(int) }));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004a2_iterator.Field);
							var f00000004a2_next = _generator.DefineState();
							_generator.JumpToState(f00000004a2_next);
							_generator.MarkState(f00000004a2_next);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
							f00000004a2_iterator.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
							_generator.MarkState(f00000004a2_dispatchers[1]);
							var f00000004h0 = _generator.MakeField("accumulate_Call", typeof(Flabbergast.Context));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
							if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000004VI.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000004VI.BackingType)));
							_generator.LoadReboxed(f00000004VI, typeof(Flabbergast.Frame));
							if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
							_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004h0.Field);
							_generator.StartInterlock(1);
							_generator.LoadTaskMaster();
							f00000004VL.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
							f00000004a2_key.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
							f00000004h0.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
							var f00000004ew = _generator.MakeField("lookup", typeof(object));
							_generator.GenerateConsumeResult(f00000004ew, true);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
							_generator.StopInterlock();
							if (!typeof(Template).IsAssignableFrom(f00000004Zv.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000004Zv.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000004Zv.BackingType)));
							f00000004Zv.Load(_generator);
							f00000004a2_key.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
							var f00000005BK_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000004Zv.BackingType);
							var f00000005BK_boxed_type = f00000005BK_is_frame ? typeof(object) : typeof(ComputeValue);
							_generator.LoadReboxed(f00000004ew, f00000005BK_boxed_type);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000004Zv.BackingType.GetMethod(f00000005BK_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000005BK_boxed_type }));
							_generator.CopyField(f00000004a2, f00000004a2);
							_generator.JumpToState(f00000004a2_next);
							f00000004a2_position = 2;
							_generator.MarkState(f00000004a2_dispatchers[f00000004a2_position++]);
							reduce_env.GenerateLookupCache(_generator, new[] { new System.Tuple<RestrictableType, Generator.ParameterisedBlock<Generator.ParameterisedBlock<LoadableValue>>>(bottleneck_type, f00000005D0_block => {
								f00000005D0_block(f00000003nD);})}, f00000004GH_cache, f00000004VL, f00000004VK, _self_frame, (f00000004jZ_context, f00000004jZ_cache) => {
								_generator.DebugPosition(this);
								reduce_expr.Generate(_generator, f00000004jZ_cache, f00000004VL, f00000004jZ_context, _self_frame, _container_frame, (f00000004kw) => {
									_generator.DebugPosition(this);
								if (!typeof(Template).IsAssignableFrom(f00000004Zv.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000004Zv.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000004Zv.BackingType)));
								f00000004Zv.Load(_generator);
								f00000004a2_key.Load(_generator);
								_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
								var f00000005CN_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000004Zv.BackingType);
								var f00000005CN_boxed_type = f00000005CN_is_frame ? typeof(object) : typeof(ComputeValue);
								_generator.LoadReboxed(f00000004kw, f00000005CN_boxed_type);
								_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000004Zv.BackingType.GetMethod(f00000005CN_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000005CN_boxed_type }));
								_generator.CopyField(f00000004kw, f00000004a2);
								_generator.JumpToState(f00000004a2_next);
								});
							});
							_generator.MarkState(f00000004a2_dispatchers[0]);
						_generator.CopyField(f00000004a2, f00000003nD);
						_generator.JumpToState(f00000003nD_next);
						});
					});
				});
			});
			f00000003nD_position = 2;
			_generator.MarkState(f00000003nD_dispatchers[0]);
			_final_block(f00000003dF);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		selector.GenerateApi(_api_gen, false);
		initial_expr.GenerateApi(_api_gen, false);
		reduce_expr.GenerateApi(_api_gen, false);
	}
	internal selector_accumulate Clone() {
		var _obj = new selector_accumulate();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.selector = selector;
		_obj.reduce_expr = reduce_expr;
		_obj.initial_name = initial_name;
		_obj.initial_expr = initial_expr;
		return _obj;
	}
}
internal class selector_each : selector {
	public override string PrettyName { get { return "fricassée Each input"; } }
	internal expression each_expr;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (each_expr != null) { each_expr.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		blank = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, null, false);
		_return = blank;
		return _return;
	}
	Environment blank;
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000003W9 = _type & (0 | Flabbergast.Type.Frame);
		if (f00000003W9 == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Frame, _type);
		}
		var f00000003aw =  f00000003W9;
		if (each_expr != null) f00000003aw &= AstTypeableNode.HorrendousTypeMerge(each_expr.EnsureType(_collector, f00000003W9, ref _success, true), f00000003W9);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		each_expr.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000003W7) => {
			_generator.DebugPosition(this);
			_final_block(f00000003W7);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		each_expr.GenerateApi(_api_gen, false);
	}
	internal selector_each Clone() {
		var _obj = new selector_each();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.each_expr = each_expr;
		return _obj;
	}
}
internal class selector_let : selector {
	public override string PrettyName { get { return "fricassée Let"; } }
	internal selector selector;
	internal System.Collections.Generic.List<named_definition> definitions = new System.Collections.Generic.List<named_definition>();
	internal System.Collections.Generic.Dictionary<string, bool> definitions_dedup = new System.Collections.Generic.Dictionary<string, bool>{};
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (_return != null) throw new System.InvalidOperationException("Refusing to overwrite return value.");
		if (selector == null) throw new System.InvalidOperationException("Field selector in let is empty.");
		select_env = selector.PropagateEnvironment(_collector, _queue, _environment, ref _success);
		if (select_env == null) throw new System.InvalidOperationException("Field selector in let did not collect and environment.");
		if (definitions != null) { foreach (var f00000003b2 in definitions) f00000003b2.PropagateEnvironment(_collector, _queue, select_env, ref _success); }
		inner_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, select_env, true);
		if (definitions != null) foreach (var f00000003kf in definitions) {
			f00000003kf.AddMask(_collector, inner_environment);
		}
		_return = inner_environment;
		return _return;
	}
	Environment select_env;
	Environment inner_environment;
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000003WI = NameInfo.AnyType;
		if (definitions != null) foreach (var f00000003WI_item in definitions) f00000003WI &= f00000003WI_item.EnsureType(_collector, _type, ref _success, true);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		selector.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000003dj) => {
			_generator.DebugPosition(this);
			var f00000003rl = _generator.MakeField("let_iterator_inputs", typeof(IAttributeNames[]));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003rl.Field);
			int f00000005Lc_next;
			f00000005Lc_next = _generator.DefineState();
			f00000003rl.Load(_generator);
			if (!typeof(IAttributeNames).IsAssignableFrom(f00000003dj.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f00000003dj.BackingType)));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
			f00000003dj.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
			_generator.JumpToState(f00000005Lc_next);
			_generator.MarkState(f00000005Lc_next);
			var f00000003dk = _generator.MakeField("let_iterator_accumulator", typeof(Flabbergast.MutableFrame));
			var f00000003dk_start_block = _generator.DefineState();
			LoadableValue f00000003rm = _source_reference;
			var f00000003kk = _generator.MakeField("let_new_frame", typeof(MutableFrame));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.LoadTaskMaster();
			_generator.AmendSourceReference(this, "fricassée Let", f00000003rm, null);
			_context.Load(_generator);
			_self_frame.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003kk.Field);
			_generator.CopyField(f00000003kk, f00000003dk);
			_generator.JumpToState(f00000003dk_start_block);
			_generator.MarkState(f00000003dk_start_block);
			var f00000003dk_dispatchers = new int[ 2 ];
			for(var f00000004U1_it = 0; f00000004U1_it < f00000003dk_dispatchers.Length; f00000004U1_it++) { f00000003dk_dispatchers[f00000004U1_it] = _generator.DefineState(); }
			var f00000003dk_iterator = _generator.MakeField("let_iterator", typeof(MergeIterator));
			#pragma warning disable 219
			var f00000003dk_key = new MethodValue(f00000003dk_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
			var f00000003dk_ordinal = new MethodValue(f00000003dk_iterator, typeof(MergeIterator).GetMethod("get_Position"));
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000003rl.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003dk_dispatchers[1]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003dk_dispatchers[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
			#pragma warning disable 219
			var f00000003dk_position = 2;
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003dk_iterator.Field);
			var f00000003dk_next = _generator.DefineState();
			_generator.JumpToState(f00000003dk_next);
			_generator.MarkState(f00000003dk_next);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000003dk_iterator.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
			f00000003rm = _generator.PushIteratorSourceReference(this, f00000003dk_iterator, _source_reference);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
			_generator.MarkState(f00000003dk_dispatchers[1]);
			var f000000043a = _generator.MakeField("let_Call", typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000003dj.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000003dj.BackingType)));
			_generator.LoadReboxed(f00000003dj, typeof(Flabbergast.Frame));
			if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
			_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000043a.Field);
			_generator.StartInterlock(1);
			_generator.LoadTaskMaster();
			f00000003rm.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			f00000003dk_key.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
			f000000043a.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
			var f00000003uF = _generator.MakeField("lookup", typeof(object));
			_generator.GenerateConsumeResult(f00000003uF, true);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
			_generator.StopInterlock();
			_generator.DynamicTypeDispatch(f00000003uF, f00000003rm, new System.Type[] { typeof(Flabbergast.Frame)}, (f00000004ER) => {
				_generator.DebugPosition(this);
				var f0000000462 = _generator.MakeField("let_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000004ER.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000004ER.BackingType)));
				_generator.LoadReboxed(f00000004ER, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(_context.BackingType)));
				_generator.LoadReboxed(_context, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f0000000462.Field);
				select_env.GenerateLookupCache(_generator, null, _cache, f00000003rm, f0000000462, _self_frame, (f0000000463_context, f0000000463_cache) => {
					_generator.DebugPosition(this);
					_generator.DynamicTypeDispatch(f00000003uF, f00000003rm, new System.Type[] { typeof(Flabbergast.Frame)}, (f00000004Yi) => {
						_generator.DebugPosition(this);
						var f00000004Tz = _generator.MakeField("let_Call", typeof(Flabbergast.Context));
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
						if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000004Yi.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000004Yi.BackingType)));
						_generator.LoadReboxed(f00000004Yi, typeof(Flabbergast.Frame));
						if (!typeof(Flabbergast.Context).IsAssignableFrom(f0000000463_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(f0000000463_context.BackingType)));
						_generator.LoadReboxed(f0000000463_context, typeof(Flabbergast.Context));
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004Tz.Field);
						_generator.DynamicTypeDispatch(f00000003uF, f00000003rm, new System.Type[] { typeof(Flabbergast.Frame)}, (f00000004Ty) => {
							_generator.DebugPosition(this);
							var f00000004U0 = _generator.PushSourceReference(this, f00000003rm);
							var f00000004eT = _generator.MakeField("let_iterator_inputs", typeof(IAttributeNames[]));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004eT.Field);
							int f00000005Bg_next;
							f00000005Bg_next = _generator.DefineState();
							f00000004eT.Load(_generator);
							if (!typeof(IAttributeNames).IsAssignableFrom(f00000004Ty.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f00000004Ty.BackingType)));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
							f00000004Ty.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
							_generator.JumpToState(f00000005Bg_next);
							_generator.MarkState(f00000005Bg_next);
							var f00000004Yk = _generator.MakeField("let_iterator_accumulator", typeof(Flabbergast.MutableFrame));
							var f00000004Yk_start_block = _generator.DefineState();
							var f00000004cS = _generator.MakeField("let_new_frame", typeof(MutableFrame));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
							_generator.LoadTaskMaster();
							_generator.AmendSourceReference(this, "fricassée Let", f00000004U0, null);
							f00000004Tz.Load(_generator);
							_self_frame.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004cS.Field);
							_generator.CopyField(f00000004cS, f00000004Yk);
							_generator.JumpToState(f00000004Yk_start_block);
							_generator.MarkState(f00000004Yk_start_block);
							var f00000004Yk_dispatchers = new int[ 2 + definitions.Count ];
							for(var f000000051x_it = 0; f000000051x_it < f00000004Yk_dispatchers.Length; f000000051x_it++) { f00000004Yk_dispatchers[f000000051x_it] = _generator.DefineState(); }
							var f00000004Yk_iterator = _generator.MakeField("let_iterator", typeof(MergeIterator));
							#pragma warning disable 219
							var f00000004Yk_key = new MethodValue(f00000004Yk_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
							var f00000004Yk_ordinal = new MethodValue(f00000004Yk_iterator, typeof(MergeIterator).GetMethod("get_Position"));
							#pragma warning restore 219
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
							f00000004eT.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000004Yk_dispatchers[1]);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000004Yk_dispatchers[0]);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
							#pragma warning disable 219
							var f00000004Yk_position = 2;
							#pragma warning restore 219
							foreach (var f00000004eV in definitions) {
								_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
								_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldstr, Generator.ToString(f00000004eV.name));
								_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000004Yk_dispatchers[f00000004Yk_position++]);
								_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("AddDispatcher", new System.Type[] { typeof(string), typeof(int) }));
							}
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004Yk_iterator.Field);
							var f00000004Yk_next = _generator.DefineState();
							_generator.JumpToState(f00000004Yk_next);
							_generator.MarkState(f00000004Yk_next);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
							f00000004Yk_iterator.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
							_generator.MarkState(f00000004Yk_dispatchers[1]);
							var f00000004gQ = _generator.MakeField("let_Call", typeof(Flabbergast.Context));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
							if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000004Ty.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000004Ty.BackingType)));
							_generator.LoadReboxed(f00000004Ty, typeof(Flabbergast.Frame));
							if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
							_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004gQ.Field);
							_generator.StartInterlock(1);
							_generator.LoadTaskMaster();
							f00000004U0.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
							f00000004Yk_key.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
							f00000004gQ.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
							var f00000004eS = _generator.MakeField("lookup", typeof(object));
							_generator.GenerateConsumeResult(f00000004eS, true);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
							_generator.StopInterlock();
							if (!typeof(Template).IsAssignableFrom(f00000004Yk.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000004Yk.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000004Yk.BackingType)));
							f00000004Yk.Load(_generator);
							f00000004Yk_key.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
							var f000000052d_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000004Yk.BackingType);
							var f000000052d_boxed_type = f000000052d_is_frame ? typeof(object) : typeof(ComputeValue);
							_generator.LoadReboxed(f00000004eS, f000000052d_boxed_type);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000004Yk.BackingType.GetMethod(f000000052d_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f000000052d_boxed_type }));
							_generator.CopyField(f00000004Yk, f00000004Yk);
							_generator.JumpToState(f00000004Yk_next);
							f00000004Yk_position = 2;
							foreach (var f00000004eV in definitions) {
								_generator.MarkState(f00000004Yk_dispatchers[f00000004Yk_position++]);
								f00000004eV.Generate(_generator, f0000000463_cache, f00000004U0, f00000004Tz, _self_frame, _container_frame, (f00000004jE) => {
									_generator.DebugPosition(this);
									if (!typeof(Template).IsAssignableFrom(f00000004Yk.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000004Yk.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000004Yk.BackingType)));
									f00000004Yk.Load(_generator);
									f00000004Yk_key.Load(_generator);
									_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
									var f000000054t_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000004Yk.BackingType);
									var f000000054t_boxed_type = f000000054t_is_frame ? typeof(object) : typeof(ComputeValue);
									_generator.LoadReboxed(f00000004jE, f000000054t_boxed_type);
									_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000004Yk.BackingType.GetMethod(f000000054t_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f000000054t_boxed_type }));
									_generator.CopyField(f00000004Yk, f00000004Yk);
									_generator.JumpToState(f00000004Yk_next);
								});
							}
							_generator.MarkState(f00000004Yk_dispatchers[0]);
							if (!typeof(Template).IsAssignableFrom(f00000003dk.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000003dk.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000003dk.BackingType)));
							f00000003dk.Load(_generator);
							f00000003dk_key.Load(_generator);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
							var f00000004xr_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000003dk.BackingType);
							var f00000004xr_boxed_type = f00000004xr_is_frame ? typeof(object) : typeof(ComputeValue);
							_generator.LoadReboxed(f00000004Yk, f00000004xr_boxed_type);
							_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000003dk.BackingType.GetMethod(f00000004xr_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000004xr_boxed_type }));
						_generator.CopyField(f00000003dk, f00000003dk);
						_generator.JumpToState(f00000003dk_next);
						});
					});
				});
			});
			f00000003dk_position = 2;
			_generator.MarkState(f00000003dk_dispatchers[0]);
			_final_block(f00000003dk);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		selector.GenerateApi(_api_gen, false);
		foreach(var f00000003b0 in definitions) 			f00000003b0.GenerateApi(_api_gen, false);
	}
	internal selector_let Clone() {
		var _obj = new selector_let();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.selector = selector;
		_obj.definitions.AddRange(definitions);
		foreach(var _element in definitions_dedup.Keys) _obj.definitions_dedup[_element] = true;
		return _obj;
	}
}
internal class selector_merge : selector {
	public override string PrettyName { get { return "fricassée merge input"; } }
	internal System.Collections.Generic.List<fricassee_merge_input> inputs = new System.Collections.Generic.List<fricassee_merge_input>();
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (inputs != null) { foreach (var f00000003WL in inputs) f00000003WL.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		merge_environment = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, _environment, false);
		if (inputs != null) foreach (var f00000003du in inputs) {
			f00000003du.AddMask(_collector, merge_environment);
		}
		_return = merge_environment;
		return _return;
	}
	Environment merge_environment;
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000003j0 = _generator.MakeField("merge_iterator_inputs", typeof(IAttributeNames[]));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, inputs.Where(x => x.NeedsGeneration).Count());
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003j0.Field);
		var f00000004tx_pos = 0;
		var f00000003j0_matched_frames = new System.Collections.Generic.Dictionary<AstNode, int>();
		foreach(var f00000004tx in inputs.Where(x => x.NeedsGeneration)) {
			f00000003j0_matched_frames[f00000004tx] = f00000004tx_pos;
			var f00000004tx_next = _generator.DefineState();
			f00000004tx.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000004tx_result) => {
				f00000003j0.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000004tx_pos);
				f00000004tx_result.Load(_generator);
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
				_generator.JumpToState(f00000004tx_next);
			});
			_generator.MarkState(f00000004tx_next);
			f00000004tx_pos++;
		}
		var f00000003WN = _generator.MakeField("merge_iterator_accumulator", typeof(Flabbergast.MutableFrame));
		var f00000003WN_start_block = _generator.DefineState();
		var f00000003bN = _generator.MakeField("merge_new_frame", typeof(MutableFrame));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
		_generator.LoadTaskMaster();
		_generator.AmendSourceReference(this, "fricassée merge", _source_reference, null);
		_context.Load(_generator);
		_self_frame.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003bN.Field);
		_generator.CopyField(f00000003bN, f00000003WN);
		_generator.JumpToState(f00000003WN_start_block);
		_generator.MarkState(f00000003WN_start_block);
		var f00000003WN_dispatchers = new int[ 2 ];
		for(var f00000003iz_it = 0; f00000003iz_it < f00000003WN_dispatchers.Length; f00000003iz_it++) { f00000003WN_dispatchers[f00000003iz_it] = _generator.DefineState(); }
		var f00000003WN_iterator = _generator.MakeField("merge_iterator", typeof(MergeIterator));
		#pragma warning disable 219
		var f00000003WN_key = new MethodValue(f00000003WN_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
		var f00000003WN_ordinal = new MethodValue(f00000003WN_iterator, typeof(MergeIterator).GetMethod("get_Position"));
		#pragma warning restore 219
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
		f00000003j0.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003WN_dispatchers[1]);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003WN_dispatchers[0]);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
		#pragma warning disable 219
		var f00000003WN_position = 2;
		#pragma warning restore 219
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003WN_iterator.Field);
		var f00000003WN_next = _generator.DefineState();
		_generator.JumpToState(f00000003WN_next);
		_generator.MarkState(f00000003WN_next);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
		f00000003WN_iterator.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
		_generator.MarkState(f00000003WN_dispatchers[1]);
		var f00000003pz = _generator.MakeField("merge_merge_frame", typeof(MutableFrame));
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
		_generator.LoadTaskMaster();
		_source_reference.Load(_generator);
		_context.Load(_generator);
		_self_frame.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003pz.Field);
		foreach(var f00000004Eg in inputs) {
			f00000004Eg.PrepareValue(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, f00000003j0_matched_frames.ContainsKey(f00000004Eg) ? new MatchedFrameValue(f00000003j0_matched_frames[f00000004Eg], f00000003j0) : null, f00000003WN_ordinal, f00000003WN_key, f00000003pz);
		}
		if (!typeof(Template).IsAssignableFrom(f00000003WN.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000003WN.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000003WN.BackingType)));
		f00000003WN.Load(_generator);
		f00000003WN_key.Load(_generator);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
		var f00000003xU_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000003WN.BackingType);
		var f00000003xU_boxed_type = f00000003xU_is_frame ? typeof(object) : typeof(ComputeValue);
		_generator.LoadReboxed(f00000003pz, f00000003xU_boxed_type);
		_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000003WN.BackingType.GetMethod(f00000003xU_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000003xU_boxed_type }));
		_generator.CopyField(f00000003WN, f00000003WN);
		_generator.JumpToState(f00000003WN_next);
		f00000003WN_position = 2;
		_generator.MarkState(f00000003WN_dispatchers[0]);
		_final_block(f00000003WN);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		foreach(var f00000003WJ in inputs) 			f00000003WJ.GenerateApi(_api_gen, false);
	}
	internal selector_merge Clone() {
		var _obj = new selector_merge();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.inputs.AddRange(inputs);
		return _obj;
	}
}
internal class selector_order_by : selector {
	public override string PrettyName { get { return "fricassée Order By clause"; } }
	internal selector selector;
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (_return != null) throw new System.InvalidOperationException("Refusing to overwrite return value.");
		if (selector == null) throw new System.InvalidOperationException("Field selector in order_by is empty.");
		select_env = selector.PropagateEnvironment(_collector, _queue, _environment, ref _success);
		if (select_env == null) throw new System.InvalidOperationException("Field selector in order_by did not collect and environment.");
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, select_env, ref _success); }
		_return = select_env;
		return _return;
	}
	Environment select_env;
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000003WY = _type;
		for(var f00000003WY_junk = 0; f00000003WY_junk < 2; f00000003WY_junk++) {
			var f00000003bm = NameInfo.AnyType;
			var f00000003qB = f00000003WY & (0 | Flabbergast.Type.Int | Flabbergast.Type.Float | Flabbergast.Type.Str);
			if (f00000003qB == 0) {
				_success = false;
				_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Int | Flabbergast.Type.Float | Flabbergast.Type.Str, f00000003WY);
			}
			var f00000003xy =  f00000003qB;
			if (expression != null) f00000003xy &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, f00000003qB, ref _success, true), f00000003qB);
			if ((f00000003xy & (f00000003xy -1 )) != 0) {
				_collector.ReportSingleTypeError(this, f00000003xy);
				_success = false;
			}
			f00000003bm &= f00000003xy;
			var f00000003jT = Environment.EnsureIntrinsic(_collector, this, f00000003WY, true, ref _success);
			f00000003bm &= f00000003jT;
			f00000003WY &= f00000003bm;
		}
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		selector.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000003e6) => {
			_generator.DebugPosition(this);
			var f00000003sA = _generator.MakeField("order_by_iterator_inputs", typeof(IAttributeNames[]));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003sA.Field);
			int f00000005IK_next;
			f00000005IK_next = _generator.DefineState();
			f00000003sA.Load(_generator);
			if (!typeof(IAttributeNames).IsAssignableFrom(f00000003e6.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f00000003e6.BackingType)));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
			f00000003e6.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
			_generator.JumpToState(f00000005IK_next);
			_generator.MarkState(f00000005IK_next);
			var f00000003e7 = _generator.MakeField("order_by_iterator_accumulator", typeof(Flabbergast.MutableFrame));
			var f00000003e7_start_block = _generator.DefineState();
			LoadableValue f00000003sB = _source_reference;
			var f00000003kt = _generator.MakeField("order_by_new_frame", typeof(MutableFrame));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.LoadTaskMaster();
			_generator.AmendSourceReference(this, "defined", f00000003sB, null);
			_context.Load(_generator);
			_self_frame.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003kt.Field);
			_generator.CopyField(f00000003kt, f00000003e7);
			_generator.JumpToState(f00000003e7_start_block);
			_generator.MarkState(f00000003e7_start_block);
			var f00000003e7_type = typeof(OrderByIterator<>).MakeGenericType(Environment.GetIntrinsicRealTypes(this));
			var f00000004U8_setup = _generator.DefineState();
			var f00000004U8_process = _generator.DefineState();
			var f00000004U8_end = _generator.DefineState();
			var f00000003e7_iterator = _generator.MakeField("order_by_iterator", f00000003e7_type);
			#pragma warning disable 219
			var f00000003e7_key = new MethodValue(f00000003e7_iterator, f00000003e7_type.GetMethod("get_Currentish"));
			var f00000003e7_ordinal = new MethodValue(f00000003e7_iterator, f00000003e7_type.GetMethod("get_Position"));
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000003sA.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, f00000003e7_type.GetConstructors()[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003e7_iterator.Field);
			_generator.JumpToState(f00000004U8_setup);
			_generator.MarkState(f00000004U8_setup);
			f00000003e7_iterator.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000003e7_type.GetMethod("SetupNext"));
			var f00000004U8_build_label = _generator.Builder.DefineLabel();
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Brtrue, f00000004U8_build_label);
			_generator.JumpToState(f00000004U8_process);
			_generator.Builder.MarkLabel(f00000004U8_build_label);
			var f00000004Kc = _generator.MakeField("order_by_Call", typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000003e6.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000003e6.BackingType)));
			_generator.LoadReboxed(f00000003e6, typeof(Flabbergast.Frame));
			if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
			_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000004Kc.Field);
			_generator.StartInterlock(1);
			_generator.LoadTaskMaster();
			f00000003sB.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			f00000003e7_key.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
			f00000004Kc.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
			var f00000004CY = _generator.MakeField("lookup", typeof(object));
			_generator.GenerateConsumeResult(f00000004CY, true);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
			_generator.StopInterlock();
			_generator.DynamicTypeDispatch(f00000004CY, f00000003sB, new System.Type[] { typeof(Flabbergast.Frame)}, (f000000043z) => {
				_generator.DebugPosition(this);
				var f00000003ub = _generator.MakeField("order_by_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f000000043z.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f000000043z.BackingType)));
				_generator.LoadReboxed(f000000043z, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(_context.BackingType)));
				_generator.LoadReboxed(_context, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003ub.Field);
				select_env.GenerateLookupCache(_generator, null, _cache, f00000003sB, f00000003ub, _self_frame, (f00000003uc_context, f00000003uc_cache) => {
					_generator.DebugPosition(this);
					expression.Generate(_generator, f00000003uc_cache, f00000003sB, f00000003uc_context, _self_frame, _container_frame, (f0000000440) => {
						_generator.DebugPosition(this);
					f00000003e7_iterator.Load(_generator);
					f0000000440.Load(_generator);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000003e7_type.GetMethod("SetupReturn", Environment.GetIntrinsicRealTypes(this)));
					_generator.JumpToState(f00000004U8_setup);
					});
				});
			});
			_generator.MarkState(f00000004U8_process);
			f00000003e7_iterator.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000003e7_type.GetMethod("Next"));
			var f00000004U8_cont = _generator.Builder.DefineLabel();
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Brtrue, f00000004U8_cont);
			_generator.JumpToState(f00000004U8_end);
			_generator.Builder.MarkLabel(f00000004U8_cont);
			f00000003sB = _generator.PushIteratorSourceReference(this, f00000003e7_iterator, _source_reference);
			var f00000003sC = new GeneratedValue(typeof(Flabbergast.Stringish), (f000000054F_builder) => {
			if (!typeof(long).IsAssignableFrom(f00000003e7_ordinal.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Call.", Stringish.NameForType(f00000003e7_ordinal.BackingType)));
			_generator.LoadReboxed(f00000003e7_ordinal, typeof(long));
			f000000054F_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(TaskMaster).GetMethod("OrdinalName", new System.Type[] { typeof(long) }));
			});
			var f00000003zw = _generator.MakeField("order_by_Call", typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000003e6.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000003e6.BackingType)));
			_generator.LoadReboxed(f00000003e6, typeof(Flabbergast.Frame));
			if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
			_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003zw.Field);
			_generator.StartInterlock(1);
			_generator.LoadTaskMaster();
			f00000003sB.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			f00000003e7_key.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
			f00000003zw.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
			var f00000003sD = _generator.MakeField("lookup", typeof(object));
			_generator.GenerateConsumeResult(f00000003sD, true);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
			_generator.StopInterlock();
			if (!typeof(Template).IsAssignableFrom(f00000003e7.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000003e7.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000003e7.BackingType)));
			f00000003e7.Load(_generator);
			f00000003sC.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			var f00000004gV_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000003e7.BackingType);
			var f00000004gV_boxed_type = f00000004gV_is_frame ? typeof(object) : typeof(ComputeValue);
			_generator.LoadReboxed(f00000003sD, f00000004gV_boxed_type);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000003e7.BackingType.GetMethod(f00000004gV_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000004gV_boxed_type }));
			_generator.CopyField(f00000003e7, f00000003e7);
			_generator.JumpToState(f00000004U8_process);
			_generator.MarkState(f00000004U8_end);
			_final_block(f00000003e7);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		selector.GenerateApi(_api_gen, false);
		expression.GenerateApi(_api_gen, false);
	}
	internal selector_order_by Clone() {
		var _obj = new selector_order_by();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.selector = selector;
		_obj.expression = expression;
		return _obj;
	}
}
internal class selector_reverse : selector {
	public override string PrettyName { get { return "fricassée Reverse clause"; } }
	internal selector selector;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (_return != null) throw new System.InvalidOperationException("Refusing to overwrite return value.");
		if (selector == null) throw new System.InvalidOperationException("Field selector in reverse is empty.");
		select_env = selector.PropagateEnvironment(_collector, _queue, _environment, ref _success);
		if (select_env == null) throw new System.InvalidOperationException("Field selector in reverse did not collect and environment.");
		_return = select_env;
		return _return;
	}
	Environment select_env;
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		selector.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000003eH) => {
			_generator.DebugPosition(this);
			var f00000003sT = _generator.MakeField("reverse_iterator_inputs", typeof(IAttributeNames[]));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003sT.Field);
			int f00000005HT_next;
			f00000005HT_next = _generator.DefineState();
			f00000003sT.Load(_generator);
			if (!typeof(IAttributeNames).IsAssignableFrom(f00000003eH.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f00000003eH.BackingType)));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
			f00000003eH.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
			_generator.JumpToState(f00000005HT_next);
			_generator.MarkState(f00000005HT_next);
			var f00000003eI = _generator.MakeField("reverse_iterator_accumulator", typeof(Flabbergast.MutableFrame));
			var f00000003eI_start_block = _generator.DefineState();
			LoadableValue f00000003sU = _source_reference;
			var f00000003l2 = _generator.MakeField("reverse_new_frame", typeof(MutableFrame));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.LoadTaskMaster();
			_generator.AmendSourceReference(this, "defined", f00000003sU, null);
			_context.Load(_generator);
			_self_frame.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003l2.Field);
			_generator.CopyField(f00000003l2, f00000003eI);
			_generator.JumpToState(f00000003eI_start_block);
			_generator.MarkState(f00000003eI_start_block);
			var f00000003eI_dispatchers = new int[ 2 ];
			for(var f00000004UF_it = 0; f00000004UF_it < f00000003eI_dispatchers.Length; f00000004UF_it++) { f00000003eI_dispatchers[f00000004UF_it] = _generator.DefineState(); }
			var f00000003eI_iterator = _generator.MakeField("reverse_iterator", typeof(MergeIterator));
			#pragma warning disable 219
			var f00000003eI_key = new MethodValue(f00000003eI_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
			var f00000003eI_ordinal = new MethodValue(f00000003eI_iterator, typeof(MergeIterator).GetMethod("get_Position"));
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000003sT.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003eI_dispatchers[1]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003eI_dispatchers[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
			#pragma warning disable 219
			var f00000003eI_position = 2;
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003eI_iterator.Field);
			var f00000003eI_next = _generator.DefineState();
			_generator.JumpToState(f00000003eI_next);
			_generator.MarkState(f00000003eI_next);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000003eI_iterator.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
			f00000003sU = _generator.PushIteratorSourceReference(this, f00000003eI_iterator, _source_reference);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
			_generator.MarkState(f00000003eI_dispatchers[1]);
			var f000000044H = _generator.MakeField("reverse_Call", typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000003eH.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000003eH.BackingType)));
			_generator.LoadReboxed(f00000003eH, typeof(Flabbergast.Frame));
			if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
			_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000044H.Field);
			_generator.StartInterlock(1);
			_generator.LoadTaskMaster();
			f00000003sU.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			f00000003eI_key.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
			f000000044H.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
			var f00000003up = _generator.MakeField("lookup", typeof(object));
			_generator.GenerateConsumeResult(f00000003up, true);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
			_generator.StopInterlock();
			_generator.DynamicTypeDispatch(f00000003up, f00000003sU, new System.Type[] { typeof(Flabbergast.Frame)}, (f00000004FN) => {
				_generator.DebugPosition(this);
				var f0000000471 = _generator.MakeField("reverse_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000004FN.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000004FN.BackingType)));
				_generator.LoadReboxed(f00000004FN, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(_context.BackingType)));
				_generator.LoadReboxed(_context, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f0000000471.Field);
				select_env.GenerateLookupCache(_generator, null, _cache, f00000003sU, f0000000471, _self_frame, (f0000000472_context, f0000000472_cache) => {
					_generator.DebugPosition(this);
					var f00000004Sz = new GeneratedValue(typeof(long), (f000000052i_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000003eI_ordinal.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Neg.", Stringish.NameForType(f00000003eI_ordinal.BackingType)));
					_generator.LoadReboxed(f00000003eI_ordinal, typeof(long));
					f000000052i_builder.Emit(System.Reflection.Emit.OpCodes.Neg);
					});
					var f00000004Mf = new GeneratedValue(typeof(Flabbergast.Stringish), (f00000004y6_builder) => {
					if (!typeof(long).IsAssignableFrom(f00000004Sz.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Call.", Stringish.NameForType(f00000004Sz.BackingType)));
					_generator.LoadReboxed(f00000004Sz, typeof(long));
					f00000004y6_builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(TaskMaster).GetMethod("OrdinalName", new System.Type[] { typeof(long) }));
					});
					if (!typeof(Template).IsAssignableFrom(f00000003eI.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000003eI.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000003eI.BackingType)));
					f00000003eI.Load(_generator);
					f00000004Mf.Load(_generator);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
					var f00000004vW_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000003eI.BackingType);
					var f00000004vW_boxed_type = f00000004vW_is_frame ? typeof(object) : typeof(ComputeValue);
					_generator.LoadReboxed(f00000003up, f00000004vW_boxed_type);
					_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000003eI.BackingType.GetMethod(f00000004vW_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000004vW_boxed_type }));
				_generator.CopyField(f00000003eI, f00000003eI);
				_generator.JumpToState(f00000003eI_next);
				});
			});
			f00000003eI_position = 2;
			_generator.MarkState(f00000003eI_dispatchers[0]);
			_final_block(f00000003eI);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		selector.GenerateApi(_api_gen, false);
	}
	internal selector_reverse Clone() {
		var _obj = new selector_reverse();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.selector = selector;
		return _obj;
	}
}
internal class selector_where : selector {
	public override string PrettyName { get { return "fricassée Where clause"; } }
	internal selector selector;
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (_return != null) throw new System.InvalidOperationException("Refusing to overwrite return value.");
		if (selector == null) throw new System.InvalidOperationException("Field selector in where is empty.");
		select_env = selector.PropagateEnvironment(_collector, _queue, _environment, ref _success);
		if (select_env == null) throw new System.InvalidOperationException("Field selector in where did not collect and environment.");
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, select_env, ref _success); }
		target_env = new Environment(FileName, StartRow, StartColumn, EndRow, EndColumn, select_env, false);
		_return = target_env;
		return _return;
	}
	Environment select_env;
	Environment target_env;
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000003Wq = _type & (0 | Flabbergast.Type.Bool);
		if (f00000003Wq == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool, _type);
		}
		var f00000003cI =  f00000003Wq;
		if (expression != null) f00000003cI &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, f00000003Wq, ref _success, true), f00000003Wq);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		selector.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000003eU) => {
			_generator.DebugPosition(this);
			var f00000003si = _generator.MakeField("where_iterator_inputs", typeof(IAttributeNames[]));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(IAttributeNames));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003si.Field);
			int f00000005ES_next;
			f00000005ES_next = _generator.DefineState();
			f00000003si.Load(_generator);
			if (!typeof(IAttributeNames).IsAssignableFrom(f00000003eU.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-collection {0} in iteration.", Stringish.NameForType(f00000003eU.BackingType)));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, 0);
			f00000003eU.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(IAttributeNames));
			_generator.JumpToState(f00000005ES_next);
			_generator.MarkState(f00000005ES_next);
			var f00000003eV = _generator.MakeField("where_iterator_accumulator", typeof(Flabbergast.MutableFrame));
			var f00000003eV_start_block = _generator.DefineState();
			LoadableValue f00000003sj = _source_reference;
			var f00000003lA = _generator.MakeField("where_new_frame", typeof(MutableFrame));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.LoadTaskMaster();
			_generator.AmendSourceReference(this, "defined", f00000003sj, null);
			_context.Load(_generator);
			_self_frame.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MutableFrame).GetConstructors()[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003lA.Field);
			_generator.CopyField(f00000003lA, f00000003eV);
			_generator.JumpToState(f00000003eV_start_block);
			_generator.MarkState(f00000003eV_start_block);
			var f00000003eV_dispatchers = new int[ 2 ];
			for(var f00000004UJ_it = 0; f00000004UJ_it < f00000003eV_dispatchers.Length; f00000004UJ_it++) { f00000003eV_dispatchers[f00000004UJ_it] = _generator.DefineState(); }
			var f00000003eV_iterator = _generator.MakeField("where_iterator", typeof(MergeIterator));
			#pragma warning disable 219
			var f00000003eV_key = new MethodValue(f00000003eV_iterator, typeof(MergeIterator).GetMethod("get_Currentish"));
			var f00000003eV_ordinal = new MethodValue(f00000003eV_iterator, typeof(MergeIterator).GetMethod("get_Position"));
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000003si.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003eV_dispatchers[1]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4, f00000003eV_dispatchers[0]);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(MergeIterator).GetConstructors()[0]);
			#pragma warning disable 219
			var f00000003eV_position = 2;
			#pragma warning restore 219
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f00000003eV_iterator.Field);
			var f00000003eV_next = _generator.DefineState();
			_generator.JumpToState(f00000003eV_next);
			_generator.MarkState(f00000003eV_next);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			f00000003eV_iterator.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(MergeIterator).GetMethod("Next"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, _generator.StateField);
			f00000003sj = _generator.PushIteratorSourceReference(this, f00000003eV_iterator, _source_reference);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Tailcall);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Computation).GetMethod("Run", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ret);
			_generator.MarkState(f00000003eV_dispatchers[1]);
			var f000000044T = _generator.MakeField("where_Call", typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
			if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000003eU.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000003eU.BackingType)));
			_generator.LoadReboxed(f00000003eU, typeof(Flabbergast.Frame));
			if (!typeof(Flabbergast.Context).IsAssignableFrom(LoadableValue.NULL_LIST.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(LoadableValue.NULL_LIST.BackingType)));
			_generator.LoadReboxed(LoadableValue.NULL_LIST, typeof(Flabbergast.Context));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000044T.Field);
			_generator.StartInterlock(1);
			_generator.LoadTaskMaster();
			f00000003sj.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_1);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newarr, typeof(string));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Dup);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldc_I4_0);
			f00000003eV_key.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stelem, typeof(string));
			f000000044T.Load(_generator);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(Lookup).GetConstructors()[0]);
			var f00000003ux = _generator.MakeField("lookup", typeof(object));
			_generator.GenerateConsumeResult(f00000003ux, true);
			_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Lookup).GetMethod("Notify", new System.Type[] { typeof(ConsumeResult) }));
			_generator.StopInterlock();
			_generator.DynamicTypeDispatch(f00000003ux, f00000003sj, new System.Type[] { typeof(Flabbergast.Frame)}, (f00000004FZ) => {
				_generator.DebugPosition(this);
				var f000000047E = _generator.MakeField("where_Call", typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Ldarg_0);
				if (!typeof(Flabbergast.Frame).IsAssignableFrom(f00000004FZ.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Frame but got {0} in Call.", Stringish.NameForType(f00000004FZ.BackingType)));
				_generator.LoadReboxed(f00000004FZ, typeof(Flabbergast.Frame));
				if (!typeof(Flabbergast.Context).IsAssignableFrom(_context.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  List but got {0} in Call.", Stringish.NameForType(_context.BackingType)));
				_generator.LoadReboxed(_context, typeof(Flabbergast.Context));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, typeof(Context).GetMethod("Prepend", new System.Type[] { typeof(Frame), typeof(Context) }));
				_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Stfld, f000000047E.Field);
				select_env.GenerateLookupCache(_generator, null, _cache, f00000003sj, f000000047E, _self_frame, (f000000047F_context, f000000047F_cache) => {
					_generator.DebugPosition(this);
					_generator.ConditionalFlow((f00000004v0_cond) => {
						expression.Generate(_generator, f000000047F_cache, f00000003sj, f000000047F_context, _self_frame, _container_frame, (f00000004Mn) => {
							_generator.DebugPosition(this);
						f00000004v0_cond(f00000004Mn);
						});
					}, (f00000004v0_true) => {
						if (!typeof(Template).IsAssignableFrom(f00000003eV.BackingType) && !typeof(MutableFrame).IsAssignableFrom(f00000003eV.BackingType)) throw new System.InvalidOperationException(System.String.Format("Use of non-mutable collection {0} in iteration.", Stringish.NameForType(f00000003eV.BackingType)));
						f00000003eV.Load(_generator);
						f00000003eV_key.Load(_generator);
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Callvirt, typeof(Stringish).GetMethod("ToString"));
						var f00000004vZ_is_frame = typeof(MutableFrame).IsAssignableFrom(f00000003eV.BackingType);
						var f00000004vZ_boxed_type = f00000004vZ_is_frame ? typeof(object) : typeof(ComputeValue);
						_generator.LoadReboxed(f00000003ux, f00000004vZ_boxed_type);
						_generator.Builder.Emit(System.Reflection.Emit.OpCodes.Call, f00000003eV.BackingType.GetMethod(f00000004vZ_is_frame ? "Set" : "set_Item", new System.Type[] { typeof(string), f00000004vZ_boxed_type }));
					f00000004v0_true(f00000003eV);
					}, (f00000004v0_false) => {
					f00000004v0_false(f00000003eV);
					}, (f00000004Fa) => {
					_generator.CopyField(f00000004Fa, f00000003eV);
					_generator.JumpToState(f00000003eV_next);
					});
				});
			});
			f00000003eV_position = 2;
			_generator.MarkState(f00000003eV_dispatchers[0]);
			_final_block(f00000003eV);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		selector.GenerateApi(_api_gen, false);
		expression.GenerateApi(_api_gen, false);
	}
	internal selector_where Clone() {
		var _obj = new selector_where();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.selector = selector;
		_obj.expression = expression;
		return _obj;
	}
}
internal abstract class string_piece : AstTypeableNode {
	internal RevCons<char> comment = null;
	internal static bool ParseRule_Base(ref ParserPosition position, out string_piece result) {
		position.TraceEnter("string_piece");
		if(position.CheckCache<string_piece>("string_piece", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("any string_piece", "string_piece");		slave_position = position.Clone();
		if (ParseRule_expression_escape(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("string_piece", true);
			position.Cache<string_piece>("string_piece", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_literal_string(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("string_piece", true);
			position.Cache<string_piece>("string_piece", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("string_piece", false);
		position.Cache<string_piece>("string_piece", start_index, null);
		return false;
	}
	internal static bool ParseRule_expression_escape(ref ParserPosition _position, out string_piece _result) {
		if(_position.CheckCache<string_piece_expression_escape, string_piece>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new string_piece_expression_escape();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("string_piece:expression_escape");

		bool _sequence_fail_f00000000BM = false;
		if (_position.Match("\\(")) {
		} else {
			_position.Update("“\\(”", "expression in string");
			_sequence_fail_f00000000BM = true;
			goto _sequence_end_f00000000BM;
		}
		while(true) {
			ParserPosition _many_position_f00000000Hm = _position.Clone();
			var _many_obj_f00000000Hm = _obj.Clone();
			bool _alternate_success_f00000000MF = false;
			ParserPosition _alt_position_f00000000MF = _position;
			var _alt_obj_f00000000MF = _obj;
			if (!_alternate_success_f00000000MF) {
				_position = _alt_position_f00000000MF.Clone();
				_obj = _alt_obj_f00000000MF.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000MF = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "expression in string");
					_position = _alt_position_f00000000MF;
					_obj = _alt_obj_f00000000MF;
				}
			}
			if (!_alternate_success_f00000000MF) {
				_position = _alt_position_f00000000MF.Clone();
				_obj = _alt_obj_f00000000MF.Clone();
				bool _sequence_fail_f00000000Rv = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "expression in string");
					_sequence_fail_f00000000Rv = true;
					goto _sequence_end_f00000000Rv;
				}
				while(true) {
					ParserPosition _many_position_f00000000Xa = _position.Clone();
					var _many_obj_f00000000Xa = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "expression in string");
						_position = _many_position_f00000000Xa;
						_obj = _many_obj_f00000000Xa;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "expression in string");
					_sequence_fail_f00000000Rv = true;
					goto _sequence_end_f00000000Rv;
				}
				_sequence_end_f00000000Rv:
				if (_sequence_fail_f00000000Rv) {
					_position = _alt_position_f00000000MF;
					_obj = _alt_obj_f00000000MF;
				} else {
					_alternate_success_f00000000MF = true;
				}
			}
			if (_alternate_success_f00000000MF) {
			} else {
				_position = _many_position_f00000000Hm;
				_obj = _many_obj_f00000000Hm;
				break;
			}
		}
		if (expression.ParseRule_expression0(ref _position, out _obj.expression)) {
		} else {
		_sequence_fail_f00000000BM = true;
		goto _sequence_end_f00000000BM;
		}
		while(true) {
			ParserPosition _many_position_f00000000Hq = _position.Clone();
			var _many_obj_f00000000Hq = _obj.Clone();
			bool _alternate_success_f00000000MG = false;
			ParserPosition _alt_position_f00000000MG = _position;
			var _alt_obj_f00000000MG = _obj;
			if (!_alternate_success_f00000000MG) {
				_position = _alt_position_f00000000MG.Clone();
				_obj = _alt_obj_f00000000MG.Clone();
				if (" \t\n\r\f\u000b".IndexOf(_position.Next()) != -1) {
					_alternate_success_f00000000MG = true;
				} else {
					_position.Update(Parser.ToLiteral(" \t\n\r\f\u000b"), "expression in string");
					_position = _alt_position_f00000000MG;
					_obj = _alt_obj_f00000000MG;
				}
			}
			if (!_alternate_success_f00000000MG) {
				_position = _alt_position_f00000000MG.Clone();
				_obj = _alt_obj_f00000000MG.Clone();
				bool _sequence_fail_f00000000Ry = false;
				if (_position.Match("#")) {
				} else {
					_position.Update("“#”", "expression in string");
					_sequence_fail_f00000000Ry = true;
					goto _sequence_end_f00000000Ry;
				}
				while(true) {
					ParserPosition _many_position_f00000000Xg = _position.Clone();
					var _many_obj_f00000000Xg = _obj.Clone();
					if ("\n".IndexOf(_position.Next()) == -1) {
						_obj.comment = new RevCons<char>(_position.PeekLast(), _obj.comment);
					} else {
						_position.Update(Parser.ToLiteral("\n"), "expression in string");
						_position = _many_position_f00000000Xg;
						_obj = _many_obj_f00000000Xg;
						break;
					}
				}
				if ("\n".IndexOf(_position.Next()) != -1) {
				} else {
					_position.Update(Parser.ToLiteral("\n"), "expression in string");
					_sequence_fail_f00000000Ry = true;
					goto _sequence_end_f00000000Ry;
				}
				_sequence_end_f00000000Ry:
				if (_sequence_fail_f00000000Ry) {
					_position = _alt_position_f00000000MG;
					_obj = _alt_obj_f00000000MG;
				} else {
					_alternate_success_f00000000MG = true;
				}
			}
			if (_alternate_success_f00000000MG) {
			} else {
				_position = _many_position_f00000000Hq;
				_obj = _many_obj_f00000000Hq;
				break;
			}
		}
		if (_position.Match(")")) {
		} else {
			_position.Update("“)”", "expression in string");
			_sequence_fail_f00000000BM = true;
			goto _sequence_end_f00000000BM;
		}
		_sequence_end_f00000000BM:
		if (_sequence_fail_f00000000BM) {
			_position.Cache<string_piece_expression_escape>(_start_index, null);
			_position.TraceExit("string_piece:expression_escape", false);
			_result = null;
			return false;
		} else {
			_position.Cache<string_piece_expression_escape>(_start_index, _obj);
			_position.TraceExit("string_piece:expression_escape", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (string_piece)_obj;
			return true;
		}
	}
	internal static bool ParseRule_literal_string(ref ParserPosition _position, out string_piece _result) {
		if(_position.CheckCache<string_piece_literal_string, string_piece>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new string_piece_literal_string();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("string_piece:literal_string");

		bool _first_f00000000EC = true;
		while(true) {
			ParserPosition _many_position_f00000000EC = _position.Clone();
			var _many_obj_f00000000EC = _obj.Clone();
			bool _alternate_success_f00000000Hz = false;
			ParserPosition _alt_position_f00000000Hz = _position;
			var _alt_obj_f00000000Hz = _obj;
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				if (_position.Match("\\a")) {
					foreach (var f00000000aC_c in System.Char.ConvertFromUtf32(7)) {
					_obj.text = new RevCons<char>(f00000000aC_c, _obj.text);
					}
					_alternate_success_f00000000Hz = true;
				} else {
					_position.Update("“\\a”", "string literal");
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				if (_position.Match("\\b")) {
					foreach (var f00000000aD_c in System.Char.ConvertFromUtf32(8)) {
					_obj.text = new RevCons<char>(f00000000aD_c, _obj.text);
					}
					_alternate_success_f00000000Hz = true;
				} else {
					_position.Update("“\\b”", "string literal");
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				if (_position.Match("\\f")) {
					foreach (var f00000000aE_c in System.Char.ConvertFromUtf32(12)) {
					_obj.text = new RevCons<char>(f00000000aE_c, _obj.text);
					}
					_alternate_success_f00000000Hz = true;
				} else {
					_position.Update("“\\f”", "string literal");
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				if (_position.Match("\\n")) {
					foreach (var f00000000aF_c in System.Char.ConvertFromUtf32(10)) {
					_obj.text = new RevCons<char>(f00000000aF_c, _obj.text);
					}
					_alternate_success_f00000000Hz = true;
				} else {
					_position.Update("“\\n”", "string literal");
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				if (_position.Match("\\r")) {
					foreach (var f00000000aG_c in System.Char.ConvertFromUtf32(13)) {
					_obj.text = new RevCons<char>(f00000000aG_c, _obj.text);
					}
					_alternate_success_f00000000Hz = true;
				} else {
					_position.Update("“\\r”", "string literal");
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				if (_position.Match("\\t")) {
					foreach (var f00000000aH_c in System.Char.ConvertFromUtf32(9)) {
					_obj.text = new RevCons<char>(f00000000aH_c, _obj.text);
					}
					_alternate_success_f00000000Hz = true;
				} else {
					_position.Update("“\\t”", "string literal");
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				if (_position.Match("\\v")) {
					foreach (var f00000000aI_c in System.Char.ConvertFromUtf32(11)) {
					_obj.text = new RevCons<char>(f00000000aI_c, _obj.text);
					}
					_alternate_success_f00000000Hz = true;
				} else {
					_position.Update("“\\v”", "string literal");
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				if (_position.Match("\\\"")) {
					foreach (var f00000000aJ_c in System.Char.ConvertFromUtf32(34)) {
					_obj.text = new RevCons<char>(f00000000aJ_c, _obj.text);
					}
					_alternate_success_f00000000Hz = true;
				} else {
					_position.Update("“\\\"”", "string literal");
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				if (_position.Match("\\\\")) {
					foreach (var f00000000aK_c in System.Char.ConvertFromUtf32(92)) {
					_obj.text = new RevCons<char>(f00000000aK_c, _obj.text);
					}
					_alternate_success_f00000000Hz = true;
				} else {
					_position.Update("“\\\\”", "string literal");
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				int _unicode_acc_f00000000MR = 0;
				bool _sequence_fail_f00000000SB = false;
				if (_position.Match("\\")) {
				} else {
					_position.Update("“\\”", "string literal");
					_sequence_fail_f00000000SB = true;
					goto _sequence_end_f00000000SB;
				}
				if (_position.Next() >= '0' && _position.PeekLast() <= '7') {
				_unicode_acc_f00000000MR = _unicode_acc_f00000000MR * 8 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “7”", "string literal");
					_sequence_fail_f00000000SB = true;
					goto _sequence_end_f00000000SB;
				}
				if (_position.Next() >= '0' && _position.PeekLast() <= '7') {
				_unicode_acc_f00000000MR = _unicode_acc_f00000000MR * 8 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “7”", "string literal");
					_sequence_fail_f00000000SB = true;
					goto _sequence_end_f00000000SB;
				}
				if (_position.Next() >= '0' && _position.PeekLast() <= '7') {
				_unicode_acc_f00000000MR = _unicode_acc_f00000000MR * 8 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “7”", "string literal");
					_sequence_fail_f00000000SB = true;
					goto _sequence_end_f00000000SB;
				}
				_sequence_end_f00000000SB:
				if (_sequence_fail_f00000000SB) {
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				} else {
					foreach (var f00000003B4_c in System.Char.ConvertFromUtf32(_unicode_acc_f00000000MR)) { 
					_obj.text = new RevCons<char>(f00000003B4_c, _obj.text);}
					_alternate_success_f00000000Hz = true;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				int _unicode_acc_f00000000MS = 0;
				bool _sequence_fail_f00000000SC = false;
				if (_position.Match("\\x")) {
				} else {
					_position.Update("“\\x”", "string literal");
					_sequence_fail_f00000000SC = true;
					goto _sequence_end_f00000000SC;
				}
				bool _alternate_success_f00000000Xs = false;
				ParserPosition _alt_position_f00000000Xs = _position;
				var _alt_obj_f00000000Xs = _obj;
				if (!_alternate_success_f00000000Xs) {
					_position = _alt_position_f00000000Xs.Clone();
					_obj = _alt_obj_f00000000Xs.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MS = _unicode_acc_f00000000MS * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Xs = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Xs;
						_obj = _alt_obj_f00000000Xs;
					}
				}
				if (!_alternate_success_f00000000Xs) {
					_position = _alt_position_f00000000Xs.Clone();
					_obj = _alt_obj_f00000000Xs.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MS = _unicode_acc_f00000000MS * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Xs = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Xs;
						_obj = _alt_obj_f00000000Xs;
					}
				}
				if (!_alternate_success_f00000000Xs) {
					_position = _alt_position_f00000000Xs.Clone();
					_obj = _alt_obj_f00000000Xs.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MS = _unicode_acc_f00000000MS * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Xs = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Xs;
						_obj = _alt_obj_f00000000Xs;
					}
				}
				if (_alternate_success_f00000000Xs) {
				} else {
					_sequence_fail_f00000000SC = true;
					goto _sequence_end_f00000000SC;
				}
				bool _alternate_success_f00000000Xt = false;
				ParserPosition _alt_position_f00000000Xt = _position;
				var _alt_obj_f00000000Xt = _obj;
				if (!_alternate_success_f00000000Xt) {
					_position = _alt_position_f00000000Xt.Clone();
					_obj = _alt_obj_f00000000Xt.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MS = _unicode_acc_f00000000MS * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Xt = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Xt;
						_obj = _alt_obj_f00000000Xt;
					}
				}
				if (!_alternate_success_f00000000Xt) {
					_position = _alt_position_f00000000Xt.Clone();
					_obj = _alt_obj_f00000000Xt.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MS = _unicode_acc_f00000000MS * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Xt = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Xt;
						_obj = _alt_obj_f00000000Xt;
					}
				}
				if (!_alternate_success_f00000000Xt) {
					_position = _alt_position_f00000000Xt.Clone();
					_obj = _alt_obj_f00000000Xt.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MS = _unicode_acc_f00000000MS * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Xt = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Xt;
						_obj = _alt_obj_f00000000Xt;
					}
				}
				if (_alternate_success_f00000000Xt) {
				} else {
					_sequence_fail_f00000000SC = true;
					goto _sequence_end_f00000000SC;
				}
				_sequence_end_f00000000SC:
				if (_sequence_fail_f00000000SC) {
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				} else {
					foreach (var f00000002tI_c in System.Char.ConvertFromUtf32(_unicode_acc_f00000000MS)) { 
					_obj.text = new RevCons<char>(f00000002tI_c, _obj.text);}
					_alternate_success_f00000000Hz = true;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				int _unicode_acc_f00000000MT = 0;
				bool _sequence_fail_f00000000SD = false;
				if (_position.Match("\\u")) {
				} else {
					_position.Update("“\\u”", "string literal");
					_sequence_fail_f00000000SD = true;
					goto _sequence_end_f00000000SD;
				}
				bool _alternate_success_f00000000Xw = false;
				ParserPosition _alt_position_f00000000Xw = _position;
				var _alt_obj_f00000000Xw = _obj;
				if (!_alternate_success_f00000000Xw) {
					_position = _alt_position_f00000000Xw.Clone();
					_obj = _alt_obj_f00000000Xw.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MT = _unicode_acc_f00000000MT * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Xw = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Xw;
						_obj = _alt_obj_f00000000Xw;
					}
				}
				if (!_alternate_success_f00000000Xw) {
					_position = _alt_position_f00000000Xw.Clone();
					_obj = _alt_obj_f00000000Xw.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MT = _unicode_acc_f00000000MT * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Xw = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Xw;
						_obj = _alt_obj_f00000000Xw;
					}
				}
				if (!_alternate_success_f00000000Xw) {
					_position = _alt_position_f00000000Xw.Clone();
					_obj = _alt_obj_f00000000Xw.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MT = _unicode_acc_f00000000MT * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Xw = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Xw;
						_obj = _alt_obj_f00000000Xw;
					}
				}
				if (_alternate_success_f00000000Xw) {
				} else {
					_sequence_fail_f00000000SD = true;
					goto _sequence_end_f00000000SD;
				}
				bool _alternate_success_f00000000Xx = false;
				ParserPosition _alt_position_f00000000Xx = _position;
				var _alt_obj_f00000000Xx = _obj;
				if (!_alternate_success_f00000000Xx) {
					_position = _alt_position_f00000000Xx.Clone();
					_obj = _alt_obj_f00000000Xx.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MT = _unicode_acc_f00000000MT * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Xx = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Xx;
						_obj = _alt_obj_f00000000Xx;
					}
				}
				if (!_alternate_success_f00000000Xx) {
					_position = _alt_position_f00000000Xx.Clone();
					_obj = _alt_obj_f00000000Xx.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MT = _unicode_acc_f00000000MT * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Xx = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Xx;
						_obj = _alt_obj_f00000000Xx;
					}
				}
				if (!_alternate_success_f00000000Xx) {
					_position = _alt_position_f00000000Xx.Clone();
					_obj = _alt_obj_f00000000Xx.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MT = _unicode_acc_f00000000MT * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Xx = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Xx;
						_obj = _alt_obj_f00000000Xx;
					}
				}
				if (_alternate_success_f00000000Xx) {
				} else {
					_sequence_fail_f00000000SD = true;
					goto _sequence_end_f00000000SD;
				}
				bool _alternate_success_f00000000Xy = false;
				ParserPosition _alt_position_f00000000Xy = _position;
				var _alt_obj_f00000000Xy = _obj;
				if (!_alternate_success_f00000000Xy) {
					_position = _alt_position_f00000000Xy.Clone();
					_obj = _alt_obj_f00000000Xy.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MT = _unicode_acc_f00000000MT * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Xy = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Xy;
						_obj = _alt_obj_f00000000Xy;
					}
				}
				if (!_alternate_success_f00000000Xy) {
					_position = _alt_position_f00000000Xy.Clone();
					_obj = _alt_obj_f00000000Xy.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MT = _unicode_acc_f00000000MT * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Xy = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Xy;
						_obj = _alt_obj_f00000000Xy;
					}
				}
				if (!_alternate_success_f00000000Xy) {
					_position = _alt_position_f00000000Xy.Clone();
					_obj = _alt_obj_f00000000Xy.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MT = _unicode_acc_f00000000MT * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Xy = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Xy;
						_obj = _alt_obj_f00000000Xy;
					}
				}
				if (_alternate_success_f00000000Xy) {
				} else {
					_sequence_fail_f00000000SD = true;
					goto _sequence_end_f00000000SD;
				}
				bool _alternate_success_f00000000Xz = false;
				ParserPosition _alt_position_f00000000Xz = _position;
				var _alt_obj_f00000000Xz = _obj;
				if (!_alternate_success_f00000000Xz) {
					_position = _alt_position_f00000000Xz.Clone();
					_obj = _alt_obj_f00000000Xz.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MT = _unicode_acc_f00000000MT * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Xz = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Xz;
						_obj = _alt_obj_f00000000Xz;
					}
				}
				if (!_alternate_success_f00000000Xz) {
					_position = _alt_position_f00000000Xz.Clone();
					_obj = _alt_obj_f00000000Xz.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MT = _unicode_acc_f00000000MT * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Xz = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Xz;
						_obj = _alt_obj_f00000000Xz;
					}
				}
				if (!_alternate_success_f00000000Xz) {
					_position = _alt_position_f00000000Xz.Clone();
					_obj = _alt_obj_f00000000Xz.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MT = _unicode_acc_f00000000MT * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Xz = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Xz;
						_obj = _alt_obj_f00000000Xz;
					}
				}
				if (_alternate_success_f00000000Xz) {
				} else {
					_sequence_fail_f00000000SD = true;
					goto _sequence_end_f00000000SD;
				}
				_sequence_end_f00000000SD:
				if (_sequence_fail_f00000000SD) {
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				} else {
					foreach (var f00000003cL_c in System.Char.ConvertFromUtf32(_unicode_acc_f00000000MT)) { 
					_obj.text = new RevCons<char>(f00000003cL_c, _obj.text);}
					_alternate_success_f00000000Hz = true;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				int _unicode_acc_f00000000MU = 0;
				bool _sequence_fail_f00000000SE = false;
				if (_position.Match("\\U")) {
				} else {
					_position.Update("“\\U”", "string literal");
					_sequence_fail_f00000000SE = true;
					goto _sequence_end_f00000000SE;
				}
				bool _alternate_success_f00000000Y2 = false;
				ParserPosition _alt_position_f00000000Y2 = _position;
				var _alt_obj_f00000000Y2 = _obj;
				if (!_alternate_success_f00000000Y2) {
					_position = _alt_position_f00000000Y2.Clone();
					_obj = _alt_obj_f00000000Y2.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Y2 = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Y2;
						_obj = _alt_obj_f00000000Y2;
					}
				}
				if (!_alternate_success_f00000000Y2) {
					_position = _alt_position_f00000000Y2.Clone();
					_obj = _alt_obj_f00000000Y2.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Y2 = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Y2;
						_obj = _alt_obj_f00000000Y2;
					}
				}
				if (!_alternate_success_f00000000Y2) {
					_position = _alt_position_f00000000Y2.Clone();
					_obj = _alt_obj_f00000000Y2.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Y2 = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Y2;
						_obj = _alt_obj_f00000000Y2;
					}
				}
				if (_alternate_success_f00000000Y2) {
				} else {
					_sequence_fail_f00000000SE = true;
					goto _sequence_end_f00000000SE;
				}
				bool _alternate_success_f00000000Y3 = false;
				ParserPosition _alt_position_f00000000Y3 = _position;
				var _alt_obj_f00000000Y3 = _obj;
				if (!_alternate_success_f00000000Y3) {
					_position = _alt_position_f00000000Y3.Clone();
					_obj = _alt_obj_f00000000Y3.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Y3 = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Y3;
						_obj = _alt_obj_f00000000Y3;
					}
				}
				if (!_alternate_success_f00000000Y3) {
					_position = _alt_position_f00000000Y3.Clone();
					_obj = _alt_obj_f00000000Y3.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Y3 = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Y3;
						_obj = _alt_obj_f00000000Y3;
					}
				}
				if (!_alternate_success_f00000000Y3) {
					_position = _alt_position_f00000000Y3.Clone();
					_obj = _alt_obj_f00000000Y3.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Y3 = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Y3;
						_obj = _alt_obj_f00000000Y3;
					}
				}
				if (_alternate_success_f00000000Y3) {
				} else {
					_sequence_fail_f00000000SE = true;
					goto _sequence_end_f00000000SE;
				}
				bool _alternate_success_f00000000Y4 = false;
				ParserPosition _alt_position_f00000000Y4 = _position;
				var _alt_obj_f00000000Y4 = _obj;
				if (!_alternate_success_f00000000Y4) {
					_position = _alt_position_f00000000Y4.Clone();
					_obj = _alt_obj_f00000000Y4.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Y4 = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Y4;
						_obj = _alt_obj_f00000000Y4;
					}
				}
				if (!_alternate_success_f00000000Y4) {
					_position = _alt_position_f00000000Y4.Clone();
					_obj = _alt_obj_f00000000Y4.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Y4 = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Y4;
						_obj = _alt_obj_f00000000Y4;
					}
				}
				if (!_alternate_success_f00000000Y4) {
					_position = _alt_position_f00000000Y4.Clone();
					_obj = _alt_obj_f00000000Y4.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Y4 = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Y4;
						_obj = _alt_obj_f00000000Y4;
					}
				}
				if (_alternate_success_f00000000Y4) {
				} else {
					_sequence_fail_f00000000SE = true;
					goto _sequence_end_f00000000SE;
				}
				bool _alternate_success_f00000000Y5 = false;
				ParserPosition _alt_position_f00000000Y5 = _position;
				var _alt_obj_f00000000Y5 = _obj;
				if (!_alternate_success_f00000000Y5) {
					_position = _alt_position_f00000000Y5.Clone();
					_obj = _alt_obj_f00000000Y5.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Y5 = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Y5;
						_obj = _alt_obj_f00000000Y5;
					}
				}
				if (!_alternate_success_f00000000Y5) {
					_position = _alt_position_f00000000Y5.Clone();
					_obj = _alt_obj_f00000000Y5.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Y5 = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Y5;
						_obj = _alt_obj_f00000000Y5;
					}
				}
				if (!_alternate_success_f00000000Y5) {
					_position = _alt_position_f00000000Y5.Clone();
					_obj = _alt_obj_f00000000Y5.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Y5 = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Y5;
						_obj = _alt_obj_f00000000Y5;
					}
				}
				if (_alternate_success_f00000000Y5) {
				} else {
					_sequence_fail_f00000000SE = true;
					goto _sequence_end_f00000000SE;
				}
				bool _alternate_success_f00000000Y6 = false;
				ParserPosition _alt_position_f00000000Y6 = _position;
				var _alt_obj_f00000000Y6 = _obj;
				if (!_alternate_success_f00000000Y6) {
					_position = _alt_position_f00000000Y6.Clone();
					_obj = _alt_obj_f00000000Y6.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Y6 = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Y6;
						_obj = _alt_obj_f00000000Y6;
					}
				}
				if (!_alternate_success_f00000000Y6) {
					_position = _alt_position_f00000000Y6.Clone();
					_obj = _alt_obj_f00000000Y6.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Y6 = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Y6;
						_obj = _alt_obj_f00000000Y6;
					}
				}
				if (!_alternate_success_f00000000Y6) {
					_position = _alt_position_f00000000Y6.Clone();
					_obj = _alt_obj_f00000000Y6.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Y6 = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Y6;
						_obj = _alt_obj_f00000000Y6;
					}
				}
				if (_alternate_success_f00000000Y6) {
				} else {
					_sequence_fail_f00000000SE = true;
					goto _sequence_end_f00000000SE;
				}
				bool _alternate_success_f00000000Y7 = false;
				ParserPosition _alt_position_f00000000Y7 = _position;
				var _alt_obj_f00000000Y7 = _obj;
				if (!_alternate_success_f00000000Y7) {
					_position = _alt_position_f00000000Y7.Clone();
					_obj = _alt_obj_f00000000Y7.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Y7 = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Y7;
						_obj = _alt_obj_f00000000Y7;
					}
				}
				if (!_alternate_success_f00000000Y7) {
					_position = _alt_position_f00000000Y7.Clone();
					_obj = _alt_obj_f00000000Y7.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Y7 = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Y7;
						_obj = _alt_obj_f00000000Y7;
					}
				}
				if (!_alternate_success_f00000000Y7) {
					_position = _alt_position_f00000000Y7.Clone();
					_obj = _alt_obj_f00000000Y7.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Y7 = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Y7;
						_obj = _alt_obj_f00000000Y7;
					}
				}
				if (_alternate_success_f00000000Y7) {
				} else {
					_sequence_fail_f00000000SE = true;
					goto _sequence_end_f00000000SE;
				}
				bool _alternate_success_f00000000Y8 = false;
				ParserPosition _alt_position_f00000000Y8 = _position;
				var _alt_obj_f00000000Y8 = _obj;
				if (!_alternate_success_f00000000Y8) {
					_position = _alt_position_f00000000Y8.Clone();
					_obj = _alt_obj_f00000000Y8.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Y8 = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Y8;
						_obj = _alt_obj_f00000000Y8;
					}
				}
				if (!_alternate_success_f00000000Y8) {
					_position = _alt_position_f00000000Y8.Clone();
					_obj = _alt_obj_f00000000Y8.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Y8 = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Y8;
						_obj = _alt_obj_f00000000Y8;
					}
				}
				if (!_alternate_success_f00000000Y8) {
					_position = _alt_position_f00000000Y8.Clone();
					_obj = _alt_obj_f00000000Y8.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Y8 = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Y8;
						_obj = _alt_obj_f00000000Y8;
					}
				}
				if (_alternate_success_f00000000Y8) {
				} else {
					_sequence_fail_f00000000SE = true;
					goto _sequence_end_f00000000SE;
				}
				bool _alternate_success_f00000000Y9 = false;
				ParserPosition _alt_position_f00000000Y9 = _position;
				var _alt_obj_f00000000Y9 = _obj;
				if (!_alternate_success_f00000000Y9) {
					_position = _alt_position_f00000000Y9.Clone();
					_obj = _alt_obj_f00000000Y9.Clone();
					if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 48);
						_alternate_success_f00000000Y9 = true;
					} else {
						_position.Update("character between “0” and “9”", "string literal");
						_position = _alt_position_f00000000Y9;
						_obj = _alt_obj_f00000000Y9;
					}
				}
				if (!_alternate_success_f00000000Y9) {
					_position = _alt_position_f00000000Y9.Clone();
					_obj = _alt_obj_f00000000Y9.Clone();
					if (_position.Next() >= 'a' && _position.PeekLast() <= 'f') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 87);
						_alternate_success_f00000000Y9 = true;
					} else {
						_position.Update("character between “a” and “f”", "string literal");
						_position = _alt_position_f00000000Y9;
						_obj = _alt_obj_f00000000Y9;
					}
				}
				if (!_alternate_success_f00000000Y9) {
					_position = _alt_position_f00000000Y9.Clone();
					_obj = _alt_obj_f00000000Y9.Clone();
					if (_position.Next() >= 'A' && _position.PeekLast() <= 'F') {
					_unicode_acc_f00000000MU = _unicode_acc_f00000000MU * 16 + (_position.PeekLast() - 55);
						_alternate_success_f00000000Y9 = true;
					} else {
						_position.Update("character between “A” and “F”", "string literal");
						_position = _alt_position_f00000000Y9;
						_obj = _alt_obj_f00000000Y9;
					}
				}
				if (_alternate_success_f00000000Y9) {
				} else {
					_sequence_fail_f00000000SE = true;
					goto _sequence_end_f00000000SE;
				}
				_sequence_end_f00000000SE:
				if (_sequence_fail_f00000000SE) {
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				} else {
					foreach (var f00000004pl_c in System.Char.ConvertFromUtf32(_unicode_acc_f00000000MU)) { 
					_obj.text = new RevCons<char>(f00000004pl_c, _obj.text);}
					_alternate_success_f00000000Hz = true;
				}
			}
			if (!_alternate_success_f00000000Hz) {
				_position = _alt_position_f00000000Hz.Clone();
				_obj = _alt_obj_f00000000Hz.Clone();
				if ("\\\"".IndexOf(_position.Next()) == -1) {
					_obj.text = new RevCons<char>(_position.PeekLast(), _obj.text);
					_alternate_success_f00000000Hz = true;
				} else {
					_position.Update(Parser.ToLiteral("\\\""), "string literal");
					_position = _alt_position_f00000000Hz;
					_obj = _alt_obj_f00000000Hz;
				}
			}
			if (_alternate_success_f00000000Hz) {
			} else {
				_position = _many_position_f00000000EC;
				_obj = _many_obj_f00000000EC;
				break;
			}
			_first_f00000000EC = false;
		}
		if (_first_f00000000EC) {
			_position.Cache<string_piece_literal_string>(_start_index, null);
			_position.TraceExit("string_piece:literal_string", false);
			_result = null;
			return false;
		} else {
			_position.Cache<string_piece_literal_string>(_start_index, _obj);
			_position.TraceExit("string_piece:literal_string", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (string_piece)_obj;
			return true;
		}
	}
	public abstract void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _block);
}
internal class string_piece_expression_escape : string_piece {
	public override string PrettyName { get { return "expression in string"; } }
	internal expression expression;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		if (expression != null) { expression.PropagateEnvironment(_collector, _queue, _environment, ref _success); }
		return _return;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

		var f00000000BN = _type & (0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str);
		if (f00000000BN == 0) {
			_success = false;
			_collector.ReportExpressionTypeError(this, 0 | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int | Flabbergast.Type.Str, _type);
		}
		var f00000000E4 =  f00000000BN;
		if (expression != null) f00000000E4 &= AstTypeableNode.HorrendousTypeMerge(expression.EnsureType(_collector, f00000000BN, ref _success, _needs_unbox), f00000000BN);
	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		expression.Generate(_generator, _cache, _source_reference, _context, _self_frame, _container_frame, (f00000000Hk) => {
			_generator.DebugPosition(this);
			var f00000000Dx = _generator.ToStringish(f00000000Hk, _source_reference);
			var f00000000BL = new GeneratedValue(typeof(Flabbergast.Stringish), (f00000000kn_builder) => {
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(_accumulator.BackingType)));
			_generator.LoadReboxed(_accumulator, typeof(Flabbergast.Stringish));
			if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000000Dx.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000000Dx.BackingType)));
			_generator.LoadReboxed(f00000000Dx, typeof(Flabbergast.Stringish));
			f00000000kn_builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(ConcatStringish).GetConstructors()[0]);
			});
			_final_block(f00000000BL);
		});
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
		expression.GenerateApi(_api_gen, false);
	}
	internal string_piece_expression_escape Clone() {
		var _obj = new string_piece_expression_escape();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.expression = expression;
		return _obj;
	}
}
internal class string_piece_literal_string : string_piece {
	public override string PrettyName { get { return "string literal"; } }
	internal RevCons<char> text = null;
	internal override Environment PropagateEnvironment(ErrorCollector _collector, System.Collections.Generic.List<AstTypeableNode> _queue, Environment _environment, ref bool _success) {
		Environment = _environment;
		Environment _return = null;
		_queue.Add(this);
		return _return;
	}
	internal override void MakeTypeDemands(ErrorCollector _collector, ref bool _success) {
		#pragma warning disable 219
		var _type = NameInfo.AnyType;
		var _needs_unbox = false;
		#pragma warning restore 219

	}
	public override void Generate(Generator _generator, LookupCache _cache, LoadableValue _source_reference, LoadableValue _context, LoadableValue _self_frame, LoadableValue _container_frame, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000000EB = new StringishValue(Generator.ToString(text));
		var f00000000BP = new GeneratedValue(typeof(Flabbergast.Stringish), (f00000000ky_builder) => {
		if (!typeof(Flabbergast.Stringish).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(_accumulator.BackingType)));
		_generator.LoadReboxed(_accumulator, typeof(Flabbergast.Stringish));
		if (!typeof(Flabbergast.Stringish).IsAssignableFrom(f00000000EB.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Str but got {0} in Newobj.", Stringish.NameForType(f00000000EB.BackingType)));
		_generator.LoadReboxed(f00000000EB, typeof(Flabbergast.Stringish));
		f00000000ky_builder.Emit(System.Reflection.Emit.OpCodes.Newobj, typeof(ConcatStringish).GetConstructors()[0]);
		});
		_final_block(f00000000BP);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal string_piece_literal_string Clone() {
		var _obj = new string_piece_literal_string();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.comment = comment;
		_obj.text = text;
		return _obj;
	}
}
internal abstract class time : AstNode {
	internal static bool ParseRule_Base(ref ParserPosition position, out time result) {
		position.TraceEnter("time");
		if(position.CheckCache<time>("time", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("any time", "time");		slave_position = position.Clone();
		if (ParseRule_days(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("time", true);
			position.Cache<time>("time", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_hours(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("time", true);
			position.Cache<time>("time", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_minutes(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("time", true);
			position.Cache<time>("time", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_seconds(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("time", true);
			position.Cache<time>("time", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("time", false);
		position.Cache<time>("time", start_index, null);
		return false;
	}
	internal static bool ParseRule_days(ref ParserPosition _position, out time _result) {
		if(_position.CheckCache<time_days, time>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new time_days();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("time:days");

		bool _sequence_fail_f00000000an = false;
		bool _alternate_success_f00000000t4 = false;
		ParserPosition _alt_position_f00000000t4 = _position;
		var _alt_obj_f00000000t4 = _obj;
		if (!_alternate_success_f00000000t4) {
			_position = _alt_position_f00000000t4.Clone();
			_obj = _alt_obj_f00000000t4.Clone();
			if (_position.Match("0")) {
				_alternate_success_f00000000t4 = true;
			} else {
				_position.Update("“0”", "days");
				_position = _alt_position_f00000000t4;
				_obj = _alt_obj_f00000000t4;
			}
		}
		if (!_alternate_success_f00000000t4) {
			_position = _alt_position_f00000000t4.Clone();
			_obj = _alt_obj_f00000000t4.Clone();
			bool _sequence_fail_f000000012J = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
			} else {
				_position.Update("character between “1” and “9”", "days");
				_sequence_fail_f000000012J = true;
				goto _sequence_end_f000000012J;
			}
			while(true) {
				ParserPosition _many_position_f000000018U = _position.Clone();
				var _many_obj_f000000018U = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “9”", "days");
					_position = _many_position_f000000018U;
					_obj = _many_obj_f000000018U;
					break;
				}
			}
			_sequence_end_f000000012J:
			if (_sequence_fail_f000000012J) {
				_position = _alt_position_f00000000t4;
				_obj = _alt_obj_f00000000t4;
			} else {
				_alternate_success_f00000000t4 = true;
			}
		}
		if (_alternate_success_f00000000t4) {
		} else {
			_sequence_fail_f00000000an = true;
			goto _sequence_end_f00000000an;
		}
		if (_position.Match("d")) {
		} else {
			_position.Update("“d”", "days");
			_sequence_fail_f00000000an = true;
			goto _sequence_end_f00000000an;
		}
		_sequence_end_f00000000an:
		if (_sequence_fail_f00000000an) {
			_position.Cache<time_days>(_start_index, null);
			_position.TraceExit("time:days", false);
			_result = null;
			return false;
		} else {
			_position.Cache<time_days>(_start_index, _obj);
			_position.TraceExit("time:days", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (time)_obj;
			return true;
		}
	}
	internal static bool ParseRule_hours(ref ParserPosition _position, out time _result) {
		if(_position.CheckCache<time_hours, time>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new time_hours();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("time:hours");

		bool _sequence_fail_f00000000ar = false;
		bool _alternate_success_f00000000tA = false;
		ParserPosition _alt_position_f00000000tA = _position;
		var _alt_obj_f00000000tA = _obj;
		if (!_alternate_success_f00000000tA) {
			_position = _alt_position_f00000000tA.Clone();
			_obj = _alt_obj_f00000000tA.Clone();
			if (_position.Match("0")) {
				_alternate_success_f00000000tA = true;
			} else {
				_position.Update("“0”", "hours");
				_position = _alt_position_f00000000tA;
				_obj = _alt_obj_f00000000tA;
			}
		}
		if (!_alternate_success_f00000000tA) {
			_position = _alt_position_f00000000tA.Clone();
			_obj = _alt_obj_f00000000tA.Clone();
			bool _sequence_fail_f000000012M = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
			} else {
				_position.Update("character between “1” and “9”", "hours");
				_sequence_fail_f000000012M = true;
				goto _sequence_end_f000000012M;
			}
			while(true) {
				ParserPosition _many_position_f000000018b = _position.Clone();
				var _many_obj_f000000018b = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “9”", "hours");
					_position = _many_position_f000000018b;
					_obj = _many_obj_f000000018b;
					break;
				}
			}
			_sequence_end_f000000012M:
			if (_sequence_fail_f000000012M) {
				_position = _alt_position_f00000000tA;
				_obj = _alt_obj_f00000000tA;
			} else {
				_alternate_success_f00000000tA = true;
			}
		}
		if (_alternate_success_f00000000tA) {
		} else {
			_sequence_fail_f00000000ar = true;
			goto _sequence_end_f00000000ar;
		}
		if (_position.Match("h")) {
		} else {
			_position.Update("“h”", "hours");
			_sequence_fail_f00000000ar = true;
			goto _sequence_end_f00000000ar;
		}
		_sequence_end_f00000000ar:
		if (_sequence_fail_f00000000ar) {
			_position.Cache<time_hours>(_start_index, null);
			_position.TraceExit("time:hours", false);
			_result = null;
			return false;
		} else {
			_position.Cache<time_hours>(_start_index, _obj);
			_position.TraceExit("time:hours", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (time)_obj;
			return true;
		}
	}
	internal static bool ParseRule_minutes(ref ParserPosition _position, out time _result) {
		if(_position.CheckCache<time_minutes, time>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new time_minutes();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("time:minutes");

		bool _sequence_fail_f00000000av = false;
		bool _alternate_success_f00000000tG = false;
		ParserPosition _alt_position_f00000000tG = _position;
		var _alt_obj_f00000000tG = _obj;
		if (!_alternate_success_f00000000tG) {
			_position = _alt_position_f00000000tG.Clone();
			_obj = _alt_obj_f00000000tG.Clone();
			if (_position.Match("0")) {
				_alternate_success_f00000000tG = true;
			} else {
				_position.Update("“0”", "minutes");
				_position = _alt_position_f00000000tG;
				_obj = _alt_obj_f00000000tG;
			}
		}
		if (!_alternate_success_f00000000tG) {
			_position = _alt_position_f00000000tG.Clone();
			_obj = _alt_obj_f00000000tG.Clone();
			bool _sequence_fail_f000000012P = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
			} else {
				_position.Update("character between “1” and “9”", "minutes");
				_sequence_fail_f000000012P = true;
				goto _sequence_end_f000000012P;
			}
			while(true) {
				ParserPosition _many_position_f000000018i = _position.Clone();
				var _many_obj_f000000018i = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “9”", "minutes");
					_position = _many_position_f000000018i;
					_obj = _many_obj_f000000018i;
					break;
				}
			}
			_sequence_end_f000000012P:
			if (_sequence_fail_f000000012P) {
				_position = _alt_position_f00000000tG;
				_obj = _alt_obj_f00000000tG;
			} else {
				_alternate_success_f00000000tG = true;
			}
		}
		if (_alternate_success_f00000000tG) {
		} else {
			_sequence_fail_f00000000av = true;
			goto _sequence_end_f00000000av;
		}
		if (_position.Match("m")) {
		} else {
			_position.Update("“m”", "minutes");
			_sequence_fail_f00000000av = true;
			goto _sequence_end_f00000000av;
		}
		_sequence_end_f00000000av:
		if (_sequence_fail_f00000000av) {
			_position.Cache<time_minutes>(_start_index, null);
			_position.TraceExit("time:minutes", false);
			_result = null;
			return false;
		} else {
			_position.Cache<time_minutes>(_start_index, _obj);
			_position.TraceExit("time:minutes", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (time)_obj;
			return true;
		}
	}
	internal static bool ParseRule_seconds(ref ParserPosition _position, out time _result) {
		if(_position.CheckCache<time_seconds, time>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new time_seconds();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("time:seconds");

		bool _sequence_fail_f00000000az = false;
		bool _alternate_success_f00000000tM = false;
		ParserPosition _alt_position_f00000000tM = _position;
		var _alt_obj_f00000000tM = _obj;
		if (!_alternate_success_f00000000tM) {
			_position = _alt_position_f00000000tM.Clone();
			_obj = _alt_obj_f00000000tM.Clone();
			if (_position.Match("0")) {
				_alternate_success_f00000000tM = true;
			} else {
				_position.Update("“0”", "seconds");
				_position = _alt_position_f00000000tM;
				_obj = _alt_obj_f00000000tM;
			}
		}
		if (!_alternate_success_f00000000tM) {
			_position = _alt_position_f00000000tM.Clone();
			_obj = _alt_obj_f00000000tM.Clone();
			bool _sequence_fail_f000000012S = false;
			if (_position.Next() >= '1' && _position.PeekLast() <= '9') {
			_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
			} else {
				_position.Update("character between “1” and “9”", "seconds");
				_sequence_fail_f000000012S = true;
				goto _sequence_end_f000000012S;
			}
			while(true) {
				ParserPosition _many_position_f000000018p = _position.Clone();
				var _many_obj_f000000018p = _obj.Clone();
				if (_position.Next() >= '0' && _position.PeekLast() <= '9') {
				_obj.count = _obj.count * 10 + (_position.PeekLast() - 48);
				} else {
					_position.Update("character between “0” and “9”", "seconds");
					_position = _many_position_f000000018p;
					_obj = _many_obj_f000000018p;
					break;
				}
			}
			_sequence_end_f000000012S:
			if (_sequence_fail_f000000012S) {
				_position = _alt_position_f00000000tM;
				_obj = _alt_obj_f00000000tM;
			} else {
				_alternate_success_f00000000tM = true;
			}
		}
		if (_alternate_success_f00000000tM) {
		} else {
			_sequence_fail_f00000000az = true;
			goto _sequence_end_f00000000az;
		}
		if (_position.Match("s")) {
		} else {
			_position.Update("“s”", "seconds");
			_sequence_fail_f00000000az = true;
			goto _sequence_end_f00000000az;
		}
		_sequence_end_f00000000az:
		if (_sequence_fail_f00000000az) {
			_position.Cache<time_seconds>(_start_index, null);
			_position.TraceExit("time:seconds", false);
			_result = null;
			return false;
		} else {
			_position.Cache<time_seconds>(_start_index, _obj);
			_position.TraceExit("time:seconds", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (time)_obj;
			return true;
		}
	}
	public abstract void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _block);
}
internal class time_days : time {
	public override string PrettyName { get { return "days"; } }
	internal long count;
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000000iL = new IntConstant(count * 86400);
		var f00000000am = new GeneratedValue(typeof(long), (f00000001PC_builder) => {
		if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Add.", Stringish.NameForType(_accumulator.BackingType)));
		_generator.LoadReboxed(_accumulator, typeof(long));
		if (!typeof(long).IsAssignableFrom(f00000000iL.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Add.", Stringish.NameForType(f00000000iL.BackingType)));
		_generator.LoadReboxed(f00000000iL, typeof(long));
		f00000001PC_builder.Emit(System.Reflection.Emit.OpCodes.Add);
		});
		_final_block(f00000000am);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal time_days Clone() {
		var _obj = new time_days();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.count = count;
		return _obj;
	}
}
internal class time_hours : time {
	public override string PrettyName { get { return "hours"; } }
	internal long count;
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000000iU = new IntConstant(count * 3600);
		var f00000000aq = new GeneratedValue(typeof(long), (f00000001PH_builder) => {
		if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Add.", Stringish.NameForType(_accumulator.BackingType)));
		_generator.LoadReboxed(_accumulator, typeof(long));
		if (!typeof(long).IsAssignableFrom(f00000000iU.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Add.", Stringish.NameForType(f00000000iU.BackingType)));
		_generator.LoadReboxed(f00000000iU, typeof(long));
		f00000001PH_builder.Emit(System.Reflection.Emit.OpCodes.Add);
		});
		_final_block(f00000000aq);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal time_hours Clone() {
		var _obj = new time_hours();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.count = count;
		return _obj;
	}
}
internal class time_minutes : time {
	public override string PrettyName { get { return "minutes"; } }
	internal long count;
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000000id = new IntConstant(count * 60);
		var f00000000au = new GeneratedValue(typeof(long), (f00000001PM_builder) => {
		if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Add.", Stringish.NameForType(_accumulator.BackingType)));
		_generator.LoadReboxed(_accumulator, typeof(long));
		if (!typeof(long).IsAssignableFrom(f00000000id.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Add.", Stringish.NameForType(f00000000id.BackingType)));
		_generator.LoadReboxed(f00000000id, typeof(long));
		f00000001PM_builder.Emit(System.Reflection.Emit.OpCodes.Add);
		});
		_final_block(f00000000au);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal time_minutes Clone() {
		var _obj = new time_minutes();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.count = count;
		return _obj;
	}
}
internal class time_seconds : time {
	public override string PrettyName { get { return "seconds"; } }
	internal long count;
	public override void Generate(Generator _generator, LoadableValue _source_reference, LoadableValue _accumulator, Generator.ParameterisedBlock<LoadableValue> _final_block) {
		_generator.DebugPosition(this);
		var f00000000im = new IntConstant(count * 1);
		var f00000000ay = new GeneratedValue(typeof(long), (f00000001PR_builder) => {
		if (!typeof(long).IsAssignableFrom(_accumulator.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Add.", Stringish.NameForType(_accumulator.BackingType)));
		_generator.LoadReboxed(_accumulator, typeof(long));
		if (!typeof(long).IsAssignableFrom(f00000000im.BackingType)) throw new System.InvalidOperationException(System.String.Format("Expected  Int but got {0} in Add.", Stringish.NameForType(f00000000im.BackingType)));
		_generator.LoadReboxed(f00000000im, typeof(long));
		f00000001PR_builder.Emit(System.Reflection.Emit.OpCodes.Add);
		});
		_final_block(f00000000ay);
	}
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal time_seconds Clone() {
		var _obj = new time_seconds();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		_obj.count = count;
		return _obj;
	}
}
internal abstract class type_name : AstNode {
	internal abstract Type TypeId { get; }
	internal abstract Type CastableFrom { get; }
	internal abstract bool Unbox { get; }
	internal static bool ParseRule_Base(ref ParserPosition position, out type_name result) {
		position.TraceEnter("type_name");
		if(position.CheckCache<type_name>("type_name", out result)) return result != null;
		ParserPosition slave_position;
		var start_index = position.Index;
		position.Update("any type_name", "type_name");		slave_position = position.Clone();
		if (ParseRule_bin(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("type_name", true);
			position.Cache<type_name>("type_name", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_bool(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("type_name", true);
			position.Cache<type_name>("type_name", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_float(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("type_name", true);
			position.Cache<type_name>("type_name", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_frame(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("type_name", true);
			position.Cache<type_name>("type_name", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_int(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("type_name", true);
			position.Cache<type_name>("type_name", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_str(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("type_name", true);
			position.Cache<type_name>("type_name", start_index, result);
			return true;
		}
		slave_position = position.Clone();
		if (ParseRule_tmpl(ref slave_position, out result)) {
			position = slave_position;
			position.TraceExit("type_name", true);
			position.Cache<type_name>("type_name", start_index, result);
			return true;
		}
		result = null;
		position.TraceExit("type_name", false);
		position.Cache<type_name>("type_name", start_index, null);
		return false;
	}
	internal static bool ParseRule_bin(ref ParserPosition _position, out type_name _result) {
		if(_position.CheckCache<type_name_bin, type_name>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new type_name_bin();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("type_name:bin");

		if (_position.Match("Bin")) {
			_position.Cache<type_name_bin>(_start_index, _obj);
			_position.TraceExit("type_name:bin", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (type_name)_obj;
			return true;
		} else {
			_position.Update("“Bin”", "Bin type");
			_position.Cache<type_name_bin>(_start_index, null);
			_position.TraceExit("type_name:bin", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_bool(ref ParserPosition _position, out type_name _result) {
		if(_position.CheckCache<type_name_bool, type_name>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new type_name_bool();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("type_name:bool");

		if (_position.Match("Bool")) {
			_position.Cache<type_name_bool>(_start_index, _obj);
			_position.TraceExit("type_name:bool", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (type_name)_obj;
			return true;
		} else {
			_position.Update("“Bool”", "Bool type");
			_position.Cache<type_name_bool>(_start_index, null);
			_position.TraceExit("type_name:bool", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_float(ref ParserPosition _position, out type_name _result) {
		if(_position.CheckCache<type_name_float, type_name>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new type_name_float();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("type_name:float");

		if (_position.Match("Float")) {
			_position.Cache<type_name_float>(_start_index, _obj);
			_position.TraceExit("type_name:float", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (type_name)_obj;
			return true;
		} else {
			_position.Update("“Float”", "Float type");
			_position.Cache<type_name_float>(_start_index, null);
			_position.TraceExit("type_name:float", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_frame(ref ParserPosition _position, out type_name _result) {
		if(_position.CheckCache<type_name_frame, type_name>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new type_name_frame();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("type_name:frame");

		if (_position.Match("Frame")) {
			_position.Cache<type_name_frame>(_start_index, _obj);
			_position.TraceExit("type_name:frame", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (type_name)_obj;
			return true;
		} else {
			_position.Update("“Frame”", "Frame type");
			_position.Cache<type_name_frame>(_start_index, null);
			_position.TraceExit("type_name:frame", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_int(ref ParserPosition _position, out type_name _result) {
		if(_position.CheckCache<type_name_int, type_name>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new type_name_int();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("type_name:int");

		if (_position.Match("Int")) {
			_position.Cache<type_name_int>(_start_index, _obj);
			_position.TraceExit("type_name:int", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (type_name)_obj;
			return true;
		} else {
			_position.Update("“Int”", "Int type");
			_position.Cache<type_name_int>(_start_index, null);
			_position.TraceExit("type_name:int", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_str(ref ParserPosition _position, out type_name _result) {
		if(_position.CheckCache<type_name_str, type_name>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new type_name_str();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("type_name:str");

		if (_position.Match("Str")) {
			_position.Cache<type_name_str>(_start_index, _obj);
			_position.TraceExit("type_name:str", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (type_name)_obj;
			return true;
		} else {
			_position.Update("“Str”", "Str type");
			_position.Cache<type_name_str>(_start_index, null);
			_position.TraceExit("type_name:str", false);
			_result = null;
			return false;
		}
	}
	internal static bool ParseRule_tmpl(ref ParserPosition _position, out type_name _result) {
		if(_position.CheckCache<type_name_tmpl, type_name>(out _result)) return _result != null;
		int _start_index = _position.Index;
		var _obj = new type_name_tmpl();
		_obj.FileName = _position.Parser.FileName;
		_obj.StartRow = _position.Row;
		_obj.StartColumn = _position.Column;
		_position.TraceEnter("type_name:tmpl");

		if (_position.Match("Template")) {
			_position.Cache<type_name_tmpl>(_start_index, _obj);
			_position.TraceExit("type_name:tmpl", true);
			_obj.EndRow = _position.Row;
			_obj.EndColumn = _position.Column;
			_result = (type_name)_obj;
			return true;
		} else {
			_position.Update("“Template”", "Template type");
			_position.Cache<type_name_tmpl>(_start_index, null);
			_position.TraceExit("type_name:tmpl", false);
			_result = null;
			return false;
		}
	}
}
internal class type_name_bin : type_name {
	public override string PrettyName { get { return "Bin type"; } }
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal override Type TypeId { get { return Flabbergast.Type.Bin; } }
	internal override Type CastableFrom { get { return Flabbergast.Type.Bin; }}
	internal override bool Unbox { get { return true; }}
	internal type_name_bin Clone() {
		var _obj = new type_name_bin();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		return _obj;
	}
}
internal class type_name_bool : type_name {
	public override string PrettyName { get { return "Bool type"; } }
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal override Type TypeId { get { return Flabbergast.Type.Bool; } }
	internal override Type CastableFrom { get { return Flabbergast.Type.Bool; }}
	internal override bool Unbox { get { return true; }}
	internal type_name_bool Clone() {
		var _obj = new type_name_bool();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		return _obj;
	}
}
internal class type_name_float : type_name {
	public override string PrettyName { get { return "Float type"; } }
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal override Type TypeId { get { return Flabbergast.Type.Float; } }
	internal override Type CastableFrom { get { return Flabbergast.Type.Float | Flabbergast.Type.Int; }}
	internal override bool Unbox { get { return true; }}
	internal type_name_float Clone() {
		var _obj = new type_name_float();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		return _obj;
	}
}
internal class type_name_frame : type_name {
	public override string PrettyName { get { return "Frame type"; } }
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal override Type TypeId { get { return Flabbergast.Type.Frame; } }
	internal override Type CastableFrom { get { return Flabbergast.Type.Frame; }}
	internal override bool Unbox { get { return true; }}
	internal type_name_frame Clone() {
		var _obj = new type_name_frame();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		return _obj;
	}
}
internal class type_name_int : type_name {
	public override string PrettyName { get { return "Int type"; } }
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal override Type TypeId { get { return Flabbergast.Type.Int; } }
	internal override Type CastableFrom { get { return Flabbergast.Type.Int | Flabbergast.Type.Float; }}
	internal override bool Unbox { get { return true; }}
	internal type_name_int Clone() {
		var _obj = new type_name_int();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		return _obj;
	}
}
internal class type_name_str : type_name {
	public override string PrettyName { get { return "Str type"; } }
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal override Type TypeId { get { return Flabbergast.Type.Str; } }
	internal override Type CastableFrom { get { return Flabbergast.Type.Str | Flabbergast.Type.Bool | Flabbergast.Type.Float | Flabbergast.Type.Int; }}
	internal override bool Unbox { get { return false; }}
	internal type_name_str Clone() {
		var _obj = new type_name_str();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		return _obj;
	}
}
internal class type_name_tmpl : type_name {
	public override string PrettyName { get { return "Template type"; } }
	public override void GenerateApi(ApiGenerator _api_gen, bool _collect_names) {
	}
	internal override Type TypeId { get { return Flabbergast.Type.Template; } }
	internal override Type CastableFrom { get { return Flabbergast.Type.Template; }}
	internal override bool Unbox { get { return true; }}
	internal type_name_tmpl Clone() {
		var _obj = new type_name_tmpl();
		_obj.StartRow = StartRow;
		_obj.EndRow = EndRow;
		_obj.StartColumn = StartColumn;
		_obj.EndColumn = EndColumn;
		_obj.FileName = FileName;
		return _obj;
	}
}
}